#
# The file contains PERL source that represents the MMRs from
#    an ASIC hardware register (hwreg) file.
#
# This file was generated using the "hwr2perl" utility.
# HWREG source file : hwreg_tio.hwreg
# ASIC base name    : "tio_01"
# PERL file created : 11:54:26 Thursday October 13
#
#
#  MODIFICATION HISTORY:
#
#     WHEN      WHO             WHAT
#     --------  --------------  ------------------------------------------------
#     12/11/03  Karen Beighley  Added code to initialize TYPE fields.
#     04/08/05  Gary Meyer      Added decodes for TIO_FIRST_ERROR fields.
#     10/13/05  Karen Beighley  Added CE MMRs, which are available via SSP port
#


$tio_01_defined = 1;


##########################################################################
#                                                                        #
#   TIO_ICE_GMS_ERROR_SUMMARY                                            #
#                                                                        #
##########################################################################

%tio_01_00000_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ICE_MMR_ACC_ERR"              => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "MMR Access Error" ],
   "ICE_MMR_ADDR_ERR"             => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "MMR Address Error" ],
   "RSVD0"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMA_CT_TAIL_TO_ERR"           => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Tail Timeout Error" ],
   "CMA_CT_UBE_ERR"               => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Uncorrectable Bit Error" ],
   "CMA_CT_SBE_ERR"               => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Single Bit Error" ],
   "CMA_CT_PROT_ERR"              => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Protocol Error" ],
   "CMA_CT_BFR_OF_ERR"            => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Buffer Overflow Error" ],
   "RSVD1"                        => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PMI_TX_CT_REQ_CRED_OF_ERR"    => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Request Credit Overflow Error" ],
   "PMI_TX_PIO_HD_RETRY_TO_ERR"   => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "PIO Head Retry Timeout Error" ],
   "PMI_TX_PIO_NACK_CNT_OF_ERR"   => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PIO NACK Count Overflow Error" ],
   "PMI_RX_CT_RSP_HEAD_ERR"       => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Header Error" ],
   "PMI_RX_CT_REQ_HEAD_ERR"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Request Header Error" ],
   "PMI_RX_CT_RSP_INV_ERR"        => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Invalid Error" ],
   "PMI_RX_CT_REQ_INV_ERR"        => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Request Invalid Error" ],
   "RSVD2"                        => [  16,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FRZ_TT_INVAL_ERR"             => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Translation Table Invalid Entry Error" ],
   "FRZ_CT_RSP_UNEXP_ERR"         => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Unexpected Error" ],
   "FRZ_CT_RSP_DSB_ERR"           => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Data Sideband Error" ],
   "FRZ_CT_RSP_LG_ERR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Long Error" ],
   "FRZ_CT_RSP_SH_ERR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Short Error" ],
   "FRZ_PRB_OF_ERR"               => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "PRB Overflow Error" ],
   "FRZ_PRB_TO_ERR"               => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout Error" ],
   "FRZ_XN_GFX_RSP_LG_ERR"        => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "XN Graphics Response Long Error" ],
   "FRZ_XN_GFX_REQ_ADDR_ERR"      => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "XN Graphics Address Error" ],
   "FRZ_XN_REQ_PERM_ERR"          => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "XN Request Permission Error" ],
   "FRZ_XN_REQ_DSB_ERR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "XN Request Data Sideband Error" ],
   "FRZ_XN_REQ_LG_ERR"            => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "XN Request Long Error" ],
   "FRZ_XN_REQ_SH_ERR"            => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "XN Request Short Error" ],
   "RSVD3"                        => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRC_CT_RD_REQ_LG_ERR"         => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Coretalk Read Request Long Error" ],
   "RRC_CRB_OF_ERR"               => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Read CRB Overflow Error" ],
   "RRC_RD_CRB_NACK_ERR"          => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "Read CRB NACK Limit Error" ],
   "RRC_RD_CRB_TO_ERR"            => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Read CRB Timeout Error" ],
   "RRC_XN_RD_RSP_ACC_ERR"        => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XN Read Response Access Error" ],
   "RRC_XN_RD_RSP_UNEXP_ERR"      => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XN Read Response Unexpected Error" ],
   "RRC_XN_RD_RSP_DSB_ERR"        => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XN Read Response Data Sideband Error" ],
   "RRC_XN_RD_RSP_LG_ERR"         => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XN Read Response Long" ],
   "RRC_XN_RD_RSP_SH_ERR"         => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "XN Read Response Short Error" ],
   "RSVD4"                        => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH0"                     => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "SCRATCH0" ],
   "WRC_CT_WR_REQ_BAD_BE"         => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Bad Byte Enables" ],
   "WRC_CT_WR_REQ_DSB_ERR"        => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Data Sideband Error" ],
   "WRC_CT_WR_REQ_LG_ERR"         => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Long Error" ],
   "WRC_CT_WR_REQ_SH_ERR"         => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Short Error" ],
   "WRC_WR_CRB_OF_ERR"            => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Write CRB Overflow Error" ],
   "WRC_WR_CRB_NACK_ERR"          => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Write CRB NACK Limit Error" ],
   "WRC_WR_CRB_TO_ERR"            => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Write CRB Timeout Error" ],
   "WRC_XN_WR_RSP_ACC_ERR"        => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "XN Write Response Access Error" ],
   "WRC_XN_WR_RSP_UNEXP_ERR"      => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "XN Write Response Unexpected Error" ],
   "WRC_XN_WR_RSP_DSB_ERR"        => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "XN Write Response Data Sideband Error" ],
   "WRC_XN_WR_RSP_LG_ERR"         => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "XN Write Response Long Error" ],
   "WRC_XN_WR_RSP_SH_ERR"         => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "XN Write Response Short Error" ],
   "RSVD5"                        => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NPA_XN_RSP_CRED_OF_ERR"       => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "XN Response Credit Overflow Error" ],
   "NPA_XN_REQ_CRED_OF_ERR"       => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "XN Request Credit Overflow Error" ],
   "NPA_XN_REQ_BFR_OF_ERR"        => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Request Buffer Overflow Error" ],
   "NPA_XN_RSP_HEAD_ERR"          => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Response Header Error" ],
   "NPA_XN_REQ_HEAD_ERR"          => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Request Header Error" ],
   "NPA_XN_RSP_INV_ERR"           => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Response Invalid Error" ],
   "NPA_XN_REQ_INV_ERR"           => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Request Invalid Error" ],
);

%tio_01_00000_def =
( NAME    => "TIO_ICE_GMS_ERROR_SUMMARY",
  ADDRESS => 0x00000000b0000000,
  NOTE    => "This register holds error summary for all of ICE. For full detail note of ICE errors, refer to the ICE Programmable Features cha",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00000_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_GMS_ERROR_SUMMARY_ALIAS                                      #
#                                                                        #
##########################################################################

%tio_01_00001_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ICE_MMR_ACC_ERR"              => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "MMR Access Error" ],
   "ICE_MMR_ADDR_ERR"             => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "MMR Address Error" ],
   "RSVD0"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMA_CT_TAIL_TO_ERR"           => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Tail Timeout Error" ],
   "CMA_CT_UBE_ERR"               => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Uncorrectable Bit Error" ],
   "CMA_CT_SBE_ERR"               => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Single Bit Error" ],
   "CMA_CT_PROT_ERR"              => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Protocol Error" ],
   "CMA_CT_BFR_OF_ERR"            => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Buffer Overflow Error" ],
   "RSVD1"                        => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PMI_TX_CT_REQ_CRED_OF_ERR"    => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Request Credit Overflow Error" ],
   "PMI_TX_PIO_HD_RETRY_TO_ERR"   => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "PIO Head Retry Timeout Error" ],
   "PMI_TX_PIO_NACK_CNT_OF_ERR"   => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PIO NACK Count Overflow Error" ],
   "PMI_RX_CT_RSP_HEAD_ERR"       => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Header Error" ],
   "PMI_RX_CT_REQ_HEAD_ERR"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Request Header Error" ],
   "PMI_RX_CT_RSP_INV_ERR"        => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Invalid Error" ],
   "PMI_RX_CT_REQ_INV_ERR"        => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Request Invalid Error" ],
   "RSVD2"                        => [  16,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FRZ_TT_INVAL_ERR"             => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Translation Table Invalid Entry Error" ],
   "FRZ_CT_RSP_UNEXP_ERR"         => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Unexpected Error" ],
   "FRZ_CT_RSP_DSB_ERR"           => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Data Sideband Error" ],
   "FRZ_CT_RSP_LG_ERR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Long Error" ],
   "FRZ_CT_RSP_SH_ERR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Short Error" ],
   "FRZ_PRB_OF_ERR"               => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "PRB Overflow Error" ],
   "FRZ_PRB_TO_ERR"               => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout Error" ],
   "FRZ_XN_GFX_RSP_LG_ERR"        => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "XN Graphics Response Long Error" ],
   "FRZ_XN_GFX_REQ_ADDR_ERR"      => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "XN Graphics Address Error" ],
   "FRZ_XN_REQ_PERM_ERR"          => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "XN Request Permission Error" ],
   "FRZ_XN_REQ_DSB_ERR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "XN Request Data Sideband Error" ],
   "FRZ_XN_REQ_LG_ERR"            => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "XN Request Long Error" ],
   "FRZ_XN_REQ_SH_ERR"            => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "XN Request Short Error" ],
   "RSVD3"                        => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRC_CT_RD_REQ_LG_ERR"         => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Coretalk Read Request Long Error" ],
   "RRC_CRB_OF_ERR"               => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Read CRB Overflow Error" ],
   "RRC_RD_CRB_NACK_ERR"          => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "Read CRB NACK Limit Error" ],
   "RRC_RD_CRB_TO_ERR"            => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Read CRB Timeout Error" ],
   "RRC_XN_RD_RSP_ACC_ERR"        => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XN Read Response Access Error" ],
   "RRC_XN_RD_RSP_UNEXP_ERR"      => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XN Read Response Unexpected Error" ],
   "RRC_XN_RD_RSP_DSB_ERR"        => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XN Read Response Data Sideband Error" ],
   "RRC_XN_RD_RSP_LG_ERR"         => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XN Read Response Long" ],
   "RRC_XN_RD_RSP_SH_ERR"         => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "XN Read Response Short Error" ],
   "RSVD4"                        => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH0"                     => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "SCRATCH0" ],
   "WRC_CT_WR_REQ_BAD_BE"         => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Bad Byte Enables" ],
   "WRC_CT_WR_REQ_DSB_ERR"        => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Data Sideband Error" ],
   "WRC_CT_WR_REQ_LG_ERR"         => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Long Error" ],
   "WRC_CT_WR_REQ_SH_ERR"         => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Short Error" ],
   "WRC_WR_CRB_OF_ERR"            => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Write CRB Overflow Error" ],
   "WRC_WR_CRB_NACK_ERR"          => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Write CRB NACK Limit Error" ],
   "WRC_WR_CRB_TO_ERR"            => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Write CRB Timeout Error" ],
   "WRC_XN_WR_RSP_ACC_ERR"        => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "XN Write Response Access Error" ],
   "WRC_XN_WR_RSP_UNEXP_ERR"      => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "XN Write Response Unexpected Error" ],
   "WRC_XN_WR_RSP_DSB_ERR"        => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "XN Write Response Data Sideband Error" ],
   "WRC_XN_WR_RSP_LG_ERR"         => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "XN Write Response Long Error" ],
   "WRC_XN_WR_RSP_SH_ERR"         => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "XN Write Response Short Error" ],
   "RSVD5"                        => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NPA_XN_RSP_CRED_OF_ERR"       => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "XN Response Credit Overflow Error" ],
   "NPA_XN_REQ_CRED_OF_ERR"       => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "XN Request Credit Overflow Error" ],
   "NPA_XN_REQ_BFR_OF_ERR"        => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Request Buffer Overflow Error" ],
   "NPA_XN_RSP_HEAD_ERR"          => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Response Header Error" ],
   "NPA_XN_REQ_HEAD_ERR"          => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Request Header Error" ],
   "NPA_XN_RSP_INV_ERR"           => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Response Invalid Error" ],
   "NPA_XN_REQ_INV_ERR"           => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Request Invalid Error" ],
);

%tio_01_00001_def =
( NAME    => "TIO_ICE_GMS_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x00000000b0000008,
  NOTE    => "Each bit in this register maps one-to-one to the bits in the Error note Summary register. All non-reserved bits have W1C access ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00001_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_GMS_ERROR_OVERFLOW                                           #
#                                                                        #
##########################################################################

%tio_01_00002_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ICE_MMR_ACC_ERR"              => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "MMR Access Error" ],
   "ICE_MMR_ADDR_ERR"             => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "MMR Address Error" ],
   "RSVD0"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMA_CT_TAIL_TO_ERR"           => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Tail Timeout Error" ],
   "CMA_CT_UBE_ERR"               => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Uncorrectable Bit Error" ],
   "CMA_CT_SBE_ERR"               => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Single Bit Error" ],
   "CMA_CT_PROT_ERR"              => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Protocol Error" ],
   "CMA_CT_BFR_OF_ERR"            => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Buffer Overflow Error" ],
   "RSVD1"                        => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PMI_TX_CT_REQ_CRED_OF_ERR"    => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Request Credit Overflow Error" ],
   "PMI_TX_PIO_HD_RETRY_TO_ERR"   => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "PIO Head Retry Timeout Error" ],
   "PMI_TX_PIO_NACK_CNT_OF_ERR"   => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PIO NACK Count Overflow Error" ],
   "PMI_RX_CT_RSP_HEAD_ERR"       => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Header Error" ],
   "PMI_RX_CT_REQ_HEAD_ERR"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Request Header Error" ],
   "PMI_RX_CT_RSP_INV_ERR"        => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Invalid Error" ],
   "PMI_RX_CT_REQ_INV_ERR"        => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Request Invalid Error" ],
   "RSVD2"                        => [  16,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FRZ_TT_INVAL_ERR"             => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Translation Table Invalid Entry Error" ],
   "FRZ_CT_RSP_UNEXP_ERR"         => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Unexpected Error" ],
   "FRZ_CT_RSP_DSB_ERR"           => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Data Sideband Error" ],
   "FRZ_CT_RSP_LG_ERR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Long Error" ],
   "FRZ_CT_RSP_SH_ERR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Short Error" ],
   "FRZ_PRB_OF_ERR"               => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "PRB Overflow Error" ],
   "FRZ_PRB_TO_ERR"               => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout Error" ],
   "FRZ_XN_GFX_RSP_LG_ERR"        => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "XN Graphics Response Long Error" ],
   "FRZ_XN_GFX_REQ_ADDR_ERR"      => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "XN Graphics Address Error" ],
   "FRZ_XN_REQ_PERM_ERR"          => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "XN Request Permission Error" ],
   "FRZ_XN_REQ_DSB_ERR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "XN Request Data Sideband Error" ],
   "FRZ_XN_REQ_LG_ERR"            => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "XN Request Long Error" ],
   "FRZ_XN_REQ_SH_ERR"            => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "XN Request Short Error" ],
   "RSVD3"                        => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRC_CT_RD_REQ_LG_ERR"         => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Coretalk Read Request Long Error" ],
   "RRC_CRB_OF_ERR"               => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Read CRB Overflow Error" ],
   "RRC_RD_CRB_NACK_ERR"          => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "Read CRB NACK Limit Error" ],
   "RRC_RD_CRB_TO_ERR"            => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Read CRB Timeout Error" ],
   "RRC_XN_RD_RSP_ACC_ERR"        => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XN Read Response Access Error" ],
   "RRC_XN_RD_RSP_UNEXP_ERR"      => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XN Read Response Unexpected Error" ],
   "RRC_XN_RD_RSP_DSB_ERR"        => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XN Read Response Data Sideband Error" ],
   "RRC_XN_RD_RSP_LG_ERR"         => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XN Read Response Long" ],
   "RRC_XN_RD_RSP_SH_ERR"         => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "XN Read Response Short Error" ],
   "RSVD4"                        => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH1"                     => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "SCRATCH1" ],
   "WRC_CT_WR_REQ_BAD_BE"         => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Bad Byte Enables" ],
   "WRC_CT_WR_REQ_DSB_ERR"        => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Data Sideband Error" ],
   "WRC_CT_WR_REQ_LG_ERR"         => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Long Error" ],
   "WRC_CT_WR_REQ_SH_ERR"         => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Short Error" ],
   "WRC_WR_CRB_OF_ERR"            => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Write CRB Overflow Error" ],
   "WRC_WR_CRB_NACK_ERR"          => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Write CRB NACK Limit Error" ],
   "WRC_WR_CRB_TO_ERR"            => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Write CRB Timeout Error" ],
   "WRC_XN_WR_RSP_ACC_ERR"        => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "XN Write Response Access Error" ],
   "WRC_XN_WR_RSP_UNEXP_ERR"      => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "XN Write Response Unexpected Error" ],
   "WRC_XN_WR_RSP_DSB_ERR"        => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "XN Write Response Data Sideband Error" ],
   "WRC_XN_WR_RSP_LG_ERR"         => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "XN Write Response Long Error" ],
   "WRC_XN_WR_RSP_SH_ERR"         => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "XN Write Response Short Error" ],
   "RSVD5"                        => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NPA_XN_RSP_CRED_OF_ERR"       => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "XN Response Credit Overflow Error" ],
   "NPA_XN_REQ_CRED_OF_ERR"       => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "XN Request Credit Overflow Error" ],
   "NPA_XN_REQ_BFR_OF_ERR"        => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Request Buffer Overflow Error" ],
   "NPA_XN_RSP_HEAD_ERR"          => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Response Header Error" ],
   "NPA_XN_REQ_HEAD_ERR"          => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Request Header Error" ],
   "NPA_XN_RSP_INV_ERR"           => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Response Invalid Error" ],
   "NPA_XN_REQ_INV_ERR"           => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Request Invalid Error" ],
);

%tio_01_00002_def =
( NAME    => "TIO_ICE_GMS_ERROR_OVERFLOW",
  ADDRESS => 0x00000000b0000010,
  NOTE    => "This register holds error summary for ICE errors that occur a note second time before the Error Summary register is cleared. The",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00002_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_GMS_ERROR_OVERFLOW_ALIAS                                     #
#                                                                        #
##########################################################################

%tio_01_00003_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ICE_MMR_ACC_ERR"              => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "MMR Access Error" ],
   "ICE_MMR_ADDR_ERR"             => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "MMR Address Error" ],
   "RSVD0"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMA_CT_TAIL_TO_ERR"           => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Tail Timeout Error" ],
   "CMA_CT_UBE_ERR"               => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Uncorrectable Bit Error" ],
   "CMA_CT_SBE_ERR"               => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Single Bit Error" ],
   "CMA_CT_PROT_ERR"              => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Protocol Error" ],
   "CMA_CT_BFR_OF_ERR"            => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Buffer Overflow Error" ],
   "RSVD1"                        => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PMI_TX_CT_REQ_CRED_OF_ERR"    => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Request Credit Overflow Error" ],
   "PMI_TX_PIO_HD_RETRY_TO_ERR"   => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "PIO Head Retry Timeout Error" ],
   "PMI_TX_PIO_NACK_CNT_OF_ERR"   => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PIO NACK Count Overflow Error" ],
   "PMI_RX_CT_RSP_HEAD_ERR"       => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Header Error" ],
   "PMI_RX_CT_REQ_HEAD_ERR"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Request Header Error" ],
   "PMI_RX_CT_RSP_INV_ERR"        => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Invalid Error" ],
   "PMI_RX_CT_REQ_INV_ERR"        => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Request Invalid Error" ],
   "RSVD2"                        => [  16,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FRZ_TT_INVAL_ERR"             => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Translation Table Invalid Entry Error" ],
   "FRZ_CT_RSP_UNEXP_ERR"         => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Unexpected Error" ],
   "FRZ_CT_RSP_DSB_ERR"           => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Data Sideband Error" ],
   "FRZ_CT_RSP_LG_ERR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Long Error" ],
   "FRZ_CT_RSP_SH_ERR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Short Error" ],
   "FRZ_PRB_OF_ERR"               => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "PRB Overflow Error" ],
   "FRZ_PRB_TO_ERR"               => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout Error" ],
   "FRZ_XN_GFX_RSP_LG_ERR"        => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "XN Graphics Response Long Error" ],
   "FRZ_XN_GFX_REQ_ADDR_ERR"      => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "XN Graphics Address Error" ],
   "FRZ_XN_REQ_PERM_ERR"          => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "XN Request Permission Error" ],
   "FRZ_XN_REQ_DSB_ERR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "XN Request Data Sideband Error" ],
   "FRZ_XN_REQ_LG_ERR"            => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "XN Request Long Error" ],
   "FRZ_XN_REQ_SH_ERR"            => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "XN Request Short Error" ],
   "RSVD3"                        => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRC_CT_RD_REQ_LG_ERR"         => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Coretalk Read Request Long Error" ],
   "RRC_CRB_OF_ERR"               => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Read CRB Overflow Error" ],
   "RRC_RD_CRB_NACK_ERR"          => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "Read CRB NACK Limit Error" ],
   "RRC_RD_CRB_TO_ERR"            => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Read CRB Timeout Error" ],
   "RRC_XN_RD_RSP_ACC_ERR"        => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XN Read Response Access Error" ],
   "RRC_XN_RD_RSP_UNEXP_ERR"      => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XN Read Response Unexpected Error" ],
   "RRC_XN_RD_RSP_DSB_ERR"        => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XN Read Response Data Sideband Error" ],
   "RRC_XN_RD_RSP_LG_ERR"         => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XN Read Response Long" ],
   "RRC_XN_RD_RSP_SH_ERR"         => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "XN Read Response Short Error" ],
   "RSVD4"                        => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH1"                     => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "SCRATCH1" ],
   "WRC_CT_WR_REQ_BAD_BE"         => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Bad Byte Enables" ],
   "WRC_CT_WR_REQ_DSB_ERR"        => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Data Sideband Error" ],
   "WRC_CT_WR_REQ_LG_ERR"         => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Long Error" ],
   "WRC_CT_WR_REQ_SH_ERR"         => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Short Error" ],
   "WRC_WR_CRB_OF_ERR"            => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Write CRB Overflow Error" ],
   "WRC_WR_CRB_NACK_ERR"          => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Write CRB NACK Limit Error" ],
   "WRC_WR_CRB_TO_ERR"            => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Write CRB Timeout Error" ],
   "WRC_XN_WR_RSP_ACC_ERR"        => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "XN Write Response Access Error" ],
   "WRC_XN_WR_RSP_UNEXP_ERR"      => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "XN Write Response Unexpected Error" ],
   "WRC_XN_WR_RSP_DSB_ERR"        => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "XN Write Response Data Sideband Error" ],
   "WRC_XN_WR_RSP_LG_ERR"         => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "XN Write Response Long Error" ],
   "WRC_XN_WR_RSP_SH_ERR"         => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "XN Write Response Short Error" ],
   "RSVD5"                        => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NPA_XN_RSP_CRED_OF_ERR"       => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "XN Response Credit Overflow Error" ],
   "NPA_XN_REQ_CRED_OF_ERR"       => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "XN Request Credit Overflow Error" ],
   "NPA_XN_REQ_BFR_OF_ERR"        => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Request Buffer Overflow Error" ],
   "NPA_XN_RSP_HEAD_ERR"          => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Response Header Error" ],
   "NPA_XN_REQ_HEAD_ERR"          => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Request Header Error" ],
   "NPA_XN_RSP_INV_ERR"           => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Response Invalid Error" ],
   "NPA_XN_REQ_INV_ERR"           => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Request Invalid Error" ],
);

%tio_01_00003_def =
( NAME    => "TIO_ICE_GMS_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x00000000b0000018,
  NOTE    => "This is an alias to clear select bits in the Error Overflow note Register. Each bit in this register maps one-to-one to the bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00003_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_GMS_FIRST_ERROR                                              #
#                                                                        #
##########################################################################

%tio_01_00004_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ICE_MMR_ACC_ERR"              => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "MMR Access Error" ],
   "ICE_MMR_ADDR_ERR"             => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "MMR Address Error" ],
   "RSVD0"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMA_CT_TAIL_TO_ERR"           => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Tail Timeout Error" ],
   "CMA_CT_UBE_ERR"               => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Uncorrectable Bit Error" ],
   "CMA_CT_SBE_ERR"               => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Single Bit Error" ],
   "CMA_CT_PROT_ERR"              => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Protocol Error" ],
   "CMA_CT_BFR_OF_ERR"            => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Buffer Overflow Error" ],
   "RSVD1"                        => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PMI_TX_CT_REQ_CRED_OF_ERR"    => [   9,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Request Credit Overflow Error" ],
   "PMI_TX_PIO_HD_RETRY_TO_ERR"   => [  10,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "PIO Head Retry Timeout Error" ],
   "PMI_TX_PIO_NACK_CNT_OF_ERR"   => [  11,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "PIO NACK Count Overflow Error" ],
   "PMI_RX_CT_RSP_HEAD_ERR"       => [  12,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Header Error" ],
   "PMI_RX_CT_REQ_HEAD_ERR"       => [  13,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Request Header Error" ],
   "PMI_RX_CT_RSP_INV_ERR"        => [  14,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Invalid Error" ],
   "PMI_RX_CT_REQ_INV_ERR"        => [  15,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "Coretalk Request Invalid Error" ],
   "RSVD2"                        => [  16,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FRZ_TT_INVAL_ERR"             => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Translation Table Invalid Entry Error" ],
   "FRZ_CT_RSP_UNEXP_ERR"         => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Unexpected Error" ],
   "FRZ_CT_RSP_DSB_ERR"           => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Data Sideband Error" ],
   "FRZ_CT_RSP_LG_ERR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Long Error" ],
   "FRZ_CT_RSP_SH_ERR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "Coretalk Response Short Error" ],
   "FRZ_PRB_OF_ERR"               => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "PRB Overflow Error" ],
   "FRZ_PRB_TO_ERR"               => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout Error" ],
   "FRZ_XN_GFX_RSP_LG_ERR"        => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "XN Graphics Response Long Error" ],
   "FRZ_XN_GFX_REQ_ADDR_ERR"      => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "XN Graphics Address Error" ],
   "FRZ_XN_REQ_PERM_ERR"          => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "XN Request Permission Error" ],
   "FRZ_XN_REQ_DSB_ERR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "XN Request Data Sideband Error" ],
   "FRZ_XN_REQ_LG_ERR"            => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "XN Request Long Error" ],
   "FRZ_XN_REQ_SH_ERR"            => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "XN Request Short Error" ],
   "RSVD3"                        => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRC_CT_RD_REQ_LG_ERR"         => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Coretalk Read Request Long Error" ],
   "RRC_CRB_OF_ERR"               => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Read CRB Overflow Error" ],
   "RRC_RD_CRB_NACK_ERR"          => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "Read CRB NACK Limit Error" ],
   "RRC_RD_CRB_TO_ERR"            => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Read CRB Timeout Error" ],
   "RRC_XN_RD_RSP_ACC_ERR"        => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "XN Read Response Access Error" ],
   "RRC_XN_RD_RSP_UNEXP_ERR"      => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "XN Read Response Unexpected Error" ],
   "RRC_XN_RD_RSP_DSB_ERR"        => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "XN Read Response Data Sideband Error" ],
   "RRC_XN_RD_RSP_LG_ERR"         => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "XN Read Response Long" ],
   "RRC_XN_RD_RSP_SH_ERR"         => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "XN Read Response Short Error" ],
   "RSVD4"                        => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH2"                     => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "SCRATCH2" ],
   "WRC_CT_WR_REQ_BAD_BE"         => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Bad Byte Enables" ],
   "WRC_CT_WR_REQ_DSB_ERR"        => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Data Sideband Error" ],
   "WRC_CT_WR_REQ_LG_ERR"         => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Long Error" ],
   "WRC_CT_WR_REQ_SH_ERR"         => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Coretalk Write Request Short Error" ],
   "WRC_WR_CRB_OF_ERR"            => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Write CRB Overflow Error" ],
   "WRC_WR_CRB_NACK_ERR"          => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Write CRB NACK Limit Error" ],
   "WRC_WR_CRB_TO_ERR"            => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Write CRB Timeout Error" ],
   "WRC_XN_WR_RSP_ACC_ERR"        => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "XN Write Response Access Error" ],
   "WRC_XN_WR_RSP_UNEXP_ERR"      => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "XN Write Response Unexpected Error" ],
   "WRC_XN_WR_RSP_DSB_ERR"        => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "XN Write Response Data Sideband Error" ],
   "WRC_XN_WR_RSP_LG_ERR"         => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "XN Write Response Long Error" ],
   "WRC_XN_WR_RSP_SH_ERR"         => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "XN Write Response Short Error" ],
   "RSVD5"                        => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NPA_XN_RSP_CRED_OF_ERR"       => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "XN Response Credit Overflow Error" ],
   "NPA_XN_REQ_CRED_OF_ERR"       => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "XN Request Credit Overflow Error" ],
   "NPA_XN_REQ_BFR_OF_ERR"        => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Request Buffer Overflow Error" ],
   "NPA_XN_RSP_HEAD_ERR"          => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Response Header Error" ],
   "NPA_XN_REQ_HEAD_ERR"          => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Request Header Error" ],
   "NPA_XN_RSP_INV_ERR"           => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Response Invalid Error" ],
   "NPA_XN_REQ_INV_ERR"           => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Request Invalid Error" ],
);

%tio_01_00004_def =
( NAME    => "TIO_ICE_GMS_FIRST_ERROR",
  ADDRESS => 0x00000000b0000020,
  NOTE    => "This register holds first error summary for all of ICE. Once the note Error Summary register is cleared, the next error(s) that ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00004_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_GMS_ERROR_MASK                                               #
#                                                                        #
##########################################################################

%tio_01_00005_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ICE_MMR_ACC_ERR"              => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "MMR Access Error" ],
   "ICE_MMR_ADDR_ERR"             => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "MMR Address Error" ],
   "RSVD0"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CMA_CT_TAIL_TO_ERR"           => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "Coretalk Tail Timeout Error" ],
   "CMA_CT_UBE_ERR"               => [   4,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "Coretalk Uncorrectable Bit Error" ],
   "CMA_CT_SBE_ERR"               => [   5,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "Coretalk Single Bit Error" ],
   "CMA_CT_PROT_ERR"              => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Coretalk Protocol Error" ],
   "CMA_CT_BFR_OF_ERR"            => [   7,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "Coretalk Buffer Overflow Error" ],
   "RSVD1"                        => [   8,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PMI_TX_CT_REQ_CRED_OF_ERR"    => [   9,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "Coretalk Request Credit Overflow Error" ],
   "PMI_TX_PIO_HD_RETRY_TO_ERR"   => [  10,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "PIO Head Retry Timeout Error" ],
   "PMI_TX_PIO_NACK_CNT_OF_ERR"   => [  11,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "PIO NACK Count Overflow Error" ],
   "PMI_RX_CT_RSP_INV_ERR"        => [  12,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "Coretalk Response Invalid Error" ],
   "PMI_RX_CT_RSP_HEAD_ERR"       => [  13,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "Coretalk Response Header Error" ],
   "PMI_RX_CT_REQ_INV_ERR"        => [  14,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "Coretalk Request Invalid Error" ],
   "PMI_RX_CT_REQ_HEAD_ERR"       => [  15,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "Coretalk Request Header Error" ],
   "RSVD2"                        => [  16,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FRZ_TT_INVAL_ERR"             => [  17,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "Translation Table Invalid Entry Error" ],
   "FRZ_CT_RSP_UNEXP_ERR"         => [  18,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "Coretalk Response Unexpected Error" ],
   "FRZ_CT_RSP_DSB_ERR"           => [  19,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "Coretalk Response Data Sideband Error" ],
   "FRZ_CT_RSP_LG_ERR"            => [  20,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "Coretalk Response Long Error" ],
   "FRZ_CT_RSP_SH_ERR"            => [  21,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "Coretalk Response Short Error" ],
   "FRZ_PRB_OF_ERR"               => [  22,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "PRB Overflow Error" ],
   "FRZ_PRB_TO_ERR"               => [  23,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Error" ],
   "FRZ_XN_GFX_RSP_LG_ERR"        => [  24,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "XN Graphics Response Long Error" ],
   "FRZ_XN_GFX_REQ_ADDR_ERR"      => [  25,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "XN Graphics Address Error" ],
   "FRZ_XN_REQ_PERM_ERR"          => [  26,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "XN Request Permission Error" ],
   "FRZ_XN_REQ_DSB_ERR"           => [  27,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "XN Request Data Sideband Error" ],
   "FRZ_XN_REQ_LG_ERR"            => [  28,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "XN Request Long Error" ],
   "FRZ_XN_REQ_SH_ERR"            => [  29,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "XN Request Short Error" ],
   "RSVD3"                        => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRC_CT_RD_REQ_LG_ERR"         => [  31,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "Coretalk Read Request Long Error" ],
   "RRC_CRB_OF_ERR"               => [  32,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "Read CRB Overflow Error" ],
   "RRC_RD_CRB_NACK_ERR"          => [  33,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "Read CRB NACK Limit Error" ],
   "RRC_RD_CRB_TO_ERR"            => [  34,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "Read CRB Timeout Error" ],
   "RRC_XN_RD_RSP_ACC_ERR"        => [  35,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "XN Read Response Access Error" ],
   "RRC_XN_RD_RSP_UNEXP_ERR"      => [  36,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "XN Read Response Unexpected Error" ],
   "RRC_XN_RD_RSP_DSB_ERR"        => [  37,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "XN Read Response Data Sideband Error" ],
   "RRC_XN_RD_RSP_LG_ERR"         => [  38,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "XN Read Response Long" ],
   "RRC_XN_RD_RSP_SH_ERR"         => [  39,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "XN Read Response Short Error" ],
   "RSVD4"                        => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH3"                     => [  41,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "SCRATCH3" ],
   "WRC_CT_WR_REQ_BAD_BE"         => [  42,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "Coretalk Write Request Bad Byte Enables" ],
   "WRC_CT_WR_REQ_LG_ERR"         => [  43,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Coretalk Write Request Long Error" ],
   "WRC_CT_WR_REQ_SH_ERR"         => [  44,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Coretalk Write Request Short Error" ],
   "WRC_CT_WR_REQ_DSB_ERR"        => [  45,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Coretalk Write Request Data Sideband Error" ],
   "WRC_WR_CRB_OF_ERR"            => [  46,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Write CRB Overflow Error" ],
   "WRC_WR_CRB_NACK_ERR"          => [  47,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Write CRB NACK Limit Error" ],
   "WRC_WR_CRB_TO_ERR"            => [  48,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Write CRB Timeout Error" ],
   "WRC_XN_WR_RSP_ACC_ERR"        => [  49,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "XN Write Response Access Error" ],
   "WRC_XN_WR_RSP_UNEXP_ERR"      => [  50,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "XN Write Response Unexpected Error" ],
   "WRC_XN_WR_RSP_DSB_ERR"        => [  51,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "XN Write Response Data Sideband Error" ],
   "WRC_XN_WR_RSP_LG_ERR"         => [  52,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "XN Write Response Long Error" ],
   "WRC_XN_WR_RSP_SH_ERR"         => [  53,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "XN Write Response Short Error" ],
   "RSVD5"                        => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NPA_XN_RSP_CRED_OF_ERR"       => [  55,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "XN Response Credit Overflow Error" ],
   "NPA_XN_REQ_CRED_OF_ERR"       => [  56,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "XN Request Credit Overflow Error" ],
   "NPA_XN_REQ_BFR_OF_ERR"        => [  57,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "XN Request Buffer Overflow Error" ],
   "NPA_XN_RSP_HEAD_ERR"          => [  58,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "XN Response Header Error" ],
   "NPA_XN_REQ_HEAD_ERR"          => [  59,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "XN Request Header Error" ],
   "NPA_XN_RSP_INV_ERR"           => [  60,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "XN Response Invalid Error" ],
   "NPA_XN_REQ_INV_ERR"           => [  61,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "XN Request Invalid Error" ],
);

%tio_01_00005_def =
( NAME    => "TIO_ICE_GMS_ERROR_MASK",
  ADDRESS => 0x00000000b0000028,
  NOTE    => "Bits set in this register will mask out the corresponding bits in note the First Error register. The mask will not prevent setti",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00005_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_GMS_DBG_TRIG_COMPARE                                         #
#                                                                        #
##########################################################################

%tio_01_00006_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_CMP"               => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Debug Trigger Compare Pattern" ],
);

%tio_01_00006_def =
( NAME    => "TIO_ICE_GMS_DBG_TRIG_COMPARE",
  ADDRESS => 0x00000000b00000e0,
  NOTE    => "This holds the debug compare value for triggers via the Debug Port. note Upon a match between trigger data and debug_trig_cmp, b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00006_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_GMS_DBG_TRIG_SELECT                                          #
#                                                                        #
##########################################################################

%tio_01_00007_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_NIB7_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 7 select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_DATA7_SEL"         => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Debug data group 7 select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_NIB6_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 6 select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_DATA6_SEL"         => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Debug data group 6 select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_NIB5_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 5 select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_DATA5_SEL"         => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Debug data group 5 select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_NIB4_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 4 select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_DATA4_SEL"         => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Debug data group 4 select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_NIB3_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 3 select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_DATA3_SEL"         => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Debug data group 3 select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_NIB2_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Debug nibble group 2 select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_DATA2_SEL"         => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Debug data group 2 select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_NIB1_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Debug nibble group 1 select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_DATA1_SEL"         => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Debug data group 1 select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_NIB0_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Debug nibble group 0 select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_DATA0_SEL"         => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Debug data group 0 select" ],
);

%tio_01_00007_def =
( NAME    => "TIO_ICE_GMS_DBG_TRIG_SELECT",
  ADDRESS => 0x00000000b00000e8,
  NOTE    => "This register holds the settings for the ICE DEBUG port data and note nibble selects for trigger functionality.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00007_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_GMS_DBG_TRIG_ENABLE                                          #
#                                                                        #
##########################################################################

%tio_01_00008_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_TRIG_CMP_EN"            => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Debug Trigger Compare Enable" ],
);

%tio_01_00008_def =
( NAME    => "TIO_ICE_GMS_DBG_TRIG_ENABLE",
  ADDRESS => 0x00000000b00000f0,
  NOTE    => "This holds the debug compare enable bits for triggers via the Debug note Port. If a bit is 1, the corresponding bit of the trigg",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00008_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_GMS_DBG_MUX_SELECT                                           #
#                                                                        #
##########################################################################

%tio_01_00009_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_TRIG_EN"                => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Debug Trigger Select" ],
   "DEBUG_NIB7_SEL"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 7 select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA7_SEL"              => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Debug data group 7 select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB6_SEL"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 6 select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA6_SEL"              => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Debug data group 6 select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB5_SEL"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 5 select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA5_SEL"              => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Debug data group 5 select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB4_SEL"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 4 select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA4_SEL"              => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Debug data group 4 select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB3_SEL"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 3 select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA3_SEL"              => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Debug data group 3 select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB2_SEL"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Debug nibble group 2 select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA2_SEL"              => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Debug data group 2 select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB1_SEL"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Debug nibble group 1 select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA1_SEL"              => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Debug data group 1 select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB0_SEL"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Debug nibble group 0 select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA0_SEL"              => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Debug data group 0 select" ],
);

%tio_01_00009_def =
( NAME    => "TIO_ICE_GMS_DBG_MUX_SELECT",
  ADDRESS => 0x00000000b00000f8,
  NOTE    => "This register holds the settings for the ICE DEBUG port data and note nibble selects.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00009_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_GMS_TIMEOUT_PULSE                                            #
#                                                                        #
##########################################################################

%tio_01_00010_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  13,  51, 0xFFFFFFFFFFFFE000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GMS_TIMEOUT_PULSE"            => [   1,   0,  13, 0x0000000000001FFF, 0x00, 1, 0x0000000000000000, "GMS Timeout Pulse Control" ],
);

%tio_01_00010_def =
( NAME    => "TIO_ICE_GMS_TIMEOUT_PULSE",
  ADDRESS => 0x00000000b0000100,
  NOTE    => "This register holds the programmable timeout pulse value for the note ICE timeout pulse counter. The timeout pulse counter count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00010_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_GMS_TIMEOUT_PRESCALE                                         #
#                                                                        #
##########################################################################

%tio_01_00011_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GMS_TIMEOUT_PRESCALE"         => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 1, 0x0000000000000000, "Timeout Prescale" ],
);

%tio_01_00011_def =
( NAME    => "TIO_ICE_GMS_TIMEOUT_PRESCALE",
  ADDRESS => 0x00000000b0000108,
  NOTE    => "This register holds the programmable timeout prescale value for the note ICE timeout prescale counter. The timeout prescale coun",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00011_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_GMS_REQ_NACK_LIMIT                                           #
#                                                                        #
##########################################################################

%tio_01_00012_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_NACK_LIMIT"               => [   1,   0,  12, 0x0000000000000FFF, 0x00, 1, 0x0000000000000000, "Programmable NACK Limit" ],
);

%tio_01_00012_def =
( NAME    => "TIO_ICE_GMS_REQ_NACK_LIMIT",
  ADDRESS => 0x00000000b0000110,
  NOTE    => "This is the programmable NACK limit for the request controllers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00012_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_GMS_REQ_PRIORITY                                             #
#                                                                        #
##########################################################################

%tio_01_00013_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_PRIORITY"                 => [   1,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Programmable NACKed Request Priority" ],
);

%tio_01_00013_def =
( NAME    => "TIO_ICE_GMS_REQ_PRIORITY",
  ADDRESS => 0x00000000b0000118,
  NOTE    => "This is to set the increments for NACKed request priority.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00013_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_ERROR_SUMMARY                                            #
#                                                                        #
##########################################################################

%tio_01_00014_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   7,  57, 0xFFFFFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_RSP_CRED_OF_ERR"           => [   1,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "XN Response Credit Overflow Error" ],
   "XN_REQ_CRED_OF_ERR"           => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "XN Request Credit Overflow Error" ],
   "XN_REQ_BFR_OF_ERR"            => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Request Buffer Overflow Error" ],
   "XN_RSP_HEAD_ERR"              => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Response Head Error" ],
   "XN_REQ_HEAD_ERR"              => [   5,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Request Head Error" ],
   "XN_RSP_INV_ERR"               => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Response Invalid Error" ],
   "XN_REQ_INV_ERR"               => [   7,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Request Invalid Error" ],
);

%tio_01_00014_def =
( NAME    => "TIO_ICE_NPA_ERROR_SUMMARY",
  ADDRESS => 0x00000000b0002000,
  NOTE    => "This register indicates what errors have been detected within the note NPA. When any of these bits set the global block will als",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00014_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_ERROR_SUMMARY_ALIAS                                      #
#                                                                        #
##########################################################################

%tio_01_00015_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   7,  57, 0xFFFFFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_RSP_CRED_OF_ERR"           => [   1,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "XN Response Credit Overflow Error" ],
   "XN_REQ_CRED_OF_ERR"           => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "XN Request Credit Overflow Error" ],
   "XN_REQ_BFR_OF_ERR"            => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Request Buffer Overflow Error" ],
   "XN_RSP_HEAD_ERR"              => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Response Head Error" ],
   "XN_REQ_HEAD_ERR"              => [   5,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Request Head Error" ],
   "XN_RSP_INV_ERR"               => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Response Invalid Error" ],
   "XN_REQ_INV_ERR"               => [   7,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Request Invalid Error" ],
);

%tio_01_00015_def =
( NAME    => "TIO_ICE_NPA_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x00000000b0002008,
  NOTE    => "This register is an alias for the NPA Error Summary register. When note accessing the NPA Error Summary register, the SW attribu",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00015_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_FIRST_ERROR                                              #
#                                                                        #
##########################################################################

%tio_01_00016_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   7,  57, 0xFFFFFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_RSP_CRED_OF_ERR"           => [   1,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "XN Response Credit Overflow Error" ],
   "XN_REQ_CRED_OF_ERR"           => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "XN Request Credit Overflow Error" ],
   "XN_REQ_BFR_OF_ERR"            => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Request Buffer Overflow Error" ],
   "XN_RSP_HEAD_ERR"              => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Response Head Error" ],
   "XN_REQ_HEAD_ERR"              => [   5,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Request Head Error" ],
   "XN_RSP_INV_ERR"               => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Response Invalid Error" ],
   "XN_REQ_INV_ERR"               => [   7,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Request Invalid Error" ],
);

%tio_01_00016_def =
( NAME    => "TIO_ICE_NPA_FIRST_ERROR",
  ADDRESS => 0x00000000b0002020,
  NOTE    => "When an error occurs within the NPA and this register equals zero, note the corresponding bit of the error will set in this regi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00016_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_XN_ERROR_DETAIL_1                                        #
#                                                                        #
##########################################################################

%tio_01_00017_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   2,  52,   9, 0x1FF0000000000000, 0x00, 0, 0x0000000000000000, "Message Echo Field" ],
   "RSVD1"                        => [   3,  49,   3, 0x000E000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HEADER_ERROR"                 => [   4,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "Header Error" ],
   "RSVD2"                        => [   5,  42,   6, 0x0000FC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DESTINATION_CHIPLET_ID"       => [   6,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Message Destination Chiplet ID" ],
   "SOURCE_CHIPLET_ID"            => [   7,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Message Source Chiplet ID" ],
   "SOURCE_NODE_ID"               => [   8,  24,  14, 0x0000003FFF000000, 0x00, 0, 0x0000000000000000, "Message Source Node ID" ],
   "SUPPLEMENTAL"                 => [   9,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Message Supplemental Field" ],
   "COMMAND"                      => [  10,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Message Command" ],
);

%tio_01_00017_def =
( NAME    => "TIO_ICE_NPA_XN_ERROR_DETAIL_1",
  ADDRESS => 0x00000000b0002040,
  NOTE    => "This register captures the contents of the network message header note when an error is detected. The Valid bit indicates that t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00017_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_XN_ERROR_DETAIL_2                                        #
#                                                                        #
##########################################################################

%tio_01_00018_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   3,  49, 0x000FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Message Address" ],
);

%tio_01_00018_def =
( NAME    => "TIO_ICE_NPA_XN_ERROR_DETAIL_2",
  ADDRESS => 0x00000000b0002048,
  NOTE    => "This register captures the address of the network message when an note error is detected by the NPA. It triggers on the same err",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00018_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_XN_DATA0_CMP                                             #
#                                                                        #
##########################################################################

%tio_01_00019_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "XN_DATA0_CMP"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "XN Data0 Compare" ],
);

%tio_01_00019_def =
( NAME    => "TIO_ICE_NPA_XN_DATA0_CMP",
  ADDRESS => 0x00000000b00020c0,
  NOTE    => "This register is used in conjunction with the NPA XN DATA0 ENABLE note register to generate a pulse to the debug port when data ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00019_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_XN_DATA1_CMP                                             #
#                                                                        #
##########################################################################

%tio_01_00020_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "XN_DATA1_CMP"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "XN Data1 Compare" ],
);

%tio_01_00020_def =
( NAME    => "TIO_ICE_NPA_XN_DATA1_CMP",
  ADDRESS => 0x00000000b00020c8,
  NOTE    => "This register is used in conjunction with the NPA XN DATA1 ENABLE note register to generate a pulse to the debug port when data ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00020_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_XN_DATA0_EN                                              #
#                                                                        #
##########################################################################

%tio_01_00021_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "XN_DATA0_EN"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "XN Data0 Enable" ],
);

%tio_01_00021_def =
( NAME    => "TIO_ICE_NPA_XN_DATA0_EN",
  ADDRESS => 0x00000000b00020d0,
  NOTE    => "This register is used in conjunction with the NPA XN DATA0 COMPARE note register to generate a pulse to the debug port when data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00021_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_XN_DATA1_EN                                              #
#                                                                        #
##########################################################################

%tio_01_00022_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "XN_DATA1_EN"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "XN Data1 Enable" ],
);

%tio_01_00022_def =
( NAME    => "TIO_ICE_NPA_XN_DATA1_EN",
  ADDRESS => 0x00000000b00020d8,
  NOTE    => "This register is used in conjunction with the NPA XN DATA1 COMPARE note register to generate a pulse to the debug port when data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00022_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_DBG_MUX_SELECT                                           #
#                                                                        #
##########################################################################

%tio_01_00023_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_PORT_SEL"             => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_PORT_SEL"             => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_PORT_SEL"             => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_PORT_SEL"             => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_PORT_SEL"             => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_PORT_SEL"             => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_PORT_SEL"             => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_PORT_SEL"             => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_00023_def =
( NAME    => "TIO_ICE_NPA_DBG_MUX_SELECT",
  ADDRESS => 0x00000000b00020f8,
  NOTE    => "This register controls which signals from the NPA are routed to the note global debug mux.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00023_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_WR_ACC_CFG                                               #
#                                                                        #
##########################################################################

%tio_01_00024_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WAB_BYPASS_DIS"               => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Write Accelerate Buffer Bypass Disable" ],
   "WAB_CRED_LIMIT"               => [   2,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Write Accelerate Buffer Credit Limit" ],
);

%tio_01_00024_def =
( NAME    => "TIO_ICE_NPA_WR_ACC_CFG",
  ADDRESS => 0x00000000b0002100,
  NOTE    => "This register contains the configuration information needed by the note Write Accelerate Buffer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00024_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_WR_REQ_CFG                                               #
#                                                                        #
##########################################################################

%tio_01_00025_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRB_BYPASS_DIS"               => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Write Request Buffer Bypass Disable" ],
   "WRB_CRED_LIMIT"               => [   2,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Write Request Buffer Credit Limit" ],
);

%tio_01_00025_def =
( NAME    => "TIO_ICE_NPA_WR_REQ_CFG",
  ADDRESS => 0x00000000b0002108,
  NOTE    => "This register contains the configuration information needed by the note Write Request Buffer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00025_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_RD_ACC_CFG                                               #
#                                                                        #
##########################################################################

%tio_01_00026_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RAB_BYPASS_DIS"               => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Read Accelerate Buffer Bypass Disable" ],
   "RSVD1"                        => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RAB_CRED_LIMIT"               => [   3,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Read Accelerate Buffer Credit Limit" ],
);

%tio_01_00026_def =
( NAME    => "TIO_ICE_NPA_RD_ACC_CFG",
  ADDRESS => 0x00000000b0002110,
  NOTE    => "This register contains the configuration information needed by the note Read Accelerate Buffer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00026_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_RD_REQ_CFG                                               #
#                                                                        #
##########################################################################

%tio_01_00027_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRB_BYPASS_DIS"               => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Read Request Buffer Bypass Disable" ],
   "RSVD1"                        => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRB_CRED_LIMIT"               => [   3,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Read Request Buffer Credit Limit" ],
);

%tio_01_00027_def =
( NAME    => "TIO_ICE_NPA_RD_REQ_CFG",
  ADDRESS => 0x00000000b0002118,
  NOTE    => "This register contains the configuration information needed by the note Read Request Buffer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00027_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_NOQ_REQ_CFG                                              #
#                                                                        #
##########################################################################

%tio_01_00028_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  13,  51, 0xFFFFFFFFFFFFE000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOQ_REQ_THROTTLE_EN"          => [   1,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "NOQ Request Throttle Enable" ],
   "MAX_REQ_CRED_CNT"             => [   2,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "NOQ Max Request Credit Count" ],
);

%tio_01_00028_def =
( NAME    => "TIO_ICE_NPA_NOQ_REQ_CFG",
  ADDRESS => 0x00000000b0002120,
  NOTE    => "This register contains the configuration information needed by the note Network Output Queue Request logic.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00028_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_NOQ_RSP_CFG                                              #
#                                                                        #
##########################################################################

%tio_01_00029_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  13,  51, 0xFFFFFFFFFFFFE000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOQ_RSP_THROTTLE_EN"          => [   1,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "NOQ Response Throttle Enable" ],
   "MAX_RSP_CRED_CNT"             => [   2,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "NOQ Max Response Credit Count" ],
   "RSVD1"                        => [   3,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FRZ_RSP_BYPASS_DIS"           => [   4,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "FRZ Response Buffer Bypass Disable" ],
   "RSVD2"                        => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FRZ_RSP_CRED_LIMIT"           => [   6,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "FRZ Response Buffer Credit Limit" ],
);

%tio_01_00029_def =
( NAME    => "TIO_ICE_NPA_NOQ_RSP_CFG",
  ADDRESS => 0x00000000b0002128,
  NOTE    => "This register contains the configuration information needed by the note Network Output Queue Response logic and the Freezer Resp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00029_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_RIQ_CFG                                                  #
#                                                                        #
##########################################################################

%tio_01_00030_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 1, 0x0000000000000000, "Scratch Bits" ],
   "RSVD0"                        => [   1,   5,  55, 0x0FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_BYPASS_DIS"               => [   2,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "RIQ Bypass Disable" ],
);

%tio_01_00030_def =
( NAME    => "TIO_ICE_NPA_RIQ_CFG",
  ADDRESS => 0x00000000b0002130,
  NOTE    => "This register contains the configuration information needed by the note Request Issue Queue.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00030_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_RD_WR_DYN_CREDIT_STAT                                     #
#                                                                        #
##########################################################################

%tio_01_00031_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  27,  37, 0xFFFFFFFFF8000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRC_REQ_CRED_CNT"             => [   1,  24,   3, 0x0000000007000000, 0x00, 1, 0x0000000000000000, "RRC Request Credit Count" ],
   "RSVD1"                        => [   2,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRC_ACC_CRED_CNT"             => [   3,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "RRC Accelerate Credit Count" ],
   "RSVD2"                        => [   4,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRC_REQ_CRED_CNT"             => [   5,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "WRC Request Credit Count" ],
   "RSVD3"                        => [   6,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRC_ACC_CRED_CNT"             => [   7,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "WRC Accelerate Credit Count" ],
);

%tio_01_00031_def =
( NAME    => "TIO_ICE_NPA_RD_WR_DYN_CREDIT_STAT",
  ADDRESS => 0x00000000b0002140,
  NOTE    => "This register holds the current state of the credit counters that note interface to the RRC and WRC.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00031_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_RD_WR_LAST_CREDIT_STAT                                     #
#                                                                        #
##########################################################################

%tio_01_00032_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  27,  37, 0xFFFFFFFFF8000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRC_REQ_CRED_CNT"             => [   1,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "RRC Request Credit Count" ],
   "RSVD1"                        => [   2,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRC_ACC_CRED_CNT"             => [   3,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "RRC Accelerate Credit Count" ],
   "RSVD2"                        => [   4,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRC_REQ_CRED_CNT"             => [   5,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "WRC Request Credit Count" ],
   "RSVD3"                        => [   6,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRC_ACC_CRED_CNT"             => [   7,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "WRC Accelerate Credit Count" ],
);

%tio_01_00032_def =
( NAME    => "TIO_ICE_NPA_RD_WR_LAST_CREDIT_STAT",
  ADDRESS => 0x00000000b0002148,
  NOTE    => "This register holds the state of the credit counters that interface note to the RRC and WRC when a soft reset is issued. This is",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00032_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_NOQ_DYN_CREDIT_STAT                                      #
#                                                                        #
##########################################################################

%tio_01_00033_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_RSP_CRED_CNT"              => [   1,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "XN Response Credit Count" ],
   "RSVD1"                        => [   2,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_REQ_CRED_CNT"              => [   3,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "XN Request Credit Count" ],
   "RSVD2"                        => [   4,  11,   5, 0x000000000000F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FRZ_RSP_CRED_CNT"             => [   5,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "FRZ Response Credit Count" ],
);

%tio_01_00033_def =
( NAME    => "TIO_ICE_NPA_NOQ_DYN_CREDIT_STAT",
  ADDRESS => 0x00000000b0002150,
  NOTE    => "This register holds the current state of the credit counters that note are used in the Network Output Queue.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00033_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_NOQ_LAST_CREDIT_STAT                                     #
#                                                                        #
##########################################################################

%tio_01_00034_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_RSP_CRED_CNT"              => [   1,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "XN Response Credit Count" ],
   "RSVD1"                        => [   2,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_REQ_CRED_CNT"              => [   3,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "XN Request Credit Count" ],
   "RSVD2"                        => [   4,  11,   5, 0x000000000000F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FRZ_RSP_CRED_CNT"             => [   5,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "FRZ Response Credit Count" ],
);

%tio_01_00034_def =
( NAME    => "TIO_ICE_NPA_NOQ_LAST_CREDIT_STAT",
  ADDRESS => 0x00000000b0002158,
  NOTE    => "This register holds the state of the credit counters that are used note in the Network Output Queue when a soft reset is issued.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00034_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_RIQ_DYN_STAT                                             #
#                                                                        #
##########################################################################

%tio_01_00035_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_WR_RTY_VALID"             => [   1,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "RIQ Write Retry Valid" ],
   "RIQ_WR_NEW_VALID"             => [   2,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "RIQ Write New Valid" ],
   "RIQ_RD_RTY_VALID"             => [   3,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "RIQ Read Retry Valid" ],
   "RIQ_RD_NEW_VALID"             => [   4,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "RIQ Read New Valid" ],
   "RSVD1"                        => [   5,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_WR_ADDR"                  => [   6,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "RIQ Write Address" ],
   "RSVD2"                        => [   7,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_RD_ADDR"                  => [   8,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "RIQ Read Address" ],
);

%tio_01_00035_def =
( NAME    => "TIO_ICE_NPA_RIQ_DYN_STAT",
  ADDRESS => 0x00000000b0002160,
  NOTE    => "This register contains status information about the Request Issue note Queue. The Request Issue Queue is responsible for holding",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00035_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_RIQ_LAST_STAT                                            #
#                                                                        #
##########################################################################

%tio_01_00036_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_WR_RTY_VALID"             => [   1,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "RIQ Write Retry Valid" ],
   "RIQ_WR_NEW_VALID"             => [   2,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "RIQ Write New Valid" ],
   "RIQ_RD_RTY_VALID"             => [   3,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "RIQ Read Retry Valid" ],
   "RIQ_RD_NEW_VALID"             => [   4,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "RIQ Read New Valid" ],
   "RSVD1"                        => [   5,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_WR_ADDR"                  => [   6,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "RIQ Write Address" ],
   "RSVD2"                        => [   7,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_RD_ADDR"                  => [   8,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "RIQ Read Address" ],
);

%tio_01_00036_def =
( NAME    => "TIO_ICE_NPA_RIQ_LAST_STAT",
  ADDRESS => 0x00000000b0002168,
  NOTE    => "This register holds the state of the Request Issue Queue when a note soft reset is issued. This is intended as a debug tool.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00036_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_NIQ_REQ_CFG                                              #
#                                                                        #
##########################################################################

%tio_01_00037_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIQ_PRB_CRED_THRES"           => [   1,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "NIQ PRB Credit Threshold" ],
   "RSVD1"                        => [   2,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_REQ_CRED"               => [   3,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NIQ Force Request Credit" ],
   "NIQ_REQ_BYPASS_DIS"           => [   4,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NIQ Request Buffer Bypass Disable" ],
   "NIQ_REQ_CRED_LIMIT"           => [   5,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "NIQ Request Buffer Credit Limit" ],
);

%tio_01_00037_def =
( NAME    => "TIO_ICE_NPA_NIQ_REQ_CFG",
  ADDRESS => 0x00000000b0002180,
  NOTE    => "This register contains the configuration information needed by the note Network Input Queue Request Buffer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00037_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_NIQ_RSP_CFG                                              #
#                                                                        #
##########################################################################

%tio_01_00038_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIQ_RSP_CRED_LIMIT"           => [   1,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "NIQ Response Buffer Credit Limit" ],
);

%tio_01_00038_def =
( NAME    => "TIO_ICE_NPA_NIQ_RSP_CFG",
  ADDRESS => 0x00000000b0002188,
  NOTE    => "This register contains the configuration information needed by the note Network Input Queue Response channel. It should be noted",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00038_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_NIQ_DYN_CREDIT_STAT                                      #
#                                                                        #
##########################################################################

%tio_01_00039_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIQ_PRB_CRED_CNT"             => [   1,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "NIQ PRB Credit Count" ],
   "RSVD1"                        => [   2,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIQ_RSP_CRED_CNT"             => [   3,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "NIQ Response Credit Count" ],
   "RSVD2"                        => [   4,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIQ_REQ_CRED_CNT"             => [   5,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "NIQ Request Credit Count" ],
);

%tio_01_00039_def =
( NAME    => "TIO_ICE_NPA_NIQ_DYN_CREDIT_STAT",
  ADDRESS => 0x00000000b0002190,
  NOTE    => "This register holds the current state of the credit counters that note are used in the Network Input Queue.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00039_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_NIQ_LAST_CREDIT_STAT                                     #
#                                                                        #
##########################################################################

%tio_01_00040_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIQ_PRB_CRED_CNT"             => [   1,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "NIQ PRB Credit Count" ],
   "RSVD1"                        => [   2,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIQ_RSP_CRED_CNT"             => [   3,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "NIQ Response Credit Count" ],
   "RSVD2"                        => [   4,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIQ_REQ_CRED_CNT"             => [   5,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "NIQ Request Credit Count" ],
);

%tio_01_00040_def =
( NAME    => "TIO_ICE_NPA_NIQ_LAST_CREDIT_STAT",
  ADDRESS => 0x00000000b0002198,
  NOTE    => "This register holds the state of the credit counters that are used note in the Network Input Queue when a soft reset is issued. ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00040_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_HQ_VAL_DETAIL0                                           #
#                                                                        #
##########################################################################

%tio_01_00041_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HQ_VALID_63_0"                => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "PIO Head Queue Valid Bits 63:0" ],
);

%tio_01_00041_def =
( NAME    => "TIO_ICE_NPA_HQ_VAL_DETAIL0",
  ADDRESS => 0x00000000b0002200,
  NOTE    => "This register holds the head queue valid bits for head queue note entries 0 to 63. When this register is read, the head queue va",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00041_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_HQ_VAL_DETAIL1                                           #
#                                                                        #
##########################################################################

%tio_01_00042_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HQ_VALID_95_64"               => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "PIO Head Queue Valid Bits 95:64" ],
);

%tio_01_00042_def =
( NAME    => "TIO_ICE_NPA_HQ_VAL_DETAIL1",
  ADDRESS => 0x00000000b0002208,
  NOTE    => "This register holds the head queue valid bits for head queue note entries 64 to 95. The valid bis are captured in this register ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00042_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_HQ_ENTRY0                                                #
#                                                                        #
##########################################################################

%tio_01_00043_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HQ_VAL"                       => [   1,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PIO Head Queue 0 Valid" ],
   "HQ_NACK_REC"                  => [   2,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "PIO Head Queue 0 NACK Received" ],
   "HQ_RW"                        => [   3,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PIO Head Queue 0 Read/Write Indicator" ],
   "HQ_CRB_NUM"                   => [   4,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "PIO Head Queue 0 CRB Number" ],
);

%tio_01_00043_def =
( NAME    => "TIO_ICE_NPA_HQ_ENTRY0",
  ADDRESS => 0x00000000b0002210,
  NOTE    => "This register holds the contents of the head queue entry that is at note the top of the head queue.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00043_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_NPA_HQ_EJECT_HEAD                                            #
#                                                                        #
##########################################################################

%tio_01_00044_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EJECT_HEAD"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PIO Head Queue Eject Head" ],
);

%tio_01_00044_def =
( NAME    => "TIO_ICE_NPA_HQ_EJECT_HEAD",
  ADDRESS => 0x00000000b0002218,
  NOTE    => "This register is intended to be used as a diagnostic register and note gives software the ability to pop head queue entry 0 off ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00044_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_ERROR_SUMMARY                                            #
#                                                                        #
##########################################################################

%tio_01_00045_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CT_WR_REQ_BAD_BE"             => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "CT Bad Byte Enables" ],
   "CT_WR_REQ_DSB_ERR"            => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "CT Data Sideband Error" ],
   "CT_WR_REQ_LG_ERR"             => [   3,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "CT Write Request Long Error" ],
   "CT_WR_REQ_SH_ER"              => [   4,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "CT Write Request Short Error" ],
   "WR_CRB_OF_ERR"                => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Write CRB Overflow Error" ],
   "WR_CRB_NACK_ERR"              => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Write CRB NACK Limit Error" ],
   "WR_CRB_TO_ERR"                => [   7,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Write CRB Timeout Error" ],
   "XN_WR_RSP_ACC_ERR"            => [   8,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Access Error" ],
   "XN_WR_RSP_UNEXP_ERR"          => [   9,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Unexpected Response Error" ],
   "XN_WR_RSP_DSB_ERR"            => [  10,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Write Response Data Sideband Error" ],
   "XN_WR_RSP_LG_ERR"             => [  11,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Write Response Long Error" ],
   "XN_WR_RSP_SH_ERR"             => [  12,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Write Response Short Error" ],
);

%tio_01_00045_def =
( NAME    => "TIO_ICE_WRC_ERROR_SUMMARY",
  ADDRESS => 0x00000000b0004000,
  NOTE    => "This register indicates what errors have been detected within the note WRC. When any of these bits set the global block will als",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00045_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_ERROR_SUMMARY_ALIAS                                      #
#                                                                        #
##########################################################################

%tio_01_00046_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CT_WR_REQ_BAD_BE"             => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "CT Bad Byte Enables" ],
   "CT_WR_REQ_DSB_ERR"            => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "CT Data Sideband Error" ],
   "CT_WR_REQ_LG_ERR"             => [   3,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "CT Write Request Long Error" ],
   "CT_WR_REQ_SH_ER"              => [   4,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "CT Write Request Short Error" ],
   "WR_CRB_OF_ERR"                => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Write CRB Overflow Error" ],
   "WR_CRB_NACK_ERR"              => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Write CRB NACK Limit Error" ],
   "WR_CRB_TO_ERR"                => [   7,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Write CRB Timeout Error" ],
   "XN_WR_RSP_ACC_ERR"            => [   8,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Access Error" ],
   "XN_WR_RSP_UNEXP_ERR"          => [   9,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Unexpected Response Error" ],
   "XN_WR_RSP_DSB_ERR"            => [  10,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Write Response Data Sideband Error" ],
   "XN_WR_RSP_LG_ERR"             => [  11,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Write Response Long Error" ],
   "XN_WR_RSP_SH_ERR"             => [  12,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Write Response Short Error" ],
);

%tio_01_00046_def =
( NAME    => "TIO_ICE_WRC_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x00000000b0004008,
  NOTE    => "This register is an alias for the WRC Error Summary register. When note accessing the WRC Error Summary register, the SW attribu",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00046_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_FIRST_ERROR                                              #
#                                                                        #
##########################################################################

%tio_01_00047_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CT_WR_REQ_BAD_BE"             => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "CT Bad Byte Enables" ],
   "CT_WR_REQ_DSB_ERR"            => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "CT Data Sideband Error" ],
   "CT_WR_REQ_LG_ERR"             => [   3,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "CT Write Request Long Error" ],
   "CT_WR_REQ_SH_ER"              => [   4,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "CT Write Request Short Error" ],
   "WR_CRB_OF_ERR"                => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Write CRB Overflow Error" ],
   "WR_CRB_NACK_ERR"              => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Write CRB NACK Limit Error" ],
   "WR_CRB_TO_ERR"                => [   7,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Write CRB Timeout Error" ],
   "XN_WR_RSP_ACC_ERR"            => [   8,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Access Error" ],
   "XN_WR_RSP_UNEXP_ERR"          => [   9,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Unexpected Response Error" ],
   "XN_WR_RSP_DSB_ERR"            => [  10,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Write Response Data Sideband Error" ],
   "XN_WR_RSP_LG_ERR"             => [  11,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Write Response Long Error" ],
   "XN_WR_RSP_SH_ERR"             => [  12,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Write Response Short Error" ],
);

%tio_01_00047_def =
( NAME    => "TIO_ICE_WRC_FIRST_ERROR",
  ADDRESS => 0x00000000b0004020,
  NOTE    => "When an error occurs within the WRC and this register is zero, the note corresponding bit of the error will set in this register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00047_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_XN_ERROR_DETAIL_1                                        #
#                                                                        #
##########################################################################

%tio_01_00048_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   2,  52,   9, 0x1FF0000000000000, 0x00, 0, 0x0000000000000000, "Echo Field" ],
   "RSVD1"                        => [   3,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_ERROR"                   => [   4,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Data Error" ],
   "RSVD2"                        => [   5,  42,   7, 0x0001FC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DESTINATION_ID"               => [   6,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Message Destination Chiplet ID" ],
   "SOURCE_CHIPLET_ID"            => [   7,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Message Source ID" ],
   "SOURCE_NODE_ID"               => [   8,  24,  14, 0x0000003FFF000000, 0x00, 0, 0x0000000000000000, "Message Source ID" ],
   "SUPPLEMENTAL"                 => [   9,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Message Supplemental Field" ],
   "COMMAND"                      => [  10,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Message Command" ],
);

%tio_01_00048_def =
( NAME    => "TIO_ICE_WRC_XN_ERROR_DETAIL_1",
  ADDRESS => 0x00000000b0004040,
  NOTE    => "This register captures the contents of the network message that note caused the error within the WRC. Once this register capture",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00048_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_XN_ERROR_DETAIL_2                                        #
#                                                                        #
##########################################################################

%tio_01_00049_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   3,  49, 0x000FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Message Address" ],
);

%tio_01_00049_def =
( NAME    => "TIO_ICE_WRC_XN_ERROR_DETAIL_2",
  ADDRESS => 0x00000000b0004048,
  NOTE    => "This register captures the address of the network message when an note error is detected by the WRC. It triggers on the same err",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00049_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CT_ERROR_DETAIL_1                                        #
#                                                                        #
##########################################################################

%tio_01_00050_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "RSVD0"                        => [   1,  50,  13, 0x7FFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_ERROR"                   => [   2,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Data Error" ],
   "RSVD1"                        => [   3,  36,  13, 0x0001FFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMMAND_ERROR_BIT"            => [   4,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Coretalk Command Word Error Bit" ],
   "PIO_NOT_MEMORY"               => [   5,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PIO operation not memory operation" ],
   "RSVD2"                        => [   6,  24,  10, 0x00000003FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DBL_WRD_DATA_ENABLE"          => [   7,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Coretalk Double Word Data Enable" ],
   "TNUM"                         => [   8,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Coretalk Transaction Number" ],
   "DATA_SIZE"                    => [   9,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Coretalk Data Size" ],
   "SOURCE_ID"                    => [  10,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "Coretalk Source ID" ],
   "PACKET_TYPE"                  => [  11,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Coretalk Packet Type" ],
);

%tio_01_00050_def =
( NAME    => "TIO_ICE_WRC_CT_ERROR_DETAIL_1",
  ADDRESS => 0x00000000b0004060,
  NOTE    => "This register captures the contents of the Coretalk packet that note caused an error withing the WRC. Once this register capture",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00050_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CT_ERROR_DETAIL_2                                        #
#                                                                        #
##########################################################################

%tio_01_00051_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   3,  53, 0x00FFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Coretalk Address" ],
);

%tio_01_00051_def =
( NAME    => "TIO_ICE_WRC_CT_ERROR_DETAIL_2",
  ADDRESS => 0x00000000b0004068,
  NOTE    => "This register triggers on the same errors as wrc_ct_error_detail_1 note and is armed in the same manner.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00051_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_DBG_MUX_SELECT                                           #
#                                                                        #
##########################################################################

%tio_01_00052_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_PORT_SEL"             => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_PORT_SEL"             => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_PORT_SEL"             => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_PORT_SEL"             => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_PORT_SEL"             => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_PORT_SEL"             => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_PORT_SEL"             => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_PORT_SEL"             => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_00052_def =
( NAME    => "TIO_ICE_WRC_DBG_MUX_SELECT",
  ADDRESS => 0x00000000b00040f8,
  NOTE    => "This register controls which signals from the WRC are routed to the note global debug mux.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00052_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CFG                                                      #
#                                                                        #
##########################################################################

%tio_01_00053_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 1, 0x0000000000000000, "Scratch Bits" ],
   "RSVD0"                        => [   1,  10,  50, 0x0FFFFFFFFFFFFC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_BYPASS_DISABLE"          => [   2,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Data Bypass Disable" ],
   "RIQ_BYPASS_DISABLE"           => [   3,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Request Issue Queue Bypass Disable" ],
   "RSVD1"                        => [   4,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_LIMIT"                 => [   5,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Credit Limit" ],
);

%tio_01_00053_def =
( NAME    => "TIO_ICE_WRC_CFG",
  ADDRESS => 0x00000000b0004100,
  NOTE    => "This register provides the ability to force some modes intended to note be used to aid functionality testing.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00053_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_TIMEOUT_DETAIL                                           #
#                                                                        #
##########################################################################

%tio_01_00054_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMEOUT"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 1, 0x0000000000000000, "WRC Timeout" ],
);

%tio_01_00054_def =
( NAME    => "TIO_ICE_WRC_TIMEOUT_DETAIL",
  ADDRESS => 0x00000000b0004108,
  NOTE    => "This register indicates which CRBs have timed-out or reached the note NACK limit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00054_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_DYN_CREDIT_STAT                                          #
#                                                                        #
##########################################################################

%tio_01_00055_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACC_CREDIT"                   => [   1,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "NPA Accelerated Request Credit" ],
   "RSVD1"                        => [   2,  36,  12, 0x0000FFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_CREDIT"                   => [   3,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "NPA Write Request Credit" ],
   "RSVD2"                        => [   4,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PMI_CREDIT"                   => [   5,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "PMI Credit Count" ],
   "RSVD3"                        => [   6,   6,  10, 0x000000000000FFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_USED"                     => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Number of CRBs used" ],
);

%tio_01_00055_def =
( NAME    => "TIO_ICE_WRC_DYN_CREDIT_STAT",
  ADDRESS => 0x00000000b0004110,
  NOTE    => "This register indicates the current state of the credit counters note within the WRC.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00055_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_LAST_CREDIT_STAT                                         #
#                                                                        #
##########################################################################

%tio_01_00056_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_ACC_CREDIT"              => [   1,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Last NPA Accelerated Request Credit" ],
   "RSVD1"                        => [   2,  36,  12, 0x0000FFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_REQ_CREDIT"              => [   3,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Last NPA Write Request Credit" ],
   "RSVD2"                        => [   4,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_PMI_CREDIT"              => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Last PMI Credit Count" ],
   "RSVD3"                        => [   6,   6,  10, 0x000000000000FFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_CRB_USED"                => [   7,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Last Number of CRBs used" ],
);

%tio_01_00056_def =
( NAME    => "TIO_ICE_WRC_LAST_CREDIT_STAT",
  ADDRESS => 0x00000000b0004118,
  NOTE    => "This register holds the state of the credit counters in the WRC note when a soft reset is issued. This is intended as a debug to",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00056_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_IQ_STAT                                                  #
#                                                                        #
##########################################################################

%tio_01_00057_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AIQ_OUTPUT_VALID"             => [   1,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "Accelerated Issue Queue Output Valid" ],
   "RSVD1"                        => [   2,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AIQ_WRITE_ADDR"               => [   3,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "Accelerated Issue Queue Write Address" ],
   "RSVD2"                        => [   4,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AIQ_READ_ADDR"                => [   5,  32,   5, 0x0000001F00000000, 0x00, 1, 0x0000000000000000, "Accelerated Issue Queue Read Address" ],
   "RSVD3"                        => [   6,  17,  15, 0x00000000FFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_OUTPUT_VALID"             => [   7,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Request Issue Queue Output Valid" ],
   "RSVD4"                        => [   8,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_WRITE_ADDR"               => [   9,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Request Issue Queue Write Address" ],
   "RSVD5"                        => [  10,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_READ_ADDR"                => [  11,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Request Issue Queue Read Address" ],
);

%tio_01_00057_def =
( NAME    => "TIO_ICE_WRC_IQ_STAT",
  ADDRESS => 0x00000000b0004120,
  NOTE    => "This register contains some status information from the two issue note queues.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00057_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_0                                                    #
#                                                                        #
##########################################################################

%tio_01_00058_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00058_def =
( NAME    => "TIO_ICE_WRC_CRB_0",
  ADDRESS => 0x00000000b0004800,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00058_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_1                                                    #
#                                                                        #
##########################################################################

%tio_01_00059_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00059_def =
( NAME    => "TIO_ICE_WRC_CRB_1",
  ADDRESS => 0x00000000b0004810,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00059_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_2                                                    #
#                                                                        #
##########################################################################

%tio_01_00060_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00060_def =
( NAME    => "TIO_ICE_WRC_CRB_2",
  ADDRESS => 0x00000000b0004820,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00060_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_3                                                    #
#                                                                        #
##########################################################################

%tio_01_00061_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00061_def =
( NAME    => "TIO_ICE_WRC_CRB_3",
  ADDRESS => 0x00000000b0004830,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00061_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_4                                                    #
#                                                                        #
##########################################################################

%tio_01_00062_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00062_def =
( NAME    => "TIO_ICE_WRC_CRB_4",
  ADDRESS => 0x00000000b0004840,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00062_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_5                                                    #
#                                                                        #
##########################################################################

%tio_01_00063_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00063_def =
( NAME    => "TIO_ICE_WRC_CRB_5",
  ADDRESS => 0x00000000b0004850,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00063_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_6                                                    #
#                                                                        #
##########################################################################

%tio_01_00064_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00064_def =
( NAME    => "TIO_ICE_WRC_CRB_6",
  ADDRESS => 0x00000000b0004860,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00064_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_7                                                    #
#                                                                        #
##########################################################################

%tio_01_00065_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00065_def =
( NAME    => "TIO_ICE_WRC_CRB_7",
  ADDRESS => 0x00000000b0004870,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00065_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_8                                                    #
#                                                                        #
##########################################################################

%tio_01_00066_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00066_def =
( NAME    => "TIO_ICE_WRC_CRB_8",
  ADDRESS => 0x00000000b0004880,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00066_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_9                                                    #
#                                                                        #
##########################################################################

%tio_01_00067_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00067_def =
( NAME    => "TIO_ICE_WRC_CRB_9",
  ADDRESS => 0x00000000b0004890,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00067_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_10                                                   #
#                                                                        #
##########################################################################

%tio_01_00068_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00068_def =
( NAME    => "TIO_ICE_WRC_CRB_10",
  ADDRESS => 0x00000000b00048a0,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00068_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_11                                                   #
#                                                                        #
##########################################################################

%tio_01_00069_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00069_def =
( NAME    => "TIO_ICE_WRC_CRB_11",
  ADDRESS => 0x00000000b00048b0,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00069_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_12                                                   #
#                                                                        #
##########################################################################

%tio_01_00070_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00070_def =
( NAME    => "TIO_ICE_WRC_CRB_12",
  ADDRESS => 0x00000000b00048c0,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00070_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_13                                                   #
#                                                                        #
##########################################################################

%tio_01_00071_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00071_def =
( NAME    => "TIO_ICE_WRC_CRB_13",
  ADDRESS => 0x00000000b00048d0,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00071_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_14                                                   #
#                                                                        #
##########################################################################

%tio_01_00072_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00072_def =
( NAME    => "TIO_ICE_WRC_CRB_14",
  ADDRESS => 0x00000000b00048e0,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00072_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_15                                                   #
#                                                                        #
##########################################################################

%tio_01_00073_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00073_def =
( NAME    => "TIO_ICE_WRC_CRB_15",
  ADDRESS => 0x00000000b00048f0,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00073_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_16                                                   #
#                                                                        #
##########################################################################

%tio_01_00074_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00074_def =
( NAME    => "TIO_ICE_WRC_CRB_16",
  ADDRESS => 0x00000000b0004900,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00074_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_17                                                   #
#                                                                        #
##########################################################################

%tio_01_00075_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00075_def =
( NAME    => "TIO_ICE_WRC_CRB_17",
  ADDRESS => 0x00000000b0004910,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00075_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_18                                                   #
#                                                                        #
##########################################################################

%tio_01_00076_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00076_def =
( NAME    => "TIO_ICE_WRC_CRB_18",
  ADDRESS => 0x00000000b0004920,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00076_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_19                                                   #
#                                                                        #
##########################################################################

%tio_01_00077_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00077_def =
( NAME    => "TIO_ICE_WRC_CRB_19",
  ADDRESS => 0x00000000b0004930,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00077_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_20                                                   #
#                                                                        #
##########################################################################

%tio_01_00078_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00078_def =
( NAME    => "TIO_ICE_WRC_CRB_20",
  ADDRESS => 0x00000000b0004940,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00078_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_21                                                   #
#                                                                        #
##########################################################################

%tio_01_00079_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00079_def =
( NAME    => "TIO_ICE_WRC_CRB_21",
  ADDRESS => 0x00000000b0004950,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00079_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_22                                                   #
#                                                                        #
##########################################################################

%tio_01_00080_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00080_def =
( NAME    => "TIO_ICE_WRC_CRB_22",
  ADDRESS => 0x00000000b0004960,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00080_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_23                                                   #
#                                                                        #
##########################################################################

%tio_01_00081_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00081_def =
( NAME    => "TIO_ICE_WRC_CRB_23",
  ADDRESS => 0x00000000b0004970,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00081_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_24                                                   #
#                                                                        #
##########################################################################

%tio_01_00082_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00082_def =
( NAME    => "TIO_ICE_WRC_CRB_24",
  ADDRESS => 0x00000000b0004980,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00082_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_25                                                   #
#                                                                        #
##########################################################################

%tio_01_00083_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00083_def =
( NAME    => "TIO_ICE_WRC_CRB_25",
  ADDRESS => 0x00000000b0004990,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00083_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_26                                                   #
#                                                                        #
##########################################################################

%tio_01_00084_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00084_def =
( NAME    => "TIO_ICE_WRC_CRB_26",
  ADDRESS => 0x00000000b00049a0,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00084_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_27                                                   #
#                                                                        #
##########################################################################

%tio_01_00085_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00085_def =
( NAME    => "TIO_ICE_WRC_CRB_27",
  ADDRESS => 0x00000000b00049b0,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00085_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_28                                                   #
#                                                                        #
##########################################################################

%tio_01_00086_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00086_def =
( NAME    => "TIO_ICE_WRC_CRB_28",
  ADDRESS => 0x00000000b00049c0,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00086_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_29                                                   #
#                                                                        #
##########################################################################

%tio_01_00087_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00087_def =
( NAME    => "TIO_ICE_WRC_CRB_29",
  ADDRESS => 0x00000000b00049d0,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00087_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_30                                                   #
#                                                                        #
##########################################################################

%tio_01_00088_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00088_def =
( NAME    => "TIO_ICE_WRC_CRB_30",
  ADDRESS => 0x00000000b00049e0,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00088_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_31                                                   #
#                                                                        #
##########################################################################

%tio_01_00089_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "RSVD0"                        => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00089_def =
( NAME    => "TIO_ICE_WRC_CRB_31",
  ADDRESS => 0x00000000b00049f0,
  NOTE    => "There are 32 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00089_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_0                                               #
#                                                                        #
##########################################################################

%tio_01_00090_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00090_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_0",
  ADDRESS => 0x00000000b0004808,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00090_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_1                                               #
#                                                                        #
##########################################################################

%tio_01_00091_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00091_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_1",
  ADDRESS => 0x00000000b0004818,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00091_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_2                                               #
#                                                                        #
##########################################################################

%tio_01_00092_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00092_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_2",
  ADDRESS => 0x00000000b0004828,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00092_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_3                                               #
#                                                                        #
##########################################################################

%tio_01_00093_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00093_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_3",
  ADDRESS => 0x00000000b0004838,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00093_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_4                                               #
#                                                                        #
##########################################################################

%tio_01_00094_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00094_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_4",
  ADDRESS => 0x00000000b0004848,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00094_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_5                                               #
#                                                                        #
##########################################################################

%tio_01_00095_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00095_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_5",
  ADDRESS => 0x00000000b0004858,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00095_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_6                                               #
#                                                                        #
##########################################################################

%tio_01_00096_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00096_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_6",
  ADDRESS => 0x00000000b0004868,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00096_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_7                                               #
#                                                                        #
##########################################################################

%tio_01_00097_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00097_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_7",
  ADDRESS => 0x00000000b0004878,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00097_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_8                                               #
#                                                                        #
##########################################################################

%tio_01_00098_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00098_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_8",
  ADDRESS => 0x00000000b0004888,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00098_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_9                                               #
#                                                                        #
##########################################################################

%tio_01_00099_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00099_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_9",
  ADDRESS => 0x00000000b0004898,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00099_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_10                                              #
#                                                                        #
##########################################################################

%tio_01_00100_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00100_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_10",
  ADDRESS => 0x00000000b00048a8,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00100_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_11                                              #
#                                                                        #
##########################################################################

%tio_01_00101_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00101_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_11",
  ADDRESS => 0x00000000b00048b8,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00101_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_12                                              #
#                                                                        #
##########################################################################

%tio_01_00102_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00102_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_12",
  ADDRESS => 0x00000000b00048c8,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00102_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_13                                              #
#                                                                        #
##########################################################################

%tio_01_00103_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00103_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_13",
  ADDRESS => 0x00000000b00048d8,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00103_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_14                                              #
#                                                                        #
##########################################################################

%tio_01_00104_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00104_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_14",
  ADDRESS => 0x00000000b00048e8,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00104_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_15                                              #
#                                                                        #
##########################################################################

%tio_01_00105_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00105_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_15",
  ADDRESS => 0x00000000b00048f8,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00105_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_16                                              #
#                                                                        #
##########################################################################

%tio_01_00106_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00106_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_16",
  ADDRESS => 0x00000000b0004908,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00106_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_17                                              #
#                                                                        #
##########################################################################

%tio_01_00107_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00107_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_17",
  ADDRESS => 0x00000000b0004918,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00107_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_18                                              #
#                                                                        #
##########################################################################

%tio_01_00108_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00108_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_18",
  ADDRESS => 0x00000000b0004928,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00108_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_19                                              #
#                                                                        #
##########################################################################

%tio_01_00109_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00109_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_19",
  ADDRESS => 0x00000000b0004938,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00109_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_20                                              #
#                                                                        #
##########################################################################

%tio_01_00110_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00110_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_20",
  ADDRESS => 0x00000000b0004948,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00110_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_21                                              #
#                                                                        #
##########################################################################

%tio_01_00111_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00111_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_21",
  ADDRESS => 0x00000000b0004958,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00111_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_22                                              #
#                                                                        #
##########################################################################

%tio_01_00112_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00112_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_22",
  ADDRESS => 0x00000000b0004968,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00112_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_23                                              #
#                                                                        #
##########################################################################

%tio_01_00113_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00113_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_23",
  ADDRESS => 0x00000000b0004978,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00113_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_24                                              #
#                                                                        #
##########################################################################

%tio_01_00114_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00114_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_24",
  ADDRESS => 0x00000000b0004988,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00114_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_25                                              #
#                                                                        #
##########################################################################

%tio_01_00115_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00115_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_25",
  ADDRESS => 0x00000000b0004998,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00115_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_26                                              #
#                                                                        #
##########################################################################

%tio_01_00116_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00116_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_26",
  ADDRESS => 0x00000000b00049a8,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00116_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_27                                              #
#                                                                        #
##########################################################################

%tio_01_00117_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00117_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_27",
  ADDRESS => 0x00000000b00049b8,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00117_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_28                                              #
#                                                                        #
##########################################################################

%tio_01_00118_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00118_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_28",
  ADDRESS => 0x00000000b00049c8,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00118_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_29                                              #
#                                                                        #
##########################################################################

%tio_01_00119_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00119_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_29",
  ADDRESS => 0x00000000b00049d8,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00119_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_30                                              #
#                                                                        #
##########################################################################

%tio_01_00120_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00120_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_30",
  ADDRESS => 0x00000000b00049e8,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00120_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_WRC_CRB_ADDR_31                                              #
#                                                                        #
##########################################################################

%tio_01_00121_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00121_def =
( NAME    => "TIO_ICE_WRC_CRB_ADDR_31",
  ADDRESS => 0x00000000b00049f8,
  NOTE    => "There are 32 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00121_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_ERROR_SUMMARY                                            #
#                                                                        #
##########################################################################

%tio_01_00122_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CT_RD_REQ_LG_ERR"             => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "CT Read Request Long Error" ],
   "RD_CRB_OF_ERR"                => [   2,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Read CRB Overflow Error" ],
   "RD_CRB_NACK_ERR"              => [   3,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Read CRB NACK Limit Error" ],
   "RD_CRB_TO_ERR"                => [   4,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Read CRB Timeout Error" ],
   "XN_RD_RSP_ACC_ERR"            => [   5,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Access Error" ],
   "XN_RD_RSP_UNEXP_ERR"          => [   6,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Unexpected Response Error" ],
   "XN_RD_RSP_DSB_ERR"            => [   7,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Data Sideband Error" ],
   "XN_RD_RSP_LG_ERR"             => [   8,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Read Response Long Error" ],
   "XN_RD_RSP_SH_ERR"             => [   9,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Read Response Short Error" ],
);

%tio_01_00122_def =
( NAME    => "TIO_ICE_RRC_ERROR_SUMMARY",
  ADDRESS => 0x00000000b0006000,
  NOTE    => "This register indicates what errors have been detected within the note RRC. When any of these bits set the global block will als",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00122_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_ERROR_SUMMARY_ALIAS                                      #
#                                                                        #
##########################################################################

%tio_01_00123_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CT_RD_REQ_LG_ERR"             => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "CT Read Request Long Error" ],
   "RD_CRB_OF_ERR"                => [   2,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Read CRB Overflow Error" ],
   "RD_CRB_NACK_ERR"              => [   3,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Read CRB NACK Limit Error" ],
   "RD_CRB_TO_ERR"                => [   4,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Read CRB Timeout Error" ],
   "XN_RD_RSP_ACC_ERR"            => [   5,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Access Error" ],
   "XN_RD_RSP_UNEXP_ERR"          => [   6,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Unexpected Response Error" ],
   "XN_RD_RSP_DSB_ERR"            => [   7,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Data Sideband Error" ],
   "XN_RD_RSP_LG_ERR"             => [   8,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Read Response Long Error" ],
   "XN_RD_RSP_SH_ERR"             => [   9,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Read Response Short Error" ],
);

%tio_01_00123_def =
( NAME    => "TIO_ICE_RRC_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x00000000b0006008,
  NOTE    => "This register is an alias for the RRC Error Summary register. When note accessing the RRC Error Summary register, the SW attribu",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00123_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_FIRST_ERROR                                              #
#                                                                        #
##########################################################################

%tio_01_00124_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CT_RD_REQ_LG_ERR"             => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "CT Read Request Long Error" ],
   "RD_CRB_OF_ERR"                => [   2,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Read CRB Overflow Error" ],
   "RD_CRB_NACK_ERR"              => [   3,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Read CRB NACK Limit Error" ],
   "RD_CRB_TO_ERR"                => [   4,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Read CRB Timeout Error" ],
   "XN_RD_RSP_ACC_ERR"            => [   5,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "XN Access Error" ],
   "XN_RD_RSP_UNEXP_ERR"          => [   6,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "XN Unexpected Response Error" ],
   "XN_RD_RSP_DSB_ERR"            => [   7,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Data Sideband Error" ],
   "XN_RD_RSP_LG_ERR"             => [   8,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "XN Read Response Long Error" ],
   "XN_RD_RSP_SH_ERR"             => [   9,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "XN Read Response Short Error" ],
);

%tio_01_00124_def =
( NAME    => "TIO_ICE_RRC_FIRST_ERROR",
  ADDRESS => 0x00000000b0006020,
  NOTE    => "When an error occurs within the RRC and this register is zero, the note corresponding bit of the error will set in this register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00124_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_XN_ERROR_DETAIL_1                                        #
#                                                                        #
##########################################################################

%tio_01_00125_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   2,  52,   9, 0x1FF0000000000000, 0x00, 0, 0x0000000000000000, "Echo Field" ],
   "RSVD1"                        => [   3,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_ERROR"                   => [   4,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Data Error" ],
   "RSVD2"                        => [   5,  42,   7, 0x0001FC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DESTINATION_ID"               => [   6,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Message Destination Chiplet ID" ],
   "SOURCE_CHIPLET_ID"            => [   7,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Message Source ID" ],
   "SOURCE_NODE_ID"               => [   8,  24,  14, 0x0000003FFF000000, 0x00, 0, 0x0000000000000000, "Message Source ID" ],
   "SUPPLEMENTAL"                 => [   9,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Message Supplemental Field" ],
   "COMMAND"                      => [  10,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Message Command" ],
);

%tio_01_00125_def =
( NAME    => "TIO_ICE_RRC_XN_ERROR_DETAIL_1",
  ADDRESS => 0x00000000b0006040,
  NOTE    => "This register captures the contents of the network message that note caused the error within the RRC. Once this register capture",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00125_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_XN_ERROR_DETAIL_2                                        #
#                                                                        #
##########################################################################

%tio_01_00126_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   3,  49, 0x000FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Message Address" ],
);

%tio_01_00126_def =
( NAME    => "TIO_ICE_RRC_XN_ERROR_DETAIL_2",
  ADDRESS => 0x00000000b0006048,
  NOTE    => "This register captures the address of the network message when an note error is detected by the RRC. It triggers on the same err",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00126_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CT_ERROR_DETAIL_1                                        #
#                                                                        #
##########################################################################

%tio_01_00127_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "RSVD0"                        => [   1,  36,  27, 0x7FFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMMAND_ERROR_BIT"            => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Coretalk Command Word Error Bit" ],
   "PIO_NOT_MEMORY"               => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PIO operation not memory operation" ],
   "MEMORY_READ_PARAM"            => [   4,  32,   2, 0x0000000300000000, 0x00, 0, 0x0000000000000000, "Memory Read Parameters" ],
   "RSVD1"                        => [   5,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TNUM"                         => [   6,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Coretalk Transaction Number" ],
   "DATA_SIZE"                    => [   7,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Coretalk Data Size" ],
   "SOURCE_ID"                    => [   8,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "Coretalk Source ID" ],
   "PACKET_TYPE"                  => [   9,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Coretalk Packet Type" ],
);

%tio_01_00127_def =
( NAME    => "TIO_ICE_RRC_CT_ERROR_DETAIL_1",
  ADDRESS => 0x00000000b0006060,
  NOTE    => "This register captures the contents of the Coretalk packet that note caused an error withing the RRC. Once this register capture",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00127_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CT_ERROR_DETAIL_2                                        #
#                                                                        #
##########################################################################

%tio_01_00128_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   3,  53, 0x00FFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Coretalk Address" ],
);

%tio_01_00128_def =
( NAME    => "TIO_ICE_RRC_CT_ERROR_DETAIL_2",
  ADDRESS => 0x00000000b0006068,
  NOTE    => "This register triggers on the same errors as rrc_ct_error_detail_1 note and is armed in the same manner.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00128_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_DBG_MUX_SELECT                                           #
#                                                                        #
##########################################################################

%tio_01_00129_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_PORT_SEL"             => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_PORT_SEL"             => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_PORT_SEL"             => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_PORT_SEL"             => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_PORT_SEL"             => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_PORT_SEL"             => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_PORT_SEL"             => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_PORT_SEL"             => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_00129_def =
( NAME    => "TIO_ICE_RRC_DBG_MUX_SELECT",
  ADDRESS => 0x00000000b00060f8,
  NOTE    => "This register controls which signals from the RRC are routed to the note global debug mux.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00129_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CFG                                                      #
#                                                                        #
##########################################################################

%tio_01_00130_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 1, 0x0000000000000000, "Scratch Bits" ],
   "RSVD0"                        => [   1,  13,  47, 0x0FFFFFFFFFFFE000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GET_MSG_DISABLE"              => [   2,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Disable GET messages" ],
   "RSVD1"                        => [   3,   9,   3, 0x0000000000000E00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_BYPASS_DISABLE"           => [   4,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Request Issue Queue Bypass Disable" ],
   "RSVD2"                        => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_LIMIT"                 => [   6,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "Credit Limit" ],
);

%tio_01_00130_def =
( NAME    => "TIO_ICE_RRC_CFG",
  ADDRESS => 0x00000000b0006100,
  NOTE    => "This register controls the credits between the RRC and PMI.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00130_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_TIMEOUT_DETAIL                                           #
#                                                                        #
##########################################################################

%tio_01_00131_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TIMEOUT"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "RRC Timeout" ],
);

%tio_01_00131_def =
( NAME    => "TIO_ICE_RRC_TIMEOUT_DETAIL",
  ADDRESS => 0x00000000b0006108,
  NOTE    => "This register indicates which CRBs have timed-out or reached the note NACK limit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00131_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_DYN_CREDIT_STAT                                          #
#                                                                        #
##########################################################################

%tio_01_00132_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ACC_CREDIT"                   => [   1,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "NPA Accelerated Request Credit" ],
   "RSVD1"                        => [   2,  36,  12, 0x0000FFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_CREDIT"                   => [   3,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "NPA Read Request Credit" ],
   "RSVD2"                        => [   4,  23,   9, 0x00000000FF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PMI_CREDIT"                   => [   5,  16,   7, 0x00000000007F0000, 0x00, 1, 0x0000000000000000, "PMI Credit Count" ],
   "RSVD3"                        => [   6,   7,   9, 0x000000000000FF80, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_USED"                     => [   7,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "Number of CRBs used" ],
);

%tio_01_00132_def =
( NAME    => "TIO_ICE_RRC_DYN_CREDIT_STAT",
  ADDRESS => 0x00000000b0006118,
  NOTE    => "This register indicates the current state of the credit counters note within the RRC.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00132_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_LAST_CREDIT_STAT                                         #
#                                                                        #
##########################################################################

%tio_01_00133_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_ACC_CREDIT"              => [   1,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Last NPA Accelerated Request Credit" ],
   "RSVD1"                        => [   2,  36,  12, 0x0000FFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_REQ_CREDIT"              => [   3,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Last NPA Read Request Credit" ],
   "RSVD2"                        => [   4,  23,   9, 0x00000000FF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_PMI_CREDIT"              => [   5,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Last PMI Credit Count" ],
   "RSVD3"                        => [   6,   7,   9, 0x000000000000FF80, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_CRB_USED"                => [   7,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "Last Number of CRBs used" ],
);

%tio_01_00133_def =
( NAME    => "TIO_ICE_RRC_LAST_CREDIT_STAT",
  ADDRESS => 0x00000000b0006120,
  NOTE    => "This register holds the state of the credit counters in the RRC note when a soft reset is issued. This is intended as a debug to",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00133_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_IQ_STAT                                                  #
#                                                                        #
##########################################################################

%tio_01_00134_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AIQ_OUTPUT_VALID"             => [   1,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "Accelerated Issue Queue Output Valid" ],
   "RSVD1"                        => [   2,  46,   2, 0x0000C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AIQ_WRITE_ADDR"               => [   3,  40,   6, 0x00003F0000000000, 0x00, 1, 0x0000000000000000, "Accelerated Issue Queue Write Address" ],
   "RSVD2"                        => [   4,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AIQ_READ_ADDR"                => [   5,  32,   6, 0x0000003F00000000, 0x00, 1, 0x0000000000000000, "Accelerated Issue Queue Read Address" ],
   "RSVD3"                        => [   6,  17,  15, 0x00000000FFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_OUTPUT_VALID"             => [   7,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Request Issue Queue Output Valid" ],
   "RSVD4"                        => [   8,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_WRITE_ADDR"               => [   9,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "Request Issue Queue Write Address" ],
   "RSVD5"                        => [  10,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_READ_ADDR"                => [  11,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Request Issue Queue Read Address" ],
);

%tio_01_00134_def =
( NAME    => "TIO_ICE_RRC_IQ_STAT",
  ADDRESS => 0x00000000b0006128,
  NOTE    => "This register contains some status information from the two issue note queues.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00134_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_0                                                    #
#                                                                        #
##########################################################################

%tio_01_00135_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00135_def =
( NAME    => "TIO_ICE_RRC_CRB_0",
  ADDRESS => 0x00000000b0006800,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00135_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_1                                                    #
#                                                                        #
##########################################################################

%tio_01_00136_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00136_def =
( NAME    => "TIO_ICE_RRC_CRB_1",
  ADDRESS => 0x00000000b0006810,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00136_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_2                                                    #
#                                                                        #
##########################################################################

%tio_01_00137_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00137_def =
( NAME    => "TIO_ICE_RRC_CRB_2",
  ADDRESS => 0x00000000b0006820,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00137_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_3                                                    #
#                                                                        #
##########################################################################

%tio_01_00138_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00138_def =
( NAME    => "TIO_ICE_RRC_CRB_3",
  ADDRESS => 0x00000000b0006830,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00138_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_4                                                    #
#                                                                        #
##########################################################################

%tio_01_00139_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00139_def =
( NAME    => "TIO_ICE_RRC_CRB_4",
  ADDRESS => 0x00000000b0006840,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00139_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_5                                                    #
#                                                                        #
##########################################################################

%tio_01_00140_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00140_def =
( NAME    => "TIO_ICE_RRC_CRB_5",
  ADDRESS => 0x00000000b0006850,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00140_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_6                                                    #
#                                                                        #
##########################################################################

%tio_01_00141_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00141_def =
( NAME    => "TIO_ICE_RRC_CRB_6",
  ADDRESS => 0x00000000b0006860,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00141_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_7                                                    #
#                                                                        #
##########################################################################

%tio_01_00142_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00142_def =
( NAME    => "TIO_ICE_RRC_CRB_7",
  ADDRESS => 0x00000000b0006870,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00142_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_8                                                    #
#                                                                        #
##########################################################################

%tio_01_00143_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00143_def =
( NAME    => "TIO_ICE_RRC_CRB_8",
  ADDRESS => 0x00000000b0006880,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00143_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_9                                                    #
#                                                                        #
##########################################################################

%tio_01_00144_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00144_def =
( NAME    => "TIO_ICE_RRC_CRB_9",
  ADDRESS => 0x00000000b0006890,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00144_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_10                                                   #
#                                                                        #
##########################################################################

%tio_01_00145_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00145_def =
( NAME    => "TIO_ICE_RRC_CRB_10",
  ADDRESS => 0x00000000b00068a0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00145_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_11                                                   #
#                                                                        #
##########################################################################

%tio_01_00146_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00146_def =
( NAME    => "TIO_ICE_RRC_CRB_11",
  ADDRESS => 0x00000000b00068b0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00146_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_12                                                   #
#                                                                        #
##########################################################################

%tio_01_00147_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00147_def =
( NAME    => "TIO_ICE_RRC_CRB_12",
  ADDRESS => 0x00000000b00068c0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00147_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_13                                                   #
#                                                                        #
##########################################################################

%tio_01_00148_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00148_def =
( NAME    => "TIO_ICE_RRC_CRB_13",
  ADDRESS => 0x00000000b00068d0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00148_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_14                                                   #
#                                                                        #
##########################################################################

%tio_01_00149_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00149_def =
( NAME    => "TIO_ICE_RRC_CRB_14",
  ADDRESS => 0x00000000b00068e0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00149_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_15                                                   #
#                                                                        #
##########################################################################

%tio_01_00150_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00150_def =
( NAME    => "TIO_ICE_RRC_CRB_15",
  ADDRESS => 0x00000000b00068f0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00150_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_16                                                   #
#                                                                        #
##########################################################################

%tio_01_00151_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00151_def =
( NAME    => "TIO_ICE_RRC_CRB_16",
  ADDRESS => 0x00000000b0006900,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00151_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_17                                                   #
#                                                                        #
##########################################################################

%tio_01_00152_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00152_def =
( NAME    => "TIO_ICE_RRC_CRB_17",
  ADDRESS => 0x00000000b0006910,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00152_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_18                                                   #
#                                                                        #
##########################################################################

%tio_01_00153_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00153_def =
( NAME    => "TIO_ICE_RRC_CRB_18",
  ADDRESS => 0x00000000b0006920,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00153_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_19                                                   #
#                                                                        #
##########################################################################

%tio_01_00154_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00154_def =
( NAME    => "TIO_ICE_RRC_CRB_19",
  ADDRESS => 0x00000000b0006930,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00154_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_20                                                   #
#                                                                        #
##########################################################################

%tio_01_00155_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00155_def =
( NAME    => "TIO_ICE_RRC_CRB_20",
  ADDRESS => 0x00000000b0006940,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00155_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_21                                                   #
#                                                                        #
##########################################################################

%tio_01_00156_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00156_def =
( NAME    => "TIO_ICE_RRC_CRB_21",
  ADDRESS => 0x00000000b0006950,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00156_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_22                                                   #
#                                                                        #
##########################################################################

%tio_01_00157_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00157_def =
( NAME    => "TIO_ICE_RRC_CRB_22",
  ADDRESS => 0x00000000b0006960,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00157_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_23                                                   #
#                                                                        #
##########################################################################

%tio_01_00158_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00158_def =
( NAME    => "TIO_ICE_RRC_CRB_23",
  ADDRESS => 0x00000000b0006970,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00158_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_24                                                   #
#                                                                        #
##########################################################################

%tio_01_00159_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00159_def =
( NAME    => "TIO_ICE_RRC_CRB_24",
  ADDRESS => 0x00000000b0006980,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00159_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_25                                                   #
#                                                                        #
##########################################################################

%tio_01_00160_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00160_def =
( NAME    => "TIO_ICE_RRC_CRB_25",
  ADDRESS => 0x00000000b0006990,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00160_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_26                                                   #
#                                                                        #
##########################################################################

%tio_01_00161_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00161_def =
( NAME    => "TIO_ICE_RRC_CRB_26",
  ADDRESS => 0x00000000b00069a0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00161_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_27                                                   #
#                                                                        #
##########################################################################

%tio_01_00162_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00162_def =
( NAME    => "TIO_ICE_RRC_CRB_27",
  ADDRESS => 0x00000000b00069b0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00162_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_28                                                   #
#                                                                        #
##########################################################################

%tio_01_00163_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00163_def =
( NAME    => "TIO_ICE_RRC_CRB_28",
  ADDRESS => 0x00000000b00069c0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00163_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_29                                                   #
#                                                                        #
##########################################################################

%tio_01_00164_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00164_def =
( NAME    => "TIO_ICE_RRC_CRB_29",
  ADDRESS => 0x00000000b00069d0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00164_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_30                                                   #
#                                                                        #
##########################################################################

%tio_01_00165_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00165_def =
( NAME    => "TIO_ICE_RRC_CRB_30",
  ADDRESS => 0x00000000b00069e0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00165_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_31                                                   #
#                                                                        #
##########################################################################

%tio_01_00166_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00166_def =
( NAME    => "TIO_ICE_RRC_CRB_31",
  ADDRESS => 0x00000000b00069f0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00166_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_32                                                   #
#                                                                        #
##########################################################################

%tio_01_00167_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00167_def =
( NAME    => "TIO_ICE_RRC_CRB_32",
  ADDRESS => 0x00000000b0006a00,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00167_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_33                                                   #
#                                                                        #
##########################################################################

%tio_01_00168_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00168_def =
( NAME    => "TIO_ICE_RRC_CRB_33",
  ADDRESS => 0x00000000b0006a10,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00168_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_34                                                   #
#                                                                        #
##########################################################################

%tio_01_00169_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00169_def =
( NAME    => "TIO_ICE_RRC_CRB_34",
  ADDRESS => 0x00000000b0006a20,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00169_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_35                                                   #
#                                                                        #
##########################################################################

%tio_01_00170_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00170_def =
( NAME    => "TIO_ICE_RRC_CRB_35",
  ADDRESS => 0x00000000b0006a30,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00170_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_36                                                   #
#                                                                        #
##########################################################################

%tio_01_00171_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00171_def =
( NAME    => "TIO_ICE_RRC_CRB_36",
  ADDRESS => 0x00000000b0006a40,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00171_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_37                                                   #
#                                                                        #
##########################################################################

%tio_01_00172_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00172_def =
( NAME    => "TIO_ICE_RRC_CRB_37",
  ADDRESS => 0x00000000b0006a50,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00172_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_38                                                   #
#                                                                        #
##########################################################################

%tio_01_00173_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00173_def =
( NAME    => "TIO_ICE_RRC_CRB_38",
  ADDRESS => 0x00000000b0006a60,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00173_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_39                                                   #
#                                                                        #
##########################################################################

%tio_01_00174_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00174_def =
( NAME    => "TIO_ICE_RRC_CRB_39",
  ADDRESS => 0x00000000b0006a70,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00174_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_40                                                   #
#                                                                        #
##########################################################################

%tio_01_00175_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00175_def =
( NAME    => "TIO_ICE_RRC_CRB_40",
  ADDRESS => 0x00000000b0006a80,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00175_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_41                                                   #
#                                                                        #
##########################################################################

%tio_01_00176_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00176_def =
( NAME    => "TIO_ICE_RRC_CRB_41",
  ADDRESS => 0x00000000b0006a90,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00176_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_42                                                   #
#                                                                        #
##########################################################################

%tio_01_00177_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00177_def =
( NAME    => "TIO_ICE_RRC_CRB_42",
  ADDRESS => 0x00000000b0006aa0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00177_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_43                                                   #
#                                                                        #
##########################################################################

%tio_01_00178_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00178_def =
( NAME    => "TIO_ICE_RRC_CRB_43",
  ADDRESS => 0x00000000b0006ab0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00178_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_44                                                   #
#                                                                        #
##########################################################################

%tio_01_00179_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00179_def =
( NAME    => "TIO_ICE_RRC_CRB_44",
  ADDRESS => 0x00000000b0006ac0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00179_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_45                                                   #
#                                                                        #
##########################################################################

%tio_01_00180_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00180_def =
( NAME    => "TIO_ICE_RRC_CRB_45",
  ADDRESS => 0x00000000b0006ad0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00180_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_46                                                   #
#                                                                        #
##########################################################################

%tio_01_00181_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00181_def =
( NAME    => "TIO_ICE_RRC_CRB_46",
  ADDRESS => 0x00000000b0006ae0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00181_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_47                                                   #
#                                                                        #
##########################################################################

%tio_01_00182_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00182_def =
( NAME    => "TIO_ICE_RRC_CRB_47",
  ADDRESS => 0x00000000b0006af0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00182_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_48                                                   #
#                                                                        #
##########################################################################

%tio_01_00183_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00183_def =
( NAME    => "TIO_ICE_RRC_CRB_48",
  ADDRESS => 0x00000000b0006b00,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00183_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_49                                                   #
#                                                                        #
##########################################################################

%tio_01_00184_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00184_def =
( NAME    => "TIO_ICE_RRC_CRB_49",
  ADDRESS => 0x00000000b0006b10,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00184_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_50                                                   #
#                                                                        #
##########################################################################

%tio_01_00185_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00185_def =
( NAME    => "TIO_ICE_RRC_CRB_50",
  ADDRESS => 0x00000000b0006b20,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00185_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_51                                                   #
#                                                                        #
##########################################################################

%tio_01_00186_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00186_def =
( NAME    => "TIO_ICE_RRC_CRB_51",
  ADDRESS => 0x00000000b0006b30,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00186_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_52                                                   #
#                                                                        #
##########################################################################

%tio_01_00187_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00187_def =
( NAME    => "TIO_ICE_RRC_CRB_52",
  ADDRESS => 0x00000000b0006b40,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00187_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_53                                                   #
#                                                                        #
##########################################################################

%tio_01_00188_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00188_def =
( NAME    => "TIO_ICE_RRC_CRB_53",
  ADDRESS => 0x00000000b0006b50,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00188_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_54                                                   #
#                                                                        #
##########################################################################

%tio_01_00189_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00189_def =
( NAME    => "TIO_ICE_RRC_CRB_54",
  ADDRESS => 0x00000000b0006b60,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00189_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_55                                                   #
#                                                                        #
##########################################################################

%tio_01_00190_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00190_def =
( NAME    => "TIO_ICE_RRC_CRB_55",
  ADDRESS => 0x00000000b0006b70,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00190_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_56                                                   #
#                                                                        #
##########################################################################

%tio_01_00191_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00191_def =
( NAME    => "TIO_ICE_RRC_CRB_56",
  ADDRESS => 0x00000000b0006b80,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00191_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_57                                                   #
#                                                                        #
##########################################################################

%tio_01_00192_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00192_def =
( NAME    => "TIO_ICE_RRC_CRB_57",
  ADDRESS => 0x00000000b0006b90,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00192_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_58                                                   #
#                                                                        #
##########################################################################

%tio_01_00193_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00193_def =
( NAME    => "TIO_ICE_RRC_CRB_58",
  ADDRESS => 0x00000000b0006ba0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00193_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_59                                                   #
#                                                                        #
##########################################################################

%tio_01_00194_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00194_def =
( NAME    => "TIO_ICE_RRC_CRB_59",
  ADDRESS => 0x00000000b0006bb0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00194_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_60                                                   #
#                                                                        #
##########################################################################

%tio_01_00195_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00195_def =
( NAME    => "TIO_ICE_RRC_CRB_60",
  ADDRESS => 0x00000000b0006bc0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00195_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_61                                                   #
#                                                                        #
##########################################################################

%tio_01_00196_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00196_def =
( NAME    => "TIO_ICE_RRC_CRB_61",
  ADDRESS => 0x00000000b0006bd0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00196_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_62                                                   #
#                                                                        #
##########################################################################

%tio_01_00197_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00197_def =
( NAME    => "TIO_ICE_RRC_CRB_62",
  ADDRESS => 0x00000000b0006be0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00197_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_63                                                   #
#                                                                        #
##########################################################################

%tio_01_00198_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "CRB_TCNT"                     => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "CRB Timeout Counter" ],
   "CRB_BKOFF"                    => [   2,  60,   2, 0x3000000000000000, 0x00, 1, 0x0000000000000000, "CRB Backoff State" ],
   "CRB_PMID"                     => [   3,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "CRB Personality Module ID" ],
   "CRB_DS"                       => [   4,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "CRB Data Size" ],
   "CRB_DWDE"                     => [   5,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "CRB Double Word Data Enables" ],
   "CRB_TNUM"                     => [   6,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "CRB Transaction Number" ],
   "CRB_ERROR"                    => [   7,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "CRB Error" ],
   "CRB_STATE"                    => [   8,  36,   3, 0x0000007000000000, 0x00, 1, 0x0000000000000000, "CRB State" ],
   "CRB_TYPE"                     => [   9,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "CRB Message Type" ],
   "CRB_NCNT"                     => [  10,  16,  12, 0x000000000FFF0000, 0x00, 1, 0x0000000000000000, "CRB NACK Count" ],
   "CRB_BLK"                      => [  11,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "CRB Blocking" ],
   "CRB_DOOMED"                   => [  12,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "CRB Doomed" ],
   "CRB_ICNT"                     => [  13,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "CRB IVACK Count" ],
);

%tio_01_00198_def =
( NAME    => "TIO_ICE_RRC_CRB_63",
  ADDRESS => 0x00000000b0006bf0,
  NOTE    => "There are 64 of the registers, one for each CRB. They are always note readable and, if the valid bit is not set when read, then ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00198_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_0                                               #
#                                                                        #
##########################################################################

%tio_01_00199_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00199_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_0",
  ADDRESS => 0x00000000b0006808,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00199_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_1                                               #
#                                                                        #
##########################################################################

%tio_01_00200_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00200_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_1",
  ADDRESS => 0x00000000b0006818,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00200_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_2                                               #
#                                                                        #
##########################################################################

%tio_01_00201_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00201_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_2",
  ADDRESS => 0x00000000b0006828,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00201_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_3                                               #
#                                                                        #
##########################################################################

%tio_01_00202_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00202_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_3",
  ADDRESS => 0x00000000b0006838,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00202_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_4                                               #
#                                                                        #
##########################################################################

%tio_01_00203_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00203_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_4",
  ADDRESS => 0x00000000b0006848,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00203_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_5                                               #
#                                                                        #
##########################################################################

%tio_01_00204_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00204_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_5",
  ADDRESS => 0x00000000b0006858,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00204_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_6                                               #
#                                                                        #
##########################################################################

%tio_01_00205_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00205_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_6",
  ADDRESS => 0x00000000b0006868,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00205_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_7                                               #
#                                                                        #
##########################################################################

%tio_01_00206_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00206_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_7",
  ADDRESS => 0x00000000b0006878,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00206_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_8                                               #
#                                                                        #
##########################################################################

%tio_01_00207_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00207_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_8",
  ADDRESS => 0x00000000b0006888,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00207_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_9                                               #
#                                                                        #
##########################################################################

%tio_01_00208_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00208_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_9",
  ADDRESS => 0x00000000b0006898,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00208_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_10                                              #
#                                                                        #
##########################################################################

%tio_01_00209_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00209_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_10",
  ADDRESS => 0x00000000b00068a8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00209_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_11                                              #
#                                                                        #
##########################################################################

%tio_01_00210_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00210_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_11",
  ADDRESS => 0x00000000b00068b8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00210_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_12                                              #
#                                                                        #
##########################################################################

%tio_01_00211_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00211_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_12",
  ADDRESS => 0x00000000b00068c8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00211_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_13                                              #
#                                                                        #
##########################################################################

%tio_01_00212_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00212_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_13",
  ADDRESS => 0x00000000b00068d8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00212_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_14                                              #
#                                                                        #
##########################################################################

%tio_01_00213_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00213_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_14",
  ADDRESS => 0x00000000b00068e8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00213_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_15                                              #
#                                                                        #
##########################################################################

%tio_01_00214_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00214_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_15",
  ADDRESS => 0x00000000b00068f8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00214_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_16                                              #
#                                                                        #
##########################################################################

%tio_01_00215_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00215_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_16",
  ADDRESS => 0x00000000b0006908,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00215_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_17                                              #
#                                                                        #
##########################################################################

%tio_01_00216_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00216_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_17",
  ADDRESS => 0x00000000b0006918,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00216_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_18                                              #
#                                                                        #
##########################################################################

%tio_01_00217_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00217_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_18",
  ADDRESS => 0x00000000b0006928,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00217_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_19                                              #
#                                                                        #
##########################################################################

%tio_01_00218_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00218_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_19",
  ADDRESS => 0x00000000b0006938,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00218_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_20                                              #
#                                                                        #
##########################################################################

%tio_01_00219_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00219_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_20",
  ADDRESS => 0x00000000b0006948,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00219_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_21                                              #
#                                                                        #
##########################################################################

%tio_01_00220_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00220_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_21",
  ADDRESS => 0x00000000b0006958,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00220_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_22                                              #
#                                                                        #
##########################################################################

%tio_01_00221_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00221_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_22",
  ADDRESS => 0x00000000b0006968,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00221_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_23                                              #
#                                                                        #
##########################################################################

%tio_01_00222_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00222_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_23",
  ADDRESS => 0x00000000b0006978,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00222_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_24                                              #
#                                                                        #
##########################################################################

%tio_01_00223_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00223_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_24",
  ADDRESS => 0x00000000b0006988,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00223_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_25                                              #
#                                                                        #
##########################################################################

%tio_01_00224_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00224_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_25",
  ADDRESS => 0x00000000b0006998,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00224_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_26                                              #
#                                                                        #
##########################################################################

%tio_01_00225_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00225_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_26",
  ADDRESS => 0x00000000b00069a8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00225_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_27                                              #
#                                                                        #
##########################################################################

%tio_01_00226_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00226_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_27",
  ADDRESS => 0x00000000b00069b8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00226_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_28                                              #
#                                                                        #
##########################################################################

%tio_01_00227_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00227_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_28",
  ADDRESS => 0x00000000b00069c8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00227_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_29                                              #
#                                                                        #
##########################################################################

%tio_01_00228_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00228_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_29",
  ADDRESS => 0x00000000b00069d8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00228_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_30                                              #
#                                                                        #
##########################################################################

%tio_01_00229_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00229_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_30",
  ADDRESS => 0x00000000b00069e8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00229_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_31                                              #
#                                                                        #
##########################################################################

%tio_01_00230_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00230_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_31",
  ADDRESS => 0x00000000b00069f8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00230_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_32                                              #
#                                                                        #
##########################################################################

%tio_01_00231_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00231_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_32",
  ADDRESS => 0x00000000b0006a08,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00231_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_33                                              #
#                                                                        #
##########################################################################

%tio_01_00232_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00232_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_33",
  ADDRESS => 0x00000000b0006a18,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00232_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_34                                              #
#                                                                        #
##########################################################################

%tio_01_00233_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00233_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_34",
  ADDRESS => 0x00000000b0006a28,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00233_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_35                                              #
#                                                                        #
##########################################################################

%tio_01_00234_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00234_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_35",
  ADDRESS => 0x00000000b0006a38,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00234_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_36                                              #
#                                                                        #
##########################################################################

%tio_01_00235_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00235_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_36",
  ADDRESS => 0x00000000b0006a48,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00235_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_37                                              #
#                                                                        #
##########################################################################

%tio_01_00236_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00236_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_37",
  ADDRESS => 0x00000000b0006a58,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00236_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_38                                              #
#                                                                        #
##########################################################################

%tio_01_00237_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00237_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_38",
  ADDRESS => 0x00000000b0006a68,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00237_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_39                                              #
#                                                                        #
##########################################################################

%tio_01_00238_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00238_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_39",
  ADDRESS => 0x00000000b0006a78,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00238_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_40                                              #
#                                                                        #
##########################################################################

%tio_01_00239_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00239_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_40",
  ADDRESS => 0x00000000b0006a88,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00239_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_41                                              #
#                                                                        #
##########################################################################

%tio_01_00240_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00240_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_41",
  ADDRESS => 0x00000000b0006a98,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00240_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_42                                              #
#                                                                        #
##########################################################################

%tio_01_00241_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00241_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_42",
  ADDRESS => 0x00000000b0006aa8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00241_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_43                                              #
#                                                                        #
##########################################################################

%tio_01_00242_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00242_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_43",
  ADDRESS => 0x00000000b0006ab8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00242_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_44                                              #
#                                                                        #
##########################################################################

%tio_01_00243_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00243_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_44",
  ADDRESS => 0x00000000b0006ac8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00243_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_45                                              #
#                                                                        #
##########################################################################

%tio_01_00244_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00244_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_45",
  ADDRESS => 0x00000000b0006ad8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00244_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_46                                              #
#                                                                        #
##########################################################################

%tio_01_00245_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00245_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_46",
  ADDRESS => 0x00000000b0006ae8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00245_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_47                                              #
#                                                                        #
##########################################################################

%tio_01_00246_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00246_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_47",
  ADDRESS => 0x00000000b0006af8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00246_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_48                                              #
#                                                                        #
##########################################################################

%tio_01_00247_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00247_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_48",
  ADDRESS => 0x00000000b0006b08,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00247_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_49                                              #
#                                                                        #
##########################################################################

%tio_01_00248_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00248_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_49",
  ADDRESS => 0x00000000b0006b18,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00248_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_50                                              #
#                                                                        #
##########################################################################

%tio_01_00249_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00249_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_50",
  ADDRESS => 0x00000000b0006b28,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00249_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_51                                              #
#                                                                        #
##########################################################################

%tio_01_00250_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00250_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_51",
  ADDRESS => 0x00000000b0006b38,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00250_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_52                                              #
#                                                                        #
##########################################################################

%tio_01_00251_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00251_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_52",
  ADDRESS => 0x00000000b0006b48,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00251_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_53                                              #
#                                                                        #
##########################################################################

%tio_01_00252_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00252_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_53",
  ADDRESS => 0x00000000b0006b58,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00252_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_54                                              #
#                                                                        #
##########################################################################

%tio_01_00253_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00253_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_54",
  ADDRESS => 0x00000000b0006b68,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00253_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_55                                              #
#                                                                        #
##########################################################################

%tio_01_00254_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00254_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_55",
  ADDRESS => 0x00000000b0006b78,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00254_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_56                                              #
#                                                                        #
##########################################################################

%tio_01_00255_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00255_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_56",
  ADDRESS => 0x00000000b0006b88,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00255_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_57                                              #
#                                                                        #
##########################################################################

%tio_01_00256_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00256_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_57",
  ADDRESS => 0x00000000b0006b98,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00256_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_58                                              #
#                                                                        #
##########################################################################

%tio_01_00257_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00257_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_58",
  ADDRESS => 0x00000000b0006ba8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00257_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_59                                              #
#                                                                        #
##########################################################################

%tio_01_00258_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00258_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_59",
  ADDRESS => 0x00000000b0006bb8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00258_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_60                                              #
#                                                                        #
##########################################################################

%tio_01_00259_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00259_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_60",
  ADDRESS => 0x00000000b0006bc8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00259_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_61                                              #
#                                                                        #
##########################################################################

%tio_01_00260_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00260_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_61",
  ADDRESS => 0x00000000b0006bd8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00260_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_62                                              #
#                                                                        #
##########################################################################

%tio_01_00261_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00261_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_62",
  ADDRESS => 0x00000000b0006be8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00261_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_RRC_CRB_ADDR_63                                              #
#                                                                        #
##########################################################################

%tio_01_00262_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "CRB Valid" ],
   "RSVD0"                        => [   1,  54,   9, 0x7FC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRB_ADDR"                     => [   2,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CRB Address" ],
);

%tio_01_00262_def =
( NAME    => "TIO_ICE_RRC_CRB_ADDR_63",
  ADDRESS => 0x00000000b0006bf8,
  NOTE    => "There are 64 of these registers, one for each CRB, and they follow note the same rules for reading and writing as the CRB Regist",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00262_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_ERROR_SUMMARY                                            #
#                                                                        #
##########################################################################

%tio_01_00263_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  13,  51, 0xFFFFFFFFFFFFE000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TT_INVAL_ERR"                 => [   1,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Look Up Table Invalid Data Error" ],
   "CT_RSP_UNEXP_ERR"             => [   2,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Coretalk Response Unexpected Error" ],
   "CT_RSP_DATA_ERROR"            => [   3,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Coretalk Response Data Sideband Error" ],
   "CT_LONG_PACKET"               => [   4,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Coretalk Response Long Packet Error" ],
   "CT_SHORT_PACKET"              => [   5,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Coretalk Response Short Packet Error" ],
   "PRB_OFLOW_ERROR"              => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PRB Overflow Error" ],
   "PRB_TIMEOUT_ERROR"            => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PRB Timeout Error" ],
   "XN_GFX_RSP_LONG_MSG"          => [   8,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Network GFX Response Long Message Error" ],
   "XN_GFX_ADDR_ERROR"            => [   9,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Network Graphics Address Error" ],
   "XN_REQ_PERM_ERR"              => [  10,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Network Request Permission Error" ],
   "XN_REQDATAERROR"              => [  11,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Network Request Data Error" ],
   "XN_REQ_LONG_MSG"              => [  12,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Network Request Long Message Error" ],
   "XN_REQ_SHORT_MSG"             => [  13,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Network Request Short Message Error" ],
);

%tio_01_00263_def =
( NAME    => "TIO_ICE_FRZ_ERROR_SUMMARY",
  ADDRESS => 0x00000000b0008000,
  NOTE    => "This register contains the summary of errors that get reported to note the GMS block.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00263_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_ERROR_SUMMARY_ALIAS                                      #
#                                                                        #
##########################################################################

%tio_01_00264_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  13,  51, 0xFFFFFFFFFFFFE000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TT_INVAL_ERR"                 => [   1,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Look Up Table Invalid Data Error" ],
   "CT_RSP_UNEXP_ERR"             => [   2,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Coretalk Response Unexpected Error" ],
   "CT_RSP_DATA_ERROR"            => [   3,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Coretalk Response Data Sideband Error" ],
   "CT_LONG_PACKET"               => [   4,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Coretalk Response Long Packet Error" ],
   "CT_SHORT_PACKET"              => [   5,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Coretalk Response Short Packet Error" ],
   "PRB_OFLOW_ERROR"              => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PRB Overflow Error" ],
   "PRB_TIMEOUT_ERROR"            => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PRB Timeout Error" ],
   "XN_GFX_RSP_LONG_MSG"          => [   8,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Network GFX Response Long Message Error" ],
   "XN_GFX_ADDR_ERROR"            => [   9,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Network Graphics Address Error" ],
   "XN_REQ_PERM_ERR"              => [  10,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Network Request Permission Error" ],
   "XN_REQDATAERROR"              => [  11,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Network Request Data Error" ],
   "XN_REQ_LONG_MSG"              => [  12,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Network Request Long Message Error" ],
   "XN_REQ_SHORT_MSG"             => [  13,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Network Request Short Message Error" ],
);

%tio_01_00264_def =
( NAME    => "TIO_ICE_FRZ_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x00000000b0008008,
  NOTE    => "This register is a 'write one to clear' access to the error summary note register.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00264_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_FIRST_ERROR                                              #
#                                                                        #
##########################################################################

%tio_01_00265_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  13,  51, 0xFFFFFFFFFFFFE000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TT_INVAL_ERR"                 => [   1,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Look Up Table Invalid Data Error" ],
   "CT_RSP_UNEXP_ERR"             => [   2,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Coretalk Response Unexpected Error" ],
   "CT_RSP_DATA_ERROR"            => [   3,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Coretalk Response Data Sideband Error" ],
   "CT_LONG_PACKET"               => [   4,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Coretalk Response Long Packet Error" ],
   "CT_SHORT_PACKET"              => [   5,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Coretalk Response Short Packet Error" ],
   "PRB_OFLOW_ERROR"              => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "PRB Overflow Error" ],
   "PRB_TIMEOUT_ERROR"            => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PRB Timeout Error" ],
   "XN_GFX_RSP_LONG_MSG"          => [   8,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Network GFX Response Long Message Error" ],
   "XN_GFX_ADDR_ERROR"            => [   9,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Network Graphics Address Error" ],
   "XN_REQ_PERM_ERR"              => [  10,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Network Request Permission Error" ],
   "XN_REQDATAERROR"              => [  11,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Network Request Data Error" ],
   "XN_REQ_LONG_MSG"              => [  12,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Network Request Long Message Error" ],
   "XN_REQ_SHORT_MSG"             => [  13,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Network Request Short Message Error" ],
);

%tio_01_00265_def =
( NAME    => "TIO_ICE_FRZ_FIRST_ERROR",
  ADDRESS => 0x00000000b0008020,
  NOTE    => "This register contains the first error that triggered and is stored note in the error summary register.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00265_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_XN_ERROR_DETAIL_1A                                       #
#                                                                        #
##########################################################################

%tio_01_00266_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   2,  52,   9, 0x1FF0000000000000, 0x00, 0, 0x0000000000000000, "Echo field" ],
   "RSVD1"                        => [   3,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_ERROR"                   => [   4,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Data Error" ],
   "RSVD2"                        => [   5,  42,   7, 0x0001FC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEST_CHIP_ID"                 => [   6,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Destination Chiplet ID" ],
   "SRC_CHIP_ID"                  => [   7,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Source Chiplet ID" ],
   "SRC_NODE_ID"                  => [   8,  24,  14, 0x0000003FFF000000, 0x00, 0, 0x0000000000000000, "Source Node ID" ],
   "SUPPLEMENTAL"                 => [   9,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Supplemental" ],
   "CW_WORD"                      => [  10,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Command Word" ],
);

%tio_01_00266_def =
( NAME    => "TIO_ICE_FRZ_XN_ERROR_DETAIL_1A",
  ADDRESS => 0x00000000b0008040,
  NOTE    => "This register captures the contents of the network message header note when an error is detected. The Valid bit indicates that t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00266_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_XN_ERROR_DETAIL_2A                                       #
#                                                                        #
##########################################################################

%tio_01_00267_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   3,  49, 0x000FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Address" ],
);

%tio_01_00267_def =
( NAME    => "TIO_ICE_FRZ_XN_ERROR_DETAIL_2A",
  ADDRESS => 0x00000000b0008048,
  NOTE    => "This register contains the address field from errant Network note Request. Note: Since SN2net address bits [2:0] are assumed to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00267_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_XN_ERROR_DETAIL_1B                                       #
#                                                                        #
##########################################################################

%tio_01_00268_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   2,  52,   9, 0x1FF0000000000000, 0x00, 0, 0x0000000000000000, "Echo field" ],
   "RSVD1"                        => [   3,  42,  10, 0x000FFC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEST_CHIP_ID"                 => [   4,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Destination Chiplet ID" ],
   "SRC_CHIP_ID"                  => [   5,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Source Chiplet ID" ],
   "SRC_NODE_ID"                  => [   6,  24,  14, 0x0000003FFF000000, 0x00, 0, 0x0000000000000000, "Source Node ID" ],
   "SUPPLEMENTAL"                 => [   7,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Supplemental" ],
   "CW_WORD"                      => [   8,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Command Word" ],
);

%tio_01_00268_def =
( NAME    => "TIO_ICE_FRZ_XN_ERROR_DETAIL_1B",
  ADDRESS => 0x00000000b0008050,
  NOTE    => "Log of the command word of a SN2net response packet header that note caused an error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00268_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_XN_ERROR_DETAIL_2B                                       #
#                                                                        #
##########################################################################

%tio_01_00269_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   3,  49, 0x000FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Address" ],
);

%tio_01_00269_def =
( NAME    => "TIO_ICE_FRZ_XN_ERROR_DETAIL_2B",
  ADDRESS => 0x00000000b0008058,
  NOTE    => "This register contains the address field from errant Network note Request. Note: Since SN2net address bits [2:0] are assumed to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00269_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_CT_ERROR_DETAIL_1                                        #
#                                                                        #
##########################################################################

%tio_01_00270_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "RSVD0"                        => [   1,  50,  13, 0x7FFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_ERROR"                   => [   2,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Data Error" ],
   "HEADER_ERROR"                 => [   3,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "Header Error" ],
   "RSVD1"                        => [   4,  36,  12, 0x0000FFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMMAND_ERROR_BIT"            => [   5,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Coretalk Command Word Error Bit" ],
   "PIO_NOT_MEMORY"               => [   6,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PIO operation not memory operation" ],
   "MEM_READ_PARAMETERS"          => [   7,  32,   2, 0x0000000300000000, 0x00, 0, 0x0000000000000000, "Memory Read Parameters" ],
   "GRAPHICS_CREDITS"             => [   8,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Graphics Credits" ],
   "DBL_WRD_DATA_ENABLE"          => [   9,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Coretalk Double Word Data Enable" ],
   "TNUM"                         => [  10,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Coretalk Transaction Number" ],
   "DATA_SIZE"                    => [  11,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Coretalk Data Size" ],
   "SOURCE_ID"                    => [  12,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "Coretalk Source ID" ],
   "PACKET_TYPE"                  => [  13,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Coretalk Packet Type" ],
);

%tio_01_00270_def =
( NAME    => "TIO_ICE_FRZ_CT_ERROR_DETAIL_1",
  ADDRESS => 0x00000000b0008060,
  NOTE    => "This register captures the contents of the Coretalk packet that note caused an error within the Freezer. Once this register capt",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00270_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_DBG_MUX_SELECT                                           #
#                                                                        #
##########################################################################

%tio_01_00271_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_PORT_SEL"             => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_PORT_SEL"             => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_PORT_SEL"             => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_PORT_SEL"             => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_PORT_SEL"             => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_PORT_SEL"             => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_PORT_SEL"             => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_PORT_SEL"             => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_00271_def =
( NAME    => "TIO_ICE_FRZ_DBG_MUX_SELECT",
  ADDRESS => 0x00000000b00080f8,
  NOTE    => "This register controls which signals from the RRC are routed to the note global debug mux.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00271_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_CFG                                                      #
#                                                                        #
##########################################################################

%tio_01_00272_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 1, 0x0000000000000000, "Scratch Bits" ],
   "RSVD0"                        => [   1,  18,  42, 0x0FFFFFFFFFFC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_DATA_CREDIT_LIMIT"        => [   2,  12,   6, 0x000000000003F000, 0x00, 1, 0x0000000000000000, "Coretalk Response Packet Data Buffer Credit Limit" ],
   "RSVD1"                        => [   3,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_CREDIT_LIMIT"             => [   4,   4,   6, 0x00000000000003F0, 0x00, 1, 0x0000000000000000, "Network Request Packet Credit Limit" ],
   "RSVD2"                        => [   5,   1,   3, 0x000000000000000E, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_BYPASS_DISABLE"           => [   6,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Disable Response Issue Queue Bypass" ],
);

%tio_01_00272_def =
( NAME    => "TIO_ICE_FRZ_CFG",
  ADDRESS => 0x00000000b0008100,
  NOTE    => "This register contains the configuration bits available within the note Freezer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00272_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_RIQ_STAT                                                 #
#                                                                        #
##########################################################################

%tio_01_00273_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  46,  18, 0xFFFFC00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_PRB_VAL2"                 => [   1,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "PIO PRB Valid 2" ],
   "IVACK_PRB"                    => [   2,  40,   5, 0x00001F0000000000, 0x00, 1, 0x0000000000000000, "IVACK PRB Number" ],
   "RSVD1"                        => [   3,  33,   7, 0x000000FE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_VAL"                      => [   4,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "GFX Response Valid" ],
   "RSVD2"                        => [   5,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_PRB_VAL1"                 => [   6,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PIO PRB Valid 1" ],
   "PIO_PRB"                      => [   7,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "PIO PRB Number" ],
   "RSVD3"                        => [   8,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_NACK_PRB_VAL"             => [   9,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "PIO NACK PRB Valid" ],
   "PIO_NACK_PRB"                 => [  10,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "PIO NACK PRB Number" ],
   "RSVD4"                        => [  11,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_LPRA_WR_ADDRESS"          => [  12,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "RIQ Write Address" ],
   "RSVD5"                        => [  13,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_LPRA_RD_ADDRESS"          => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "RIQ Read Address" ],
);

%tio_01_00273_def =
( NAME    => "TIO_ICE_FRZ_RIQ_STAT",
  ADDRESS => 0x00000000b0008128,
  NOTE    => "This register contains the last state of the Response Issue Queue note and is captured when soft reset is asserted.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00273_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_RIQ_LAST_STAT                                            #
#                                                                        #
##########################################################################

%tio_01_00274_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  46,  18, 0xFFFFC00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_PRB_VAL2"                 => [   1,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "PIO PRB Valid 2" ],
   "IVACK_PRB"                    => [   2,  40,   5, 0x00001F0000000000, 0x00, 0, 0x0000000000000000, "IVACK PRB Number" ],
   "RSVD1"                        => [   3,  33,   7, 0x000000FE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_VAL"                      => [   4,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "GFX Response Valid" ],
   "RSVD2"                        => [   5,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_PRB_VAL1"                 => [   6,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "PIO PRB Valid 1" ],
   "PIO_PRB"                      => [   7,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "PIO PRB Number" ],
   "RSVD3"                        => [   8,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_NACK_PRB_VAL"             => [   9,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "PIO NACK PRB Valid" ],
   "PIO_NACK_PRB"                 => [  10,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "PIO NACK PRB Number" ],
   "RSVD4"                        => [  11,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_LPRA_WR_ADDRESS"          => [  12,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "RIQ Write Address" ],
   "RSVD5"                        => [  13,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RIQ_LPRA_RD_ADDRESS"          => [  14,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "RIQ Read Address" ],
);

%tio_01_00274_def =
( NAME    => "TIO_ICE_FRZ_RIQ_LAST_STAT",
  ADDRESS => 0x00000000b0008108,
  NOTE    => "This register contains the last state of the Response Issue Queue note and is captured when soft reset is asserted.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00274_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_LAST_CREDIT_STAT                                         #
#                                                                        #
##########################################################################

%tio_01_00275_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_CREDITS"                  => [   1,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "Graphics packets credits" ],
   "RSVD1"                        => [   2,  38,   6, 0x00000FC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_UCREDITS"                => [   3,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "Data buffer micropacket credits" ],
   "RSVD2"                        => [   4,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_CREDITS"                  => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Request credits available within the Freezer for network request packets" ],
   "RSVD3"                        => [   6,   3,  13, 0x000000000000FFF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RESP_CREDITS"                 => [   7,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Response credits for responses to NPA" ],
);

%tio_01_00275_def =
( NAME    => "TIO_ICE_FRZ_LAST_CREDIT_STAT",
  ADDRESS => 0x00000000b0008110,
  NOTE    => "This register contains the last status of the credit counters when note a soft reset is encountered.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00275_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_TIMEOUT_DETAIL                                       #
#                                                                        #
##########################################################################

%tio_01_00276_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB31_TO"                     => [   1,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "PRB 31 Timeout Bit" ],
   "PRB30_TO"                     => [   2,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "PRB 30 Timeout Bit" ],
   "PRB29_TO"                     => [   3,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "PRB 29 Timeout Bit" ],
   "PRB28_TO"                     => [   4,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "PRB 28 Timeout Bit" ],
   "PRB27_TO"                     => [   5,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "PRB 27 Timeout Bit" ],
   "PRB26_TO"                     => [   6,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "PRB 26 Timeout Bit" ],
   "PRB25_TO"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "PRB 25 Timeout Bit" ],
   "PRB24_TO"                     => [   8,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "PRB 24 Timeout Bit" ],
   "PRB23_TO"                     => [   9,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "PRB 23 Timeout Bit" ],
   "PRB22_TO"                     => [  10,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "PRB 22 Timeout Bit" ],
   "PRB21_TO"                     => [  11,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "PRB 21 Timeout Bit" ],
   "PRB20_TO"                     => [  12,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "PRB 20 Timeout Bit" ],
   "PRB19_TO"                     => [  13,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "PRB 19 Timeout Bit" ],
   "PRB18_TO"                     => [  14,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "PRB 18 Timeout Bit" ],
   "PRB17_TO"                     => [  15,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "PRB 17 Timeout Bit" ],
   "PRB16_TO"                     => [  16,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "PRB 16 Timeout Bit" ],
   "PRB15_TO"                     => [  17,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "PRB 15 Timeout Bit" ],
   "PRB14_TO"                     => [  18,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "PRB 14 Timeout Bit" ],
   "PRB13_TO"                     => [  19,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "PRB 13 Timeout Bit" ],
   "PRB12_TO"                     => [  20,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PRB 12 Timeout Bit" ],
   "PRB11_TO"                     => [  21,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "PRB 11 Timeout Bit" ],
   "PRB10_TO"                     => [  22,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "PRB 10 Timeout Bit" ],
   "PRB9_TO"                      => [  23,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "PRB 9 Timeout Bit" ],
   "PRB8_TO"                      => [  24,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "PRB 8 Timeout Bit" ],
   "PRB7_TO"                      => [  25,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "PRB 7 Timeout Bit" ],
   "PRB6_TO"                      => [  26,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "PRB 6 Timeout Bit" ],
   "PRB5_TO"                      => [  27,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "PRB 5 Timeout Bit" ],
   "PRB4_TO"                      => [  28,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "PRB 4 Timeout Bit" ],
   "PRB3_TO"                      => [  29,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "PRB 3 Timeout Bit" ],
   "PRB2_TO"                      => [  30,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "PRB 2 Timeout Bit" ],
   "PRB1_TO"                      => [  31,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "PRB 1 Timeout Bit" ],
   "PRB0_TO"                      => [  32,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PRB 0 Timeout Bit" ],
);

%tio_01_00276_def =
( NAME    => "TIO_ICE_FRZ_PRB_TIMEOUT_DETAIL",
  ADDRESS => 0x00000000b0008118,
  NOTE    => "This register contains a bit for each of the PRBs. For each PRB note that has timed out, the proper bit is set.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00276_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_DYN_CREDIT_STAT                                          #
#                                                                        #
##########################################################################

%tio_01_00277_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_CREDITS"                  => [   1,  44,   4, 0x0000F00000000000, 0x00, 1, 0x0000000000000000, "Graphics packets credits" ],
   "RSVD1"                        => [   2,  38,   6, 0x00000FC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_UCREDITS"                => [   3,  32,   6, 0x0000003F00000000, 0x00, 1, 0x0000000000000000, "Data buffer micropacket credits" ],
   "RSVD2"                        => [   4,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_CREDITS"                  => [   5,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "Request credits available within the Freezer for network request packets" ],
   "RSVD3"                        => [   6,   3,  13, 0x000000000000FFF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RESP_CREDITS"                 => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Response credits for responses to NPA" ],
);

%tio_01_00277_def =
( NAME    => "TIO_ICE_FRZ_DYN_CREDIT_STAT",
  ADDRESS => 0x00000000b0008120,
  NOTE    => "This register contains the status of the credit counters within the note freezer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00277_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_0                                                    #
#                                                                        #
##########################################################################

%tio_01_00278_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00278_def =
( NAME    => "TIO_ICE_FRZ_PRB_0",
  ADDRESS => 0x00000000b0008200,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00278_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_1                                                    #
#                                                                        #
##########################################################################

%tio_01_00279_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00279_def =
( NAME    => "TIO_ICE_FRZ_PRB_1",
  ADDRESS => 0x00000000b0008210,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00279_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_2                                                    #
#                                                                        #
##########################################################################

%tio_01_00280_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00280_def =
( NAME    => "TIO_ICE_FRZ_PRB_2",
  ADDRESS => 0x00000000b0008220,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00280_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_3                                                    #
#                                                                        #
##########################################################################

%tio_01_00281_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00281_def =
( NAME    => "TIO_ICE_FRZ_PRB_3",
  ADDRESS => 0x00000000b0008230,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00281_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_4                                                    #
#                                                                        #
##########################################################################

%tio_01_00282_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00282_def =
( NAME    => "TIO_ICE_FRZ_PRB_4",
  ADDRESS => 0x00000000b0008240,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00282_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_5                                                    #
#                                                                        #
##########################################################################

%tio_01_00283_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00283_def =
( NAME    => "TIO_ICE_FRZ_PRB_5",
  ADDRESS => 0x00000000b0008250,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00283_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_6                                                    #
#                                                                        #
##########################################################################

%tio_01_00284_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00284_def =
( NAME    => "TIO_ICE_FRZ_PRB_6",
  ADDRESS => 0x00000000b0008260,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00284_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_7                                                    #
#                                                                        #
##########################################################################

%tio_01_00285_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00285_def =
( NAME    => "TIO_ICE_FRZ_PRB_7",
  ADDRESS => 0x00000000b0008270,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00285_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_8                                                    #
#                                                                        #
##########################################################################

%tio_01_00286_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00286_def =
( NAME    => "TIO_ICE_FRZ_PRB_8",
  ADDRESS => 0x00000000b0008280,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00286_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_9                                                    #
#                                                                        #
##########################################################################

%tio_01_00287_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00287_def =
( NAME    => "TIO_ICE_FRZ_PRB_9",
  ADDRESS => 0x00000000b0008290,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00287_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_10                                                   #
#                                                                        #
##########################################################################

%tio_01_00288_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00288_def =
( NAME    => "TIO_ICE_FRZ_PRB_10",
  ADDRESS => 0x00000000b00082a0,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00288_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_11                                                   #
#                                                                        #
##########################################################################

%tio_01_00289_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00289_def =
( NAME    => "TIO_ICE_FRZ_PRB_11",
  ADDRESS => 0x00000000b00082b0,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00289_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_12                                                   #
#                                                                        #
##########################################################################

%tio_01_00290_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00290_def =
( NAME    => "TIO_ICE_FRZ_PRB_12",
  ADDRESS => 0x00000000b00082c0,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00290_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_13                                                   #
#                                                                        #
##########################################################################

%tio_01_00291_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00291_def =
( NAME    => "TIO_ICE_FRZ_PRB_13",
  ADDRESS => 0x00000000b00082d0,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00291_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_14                                                   #
#                                                                        #
##########################################################################

%tio_01_00292_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00292_def =
( NAME    => "TIO_ICE_FRZ_PRB_14",
  ADDRESS => 0x00000000b00082e0,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00292_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_15                                                   #
#                                                                        #
##########################################################################

%tio_01_00293_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00293_def =
( NAME    => "TIO_ICE_FRZ_PRB_15",
  ADDRESS => 0x00000000b00082f0,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00293_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_16                                                   #
#                                                                        #
##########################################################################

%tio_01_00294_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00294_def =
( NAME    => "TIO_ICE_FRZ_PRB_16",
  ADDRESS => 0x00000000b0008300,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00294_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_17                                                   #
#                                                                        #
##########################################################################

%tio_01_00295_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00295_def =
( NAME    => "TIO_ICE_FRZ_PRB_17",
  ADDRESS => 0x00000000b0008310,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00295_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_18                                                   #
#                                                                        #
##########################################################################

%tio_01_00296_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00296_def =
( NAME    => "TIO_ICE_FRZ_PRB_18",
  ADDRESS => 0x00000000b0008320,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00296_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_19                                                   #
#                                                                        #
##########################################################################

%tio_01_00297_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00297_def =
( NAME    => "TIO_ICE_FRZ_PRB_19",
  ADDRESS => 0x00000000b0008330,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00297_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_20                                                   #
#                                                                        #
##########################################################################

%tio_01_00298_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00298_def =
( NAME    => "TIO_ICE_FRZ_PRB_20",
  ADDRESS => 0x00000000b0008340,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00298_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_21                                                   #
#                                                                        #
##########################################################################

%tio_01_00299_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00299_def =
( NAME    => "TIO_ICE_FRZ_PRB_21",
  ADDRESS => 0x00000000b0008350,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00299_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_22                                                   #
#                                                                        #
##########################################################################

%tio_01_00300_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00300_def =
( NAME    => "TIO_ICE_FRZ_PRB_22",
  ADDRESS => 0x00000000b0008360,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00300_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_23                                                   #
#                                                                        #
##########################################################################

%tio_01_00301_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00301_def =
( NAME    => "TIO_ICE_FRZ_PRB_23",
  ADDRESS => 0x00000000b0008370,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00301_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_24                                                   #
#                                                                        #
##########################################################################

%tio_01_00302_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00302_def =
( NAME    => "TIO_ICE_FRZ_PRB_24",
  ADDRESS => 0x00000000b0008380,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00302_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_25                                                   #
#                                                                        #
##########################################################################

%tio_01_00303_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00303_def =
( NAME    => "TIO_ICE_FRZ_PRB_25",
  ADDRESS => 0x00000000b0008390,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00303_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_26                                                   #
#                                                                        #
##########################################################################

%tio_01_00304_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00304_def =
( NAME    => "TIO_ICE_FRZ_PRB_26",
  ADDRESS => 0x00000000b00083a0,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00304_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_27                                                   #
#                                                                        #
##########################################################################

%tio_01_00305_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00305_def =
( NAME    => "TIO_ICE_FRZ_PRB_27",
  ADDRESS => 0x00000000b00083b0,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00305_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_28                                                   #
#                                                                        #
##########################################################################

%tio_01_00306_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00306_def =
( NAME    => "TIO_ICE_FRZ_PRB_28",
  ADDRESS => 0x00000000b00083c0,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00306_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_29                                                   #
#                                                                        #
##########################################################################

%tio_01_00307_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00307_def =
( NAME    => "TIO_ICE_FRZ_PRB_29",
  ADDRESS => 0x00000000b00083d0,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00307_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_30                                                   #
#                                                                        #
##########################################################################

%tio_01_00308_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00308_def =
( NAME    => "TIO_ICE_FRZ_PRB_30",
  ADDRESS => 0x00000000b00083e0,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00308_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PRB_31                                                   #
#                                                                        #
##########################################################################

%tio_01_00309_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PRB_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "PRB Valid" ],
   "PRB_DISABLE"                  => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "PRB Disable" ],
   "PRB_TO"                       => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "PRB Timeout" ],
   "PRB_TO_CNT"                   => [   3,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "PRB Timeout Counter" ],
   "RSVD0"                        => [   4,  37,  23, 0x0FFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_ERROR"                    => [   5,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "Error" ],
   "PRB_NACK_BELT"                => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Nack Belt" ],
   "PRB_SIZE"                     => [   7,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Size of the expected Response" ],
   "PRB_ECHO"                     => [   8,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "Network Request Echo" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PRB_TYPE"                     => [  10,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Network Request Type" ],
   "PRB_SID"                      => [  11,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Source ID" ],
);

%tio_01_00309_def =
( NAME    => "TIO_ICE_FRZ_PRB_31",
  ADDRESS => 0x00000000b00083f0,
  NOTE    => "These registers comprise the PRBs of the Freezer. The control note information for each PRB will be found here. The PRB can be n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00309_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PIO_BIG_WINDOW_1                                         #
#                                                                        #
##########################################################################

%tio_01_00310_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_EVAL_1"        => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "PIO Big Window 1 Entry Valid" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_INDEX_1"       => [   3,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "PIO Big Window 1 Corelet Index" ],
   "RSVD2"                        => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_OFFSET_1"      => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "PIO Big Window 1 Address Offset" ],
);

%tio_01_00310_def =
( NAME    => "TIO_ICE_FRZ_PIO_BIG_WINDOW_1",
  ADDRESS => 0x00000000b0008800,
  NOTE    => "This register holds the programmed value for Corelet index and note Corelet address offset along with data vaiid bit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00310_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PIO_BIG_WINDOW_2                                         #
#                                                                        #
##########################################################################

%tio_01_00311_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_EVAL_2"        => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "PIO Big Window 2 Entry Valid" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_INDEX_2"       => [   3,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "PIO Big Window 2 Corelet Index" ],
   "RSVD2"                        => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_OFFSET_2"      => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "PIO Big Window 2 Address Offset" ],
);

%tio_01_00311_def =
( NAME    => "TIO_ICE_FRZ_PIO_BIG_WINDOW_2",
  ADDRESS => 0x00000000b0008808,
  NOTE    => "This register holds the programmed value for Corelet index and note Corelet address offset along with data vaiid bit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00311_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PIO_BIG_WINDOW_3                                         #
#                                                                        #
##########################################################################

%tio_01_00312_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_EVAL_3"        => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "PIO Big Window 3 Entry Valid" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_INDEX_3"       => [   3,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "PIO Big Window 3 Corelet Index" ],
   "RSVD2"                        => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_OFFSET_3"      => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "PIO Big Window 3 Address Offset" ],
);

%tio_01_00312_def =
( NAME    => "TIO_ICE_FRZ_PIO_BIG_WINDOW_3",
  ADDRESS => 0x00000000b0008810,
  NOTE    => "This register holds the programmed value for Corelet index and note Corelet address offset along with data vaiid bit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00312_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PIO_BIG_WINDOW_4                                         #
#                                                                        #
##########################################################################

%tio_01_00313_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_EVAL_4"        => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "PIO Big Window 4 Entry Valid" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_INDEX_4"       => [   3,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "PIO Big Window 4 Corelet Index" ],
   "RSVD2"                        => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_OFFSET_4"      => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "PIO Big Window 4 Address Offset" ],
);

%tio_01_00313_def =
( NAME    => "TIO_ICE_FRZ_PIO_BIG_WINDOW_4",
  ADDRESS => 0x00000000b0008818,
  NOTE    => "This register holds the programmed value for Corelet index and note Corelet address offset along with data vaiid bit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00313_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PIO_BIG_WINDOW_5                                         #
#                                                                        #
##########################################################################

%tio_01_00314_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_EVAL_5"        => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "PIO Big Window 5 Entry Valid" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_INDEX_5"       => [   3,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "PIO Big Window 5 Corelet Index" ],
   "RSVD2"                        => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_OFFSET_5"      => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "PIO Big Window 5 Address Offset" ],
);

%tio_01_00314_def =
( NAME    => "TIO_ICE_FRZ_PIO_BIG_WINDOW_5",
  ADDRESS => 0x00000000b0008820,
  NOTE    => "This register holds the programmed value for Corelet index and note Corelet address offset along with data vaiid bit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00314_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PIO_BIG_WINDOW_6                                         #
#                                                                        #
##########################################################################

%tio_01_00315_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_EVAL_6"        => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "PIO Big Window 6 Entry Valid" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_INDEX_6"       => [   3,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "PIO Big Window 6 Corelet Index" ],
   "RSVD2"                        => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_OFFSET_6"      => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "PIO Big Window 6 Address Offset" ],
);

%tio_01_00315_def =
( NAME    => "TIO_ICE_FRZ_PIO_BIG_WINDOW_6",
  ADDRESS => 0x00000000b0008828,
  NOTE    => "This register holds the programmed value for Corelet index and note Corelet address offset along with data vaiid bit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00315_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PIO_BIG_WINDOW_7                                         #
#                                                                        #
##########################################################################

%tio_01_00316_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_EVAL_7"        => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "PIO Big Window 7 Entry Valid" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_INDEX_7"       => [   3,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "PIO Big Window 7 Corelet Index" ],
   "RSVD2"                        => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_BIG_WINDOW_OFFSET_7"      => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "PIO Big Window 7 Address Offset" ],
);

%tio_01_00316_def =
( NAME    => "TIO_ICE_FRZ_PIO_BIG_WINDOW_7",
  ADDRESS => 0x00000000b0008830,
  NOTE    => "This register holds the programmed value for Corelet index and note Corelet address offset along with data vaiid bit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00316_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_PIO_HUGE_WINDOW                                          #
#                                                                        #
##########################################################################

%tio_01_00317_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_HUGE_WINDOW_EVAL"         => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "PIO Huge Window Entry Valid" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_HUGE_WINDOW_INDEX"        => [   3,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "PIO Huge Window Corelet Index" ],
);

%tio_01_00317_def =
( NAME    => "TIO_ICE_FRZ_PIO_HUGE_WINDOW",
  ADDRESS => 0x00000000b0008838,
  NOTE    => "This register holds the programmed value for Corelet index and note Corelet address offset.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00317_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GFX_BIG_WINDOW_0                                         #
#                                                                        #
##########################################################################

%tio_01_00318_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_EVAL_0"        => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "GFX Big Window 0 Entry Valid" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_INDEX_0"       => [   3,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "GFX Big Window 0 Corelet Index" ],
   "RSVD2"                        => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_OFFSET_0"      => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "GFX Big Window 0 Address Offset" ],
);

%tio_01_00318_def =
( NAME    => "TIO_ICE_FRZ_GFX_BIG_WINDOW_0",
  ADDRESS => 0x00000000b0008840,
  NOTE    => "This register holds the programmed value for GFX address offset and note Corelet address offset along with data vaiid bit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00318_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GFX_BIG_WINDOW_1                                         #
#                                                                        #
##########################################################################

%tio_01_00319_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_EVAL_1"        => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "GFX Big Window 1 Entry Valid" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_INDEX_1"       => [   3,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "GFX Big Window 1 Corelet Index" ],
   "RSVD2"                        => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_OFFSET_1"      => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "GFX Big Window 1 Address Offset" ],
);

%tio_01_00319_def =
( NAME    => "TIO_ICE_FRZ_GFX_BIG_WINDOW_1",
  ADDRESS => 0x00000000b0008848,
  NOTE    => "This register holds the programmed value for GFX address offset and note Corelet address offset along with data vaiid bit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00319_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GFX_BIG_WINDOW_2                                         #
#                                                                        #
##########################################################################

%tio_01_00320_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_EVAL_2"        => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "GFX Big Window 2 Entry Valid" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_INDEX_2"       => [   3,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "GFX Big Window 2 Corelet Index" ],
   "RSVD2"                        => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_OFFSET_2"      => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "GFX Big Window 2 Address Offset" ],
);

%tio_01_00320_def =
( NAME    => "TIO_ICE_FRZ_GFX_BIG_WINDOW_2",
  ADDRESS => 0x00000000b0008850,
  NOTE    => "This register holds the programmed value for GFX address offset and note Corelet address offset along with data vaiid bit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00320_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GFX_BIG_WINDOW_3                                         #
#                                                                        #
##########################################################################

%tio_01_00321_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_EVAL_3"        => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "GFX Big Window 3 Entry Valid" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_INDEX_3"       => [   3,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "GFX Big Window 3 Corelet Index" ],
   "RSVD2"                        => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_OFFSET_3"      => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "GFX Big Window 3 Address Offset" ],
);

%tio_01_00321_def =
( NAME    => "TIO_ICE_FRZ_GFX_BIG_WINDOW_3",
  ADDRESS => 0x00000000b0008858,
  NOTE    => "This register holds the programmed value for GFX address offset and note Corelet address offset along with data vaiid bit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00321_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GFX_BIG_WINDOW_4                                         #
#                                                                        #
##########################################################################

%tio_01_00322_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_EVAL_4"        => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "GFX Big Window 4 Entry Valid" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_INDEX_4"       => [   3,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "GFX Big Window 4 Corelet Index" ],
   "RSVD2"                        => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_OFFSET_4"      => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "GFX Big Window 4 Address Offset" ],
);

%tio_01_00322_def =
( NAME    => "TIO_ICE_FRZ_GFX_BIG_WINDOW_4",
  ADDRESS => 0x00000000b0008860,
  NOTE    => "This register holds the programmed value for GFX address offset and note Corelet address offset along with data vaiid bit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00322_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GFX_BIG_WINDOW_5                                         #
#                                                                        #
##########################################################################

%tio_01_00323_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_EVAL_5"        => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "GFX Big Window 5 Entry Valid" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_INDEX_5"       => [   3,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "GFX Big Window 5 Corelet Index" ],
   "RSVD2"                        => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_OFFSET_5"      => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "GFX Big Window 5 Address Offset" ],
);

%tio_01_00323_def =
( NAME    => "TIO_ICE_FRZ_GFX_BIG_WINDOW_5",
  ADDRESS => 0x00000000b0008868,
  NOTE    => "This register holds the programmed value for GFX address offset and note Corelet address offset along with data vaiid bit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00323_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GFX_BIG_WINDOW_6                                         #
#                                                                        #
##########################################################################

%tio_01_00324_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_EVAL_6"        => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "GFX Big Window 6 Entry Valid" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_INDEX_6"       => [   3,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "GFX Big Window 6 Corelet Index" ],
   "RSVD2"                        => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_OFFSET_6"      => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "GFX Big Window 6 Address Offset" ],
);

%tio_01_00324_def =
( NAME    => "TIO_ICE_FRZ_GFX_BIG_WINDOW_6",
  ADDRESS => 0x00000000b0008870,
  NOTE    => "This register holds the programmed value for GFX address offset and note Corelet address offset along with data vaiid bit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00324_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GFX_BIG_WINDOW_7                                         #
#                                                                        #
##########################################################################

%tio_01_00325_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_EVAL_7"        => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "GFX Big Window 7 Entry Valid" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_INDEX_7"       => [   3,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "GFX Big Window 7 Corelet Index" ],
   "RSVD2"                        => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_BIG_WINDOW_OFFSET_7"      => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "GFX Big Window 7 Address Offset" ],
);

%tio_01_00325_def =
( NAME    => "TIO_ICE_FRZ_GFX_BIG_WINDOW_7",
  ADDRESS => 0x00000000b0008878,
  NOTE    => "This register holds the programmed value for GFX address offset and note Corelet address offset along with data vaiid bit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00325_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_CPU_PERM0                                                #
#                                                                        #
##########################################################################

%tio_01_00326_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "CPU Permission Access Bits 63-0" ],
);

%tio_01_00326_def =
( NAME    => "TIO_ICE_FRZ_CPU_PERM0",
  ADDRESS => 0x00000000b0008880,
  NOTE    => "This register holds the programmed values for CPU permission note bits[63:0].",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00326_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_CPU_PERM1                                                #
#                                                                        #
##########################################################################

%tio_01_00327_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "CPU Permission Access Bits 127-64" ],
);

%tio_01_00327_def =
( NAME    => "TIO_ICE_FRZ_CPU_PERM1",
  ADDRESS => 0x00000000b0008888,
  NOTE    => "This register holds the programmed values for CPU permission note bits[127:64].",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00327_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_CPU_PERM2                                                #
#                                                                        #
##########################################################################

%tio_01_00328_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "CPU Permission Access Bits 191-128" ],
);

%tio_01_00328_def =
( NAME    => "TIO_ICE_FRZ_CPU_PERM2",
  ADDRESS => 0x00000000b0008890,
  NOTE    => "This register holds the programmed values for CPU permission note bits[191:128].",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00328_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_CPU_PERM3                                                #
#                                                                        #
##########################################################################

%tio_01_00329_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "CPU Permission Access Bits 255-192" ],
);

%tio_01_00329_def =
( NAME    => "TIO_ICE_FRZ_CPU_PERM3",
  ADDRESS => 0x00000000b0008898,
  NOTE    => "This register holds the programmed values for CPU permission note bits[255:192].",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00329_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_EXT_IO_PERM0                                             #
#                                                                        #
##########################################################################

%tio_01_00330_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "External IO Permission Access Bits 63-0" ],
);

%tio_01_00330_def =
( NAME    => "TIO_ICE_FRZ_EXT_IO_PERM0",
  ADDRESS => 0x00000000b00088a0,
  NOTE    => "This register holds the programmed values for External IO note permission bits[63:0].",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00330_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_EXT_IO_PERM1                                             #
#                                                                        #
##########################################################################

%tio_01_00331_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "External IO Permission Access Bits 127-64" ],
);

%tio_01_00331_def =
( NAME    => "TIO_ICE_FRZ_EXT_IO_PERM1",
  ADDRESS => 0x00000000b00088a8,
  NOTE    => "This register holds the programmed values for External IO note permission bits[127:64].",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00331_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_EXT_IO_PERM2                                             #
#                                                                        #
##########################################################################

%tio_01_00332_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "External IO Permission Access Bits 191-128" ],
);

%tio_01_00332_def =
( NAME    => "TIO_ICE_FRZ_EXT_IO_PERM2",
  ADDRESS => 0x00000000b00088b0,
  NOTE    => "This register holds the programmed values for External IO note permission bits[191:128].",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00332_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_EXT_IO_PERM3                                             #
#                                                                        #
##########################################################################

%tio_01_00333_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "External IO Permission Access Bits 255-192" ],
);

%tio_01_00333_def =
( NAME    => "TIO_ICE_FRZ_EXT_IO_PERM3",
  ADDRESS => 0x00000000b00088b8,
  NOTE    => "This register holds the programmed values for External IO note permission bits[255:192].",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00333_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_CHIPLET_ID_CONFIG                                        #
#                                                                        #
##########################################################################

%tio_01_00334_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXT_IO_ID"                    => [   1,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Valid chiplet IDs from external IO nodes" ],
   "RSVD1"                        => [   2,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CPU_ID"                       => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Valid chiplet IDs from processor nodes" ],
);

%tio_01_00334_def =
( NAME    => "TIO_ICE_FRZ_CHIPLET_ID_CONFIG",
  ADDRESS => 0x00000000b00088c0,
  NOTE    => "This register holds the programmable value for CPU and External IO note node Chiplet ID enables. Each bit corresponds to a chipl",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00334_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GRC_SIR_0                                                #
#                                                                        #
##########################################################################

%tio_01_00335_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  26,  38, 0xFFFFFFFFFC000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALID"                        => [   1,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Valid" ],
   "ECHO"                         => [   2,  16,   9, 0x0000000001FF0000, 0x00, 1, 0x0000000000000000, "Network Request Echo" ],
   "SOURCE_ID"                    => [   3,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Network Request Source ID" ],
);

%tio_01_00335_def =
( NAME    => "TIO_ICE_FRZ_GRC_SIR_0",
  ADDRESS => 0x00000000b0009000,
  NOTE    => "This register contains the Source ID and Echo information from the note network request destined for the proper coretalk window.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00335_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GRC_SIR_1                                                #
#                                                                        #
##########################################################################

%tio_01_00336_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  26,  38, 0xFFFFFFFFFC000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALID"                        => [   1,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Valid" ],
   "ECHO"                         => [   2,  16,   9, 0x0000000001FF0000, 0x00, 1, 0x0000000000000000, "Network Request Echo" ],
   "SOURCE_ID"                    => [   3,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Network Request Source ID" ],
);

%tio_01_00336_def =
( NAME    => "TIO_ICE_FRZ_GRC_SIR_1",
  ADDRESS => 0x00000000b0009008,
  NOTE    => "This register contains the Source ID and Echo information from the note network request destined for the proper coretalk window.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00336_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GRC_SIR_2                                                #
#                                                                        #
##########################################################################

%tio_01_00337_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  26,  38, 0xFFFFFFFFFC000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALID"                        => [   1,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Valid" ],
   "ECHO"                         => [   2,  16,   9, 0x0000000001FF0000, 0x00, 1, 0x0000000000000000, "Network Request Echo" ],
   "SOURCE_ID"                    => [   3,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Network Request Source ID" ],
);

%tio_01_00337_def =
( NAME    => "TIO_ICE_FRZ_GRC_SIR_2",
  ADDRESS => 0x00000000b0009010,
  NOTE    => "This register contains the Source ID and Echo information from the note network request destined for the proper coretalk window.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00337_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GRC_SIR_3                                                #
#                                                                        #
##########################################################################

%tio_01_00338_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  26,  38, 0xFFFFFFFFFC000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALID"                        => [   1,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Valid" ],
   "ECHO"                         => [   2,  16,   9, 0x0000000001FF0000, 0x00, 1, 0x0000000000000000, "Network Request Echo" ],
   "SOURCE_ID"                    => [   3,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Network Request Source ID" ],
);

%tio_01_00338_def =
( NAME    => "TIO_ICE_FRZ_GRC_SIR_3",
  ADDRESS => 0x00000000b0009018,
  NOTE    => "This register contains the Source ID and Echo information from the note network request destined for the proper coretalk window.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00338_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GRC_GFX_RSP_0                                            #
#                                                                        #
##########################################################################

%tio_01_00339_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_ERROR"                    => [   1,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Response Error" ],
   "CREDITS"                      => [   2,   2,   8, 0x00000000000003FC, 0x00, 0, 0x0000000000000000, "Credits" ],
   "WID"                          => [   3,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Widget ID" ],
);

%tio_01_00339_def =
( NAME    => "TIO_ICE_FRZ_GRC_GFX_RSP_0",
  ADDRESS => 0x00000000b0009020,
  NOTE    => "This register will store the necessary information to generate the note proper response to the network.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00339_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GRC_GFX_RSP_1                                            #
#                                                                        #
##########################################################################

%tio_01_00340_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_ERROR"                    => [   1,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Response Error" ],
   "CREDITS"                      => [   2,   2,   8, 0x00000000000003FC, 0x00, 0, 0x0000000000000000, "Credits" ],
   "WID"                          => [   3,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Widget ID" ],
);

%tio_01_00340_def =
( NAME    => "TIO_ICE_FRZ_GRC_GFX_RSP_1",
  ADDRESS => 0x00000000b0009028,
  NOTE    => "This register will store the necessary information to generate the note proper response to the network.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00340_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GRC_GFX_RSP_2                                            #
#                                                                        #
##########################################################################

%tio_01_00341_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_ERROR"                    => [   1,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Response Error" ],
   "CREDITS"                      => [   2,   2,   8, 0x00000000000003FC, 0x00, 0, 0x0000000000000000, "Credits" ],
   "WID"                          => [   3,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Widget ID" ],
);

%tio_01_00341_def =
( NAME    => "TIO_ICE_FRZ_GRC_GFX_RSP_2",
  ADDRESS => 0x00000000b0009030,
  NOTE    => "This register will store the necessary information to generate the note proper response to the network.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00341_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GRC_GFX_RSP_3                                            #
#                                                                        #
##########################################################################

%tio_01_00342_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_ERROR"                    => [   1,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Response Error" ],
   "CREDITS"                      => [   2,   2,   8, 0x00000000000003FC, 0x00, 0, 0x0000000000000000, "Credits" ],
   "WID"                          => [   3,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Widget ID" ],
);

%tio_01_00342_def =
( NAME    => "TIO_ICE_FRZ_GRC_GFX_RSP_3",
  ADDRESS => 0x00000000b0009038,
  NOTE    => "This register will store the necessary information to generate the note proper response to the network.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00342_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GRC_GFX_RSP_4                                            #
#                                                                        #
##########################################################################

%tio_01_00343_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_ERROR"                    => [   1,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Response Error" ],
   "CREDITS"                      => [   2,   2,   8, 0x00000000000003FC, 0x00, 0, 0x0000000000000000, "Credits" ],
   "WID"                          => [   3,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Widget ID" ],
);

%tio_01_00343_def =
( NAME    => "TIO_ICE_FRZ_GRC_GFX_RSP_4",
  ADDRESS => 0x00000000b0009040,
  NOTE    => "This register will store the necessary information to generate the note proper response to the network.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00343_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GRC_GFX_RSP_5                                            #
#                                                                        #
##########################################################################

%tio_01_00344_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_ERROR"                    => [   1,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Response Error" ],
   "CREDITS"                      => [   2,   2,   8, 0x00000000000003FC, 0x00, 0, 0x0000000000000000, "Credits" ],
   "WID"                          => [   3,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Widget ID" ],
);

%tio_01_00344_def =
( NAME    => "TIO_ICE_FRZ_GRC_GFX_RSP_5",
  ADDRESS => 0x00000000b0009048,
  NOTE    => "This register will store the necessary information to generate the note proper response to the network.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00344_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GRC_GFX_RSP_6                                            #
#                                                                        #
##########################################################################

%tio_01_00345_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_ERROR"                    => [   1,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Response Error" ],
   "CREDITS"                      => [   2,   2,   8, 0x00000000000003FC, 0x00, 0, 0x0000000000000000, "Credits" ],
   "WID"                          => [   3,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Widget ID" ],
);

%tio_01_00345_def =
( NAME    => "TIO_ICE_FRZ_GRC_GFX_RSP_6",
  ADDRESS => 0x00000000b0009050,
  NOTE    => "This register will store the necessary information to generate the note proper response to the network.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00345_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GRC_GFX_RSP_7                                            #
#                                                                        #
##########################################################################

%tio_01_00346_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_ERROR"                    => [   1,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Response Error" ],
   "CREDITS"                      => [   2,   2,   8, 0x00000000000003FC, 0x00, 0, 0x0000000000000000, "Credits" ],
   "WID"                          => [   3,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Widget ID" ],
);

%tio_01_00346_def =
( NAME    => "TIO_ICE_FRZ_GRC_GFX_RSP_7",
  ADDRESS => 0x00000000b0009058,
  NOTE    => "This register will store the necessary information to generate the note proper response to the network.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00346_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_FRZ_GRC_CREDIT                                               #
#                                                                        #
##########################################################################

%tio_01_00347_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIMIT_CNTR"                   => [   1,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Credit Limit Counter" ],
   "PMI_CREDIT_CNTR"              => [   2,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "PMI Credits Available Counter" ],
   "PMI_IN_USE_CNTR"              => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "PMI Credits in Use Counter" ],
);

%tio_01_00347_def =
( NAME    => "TIO_ICE_FRZ_GRC_CREDIT",
  ADDRESS => 0x00000000b0009060,
  NOTE    => "This register contains information on the current state of the note credit counters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00347_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_RX_ERROR_SUMMARY                                         #
#                                                                        #
##########################################################################

%tio_01_00348_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_HDR_ERR"                  => [   1,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Response header error" ],
   "REQ_HDR_ERR"                  => [   2,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Request header error" ],
   "RSP_INVAL_TYPE"               => [   3,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Response invalid packet type" ],
   "REQ_INVAL_TYPE"               => [   4,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Request invalid packet type" ],
);

%tio_01_00348_def =
( NAME    => "TIO_ICE_PMI_RX_ERROR_SUMMARY",
  ADDRESS => 0x00000000b000a000,
  NOTE    => "This register holds error status of the PMI_rx.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00348_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_RX_ERROR_SUMMARY_ALIAS                                     #
#                                                                        #
##########################################################################

%tio_01_00349_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_HDR_ERR"                  => [   1,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Response header error" ],
   "REQ_HDR_ERR"                  => [   2,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Request header error" ],
   "RSP_INVAL_TYPE"               => [   3,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Response invalid packet type" ],
   "REQ_INVAL_TYPE"               => [   4,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Request invalid packet type" ],
);

%tio_01_00349_def =
( NAME    => "TIO_ICE_PMI_RX_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x00000000b000a008,
  NOTE    => "This is an alias to clear select bits of the Error Summary field of note the PMI_rx.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00349_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_RX_FIRST_ERROR                                           #
#                                                                        #
##########################################################################

%tio_01_00350_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_INVAL_TYPE"               => [   1,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Response invalid packet type" ],
   "RSP_HDR_ERR"                  => [   2,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Response header error" ],
   "REQ_INVAL_TYPE"               => [   3,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Request invalid packet type" ],
   "REQ_HDR_ERR"                  => [   4,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Request header error" ],
);

%tio_01_00350_def =
( NAME    => "TIO_ICE_PMI_RX_FIRST_ERROR",
  ADDRESS => 0x00000000b000a020,
  NOTE    => "This register holds first error status for PMI_rx errors.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00350_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_RX_CT_ERROR_DETAIL_1                                     #
#                                                                        #
##########################################################################

%tio_01_00351_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ERR_VALID"                    => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Error Valid" ],
   "RSVD0"                        => [   1,  49,  14, 0x7FFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HDR_ERR"                      => [   2,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "Header Error" ],
   "RSVD1"                        => [   3,  36,  12, 0x0000FFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CW_ERR"                       => [   4,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Command Word Error" ],
   "PIO_OP"                       => [   5,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PIO/Not Memory Operation" ],
   "MEM_RD_PARAM"                 => [   6,  32,   2, 0x0000000300000000, 0x00, 0, 0x0000000000000000, "Memory Read Parameters" ],
   "GFX_CRED"                     => [   7,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Graphics Credits" ],
   "DW_DATA_EN"                   => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Double Word Data Enables" ],
   "TNUM"                         => [   9,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Transaction Number" ],
   "DATA_SZ"                      => [  10,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Data Size" ],
   "SRC_ID"                       => [  11,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "Source Identification" ],
   "PKT_TYPE"                     => [  12,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Packet Type" ],
);

%tio_01_00351_def =
( NAME    => "TIO_ICE_PMI_RX_CT_ERROR_DETAIL_1",
  ADDRESS => 0x00000000b000a060,
  NOTE    => "Log of the command word of a Coretalk packet header that caused an note error.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00351_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_RX_CT_ERROR_DETAIL_2                                     #
#                                                                        #
##########################################################################

%tio_01_00352_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PKT_ADDR"                     => [   1,   3,  53, 0x00FFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Packet Address" ],
);

%tio_01_00352_def =
( NAME    => "TIO_ICE_PMI_RX_CT_ERROR_DETAIL_2",
  ADDRESS => 0x00000000b000a068,
  NOTE    => "This register contains the address of an errant packet. Note: Since note Coretalk address bits [2:0] are assumed to always be ze",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00352_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_RX_CT_DATA0_CMP                                          #
#                                                                        #
##########################################################################

%tio_01_00353_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CT_DATA0_CMP"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CT Data0 Compare" ],
);

%tio_01_00353_def =
( NAME    => "TIO_ICE_PMI_RX_CT_DATA0_CMP",
  ADDRESS => 0x00000000b000a0c0,
  NOTE    => "This register is used in conjunction with the PMI_RX CT DATA0 note ENABLE register to generate a pulse to the debug port when da",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00353_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_RX_CT_DATA1_CMP                                          #
#                                                                        #
##########################################################################

%tio_01_00354_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CT_DATA1_CMP"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CT Data1 Compare" ],
);

%tio_01_00354_def =
( NAME    => "TIO_ICE_PMI_RX_CT_DATA1_CMP",
  ADDRESS => 0x00000000b000a0c8,
  NOTE    => "This register is used in conjunction with the PMI_RX CT DATA1 note ENABLE register to generate a pulse to the debug port when da",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00354_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_RX_CT_DATA0_EN                                           #
#                                                                        #
##########################################################################

%tio_01_00355_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CT_DATA0_EN"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CT Data0 Enable" ],
);

%tio_01_00355_def =
( NAME    => "TIO_ICE_PMI_RX_CT_DATA0_EN",
  ADDRESS => 0x00000000b000a0d0,
  NOTE    => "This register is used in conjunction with the PMI_RX CT DATA0 note COMPARE register to generate a pulse to the debug port when d",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00355_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_RX_CT_DATA1_EN                                           #
#                                                                        #
##########################################################################

%tio_01_00356_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CT_DATA1_EN"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "CT Data1 Enable" ],
);

%tio_01_00356_def =
( NAME    => "TIO_ICE_PMI_RX_CT_DATA1_EN",
  ADDRESS => 0x00000000b000a0d8,
  NOTE    => "This register is used in conjunction with the PMI_RX CT DATA1 note COMPARE register to generate a pulse to the debug port when d",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00356_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_RX_DBG_MUX_SELECT                                        #
#                                                                        #
##########################################################################

%tio_01_00357_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB_SEL_7"              => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 7 select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA7_SEL"              => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Debug data group 7 select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB_SEL_6"              => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 6 select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA6_SEL"              => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Debug data group 6 select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB_SEL_5"              => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 5 select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA5_SEL"              => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Debug data group 5 select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB_SEL_4"              => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 4 select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA4_SEL"              => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Debug data group 4 select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB_SEL_3"              => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Debug nibble group 3 select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA3_SEL"              => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Debug data group 3 select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB_SEL_2"              => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Debug nibble group 2 select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA2_SEL"              => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Debug data group 2 select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB_SEL_1"              => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Debug nibble group 1 select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA1_SEL"              => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Debug data group 1 select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIB_SEL_0"              => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Debug nibble group 0 select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DATA0_SEL"              => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Debug data group 0 select" ],
);

%tio_01_00357_def =
( NAME    => "TIO_ICE_PMI_RX_DBG_MUX_SELECT",
  ADDRESS => 0x00000000b000a0f8,
  NOTE    => "This register holds the settings for the DEBUG port data and nibble note selects.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00357_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_RX_REQ_BUF_CFG                                           #
#                                                                        #
##########################################################################

%tio_01_00358_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 1, 0x0000000000000000, "Scratch Bits" ],
   "RSVD0"                        => [   1,   8,  52, 0x0FFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_CREDIT_LIM"               => [   2,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Request Buffer Credit Limit" ],
   "RSVD1"                        => [   3,   1,   3, 0x000000000000000E, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_BYPASS_DISABLE"           => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Request Bypass Disable" ],
);

%tio_01_00358_def =
( NAME    => "TIO_ICE_PMI_RX_REQ_BUF_CFG",
  ADDRESS => 0x00000000b000a100,
  NOTE    => "This register contains a field to disable the request buffer bypass note and a field to limit the request buffer credit counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00358_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_RX_REQ_DYN_CREDIT_STAT                                     #
#                                                                        #
##########################################################################

%tio_01_00359_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRC_CREDITS"                  => [   1,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "WRC pkt credit count" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRC_CREDITS"                  => [   3,  16,   7, 0x00000000007F0000, 0x00, 1, 0x0000000000000000, "RRC pkt credit count" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_RD_ADDR"                  => [   5,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Request buffer read address" ],
   "RSVD3"                        => [   6,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_WR_ADDR"                  => [   7,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Request buffer write address" ],
   "REQ_BUF_SPACE"                => [   8,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Available Request Buffer Space" ],
   "REQ_CREDITS"                  => [   9,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Request buffer credit count" ],
);

%tio_01_00359_def =
( NAME    => "TIO_ICE_PMI_RX_REQ_DYN_CREDIT_STAT",
  ADDRESS => 0x00000000b000a108,
  NOTE    => "This register stores current data pertaining to request credit note status.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00359_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_RX_REQ_LAST_CREDIT_STAT                                     #
#                                                                        #
##########################################################################

%tio_01_00360_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRC_CREDITS"                  => [   1,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "WRC pkt credit count" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRC_CREDITS"                  => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "RRC pkt credit count" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_RD_ADDR"                  => [   5,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Request buffer read address" ],
   "RSVD3"                        => [   6,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_WR_ADDR"                  => [   7,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Request buffer write address" ],
   "REQ_BUF_SPACE"                => [   8,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Available Request Buffer Space" ],
   "REQ_CREDITS"                  => [   9,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Request buffer credit count" ],
);

%tio_01_00360_def =
( NAME    => "TIO_ICE_PMI_RX_REQ_LAST_CREDIT_STAT",
  ADDRESS => 0x00000000b000a110,
  NOTE    => "This register stores data pertaining to request credit status upon note soft reset.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00360_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_RX_RSP_BUF_CFG                                           #
#                                                                        #
##########################################################################

%tio_01_00361_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_CREDIT_LIM"               => [   1,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Response Buffer Credit Limit" ],
   "RSVD1"                        => [   2,   1,   3, 0x000000000000000E, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_BYPASS_DISABLE"           => [   3,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Response Bypass Disable" ],
);

%tio_01_00361_def =
( NAME    => "TIO_ICE_PMI_RX_RSP_BUF_CFG",
  ADDRESS => 0x00000000b000a118,
  NOTE    => "This register contains a field to disable the response buffer note bypass and a field to limit the response buffer credit counte",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00361_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_RX_RSP_DYN_CREDIT_STAT                                     #
#                                                                        #
##########################################################################

%tio_01_00362_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_CREDITS"                  => [   1,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "GFX packet credit count" ],
   "RSVD1"                        => [   2,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_CREDITS"                  => [   3,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "PIO upacket credit count" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_RD_ADDR"                  => [   5,  12,   3, 0x0000000000007000, 0x00, 1, 0x0000000000000000, "Response buffer read address" ],
   "RSVD3"                        => [   6,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_WR_ADDR"                  => [   7,   8,   3, 0x0000000000000700, 0x00, 1, 0x0000000000000000, "Response buffer write address" ],
   "RSP_BUF_SPACE"                => [   8,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Available Response Buffer Space" ],
   "RSP_CREDITS"                  => [   9,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Response buffer credit count" ],
);

%tio_01_00362_def =
( NAME    => "TIO_ICE_PMI_RX_RSP_DYN_CREDIT_STAT",
  ADDRESS => 0x00000000b000a120,
  NOTE    => "This register stores current data pertaining to response credit note status.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00362_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_RX_RSP_LAST_CREDIT_STAT                                     #
#                                                                        #
##########################################################################

%tio_01_00363_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_CREDITS"                  => [   1,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "GFX packet credit count" ],
   "RSVD1"                        => [   2,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_CREDITS"                  => [   3,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "PIO upacket credit count" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_RD_ADDR"                  => [   5,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Response buffer read address" ],
   "RSVD3"                        => [   6,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_WR_ADDR"                  => [   7,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Response buffer write address" ],
   "RSP_BUF_SPACE"                => [   8,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Available Response Buffer Space" ],
   "RSP_CREDITS"                  => [   9,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Response buffer credit count" ],
);

%tio_01_00363_def =
( NAME    => "TIO_ICE_PMI_RX_RSP_LAST_CREDIT_STAT",
  ADDRESS => 0x00000000b000a128,
  NOTE    => "This register stores data pertaining to response credit status upon note soft reset.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00363_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_ERROR_SUMMARY                                         #
#                                                                        #
##########################################################################

%tio_01_00364_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CB3_B_TO"                     => [   1,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Corelet 3 Belt B Timeout" ],
   "CB3_A_TO"                     => [   2,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Corelet 3 Belt A Timeout" ],
   "CB2_B_TO"                     => [   3,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Corelet 2 Belt B Timeout" ],
   "CB2_A_TO"                     => [   4,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Corelet 2 Belt A Timeout" ],
   "CB1_B_TO"                     => [   5,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Corelet 1 Belt B Timeout" ],
   "CB1_A_TO"                     => [   6,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Corelet 1 Belt A Timeout" ],
   "CB0_B_TO"                     => [   7,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Corelet 0 Belt B Timeout" ],
   "CB0_A_TO"                     => [   8,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Corelet 0 Belt A Timeout" ],
   "CB3_CO"                       => [   9,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Corelet 3 Credit Overflow" ],
   "CB3_NBO"                      => [  10,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Corelet 3 Nack B Overflow" ],
   "CB3_NAO"                      => [  11,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Corelet 3 Nack A Overflow" ],
   "CB2_CO"                       => [  12,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Corelet 2 Credit Overflow" ],
   "CB2_NBO"                      => [  13,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Corelet 2 Nack B Overflow" ],
   "CB2_NAO"                      => [  14,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Corelet 2 Nack A Overflow" ],
   "CB1_CO"                       => [  15,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Corelet 1 Credit Overflow" ],
   "CB1_NBO"                      => [  16,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Corelet 1 Nack B Overflow" ],
   "CB1_NAO"                      => [  17,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Corelet 1 Nack A Overflow" ],
   "CB0_CO"                       => [  18,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Corelet 0 Credit Overflow" ],
   "CB0_NBO"                      => [  19,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Corelet 0 Nack B Overflow" ],
   "CB0_NAO"                      => [  20,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Corelet 0 Nack A Overflow" ],
);

%tio_01_00364_def =
( NAME    => "TIO_ICE_PMI_TX_ERROR_SUMMARY",
  ADDRESS => 0x00000000b000b000,
  NOTE    => "This register contains indications of the errors that have been note logged in the PMI Transmit Unit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00364_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_ERROR_SUMMARY_ALIAS                                     #
#                                                                        #
##########################################################################

%tio_01_00365_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CB3_B_TO"                     => [   1,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Corelet 3 Belt B Timeout" ],
   "CB3_A_TO"                     => [   2,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Corelet 3 Belt A Timeout" ],
   "CB2_B_TO"                     => [   3,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Corelet 2 Belt B Timeout" ],
   "CB2_A_TO"                     => [   4,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Corelet 2 Belt A Timeout" ],
   "CB1_B_TO"                     => [   5,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Corelet 1 Belt B Timeout" ],
   "CB1_A_TO"                     => [   6,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Corelet 1 Belt A Timeout" ],
   "CB0_B_TO"                     => [   7,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Corelet 0 Belt B Timeout" ],
   "CB0_A_TO"                     => [   8,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Corelet 0 Belt A Timeout" ],
   "CB3_CO"                       => [   9,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Corelet 3 Credit Overflow" ],
   "CB3_NBO"                      => [  10,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Corelet 3 Nack B Overflow" ],
   "CB3_NAO"                      => [  11,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Corelet 3 Nack A Overflow" ],
   "CB2_CO"                       => [  12,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Corelet 2 Credit Overflow" ],
   "CB2_NBO"                      => [  13,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Corelet 2 Nack B Overflow" ],
   "CB2_NAO"                      => [  14,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Corelet 2 Nack A Overflow" ],
   "CB1_CO"                       => [  15,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Corelet 1 Credit Overflow" ],
   "CB1_NBO"                      => [  16,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Corelet 1 Nack B Overflow" ],
   "CB1_NAO"                      => [  17,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Corelet 1 Nack A Overflow" ],
   "CB0_CO"                       => [  18,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Corelet 0 Credit Overflow" ],
   "CB0_NBO"                      => [  19,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Corelet 0 Nack B Overflow" ],
   "CB0_NAO"                      => [  20,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Corelet 0 Nack A Overflow" ],
);

%tio_01_00365_def =
( NAME    => "TIO_ICE_PMI_TX_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x00000000b000b008,
  NOTE    => "This register allows 'Write One to Clear (W1C)' access to the error note summary register.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00365_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_ERROR_OVERFLOW                                        #
#                                                                        #
##########################################################################

%tio_01_00366_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CB3_B_TO"                     => [   1,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Corelet 3 Belt B Timeout" ],
   "CB3_A_TO"                     => [   2,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Corelet 3 Belt A Timeout" ],
   "CB2_B_TO"                     => [   3,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Corelet 2 Belt B Timeout" ],
   "CB2_A_TO"                     => [   4,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Corelet 2 Belt A Timeout" ],
   "CB1_B_TO"                     => [   5,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Corelet 1 Belt B Timeout" ],
   "CB1_A_TO"                     => [   6,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Corelet 1 Belt A Timeout" ],
   "CB0_B_TO"                     => [   7,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Corelet 0 Belt B Timeout" ],
   "CB0_A_TO"                     => [   8,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Corelet 0 Belt A Timeout" ],
   "CB3_CO"                       => [   9,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Corelet 3 Credit Overflow" ],
   "CB3_NBO"                      => [  10,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Corelet 3 Nack B Overflow" ],
   "CB3_NAO"                      => [  11,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Corelet 3 Nack A Overflow" ],
   "CB2_CO"                       => [  12,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Corelet 2 Credit Overflow" ],
   "CB2_NBO"                      => [  13,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Corelet 2 Nack B Overflow" ],
   "CB2_NAO"                      => [  14,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Corelet 2 Nack A Overflow" ],
   "CB1_CO"                       => [  15,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Corelet 1 Credit Overflow" ],
   "CB1_NBO"                      => [  16,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Corelet 1 Nack B Overflow" ],
   "CB1_NAO"                      => [  17,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Corelet 1 Nack A Overflow" ],
   "CB0_CO"                       => [  18,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Corelet 0 Credit Overflow" ],
   "CB0_NBO"                      => [  19,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Corelet 0 Nack B Overflow" ],
   "CB0_NAO"                      => [  20,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Corelet 0 Nack A Overflow" ],
);

%tio_01_00366_def =
( NAME    => "TIO_ICE_PMI_TX_ERROR_OVERFLOW",
  ADDRESS => 0x00000000b000b010,
  NOTE    => "This register indicates that a second error of a given type has note occurred and, therefore, the error summary register has ove",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00366_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_ERROR_OF_ALIAS                                        #
#                                                                        #
##########################################################################

%tio_01_00367_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CB3_B_TO"                     => [   1,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Corelet 3 Belt B Timeout" ],
   "CB3_A_TO"                     => [   2,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Corelet 3 Belt A Timeout" ],
   "CB2_B_TO"                     => [   3,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Corelet 2 Belt B Timeout" ],
   "CB2_A_TO"                     => [   4,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Corelet 2 Belt A Timeout" ],
   "CB1_B_TO"                     => [   5,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Corelet 1 Belt B Timeout" ],
   "CB1_A_TO"                     => [   6,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Corelet 1 Belt A Timeout" ],
   "CB0_B_TO"                     => [   7,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Corelet 0 Belt B Timeout" ],
   "CB0_A_TO"                     => [   8,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Corelet 0 Belt A Timeout" ],
   "CB3_CO"                       => [   9,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Corelet 3 Credit Overflow" ],
   "CB3_NBO"                      => [  10,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Corelet 3 Nack B Overflow" ],
   "CB3_NAO"                      => [  11,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Corelet 3 Nack A Overflow" ],
   "CB2_CO"                       => [  12,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Corelet 2 Credit Overflow" ],
   "CB2_NBO"                      => [  13,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Corelet 2 Nack B Overflow" ],
   "CB2_NAO"                      => [  14,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Corelet 2 Nack A Overflow" ],
   "CB1_CO"                       => [  15,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Corelet 1 Credit Overflow" ],
   "CB1_NBO"                      => [  16,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Corelet 1 Nack B Overflow" ],
   "CB1_NAO"                      => [  17,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Corelet 1 Nack A Overflow" ],
   "CB0_CO"                       => [  18,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Corelet 0 Credit Overflow" ],
   "CB0_NBO"                      => [  19,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Corelet 0 Nack B Overflow" ],
   "CB0_NAO"                      => [  20,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Corelet 0 Nack A Overflow" ],
);

%tio_01_00367_def =
( NAME    => "TIO_ICE_PMI_TX_ERROR_OF_ALIAS",
  ADDRESS => 0x00000000b000b018,
  NOTE    => "This register allows 'Write One to Clear (W1C)' access to the error note overflow register.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00367_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_FIRST_ERROR                                           #
#                                                                        #
##########################################################################

%tio_01_00368_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CB3_B_TO"                     => [   1,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Corelet 3 Belt B Timeout" ],
   "CB3_A_TO"                     => [   2,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Corelet 3 Belt A Timeout" ],
   "CB2_B_TO"                     => [   3,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Corelet 2 Belt B Timeout" ],
   "CB2_A_TO"                     => [   4,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Corelet 2 Belt A Timeout" ],
   "CB1_B_TO"                     => [   5,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Corelet 1 Belt B Timeout" ],
   "CB1_A_TO"                     => [   6,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Corelet 1 Belt A Timeout" ],
   "CB0_B_TO"                     => [   7,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Corelet 0 Belt B Timeout" ],
   "CB0_A_TO"                     => [   8,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Corelet 0 Belt A Timeout" ],
   "CB3_CO"                       => [   9,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Corelet 3 Credit Overflow" ],
   "CB3_NBO"                      => [  10,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Corelet 3 Nack B Overflow" ],
   "CB3_NAO"                      => [  11,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Corelet 3 Nack A Overflow" ],
   "CB2_CO"                       => [  12,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Corelet 2 Credit Overflow" ],
   "CB2_NBO"                      => [  13,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Corelet 2 Nack B Overflow" ],
   "CB2_NAO"                      => [  14,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Corelet 2 Nack A Overflow" ],
   "CB1_CO"                       => [  15,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Corelet 1 Credit Overflow" ],
   "CB1_NBO"                      => [  16,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Corelet 1 Nack B Overflow" ],
   "CB1_NAO"                      => [  17,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Corelet 1 Nack A Overflow" ],
   "CB0_CO"                       => [  18,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Corelet 0 Credit Overflow" ],
   "CB0_NBO"                      => [  19,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Corelet 0 Nack B Overflow" ],
   "CB0_NAO"                      => [  20,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Corelet 0 Nack A Overflow" ],
);

%tio_01_00368_def =
( NAME    => "TIO_ICE_PMI_TX_FIRST_ERROR",
  ADDRESS => 0x00000000b000b020,
  NOTE    => "This register contains indications of the first error logged in the note PMI Transmit Unit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00368_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_CFG                                                   #
#                                                                        #
##########################################################################

%tio_01_00369_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 1, 0x0000000000000000, "Scratch Bits" ],
   "RSVD0"                        => [   1,   4,  56, 0x0FFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CORELET3_RESET"               => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Corelet 3 Programmable Reset" ],
   "CORELET2_RESET"               => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Corelet 2 Programmable Reset" ],
   "CORELET1_RESET"               => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Corelet 1 Programmable Reset" ],
   "CORELET0_RESET"               => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Corelet 0 Programmable Reset" ],
);

%tio_01_00369_def =
( NAME    => "TIO_ICE_PMI_TX_CFG",
  ADDRESS => 0x00000000b000b100,
  NOTE    => "This register contains the configuration bits that are used to note configure the PMI TX unit.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00369_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_LAST_CRED_STAT                                        #
#                                                                        #
##########################################################################

%tio_01_00370_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CB3_CREDITS"                  => [   1,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "CB3 Credit Status" ],
   "CB2_CREDITS"                  => [   2,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "CB2 Credit Status" ],
   "CB1_CREDITS"                  => [   3,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "CB1 Credit Status" ],
   "CB0_CREDITS"                  => [   4,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "CB0 Credit Status" ],
);

%tio_01_00370_def =
( NAME    => "TIO_ICE_PMI_TX_LAST_CRED_STAT",
  ADDRESS => 0x00000000b000b108,
  NOTE    => "This register contains the last status of the credit counts kept by note the transmit block of the PMI at the first leading edge",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00370_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_FORCE_ECC_ERR                                         #
#                                                                        #
##########################################################################

%tio_01_00371_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR2_OFFSET"                  => [   1,  44,  16, 0x0FFFF00000000000, 0x00, 1, 0x0000000000000000, "Error 2 Offset Number" ],
   "ERR2_GRP"                     => [   2,  40,   4, 0x00000F0000000000, 0x00, 1, 0x0000000000000000, "Error 2 Group Number" ],
   "ERR1_OFFSET"                  => [   3,  24,  16, 0x000000FFFF000000, 0x00, 1, 0x0000000000000000, "Error 1 Offset Number" ],
   "ERR1_GRP"                     => [   4,  20,   4, 0x0000000000F00000, 0x00, 1, 0x0000000000000000, "Error 1 Group Number" ],
   "ERR0_OFFSET"                  => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Error 0 Offset Number" ],
   "ERR0_GRP"                     => [   6,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Error 0 Group Number" ],
);

%tio_01_00371_def =
( NAME    => "TIO_ICE_PMI_TX_FORCE_ECC_ERR",
  ADDRESS => 0x00000000b000b110,
  NOTE    => "This register allows one to force up to 3 bit errors in the data note stream to corelet 3. This allows for the testing of the EC",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00371_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_NACK_CFG_CB0                                          #
#                                                                        #
##########################################################################

%tio_01_00372_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  59,   5, 0xF800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NACKA_DECR"                   => [   1,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "Nack A Decrementer" ],
   "NACKA_INCR"                   => [   2,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Nack A Incrementer" ],
   "NACKA_LD"                     => [   3,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "Nack A Loader" ],
   "NACKA_CNT"                    => [   4,  32,  24, 0x00FFFFFF00000000, 0x00, 1, 0x0000000000000000, "Nack A Counter for this Conveyor Belt" ],
   "RSVD1"                        => [   5,  27,   5, 0x00000000F8000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NACKB_DECR"                   => [   6,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Nack B Decrementer" ],
   "NACKB_INCR"                   => [   7,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Nack B Incrementer" ],
   "NACKB_LD"                     => [   8,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Nack B Loader" ],
   "NACKB_CNT"                    => [   9,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Nack B Counter for this Conveyor Belt" ],
);

%tio_01_00372_def =
( NAME    => "TIO_ICE_PMI_TX_NACK_CFG_CB0",
  ADDRESS => 0x00000000b000b800,
  NOTE    => "This register allows software to program the nack counters for this note conveyor belt. It also allows one to increment or decre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00372_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_NACK_CFG_CB1                                          #
#                                                                        #
##########################################################################

%tio_01_00373_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  59,   5, 0xF800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NACKA_DECR"                   => [   1,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "Nack A Decrementer" ],
   "NACKA_INCR"                   => [   2,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Nack A Incrementer" ],
   "NACKA_LD"                     => [   3,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "Nack A Loader" ],
   "NACKA_CNT"                    => [   4,  32,  24, 0x00FFFFFF00000000, 0x00, 1, 0x0000000000000000, "Nack A Counter for this Conveyor Belt" ],
   "RSVD1"                        => [   5,  27,   5, 0x00000000F8000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NACKB_DECR"                   => [   6,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Nack B Decrementer" ],
   "NACKB_INCR"                   => [   7,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Nack B Incrementer" ],
   "NACKB_LD"                     => [   8,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Nack B Loader" ],
   "NACKB_CNT"                    => [   9,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Nack B Counter for this Conveyor Belt" ],
);

%tio_01_00373_def =
( NAME    => "TIO_ICE_PMI_TX_NACK_CFG_CB1",
  ADDRESS => 0x00000000b000ba00,
  NOTE    => "This register allows software to program the nack counters for this note conveyor belt. It also allows one to increment or decre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00373_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_NACK_CFG_CB2                                          #
#                                                                        #
##########################################################################

%tio_01_00374_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  59,   5, 0xF800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NACKA_DECR"                   => [   1,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "Nack A Decrementer" ],
   "NACKA_INCR"                   => [   2,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Nack A Incrementer" ],
   "NACKA_LD"                     => [   3,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "Nack A Loader" ],
   "NACKA_CNT"                    => [   4,  32,  24, 0x00FFFFFF00000000, 0x00, 1, 0x0000000000000000, "Nack A Counter for this Conveyor Belt" ],
   "RSVD1"                        => [   5,  27,   5, 0x00000000F8000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NACKB_DECR"                   => [   6,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Nack B Decrementer" ],
   "NACKB_INCR"                   => [   7,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Nack B Incrementer" ],
   "NACKB_LD"                     => [   8,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Nack B Loader" ],
   "NACKB_CNT"                    => [   9,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Nack B Counter for this Conveyor Belt" ],
);

%tio_01_00374_def =
( NAME    => "TIO_ICE_PMI_TX_NACK_CFG_CB2",
  ADDRESS => 0x00000000b000bc00,
  NOTE    => "This register allows software to program the nack counters for this note conveyor belt. It also allows one to increment or decre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00374_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_NACK_CFG_CB3                                          #
#                                                                        #
##########################################################################

%tio_01_00375_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  59,   5, 0xF800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NACKA_DECR"                   => [   1,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "Nack A Decrementer" ],
   "NACKA_INCR"                   => [   2,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Nack A Incrementer" ],
   "NACKA_LD"                     => [   3,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "Nack A Loader" ],
   "NACKA_CNT"                    => [   4,  32,  24, 0x00FFFFFF00000000, 0x00, 1, 0x0000000000000000, "Nack A Counter for this Conveyor Belt" ],
   "RSVD1"                        => [   5,  27,   5, 0x00000000F8000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NACKB_DECR"                   => [   6,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "Nack B Decrementer" ],
   "NACKB_INCR"                   => [   7,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "Nack B Incrementer" ],
   "NACKB_LD"                     => [   8,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Nack B Loader" ],
   "NACKB_CNT"                    => [   9,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Nack B Counter for this Conveyor Belt" ],
);

%tio_01_00375_def =
( NAME    => "TIO_ICE_PMI_TX_NACK_CFG_CB3",
  ADDRESS => 0x00000000b000be00,
  NOTE    => "This register allows software to program the nack counters for this note conveyor belt. It also allows one to increment or decre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00375_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_NACK_STAT_CB0                                         #
#                                                                        #
##########################################################################

%tio_01_00376_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NACKA_CNT"                    => [   1,  32,  24, 0x00FFFFFF00000000, 0x00, 1, 0x0000000000000000, "Nack A Counter for the Conveyor Belt" ],
   "RSVD1"                        => [   2,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NACKB_CNT"                    => [   3,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Nack B Counter for this Conveyor Belt" ],
);

%tio_01_00376_def =
( NAME    => "TIO_ICE_PMI_TX_NACK_STAT_CB0",
  ADDRESS => 0x00000000b000b808,
  NOTE    => "This register contains the current count of the nack counters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00376_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_NACK_STAT_CB1                                         #
#                                                                        #
##########################################################################

%tio_01_00377_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NACKA_CNT"                    => [   1,  32,  24, 0x00FFFFFF00000000, 0x00, 1, 0x0000000000000000, "Nack A Counter for the Conveyor Belt" ],
   "RSVD1"                        => [   2,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NACKB_CNT"                    => [   3,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Nack B Counter for this Conveyor Belt" ],
);

%tio_01_00377_def =
( NAME    => "TIO_ICE_PMI_TX_NACK_STAT_CB1",
  ADDRESS => 0x00000000b000ba08,
  NOTE    => "This register contains the current count of the nack counters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00377_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_NACK_STAT_CB2                                         #
#                                                                        #
##########################################################################

%tio_01_00378_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NACKA_CNT"                    => [   1,  32,  24, 0x00FFFFFF00000000, 0x00, 1, 0x0000000000000000, "Nack A Counter for the Conveyor Belt" ],
   "RSVD1"                        => [   2,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NACKB_CNT"                    => [   3,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Nack B Counter for this Conveyor Belt" ],
);

%tio_01_00378_def =
( NAME    => "TIO_ICE_PMI_TX_NACK_STAT_CB2",
  ADDRESS => 0x00000000b000bc08,
  NOTE    => "This register contains the current count of the nack counters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00378_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_NACK_STAT_CB3                                         #
#                                                                        #
##########################################################################

%tio_01_00379_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NACKA_CNT"                    => [   1,  32,  24, 0x00FFFFFF00000000, 0x00, 1, 0x0000000000000000, "Nack A Counter for the Conveyor Belt" ],
   "RSVD1"                        => [   2,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NACKB_CNT"                    => [   3,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Nack B Counter for this Conveyor Belt" ],
);

%tio_01_00379_def =
( NAME    => "TIO_ICE_PMI_TX_NACK_STAT_CB3",
  ADDRESS => 0x00000000b000be08,
  NOTE    => "This register contains the current count of the nack counters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00379_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_CREDIT_CFG_CB0                                        #
#                                                                        #
##########################################################################

%tio_01_00380_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE_LD"                     => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "State Load" ],
   "STATE"                        => [   2,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "State of this Conveyor Belt" ],
   "RSVD1"                        => [   3,  17,  15, 0x00000000FFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CREDIT_CNT_LD"            => [   4,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Maximum Credit Count for Overflow Limit Loader" ],
   "MAX_CREDIT_CNT"               => [   5,  12,   4, 0x000000000000F000, 0x00, 1, 0x0000000000000000, "Maximum Credits Count for Overflow Limit" ],
   "RSVD2"                        => [   6,   5,   7, 0x0000000000000FE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_LD"                    => [   7,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Credit Loader" ],
   "CREDIT_CNT"                   => [   8,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Credit Count to be loaded" ],
);

%tio_01_00380_def =
( NAME    => "TIO_ICE_PMI_TX_CREDIT_CFG_CB0",
  ADDRESS => 0x00000000b000b810,
  NOTE    => "This register allows for the configuration of the credits and the note credit state machine for this Conveyor Belt.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00380_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_CREDIT_CFG_CB1                                        #
#                                                                        #
##########################################################################

%tio_01_00381_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE_LD"                     => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "State Load" ],
   "STATE"                        => [   2,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "State of this Conveyor Belt" ],
   "RSVD1"                        => [   3,  17,  15, 0x00000000FFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CREDIT_CNT_LD"            => [   4,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Maximum Credit Count for Overflow Limit Loader" ],
   "MAX_CREDIT_CNT"               => [   5,  12,   4, 0x000000000000F000, 0x00, 1, 0x0000000000000000, "Maximum Credits Count for Overflow Limit" ],
   "RSVD2"                        => [   6,   5,   7, 0x0000000000000FE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_LD"                    => [   7,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Credit Loader" ],
   "CREDIT_CNT"                   => [   8,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Credit Count to be loaded" ],
);

%tio_01_00381_def =
( NAME    => "TIO_ICE_PMI_TX_CREDIT_CFG_CB1",
  ADDRESS => 0x00000000b000ba10,
  NOTE    => "This register allows for the configuration of the credits and the note credit state machine for this Conveyor Belt.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00381_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_CREDIT_CFG_CB2                                        #
#                                                                        #
##########################################################################

%tio_01_00382_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE_LD"                     => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "State Load" ],
   "STATE"                        => [   2,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "State of this Conveyor Belt" ],
   "RSVD1"                        => [   3,  17,  15, 0x00000000FFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CREDIT_CNT_LD"            => [   4,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Maximum Credit Count for Overflow Limit Loader" ],
   "MAX_CREDIT_CNT"               => [   5,  12,   4, 0x000000000000F000, 0x00, 1, 0x0000000000000000, "Maximum Credits Count for Overflow Limit" ],
   "RSVD2"                        => [   6,   5,   7, 0x0000000000000FE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_LD"                    => [   7,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Credit Loader" ],
   "CREDIT_CNT"                   => [   8,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Credit Count to be loaded" ],
);

%tio_01_00382_def =
( NAME    => "TIO_ICE_PMI_TX_CREDIT_CFG_CB2",
  ADDRESS => 0x00000000b000bc10,
  NOTE    => "This register allows for the configuration of the credits and the note credit state machine for this Conveyor Belt.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00382_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_CREDIT_CFG_CB3                                        #
#                                                                        #
##########################################################################

%tio_01_00383_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE_LD"                     => [   1,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "State Load" ],
   "STATE"                        => [   2,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "State of this Conveyor Belt" ],
   "RSVD1"                        => [   3,  17,  15, 0x00000000FFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CREDIT_CNT_LD"            => [   4,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Maximum Credit Count for Overflow Limit Loader" ],
   "MAX_CREDIT_CNT"               => [   5,  12,   4, 0x000000000000F000, 0x00, 1, 0x0000000000000000, "Maximum Credits Count for Overflow Limit" ],
   "RSVD2"                        => [   6,   5,   7, 0x0000000000000FE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_LD"                    => [   7,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Credit Loader" ],
   "CREDIT_CNT"                   => [   8,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Credit Count to be loaded" ],
);

%tio_01_00383_def =
( NAME    => "TIO_ICE_PMI_TX_CREDIT_CFG_CB3",
  ADDRESS => 0x00000000b000be10,
  NOTE    => "This register allows for the configuration of the credits and the note credit state machine for this Conveyor Belt.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00383_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_DYN_CREDIT_STAT_CB0                                     #
#                                                                        #
##########################################################################

%tio_01_00384_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE"                        => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "State of this Conveyor Belt Algorithm" ],
   "RSVD1"                        => [   2,   4,  28, 0x00000000FFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_CNT"                   => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Current Credits available from the corelet on this conveyor belt" ],
);

%tio_01_00384_def =
( NAME    => "TIO_ICE_PMI_TX_DYN_CREDIT_STAT_CB0",
  ADDRESS => 0x00000000b000b818,
  NOTE    => "This register contains the current state of the credits and the note credit state machine for this conveyor belt.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00384_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_DYN_CREDIT_STAT_CB1                                     #
#                                                                        #
##########################################################################

%tio_01_00385_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE"                        => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "State of this Conveyor Belt Algorithm" ],
   "RSVD1"                        => [   2,   4,  28, 0x00000000FFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_CNT"                   => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Current Credits available from the corelet on this conveyor belt" ],
);

%tio_01_00385_def =
( NAME    => "TIO_ICE_PMI_TX_DYN_CREDIT_STAT_CB1",
  ADDRESS => 0x00000000b000ba18,
  NOTE    => "This register contains the current state of the credits and the note credit state machine for this conveyor belt.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00385_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_DYN_CREDIT_STAT_CB2                                     #
#                                                                        #
##########################################################################

%tio_01_00386_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE"                        => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "State of this Conveyor Belt Algorithm" ],
   "RSVD1"                        => [   2,   4,  28, 0x00000000FFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_CNT"                   => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Current Credits available from the corelet on this conveyor belt" ],
);

%tio_01_00386_def =
( NAME    => "TIO_ICE_PMI_TX_DYN_CREDIT_STAT_CB2",
  ADDRESS => 0x00000000b000bc18,
  NOTE    => "This register contains the current state of the credits and the note credit state machine for this conveyor belt.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00386_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_PMI_TX_DYN_CREDIT_STAT_CB3                                     #
#                                                                        #
##########################################################################

%tio_01_00387_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE"                        => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "State of this Conveyor Belt Algorithm" ],
   "RSVD1"                        => [   2,   4,  28, 0x00000000FFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_CNT"                   => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Current Credits available from the corelet on this conveyor belt" ],
);

%tio_01_00387_def =
( NAME    => "TIO_ICE_PMI_TX_DYN_CREDIT_STAT_CB3",
  ADDRESS => 0x00000000b000be18,
  NOTE    => "This register contains the current state of the credits and the note credit state machine for this conveyor belt.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00387_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_ERROR_SUMMARY                                            #
#                                                                        #
##########################################################################

%tio_01_00388_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAIL_TO3"                     => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 3" ],
   "TAIL_TO2"                     => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 2" ],
   "TAIL_TO1"                     => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 1" ],
   "TAIL_TO0"                     => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 0" ],
   "RSP_MBE3"                     => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Response Multi-bit Port 3" ],
   "REQ_MBE3"                     => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Request Multi-bit Port 3" ],
   "RSP_SBE3"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Response Single Bit Port 3" ],
   "REQ_SBE3"                     => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Request Single Bit Port 3" ],
   "RSVD1"                        => [   9,  12,  12, 0x0000000000FFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CONCURRENT_DV3"               => [  10,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 3" ],
   "CONCURRENT_DV2"               => [  11,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 2" ],
   "CONCURRENT_DV1"               => [  12,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 1" ],
   "CONCURRENT_DV0"               => [  13,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 0" ],
   "RSP_BUF_OFLOW3"               => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Response Buffer 3 Overflow" ],
   "REQ_BUF_OFLOW3"               => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Buffer 3 Overflow" ],
   "RSP_BUF_OFLOW2"               => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Response Buffer 2 Overflow" ],
   "REQ_BUF_OFLOW2"               => [  17,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Request Buffer 2 Overflow" ],
   "RSP_BUF_OFLOW1"               => [  18,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Response Buffer 1 Overflow" ],
   "REQ_BUF_OFLOW1"               => [  19,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Request Buffer 1 Overflow" ],
   "RSP_BUF_OFLOW0"               => [  20,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Response Buffer 0 Overflow" ],
   "REQ_BUF_OFLOW0"               => [  21,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Request Buffer 0 Overflow" ],
);

%tio_01_00388_def =
( NAME    => "TIO_ICE_CMA_ERROR_SUMMARY",
  ADDRESS => 0x00000000b000e000,
  NOTE    => "This register indicates what errors have been detected within the note CMA. When any of these bits set the global block will als",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00388_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_ERROR_SUMMARY_ALIAS                                      #
#                                                                        #
##########################################################################

%tio_01_00389_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAIL_TO3"                     => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 3" ],
   "TAIL_TO2"                     => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 2" ],
   "TAIL_TO1"                     => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 1" ],
   "TAIL_TO0"                     => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 0" ],
   "RSP_MBE3"                     => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Response Multi-bit Port 3" ],
   "REQ_MBE3"                     => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Request Multi-bit Port 3" ],
   "RSP_SBE3"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Response Single Bit Port 3" ],
   "REQ_SBE3"                     => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Request Single Bit Port 3" ],
   "RSVD1"                        => [   9,  12,  12, 0x0000000000FFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CONCURRENT_DV3"               => [  10,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 3" ],
   "CONCURRENT_DV2"               => [  11,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 2" ],
   "CONCURRENT_DV1"               => [  12,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 1" ],
   "CONCURRENT_DV0"               => [  13,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 0" ],
   "RSP_BUF_OFLOW3"               => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Response Buffer 3 Overflow" ],
   "REQ_BUF_OFLOW3"               => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Buffer 3 Overflow" ],
   "RSP_BUF_OFLOW2"               => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Response Buffer 2 Overflow" ],
   "REQ_BUF_OFLOW2"               => [  17,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Request Buffer 2 Overflow" ],
   "RSP_BUF_OFLOW1"               => [  18,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Response Buffer 1 Overflow" ],
   "REQ_BUF_OFLOW1"               => [  19,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Request Buffer 1 Overflow" ],
   "RSP_BUF_OFLOW0"               => [  20,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Response Buffer 0 Overflow" ],
   "REQ_BUF_OFLOW0"               => [  21,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Request Buffer 0 Overflow" ],
);

%tio_01_00389_def =
( NAME    => "TIO_ICE_CMA_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x00000000b000e008,
  NOTE    => "This register is an alias for the CMA Error Summary register. When note accessing the CMA Error Summary register, the SW attribu",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00389_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_ERROR_OVERFLOW                                           #
#                                                                        #
##########################################################################

%tio_01_00390_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAIL_TO3"                     => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 3" ],
   "TAIL_TO2"                     => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 2" ],
   "TAIL_TO1"                     => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 1" ],
   "TAIL_TO0"                     => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 0" ],
   "RSP_MBE3"                     => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Response Multi-bit Port 3" ],
   "REQ_MBE3"                     => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Request Multi-bit Port 3" ],
   "RSP_SBE3"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Response Single Bit Port 3" ],
   "REQ_SBE3"                     => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Request Single Bit Port 3" ],
   "RSVD1"                        => [   9,  12,  12, 0x0000000000FFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CONCURRENT_DV3"               => [  10,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 3" ],
   "CONCURRENT_DV2"               => [  11,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 2" ],
   "CONCURRENT_DV1"               => [  12,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 1" ],
   "CONCURRENT_DV0"               => [  13,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 0" ],
   "RSP_BUF_OFLOW3"               => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Response Buffer 3 Overflow" ],
   "REQ_BUF_OFLOW3"               => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Buffer 3 Overflow" ],
   "RSP_BUF_OFLOW2"               => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Response Buffer 2 Overflow" ],
   "REQ_BUF_OFLOW2"               => [  17,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Request Buffer 2 Overflow" ],
   "RSP_BUF_OFLOW1"               => [  18,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Response Buffer 1 Overflow" ],
   "REQ_BUF_OFLOW1"               => [  19,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Request Buffer 1 Overflow" ],
   "RSP_BUF_OFLOW0"               => [  20,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Response Buffer 0 Overflow" ],
   "REQ_BUF_OFLOW0"               => [  21,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Request Buffer 0 Overflow" ],
);

%tio_01_00390_def =
( NAME    => "TIO_ICE_CMA_ERROR_OVERFLOW",
  ADDRESS => 0x00000000b000e010,
  NOTE    => "This register will have a bit set if an error occurred more than note once since the Error Summary register was cleared.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00390_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_ERROR_OVERFLOW_ALIAS                                     #
#                                                                        #
##########################################################################

%tio_01_00391_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAIL_TO3"                     => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 3" ],
   "TAIL_TO2"                     => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 2" ],
   "TAIL_TO1"                     => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 1" ],
   "TAIL_TO0"                     => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 0" ],
   "RSP_MBE3"                     => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Response Multi-bit Port 3" ],
   "REQ_MBE3"                     => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Request Multi-bit Port 3" ],
   "RSP_SBE3"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Response Single Bit Port 3" ],
   "REQ_SBE3"                     => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Request Single Bit Port 3" ],
   "RSVD1"                        => [   9,  12,  12, 0x0000000000FFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CONCURRENT_DV3"               => [  10,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 3" ],
   "CONCURRENT_DV2"               => [  11,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 2" ],
   "CONCURRENT_DV1"               => [  12,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 1" ],
   "CONCURRENT_DV0"               => [  13,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 0" ],
   "RSP_BUF_OFLOW3"               => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Response Buffer 3 Overflow" ],
   "REQ_BUF_OFLOW3"               => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Buffer 3 Overflow" ],
   "RSP_BUF_OFLOW2"               => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Response Buffer 2 Overflow" ],
   "REQ_BUF_OFLOW2"               => [  17,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Request Buffer 2 Overflow" ],
   "RSP_BUF_OFLOW1"               => [  18,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Response Buffer 1 Overflow" ],
   "REQ_BUF_OFLOW1"               => [  19,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Request Buffer 1 Overflow" ],
   "RSP_BUF_OFLOW0"               => [  20,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Response Buffer 0 Overflow" ],
   "REQ_BUF_OFLOW0"               => [  21,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Request Buffer 0 Overflow" ],
);

%tio_01_00391_def =
( NAME    => "TIO_ICE_CMA_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x00000000b000e018,
  NOTE    => "This register is an alias for the CMA Error Overflow register. When note accessing the CMA Error Overflow register, the SW attri",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00391_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_FIRST_ERROR                                              #
#                                                                        #
##########################################################################

%tio_01_00392_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TAIL_TO3"                     => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 3" ],
   "TAIL_TO2"                     => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 2" ],
   "TAIL_TO1"                     => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 1" ],
   "TAIL_TO0"                     => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "Tail Timeout Port 0" ],
   "RSP_MBE3"                     => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Response Multi-bit Port 3" ],
   "REQ_MBE3"                     => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "Request Multi-bit Port 3" ],
   "RSP_SBE3"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "Response Single Bit Port 3" ],
   "REQ_SBE3"                     => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Request Single Bit Port 3" ],
   "RSVD1"                        => [   9,  12,  12, 0x0000000000FFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CONCURRENT_DV3"               => [  10,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 3" ],
   "CONCURRENT_DV2"               => [  11,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 2" ],
   "CONCURRENT_DV1"               => [  12,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 1" ],
   "CONCURRENT_DV0"               => [  13,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Concurrent Data Valids Port 0" ],
   "RSP_BUF_OFLOW3"               => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Response Buffer 3 Overflow" ],
   "REQ_BUF_OFLOW3"               => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Buffer 3 Overflow" ],
   "RSP_BUF_OFLOW2"               => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Response Buffer 2 Overflow" ],
   "REQ_BUF_OFLOW2"               => [  17,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Request Buffer 2 Overflow" ],
   "RSP_BUF_OFLOW1"               => [  18,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Response Buffer 1 Overflow" ],
   "REQ_BUF_OFLOW1"               => [  19,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Request Buffer 1 Overflow" ],
   "RSP_BUF_OFLOW0"               => [  20,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Response Buffer 0 Overflow" ],
   "REQ_BUF_OFLOW0"               => [  21,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Request Buffer 0 Overflow" ],
);

%tio_01_00392_def =
( NAME    => "TIO_ICE_CMA_FIRST_ERROR",
  ADDRESS => 0x00000000b000e020,
  NOTE    => "When an error occurs within the CMA and this register is zero, the note corresponding bit of the error will set in this register",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00392_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_DBG_MUX_SELECT                                           #
#                                                                        #
##########################################################################

%tio_01_00393_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_PORT_SEL"             => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_PORT_SEL"             => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_PORT_SEL"             => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_PORT_SEL"             => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_PORT_SEL"             => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_PORT_SEL"             => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_PORT_SEL"             => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_PORT_SEL"             => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_00393_def =
( NAME    => "TIO_ICE_CMA_DBG_MUX_SELECT",
  ADDRESS => 0x00000000b000e0f8,
  NOTE    => "This register controls which signals from the CMA are routed to the note global debug mux.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00393_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_CFG                                                      #
#                                                                        #
##########################################################################

%tio_01_00394_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_CREDIT"                 => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Force" ],
   "RSVD1"                        => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECC_DISABLE"                  => [   3,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "ECC Disable" ],
   "BYPASS_DISABLE"               => [   4,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Bypass Disable" ],
   "RSVD2"                        => [   5,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXT_CREDIT_LIMIT"             => [   6,   4,   6, 0x00000000000003F0, 0x00, 1, 0x0000000000000000, "External Credit Limit" ],
   "INT_CREDIT_LIMIT"             => [   7,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Internal Credit Limit" ],
);

%tio_01_00394_def =
( NAME    => "TIO_ICE_CMA_CFG",
  ADDRESS => 0x00000000b000e100,
  NOTE    => "This register provides the ability to force some modes intended to note be used to aid functionality testing.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00394_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_TIMEOUT_CFG                                              #
#                                                                        #
##########################################################################

%tio_01_00395_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMEOUT_LIMIT"                => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Tail Timeout Limit" ],
);

%tio_01_00395_def =
( NAME    => "TIO_ICE_CMA_TIMEOUT_CFG",
  ADDRESS => 0x00000000b000e108,
  NOTE    => "This register controls the monitoring of tail timeouts.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00395_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_READ_CFG                                                 #
#                                                                        #
##########################################################################

%tio_01_00396_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SENSITIVITY_PERIOD"           => [   1,  32,  16, 0x0000FFFF00000000, 0x00, 1, 0x0000000000000000, "Read Sensitivity Period" ],
   "RSVD1"                        => [   2,  20,  12, 0x00000000FFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "READ_SENSITIVITY"             => [   3,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "Read Sensitivity Mask" ],
   "RSVD2"                        => [   4,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "READ_PERIOD"                  => [   5,   0,  10, 0x00000000000003FF, 0x00, 1, 0x0000000000000000, "Read Period Duration" ],
);

%tio_01_00396_def =
( NAME    => "TIO_ICE_CMA_READ_CFG",
  ADDRESS => 0x00000000b000e110,
  NOTE    => "This register controls the manner in which the CMA will place flow note control restrictions on Read Request packets.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00396_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_WRITE_CFG                                                #
#                                                                        #
##########################################################################

%tio_01_00397_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  10,  54, 0xFFFFFFFFFFFFFC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_PERIOD"                 => [   1,   0,  10, 0x00000000000003FF, 0x00, 1, 0x0000000000000000, "Write Period Duration" ],
);

%tio_01_00397_def =
( NAME    => "TIO_ICE_CMA_WRITE_CFG",
  ADDRESS => 0x00000000b000e118,
  NOTE    => "This register controls the manner in which the CMA will place flow note control restrictions on Write Request packets.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00397_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_PORT_CFG_0                                               #
#                                                                        #
##########################################################################

%tio_01_00398_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_LIMIT"                  => [   1,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "Number of Write Requests" ],
   "RSVD1"                        => [   2,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "READ_LIMIT"                   => [   3,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Number of Read Requests" ],
);

%tio_01_00398_def =
( NAME    => "TIO_ICE_CMA_PORT_CFG_0",
  ADDRESS => 0x00000000b000e120,
  NOTE    => "This register controls the flow control for the individual note core-let.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00398_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_PORT_CFG_1                                               #
#                                                                        #
##########################################################################

%tio_01_00399_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_LIMIT"                  => [   1,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "Number of Write Requests" ],
   "RSVD1"                        => [   2,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "READ_LIMIT"                   => [   3,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Number of Read Requests" ],
);

%tio_01_00399_def =
( NAME    => "TIO_ICE_CMA_PORT_CFG_1",
  ADDRESS => 0x00000000b000e128,
  NOTE    => "This register controls the flow control for the individual note core-let.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00399_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_PORT_CFG_2                                               #
#                                                                        #
##########################################################################

%tio_01_00400_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_LIMIT"                  => [   1,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "Number of Write Requests" ],
   "RSVD1"                        => [   2,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "READ_LIMIT"                   => [   3,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Number of Read Requests" ],
);

%tio_01_00400_def =
( NAME    => "TIO_ICE_CMA_PORT_CFG_2",
  ADDRESS => 0x00000000b000e130,
  NOTE    => "This register controls the flow control for the individual note core-let.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00400_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_PORT_CFG_3                                               #
#                                                                        #
##########################################################################

%tio_01_00401_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  14,  50, 0xFFFFFFFFFFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRITE_LIMIT"                  => [   1,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "Number of Write Requests" ],
   "RSVD1"                        => [   2,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "READ_LIMIT"                   => [   3,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Number of Read Requests" ],
);

%tio_01_00401_def =
( NAME    => "TIO_ICE_CMA_PORT_CFG_3",
  ADDRESS => 0x00000000b000e138,
  NOTE    => "This register controls the flow control for the individual note core-let.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00401_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_CORELET_DBG_MUX_SELECT                                     #
#                                                                        #
##########################################################################

%tio_01_00402_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLOCK_SEL"                    => [   1,  32,   2, 0x0000000300000000, 0x00, 0, 0x0000000000000000, "Clock Select" ],
   "RSVD1"                        => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_PORT_SEL"             => [   3,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_PORT_SEL"             => [   5,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_PORT_SEL"             => [   7,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD4"                        => [   8,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_PORT_SEL"             => [   9,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD5"                        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_PORT_SEL"             => [  11,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD6"                        => [  12,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_PORT_SEL"             => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD7"                        => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_PORT_SEL"             => [  15,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD8"                        => [  16,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_PORT_SEL"             => [  17,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_00402_def =
( NAME    => "TIO_ICE_CMA_CORELET_DBG_MUX_SELECT",
  ADDRESS => 0x00000000b000e140,
  NOTE    => "This register controls which debug signals from the core-lets are note routed to the Local Block debug mux.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00402_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_SYNDROME                                                 #
#                                                                        #
##########################################################################

%tio_01_00403_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_SYN_UPPER"                => [   1,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Response Syndrome Upper" ],
   "RSP_SYN_LOWER"                => [   2,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Response Syndrome Lower" ],
   "REQ_SYN_UPPER"                => [   3,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Request Syndrome Upper" ],
   "REQ_SYN_LOWER"                => [   4,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Request Syndrome Lower" ],
);

%tio_01_00403_def =
( NAME    => "TIO_ICE_CMA_SYNDROME",
  ADDRESS => 0x00000000b000e148,
  NOTE    => "When a single or double bit error has been detected and logged in note the Error Summary register, this register will contain th",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00403_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_CL0_DYN_CREDIT_STAT                                      #
#                                                                        #
##########################################################################

%tio_01_00404_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_SENT"                     => [   1,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "Response Buffer Credits Sent" ],
   "RSVD1"                        => [   2,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_USED"                     => [   3,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "Response Buffer Slots Used" ],
   "RSVD2"                        => [   4,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_SENT"                     => [   5,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Request Buffer Credits Sent" ],
   "RSVD3"                        => [   6,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_USED"                     => [   7,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Request Buffer Slots Used" ],
);

%tio_01_00404_def =
( NAME    => "TIO_ICE_CMA_CL0_DYN_CREDIT_STAT",
  ADDRESS => 0x00000000b000e150,
  NOTE    => "This register indicates the current state of the credit counters note within the CMA for core-let 0.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00404_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_CL1_DYN_CREDIT_STAT                                      #
#                                                                        #
##########################################################################

%tio_01_00405_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_SENT"                     => [   1,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "Response Buffer Credits Sent" ],
   "RSVD1"                        => [   2,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_USED"                     => [   3,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "Response Buffer Slots Used" ],
   "RSVD2"                        => [   4,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_SENT"                     => [   5,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Request Buffer Credits Sent" ],
   "RSVD3"                        => [   6,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_USED"                     => [   7,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Request Buffer Slots Used" ],
);

%tio_01_00405_def =
( NAME    => "TIO_ICE_CMA_CL1_DYN_CREDIT_STAT",
  ADDRESS => 0x00000000b000e158,
  NOTE    => "This register indicates the current state of the credit counters note within the CMA for core-let 1.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00405_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_CL2_DYN_CREDIT_STAT                                      #
#                                                                        #
##########################################################################

%tio_01_00406_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_SENT"                     => [   1,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "Response Buffer Credits Sent" ],
   "RSVD1"                        => [   2,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_USED"                     => [   3,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "Response Buffer Slots Used" ],
   "RSVD2"                        => [   4,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_SENT"                     => [   5,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Request Buffer Credits Sent" ],
   "RSVD3"                        => [   6,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_USED"                     => [   7,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Request Buffer Slots Used" ],
);

%tio_01_00406_def =
( NAME    => "TIO_ICE_CMA_CL2_DYN_CREDIT_STAT",
  ADDRESS => 0x00000000b000e160,
  NOTE    => "This register indicates the current state of the credit counters note within the CMA for core-let 2.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00406_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_CL3_DYN_CREDIT_STAT                                      #
#                                                                        #
##########################################################################

%tio_01_00407_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_SENT"                     => [   1,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "Response Buffer Credits Sent" ],
   "RSVD1"                        => [   2,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_USED"                     => [   3,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "Response Buffer Slots Used" ],
   "RSVD2"                        => [   4,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_SENT"                     => [   5,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "Request Buffer Credits Sent" ],
   "RSVD3"                        => [   6,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_USED"                     => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Request Buffer Slots Used" ],
);

%tio_01_00407_def =
( NAME    => "TIO_ICE_CMA_CL3_DYN_CREDIT_STAT",
  ADDRESS => 0x00000000b000e168,
  NOTE    => "This register indicates the current state of the credit counters note within the CMA for core-let 3.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00407_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_CL0_LAST_CREDIT_STAT                                     #
#                                                                        #
##########################################################################

%tio_01_00408_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_SENT"                     => [   1,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Response Buffer Credits Sent" ],
   "RSVD1"                        => [   2,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_USED"                     => [   3,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Response Buffer Slots Used" ],
   "RSVD2"                        => [   4,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_SENT"                     => [   5,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Request Buffer Credits Sent" ],
   "RSVD3"                        => [   6,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_USED"                     => [   7,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Request Buffer Slots Used" ],
);

%tio_01_00408_def =
( NAME    => "TIO_ICE_CMA_CL0_LAST_CREDIT_STAT",
  ADDRESS => 0x00000000b000e170,
  NOTE    => "This register holds the state of the credit counters in the CMA note when a soft reset is issued. This is intended as a debug to",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00408_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_CL1_LAST_CREDIT_STAT                                     #
#                                                                        #
##########################################################################

%tio_01_00409_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_SENT"                     => [   1,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Response Buffer Credits Sent" ],
   "RSVD1"                        => [   2,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_USED"                     => [   3,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Response Buffer Slots Used" ],
   "RSVD2"                        => [   4,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_SENT"                     => [   5,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Request Buffer Credits Sent" ],
   "RSVD3"                        => [   6,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_USED"                     => [   7,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Request Buffer Slots Used" ],
);

%tio_01_00409_def =
( NAME    => "TIO_ICE_CMA_CL1_LAST_CREDIT_STAT",
  ADDRESS => 0x00000000b000e178,
  NOTE    => "This register holds the state of the credit counters in the CMA note when a soft reset is issued. This is intended as a debug to",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00409_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_CL2_LAST_CREDIT_STAT                                     #
#                                                                        #
##########################################################################

%tio_01_00410_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_SENT"                     => [   1,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Response Buffer Credits Sent" ],
   "RSVD1"                        => [   2,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_USED"                     => [   3,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Response Buffer Slots Used" ],
   "RSVD2"                        => [   4,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_SENT"                     => [   5,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Request Buffer Credits Sent" ],
   "RSVD3"                        => [   6,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_USED"                     => [   7,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Request Buffer Slots Used" ],
);

%tio_01_00410_def =
( NAME    => "TIO_ICE_CMA_CL2_LAST_CREDIT_STAT",
  ADDRESS => 0x00000000b000e180,
  NOTE    => "This register holds the state of the credit counters in the CMA note when a soft reset is issued. This is intended as a debug to",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00410_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_CL3_LAST_CREDIT_STAT                                     #
#                                                                        #
##########################################################################

%tio_01_00411_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_SENT"                     => [   1,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "Response Buffer Credits Sent" ],
   "RSVD1"                        => [   2,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_USED"                     => [   3,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Response Buffer Slots Used" ],
   "RSVD2"                        => [   4,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_SENT"                     => [   5,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "Request Buffer Credits Sent" ],
   "RSVD3"                        => [   6,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_USED"                     => [   7,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Request Buffer Slots Used" ],
);

%tio_01_00411_def =
( NAME    => "TIO_ICE_CMA_CL3_LAST_CREDIT_STAT",
  ADDRESS => 0x00000000b000e188,
  NOTE    => "This register holds the state of the credit counters in the CMA note when a soft reset is issued. This is intended as a debug to",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00411_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_PMI_DYN_CREDIT_STAT                                      #
#                                                                        #
##########################################################################

%tio_01_00412_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_CREDIT"                   => [   1,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "Response Credit Count" ],
   "REQ_CREDIT"                   => [   2,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Request Credit Count" ],
);

%tio_01_00412_def =
( NAME    => "TIO_ICE_CMA_PMI_DYN_CREDIT_STAT",
  ADDRESS => 0x00000000b000e190,
  NOTE    => "This register indicates the current state of the credit counters note within the CMA for the PMI port.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00412_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_CMA_PMI_LAST_CREDIT_STAT                                     #
#                                                                        #
##########################################################################

%tio_01_00413_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSP_CREDIT"                   => [   1,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Response Credit Count" ],
   "REQ_CREDIT"                   => [   2,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Request Credit Count" ],
);

%tio_01_00413_def =
( NAME    => "TIO_ICE_CMA_PMI_LAST_CREDIT_STAT",
  ADDRESS => 0x00000000b000e198,
  NOTE    => "This register holds the state of the credit counters in the CMA note when a soft reset is issued. This is intended as a debug to",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00413_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_LIQ_CTL                                                       #
#                                                                        #
##########################################################################

%tio_01_00414_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  18,  46, 0xFFFFFFFFFFFC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FORCE_RP_CREDIT"              => [   1,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Force reply credit" ],
   "FORCE_RQ_CREDIT"              => [   2,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Force request credit" ],
   "RSVD1"                        => [   3,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RPL_CTL"                  => [   4,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "LIQ Reply Control" ],
   "RSVD2"                        => [   5,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_REQ_CTL"                  => [   6,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "LIQ Request Control" ],
);

%tio_01_00414_def =
( NAME    => "TIO_LB_LIQ_CTL",
  ADDRESS => 0x0000000090040000,
  NOTE    => "The LB_LIQ_CTL register provides credit control for the LB's Input note Request Queue and Input Reply Queue. Parameters specifie",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00414_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_LOQ_CTL                                                       #
#                                                                        #
##########################################################################

%tio_01_00415_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOQ_RPL_CTL"                  => [   1,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "LOQ Reply Control" ],
   "LOQ_REQ_CTL"                  => [   2,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "LOQ Request Control" ],
);

%tio_01_00415_def =
( NAME    => "TIO_LB_LOQ_CTL",
  ADDRESS => 0x0000000090040080,
  NOTE    => "The LB_LOQ_CTL register provides maintenance testing facilities note which throttle request and reply messages leaving the LB's ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00415_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_MAX_REP_CREDIT_CNT                                            #
#                                                                        #
##########################################################################

%tio_01_00416_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT"                      => [   1,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Max reply credits" ],
);

%tio_01_00416_def =
( NAME    => "TIO_LB_MAX_REP_CREDIT_CNT",
  ADDRESS => 0x0000000090040100,
  NOTE    => "The LB_MAX_REP_CREDIT_CNT register specifies the reply VC credit note limit for the LB's LOQ block.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00416_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_MAX_REQ_CREDIT_CNT                                            #
#                                                                        #
##########################################################################

%tio_01_00417_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_CNT"                      => [   1,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Max request credits" ],
);

%tio_01_00417_def =
( NAME    => "TIO_LB_MAX_REQ_CREDIT_CNT",
  ADDRESS => 0x0000000090040180,
  NOTE    => "The LB_MAX_REQ_CREDIT_CNT register specifies the request VC credit note limit for the LB's LOQ block.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00417_flds
);


##########################################################################
#                                                                        #
#   TIO_PIO_TIME_OUT                                                     #
#                                                                        #
##########################################################################

%tio_01_00418_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VALUE"                        => [   1,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "PIO time out value" ],
);

%tio_01_00418_def =
( NAME    => "TIO_PIO_TIME_OUT",
  ADDRESS => 0x0000000090040200,
  NOTE    => "The PIO time out value register sets the time out value for PIO note request. This is the amount of time the PIO channel waits f",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00418_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_CREDIT_STATUS                                                 #
#                                                                        #
##########################################################################

%tio_01_00419_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOQ_RP_CREDIT"                => [   1,  23,   5, 0x000000000F800000, 0x00, 0, 0x0000000000000000, "LOQ reply queue credit counter" ],
   "LOQ_RQ_CREDIT"                => [   2,  18,   5, 0x00000000007C0000, 0x00, 0, 0x0000000000000000, "LOQ request queue credit counter" ],
   "RSVD1"                        => [   3,  10,   8, 0x000000000003FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RP_CREDIT"                => [   4,   6,   4, 0x00000000000003C0, 0x00, 0, 0x0000000000000000, "LIQ reply queue credit counter" ],
   "RSVD2"                        => [   5,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RQ_CREDIT"                => [   6,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "LIQ request queue credit counter" ],
);

%tio_01_00419_def =
( NAME    => "TIO_LB_CREDIT_STATUS",
  ADDRESS => 0x0000000090050000,
  NOTE    => "This register holds a shadow copy of the credit/debit counters in note the LB. These are dynamic copies that show the values in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00419_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_DEBUG_LOCAL_SEL                                               #
#                                                                        #
##########################################################################

%tio_01_00420_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Enable compare on bit 31 of Analyzer data" ],
   "FIELD_SELECT_7"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Field select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_7"               => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Group select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_6"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Field select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_6"               => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Group select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_5"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Field select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_5"               => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Group select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_4"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Field select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_4"               => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Group select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_3"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Field select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_3"               => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Group select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_2"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Field select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_2"               => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Group select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_1"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Field select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_1"               => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Group select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_0"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Field select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_0"               => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Group select" ],
);

%tio_01_00420_def =
( NAME    => "TIO_LB_DEBUG_LOCAL_SEL",
  ADDRESS => 0x0000000090050080,
  NOTE    => "The tio_lb_debug_local_sel is the top level debug mux for the LB note chiplet. The chiplet select fields selects one of eight in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00420_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_DEBUG_MUX0_SEL                                                #
#                                                                        #
##########################################################################

%tio_01_00421_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_7"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Field select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_7"               => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Group select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_6"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Field select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_6"               => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Group select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_5"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Field select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_5"               => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Group select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_4"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Field select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_4"               => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Group select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_3"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Field select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_3"               => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Group select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_2"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Field select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_2"               => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Group select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_1"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Field select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_1"               => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Group select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_0"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Field select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_0"               => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Group select" ],
);

%tio_01_00421_def =
( NAME    => "TIO_LB_DEBUG_MUX0_SEL",
  ADDRESS => 0x0000000090050100,
  NOTE    => "The tio_lb_debug_local_sel is the top level debug mux for the LB note chiplet. The chiplet select fields selects one of eight in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00421_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_DEBUG_MUX1_SEL                                                #
#                                                                        #
##########################################################################

%tio_01_00422_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_7"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Field select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_7"               => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Group select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_6"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Field select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_6"               => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Group select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_5"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Field select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_5"               => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Group select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_4"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Field select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_4"               => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Group select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_3"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Field select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_3"               => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Group select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_2"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Field select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_2"               => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Group select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_1"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Field select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_1"               => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Group select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_0"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Field select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_0"               => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Group select" ],
);

%tio_01_00422_def =
( NAME    => "TIO_LB_DEBUG_MUX1_SEL",
  ADDRESS => 0x0000000090050180,
  NOTE    => "The lb_debug_mux1_sel register controls the 2nd level debug mux for note the lb chiplet. The output of this debug mux is connect",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00422_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_DEBUG_COMPARE_SEL                                             #
#                                                                        #
##########################################################################

%tio_01_00423_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_7"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Field select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_7"               => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Group select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_6"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Field select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_6"               => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Group select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_5"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Field select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_5"               => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Group select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_4"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Field select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_4"               => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Group select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_3"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Field select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_3"               => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Group select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_2"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Field select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_2"               => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Group select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_1"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Field select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_1"               => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Group select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_0"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Field select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_0"               => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Group select" ],
);

%tio_01_00423_def =
( NAME    => "TIO_LB_DEBUG_COMPARE_SEL",
  ADDRESS => 0x0000000090050200,
  NOTE    => "The lb_debug_compare_sel register controls the compare mux in the note top level LB debug mux. The output of the compare mux is ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00423_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_ERROR_DETAIL_1                                                #
#                                                                        #
##########################################################################

%tio_01_00424_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "VALID" ],
   "RSVD0"                        => [   1,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ECHO"                         => [   2,  52,   9, 0x1FF0000000000000, 0x00, 0, 0x0000000000000000, "Echo Field" ],
   "RSVD1"                        => [   3,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_ERR"                     => [   4,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "DATA_ERR" ],
   "HDR_ERR"                      => [   5,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "HDR_ERR" ],
   "RSVD2"                        => [   6,  42,   6, 0x0000FC0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEST"                         => [   7,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Destination Chiplet Code" ],
   "SOURCE_CHIPLET_ID"            => [   8,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Chiplet Code" ],
   "SOURCE_NODE_ID"               => [   9,  24,  14, 0x0000003FFF000000, 0x00, 0, 0x0000000000000000, "Source Node Number" ],
   "SUPPL"                        => [  10,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Supplemental Field" ],
   "COMMAND"                      => [  11,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "SN2NET Message Code" ],
);

%tio_01_00424_def =
( NAME    => "TIO_LB_ERROR_DETAIL_1",
  ADDRESS => 0x0000000090050280,
  NOTE    => "The LB_ERROR_DETAIL_1 register provides storage for detail error note information for the first LB Hardware Error detected.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00424_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_ERROR_DETAIL_2                                                #
#                                                                        #
##########################################################################

%tio_01_00425_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   0,  49, 0x0001FFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "PHYSICAL_ADDRESS[49:3]" ],
);

%tio_01_00425_def =
( NAME    => "TIO_LB_ERROR_DETAIL_2",
  ADDRESS => 0x0000000090050300,
  NOTE    => "The LB_ERROR_DETAIL_2 register provides storage for detail error note information for the first LB Hardware Error detected.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00425_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_ERROR_DETAIL_3                                                #
#                                                                        #
##########################################################################

%tio_01_00426_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "DATA" ],
);

%tio_01_00426_def =
( NAME    => "TIO_LB_ERROR_DETAIL_3",
  ADDRESS => 0x0000000090050380,
  NOTE    => "The LB_ERROR_DETAIL_3 register provides storage for detail error note information for the first LB Hardware Error detected.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00426_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_ERROR_DETAIL_4                                                #
#                                                                        #
##########################################################################

%tio_01_00427_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ROUTE"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Vector Message Route" ],
);

%tio_01_00427_def =
( NAME    => "TIO_LB_ERROR_DETAIL_4",
  ADDRESS => 0x0000000090050400,
  NOTE    => "The LB_ERROR_DETAIL_4 register provides storage for detail error note information for the first LB Hardware Error detected.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00427_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_ERROR_MASK                                                    #
#                                                                        #
##########################################################################

%tio_01_00428_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY"                 => [   1,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Bad Reply from NCWRF Request Mask" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW"           => [   3,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Reply Credit Overflow Error Mask" ],
   "RQ_CREDIT_OVERFLOW"           => [   4,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Request Credit Overflow Error Mask" ],
   "UNEXP_VALID"                  => [   5,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "MMR Address Decode Error Mask" ],
   "RP_FIFO_ERROR"                => [   6,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "Reply Queue Overflow Error Mask" ],
   "RQ_FIFO_ERROR"                => [   7,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "Request Queue Overflow Error Mask" ],
   "GCLK_DROP"                    => [   8,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Dropped Global Clock Error Mask" ],
   "VECTOR_RP_ROUTE_ERROR"        => [   9,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Vector Reply Route Error Mask" ],
   "VECTOR_RQ_ROUTE_ERROR"        => [  10,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Vector Request Route Error Mask" ],
   "RSVD2"                        => [  11,  10,   5, 0x0000000000007C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RQ_TIME_OUT"                  => [  12,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Request Time-out Error Mask" ],
   "RQ_BAD_ADDR"                  => [  13,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Request Bad Address Error Mask" ],
   "RP_BAD_DATA"                  => [  14,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Reply Bad Data Error Mask" ],
   "RQ_BAD_DATA"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Request Bad Data Error Mask" ],
   "RP_LONG"                      => [  16,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Obese Reply Message Error Mask" ],
   "RQ_LONG"                      => [  17,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Obese Request Message Error Mask" ],
   "RP_SHORT"                     => [  18,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Runt Reply Message Error Mask" ],
   "RQ_SHORT"                     => [  19,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Runt Request Message Error Mask" ],
   "RP_BAD_CMD"                   => [  20,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Unsupported Reply Message Error Mask" ],
   "RQ_BAD_CMD"                   => [  21,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Unsupported Request Message Error Mask" ],
);

%tio_01_00428_def =
( NAME    => "TIO_LB_ERROR_MASK",
  ADDRESS => 0x0000000090050480,
  NOTE    => "The LB_ERROR_MASK register is the primary LB Hardware Error note configuration register. It contains a mask bit for each of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00428_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_ERROR_OVERFLOW                                                #
#                                                                        #
##########################################################################

%tio_01_00429_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY_OVRFL"           => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Bad Reply from NCWRF Request" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW_OVRFL"     => [   3,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error Overflow" ],
   "RQ_CREDIT_OVERFLOW_OVRFL"     => [   4,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error Overflow" ],
   "UNEXP_VALID_OVRFL"            => [   5,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error Overflow" ],
   "RP_FIFO_ERROR_OVRFL"          => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error Overflow" ],
   "RQ_FIFO_ERROR_OVRFL"          => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error Overflow" ],
   "GCLK_DROP_OVRFL"              => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error Overflow" ],
   "VECTOR_RP_ROUTE_ERROR_OVRFL"  => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error Overflow" ],
   "VECTOR_RQ_ROUTE_ERROR_OVRFL"  => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error Overflow" ],
   "RSVD2"                        => [  11,  10,   5, 0x0000000000007C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RQ_TIME_OUT_OVRFL"            => [  12,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error Overflow" ],
   "RQ_BAD_ADDR_OVRFL"            => [  13,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error Overflow" ],
   "RP_BAD_DATA_OVRFL"            => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error Overflow" ],
   "RQ_BAD_DATA_OVRFL"            => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error Overflow" ],
   "RP_LONG_OVRFL"                => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error Overflow" ],
   "RQ_LONG_OVRFL"                => [  17,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error Overflow" ],
   "RP_SHORT_OVRFL"               => [  18,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error Overflow" ],
   "RQ_SHORT_OVRFL"               => [  19,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error Overflow" ],
   "RP_BAD_CMD_OVRFL"             => [  20,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error Overflow" ],
   "RQ_BAD_CMD_OVRFL"             => [  21,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error Overflow" ],
);

%tio_01_00429_def =
( NAME    => "TIO_LB_ERROR_OVERFLOW",
  ADDRESS => 0x0000000090050500,
  NOTE    => "The LB_ERROR_OVERFLOW register contains 23 flags. Each flag note corresponds to 1 of the 23 hardware errors detected by the LB n",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00429_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_ERROR_OVERFLOW_ALIAS                                          #
#                                                                        #
##########################################################################

%tio_01_00430_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY_OVRFL"           => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Bad Reply from NCWRF Request" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW_OVRFL"     => [   3,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error Overflow" ],
   "RQ_CREDIT_OVERFLOW_OVRFL"     => [   4,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error Overflow" ],
   "UNEXP_VALID_OVRFL"            => [   5,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error Overflow" ],
   "RP_FIFO_ERROR_OVRFL"          => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error Overflow" ],
   "RQ_FIFO_ERROR_OVRFL"          => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error Overflow" ],
   "GCLK_DROP_OVRFL"              => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error Overflow" ],
   "VECTOR_RP_ROUTE_ERROR_OVRFL"  => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error Overflow" ],
   "VECTOR_RQ_ROUTE_ERROR_OVRFL"  => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error Overflow" ],
   "RSVD2"                        => [  11,  10,   5, 0x0000000000007C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RQ_TIME_OUT_OVRFL"            => [  12,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error Overflow" ],
   "RQ_BAD_ADDR_OVRFL"            => [  13,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error Overflow" ],
   "RP_BAD_DATA_OVRFL"            => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error Overflow" ],
   "RQ_BAD_DATA_OVRFL"            => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error Overflow" ],
   "RP_LONG_OVRFL"                => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error Overflow" ],
   "RQ_LONG_OVRFL"                => [  17,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error Overflow" ],
   "RP_SHORT_OVRFL"               => [  18,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error Overflow" ],
   "RQ_SHORT_OVRFL"               => [  19,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error Overflow" ],
   "RP_BAD_CMD_OVRFL"             => [  20,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error Overflow" ],
   "RQ_BAD_CMD_OVRFL"             => [  21,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error Overflow" ],
);

%tio_01_00430_def =
( NAME    => "TIO_LB_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000090050508,
  NOTE    => "The LB_ERROR_OVERFLOW_ALIAS address is an alias to the note LB_ERROR_OVERFLOW register. Refer to the LB_ERROR_OVERFLOW register ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00430_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_ERROR_SUMMARY                                                 #
#                                                                        #
##########################################################################

%tio_01_00431_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY"                 => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Bad Reply from NCWRF Request" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW"           => [   3,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error" ],
   "RQ_CREDIT_OVERFLOW"           => [   4,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error" ],
   "UNEXP_VALID"                  => [   5,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error" ],
   "RP_FIFO_ERROR"                => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error" ],
   "RQ_FIFO_ERROR"                => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error" ],
   "GCLK_DROP"                    => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error" ],
   "VECTOR_RP_ROUTE_ERROR"        => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error" ],
   "VECTOR_RQ_ROUTE_ERROR"        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error" ],
   "RSVD2"                        => [  11,  10,   5, 0x0000000000007C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RQ_TIME_OUT"                  => [  12,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error" ],
   "RQ_BAD_ADDR"                  => [  13,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error" ],
   "RP_BAD_DATA"                  => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error" ],
   "RQ_BAD_DATA"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error" ],
   "RP_LONG"                      => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error" ],
   "RQ_LONG"                      => [  17,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error" ],
   "RP_SHORT"                     => [  18,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error" ],
   "RQ_SHORT"                     => [  19,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error" ],
   "RP_BAD_CMD"                   => [  20,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error" ],
   "RQ_BAD_CMD"                   => [  21,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error" ],
);

%tio_01_00431_def =
( NAME    => "TIO_LB_ERROR_SUMMARY",
  ADDRESS => 0x0000000090050580,
  NOTE    => "The LB_ERROR_SUMMARY register is the LB's top-level error flag note register. It contains 23 flags. Each flag corresponds to one",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00431_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_ERROR_SUMMARY_ALIAS                                           #
#                                                                        #
##########################################################################

%tio_01_00432_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY"                 => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Bad Reply from NCWRF Request" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW"           => [   3,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error" ],
   "RQ_CREDIT_OVERFLOW"           => [   4,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error" ],
   "UNEXP_VALID"                  => [   5,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error" ],
   "RP_FIFO_ERROR"                => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error" ],
   "RQ_FIFO_ERROR"                => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error" ],
   "GCLK_DROP"                    => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error" ],
   "VECTOR_RP_ROUTE_ERROR"        => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error" ],
   "VECTOR_RQ_ROUTE_ERROR"        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error" ],
   "RSVD2"                        => [  11,  10,   5, 0x0000000000007C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RQ_TIME_OUT"                  => [  12,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error" ],
   "RQ_BAD_ADDR"                  => [  13,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error" ],
   "RP_BAD_DATA"                  => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error" ],
   "RQ_BAD_DATA"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error" ],
   "RP_LONG"                      => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error" ],
   "RQ_LONG"                      => [  17,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error" ],
   "RP_SHORT"                     => [  18,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error" ],
   "RQ_SHORT"                     => [  19,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error" ],
   "RP_BAD_CMD"                   => [  20,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error" ],
   "RQ_BAD_CMD"                   => [  21,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error" ],
);

%tio_01_00432_def =
( NAME    => "TIO_LB_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x0000000090050588,
  NOTE    => "The LB_ERROR_SUMMARY_ALIAS address is an alias to the note LB_ERROR_SUMMARY register. Refer to the LB_ERROR_SUMMARY register not",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00432_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_FIRST_ERROR                                                   #
#                                                                        #
##########################################################################

%tio_01_00433_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_BAD_REPLY"                 => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Bad Reply Error" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RP_CREDIT_OVERFLOW"           => [   3,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Reply Credit Overflow Error" ],
   "RQ_CREDIT_OVERFLOW"           => [   4,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Request Credit Overflow Error" ],
   "UNEXP_VALID"                  => [   5,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "MMR Address Decode Error" ],
   "RP_FIFO_ERROR"                => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reply Queue Overflow Error" ],
   "RQ_FIFO_ERROR"                => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Request Queue Overflow Error" ],
   "GCLK_DROP"                    => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Dropped Global Clock Error" ],
   "VECTOR_RP_ROUTE_ERROR"        => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Vector Reply Route Error" ],
   "VECTOR_RQ_ROUTE_ERROR"        => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Vector Request Route Error" ],
   "RSVD2"                        => [  11,  10,   5, 0x0000000000007C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RQ_TIME_OUT"                  => [  12,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Request Time-out Error" ],
   "RQ_BAD_ADDR"                  => [  13,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Request Bad Address Error" ],
   "RP_BAD_DATA"                  => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reply Bad Data Error" ],
   "RQ_BAD_DATA"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Request Bad Data Error" ],
   "RP_LONG"                      => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Obese Reply Message Error" ],
   "RQ_LONG"                      => [  17,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Obese Request Message Error" ],
   "RP_SHORT"                     => [  18,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Runt Reply Message Error" ],
   "RQ_SHORT"                     => [  19,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Runt Request Message Error" ],
   "RP_BAD_CMD"                   => [  20,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Unsupported Reply Message Error" ],
   "RQ_BAD_CMD"                   => [  21,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Unsupported Request Message Error" ],
);

%tio_01_00433_def =
( NAME    => "TIO_LB_FIRST_ERROR",
  ADDRESS => 0x0000000090050600,
  NOTE    => "The LB_FIRST_ERROR register contains 23 flags. Each flag note corresponds to one of the 23 flags in the LB_ERROR_SUMMARY note re",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00433_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_LAST_CREDIT                                                   #
#                                                                        #
##########################################################################

%tio_01_00434_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  28,  36, 0xFFFFFFFFF0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOQ_RP_CREDIT"                => [   1,  23,   5, 0x000000000F800000, 0x00, 0, 0x0000000000000000, "LOQ reply queue credit counter" ],
   "LOQ_RQ_CREDIT"                => [   2,  18,   5, 0x00000000007C0000, 0x00, 0, 0x0000000000000000, "LOQ request queue credit counter" ],
   "RSVD1"                        => [   3,  10,   8, 0x000000000003FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RP_CREDIT"                => [   4,   6,   4, 0x00000000000003C0, 0x00, 0, 0x0000000000000000, "LIQ reply queue credit counter" ],
   "RSVD2"                        => [   5,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LIQ_RQ_CREDIT"                => [   6,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "LIQ request queue credit counter" ],
);

%tio_01_00434_def =
( NAME    => "TIO_LB_LAST_CREDIT",
  ADDRESS => 0x0000000090050680,
  NOTE    => "This register holds the value of the credit/debit counter in the LB note before the last reset occurred. The leading edge of res",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00434_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_COMPARE_COMPARE                                               #
#                                                                        #
##########################################################################

%tio_01_00435_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Mask to select Debug bits for trigger generation" ],
);

%tio_01_00435_def =
( NAME    => "TIO_LB_COMPARE_COMPARE",
  ADDRESS => 0x0000000090050780,
  NOTE    => "The tio_lb_compare_compare register contains a bit mask enable for note the debug compare function. For each bit that is set in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00435_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_TRIGGER_DATA                                                  #
#                                                                        #
##########################################################################

%tio_01_00436_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_PATTERN"              => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "debug bit pattern for trigger generation" ],
);

%tio_01_00436_def =
( NAME    => "TIO_LB_TRIGGER_DATA",
  ADDRESS => 0x0000000090050800,
  NOTE    => "The tio_lb_trigger_data register contains the compare data for the note LB trigger compare function. This data is compared again",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00436_flds
);


##########################################################################
#                                                                        #
#   TIO_AUTO_REPLY_ENABLE0                                               #
#                                                                        #
##########################################################################

%tio_01_00437_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Enable 0" ],
);

%tio_01_00437_def =
( NAME    => "TIO_AUTO_REPLY_ENABLE0",
  ADDRESS => 0x0000000090062000,
  NOTE    => "Automatic Maintenance Reply Enable 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00437_flds
);


##########################################################################
#                                                                        #
#   TIO_AUTO_REPLY_ENABLE1                                               #
#                                                                        #
##########################################################################

%tio_01_00438_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE1"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Enable 1" ],
);

%tio_01_00438_def =
( NAME    => "TIO_AUTO_REPLY_ENABLE1",
  ADDRESS => 0x0000000090062080,
  NOTE    => "Automatic Maintenance Reply Enable 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00438_flds
);


##########################################################################
#                                                                        #
#   TIO_AUTO_REPLY_HEADER0                                               #
#                                                                        #
##########################################################################

%tio_01_00439_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Header 0" ],
);

%tio_01_00439_def =
( NAME    => "TIO_AUTO_REPLY_HEADER0",
  ADDRESS => 0x0000000090062100,
  NOTE    => "Automatic Maintenance Reply Header 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00439_flds
);


##########################################################################
#                                                                        #
#   TIO_AUTO_REPLY_HEADER1                                               #
#                                                                        #
##########################################################################

%tio_01_00440_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER1"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Header 1" ],
);

%tio_01_00440_def =
( NAME    => "TIO_AUTO_REPLY_HEADER1",
  ADDRESS => 0x0000000090062180,
  NOTE    => "Automatic Maintenance Reply Header 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00440_flds
);


##########################################################################
#                                                                        #
#   TIO_ENABLE_RP_AUTO_REPLY                                             #
#                                                                        #
##########################################################################

%tio_01_00441_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Reply Auto Reply" ],
);

%tio_01_00441_def =
( NAME    => "TIO_ENABLE_RP_AUTO_REPLY",
  ADDRESS => 0x0000000090062200,
  NOTE    => "Enable Automatic Maintenance Reply From Reply Queue",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00441_flds
);


##########################################################################
#                                                                        #
#   TIO_ENABLE_RQ_AUTO_REPLY                                             #
#                                                                        #
##########################################################################

%tio_01_00442_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Request Auto Reply" ],
);

%tio_01_00442_def =
( NAME    => "TIO_ENABLE_RQ_AUTO_REPLY",
  ADDRESS => 0x0000000090062280,
  NOTE    => "Enable Automatic Maintenance Reply From Request Queue",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00442_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_CNTRL                                                   #
#                                                                        #
##########################################################################

%tio_01_00443_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BUSY"                         => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Busy" ],
   "START"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Start" ],
   "RSVD0"                        => [   2,  16,  46, 0x3FFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SUPPRESS_HEADER_ENABLE"       => [   3,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Enable suppressing the header field" ],
   "EXTRA_HEADER_FLAG_ENABLE"     => [   4,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Enable extra header flag" ],
   "PORT"                         => [   5,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "0 = request port, 1 = reply port" ],
   "ERROR_INJECT_ENABLE"          => [   6,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Enable ERROR_INJECT_POINT field" ],
   "ERROR_INJECT_POINT"           => [   7,   6,   6, 0x0000000000000FC0, 0x00, 0, 0x0000000000000000, "Point message that the error bit would be activated" ],
   "MSG_LENGTH"                   => [   8,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "Message data payload length, 0 - 63" ],
);

%tio_01_00443_def =
( NAME    => "TIO_DIAG_MSG_CNTRL",
  ADDRESS => 0x0000000090063000,
  NOTE    => "The diag_msg_cntrl register controls the launching of a diagnostic note message onto the SN2 network. The length of the message,",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00443_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA0L                                                  #
#                                                                        #
##########################################################################

%tio_01_00444_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%tio_01_00444_def =
( NAME    => "TIO_DIAG_MSG_DATA0L",
  ADDRESS => 0x0000000090063080,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00444_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA0U                                                  #
#                                                                        #
##########################################################################

%tio_01_00445_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%tio_01_00445_def =
( NAME    => "TIO_DIAG_MSG_DATA0U",
  ADDRESS => 0x0000000090063100,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00445_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA1L                                                  #
#                                                                        #
##########################################################################

%tio_01_00446_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%tio_01_00446_def =
( NAME    => "TIO_DIAG_MSG_DATA1L",
  ADDRESS => 0x0000000090063180,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00446_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA1U                                                  #
#                                                                        #
##########################################################################

%tio_01_00447_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%tio_01_00447_def =
( NAME    => "TIO_DIAG_MSG_DATA1U",
  ADDRESS => 0x0000000090063200,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00447_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA2L                                                  #
#                                                                        #
##########################################################################

%tio_01_00448_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%tio_01_00448_def =
( NAME    => "TIO_DIAG_MSG_DATA2L",
  ADDRESS => 0x0000000090063280,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00448_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA2U                                                  #
#                                                                        #
##########################################################################

%tio_01_00449_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%tio_01_00449_def =
( NAME    => "TIO_DIAG_MSG_DATA2U",
  ADDRESS => 0x0000000090063300,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00449_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA3L                                                  #
#                                                                        #
##########################################################################

%tio_01_00450_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%tio_01_00450_def =
( NAME    => "TIO_DIAG_MSG_DATA3L",
  ADDRESS => 0x0000000090063380,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00450_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA3U                                                  #
#                                                                        #
##########################################################################

%tio_01_00451_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%tio_01_00451_def =
( NAME    => "TIO_DIAG_MSG_DATA3U",
  ADDRESS => 0x0000000090063400,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00451_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA4L                                                  #
#                                                                        #
##########################################################################

%tio_01_00452_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%tio_01_00452_def =
( NAME    => "TIO_DIAG_MSG_DATA4L",
  ADDRESS => 0x0000000090063480,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00452_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA4U                                                  #
#                                                                        #
##########################################################################

%tio_01_00453_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%tio_01_00453_def =
( NAME    => "TIO_DIAG_MSG_DATA4U",
  ADDRESS => 0x0000000090063500,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00453_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA5L                                                  #
#                                                                        #
##########################################################################

%tio_01_00454_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%tio_01_00454_def =
( NAME    => "TIO_DIAG_MSG_DATA5L",
  ADDRESS => 0x0000000090063580,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00454_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA5U                                                  #
#                                                                        #
##########################################################################

%tio_01_00455_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%tio_01_00455_def =
( NAME    => "TIO_DIAG_MSG_DATA5U",
  ADDRESS => 0x0000000090063600,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00455_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA6L                                                  #
#                                                                        #
##########################################################################

%tio_01_00456_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%tio_01_00456_def =
( NAME    => "TIO_DIAG_MSG_DATA6L",
  ADDRESS => 0x0000000090063680,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00456_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA6U                                                  #
#                                                                        #
##########################################################################

%tio_01_00457_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%tio_01_00457_def =
( NAME    => "TIO_DIAG_MSG_DATA6U",
  ADDRESS => 0x0000000090063700,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00457_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA7L                                                  #
#                                                                        #
##########################################################################

%tio_01_00458_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%tio_01_00458_def =
( NAME    => "TIO_DIAG_MSG_DATA7L",
  ADDRESS => 0x0000000090063780,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00458_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA7U                                                  #
#                                                                        #
##########################################################################

%tio_01_00459_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%tio_01_00459_def =
( NAME    => "TIO_DIAG_MSG_DATA7U",
  ADDRESS => 0x0000000090063800,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00459_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA8L                                                  #
#                                                                        #
##########################################################################

%tio_01_00460_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_LOWER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Data" ],
);

%tio_01_00460_def =
( NAME    => "TIO_DIAG_MSG_DATA8L",
  ADDRESS => 0x0000000090063880,
  NOTE    => "Diagnostic Data, lower 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00460_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_DATA8U                                                  #
#                                                                        #
##########################################################################

%tio_01_00461_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA_UPPER"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Data" ],
);

%tio_01_00461_def =
( NAME    => "TIO_DIAG_MSG_DATA8U",
  ADDRESS => 0x0000000090063900,
  NOTE    => "Diagnostice Data, upper 64 bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00461_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_HDR0                                                    #
#                                                                        #
##########################################################################

%tio_01_00462_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER0"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower 64 bits of Diagnositic Message Header" ],
);

%tio_01_00462_def =
( NAME    => "TIO_DIAG_MSG_HDR0",
  ADDRESS => 0x0000000090063980,
  NOTE    => "Diagnostice Data, lower 64 bits of header",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00462_flds
);


##########################################################################
#                                                                        #
#   TIO_DIAG_MSG_HDR1                                                    #
#                                                                        #
##########################################################################

%tio_01_00463_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER1"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Upper 64 bits of Diagnositic Message Header" ],
);

%tio_01_00463_def =
( NAME    => "TIO_DIAG_MSG_HDR1",
  ADDRESS => 0x0000000090063a00,
  NOTE    => "Diagnostice Data, upper 64 bits of header",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00463_flds
);


##########################################################################
#                                                                        #
#   TIO_DEBUG_SELECT                                                     #
#                                                                        #
##########################################################################

%tio_01_00464_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMPARE_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Enable compare on bit 31 of Analyzer data" ],
   "RSVD0"                        => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEL_AEGIS"                    => [   2,  51,   9, 0x0FF8000000000000, 0x00, 0, 0x0000000000000000, "Select AEGIS to debug port" ],
   "RSVD1"                        => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_7"               => [   4,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Group select 7" ],
   "FIELD_SELECT_7"               => [   5,  42,   3, 0x00001C0000000000, 0x00, 0, 0x0000000000000000, "Field select 7" ],
   "GROUP_SELECT_6"               => [   6,  39,   3, 0x0000038000000000, 0x00, 0, 0x0000000000000000, "Group select 6" ],
   "FIELD_SELECT_6"               => [   7,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Field select 6" ],
   "GROUP_SELECT_5"               => [   8,  33,   3, 0x0000000E00000000, 0x00, 0, 0x0000000000000000, "Group select 5" ],
   "FIELD_SELECT_5"               => [   9,  30,   3, 0x00000001C0000000, 0x00, 0, 0x0000000000000000, "Field select 5" ],
   "GROUP_SELECT_4"               => [  10,  27,   3, 0x0000000038000000, 0x00, 0, 0x0000000000000000, "Group select 4" ],
   "FIELD_SELECT_4"               => [  11,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Field select 4" ],
   "GROUP_SELECT_3"               => [  12,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Group select 3" ],
   "FIELD_SELECT_3"               => [  13,  18,   3, 0x00000000001C0000, 0x00, 0, 0x0000000000000000, "Field select 3" ],
   "GROUP_SELECT_2"               => [  14,  15,   3, 0x0000000000038000, 0x00, 0, 0x0000000000000000, "Group select 2" ],
   "FIELD_SELECT_2"               => [  15,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Field select 2" ],
   "GROUP_SELECT_1"               => [  16,   9,   3, 0x0000000000000E00, 0x00, 0, 0x0000000000000000, "Group select 1" ],
   "FIELD_SELECT_1"               => [  17,   6,   3, 0x00000000000001C0, 0x00, 0, 0x0000000000000000, "Field selecct 1" ],
   "GROUP_SELECT_0"               => [  18,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Group select 0" ],
   "FIELD_SELECT_0"               => [  19,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Field select 0" ],
);

%tio_01_00464_def =
( NAME    => "TIO_DEBUG_SELECT",
  ADDRESS => 0x0000000090064000,
  NOTE    => "The tio_debug_select register controls the top level debug mux for note the TIO debug data. The group_select fields selects one ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00464_flds
);


##########################################################################
#                                                                        #
#   TIO_COMPARE_COMPARE_MASK                                             #
#                                                                        #
##########################################################################

%tio_01_00465_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "TIO Debug Compare Mask" ],
);

%tio_01_00465_def =
( NAME    => "TIO_COMPARE_COMPARE_MASK",
  ADDRESS => 0x0000000090064080,
  NOTE    => "TIO Debug Compare Mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00465_flds
);


##########################################################################
#                                                                        #
#   TIO_COMPARE_COMPARE_PATTERN                                          #
#                                                                        #
##########################################################################

%tio_01_00466_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "TIO Trigger Compare Pattern" ],
);

%tio_01_00466_def =
( NAME    => "TIO_COMPARE_COMPARE_PATTERN",
  ADDRESS => 0x0000000090064100,
  NOTE    => "TIO Debug Compare Pattern",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00466_flds
);


##########################################################################
#                                                                        #
#   TIO_COMPARE_SEL                                                      #
#                                                                        #
##########################################################################

%tio_01_00467_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_7"               => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_7"               => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_6"               => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_6"               => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_5"               => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_5"               => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_4"               => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_4"               => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_3"               => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_3"               => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_2"               => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_2"               => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_1"               => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_1"               => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIELD_SELECT_0"               => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GROUP_SELECT_0"               => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%tio_01_00467_def =
( NAME    => "TIO_COMPARE_SEL",
  ADDRESS => 0x0000000090064180,
  NOTE    => "The tio_compare_sel register controls the compare mux in the top note level TIO debug mux. The output of the compare mux is comp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00467_flds
);


##########################################################################
#                                                                        #
#   TIO_OB_LA_CONTROL                                                    #
#                                                                        #
##########################################################################

%tio_01_00468_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RESET"                        => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Reset Logic Analyzer Buffer" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   3,  16,  14, 0x000000003FFF0000, 0x00, 1, 0x0000000000000000, "Node ID" ],
   "RSVD2"                        => [   4,   4,  12, 0x000000000000FFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRAP_MEM"                     => [   5,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Memory wrap control" ],
   "WRAP_BUFF"                    => [   6,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Buffer wrap control" ],
   "WRITE_MEM"                    => [   7,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Write memory control" ],
   "WRITE_BUFF"                   => [   8,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Write buffer control" ],
);

%tio_01_00468_def =
( NAME    => "TIO_OB_LA_CONTROL",
  ADDRESS => 0x0000000090064200,
  NOTE    => "The OB_LA_CONTROL register controls writing to the on board logic note analyzer buffer and writting that buffer to memory.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00468_flds
);


##########################################################################
#                                                                        #
#   TIO_OB_LA_START_CONTROL                                              #
#                                                                        #
##########################################################################

%tio_01_00469_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  10,  54, 0xFFFFFFFFFFFFFC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WORD_MODE"                    => [   1,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "Word mode select" ],
   "TRIGGER"                      => [   2,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Start control trigger select" ],
   "SOURCE"                       => [   3,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Start control source select" ],
   "POLARITY"                     => [   4,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Polarity of start stimulus" ],
   "RSVD1"                        => [   5,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELECT"                       => [   6,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Start control select bits" ],
);

%tio_01_00469_def =
( NAME    => "TIO_OB_LA_START_CONTROL",
  ADDRESS => 0x0000000090064280,
  NOTE    => "The OB_LA_START_CONTROL register controls starting recording of the note on board logic analzyer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00469_flds
);


##########################################################################
#                                                                        #
#   TIO_OB_LA_STOP_CONTROL                                               #
#                                                                        #
##########################################################################

%tio_01_00470_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER"                      => [   1,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Stop control trigger select" ],
   "SOURCE"                       => [   2,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Stop control source select" ],
   "POLARITY"                     => [   3,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Polarity of stop stimulus" ],
   "RSVD1"                        => [   4,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SELECT"                       => [   5,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Stop control select bits" ],
);

%tio_01_00470_def =
( NAME    => "TIO_OB_LA_STOP_CONTROL",
  ADDRESS => 0x0000000090064300,
  NOTE    => "The OB_LA_STOP_CONTROL register controls stopping recording of the note on board logic analzyer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00470_flds
);


##########################################################################
#                                                                        #
#   TIO_OB_LA_START_ADDRESS                                              #
#                                                                        #
##########################################################################

%tio_01_00471_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   7,  31, 0x0000003FFFFFFF80, 0x00, 1, 0x0000000000000000, "Starting address bits 7 - 37" ],
);

%tio_01_00471_def =
( NAME    => "TIO_OB_LA_START_ADDRESS",
  ADDRESS => 0x0000000090064380,
  NOTE    => "The OB_LA_START_ADDRESS register contains the starting address for note storing the on board logic analyzer data in memory. This",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00471_flds
);


##########################################################################
#                                                                        #
#   TIO_OB_LA_END_ADDRESS                                                #
#                                                                        #
##########################################################################

%tio_01_00472_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   7,  31, 0x0000003FFFFFFF80, 0x00, 1, 0x0000000000000000, "Ending address bits 7 - 37" ],
);

%tio_01_00472_def =
( NAME    => "TIO_OB_LA_END_ADDRESS",
  ADDRESS => 0x0000000090064400,
  NOTE    => "The OB_LA_END_ADDRESS register contains the ending address for note storing the on board logic analyzer data in memory. This is ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00472_flds
);


##########################################################################
#                                                                        #
#   TIO_STOP_CLK_CONTROL                                                 #
#                                                                        #
##########################################################################

%tio_01_00473_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "Clock stop enable (0-disabled, 1-enabled)" ],
   "MODE"                         => [   2,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Clock stop mode select (0-external, 1-internal)" ],
   "POLARITY"                     => [   3,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Clock stop polarity select (0-negative edge, 1-positive edge)" ],
   "EVENT"                        => [   4,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "Clock stop format select (1-level, 0-edge)" ],
   "STIMULUS"                     => [   5,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Clock stop stimulus" ],
);

%tio_01_00473_def =
( NAME    => "TIO_STOP_CLK_CONTROL",
  ADDRESS => 0x0000000090065000,
  NOTE    => "Stop Clock Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00473_flds
);


##########################################################################
#                                                                        #
#   TIO_STOP_CLK_DELAY_PHASE                                             #
#                                                                        #
##########################################################################

%tio_01_00474_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DELAY"                        => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Delay phase" ],
);

%tio_01_00474_def =
( NAME    => "TIO_STOP_CLK_DELAY_PHASE",
  ADDRESS => 0x0000000090065080,
  NOTE    => "Stop Clock Delay Phase",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00474_flds
);


##########################################################################
#                                                                        #
#   TIO_TSF_ARM_MASK                                                     #
#                                                                        #
##########################################################################

%tio_01_00475_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility arm mask" ],
);

%tio_01_00475_def =
( NAME    => "TIO_TSF_ARM_MASK",
  ADDRESS => 0x0000000090066000,
  NOTE    => "Trigger sequencing facility arm mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00475_flds
);


##########################################################################
#                                                                        #
#   TIO_TSF_COUNTER_PRESETS                                              #
#                                                                        #
##########################################################################

%tio_01_00476_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COUNT_8A"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8a" ],
   "COUNT_8B"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8b" ],
   "COUNT_16"                     => [   2,  32,  16, 0x0000FFFF00000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 16" ],
   "COUNT_32"                     => [   3,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 32" ],
);

%tio_01_00476_def =
( NAME    => "TIO_TSF_COUNTER_PRESETS",
  ADDRESS => 0x0000000090066080,
  NOTE    => "The tio_tsf_counter_presets register contains the initial values note for the trigger sequencing facility down counters.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00476_flds
);


##########################################################################
#                                                                        #
#   TIO_TSF_DECREMENT_CTL                                                #
#                                                                        #
##########################################################################

%tio_01_00477_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CTL"                          => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter decrement control" ],
);

%tio_01_00477_def =
( NAME    => "TIO_TSF_DECREMENT_CTL",
  ADDRESS => 0x0000000090066100,
  NOTE    => "Trigger sequencing facility counter decrement control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00477_flds
);


##########################################################################
#                                                                        #
#   TIO_TSF_DIAG_MSG_CTL                                                 #
#                                                                        #
##########################################################################

%tio_01_00478_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE"                       => [   1,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Trigger sequencing facility diagnostic message control" ],
);

%tio_01_00478_def =
( NAME    => "TIO_TSF_DIAG_MSG_CTL",
  ADDRESS => 0x0000000090066180,
  NOTE    => "Trigger sequencing facility diagnostic message control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00478_flds
);


##########################################################################
#                                                                        #
#   TIO_TSF_DISARM_MASK                                                  #
#                                                                        #
##########################################################################

%tio_01_00479_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility disarm mask" ],
);

%tio_01_00479_def =
( NAME    => "TIO_TSF_DISARM_MASK",
  ADDRESS => 0x0000000090066200,
  NOTE    => "Trigger sequencing facility disarm mask",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00479_flds
);


##########################################################################
#                                                                        #
#   TIO_TSF_ENABLE_CTL                                                   #
#                                                                        #
##########################################################################

%tio_01_00480_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CTL"                          => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter enable control" ],
);

%tio_01_00480_def =
( NAME    => "TIO_TSF_ENABLE_CTL",
  ADDRESS => 0x0000000090066280,
  NOTE    => "Trigger sequencing facility counter enable control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00480_flds
);


##########################################################################
#                                                                        #
#   TIO_TSF_SOFTWARE_ARM                                                 #
#                                                                        #
##########################################################################

%tio_01_00481_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT7"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 7" ],
   "BIT6"                         => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 6" ],
   "BIT5"                         => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 5" ],
   "BIT4"                         => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 4" ],
   "BIT3"                         => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 3" ],
   "BIT2"                         => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 2" ],
   "BIT1"                         => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 1" ],
   "BIT0"                         => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software arm bit 0" ],
);

%tio_01_00481_def =
( NAME    => "TIO_TSF_SOFTWARE_ARM",
  ADDRESS => 0x0000000090066300,
  NOTE    => "The tio_tsf_software_arm register provides software with a means to note arm any of the trigger sequencing variables. Writing a ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00481_flds
);


##########################################################################
#                                                                        #
#   TIO_TSF_SOFTWARE_DISARM                                              #
#                                                                        #
##########################################################################

%tio_01_00482_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT7"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 7" ],
   "BIT6"                         => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 6" ],
   "BIT5"                         => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 5" ],
   "BIT4"                         => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 4" ],
   "BIT3"                         => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 3" ],
   "BIT2"                         => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 2" ],
   "BIT1"                         => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 1" ],
   "BIT0"                         => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software disarm bit 0" ],
);

%tio_01_00482_def =
( NAME    => "TIO_TSF_SOFTWARE_DISARM",
  ADDRESS => 0x0000000090066380,
  NOTE    => "The tio_tsf_software_disarm register provides software with a means note to disarm any of the trigger sequencing variables. Writ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00482_flds
);


##########################################################################
#                                                                        #
#   TIO_TSF_SOFTWARE_TRIGGERED                                           #
#                                                                        #
##########################################################################

%tio_01_00483_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BIT7"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 7" ],
   "BIT6"                         => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 6" ],
   "BIT5"                         => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 5" ],
   "BIT4"                         => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 4" ],
   "BIT3"                         => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 3" ],
   "BIT2"                         => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 2" ],
   "BIT1"                         => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 1" ],
   "BIT0"                         => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility software triggered bit 0" ],
);

%tio_01_00483_def =
( NAME    => "TIO_TSF_SOFTWARE_TRIGGERED",
  ADDRESS => 0x0000000090066400,
  NOTE    => "The tio_tsf_software_triggered register provides software with a note means to trigger any of the trigger sequencing variables. ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00483_flds
);


##########################################################################
#                                                                        #
#   TIO_TSF_TRIGGER_MASK                                                 #
#                                                                        #
##########################################################################

%tio_01_00484_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility trigger mask" ],
);

%tio_01_00484_def =
( NAME    => "TIO_TSF_TRIGGER_MASK",
  ADDRESS => 0x0000000090066480,
  NOTE    => "The tio_tsf_trigger_mask is used to enable an auxiliary trigger note compare to trigger a particular trigger sequencing variable",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00484_flds
);


##########################################################################
#                                                                        #
#   TIO_VEC_DATA                                                         #
#                                                                        #
##########################################################################

%tio_01_00485_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%tio_01_00485_def =
( NAME    => "TIO_VEC_DATA",
  ADDRESS => 0x0000000090067000,
  NOTE    => "The VEC_DATA register contains the value used for the data payload note when the TIO generates a Vector Write Request (VWR) mess",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00485_flds
);


##########################################################################
#                                                                        #
#   TIO_VEC_PARMS                                                        #
#                                                                        #
##########################################################################

%tio_01_00486_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BUSY"                         => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Busy" ],
   "START"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "Start" ],
   "RSVD0"                        => [   2,  46,  16, 0x3FFFC00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_ID"                       => [   3,  35,  11, 0x00003FF800000000, 0x00, 0, 0x0000000000000000, "PIO ID" ],
   "ADDRESS"                      => [   4,   3,  32, 0x00000007FFFFFFF8, 0x00, 0, 0x0000000000000000, "Address[34:3]" ],
   "RSVD1"                        => [   5,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_PORT"                      => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Network Interface Port Select" ],
   "TYPE"                         => [   7,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Vector Request Message Type" ],
);

%tio_01_00486_def =
( NAME    => "TIO_VEC_PARMS",
  ADDRESS => 0x0000000090067080,
  NOTE    => "The VEC_PARMS register controls various parameters associated with note the TIO's generation of Vector Request messages (i.e., e",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00486_flds
);


##########################################################################
#                                                                        #
#   TIO_VEC_ROUTE                                                        #
#                                                                        #
##########################################################################

%tio_01_00487_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ROUTE"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Route" ],
);

%tio_01_00487_def =
( NAME    => "TIO_VEC_ROUTE",
  ADDRESS => 0x0000000090067100,
  NOTE    => "The VEC_ROUTE register contains the routing information for TIO note generated Vector Read Request (VRD) or Vector Write Request",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00487_flds
);


##########################################################################
#                                                                        #
#   TIO_CPU_PERM0                                                        #
#                                                                        #
##########################################################################

%tio_01_00488_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 0 - 63" ],
);

%tio_01_00488_def =
( NAME    => "TIO_CPU_PERM0",
  ADDRESS => 0x0000000090060000,
  NOTE    => "CPU MMR Access Permission Bits 63 - 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00488_flds
);


##########################################################################
#                                                                        #
#   TIO_CPU_PERM1                                                        #
#                                                                        #
##########################################################################

%tio_01_00489_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 64 - 127" ],
);

%tio_01_00489_def =
( NAME    => "TIO_CPU_PERM1",
  ADDRESS => 0x0000000090060080,
  NOTE    => "CPU MMR Access Permission Bits 64 - 127",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00489_flds
);


##########################################################################
#                                                                        #
#   TIO_CPU_PERM2                                                        #
#                                                                        #
##########################################################################

%tio_01_00490_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 128 - 191" ],
);

%tio_01_00490_def =
( NAME    => "TIO_CPU_PERM2",
  ADDRESS => 0x0000000090060100,
  NOTE    => "CPU MMR Access Permission Bits 128 - 191",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00490_flds
);


##########################################################################
#                                                                        #
#   TIO_CPU_PERM3                                                        #
#                                                                        #
##########################################################################

%tio_01_00491_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 192 - 255" ],
);

%tio_01_00491_def =
( NAME    => "TIO_CPU_PERM3",
  ADDRESS => 0x0000000090060180,
  NOTE    => "CPU MMR Access Permission Bits 192 - 255",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00491_flds
);


##########################################################################
#                                                                        #
#   TIO_CPU_PERM_OVR                                                     #
#                                                                        #
##########################################################################

%tio_01_00492_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "OVERRIDE"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Override" ],
);

%tio_01_00492_def =
( NAME    => "TIO_CPU_PERM_OVR",
  ADDRESS => 0x0000000090060200,
  NOTE    => "CPU MMR Access Permission Override",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00492_flds
);


##########################################################################
#                                                                        #
#   TIO_EXT_IO_PERM0                                                     #
#                                                                        #
##########################################################################

%tio_01_00493_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 0 - 63" ],
);

%tio_01_00493_def =
( NAME    => "TIO_EXT_IO_PERM0",
  ADDRESS => 0x0000000090060280,
  NOTE    => "External IO MMR Access Permission Bits 0 - 63",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00493_flds
);


##########################################################################
#                                                                        #
#   TIO_EXT_IO_PERM1                                                     #
#                                                                        #
##########################################################################

%tio_01_00494_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 64 - 127" ],
);

%tio_01_00494_def =
( NAME    => "TIO_EXT_IO_PERM1",
  ADDRESS => 0x0000000090060300,
  NOTE    => "External IO MMR Access Permission Bits 64 - 127",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00494_flds
);


##########################################################################
#                                                                        #
#   TIO_EXT_IO_PERM2                                                     #
#                                                                        #
##########################################################################

%tio_01_00495_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 128 - 191" ],
);

%tio_01_00495_def =
( NAME    => "TIO_EXT_IO_PERM2",
  ADDRESS => 0x0000000090060380,
  NOTE    => "External IO MMR Access Permission Bits 128 - 191",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00495_flds
);


##########################################################################
#                                                                        #
#   TIO_EXT_IO_PERM3                                                     #
#                                                                        #
##########################################################################

%tio_01_00496_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 192 - 255" ],
);

%tio_01_00496_def =
( NAME    => "TIO_EXT_IO_PERM3",
  ADDRESS => 0x0000000090060400,
  NOTE    => "External IO MMR Access Permission Bits 192 - 255",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00496_flds
);


##########################################################################
#                                                                        #
#   TIO_CHIPLET_ID_CONFIG                                                #
#                                                                        #
##########################################################################

%tio_01_00497_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  12,  52, 0xFFFFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EXT_IO_ID"                    => [   1,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Valid chiplet IDs from external IO nodes" ],
   "RSVD1"                        => [   2,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CPU_ID"                       => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Valid chiplet IDs from processor nodes" ],
);

%tio_01_00497_def =
( NAME    => "TIO_CHIPLET_ID_CONFIG",
  ADDRESS => 0x0000000090060480,
  NOTE    => "Chiplet ID Permission Configuration",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00497_flds
);


##########################################################################
#                                                                        #
#   TIO_GC_FIL_CTRL                                                      #
#                                                                        #
##########################################################################

%tio_01_00498_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  58,   6, 0xFC00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_COUNTER"                => [   1,  48,  10, 0x03FF000000000000, 0x00, 1, 0x0000000000000000, "Error counter" ],
   "RSVD1"                        => [   2,  46,   2, 0x0000C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DROPOUT_THRESH"               => [   3,  36,  10, 0x00003FF000000000, 0x00, 1, 0x0000000000000000, "Dropout threshold" ],
   "RSVD2"                        => [   4,  34,   2, 0x0000000C00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DROPOUT_COUNTER"              => [   5,  24,  10, 0x00000003FF000000, 0x00, 1, 0x0000000000000000, "Dropout Counter" ],
   "RSVD3"                        => [   6,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK_ENABLE"                  => [   7,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Mask Enable" ],
   "MASK_COUNTER"                 => [   8,   8,  12, 0x00000000000FFF00, 0x00, 1, 0x0000000000000000, "Mask Counter" ],
   "RSVD4"                        => [   9,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OFFSET"                       => [  10,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Offset" ],
);

%tio_01_00498_def =
( NAME    => "TIO_GC_FIL_CTRL",
  ADDRESS => 0x0000000090060680,
  NOTE    => "TIO Global Clock Filter Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00498_flds
);


##########################################################################
#                                                                        #
#   TIO_GC_SRC_CTRL                                                      #
#                                                                        #
##########################################################################

%tio_01_00499_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  34,  30, 0xFFFFFFFC00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SOURCE_SEL"                   => [   1,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "Source select (0=ext., 1=Int., 2=TIO)" ],
   "RSVD1"                        => [   2,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOGGLE_BIT"                   => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "Toggle bit" ],
   "RSVD2"                        => [   4,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNTER"                      => [   5,  16,  10, 0x0000000003FF0000, 0x00, 1, 0x0000000000000000, "Counter" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_COUNT"                    => [   7,   4,  10, 0x0000000000003FF0, 0x00, 1, 0x0000000000000000, "Max Count" ],
   "RSVD4"                        => [   8,   1,   3, 0x000000000000000E, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_COUNTER"               => [   9,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable Counter" ],
);

%tio_01_00499_def =
( NAME    => "TIO_GC_SRC_CTRL",
  ADDRESS => 0x0000000090060700,
  NOTE    => "TIO Global Clock Control",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00499_flds
);


##########################################################################
#                                                                        #
#   TIO_HARD_RESET                                                       #
#                                                                        #
##########################################################################

%tio_01_00500_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "HARD_RESET"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Hard Reset" ],
);

%tio_01_00500_def =
( NAME    => "TIO_HARD_RESET",
  ADDRESS => 0x0000000090060780,
  NOTE    => "TIO Hard Reset",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00500_flds
);


##########################################################################
#                                                                        #
#   TIO_CPU_ACCESS0                                                      #
#                                                                        #
##########################################################################

%tio_01_00501_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 0 - 63" ],
);

%tio_01_00501_def =
( NAME    => "TIO_CPU_ACCESS0",
  ADDRESS => 0x0000000090060800,
  NOTE    => "CPU Interrupt Access Permission Bits 63 - 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00501_flds
);


##########################################################################
#                                                                        #
#   TIO_CPU_ACCESS1                                                      #
#                                                                        #
##########################################################################

%tio_01_00502_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 64 - 127" ],
);

%tio_01_00502_def =
( NAME    => "TIO_CPU_ACCESS1",
  ADDRESS => 0x0000000090060880,
  NOTE    => "CPU Interrupt Access Permission Bits 127 - 64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00502_flds
);


##########################################################################
#                                                                        #
#   TIO_CPU_ACCESS2                                                      #
#                                                                        #
##########################################################################

%tio_01_00503_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 128 - 191" ],
);

%tio_01_00503_def =
( NAME    => "TIO_CPU_ACCESS2",
  ADDRESS => 0x0000000090060900,
  NOTE    => "CPU Interrupt Access Permission Bits 191 - 128",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00503_flds
);


##########################################################################
#                                                                        #
#   TIO_CPU_ACCESS3                                                      #
#                                                                        #
##########################################################################

%tio_01_00504_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 192 - 255" ],
);

%tio_01_00504_def =
( NAME    => "TIO_CPU_ACCESS3",
  ADDRESS => 0x0000000090060980,
  NOTE    => "CPU Interrupt Access Permission Bits 192 - 255",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00504_flds
);


##########################################################################
#                                                                        #
#   TIO_EXT_IOI_ACCESS0                                                  #
#                                                                        #
##########################################################################

%tio_01_00505_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 0 - 63" ],
);

%tio_01_00505_def =
( NAME    => "TIO_EXT_IOI_ACCESS0",
  ADDRESS => 0x0000000090060a00,
  NOTE    => "External IO Interrupt Access Permission Bits 0 - 63",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00505_flds
);


##########################################################################
#                                                                        #
#   TIO_EXT_IOI_ACCESS1                                                  #
#                                                                        #
##########################################################################

%tio_01_00506_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 64 - 127" ],
);

%tio_01_00506_def =
( NAME    => "TIO_EXT_IOI_ACCESS1",
  ADDRESS => 0x0000000090060a80,
  NOTE    => "External IO Interrupt Access Permission Bits 64 - 127",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00506_flds
);


##########################################################################
#                                                                        #
#   TIO_EXT_IOI_ACCESS2                                                  #
#                                                                        #
##########################################################################

%tio_01_00507_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 128 - 191" ],
);

%tio_01_00507_def =
( NAME    => "TIO_EXT_IOI_ACCESS2",
  ADDRESS => 0x0000000090060b00,
  NOTE    => "External IO Interrupt Access Permission Bits 128 - 191",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00507_flds
);


##########################################################################
#                                                                        #
#   TIO_EXT_IOI_ACCESS3                                                  #
#                                                                        #
##########################################################################

%tio_01_00508_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACCESS_BITS"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Access Bits 192 - 255" ],
);

%tio_01_00508_def =
( NAME    => "TIO_EXT_IOI_ACCESS3",
  ADDRESS => 0x0000000090060b80,
  NOTE    => "External IO Interrupt Access Permission Bits 192 - 255",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00508_flds
);


##########################################################################
#                                                                        #
#   TIO_JTAG_CONFIG                                                      #
#                                                                        #
##########################################################################

%tio_01_00509_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "JTAG_CONFIG_AUX"              => [   1,  19,   4, 0x0000000000780000, 0x00, 0, 0x0000000000000000, "Auxilary config bits" ],
   "JSEL_TP5"                     => [   2,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "jsel_tp5" ],
   "JSEL_TP4"                     => [   3,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "jsel_tp4" ],
   "JSEL_B0"                      => [   4,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "jsel_b0" ],
   "WARM_FENCE_ENABLE"            => [   5,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Warm reset fence enable" ],
   "SIM_RESET_N"                  => [   6,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "sim_rst_n" ],
   "CP1_TT_IO_PULL_UP_CONTROL"    => [   7,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Pullup control for cp1 I/O cells" ],
   "CP0_TT_IO_PULL_UP_CONTROL"    => [   8,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "Pullup control for cp0 I/O cells" ],
   "CP1_MCPP_IO_MODE_CONTROL"     => [   9,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Tristate control for cp1 I/O cells" ],
   "CP0_MCPP_IO_MODE_CONTROL"     => [  10,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "Tristate control for cp0 I/O cells" ],
   "P_CP1_BUS_INT_ARB_EN"         => [  11,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Selects arbitration source for cp1, 1=internal, 0=external" ],
   "P_CP1_BUS_PCIX_EN"            => [  12,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Select PCI/PCI-X mode for cp1, 0=PCI, 1=PCI-X" ],
   "P_CP1_BUS_PCI_SPEED_SEL_I"    => [  13,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Select clock for cp1, 000=33MHz, 001=66MHz, 010=100MHz, 011=133MHz 1xx=external" ],
   "P_CP0_BUS_INT_ARB_EN"         => [  14,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Selects arbitration source for cp0, 1=internal, 0=external" ],
   "P_CP0_BUS_PCIX_EN"            => [  15,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Select PCI/PCI-X mode for cp0, 0=PCI, 1=PCI-X" ],
   "P_CP0_BUS_PCI_SPEED_SEL_I"    => [  16,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Select clock for cp0, 000=33MHz, 001=66MHz, 010=100MHz, 011=133MHz 1xx=external" ],
);

%tio_01_00509_def =
( NAME    => "TIO_JTAG_CONFIG",
  ADDRESS => 0x0000000090060e00,
  NOTE    => "The tio_jtag_config register contains a copy of the JTAG note configuration bits. These bits are loaded by JTAG before clock not",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00509_flds
);


##########################################################################
#                                                                        #
#   TIO_NODE_ID                                                          #
#                                                                        #
##########################################################################

%tio_01_00510_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ICE_CHIPLET_ID"               => [   1,  59,   2, 0x1800000000000000, 0x00, 1, 0x0000000000000000, "Chiplet ID value for ICE chiplet" ],
   "SYSTEM_TYPE"                  => [   2,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "System type, 0 = SHub (SN2-IA), 1 = Orbit (SN2-MIPS)" ],
   "RSVD1"                        => [   3,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_PORT"                      => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI port of vector reference, 0 = NI0, 1 = NI1" ],
   "RSVD2"                        => [   5,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODES_PER_BIT"                => [   6,  48,   6, 0x003F000000000000, 0x00, 1, 0x0000000000000000, "Nodes Per Bit" ],
   "RSVD3"                        => [   7,  46,   2, 0x0000C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   8,  32,  14, 0x00003FFF00000000, 0x00, 1, 0x0000000000000000, "Node Identification" ],
   "REVISION"                     => [   9,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Revision" ],
   "PART_NUMBER"                  => [  10,  12,  16, 0x000000000FFFF000, 0x00, 0, 0x0000000000000000, "Part Number" ],
   "MANUFACTURER"                 => [  11,   1,  11, 0x0000000000000FFE, 0x00, 0, 0x0000000000000000, "Manufacturer" ],
   "FORCE1"                       => [  12,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Must be 1" ],
);

%tio_01_00510_def =
( NAME    => "TIO_NODE_ID",
  ADDRESS => 0x0000000090060e80,
  NOTE    => "TIO node ID Number",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00510_flds
);


##########################################################################
#                                                                        #
#   TIO_SOFT_RESET                                                       #
#                                                                        #
##########################################################################

%tio_01_00511_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SOFT_RESET"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Soft Reset" ],
);

%tio_01_00511_def =
( NAME    => "TIO_SOFT_RESET",
  ADDRESS => 0x0000000090061100,
  NOTE    => "TIO Soft Reset",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00511_flds
);


##########################################################################
#                                                                        #
#   TIO_THROTTLE_INTERVAL                                                #
#                                                                        #
##########################################################################

%tio_01_00512_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RESET"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reset Throttle Counter" ],
   "RSVD0"                        => [   1,  30,  33, 0x7FFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   2,   0,  30, 0x000000003FFFFFFF, 0x00, 1, 0x0000000000000000, "Throttle Interval" ],
);

%tio_01_00512_def =
( NAME    => "TIO_THROTTLE_INTERVAL",
  ADDRESS => 0x0000000090068000,
  NOTE    => "Throttle Interval",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00512_flds
);


##########################################################################
#                                                                        #
#   TIO_THROTTLE_TIME                                                    #
#                                                                        #
##########################################################################

%tio_01_00513_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  30, 0x000000003FFFFFFF, 0x00, 1, 0x0000000000000000, "Throttle Time" ],
);

%tio_01_00513_def =
( NAME    => "TIO_THROTTLE_TIME",
  ADDRESS => 0x0000000090068080,
  NOTE    => "Throttle Time",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00513_flds
);


##########################################################################
#                                                                        #
#   TIO_THROTTLE_ENABLE                                                  #
#                                                                        #
##########################################################################

%tio_01_00514_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN"                           => [   1,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable Throttling on XN Port" ],
   "IILB"                         => [   2,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable Throttling on IILB Port" ],
);

%tio_01_00514_def =
( NAME    => "TIO_THROTTLE_ENABLE",
  ADDRESS => 0x0000000090068100,
  NOTE    => "Throttle Enable",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00514_flds
);


##########################################################################
#                                                                        #
#   TIO_FIRST_ERROR                                                      #
#                                                                        #
##########################################################################

%tio_01_00515_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  11,  53, 0xFFFFFFFFFFFFF800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   1,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "XN Uncorrectable Error" ],
   "RSVD1"                        => [   2,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSVD2"                        => [   3,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_CE_INT"                    => [   4,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "XN Correctable Error" ],
   "RSVD3"                        => [   5,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSVD4"                        => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RSVD5"                        => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_HW_INT"                    => [   8,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "LB Hardware Error" ],
   "XN_HW_INT"                    => [   9,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Hardware Error" ],
   "RSVD6"                        => [  10,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ICE_HW_INT"                   => [  11,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "ICE Hardware Error" ],
);

%tio_01_00515_def =
( NAME    => "TIO_FIRST_ERROR",
  ADDRESS => 0x0000000090071000,
  NOTE    => "The tio_first_error register is the top-level error register for note the TIO. If the tio_event_occurred register indicates that",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00515_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_HW_TIME_STAMP                                                 #
#                                                                        #
##########################################################################

%tio_01_00516_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%tio_01_00516_def =
( NAME    => "TIO_LB_HW_TIME_STAMP",
  ADDRESS => 0x0000000090071100,
  NOTE    => "The tio_lb_hw_time_stamp register stores the time stamp of the note first hardware error detected by the LB chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00516_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_HW_TIME_STAMP                                                #
#                                                                        #
##########################################################################

%tio_01_00517_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%tio_01_00517_def =
( NAME    => "TIO_ICE_HW_TIME_STAMP",
  ADDRESS => 0x0000000090071380,
  NOTE    => "The tio_ice_hw_time_stamp register stores the time stamp of the note first hardware error detected by the ICE chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00517_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_COR_TIME_STAMP                                                #
#                                                                        #
##########################################################################

%tio_01_00518_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%tio_01_00518_def =
( NAME    => "TIO_XN_COR_TIME_STAMP",
  ADDRESS => 0x0000000090071880,
  NOTE    => "The tio_xn_cor_time_stamp register stores the time stamp of the note first correctable data error detected by the XN chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00518_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_HW_TIME_STAMP                                                 #
#                                                                        #
##########################################################################

%tio_01_00519_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%tio_01_00519_def =
( NAME    => "TIO_XN_HW_TIME_STAMP",
  ADDRESS => 0x0000000090071900,
  NOTE    => "The tio_xn_hw_time_stamp register stores the time stamp of the note first hardware error detected by the XN chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00519_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_UNCOR_TIME_STAMP                                              #
#                                                                        #
##########################################################################

%tio_01_00520_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%tio_01_00520_def =
( NAME    => "TIO_XN_UNCOR_TIME_STAMP",
  ADDRESS => 0x0000000090071980,
  NOTE    => "The tio_xn_uncor_time_stamp register stores the time stamp of the note first uncorrectable data error detected by the XN chiplet",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00520_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_HW_TIME_STAMP                                                 #
#                                                                        #
##########################################################################

%tio_01_00521_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid Flag" ],
   "TIME"                         => [   1,   0,  63, 0x7FFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Time Stamp Value" ],
);

%tio_01_00521_def =
( NAME    => "TIO_CA_HW_TIME_STAMP",
  ADDRESS => 0x0000000090071a00,
  NOTE    => "The tio_ca_hw_time_stamp register stores the time stamp of the note first hardware error detected by the CA chiplet.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00521_flds
);


##########################################################################
#                                                                        #
#   TIO_DEBUG_PORT                                                       #
#                                                                        #
##########################################################################

%tio_01_00522_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_NIBBLE7"                => [   1,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Debug port nibble 7" ],
   "DEBUG_NIBBLE6"                => [   2,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Debug port nibble 6" ],
   "DEBUG_NIBBLE5"                => [   3,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Debug port nibble 5" ],
   "DEBUG_NIBBLE4"                => [   4,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Debug port nibble 4" ],
   "DEBUG_NIBBLE3"                => [   5,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Debug port nibble 3" ],
   "DEBUG_NIBBLE2"                => [   6,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Debug port nibble 2" ],
   "DEBUG_NIBBLE1"                => [   7,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Debug port nibble 1" ],
   "DEBUG_NIBBLE0"                => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Debug port nibble 0" ],
);

%tio_01_00522_def =
( NAME    => "TIO_DEBUG_PORT",
  ADDRESS => 0x0000000090072000,
  NOTE    => "The tio_debug_port register is a copy of the data being sent to the note debug output port.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00522_flds
);


##########################################################################
#                                                                        #
#   TIO_AEGIS_DEBUG_DATA                                                 #
#                                                                        #
##########################################################################

%tio_01_00523_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AEGIS_DATA"                   => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "AEGIS debug data" ],
);

%tio_01_00523_def =
( NAME    => "TIO_AEGIS_DEBUG_DATA",
  ADDRESS => 0x0000000090072080,
  NOTE    => "The tio_aegis_debug_data register contains a copy of the debug data note being sent from the Aegis to the LB.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00523_flds
);


##########################################################################
#                                                                        #
#   TIO_LB_DEBUG_DATA                                                    #
#                                                                        #
##########################################################################

%tio_01_00524_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_DATA"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "LB debug data" ],
);

%tio_01_00524_def =
( NAME    => "TIO_LB_DEBUG_DATA",
  ADDRESS => 0x0000000090072180,
  NOTE    => "The lb_debug_data register contains a copy of the debug data being note sent from the LB to the top level TIO debug mux.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00524_flds
);


##########################################################################
#                                                                        #
#   TIO_ICE_DEBUG_DATA                                                   #
#                                                                        #
##########################################################################

%tio_01_00525_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ICE_DATA"                     => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "ICE Debug Data" ],
);

%tio_01_00525_def =
( NAME    => "TIO_ICE_DEBUG_DATA",
  ADDRESS => 0x0000000090072280,
  NOTE    => "The tio_pi_debug_data register contains a copy of the debug data note being sent from the ICE to the LB.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00525_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_DEBUG_DATA                                                    #
#                                                                        #
##########################################################################

%tio_01_00526_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_DATA"                      => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "XN debug data" ],
);

%tio_01_00526_def =
( NAME    => "TIO_XN_DEBUG_DATA",
  ADDRESS => 0x0000000090072300,
  NOTE    => "The tio_xn_debug_data register contains a copy of the debug data note being sent from the XN to the LB.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00526_flds
);


##########################################################################
#                                                                        #
#   TIO_OB_LA_STATUS                                                     #
#                                                                        #
##########################################################################

%tio_01_00527_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  40,  24, 0xFFFFFF0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUFFER_ADDR"                  => [   1,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Buffer Address" ],
   "RSVD1"                        => [   2,  17,  15, 0x00000000FFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RECORD"                       => [   3,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Buffer Recording On" ],
   "NCWRF"                        => [   4,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "Outstanding NCWRF Count" ],
);

%tio_01_00527_def =
( NAME    => "TIO_OB_LA_STATUS",
  ADDRESS => 0x0000000090072800,
  NOTE    => "The OB_LA_STATUS register contains the status of the on board logic note analyzer buffer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00527_flds
);


##########################################################################
#                                                                        #
#   TIO_OB_LA_SEQUENCE                                                   #
#                                                                        #
##########################################################################

%tio_01_00528_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RTC"                          => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 1, 0x0000000000000000, "RTC Count" ],
   "SEQUENCE"                     => [   1,   0,   9, 0x00000000000001FF, 0x00, 1, 0x0000000000000000, "Current Sequence Number" ],
);

%tio_01_00528_def =
( NAME    => "TIO_OB_LA_SEQUENCE",
  ADDRESS => 0x0000000090072880,
  NOTE    => "The OB_LA_SEQUENCE register contains the sequence number of the note last cache line saved in the logic analyzer buffer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00528_flds
);


##########################################################################
#                                                                        #
#   TIO_OB_LA_CURRENT_ADDR                                               #
#                                                                        #
##########################################################################

%tio_01_00529_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDRESS"                      => [   1,   7,  31, 0x0000003FFFFFFF80, 0x00, 1, 0x0000000000000000, "Current Memory Address" ],
);

%tio_01_00529_def =
( NAME    => "TIO_OB_LA_CURRENT_ADDR",
  ADDRESS => 0x0000000090072900,
  NOTE    => "The OB_LA_CURRENT_ADDR register contains the current memory address note for the on board logic analyzer buffer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00529_flds
);


##########################################################################
#                                                                        #
#   TIO_TSF_ARMED_STATE                                                  #
#                                                                        #
##########################################################################

%tio_01_00530_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE"                        => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility armed state" ],
);

%tio_01_00530_def =
( NAME    => "TIO_TSF_ARMED_STATE",
  ADDRESS => 0x0000000090073000,
  NOTE    => "The tio_tsf_armed_state contains the armed state for each of the note trigger sequencing variables. Bit 0 is the armed state for",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00530_flds
);


##########################################################################
#                                                                        #
#   TIO_TSF_COUNTER_VALUE                                                #
#                                                                        #
##########################################################################

%tio_01_00531_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COUNT_8A"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8a" ],
   "COUNT_8B"                     => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 8b" ],
   "COUNT_16"                     => [   2,  32,  16, 0x0000FFFF00000000, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 16" ],
   "COUNT_32"                     => [   3,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility counter 32" ],
);

%tio_01_00531_def =
( NAME    => "TIO_TSF_COUNTER_VALUE",
  ADDRESS => 0x0000000090073080,
  NOTE    => "The tio_tsf_counter_value register contains the counter values of note the trigger sequencing down counters. These counters are ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00531_flds
);


##########################################################################
#                                                                        #
#   TIO_TSF_TRIGGERED_STATE                                              #
#                                                                        #
##########################################################################

%tio_01_00532_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATE"                        => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Trigger sequencing facility triggered state" ],
);

%tio_01_00532_def =
( NAME    => "TIO_TSF_TRIGGERED_STATE",
  ADDRESS => 0x0000000090073100,
  NOTE    => "The tsf_triggered_state contains the triggered state for each of note the trigger sequencing variables. Bit 0 is the triggered s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00532_flds
);


##########################################################################
#                                                                        #
#   TIO_VEC_RDDATA                                                       #
#                                                                        #
##########################################################################

%tio_01_00533_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%tio_01_00533_def =
( NAME    => "TIO_VEC_RDDATA",
  ADDRESS => 0x0000000090074000,
  NOTE    => "The tio_vec_rddata register contains the vector PIO read data, if note any. The LB will not modify this register's value if an i",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00533_flds
);


##########################################################################
#                                                                        #
#   TIO_VEC_RETURN                                                       #
#                                                                        #
##########################################################################

%tio_01_00534_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ROUTE"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Route" ],
);

%tio_01_00534_def =
( NAME    => "TIO_VEC_RETURN",
  ADDRESS => 0x0000000090074080,
  NOTE    => "The tio_vec_return register contains the return vector PIO route. note The LB will not modify this register's value if an incomi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00534_flds
);


##########################################################################
#                                                                        #
#   TIO_VEC_STATUS                                                       #
#                                                                        #
##########################################################################

%tio_01_00535_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS_VALID"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Status_Valid" ],
   "OVERRUN"                      => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Overrun" ],
   "SOURCE"                       => [   2,  46,  16, 0x3FFFC00000000000, 0x00, 0, 0x0000000000000000, "Source" ],
   "PIO_ID"                       => [   3,  35,  11, 0x00003FF800000000, 0x00, 0, 0x0000000000000000, "PIO ID" ],
   "ADDRESS"                      => [   4,   3,  32, 0x00000007FFFFFFF8, 0x00, 0, 0x0000000000000000, "Address" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Type" ],
);

%tio_01_00535_def =
( NAME    => "TIO_VEC_STATUS",
  ADDRESS => 0x0000000090074100,
  NOTE    => "The tio_vec_status register contains the vector PIO return status. note Software should clear this register before launching a v",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00535_flds
);


##########################################################################
#                                                                        #
#   TIO_VEC_STATUS_ALIAS                                                 #
#                                                                        #
##########################################################################

%tio_01_00536_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "STATUS_VALID"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Status_Valid" ],
   "OVERRUN"                      => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Overrun" ],
   "SOURCE"                       => [   2,  46,  16, 0x3FFFC00000000000, 0x00, 0, 0x0000000000000000, "Source" ],
   "PIO_ID"                       => [   3,  35,  11, 0x00003FF800000000, 0x00, 0, 0x0000000000000000, "PIO ID" ],
   "ADDRESS"                      => [   4,   3,  32, 0x00000007FFFFFFF8, 0x00, 0, 0x0000000000000000, "Address" ],
   "TYPE"                         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Type" ],
);

%tio_01_00536_def =
( NAME    => "TIO_VEC_STATUS_ALIAS",
  ADDRESS => 0x0000000090074108,
  NOTE    => "The VEC_STATUS_ALIAS is the alias address for the VEC_STATUS note registers. Refer to the VEC_STATUS description and its note AL",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00536_flds
);


##########################################################################
#                                                                        #
#   TIO_LOGIC_ANALYZER_BUFFER                                            #
#                                                                        #
##########################################################################

%tio_01_00537_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Logic Analyzer Data" ],
);

%tio_01_00537_def =
( NAME    => "TIO_LOGIC_ANALYZER_BUFFER",
  ADDRESS => 0x0000000090075000,
  NOTE    => "The logic_analyzer_buffer is a 64 bit by 256 word deep buffer for note the on-board logic analzyer. When enabled, debug port dat",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00537_flds
);


##########################################################################
#                                                                        #
#   TIO_THROTTLE_STATUS                                                  #
#                                                                        #
##########################################################################

%tio_01_00538_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIME"                         => [   1,  32,  30, 0x3FFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Current throttle time count" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INTERVAL"                     => [   3,   0,  30, 0x000000003FFFFFFF, 0x00, 0, 0x0000000000000000, "Current throttle interval count" ],
);

%tio_01_00538_def =
( NAME    => "TIO_THROTTLE_STATUS",
  ADDRESS => 0x0000000090077000,
  NOTE    => "The tio_throttle_status register contains the counter values of the note throttle interval counter and throttle time counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00538_flds
);


##########################################################################
#                                                                        #
#   TIO_PERFORMANCE_COUNT0_CONTROL                                       #
#                                                                        #
##########################################################################

%tio_01_00539_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 0 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 0 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 0 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 0 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 0 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 0 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 0 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 0 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 0 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 0 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 0 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 0 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 0 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 0 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 0 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 0 up stimulus" ],
);

%tio_01_00539_def =
( NAME    => "TIO_PERFORMANCE_COUNT0_CONTROL",
  ADDRESS => 0x0000000090080000,
  NOTE    => "The tio_performance_count0_control register controls the note incrementing and decrementing of event counter 0.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00539_flds
);


##########################################################################
#                                                                        #
#   TIO_PERFORMANCE_COUNT1_CONTROL                                       #
#                                                                        #
##########################################################################

%tio_01_00540_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 1 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 1 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 1 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 1 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 1 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 1 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 1 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 1 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 1 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 1 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 1 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 1 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 1 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 1 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 1 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 1 up stimulus" ],
);

%tio_01_00540_def =
( NAME    => "TIO_PERFORMANCE_COUNT1_CONTROL",
  ADDRESS => 0x0000000090090000,
  NOTE    => "The tio_performance_count1_control register controls the note incrementing and decrementing of event counter 1.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00540_flds
);


##########################################################################
#                                                                        #
#   TIO_PERFORMANCE_COUNT2_CONTROL                                       #
#                                                                        #
##########################################################################

%tio_01_00541_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 2 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 2 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 2 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 2 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 2 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 2 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 2 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 2 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 2 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 2 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 2 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 2 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 2 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 2 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 2 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 2 up stimulus" ],
);

%tio_01_00541_def =
( NAME    => "TIO_PERFORMANCE_COUNT2_CONTROL",
  ADDRESS => 0x00000000900a0000,
  NOTE    => "The tio_performance_count2_control register controls the note incrementing and decrementing of event counter 2.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00541_flds
);


##########################################################################
#                                                                        #
#   TIO_PERFORMANCE_COUNT3_CONTROL                                       #
#                                                                        #
##########################################################################

%tio_01_00542_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 3 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 3 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 3 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 3 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 3 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 3 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 3 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 3 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 3 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 3 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 3 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 3 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 3 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 3 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 3 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 3 up stimulus" ],
);

%tio_01_00542_def =
( NAME    => "TIO_PERFORMANCE_COUNT3_CONTROL",
  ADDRESS => 0x00000000900b0000,
  NOTE    => "The tio_performance_count3_control register controls the note incrementing and decrementing of event counter 3.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00542_flds
);


##########################################################################
#                                                                        #
#   TIO_PERFORMANCE_COUNT4_CONTROL                                       #
#                                                                        #
##########################################################################

%tio_01_00543_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 4 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 4 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 4 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 4 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 4 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 4 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 4 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 4 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 4 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 4 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 4 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 4 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 4 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 4 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 4 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 4 up stimulus" ],
);

%tio_01_00543_def =
( NAME    => "TIO_PERFORMANCE_COUNT4_CONTROL",
  ADDRESS => 0x00000000900c0000,
  NOTE    => "The tio_performance_count4_control register controls the note incrementing and decrementing of event counter 4.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00543_flds
);


##########################################################################
#                                                                        #
#   TIO_PERFORMANCE_COUNT5_CONTROL                                       #
#                                                                        #
##########################################################################

%tio_01_00544_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 5 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 5 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 5 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 5 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 5 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 5 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 5 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 5 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 5 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 5 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 5 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 5 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 5 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 5 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 5 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 5 up stimulus" ],
);

%tio_01_00544_def =
( NAME    => "TIO_PERFORMANCE_COUNT5_CONTROL",
  ADDRESS => 0x00000000900d0000,
  NOTE    => "The tio_performance_count5_control register controls the note incrementing and decrementing of event counter 5.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00544_flds
);


##########################################################################
#                                                                        #
#   TIO_PERFORMANCE_COUNT6_CONTROL                                       #
#                                                                        #
##########################################################################

%tio_01_00545_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 6 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 6 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 6 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 6 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 6 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 6 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 6 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 6 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 6 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 6 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 6 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 6 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 6 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 6 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 6 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 6 up stimulus" ],
);

%tio_01_00545_def =
( NAME    => "TIO_PERFORMANCE_COUNT6_CONTROL",
  ADDRESS => 0x00000000900e0000,
  NOTE    => "The tio_performance_count6_control register controls the note incrementing and decrementing of event counter 6.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00545_flds
);


##########################################################################
#                                                                        #
#   TIO_PERFORMANCE_COUNT7_CONTROL                                       #
#                                                                        #
##########################################################################

%tio_01_00546_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  33,  31, 0xFFFFFFFE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CLR_ENABLE"                   => [   1,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Counter 7 enable clear" ],
   "CLR_MODE"                     => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Counter 7 clear mode select (1-internal, 0-external)" ],
   "CLR_POLARITY"                 => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "Counter 7 clear polarity select (1-negative edge, 0-positive edge)" ],
   "CLR_EVENT"                    => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "Counter 7 clear format select (1-level, 0-edge)" ],
   "CLR_STIMULUS"                 => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "Counter 7 clear stimulus" ],
   "RSVD1"                        => [   6,  19,   5, 0x0000000000F80000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PEAK_DET_ENABLE"              => [   7,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "Counter 7 enable peak detection" ],
   "DEC_ENABLE"                   => [   8,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Counter 7 enable decrement" ],
   "INC_ENABLE"                   => [   9,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Counter 7 enable increment" ],
   "DN_MODE"                      => [  10,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Counter 7 down mode select (1-internal, 0-external)" ],
   "DN_POLARITY"                  => [  11,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Counter 7 down polarity select (1-negative edge, 0-positive edge)" ],
   "DN_EVENT"                     => [  12,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Counter 7 down format select (1-level, 0-edge)" ],
   "DN_STIMULUS"                  => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "Counter 7 down stimulus" ],
   "UP_MODE"                      => [  14,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter 7 up mode select (1-internal, 0-external)" ],
   "UP_POLARITY"                  => [  15,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter 7 up polarity select (1-negative edge, 0-positive edge)" ],
   "UP_EVENT"                     => [  16,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter 7 up format select (1-level, 0-edge)" ],
   "UP_STIMULUS"                  => [  17,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter 7 up stimulus" ],
);

%tio_01_00546_def =
( NAME    => "TIO_PERFORMANCE_COUNT7_CONTROL",
  ADDRESS => 0x00000000900f0000,
  NOTE    => "The tio_performance_count7_control register controls the note incrementing and decrementing of event counter 7.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00546_flds
);


##########################################################################
#                                                                        #
#   TIO_PROFILE_DN_CONTROL                                               #
#                                                                        #
##########################################################################

%tio_01_00547_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MODE"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter mode select (1-internal, 0-external)" ],
   "POLARITY"                     => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter polarity select (1-negative edge, 0-positive edge)" ],
   "EVENT"                        => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter format select (1-level, 0-edge)" ],
   "STIMULUS"                     => [   4,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter stimulus" ],
);

%tio_01_00547_def =
( NAME    => "TIO_PROFILE_DN_CONTROL",
  ADDRESS => 0x0000000090100000,
  NOTE    => "The tio_profile_dn_control register controls the decrementing of note the profile counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00547_flds
);


##########################################################################
#                                                                        #
#   TIO_PROFILE_PEAK_CONTROL                                             #
#                                                                        #
##########################################################################

%tio_01_00548_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   7,  57, 0xFFFFFFFFFFFFFF80, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "POLARITY"                     => [   1,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter polarity select (0-negative edge, 1-positive edge)" ],
   "EVENT"                        => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter format select (1-level, 0-edge)" ],
   "RSVD1"                        => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STIMULUS"                     => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Counter stimulus (1-equal, 0-greater than)" ],
);

%tio_01_00548_def =
( NAME    => "TIO_PROFILE_PEAK_CONTROL",
  ADDRESS => 0x0000000090100080,
  NOTE    => "The tio_profile_peak_control register controls the loading of the note tio_profile_peak register.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00548_flds
);


##########################################################################
#                                                                        #
#   TIO_PROFILE_RANGE                                                    #
#                                                                        #
##########################################################################

%tio_01_00549_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RANGE7"                       => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Profiling range 7" ],
   "RANGE6"                       => [   1,  48,   8, 0x00FF000000000000, 0x00, 0, 0x0000000000000000, "Profiling range 6" ],
   "RANGE5"                       => [   2,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "Profiling range 5" ],
   "RANGE4"                       => [   3,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Profiling range 4" ],
   "RANGE3"                       => [   4,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Profiling range 3" ],
   "RANGE2"                       => [   5,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Profiling range 2" ],
   "RANGE1"                       => [   6,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Profiling range 1" ],
   "RANGE0"                       => [   7,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Profiling range 0" ],
);

%tio_01_00549_def =
( NAME    => "TIO_PROFILE_RANGE",
  ADDRESS => 0x0000000090100100,
  NOTE    => "There are eight profile range fields in the tio_profile_range note register. The profiling count can be compared against the eig",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00549_flds
);


##########################################################################
#                                                                        #
#   TIO_PROFILE_UP_CONTROL                                               #
#                                                                        #
##########################################################################

%tio_01_00550_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MODE"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Counter mode select (1-internal, 0-external)" ],
   "POLARITY"                     => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Counter polarity select (1-negative edge, 0-positive edge)" ],
   "EVENT"                        => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Counter format select (1-level, 0-edge)" ],
   "STIMULUS"                     => [   4,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "Counter stimulus" ],
);

%tio_01_00550_def =
( NAME    => "TIO_PROFILE_UP_CONTROL",
  ADDRESS => 0x0000000090100180,
  NOTE    => "The tio_profile_up_control register controls the decrementing of note the profile counter.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00550_flds
);


##########################################################################
#                                                                        #
#   TIO_PERFORMANCE_MONITOR_DESKEW                                       #
#                                                                        #
##########################################################################

%tio_01_00551_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BIT_31_DELAY"                 => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 31" ],
   "BIT_30_DELAY"                 => [   1,  60,   2, 0x3000000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 30" ],
   "BIT_29_DELAY"                 => [   2,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 29" ],
   "BIT_28_DELAY"                 => [   3,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 28" ],
   "BIT_27_DELAY"                 => [   4,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 27" ],
   "BIT_26_DELAY"                 => [   5,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 26" ],
   "BIT_25_DELAY"                 => [   6,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 25" ],
   "BIT_24_DELAY"                 => [   7,  48,   2, 0x0003000000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 24" ],
   "BIT_23_DELAY"                 => [   8,  46,   2, 0x0000C00000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 23" ],
   "BIT_22_DELAY"                 => [   9,  44,   2, 0x0000300000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 22" ],
   "BIT_21_DELAY"                 => [  10,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 21" ],
   "BIT_20_DELAY"                 => [  11,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 20" ],
   "BIT_19_DELAY"                 => [  12,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 19" ],
   "BIT_18_DELAY"                 => [  13,  36,   2, 0x0000003000000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 18" ],
   "BIT_17_DELAY"                 => [  14,  34,   2, 0x0000000C00000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 17" ],
   "BIT_16_DELAY"                 => [  15,  32,   2, 0x0000000300000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 16" ],
   "BIT_15_DELAY"                 => [  16,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 15" ],
   "BIT_14_DELAY"                 => [  17,  28,   2, 0x0000000030000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 14" ],
   "BIT_13_DELAY"                 => [  18,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 13" ],
   "BIT_12_DELAY"                 => [  19,  24,   2, 0x0000000003000000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 12" ],
   "BIT_11_DELAY"                 => [  20,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 11" ],
   "BIT_10_DELAY"                 => [  21,  20,   2, 0x0000000000300000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 10" ],
   "BIT_9_DELAY"                  => [  22,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 9" ],
   "BIT_8_DELAY"                  => [  23,  16,   2, 0x0000000000030000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 8" ],
   "BIT_7_DELAY"                  => [  24,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 7" ],
   "BIT_6_DELAY"                  => [  25,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 6" ],
   "BIT_5_DELAY"                  => [  26,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 5" ],
   "BIT_4_DELAY"                  => [  27,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 4" ],
   "BIT_3_DELAY"                  => [  28,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 3" ],
   "BIT_2_DELAY"                  => [  29,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 2" ],
   "BIT_1_DELAY"                  => [  30,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 1" ],
   "BIT_0_DELAY"                  => [  31,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Number of clocks to delay bit 0" ],
);

%tio_01_00551_def =
( NAME    => "TIO_PERFORMANCE_MONITOR_DESKEW",
  ADDRESS => 0x0000000090101000,
  NOTE    => "The tio_performance_monitor_deskew register controls the amount of note deskew on each of the debug data bits going to the perfo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00551_flds
);


##########################################################################
#                                                                        #
#   TIO_PERFORMANCE_COUNTER0                                             #
#                                                                        #
##########################################################################

%tio_01_00552_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 0" ],
);

%tio_01_00552_def =
( NAME    => "TIO_PERFORMANCE_COUNTER0",
  ADDRESS => 0x0000000090110000,
  NOTE    => "Performance Counter 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00552_flds
);


##########################################################################
#                                                                        #
#   TIO_PERFORMANCE_COUNTER1                                             #
#                                                                        #
##########################################################################

%tio_01_00553_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 1" ],
);

%tio_01_00553_def =
( NAME    => "TIO_PERFORMANCE_COUNTER1",
  ADDRESS => 0x0000000090120000,
  NOTE    => "Performance Counter 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00553_flds
);


##########################################################################
#                                                                        #
#   TIO_PERFORMANCE_COUNTER2                                             #
#                                                                        #
##########################################################################

%tio_01_00554_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 2" ],
);

%tio_01_00554_def =
( NAME    => "TIO_PERFORMANCE_COUNTER2",
  ADDRESS => 0x0000000090130000,
  NOTE    => "Performance Counter 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00554_flds
);


##########################################################################
#                                                                        #
#   TIO_PERFORMANCE_COUNTER3                                             #
#                                                                        #
##########################################################################

%tio_01_00555_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 3" ],
);

%tio_01_00555_def =
( NAME    => "TIO_PERFORMANCE_COUNTER3",
  ADDRESS => 0x0000000090140000,
  NOTE    => "Performance Counter 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00555_flds
);


##########################################################################
#                                                                        #
#   TIO_PERFORMANCE_COUNTER4                                             #
#                                                                        #
##########################################################################

%tio_01_00556_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 4" ],
);

%tio_01_00556_def =
( NAME    => "TIO_PERFORMANCE_COUNTER4",
  ADDRESS => 0x0000000090150000,
  NOTE    => "Performance Counter 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00556_flds
);


##########################################################################
#                                                                        #
#   TIO_PERFORMANCE_COUNTER5                                             #
#                                                                        #
##########################################################################

%tio_01_00557_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 5" ],
);

%tio_01_00557_def =
( NAME    => "TIO_PERFORMANCE_COUNTER5",
  ADDRESS => 0x0000000090160000,
  NOTE    => "Performance Counter 5",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00557_flds
);


##########################################################################
#                                                                        #
#   TIO_PERFORMANCE_COUNTER6                                             #
#                                                                        #
##########################################################################

%tio_01_00558_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 6" ],
);

%tio_01_00558_def =
( NAME    => "TIO_PERFORMANCE_COUNTER6",
  ADDRESS => 0x0000000090170000,
  NOTE    => "Performance Counter 6",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00558_flds
);


##########################################################################
#                                                                        #
#   TIO_PERFORMANCE_COUNTER7                                             #
#                                                                        #
##########################################################################

%tio_01_00559_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNT"                        => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Counter 7" ],
);

%tio_01_00559_def =
( NAME    => "TIO_PERFORMANCE_COUNTER7",
  ADDRESS => 0x0000000090180000,
  NOTE    => "Performance Counter 7",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00559_flds
);


##########################################################################
#                                                                        #
#   TIO_PROFILE_COUNTER                                                  #
#                                                                        #
##########################################################################

%tio_01_00560_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNTER"                      => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Counter Value" ],
);

%tio_01_00560_def =
( NAME    => "TIO_PROFILE_COUNTER",
  ADDRESS => 0x0000000090190000,
  NOTE    => "Profile Counter",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00560_flds
);


##########################################################################
#                                                                        #
#   TIO_PROFILE_PEAK                                                     #
#                                                                        #
##########################################################################

%tio_01_00561_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COUNTER"                      => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Counter Value" ],
);

%tio_01_00561_def =
( NAME    => "TIO_PROFILE_PEAK",
  ADDRESS => 0x0000000090190080,
  NOTE    => "Profile Peak Counter",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00561_flds
);


##########################################################################
#                                                                        #
#   TIO_RTC                                                              #
#                                                                        #
##########################################################################

%tio_01_00562_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  55,   9, 0xFF80000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REAL_TIME_CLOCK"              => [   1,   0,  55, 0x007FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Real-time Clock" ],
);

%tio_01_00562_def =
( NAME    => "TIO_RTC",
  ADDRESS => 0x00000000901c0000,
  NOTE    => "The real time clock is a 55 bit counter that wraps to zero when the note maximum value is reached. This counter is incremented o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00562_flds
);


##########################################################################
#                                                                        #
#   TIO_SCRATCH0                                                         #
#                                                                        #
##########################################################################

%tio_01_00563_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH0"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 0" ],
);

%tio_01_00563_def =
( NAME    => "TIO_SCRATCH0",
  ADDRESS => 0x00000000901d0000,
  NOTE    => "Scratch Register 0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00563_flds
);


##########################################################################
#                                                                        #
#   TIO_SCRATCH0_ALIAS                                                   #
#                                                                        #
##########################################################################

%tio_01_00564_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH0"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 0" ],
);

%tio_01_00564_def =
( NAME    => "TIO_SCRATCH0_ALIAS",
  ADDRESS => 0x00000000901d0008,
  NOTE    => "Scratch Register 0 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00564_flds
);


##########################################################################
#                                                                        #
#   TIO_SCRATCH1                                                         #
#                                                                        #
##########################################################################

%tio_01_00565_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH1"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 1" ],
);

%tio_01_00565_def =
( NAME    => "TIO_SCRATCH1",
  ADDRESS => 0x00000000901d0080,
  NOTE    => "Scratch Register 1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00565_flds
);


##########################################################################
#                                                                        #
#   TIO_SCRATCH1_ALIAS                                                   #
#                                                                        #
##########################################################################

%tio_01_00566_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH1"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Scratch register 1" ],
);

%tio_01_00566_def =
( NAME    => "TIO_SCRATCH1_ALIAS",
  ADDRESS => 0x00000000901d0088,
  NOTE    => "Scratch Register 1 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00566_flds
);


##########################################################################
#                                                                        #
#   TIO_SCRATCH2                                                         #
#                                                                        #
##########################################################################

%tio_01_00567_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH2"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Scratch register 2" ],
);

%tio_01_00567_def =
( NAME    => "TIO_SCRATCH2",
  ADDRESS => 0x00000000901d0100,
  NOTE    => "Scratch Register 2",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00567_flds
);


##########################################################################
#                                                                        #
#   TIO_SCRATCH2_ALIAS                                                   #
#                                                                        #
##########################################################################

%tio_01_00568_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCRATCH2"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Scratch register 2" ],
);

%tio_01_00568_def =
( NAME    => "TIO_SCRATCH2_ALIAS",
  ADDRESS => 0x00000000901d0108,
  NOTE    => "Scratch Register 2 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00568_flds
);


##########################################################################
#                                                                        #
#   TIO_SCRATCH3                                                         #
#                                                                        #
##########################################################################

%tio_01_00569_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH3"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 3" ],
);

%tio_01_00569_def =
( NAME    => "TIO_SCRATCH3",
  ADDRESS => 0x00000000901d0180,
  NOTE    => "Scratch Register 3",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00569_flds
);


##########################################################################
#                                                                        #
#   TIO_SCRATCH3_ALIAS                                                   #
#                                                                        #
##########################################################################

%tio_01_00570_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH3"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 3" ],
);

%tio_01_00570_def =
( NAME    => "TIO_SCRATCH3_ALIAS",
  ADDRESS => 0x00000000901d0188,
  NOTE    => "Scratch Register 3 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00570_flds
);


##########################################################################
#                                                                        #
#   TIO_SCRATCH4                                                         #
#                                                                        #
##########################################################################

%tio_01_00571_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH4"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 4" ],
);

%tio_01_00571_def =
( NAME    => "TIO_SCRATCH4",
  ADDRESS => 0x00000000901d0200,
  NOTE    => "Scratch Register 4",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00571_flds
);


##########################################################################
#                                                                        #
#   TIO_SCRATCH4_ALIAS                                                   #
#                                                                        #
##########################################################################

%tio_01_00572_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SCRATCH4"                     => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Scratch register 4" ],
);

%tio_01_00572_def =
( NAME    => "TIO_SCRATCH4_ALIAS",
  ADDRESS => 0x00000000901d0208,
  NOTE    => "Scratch Register 4 Alias Address",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00572_flds
);


##########################################################################
#                                                                        #
#   TIO_INT_NODE_ID_CONFIG                                               #
#                                                                        #
##########################################################################

%tio_01_00573_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  39,  25, 0xFFFFFF8000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VECTOR"                       => [   1,  32,   7, 0x0000007F00000000, 0x00, 1, 0x0000000000000000, "Vector number for remote interrupt messags" ],
   "RSVD1"                        => [   2,  14,  18, 0x00000000FFFFC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   3,   0,  14, 0x0000000000003FFF, 0x00, 1, 0x0000000000000000, "Node ID" ],
);

%tio_01_00573_def =
( NAME    => "TIO_INT_NODE_ID_CONFIG",
  ADDRESS => 0x0000000090000300,
  NOTE    => "Generally, interrupts are generated by the TIO and sent to a local note processor; however, the interrupts may be sent to any ot",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00573_flds
);


##########################################################################
#                                                                        #
#   TIO_LOCAL_INT0_CONFIG                                                #
#                                                                        #
##########################################################################

%tio_01_00574_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  30, 0x0007FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%tio_01_00574_def =
( NAME    => "TIO_LOCAL_INT0_CONFIG",
  ADDRESS => 0x0000000090000480,
  NOTE    => "The local interrupts indicates hardware errors, correctable and note uncorrectable data errors, and system shutdown. In addition",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00574_flds
);


##########################################################################
#                                                                        #
#   TIO_LOCAL_INT0_ENABLE                                                #
#                                                                        #
##########################################################################

%tio_01_00575_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ASIC_TO_L1"                   => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Enable ASIC to L1 Controller Interrupt" ],
   "STOP_CLOCK"                   => [   2,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt" ],
   "RSVD1"                        => [   3,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   4,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable L1 Controller to ASIC Interrupt" ],
   "SYSTEM_SHUTDOWN_INT"          => [   5,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Enable System Shutdown Interrupt" ],
   "RSVD2"                        => [   6,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   7,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "RSVD3"                        => [   8,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_CE_INT"                    => [   9,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "RSVD4"                        => [  10,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_HW_INT"                    => [  11,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable LB Hardware interrupt" ],
   "XN_HW_INT"                    => [  12,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable XN Hardware interrupt" ],
   "RSVD5"                        => [  13,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ICE_HW_INT"                   => [  14,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable ICE Hardware interrupt" ],
);

%tio_01_00575_def =
( NAME    => "TIO_LOCAL_INT0_ENABLE",
  ADDRESS => 0x0000000090000500,
  NOTE    => "This register is a multiple-bit register that enables the Local note Interrupt 0 when specified hardware errors, data errors, or",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00575_flds
);


##########################################################################
#                                                                        #
#   TIO_LOCAL_INT1_CONFIG                                                #
#                                                                        #
##########################################################################

%tio_01_00576_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  30, 0x0007FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%tio_01_00576_def =
( NAME    => "TIO_LOCAL_INT1_CONFIG",
  ADDRESS => 0x0000000090000580,
  NOTE    => "The local interrupts indicates hardware errors, correctable and note uncorrectable data errors, and system shutdown. In addition",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00576_flds
);


##########################################################################
#                                                                        #
#   TIO_LOCAL_INT1_ENABLE                                                #
#                                                                        #
##########################################################################

%tio_01_00577_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ASIC_TO_L1"                   => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Enable ASIC to L1 Controler Interrupt" ],
   "STOP_CLOCK"                   => [   2,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt" ],
   "RSVD1"                        => [   3,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   4,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable L1 Controller to ASIC Interrupt" ],
   "SYSTEM_SHUTDOWN_INT"          => [   5,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Enable System Shutdown Interrupt" ],
   "RSVD2"                        => [   6,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   7,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "RSVD3"                        => [   8,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_CE_INT"                    => [   9,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "RSVD4"                        => [  10,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_HW_INT"                    => [  11,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable LB Hardware interrupt" ],
   "XN_HW_INT"                    => [  12,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable XN Hardware interrupt" ],
   "RSVD5"                        => [  13,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ICE_HW_INT"                   => [  14,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable ICE Hardware interrupt" ],
);

%tio_01_00577_def =
( NAME    => "TIO_LOCAL_INT1_ENABLE",
  ADDRESS => 0x0000000090000600,
  NOTE    => "This register is a multiple-bit register that enables the Local note Interrupt 1 when specified hardware errors, data errors, or",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00577_flds
);


##########################################################################
#                                                                        #
#   TIO_LOCAL_INT2_CONFIG                                                #
#                                                                        #
##########################################################################

%tio_01_00578_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  30, 0x0007FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%tio_01_00578_def =
( NAME    => "TIO_LOCAL_INT2_CONFIG",
  ADDRESS => 0x0000000090000680,
  NOTE    => "The local interrupts indicates hardware errors, correctable and note uncorrectable data errors, and system shutdown. In addition",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00578_flds
);


##########################################################################
#                                                                        #
#   TIO_LOCAL_INT2_ENABLE                                                #
#                                                                        #
##########################################################################

%tio_01_00579_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ASIC_TO_L1"                   => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Enable ASIC to L1 Controler Interrupt" ],
   "STOP_CLOCK"                   => [   2,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt" ],
   "RSVD1"                        => [   3,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   4,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable L1 Controller to ASIC Interrupt" ],
   "SYSTEM_SHUTDOWN_INT"          => [   5,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Enable System Shutdown Interrupt" ],
   "RSVD2"                        => [   6,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   7,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "RSVD3"                        => [   8,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_CE_INT"                    => [   9,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "RSVD4"                        => [  10,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_HW_INT"                    => [  11,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable LB Hardware interrupt" ],
   "XN_HW_INT"                    => [  12,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable XN Hardware interrupt" ],
   "RSVD5"                        => [  13,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ICE_HW_INT"                   => [  14,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable ICE Hardware interrupt" ],
);

%tio_01_00579_def =
( NAME    => "TIO_LOCAL_INT2_ENABLE",
  ADDRESS => 0x0000000090000700,
  NOTE    => "This register is a multiple-bit register that enables the Local note Interrupt 2 when specified hardware errors, data errors, or",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00579_flds
);


##########################################################################
#                                                                        #
#   TIO_LOCAL_INT3_CONFIG                                                #
#                                                                        #
##########################################################################

%tio_01_00580_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  30, 0x0007FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%tio_01_00580_def =
( NAME    => "TIO_LOCAL_INT3_CONFIG",
  ADDRESS => 0x0000000090000780,
  NOTE    => "The local interrupts indicates hardware errors, correctable and note uncorrectable data errors, and system shutdown. In addition",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00580_flds
);


##########################################################################
#                                                                        #
#   TIO_LOCAL_INT3_ENABLE                                                #
#                                                                        #
##########################################################################

%tio_01_00581_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ASIC_TO_L1"                   => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Enable ASIC to L1 Controler Interrupt" ],
   "STOP_CLOCK"                   => [   2,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt" ],
   "RSVD1"                        => [   3,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   4,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable L1 Controller to ASIC Interrupt" ],
   "SYSTEM_SHUTDOWN_INT"          => [   5,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Enable System Shutdown Interrupt" ],
   "RSVD2"                        => [   6,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   7,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "RSVD3"                        => [   8,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_CE_INT"                    => [   9,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "RSVD4"                        => [  10,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_HW_INT"                    => [  11,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable LB Hardware interrupt" ],
   "XN_HW_INT"                    => [  12,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable XN Hardware interrupt" ],
   "RSVD5"                        => [  13,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ICE_HW_INT"                   => [  14,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable ICE Hardware interrupt" ],
);

%tio_01_00581_def =
( NAME    => "TIO_LOCAL_INT3_ENABLE",
  ADDRESS => 0x0000000090000800,
  NOTE    => "This register is a multiple-bit register that enables the Local note Interrupt 3 when specified hardware errors, data errors, or",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00581_flds
);


##########################################################################
#                                                                        #
#   TIO_LOCAL_INT4_CONFIG                                                #
#                                                                        #
##########################################################################

%tio_01_00582_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  30, 0x0007FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%tio_01_00582_def =
( NAME    => "TIO_LOCAL_INT4_CONFIG",
  ADDRESS => 0x0000000090000880,
  NOTE    => "The local interrupts indicates hardware errors, correctable and note uncorrectable data errors, and system shutdown. In addition",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00582_flds
);


##########################################################################
#                                                                        #
#   TIO_LOCAL_INT4_ENABLE                                                #
#                                                                        #
##########################################################################

%tio_01_00583_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ASIC_TO_L1"                   => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Enable ASIC to L1 Controler Interrupt" ],
   "STOP_CLOCK"                   => [   2,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt" ],
   "RSVD1"                        => [   3,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   4,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable L1 Controller to ASIC Interrupt" ],
   "SYSTEM_SHUTDOWN_INT"          => [   5,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Enable System Shutdown Interrupt" ],
   "RSVD2"                        => [   6,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   7,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "RSVD3"                        => [   8,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_CE_INT"                    => [   9,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "RSVD4"                        => [  10,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_HW_INT"                    => [  11,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable LB Hardware interrupt" ],
   "XN_HW_INT"                    => [  12,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable XN Hardware interrupt" ],
   "RSVD5"                        => [  13,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ICE_HW_INT"                   => [  14,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable ICE Hardware interrupt" ],
);

%tio_01_00583_def =
( NAME    => "TIO_LOCAL_INT4_ENABLE",
  ADDRESS => 0x0000000090000900,
  NOTE    => "This register is a multiple-bit register that enables the Local note Interrupt 4 when specified hardware errors, data errors, or",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00583_flds
);


##########################################################################
#                                                                        #
#   TIO_LOCAL_INT5_CONFIG                                                #
#                                                                        #
##########################################################################

%tio_01_00584_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IDX"                          => [   1,  52,   8, 0x0FF0000000000000, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
   "RSVD1"                        => [   2,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BASE"                         => [   3,  21,  30, 0x0007FFFFFFE00000, 0x00, 1, 0x0000000000000000, "Optional Vector Area" ],
   "RSVD2"                        => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PID"                          => [   5,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   7,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%tio_01_00584_def =
( NAME    => "TIO_LOCAL_INT5_CONFIG",
  ADDRESS => 0x0000000090000980,
  NOTE    => "The local interrupts indicates hardware errors, correctable and note uncorrectable data errors, and system shutdown. In addition",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00584_flds
);


##########################################################################
#                                                                        #
#   TIO_LOCAL_INT5_ENABLE                                                #
#                                                                        #
##########################################################################

%tio_01_00585_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  17,  47, 0xFFFFFFFFFFFE0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ASIC_TO_L1"                   => [   1,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "Enable ASIC to L1 Controler Interrupt" ],
   "STOP_CLOCK"                   => [   2,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "Stop Clock Interrupt" ],
   "RSVD1"                        => [   3,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   4,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Enable L1 Controller to ASIC Interrupt" ],
   "SYSTEM_SHUTDOWN_INT"          => [   5,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Enable System Shutdown Interrupt" ],
   "RSVD2"                        => [   6,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   7,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "RSVD3"                        => [   8,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_CE_INT"                    => [   9,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "Enable XN Correctable Error Interrupt" ],
   "RSVD4"                        => [  10,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_HW_INT"                    => [  11,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Enable LB Hardware interrupt" ],
   "XN_HW_INT"                    => [  12,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Enable XN Hardware interrupt" ],
   "RSVD5"                        => [  13,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ICE_HW_INT"                   => [  14,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable ICE Hardware interrupt" ],
);

%tio_01_00585_def =
( NAME    => "TIO_LOCAL_INT5_ENABLE",
  ADDRESS => 0x0000000090000a00,
  NOTE    => "This register is a multiple-bit register that enables the Local note Interrupt 5 when specified hardware errors, data errors, or",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00585_flds
);


##########################################################################
#                                                                        #
#   TIO_INT0                                                             #
#                                                                        #
##########################################################################

%tio_01_00586_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND"                         => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Initiate an Interrupt" ],
   "IDX"                          => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
);

%tio_01_00586_def =
( NAME    => "TIO_INT0",
  ADDRESS => 0x0000000090001000,
  NOTE    => "The TIO_INT0 register along with the TIO_INT0_CONFIG and note TIO_INT0_ENABLE registers provide IO nodes (i.e., TIO chips) with ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00586_flds
);


##########################################################################
#                                                                        #
#   TIO_INT0_CONFIG                                                      #
#                                                                        #
##########################################################################

%tio_01_00587_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NODE_ID"                      => [   0,  50,  14, 0xFFFC000000000000, 0x00, 1, 0x0000000000000000, "Node Identification" ],
   "BASE"                         => [   1,  20,  30, 0x0003FFFFFFF00000, 0x00, 1, 0x0000000000000000, "Optional Processor Interrupt Base Pointer" ],
   "PID"                          => [   2,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   3,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   4,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%tio_01_00587_def =
( NAME    => "TIO_INT0_CONFIG",
  ADDRESS => 0x0000000090001080,
  NOTE    => "The TIO_INT0_CONFIG register along with the TIO_INT0 and note TIO_INT0_ENABLE registers provide IO nodes (i.e., TIO chips) with ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00587_flds
);


##########################################################################
#                                                                        #
#   TIO_INT1                                                             #
#                                                                        #
##########################################################################

%tio_01_00588_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND"                         => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Initiate an Interrupt" ],
   "IDX"                          => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
);

%tio_01_00588_def =
( NAME    => "TIO_INT1",
  ADDRESS => 0x0000000090001100,
  NOTE    => "The TIO_INT1 register along with the TIO_INT1_CONFIG and note TIO_INT1_ENABLE registers provide IO nodes (i.e., TIO chips) with ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00588_flds
);


##########################################################################
#                                                                        #
#   TIO_INT1_CONFIG                                                      #
#                                                                        #
##########################################################################

%tio_01_00589_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NODE_ID"                      => [   0,  50,  14, 0xFFFC000000000000, 0x00, 1, 0x0000000000000000, "Node Identification" ],
   "BASE"                         => [   1,  20,  30, 0x0003FFFFFFF00000, 0x00, 1, 0x0000000000000000, "Optional Processor Interrupt Base Pointer" ],
   "PID"                          => [   2,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   3,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   4,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%tio_01_00589_def =
( NAME    => "TIO_INT1_CONFIG",
  ADDRESS => 0x0000000090001180,
  NOTE    => "The TIO_INT1_CONFIG register along with the TIO_INT1 and note TIO_INT1_ENABLE registers provide IO nodes (i.e., TIO chips) with ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00589_flds
);


##########################################################################
#                                                                        #
#   TIO_INT2                                                             #
#                                                                        #
##########################################################################

%tio_01_00590_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND"                         => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Initiate an Interrupt" ],
   "IDX"                          => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
);

%tio_01_00590_def =
( NAME    => "TIO_INT2",
  ADDRESS => 0x0000000090001200,
  NOTE    => "The TIO_INT2 register along with the TIO_INT2_CONFIG and note TIO_INT2_ENABLE registers provide IO nodes (i.e., TIO chips) with ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00590_flds
);


##########################################################################
#                                                                        #
#   TIO_INT2_CONFIG                                                      #
#                                                                        #
##########################################################################

%tio_01_00591_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NODE_ID"                      => [   0,  50,  14, 0xFFFC000000000000, 0x00, 1, 0x0000000000000000, "Node Identification" ],
   "BASE"                         => [   1,  20,  30, 0x0003FFFFFFF00000, 0x00, 1, 0x0000000000000000, "Optional Processor Interrupt Base Pointer" ],
   "PID"                          => [   2,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   3,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   4,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%tio_01_00591_def =
( NAME    => "TIO_INT2_CONFIG",
  ADDRESS => 0x0000000090001280,
  NOTE    => "The TIO_INT2_CONFIG register along with the TIO_INT2 and note TIO_INT2_ENABLE registers provide IO nodes (i.e., TIO chips) with ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00591_flds
);


##########################################################################
#                                                                        #
#   TIO_INT3                                                             #
#                                                                        #
##########################################################################

%tio_01_00592_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND"                         => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Initiate an Interrupt" ],
   "IDX"                          => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
);

%tio_01_00592_def =
( NAME    => "TIO_INT3",
  ADDRESS => 0x0000000090001300,
  NOTE    => "The TIO_INT3 register along with the TIO_INT3_CONFIG and note TIO_INT3_ENABLE registers provide IO nodes (i.e., TIO chips) with ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00592_flds
);


##########################################################################
#                                                                        #
#   TIO_INT3_CONFIG                                                      #
#                                                                        #
##########################################################################

%tio_01_00593_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NODE_ID"                      => [   0,  50,  14, 0xFFFC000000000000, 0x00, 1, 0x0000000000000000, "Node Identification" ],
   "BASE"                         => [   1,  20,  30, 0x0003FFFFFFF00000, 0x00, 1, 0x0000000000000000, "Optional Processor Interrupt Base Pointer" ],
   "PID"                          => [   2,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   3,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   4,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%tio_01_00593_def =
( NAME    => "TIO_INT3_CONFIG",
  ADDRESS => 0x0000000090001380,
  NOTE    => "The TIO_INT3_CONFIG register along with the TIO_INT3 and note TIO_INT3_ENABLE registers provide IO nodes (i.e., TIO chips) with ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00593_flds
);


##########################################################################
#                                                                        #
#   TIO_INT4                                                             #
#                                                                        #
##########################################################################

%tio_01_00594_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND"                         => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Initiate an Interrupt" ],
   "IDX"                          => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
);

%tio_01_00594_def =
( NAME    => "TIO_INT4",
  ADDRESS => 0x0000000090001400,
  NOTE    => "The TIO_INT4 register along with the TIO_INT4_CONFIG and note TIO_INT4_ENABLE registers provide IO nodes (i.e., TIO chips) with ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00594_flds
);


##########################################################################
#                                                                        #
#   TIO_INT4_CONFIG                                                      #
#                                                                        #
##########################################################################

%tio_01_00595_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NODE_ID"                      => [   0,  50,  14, 0xFFFC000000000000, 0x00, 1, 0x0000000000000000, "Node Identification" ],
   "BASE"                         => [   1,  20,  30, 0x0003FFFFFFF00000, 0x00, 1, 0x0000000000000000, "Optional Processor Interrupt Base Pointer" ],
   "PID"                          => [   2,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   3,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   4,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%tio_01_00595_def =
( NAME    => "TIO_INT4_CONFIG",
  ADDRESS => 0x0000000090001480,
  NOTE    => "The TIO_INT4_CONFIG register along with the TIO_INT4 and note TIO_INT4_ENABLE registers provide IO nodes (i.e., TIO chips) with ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00595_flds
);


##########################################################################
#                                                                        #
#   TIO_INT5                                                             #
#                                                                        #
##########################################################################

%tio_01_00596_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND"                         => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Initiate an Interrupt" ],
   "IDX"                          => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
);

%tio_01_00596_def =
( NAME    => "TIO_INT5",
  ADDRESS => 0x0000000090001500,
  NOTE    => "The TIO_INT5 register along with the TIO_INT5_CONFIG and note TIO_INT5_ENABLE registers provide IO nodes (i.e., TIO chips) with ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00596_flds
);


##########################################################################
#                                                                        #
#   TIO_INT5_CONFIG                                                      #
#                                                                        #
##########################################################################

%tio_01_00597_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NODE_ID"                      => [   0,  50,  14, 0xFFFC000000000000, 0x00, 1, 0x0000000000000000, "Node Identification" ],
   "BASE"                         => [   1,  20,  30, 0x0003FFFFFFF00000, 0x00, 1, 0x0000000000000000, "Optional Processor Interrupt Base Pointer" ],
   "PID"                          => [   2,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   3,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   4,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%tio_01_00597_def =
( NAME    => "TIO_INT5_CONFIG",
  ADDRESS => 0x0000000090001580,
  NOTE    => "The TIO_INT5_CONFIG register along with the TIO_INT5 and note TIO_INT5_ENABLE registers provide IO nodes (i.e., TIO chips) with ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00597_flds
);


##########################################################################
#                                                                        #
#   TIO_INT6                                                             #
#                                                                        #
##########################################################################

%tio_01_00598_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND"                         => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Initiate an Interrupt" ],
   "IDX"                          => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
);

%tio_01_00598_def =
( NAME    => "TIO_INT6",
  ADDRESS => 0x0000000090001600,
  NOTE    => "The TIO_INT6 register along with the TIO_INT6_CONFIG and note TIO_INT6_ENABLE registers provide IO nodes (i.e., TIO chips) with ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00598_flds
);


##########################################################################
#                                                                        #
#   TIO_INT6_CONFIG                                                      #
#                                                                        #
##########################################################################

%tio_01_00599_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NODE_ID"                      => [   0,  50,  14, 0xFFFC000000000000, 0x00, 1, 0x0000000000000000, "Node Identification" ],
   "BASE"                         => [   1,  20,  30, 0x0003FFFFFFF00000, 0x00, 1, 0x0000000000000000, "Optional Processor Interrupt Base Pointer" ],
   "PID"                          => [   2,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   3,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   4,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%tio_01_00599_def =
( NAME    => "TIO_INT6_CONFIG",
  ADDRESS => 0x0000000090001680,
  NOTE    => "The TIO_INT6_CONFIG register along with the TIO_INT6 and note TIO_INT6_ENABLE registers provide IO nodes (i.e., TIO chips) with ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00599_flds
);


##########################################################################
#                                                                        #
#   TIO_INT7                                                             #
#                                                                        #
##########################################################################

%tio_01_00600_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND"                         => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Initiate an Interrupt" ],
   "IDX"                          => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Interrupt Vector" ],
);

%tio_01_00600_def =
( NAME    => "TIO_INT7",
  ADDRESS => 0x0000000090001700,
  NOTE    => "The TIO_INT7 register along with the TIO_INT7_CONFIG and note TIO_INT7_ENABLE registers provide IO nodes (i.e., TIO chips) with ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00600_flds
);


##########################################################################
#                                                                        #
#   TIO_INT7_CONFIG                                                      #
#                                                                        #
##########################################################################

%tio_01_00601_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NODE_ID"                      => [   0,  50,  14, 0xFFFC000000000000, 0x00, 1, 0x0000000000000000, "Node Identification" ],
   "BASE"                         => [   1,  20,  30, 0x0003FFFFFFF00000, 0x00, 1, 0x0000000000000000, "Optional Processor Interrupt Base Pointer" ],
   "PID"                          => [   2,   4,  16, 0x00000000000FFFF0, 0x00, 1, 0x0000000000000000, "Processor ID" ],
   "AGT"                          => [   3,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Agent" ],
   "TYPE"                         => [   4,   0,   3, 0x0000000000000007, 0x00, 1, 0x0000000000000000, "Interrupt Type" ],
);

%tio_01_00601_def =
( NAME    => "TIO_INT7_CONFIG",
  ADDRESS => 0x0000000090001780,
  NOTE    => "The TIO_INT7_CONFIG register along with the TIO_INT7 and note TIO_INT7_ENABLE registers provide IO nodes (i.e., TIO chips) with ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00601_flds
);


##########################################################################
#                                                                        #
#   TIO_INT0_ENABLE                                                      #
#                                                                        #
##########################################################################

%tio_01_00602_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIO_ENABLE"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable TIO Interrupt 0" ],
);

%tio_01_00602_def =
( NAME    => "TIO_INT0_ENABLE",
  ADDRESS => 0x0000000090001800,
  NOTE    => "The TIO_INT0_ENABLE register along with the TIO_INT0_CONFIG and note TIO_INT0 registers provides IO nodes (i.e., ICE chips) with",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00602_flds
);


##########################################################################
#                                                                        #
#   TIO_INT1_ENABLE                                                      #
#                                                                        #
##########################################################################

%tio_01_00603_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIO_ENABLE"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable TIO Interrupt 1" ],
);

%tio_01_00603_def =
( NAME    => "TIO_INT1_ENABLE",
  ADDRESS => 0x0000000090001880,
  NOTE    => "The TIO_INT1_ENABLE register along with the TIO_INT1_CONFIG and note TIO_INT1 registers provides IO nodes (i.e., ICE chips) with",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00603_flds
);


##########################################################################
#                                                                        #
#   TIO_INT2_ENABLE                                                      #
#                                                                        #
##########################################################################

%tio_01_00604_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIO_ENABLE"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable TIO Interrupt 2" ],
);

%tio_01_00604_def =
( NAME    => "TIO_INT2_ENABLE",
  ADDRESS => 0x0000000090001900,
  NOTE    => "The TIO_INT2_ENABLE register along with the TIO_INT2_CONFIG and note TIO_INT2 registers provides IO nodes (i.e., ICE chips) with",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00604_flds
);


##########################################################################
#                                                                        #
#   TIO_INT3_ENABLE                                                      #
#                                                                        #
##########################################################################

%tio_01_00605_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIO_ENABLE"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable TIO Interrupt 3" ],
);

%tio_01_00605_def =
( NAME    => "TIO_INT3_ENABLE",
  ADDRESS => 0x0000000090001980,
  NOTE    => "The TIO_INT3_ENABLE register along with the TIO_INT3_CONFIG and note TIO_INT3 registers provides IO nodes (i.e., ICE chips) with",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00605_flds
);


##########################################################################
#                                                                        #
#   TIO_INT4_ENABLE                                                      #
#                                                                        #
##########################################################################

%tio_01_00606_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIO_ENABLE"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable TIO Interrupt 4" ],
);

%tio_01_00606_def =
( NAME    => "TIO_INT4_ENABLE",
  ADDRESS => 0x0000000090001a00,
  NOTE    => "The TIO_INT4_ENABLE register along with the TIO_INT4_CONFIG and note TIO_INT4 registers provides IO nodes (i.e., ICE chips) with",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00606_flds
);


##########################################################################
#                                                                        #
#   TIO_INT5_ENABLE                                                      #
#                                                                        #
##########################################################################

%tio_01_00607_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIO_ENABLE"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable TIO Interrupt 5" ],
);

%tio_01_00607_def =
( NAME    => "TIO_INT5_ENABLE",
  ADDRESS => 0x0000000090001a80,
  NOTE    => "The TIO_INT5_ENABLE register along with the TIO_INT5_CONFIG and note TIO_INT5 registers provides IO nodes (i.e., ICE chips) with",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00607_flds
);


##########################################################################
#                                                                        #
#   TIO_INT6_ENABLE                                                      #
#                                                                        #
##########################################################################

%tio_01_00608_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIO_ENABLE"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable TIO Interrupt 6" ],
);

%tio_01_00608_def =
( NAME    => "TIO_INT6_ENABLE",
  ADDRESS => 0x0000000090001b00,
  NOTE    => "The TIO_INT6_ENABLE register along with the TIO_INT6_CONFIG and note TIO_INT6 registers provides IO nodes (i.e., ICE chips) with",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00608_flds
);


##########################################################################
#                                                                        #
#   TIO_INT7_ENABLE                                                      #
#                                                                        #
##########################################################################

%tio_01_00609_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIO_ENABLE"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable TIO Interrupt 7" ],
);

%tio_01_00609_def =
( NAME    => "TIO_INT7_ENABLE",
  ADDRESS => 0x0000000090001b80,
  NOTE    => "The TIO_INT7_ENABLE register along with the TIO_INT7_CONFIG and note TIO_INT7 registers provides IO nodes (i.e., ICE chips) with",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00609_flds
);


##########################################################################
#                                                                        #
#   TIO_EVENT_OCCURRED                                                   #
#                                                                        #
##########################################################################

%tio_01_00610_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ASIC_TO_L1"                   => [   1,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "ASIC to L1 Interrupt Pending" ],
   "STOP_CLOCK"                   => [   2,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Stop Clock Interrupt Pending" ],
   "RSVD1"                        => [   3,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "L1 to ASIC Interrupt Pending" ],
   "SYSTEM_SHUTDOWN_INT"          => [   5,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "System Shutdown Interrupt Pending" ],
   "RSVD2"                        => [   6,  11,   8, 0x000000000007F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   7,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "XN Uncorrectable Error Interrupt Pending" ],
   "RSVD3"                        => [   8,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_CE_INT"                    => [   9,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "XN Correctable Error Interrupt Pending" ],
   "RSVD4"                        => [  10,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_HW_INT"                    => [  11,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "LB Hardware Interrupt Pending" ],
   "XN_HW_INT"                    => [  12,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Hardware Interrupt Pending" ],
   "RSVD5"                        => [  13,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ICE_HW_INT"                   => [  14,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "ICE Hardware Interrupt Pending" ],
);

%tio_01_00610_def =
( NAME    => "TIO_EVENT_OCCURRED",
  ADDRESS => 0x0000000090010000,
  NOTE    => "Each chiplet in the TIO ASIC detects and reports several types of note errors and events. When an error or event occurs, a chipl",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00610_flds
);


##########################################################################
#                                                                        #
#   TIO_EVENT_OCCURRED_ALIAS                                             #
#                                                                        #
##########################################################################

%tio_01_00611_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ASIC_TO_L1"                   => [   1,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "ASIC to L1 Interrupt Pending" ],
   "STOP_CLOCK"                   => [   2,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Stop Clock Interrupt Pending" ],
   "RSVD1"                        => [   3,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "L1 to ASIC Interrupt Pending" ],
   "SYSTEM_SHUTDOWN_INT"          => [   5,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "System Shutdown Interrupt Pending" ],
   "RSVD2"                        => [   6,  11,   8, 0x000000000007F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   7,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "XN Uncorrectable Error Interrupt Pending" ],
   "RSVD3"                        => [   8,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_CE_INT"                    => [   9,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "XN Correctable Error Interrupt Pending" ],
   "RSVD4"                        => [  10,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_HW_INT"                    => [  11,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "LB Hardware Interrupt Pending" ],
   "XN_HW_INT"                    => [  12,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Hardware Interrupt Pending" ],
   "RSVD5"                        => [  13,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ICE_HW_INT"                   => [  14,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "ICE Hardware Interrupt Pending" ],
);

%tio_01_00611_def =
( NAME    => "TIO_EVENT_OCCURRED_ALIAS",
  ADDRESS => 0x0000000090010008,
  NOTE    => "The EVENT_OCCURRED_ALIAS address is an alias to the EVENT_OCCURRED note register. Refer to the EVENT_OCCURRED register descripti",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00611_flds
);


##########################################################################
#                                                                        #
#   TIO_EVENT_OVERFLOW                                                   #
#                                                                        #
##########################################################################

%tio_01_00612_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ASIC_TO_L1"                   => [   1,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "ASIC to L1 Interrupt Overflow" ],
   "STOP_CLOCK"                   => [   2,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Stop Clock Interrupt Overflow" ],
   "RSVD1"                        => [   3,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "L1 to ASIC Interrupt Overflow" ],
   "SYSTEM_SHUTDOWN_INT"          => [   5,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "System Shutdown Interrupt Overflow" ],
   "RSVD2"                        => [   6,  11,   8, 0x000000000007F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   7,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "XN Correctable Error Interrupt Overflow" ],
   "RSVD3"                        => [   8,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_CE_INT"                    => [   9,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "XN Correctable Error Interrupt Overflow" ],
   "RSVD4"                        => [  10,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_HW_INT"                    => [  11,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "LB Hardware Interrupt Overflow" ],
   "XN_HW_INT"                    => [  12,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Hardware Interrupt Overflow" ],
   "RSVD5"                        => [  13,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ICE_HW_INT"                   => [  14,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "ICE Hardware Interrupt Overflow" ],
);

%tio_01_00612_def =
( NAME    => "TIO_EVENT_OVERFLOW",
  ADDRESS => 0x0000000090010080,
  NOTE    => "The EVENT_OVERFLOW register contains 28 flags. When a flag is note asserted, it indicates that the associtated event has occurre",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00612_flds
);


##########################################################################
#                                                                        #
#   TIO_EVENT_OVERFLOW_ALIAS                                             #
#                                                                        #
##########################################################################

%tio_01_00613_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ASIC_TO_L1"                   => [   1,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "ASIC to L1 Interrupt Overflow" ],
   "STOP_CLOCK"                   => [   2,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "Stop Clock Interrupt Overflow" ],
   "RSVD1"                        => [   3,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "L1_TO_ASIC"                   => [   4,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "L1 to ASIC Interrupt Overflow" ],
   "SYSTEM_SHUTDOWN_INT"          => [   5,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "System Shutdown Interrupt Overflow" ],
   "RSVD2"                        => [   6,  11,   8, 0x000000000007F800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_UCE_INT"                   => [   7,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "XN Correctable Error Interrupt Overflow" ],
   "RSVD3"                        => [   8,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XN_CE_INT"                    => [   9,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "XN Correctable Error Interrupt Overflow" ],
   "RSVD4"                        => [  10,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LB_HW_INT"                    => [  11,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "LB Hardware Interrupt Overflow" ],
   "XN_HW_INT"                    => [  12,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "XN Hardware Interrupt Overflow" ],
   "RSVD5"                        => [  13,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ICE_HW_INT"                   => [  14,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "ICE Hardware Interrupt Overflow" ],
);

%tio_01_00613_def =
( NAME    => "TIO_EVENT_OVERFLOW_ALIAS",
  ADDRESS => 0x0000000090010088,
  NOTE    => "The EVENT_OVERFLOW_ALIAS address is an alias to the EVENT_OVERFLOW note register. Refer to the EVENT_OVERFLOW register descripti",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00613_flds
);


##########################################################################
#                                                                        #
#   TIO_ASIC_TO_L1_DATA                                                  #
#                                                                        #
##########################################################################

%tio_01_00614_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%tio_01_00614_def =
( NAME    => "TIO_ASIC_TO_L1_DATA",
  ADDRESS => 0x0000000090038000,
  NOTE    => "The asic_to_l1_data register contains the data to be transfered to note the L1 controller. This register is used in place of the",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00614_flds
);


##########################################################################
#                                                                        #
#   TIO_ASIC_TO_L1_STATUS                                                #
#                                                                        #
##########################################################################

%tio_01_00615_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATUS"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Status, 1 = busy, 0 = idle" ],
);

%tio_01_00615_def =
( NAME    => "TIO_ASIC_TO_L1_STATUS",
  ADDRESS => 0x0000000090038080,
  NOTE    => "The asic_to_l1_status register contains the status of the asic to note L1 controller data transfer.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00615_flds
);


##########################################################################
#                                                                        #
#   TIO_L1_TO_ASIC_DATA                                                  #
#                                                                        #
##########################################################################

%tio_01_00616_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Data" ],
);

%tio_01_00616_def =
( NAME    => "TIO_L1_TO_ASIC_DATA",
  ADDRESS => 0x0000000090038100,
  NOTE    => "The l1_to_asic_data register contains the data transfered from the note L1 controller to the asic. This register is used in plac",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00616_flds
);


##########################################################################
#                                                                        #
#   TIO_L1_TO_ASIC_STATUS                                                #
#                                                                        #
##########################################################################

%tio_01_00617_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "STATUS"                       => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Status, 1 = busy, 0 = idle" ],
);

%tio_01_00617_def =
( NAME    => "TIO_L1_TO_ASIC_STATUS",
  ADDRESS => 0x0000000090038180,
  NOTE    => "The l1_to_asic_status register contains the status of the L1 to note asic data transfer. This register is used in place of the U",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00617_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_LLP_STAT                                                     #
#                                                                        #
##########################################################################

%tio_01_00618_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINK_RESET_STATE"             => [   1,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Status of LLP link." ],
);

%tio_01_00618_def =
( NAME    => "TIO_NI0_LLP_STAT",
  ADDRESS => 0x00000000d0000000,
  NOTE    => "This register describes the LLP status.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00618_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_LLP_RESET                                                    #
#                                                                        #
##########################################################################

%tio_01_00619_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WARM"                         => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Send Warm Reset. Generates a pulse." ],
   "LINK"                         => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Send Link Reset. Generates a pulse." ],
);

%tio_01_00619_def =
( NAME    => "TIO_NI0_LLP_RESET",
  ADDRESS => 0x00000000d0000008,
  NOTE    => "Writing issues a reset to the network interface",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00619_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_LLP_RESET_EN                                                 #
#                                                                        #
##########################################################################

%tio_01_00620_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OK"                           => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Allow LLP warm reset to reset SHUB" ],
);

%tio_01_00620_def =
( NAME    => "TIO_NI0_LLP_RESET_EN",
  ADDRESS => 0x00000000d0000010,
  NOTE    => "Controls LLP warm reset propagation",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00620_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_LLP_CHAN_MODE                                                #
#                                                                        #
##########################################################################

%tio_01_00621_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_CLKQUAD"               => [   1,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Reserved for future use. Terminated at dest." ],
   "ENABLE_RMT_FT_UPD"            => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Enables remote fine tune updates" ],
   "ENABLE_TUNING"                => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Enables automatic tuning of channel skew." ],
   "AC_ENCODE"                    => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Enables nearly dc-free encoding for AC-coupling" ],
   "BITMODE32"                    => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Enables 32-bit (plus sideband) channel phits" ],
);

%tio_01_00621_def =
( NAME    => "TIO_NI0_LLP_CHAN_MODE",
  ADDRESS => 0x00000000d0000018,
  NOTE    => "Sets the signaling mode of LLP and channel",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00621_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_LLP_CONFIG                                                   #
#                                                                        #
##########################################################################

%tio_01_00622_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FTU_TIME"                     => [   1,  26,  12, 0x0000003FFC000000, 0x00, 1, 0x0000000000000000, "" ],
   "NULLTIMEOUT"                  => [   2,  20,   6, 0x0000000003F00000, 0x00, 1, 0x0000000000000000, "" ],
   "MAXRETRY"                     => [   3,  10,  10, 0x00000000000FFC00, 0x00, 1, 0x0000000000000000, "" ],
   "MAXBURST"                     => [   4,   0,  10, 0x00000000000003FF, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00622_def =
( NAME    => "TIO_NI0_LLP_CONFIG",
  ADDRESS => 0x00000000d0000020,
  NOTE    => "Sets the configuration of LLP and channel",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00622_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_LLP_TEST_CTL                                                 #
#                                                                        #
##########################################################################

%tio_01_00623_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CBERROR"                      => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Indicates a Micropacket with a CB error was captured" ],
   "CAPTURED"                     => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Indicates a Valid Micropacket was captured" ],
   "FAKESNERROR"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Causes receiver to pretend it saw a sn error" ],
   "SENDSNERROR"                  => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Sends a single sequence number error" ],
   "SENDCBERROR"                  => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Sends a single error" ],
   "CAPTURECBONLY"                => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Only capture a micropacket with a Check Byte error" ],
   "ARMCAPTURE"                   => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Enable Capture of Next MicroPacket" ],
   "NOISE_MODE"                   => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LFSR_MODE"                    => [   9,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [  10,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_SEL"                     => [  11,  44,   6, 0x0003F00000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [  12,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_TEST_MODE"               => [  13,  40,   2, 0x0000030000000000, 0x00, 1, 0x0000000000000000, "Enables continuous send of data" ],
   "PATTERN"                      => [  14,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Send channel data pattern" ],
);

%tio_01_00623_def =
( NAME    => "TIO_NI0_LLP_TEST_CTL",
  ADDRESS => 0x00000000d0000028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00623_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_LLP_CAPT_WD1                                                 #
#                                                                        #
##########################################################################

%tio_01_00624_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "low order 64-bit captured word" ],
);

%tio_01_00624_def =
( NAME    => "TIO_NI0_LLP_CAPT_WD1",
  ADDRESS => 0x00000000d0000030,
  NOTE    => "low order 64-bit captured word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00624_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_LLP_CAPT_WD2                                                 #
#                                                                        #
##########################################################################

%tio_01_00625_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "high order 64-bit captured word" ],
);

%tio_01_00625_def =
( NAME    => "TIO_NI0_LLP_CAPT_WD2",
  ADDRESS => 0x00000000d0000038,
  NOTE    => "high order 64-bit captured word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00625_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_LLP_CAPT_SBCB                                                #
#                                                                        #
##########################################################################

%tio_01_00626_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CHARGEUNDERFLOW"              => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "wire charge counter underflowed, valid if llp_mode enabled" ],
   "CHARGEOVERFLOW"               => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "wire charge counter overflowed, valid if llp_mode enabled" ],
   "FAKEDALLSNERRORS"             => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "All faked SN errors have been sent" ],
   "SENTALLSNERRORS"              => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "All SN errors have been sent" ],
   "SENTALLCBERRORS"              => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "All CB errors have been sent" ],
   "CAPTUREDRCVCRC"               => [   6,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "CRC" ],
   "CAPTUREDRCVSBSN"              => [   7,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "sideband and sequence" ],
);

%tio_01_00626_def =
( NAME    => "TIO_NI0_LLP_CAPT_SBCB",
  ADDRESS => 0x00000000d0000040,
  NOTE    => "This register contains the sideband, sequence number, and CRC of note the flit that was captured. See LLP_CAPT_WD1 for descripti",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00626_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_LLP_ERR                                                      #
#                                                                        #
##########################################################################

%tio_01_00627_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_OVERFLOW"                => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "wire_error_cnt has overflowed" ],
   "WIRE_CNT"                     => [   2,  36,  24, 0x0FFFFFF000000000, 0x00, 0, 0x0000000000000000, "counts the errors detected on a single wire test" ],
   "POWER_NOT_OK"                 => [   3,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Detects and traps a loss of power_OK" ],
   "SQUASH"                       => [   4,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "Indicates a micropacket was squashed" ],
   "RCV_LINK_RESET"               => [   5,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Indicates a link reset has been received" ],
   "RETRY_TIMEOUT"                => [   6,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Indicates a retry timeout has occured" ],
   "RETRY_COUNT"                  => [   7,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Counts the retries" ],
   "RX_CB_ERR_COUNT"              => [   8,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Counts the check byte errors received" ],
   "RX_SN_ERR_COUNT"              => [   9,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Counts the sequence number errors received" ],
);

%tio_01_00627_def =
( NAME    => "TIO_NI0_LLP_ERR",
  ADDRESS => 0x00000000d0000048,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00627_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_LLP_STAT                                                     #
#                                                                        #
##########################################################################

%tio_01_00628_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   4,  60, 0xFFFFFFFFFFFFFFF0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LINK_RESET_STATE"             => [   1,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Status of LLP link." ],
);

%tio_01_00628_def =
( NAME    => "TIO_NI1_LLP_STAT",
  ADDRESS => 0x00000000d0002000,
  NOTE    => "This register describes the LLP status.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00628_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_LLP_RESET                                                    #
#                                                                        #
##########################################################################

%tio_01_00629_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WARM"                         => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Send Warm Reset. Generates a pulse." ],
   "LINK"                         => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Send Link Reset. Generates a pulse." ],
);

%tio_01_00629_def =
( NAME    => "TIO_NI1_LLP_RESET",
  ADDRESS => 0x00000000d0002008,
  NOTE    => "Writing issues a reset to the network interface",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00629_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_LLP_RESET_EN                                                 #
#                                                                        #
##########################################################################

%tio_01_00630_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OK"                           => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Allow LLP warm reset to reset SHUB" ],
);

%tio_01_00630_def =
( NAME    => "TIO_NI1_LLP_RESET_EN",
  ADDRESS => 0x00000000d0002010,
  NOTE    => "Controls LLP warm reset propagation",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00630_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_LLP_CHAN_MODE                                                #
#                                                                        #
##########################################################################

%tio_01_00631_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_CLKQUAD"               => [   1,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Reserved for future use. Terminated at dest." ],
   "ENABLE_RMT_FT_UPD"            => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Enables remote fine tune updates" ],
   "ENABLE_TUNING"                => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Enables automatic tuning of channel skew." ],
   "AC_ENCODE"                    => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Enables nearly dc-free encoding for AC-coupling" ],
   "BITMODE32"                    => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Enables 32-bit (plus sideband) channel phits" ],
);

%tio_01_00631_def =
( NAME    => "TIO_NI1_LLP_CHAN_MODE",
  ADDRESS => 0x00000000d0002018,
  NOTE    => "Sets the signaling mode of LLP and channel",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00631_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_LLP_CONFIG                                                   #
#                                                                        #
##########################################################################

%tio_01_00632_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FTU_TIME"                     => [   1,  26,  12, 0x0000003FFC000000, 0x00, 1, 0x0000000000000000, "" ],
   "NULLTIMEOUT"                  => [   2,  20,   6, 0x0000000003F00000, 0x00, 1, 0x0000000000000000, "" ],
   "MAXRETRY"                     => [   3,  10,  10, 0x00000000000FFC00, 0x00, 1, 0x0000000000000000, "" ],
   "MAXBURST"                     => [   4,   0,  10, 0x00000000000003FF, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00632_def =
( NAME    => "TIO_NI1_LLP_CONFIG",
  ADDRESS => 0x00000000d0002020,
  NOTE    => "Sets the configuration of LLP and channel",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00632_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_LLP_TEST_CTL                                                 #
#                                                                        #
##########################################################################

%tio_01_00633_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CBERROR"                      => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "Indicates a Micropacket with a CB error was captured" ],
   "CAPTURED"                     => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Indicates a Valid Micropacket was captured" ],
   "FAKESNERROR"                  => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "Causes receiver to pretend it saw a sn error" ],
   "SENDSNERROR"                  => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Sends a single sequence number error" ],
   "SENDCBERROR"                  => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "Sends a single error" ],
   "CAPTURECBONLY"                => [   6,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "Only capture a micropacket with a Check Byte error" ],
   "ARMCAPTURE"                   => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "Enable Capture of Next MicroPacket" ],
   "NOISE_MODE"                   => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LFSR_MODE"                    => [   9,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [  10,  50,   2, 0x000C000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_SEL"                     => [  11,  44,   6, 0x0003F00000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [  12,  42,   2, 0x00000C0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SEND_TEST_MODE"               => [  13,  40,   2, 0x0000030000000000, 0x00, 1, 0x0000000000000000, "Enables continuous send of data" ],
   "PATTERN"                      => [  14,   0,  40, 0x000000FFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Send channel data pattern" ],
);

%tio_01_00633_def =
( NAME    => "TIO_NI1_LLP_TEST_CTL",
  ADDRESS => 0x00000000d0002028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00633_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_LLP_CAPT_WD1                                                 #
#                                                                        #
##########################################################################

%tio_01_00634_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "low order 64-bit captured word" ],
);

%tio_01_00634_def =
( NAME    => "TIO_NI1_LLP_CAPT_WD1",
  ADDRESS => 0x00000000d0002030,
  NOTE    => "low order 64-bit captured word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00634_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_LLP_CAPT_WD2                                                 #
#                                                                        #
##########################################################################

%tio_01_00635_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "high order 64-bit captured word" ],
);

%tio_01_00635_def =
( NAME    => "TIO_NI1_LLP_CAPT_WD2",
  ADDRESS => 0x00000000d0002038,
  NOTE    => "high order 64-bit captured word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00635_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_LLP_CAPT_SBCB                                                #
#                                                                        #
##########################################################################

%tio_01_00636_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  37,  27, 0xFFFFFFE000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CHARGEUNDERFLOW"              => [   1,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "wire charge counter underflowed, valid if llp_mode enabled" ],
   "CHARGEOVERFLOW"               => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "wire charge counter overflowed, valid if llp_mode enabled" ],
   "FAKEDALLSNERRORS"             => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "All faked SN errors have been sent" ],
   "SENTALLSNERRORS"              => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "All SN errors have been sent" ],
   "SENTALLCBERRORS"              => [   5,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "All CB errors have been sent" ],
   "CAPTUREDRCVCRC"               => [   6,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "CRC" ],
   "CAPTUREDRCVSBSN"              => [   7,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "sideband and sequence" ],
);

%tio_01_00636_def =
( NAME    => "TIO_NI1_LLP_CAPT_SBCB",
  ADDRESS => 0x00000000d0002040,
  NOTE    => "This register contains the sideband, sequence number, and CRC of note the flit that was captured. See LLP_CAPT_WD1 for descripti",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00636_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_LLP_ERR                                                      #
#                                                                        #
##########################################################################

%tio_01_00637_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WIRE_OVERFLOW"                => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "wire_error_cnt has overflowed" ],
   "WIRE_CNT"                     => [   2,  36,  24, 0x0FFFFFF000000000, 0x00, 0, 0x0000000000000000, "counts the errors detected on a single wire test" ],
   "POWER_NOT_OK"                 => [   3,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Detects and traps a loss of power_OK" ],
   "SQUASH"                       => [   4,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "Indicates a micropacket was squashed" ],
   "RCV_LINK_RESET"               => [   5,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Indicates a link reset has been received" ],
   "RETRY_TIMEOUT"                => [   6,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "Indicates a retry timeout has occured" ],
   "RETRY_COUNT"                  => [   7,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Counts the retries" ],
   "RX_CB_ERR_COUNT"              => [   8,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Counts the check byte errors received" ],
   "RX_SN_ERR_COUNT"              => [   9,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "Counts the sequence number errors received" ],
);

%tio_01_00637_def =
( NAME    => "TIO_NI1_LLP_ERR",
  ADDRESS => 0x00000000d0002048,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00637_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_LLP_DEBIT_FLOW                                             #
#                                                                        #
##########################################################################

%tio_01_00638_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_CAP"                => [   1,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 debit captured value" ],
   "RSVD1"                        => [   2,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_DYN"                => [   3,  48,   5, 0x001F000000000000, 0x00, 0, 0x0000000000000000, "vc3 debit dynamic value" ],
   "RSVD2"                        => [   4,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_CAP"                => [   5,  40,   5, 0x00001F0000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD3"                        => [   6,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_DYN"                => [   7,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD4"                        => [   8,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_CAP"                => [   9,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "vc1 debit captured value" ],
   "RSVD5"                        => [  10,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_DYN"                => [  11,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "vc1 debit dynamic value" ],
   "RSVD6"                        => [  12,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_CAP"                => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD7"                        => [  14,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_DYN"                => [  15,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
);

%tio_01_00638_def =
( NAME    => "TIO_XNNI0_LLP_DEBIT_FLOW",
  ADDRESS => 0x00000000d0001030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00638_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_LINK_0_FLOW                                                #
#                                                                        #
##########################################################################

%tio_01_00639_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc0 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc0 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc0 Limit Test" ],
   "DEBIT_VC0_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc0 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%tio_01_00639_def =
( NAME    => "TIO_XNNI0_LINK_0_FLOW",
  ADDRESS => 0x00000000d0001040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00639_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_LINK_1_FLOW                                                #
#                                                                        #
##########################################################################

%tio_01_00640_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc1 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc1 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc1 Limit Test" ],
   "DEBIT_VC1_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc1 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc1 withhold" ],
);

%tio_01_00640_def =
( NAME    => "TIO_XNNI0_LINK_1_FLOW",
  ADDRESS => 0x00000000d0001050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00640_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_LINK_2_FLOW                                                #
#                                                                        #
##########################################################################

%tio_01_00641_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc2 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc2 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc2 Limit Test" ],
   "DEBIT_VC2_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc2 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
);

%tio_01_00641_def =
( NAME    => "TIO_XNNI0_LINK_2_FLOW",
  ADDRESS => 0x00000000d0001060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00641_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_LINK_3_FLOW                                                #
#                                                                        #
##########################################################################

%tio_01_00642_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc3 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc3 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc3 Limit Test" ],
   "DEBIT_VC3_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc3 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc3 withhold" ],
);

%tio_01_00642_def =
( NAME    => "TIO_XNNI0_LINK_3_FLOW",
  ADDRESS => 0x00000000d0001070,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00642_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_LLP_DEBIT_FLOW                                             #
#                                                                        #
##########################################################################

%tio_01_00643_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  61,   3, 0xE000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_CAP"                => [   1,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 debit captured value" ],
   "RSVD1"                        => [   2,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_DYN"                => [   3,  48,   5, 0x001F000000000000, 0x00, 0, 0x0000000000000000, "vc3 debit dynamic value" ],
   "RSVD2"                        => [   4,  45,   3, 0x0000E00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_CAP"                => [   5,  40,   5, 0x00001F0000000000, 0x00, 0, 0x0000000000000000, "vc2 debit captured value" ],
   "RSVD3"                        => [   6,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_DYN"                => [   7,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "vc2 debit dynamic value" ],
   "RSVD4"                        => [   8,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_CAP"                => [   9,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "vc1 debit captured value" ],
   "RSVD5"                        => [  10,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_DYN"                => [  11,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "vc1 debit dynamic value" ],
   "RSVD6"                        => [  12,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_CAP"                => [  13,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "vc0 debit captured value" ],
   "RSVD7"                        => [  14,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_DYN"                => [  15,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "vc0 debit dynamic value" ],
);

%tio_01_00643_def =
( NAME    => "TIO_XNNI1_LLP_DEBIT_FLOW",
  ADDRESS => 0x00000000d0003030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00643_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_LINK_0_FLOW                                                #
#                                                                        #
##########################################################################

%tio_01_00644_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc0 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc0 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc0 Limit Test" ],
   "DEBIT_VC0_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc0 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc0 withhold" ],
);

%tio_01_00644_def =
( NAME    => "TIO_XNNI1_LINK_0_FLOW",
  ADDRESS => 0x00000000d0003040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00644_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_LINK_1_FLOW                                                #
#                                                                        #
##########################################################################

%tio_01_00645_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc1 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc1 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC1_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc1 Limit Test" ],
   "DEBIT_VC1_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc1 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc1 withhold" ],
);

%tio_01_00645_def =
( NAME    => "TIO_XNNI1_LINK_1_FLOW",
  ADDRESS => 0x00000000d0003050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00645_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_LINK_2_FLOW                                                #
#                                                                        #
##########################################################################

%tio_01_00646_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc2 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc2 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc2 Limit Test" ],
   "DEBIT_VC2_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc2 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc2 withhold" ],
);

%tio_01_00646_def =
( NAME    => "TIO_XNNI1_LINK_2_FLOW",
  ADDRESS => 0x00000000d0003060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00646_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_LINK_3_FLOW                                                #
#                                                                        #
##########################################################################

%tio_01_00647_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_CAP"               => [   1,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "Captured vc3 credit" ],
   "RSVD1"                        => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_DYN"               => [   3,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "Dynamic vc3 credit value" ],
   "RSVD2"                        => [   4,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC3_TEST"              => [   5,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "vc3 Limit Test" ],
   "DEBIT_VC3_FORCE_CRED"         => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on vc3 from debit cntr" ],
   "RSVD3"                        => [   7,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [   8,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "vc3 withhold" ],
);

%tio_01_00647_def =
( NAME    => "TIO_XNNI1_LINK_3_FLOW",
  ADDRESS => 0x00000000d0003070,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00647_flds
);


##########################################################################
#                                                                        #
#   TIO_IILB_LOCAL_TABLE                                                 #
#                                                                        #
##########################################################################

%tio_01_00648_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V0"                           => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   4,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%tio_01_00648_def =
( NAME    => "TIO_IILB_LOCAL_TABLE",
  ADDRESS => 0x00000000d0020000,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00648_flds
);


##########################################################################
#                                                                        #
#   TIO_IILB_GLOBAL_TABLE                                                #
#                                                                        #
##########################################################################

%tio_01_00649_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "ni select" ],
   "V0"                           => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   4,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%tio_01_00649_def =
( NAME    => "TIO_IILB_GLOBAL_TABLE",
  ADDRESS => 0x00000000d0020800,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00649_flds
);


##########################################################################
#                                                                        #
#   TIO_IILB_OVER_RIDE_TABLE                                             #
#                                                                        #
##########################################################################

%tio_01_00650_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,   6,  57, 0x7FFFFFFFFFFFFFC0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_SEL0"                      => [   2,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "ni select" ],
   "V0"                           => [   3,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   4,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%tio_01_00650_def =
( NAME    => "TIO_IILB_OVER_RIDE_TABLE",
  ADDRESS => 0x00000000d0021000,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00650_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_LOCAL_TABLE                                                  #
#                                                                        #
##########################################################################

%tio_01_00651_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%tio_01_00651_def =
( NAME    => "TIO_NI0_LOCAL_TABLE",
  ADDRESS => 0x00000000d0024000,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00651_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_GLOBAL_TABLE                                                 #
#                                                                        #
##########################################################################

%tio_01_00652_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%tio_01_00652_def =
( NAME    => "TIO_NI0_GLOBAL_TABLE",
  ADDRESS => 0x00000000d0024800,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00652_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_OVER_RIDE_TABLE                                              #
#                                                                        #
##########################################################################

%tio_01_00653_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%tio_01_00653_def =
( NAME    => "TIO_NI0_OVER_RIDE_TABLE",
  ADDRESS => 0x00000000d0025000,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00653_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_LOCAL_TABLE                                                  #
#                                                                        #
##########################################################################

%tio_01_00654_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%tio_01_00654_def =
( NAME    => "TIO_NI1_LOCAL_TABLE",
  ADDRESS => 0x00000000d0026000,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00654_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_GLOBAL_TABLE                                                 #
#                                                                        #
##########################################################################

%tio_01_00655_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Indicates that this entry is valid" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Direction field for next chip" ],
);

%tio_01_00655_def =
( NAME    => "TIO_NI1_GLOBAL_TABLE",
  ADDRESS => 0x00000000d0026800,
  NOTE    => "This table provides the direction and vch for the outgoing header, note in the event that the global bits (upper bits) of the in",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00655_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_OVER_RIDE_TABLE                                              #
#                                                                        #
##########################################################################

%tio_01_00656_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "Indicates that this entry is enabled" ],
   "RSVD0"                        => [   1,   5,  58, 0x7FFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "V0"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Low bit of virtual channel for next chip" ],
   "DIR0"                         => [   3,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "Direction field for next chip" ],
);

%tio_01_00656_def =
( NAME    => "TIO_NI1_OVER_RIDE_TABLE",
  ADDRESS => 0x00000000d0027000,
  NOTE    => "If enabled, bypass the Global/Local tables",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00656_flds
);


##########################################################################
#                                                                        #
#   TIO_XNII_INTRA_FLOW                                                  #
#                                                                        #
##########################################################################

%tio_01_00657_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,  40,   7, 0x00007F0000000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   9,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [  11,  16,   7, 0x00000000007F0000, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
   "DEBIT_VC2_FORCE_CRED"         => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD6"                        => [  13,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  14,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  15,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD7"                        => [  16,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  17,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%tio_01_00657_def =
( NAME    => "TIO_XNII_INTRA_FLOW",
  ADDRESS => 0x00000000d0030200,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00657_flds
);


##########################################################################
#                                                                        #
#   TIO_XNLB_INTRA_FLOW                                                  #
#                                                                        #
##########################################################################

%tio_01_00658_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_CAP"               => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_DYN"               => [   3,  48,   7, 0x007F000000000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC2_TEST"              => [   5,  40,   7, 0x00007F0000000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_CAP"               => [   7,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_DYN"               => [   9,  24,   7, 0x000000007F000000, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CREDIT_VC0_TEST"              => [  11,  16,   7, 0x00000000007F0000, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
   "DEBIT_VC2_FORCE_CRED"         => [  12,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD6"                        => [  13,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [  14,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "DEBIT_VC0_FORCE_CRED"         => [  15,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD7"                        => [  16,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [  17,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%tio_01_00658_def =
( NAME    => "TIO_XNLB_INTRA_FLOW",
  ADDRESS => 0x00000000d0030210,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00658_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_TO_NI0_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%tio_01_00659_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 withhold" ],
);

%tio_01_00659_def =
( NAME    => "TIO_XNIILB_TO_NI0_INTRA_FLOW_DEBIT",
  ADDRESS => 0x00000000d0030220,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00659_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_TO_NI0_INTRA_FLOW_DEBIT13                                     #
#                                                                        #
##########################################################################

%tio_01_00660_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
   "VC1_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%tio_01_00660_def =
( NAME    => "TIO_XNIILB_TO_NI0_INTRA_FLOW_DEBIT13",
  ADDRESS => 0x00000000d0030230,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00660_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_TO_NI1_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%tio_01_00661_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 withhold" ],
);

%tio_01_00661_def =
( NAME    => "TIO_XNIILB_TO_NI1_INTRA_FLOW_DEBIT",
  ADDRESS => 0x00000000d0030240,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00661_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_TO_NI1_INTRA_FLOW_DEBIT13                                     #
#                                                                        #
##########################################################################

%tio_01_00662_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
   "VC1_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%tio_01_00662_def =
( NAME    => "TIO_XNIILB_TO_NI1_INTRA_FLOW_DEBIT13",
  ADDRESS => 0x00000000d0030250,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00662_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_TO_IILB_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%tio_01_00663_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 withhold" ],
);

%tio_01_00663_def =
( NAME    => "TIO_XNIILB_TO_IILB_INTRA_FLOW_DEBIT",
  ADDRESS => 0x00000000d0030260,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00663_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_FR_NI0_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%tio_01_00664_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
);

%tio_01_00664_def =
( NAME    => "TIO_XNIILB_FR_NI0_INTRA_FLOW_CREDIT",
  ADDRESS => 0x00000000d00302b0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00664_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_FR_NI1_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%tio_01_00665_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
);

%tio_01_00665_def =
( NAME    => "TIO_XNIILB_FR_NI1_INTRA_FLOW_CREDIT",
  ADDRESS => 0x00000000d00302c0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00665_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_FR_IILB_INTRA_FLOW_CREDIT                                     #
#                                                                        #
##########################################################################

%tio_01_00666_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  47,  17, 0xFFFF800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   7, 0x00007F0000000000, 0x00, 0, 0x0000000000000000, "VC2 credit captured value" ],
   "RSVD1"                        => [   2,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   7, 0x0000007F00000000, 0x00, 0, 0x0000000000000000, "VC2 credit dynamic value" ],
   "RSVD2"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_TEST"                     => [   5,  24,   7, 0x000000007F000000, 0x00, 1, 0x0000000000000000, "VC2 credit_test" ],
   "RSVD3"                        => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   7,  16,   7, 0x00000000007F0000, 0x00, 0, 0x0000000000000000, "VC0 credit captured value" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   9,   8,   7, 0x0000000000007F00, 0x00, 0, 0x0000000000000000, "VC0 credit dynamic value" ],
   "RSVD5"                        => [  10,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_TEST"                     => [  11,   0,   7, 0x000000000000007F, 0x00, 1, 0x0000000000000000, "VC0 credit_test" ],
);

%tio_01_00666_def =
( NAME    => "TIO_XNIILB_FR_IILB_INTRA_FLOW_CREDIT",
  ADDRESS => 0x00000000d00302d0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00666_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_II_FIFO_CREDIT_CNT                                        #
#                                                                        #
##########################################################################

%tio_01_00667_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  46,  18, 0xFFFFC00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   6, 0x00003F0000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
);

%tio_01_00667_def =
( NAME    => "TIO_XNIILB_II_FIFO_CREDIT_CNT",
  ADDRESS => 0x00000000d0030300,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00667_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_LB_FIFO_CREDIT_CNT                                        #
#                                                                        #
##########################################################################

%tio_01_00668_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  46,  18, 0xFFFFC00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  40,   6, 0x00003F0000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  22,  10, 0x00000000FFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
);

%tio_01_00668_def =
( NAME    => "TIO_XNIILB_LB_FIFO_CREDIT_CNT",
  ADDRESS => 0x00000000d0030310,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00668_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_ARB_CONFIG_SI                                             #
#                                                                        #
##########################################################################

%tio_01_00669_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_FULL_BYP_SI"           => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable Bypass Mode" ],
);

%tio_01_00669_def =
( NAME    => "TIO_XNIILB_ARB_CONFIG_SI",
  ADDRESS => 0x00000000d0030320,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00669_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_ARB_CONFIG_SO                                             #
#                                                                        #
##########################################################################

%tio_01_00670_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_FULL_BYP_SO"           => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable Bypass Mode" ],
);

%tio_01_00670_def =
( NAME    => "TIO_XNIILB_ARB_CONFIG_SO",
  ADDRESS => 0x00000000d0030330,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00670_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_AGE_WRAP0                                                 #
#                                                                        #
##########################################################################

%tio_01_00671_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC1_VC1_SI"                  => [   1,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "LB VC2 Pre-Scale Value" ],
   "SRC1_VC0_SI"                  => [   2,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "LB VC0 Pre-Scale Value" ],
   "SRC0_VC1_SI"                  => [   3,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "II VC2 Pre-Scale Value" ],
   "SRC0_VC0_SI"                  => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "II VC0 Pre-Scale Value" ],
);

%tio_01_00671_def =
( NAME    => "TIO_XNIILB_AGE_WRAP0",
  ADDRESS => 0x00000000d0030340,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00671_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_AGE_WRAP1                                                 #
#                                                                        #
##########################################################################

%tio_01_00672_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC2_VC1_SO"                  => [   1,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC3 Pre-Scale Value" ],
   "SRC2_VC0_SO"                  => [   2,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC1 Pre-Scale Value" ],
   "SRC1_VC1_SO"                  => [   3,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC2 Pre-Scale Value" ],
   "SRC1_VC0_SO"                  => [   4,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_NI0 VC0 Pre-Scale Value" ],
   "SRC0_VC1_SO"                  => [   5,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_IILB VC2 Pre-Scale Value" ],
   "SRC0_VC0_SO"                  => [   6,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_IILB VC0 Pre-Scale Value" ],
);

%tio_01_00672_def =
( NAME    => "TIO_XNIILB_AGE_WRAP1",
  ADDRESS => 0x00000000d0030350,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00672_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_AGE_WRAP2                                                 #
#                                                                        #
##########################################################################

%tio_01_00673_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SRC4_VC1_SO"                  => [   1,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_NI1 VC3 Pre-Scale Value" ],
   "SRC4_VC0_SO"                  => [   2,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_NI1 VC1 Pre-Scale Value" ],
   "SRC3_VC1_SO"                  => [   3,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_NI1 VC2 Pre-Scale Value" ],
   "SRC3_VC0_SO"                  => [   4,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_NI1 VC0 Pre-Scale Value" ],
);

%tio_01_00673_def =
( NAME    => "TIO_XNIILB_AGE_WRAP2",
  ADDRESS => 0x00000000d0030360,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00673_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_TO_IILB_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%tio_01_00674_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 withhold" ],
);

%tio_01_00674_def =
( NAME    => "TIO_XNNI0_TO_IILB_INTRA_FLOW_DEBIT",
  ADDRESS => 0x00000000d0030400,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00674_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_0_INTRANI_FLOW                                             #
#                                                                        #
##########################################################################

%tio_01_00675_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%tio_01_00675_def =
( NAME    => "TIO_XNNI0_0_INTRANI_FLOW",
  ADDRESS => 0x00000000d0030450,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00675_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_1_INTRANI_FLOW                                             #
#                                                                        #
##########################################################################

%tio_01_00676_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%tio_01_00676_def =
( NAME    => "TIO_XNNI0_1_INTRANI_FLOW",
  ADDRESS => 0x00000000d0030460,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00676_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_2_INTRANI_FLOW                                             #
#                                                                        #
##########################################################################

%tio_01_00677_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%tio_01_00677_def =
( NAME    => "TIO_XNNI0_2_INTRANI_FLOW",
  ADDRESS => 0x00000000d0030470,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00677_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_3_INTRANI_FLOW                                             #
#                                                                        #
##########################################################################

%tio_01_00678_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
);

%tio_01_00678_def =
( NAME    => "TIO_XNNI0_3_INTRANI_FLOW",
  ADDRESS => 0x00000000d0030480,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00678_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_VCSWITCH_FLOW                                              #
#                                                                        #
##########################################################################

%tio_01_00679_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_VCFIFO_SWITCH"           => [   1,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Select VC0/2 or VC1/3 for IILB" ],
   "RSVD1"                        => [   2,   1,  23, 0x0000000000FFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_VCFIFO_DATELINE_SWITCH"    => [   3,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Swap VC0/2 with VC1/3" ],
);

%tio_01_00679_def =
( NAME    => "TIO_XNNI0_VCSWITCH_FLOW",
  ADDRESS => 0x00000000d0030490,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00679_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_TIMER_REG                                                  #
#                                                                        #
##########################################################################

%tio_01_00680_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "QUEUECNTENABLE_REG"           => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "Queue Counter Enable" ],
   "LINKRESETENABLE_REG"          => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Link Reset Enable" ],
   "LINKCLEANUP_REG"              => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "Link Clean Up" ],
   "RSVD1"                        => [   4,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMEOUT_REG"                  => [   5,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Master Timeout Counter" ],
);

%tio_01_00680_def =
( NAME    => "TIO_XNNI0_TIMER_REG",
  ADDRESS => 0x00000000d00304a0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00680_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_IILB_TAILTO                                                #
#                                                                        #
##########################################################################

%tio_01_00681_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%tio_01_00681_def =
( NAME    => "TIO_XNNI0_IILB_TAILTO",
  ADDRESS => 0x00000000d00304b0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00681_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_NI_TAILTO                                                  #
#                                                                        #
##########################################################################

%tio_01_00682_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%tio_01_00682_def =
( NAME    => "TIO_XNNI0_NI_TAILTO",
  ADDRESS => 0x00000000d00304c0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00682_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_NI_TAILTO_SUPPORT                                          #
#                                                                        #
##########################################################################

%tio_01_00683_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INJECT_TAIL_ENABLE"           => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00683_def =
( NAME    => "TIO_XNNI0_NI_TAILTO_SUPPORT",
  ADDRESS => 0x00000000d00304f0,
  NOTE    => "This register adds a 'tail injection' feature to the basic Tail note Timeout functionality. If enabled, when a Tail Timeout Limi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00683_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_DEADLCK_FLOW                                               #
#                                                                        #
##########################################################################

%tio_01_00684_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%tio_01_00684_def =
( NAME    => "TIO_XNNI0_DEADLCK_FLOW",
  ADDRESS => 0x00000000d0030500,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00684_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_DEADLCK_FLOW_SUPPORT                                       #
#                                                                        #
##########################################################################

%tio_01_00685_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FLUSH_ENABLE"                 => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "flush enable" ],
);

%tio_01_00685_def =
( NAME    => "TIO_XNNI0_DEADLCK_FLOW_SUPPORT",
  ADDRESS => 0x00000000d0030510,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00685_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_INJECT_AGE                                                 #
#                                                                        #
##########################################################################

%tio_01_00686_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REPLY_INJECT"                 => [   1,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Value of AGE field for outgoing replies" ],
   "REQUEST_INJECT"               => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Value of AGE field for outgoing requests" ],
);

%tio_01_00686_def =
( NAME    => "TIO_XNNI0_INJECT_AGE",
  ADDRESS => 0x00000000d0030520,
  NOTE    => "This register allows the age field of network bound messages coming note from the II, LB, and in the case of Orbit, the PI and M",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00686_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_NETWORK_AGE                                                #
#                                                                        #
##########################################################################

%tio_01_00687_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_AGE_THRESHOLD_ENABLE"  => [   1,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "Age Threshold Request Enable" ],
   "FR_MMR_AGE_THRESHOLD"         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Age Threshold" ],
   "RSVD1"                        => [   3,  33,   7, 0x000000FE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_FREERUN_ENABLE"        => [   4,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "Freerun Counter Enable" ],
   "RSVD2"                        => [   5,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL3"              => [   6,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "Mux Select3" ],
   "RSVD3"                        => [   7,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL2"              => [   8,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "Mux Select2" ],
   "RSVD4"                        => [   9,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL1"              => [  10,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Mux Select1" ],
   "RSVD5"                        => [  11,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL0"              => [  12,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Mux Select0" ],
);

%tio_01_00687_def =
( NAME    => "TIO_XNNI0_NETWORK_AGE",
  ADDRESS => 0x00000000d0030530,
  NOTE    => "This register configures the Network Aging features of the XN. note There is one of these registers for each of the two NI ports",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00687_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_ARB_CONFIG                                                 #
#                                                                        #
##########################################################################

%tio_01_00688_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_SYNC_BYPASS_IN"        => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable Bypass Mode" ],
   "RSVD1"                        => [   2,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_THROT_SRC1"                => [   3,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Enable throttling of other NI requests" ],
   "EN_THROT_SRC0"                => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable throttling of II and LB requests" ],
);

%tio_01_00688_def =
( NAME    => "TIO_XNNI0_ARB_CONFIG",
  ADDRESS => 0x00000000d0030540,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00688_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_LOCAL_AGE0                                                 #
#                                                                        #
##########################################################################

%tio_01_00689_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_WRAP_SRC1_VC3"            => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC2"            => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC1"            => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC0"            => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC3"            => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_IILB VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC2"            => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_IILB VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC1"            => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_IILB VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC0"            => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_IILB VC0 Pre-Scale Value" ],
);

%tio_01_00689_def =
( NAME    => "TIO_XNNI0_LOCAL_AGE0",
  ADDRESS => 0x00000000d0030550,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00689_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI0_QUEUE_CNTR                                                 #
#                                                                        #
##########################################################################

%tio_01_00690_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC3"                => [   1,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "VC3 Queue Counter Last Value Used" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC3"                  => [   3,  48,   6, 0x003F000000000000, 0x00, 1, 0x0000000000000000, "VC3 Dynamic Queue Counter Value" ],
   "RSVD2"                        => [   4,  46,   2, 0x0000C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC2"                => [   5,  40,   6, 0x00003F0000000000, 0x00, 1, 0x0000000000000000, "VC2 Queue Counter Last Value Used" ],
   "RSVD3"                        => [   6,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC2"                  => [   7,  32,   6, 0x0000003F00000000, 0x00, 1, 0x0000000000000000, "VC2 Dynamic Queue Counter Value" ],
   "RSVD4"                        => [   8,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC1"                => [   9,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "VC1 Queue Counter Last Value Used" ],
   "RSVD5"                        => [  10,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC1"                  => [  11,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "VC1 Dynamic Queue Counter Value" ],
   "RSVD6"                        => [  12,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC0"                => [  13,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC0 Queue Counter Last Value Used" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC0"                  => [  15,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Dynamic Queue Counter Value" ],
);

%tio_01_00690_def =
( NAME    => "TIO_XNNI0_QUEUE_CNTR",
  ADDRESS => 0x00000000d0030570,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00690_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_TO_IILB_INTRA_FLOW_DEBIT                                     #
#                                                                        #
##########################################################################

%tio_01_00691_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  56,   6, 0x3F00000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  48,   6, 0x003F000000000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,  38,  10, 0x0000FFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   5,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD3"                        => [   6,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   7,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD4"                        => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_FORCE_CRED"               => [   9,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD5"                        => [  10,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_WITHHOLD"                 => [  11,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
   "VC0_FORCE_CRED"               => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD6"                        => [  13,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_WITHHOLD"                 => [  14,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 withhold" ],
);

%tio_01_00691_def =
( NAME    => "TIO_XNNI1_TO_IILB_INTRA_FLOW_DEBIT",
  ADDRESS => 0x00000000d0030600,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00691_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_0_INTRANI_FLOW                                             #
#                                                                        #
##########################################################################

%tio_01_00692_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC0 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC0" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC0_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Withhold" ],
);

%tio_01_00692_def =
( NAME    => "TIO_XNNI1_0_INTRANI_FLOW",
  ADDRESS => 0x00000000d0030650,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00692_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_1_INTRANI_FLOW                                             #
#                                                                        #
##########################################################################

%tio_01_00693_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC1 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC1" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC1_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC1 Withhold" ],
);

%tio_01_00693_def =
( NAME    => "TIO_XNNI1_1_INTRANI_FLOW",
  ADDRESS => 0x00000000d0030660,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00693_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_2_INTRANI_FLOW                                             #
#                                                                        #
##########################################################################

%tio_01_00694_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC2 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC2" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC2_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC2 Withhold" ],
);

%tio_01_00694_def =
( NAME    => "TIO_XNNI1_2_INTRANI_FLOW",
  ADDRESS => 0x00000000d0030670,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00694_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_3_INTRANI_FLOW                                             #
#                                                                        #
##########################################################################

%tio_01_00695_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  38,  26, 0xFFFFFFC000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_CAP"                      => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth captured value" ],
   "RSVD1"                        => [   2,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_DYN"                      => [   3,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "VC3 FIFO depth dynamic value" ],
   "RSVD2"                        => [   4,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_FORCE_CRED"         => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Force Credit on VC3" ],
   "RSVD3"                        => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBIT_VC3_WITHHOLD"           => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC3 Withhold" ],
);

%tio_01_00695_def =
( NAME    => "TIO_XNNI1_3_INTRANI_FLOW",
  ADDRESS => 0x00000000d0030680,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00695_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_VCSWITCH_FLOW                                              #
#                                                                        #
##########################################################################

%tio_01_00696_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  25,  39, 0xFFFFFFFFFE000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_VCFIFO_SWITCH"           => [   1,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Select VC0/2 or VC1/3 for IILB" ],
   "RSVD1"                        => [   2,   1,  23, 0x0000000000FFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_VCFIFO_DATELINE_SWITCH"    => [   3,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Swap VC0/2 with VC1/3" ],
);

%tio_01_00696_def =
( NAME    => "TIO_XNNI1_VCSWITCH_FLOW",
  ADDRESS => 0x00000000d0030690,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00696_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_TIMER_REG                                                  #
#                                                                        #
##########################################################################

%tio_01_00697_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  35,  29, 0xFFFFFFF800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "QUEUECNTENABLE_REG"           => [   1,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "Queue Counter Enable" ],
   "LINKRESETENABLE_REG"          => [   2,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "Link Reset Enable" ],
   "LINKCLEANUP_REG"              => [   3,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "Link Clean Up" ],
   "RSVD1"                        => [   4,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIMEOUT_REG"                  => [   5,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Master Timeout Counter" ],
);

%tio_01_00697_def =
( NAME    => "TIO_XNNI1_TIMER_REG",
  ADDRESS => 0x00000000d00306a0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00697_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_IILB_TAILTO                                                #
#                                                                        #
##########################################################################

%tio_01_00698_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%tio_01_00698_def =
( NAME    => "TIO_XNNI1_IILB_TAILTO",
  ADDRESS => 0x00000000d00306b0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00698_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_NI_TAILTO                                                  #
#                                                                        #
##########################################################################

%tio_01_00699_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%tio_01_00699_def =
( NAME    => "TIO_XNNI1_NI_TAILTO",
  ADDRESS => 0x00000000d00306c0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00699_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_NI_TAILTO_SUPPORT                                          #
#                                                                        #
##########################################################################

%tio_01_00700_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INJECT_TAIL_ENABLE"           => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00700_def =
( NAME    => "TIO_XNNI1_NI_TAILTO_SUPPORT",
  ADDRESS => 0x00000000d00306f0,
  NOTE    => "This register adds a 'tail injection' feature to the basic Tail note Timeout functionality. If enabled, when a Tail Timeout Limi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00700_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_DEADLCK_FLOW                                               #
#                                                                        #
##########################################################################

%tio_01_00701_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC3_CAP"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter captured value" ],
   "VC3_DYN"                      => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "vc3 counter dynamic value" ],
   "RSVD0"                        => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC3_LIMIT"                    => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "vc3 limit reg, zero disables functionality" ],
   "VC2_CAP"                      => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "vc2 counter captured value" ],
   "VC2_DYN"                      => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "vc2 counter dynamic value" ],
   "RSVD1"                        => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC2_LIMIT"                    => [   7,  32,   4, 0x0000000F00000000, 0x00, 1, 0x0000000000000000, "vc2 limit reg, zero disables functionality" ],
   "VC1_CAP"                      => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "vc1 counter captured value" ],
   "VC1_DYN"                      => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "vc1 counter dynamic value" ],
   "RSVD2"                        => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC1_LIMIT"                    => [  11,  16,   4, 0x00000000000F0000, 0x00, 1, 0x0000000000000000, "vc1 limit reg, zero disables functionality" ],
   "VC0_CAP"                      => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "vc0 counter captured value" ],
   "VC0_DYN"                      => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "vc0 counter dynamic value" ],
   "RSVD3"                        => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "VC0_LIMIT"                    => [  15,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "vc0 limit reg, zero disables functionality" ],
);

%tio_01_00701_def =
( NAME    => "TIO_XNNI1_DEADLCK_FLOW",
  ADDRESS => 0x00000000d0030700,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00701_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_DEADLCK_FLOW_SUPPORT                                       #
#                                                                        #
##########################################################################

%tio_01_00702_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FLUSH_ENABLE"                 => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "flush enable" ],
);

%tio_01_00702_def =
( NAME    => "TIO_XNNI1_DEADLCK_FLOW_SUPPORT",
  ADDRESS => 0x00000000d0030710,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00702_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_INJECT_AGE                                                 #
#                                                                        #
##########################################################################

%tio_01_00703_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REPLY_INJECT"                 => [   1,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Value of AGE field for outgoing replies" ],
   "REQUEST_INJECT"               => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "Value of AGE field for outgoing requests" ],
);

%tio_01_00703_def =
( NAME    => "TIO_XNNI1_INJECT_AGE",
  ADDRESS => 0x00000000d0030720,
  NOTE    => "This register allows the age field of network bound messages coming note from the II, LB, and in the case of Orbit, the PI and M",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00703_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_NETWORK_AGE                                                #
#                                                                        #
##########################################################################

%tio_01_00704_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_AGE_THRESHOLD_ENABLE"  => [   1,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "Age Threshold Request Enable" ],
   "FR_MMR_AGE_THRESHOLD"         => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Age Threshold" ],
   "RSVD1"                        => [   3,  33,   7, 0x000000FE00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_FREERUN_ENABLE"        => [   4,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "Freerun Counter Enable" ],
   "RSVD2"                        => [   5,  29,   3, 0x00000000E0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL3"              => [   6,  24,   5, 0x000000001F000000, 0x00, 1, 0x0000000000000000, "Mux Select3" ],
   "RSVD3"                        => [   7,  21,   3, 0x0000000000E00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL2"              => [   8,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "Mux Select2" ],
   "RSVD4"                        => [   9,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL1"              => [  10,   8,   5, 0x0000000000001F00, 0x00, 1, 0x0000000000000000, "Mux Select1" ],
   "RSVD5"                        => [  11,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FR_MMR_MUX_SEL0"              => [  12,   0,   5, 0x000000000000001F, 0x00, 1, 0x0000000000000000, "Mux Select0" ],
);

%tio_01_00704_def =
( NAME    => "TIO_XNNI1_NETWORK_AGE",
  ADDRESS => 0x00000000d0030730,
  NOTE    => "This register configures the Network Aging features of the XN. note There is one of these registers for each of the two NI ports",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00704_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_ARB_CONFIG                                                 #
#                                                                        #
##########################################################################

%tio_01_00705_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   5,  59, 0xFFFFFFFFFFFFFFE0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ENABLE_SYNC_BYPASS_IN"        => [   1,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "Enable Bypass Mode" ],
   "RSVD1"                        => [   2,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_THROT_SRC1"                => [   3,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "Enable throttling of other NI requests" ],
   "EN_THROT_SRC0"                => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Enable throttling of II and LB requests" ],
);

%tio_01_00705_def =
( NAME    => "TIO_XNNI1_ARB_CONFIG",
  ADDRESS => 0x00000000d0030740,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00705_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_LOCAL_AGE0                                                 #
#                                                                        #
##########################################################################

%tio_01_00706_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AGE_WRAP_SRC1_VC3"            => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC2"            => [   1,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC1"            => [   2,  40,   8, 0x0000FF0000000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC1_VC0"            => [   3,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "Other XN_NI VC0 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC3"            => [   4,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "XN_IILB VC3 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC2"            => [   5,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "XN_IILB VC2 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC1"            => [   6,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "XN_IILB VC1 Pre-Scale Value" ],
   "AGE_WRAP_SRC0_VC0"            => [   7,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "XN_IILB VC0 Pre-Scale Value" ],
);

%tio_01_00706_def =
( NAME    => "TIO_XNNI1_LOCAL_AGE0",
  ADDRESS => 0x00000000d0030750,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00706_flds
);


##########################################################################
#                                                                        #
#   TIO_XNNI1_QUEUE_CNTR                                                 #
#                                                                        #
##########################################################################

%tio_01_00707_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC3"                => [   1,  56,   6, 0x3F00000000000000, 0x00, 1, 0x0000000000000000, "VC3 Queue Counter Last Value Used" ],
   "RSVD1"                        => [   2,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC3"                  => [   3,  48,   6, 0x003F000000000000, 0x00, 1, 0x0000000000000000, "VC3 Dynamic Queue Counter Value" ],
   "RSVD2"                        => [   4,  46,   2, 0x0000C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC2"                => [   5,  40,   6, 0x00003F0000000000, 0x00, 1, 0x0000000000000000, "VC2 Queue Counter Last Value Used" ],
   "RSVD3"                        => [   6,  38,   2, 0x000000C000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC2"                  => [   7,  32,   6, 0x0000003F00000000, 0x00, 1, 0x0000000000000000, "VC2 Dynamic Queue Counter Value" ],
   "RSVD4"                        => [   8,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC1"                => [   9,  24,   6, 0x000000003F000000, 0x00, 1, 0x0000000000000000, "VC1 Queue Counter Last Value Used" ],
   "RSVD5"                        => [  10,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC1"                  => [  11,  16,   6, 0x00000000003F0000, 0x00, 1, 0x0000000000000000, "VC1 Dynamic Queue Counter Value" ],
   "RSVD6"                        => [  12,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LAST_USED_VC0"                => [  13,   8,   6, 0x0000000000003F00, 0x00, 1, 0x0000000000000000, "VC0 Queue Counter Last Value Used" ],
   "RSVD7"                        => [  14,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DYNAMIC_VC0"                  => [  15,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "VC0 Dynamic Queue Counter Value" ],
);

%tio_01_00707_def =
( NAME    => "TIO_XNNI1_QUEUE_CNTR",
  ADDRESS => 0x00000000d0030770,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00707_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_DEBUG_SEL                                                     #
#                                                                        #
##########################################################################

%tio_01_00708_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TRIGGER_ENABLE"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Enable trigger on bit 32 of Analyzer data" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD0"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_RLM_SEL"              => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 RLM select" ],
   "RSVD1"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD2"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_RLM_SEL"              => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 RLM select" ],
   "RSVD3"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD4"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_RLM_SEL"              => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 RLM select" ],
   "RSVD5"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD6"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_RLM_SEL"              => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 RLM select" ],
   "RSVD7"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD8"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_RLM_SEL"              => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 RLM select" ],
   "RSVD9"                        => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD10"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_RLM_SEL"              => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 RLM select" ],
   "RSVD11"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD12"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_RLM_SEL"              => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 RLM select" ],
   "RSVD13"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD14"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_RLM_SEL"              => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 RLM select" ],
);

%tio_01_00708_def =
( NAME    => "TIO_XN_DEBUG_SEL",
  ADDRESS => 0x00000000d0031000,
  NOTE    => "XN Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00708_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_DEBUG_TRIG_SEL                                                #
#                                                                        #
##########################################################################

%tio_01_00709_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_NIBBLE_SEL"          => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER7_RLM_SEL"             => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 RLM select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_NIBBLE_SEL"          => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER6_RLM_SEL"             => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 RLM select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_NIBBLE_SEL"          => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER5_RLM_SEL"             => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 RLM select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_NIBBLE_SEL"          => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER4_RLM_SEL"             => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 RLM select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_NIBBLE_SEL"          => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER3_RLM_SEL"             => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 RLM select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_NIBBLE_SEL"          => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER2_RLM_SEL"             => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 RLM select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_NIBBLE_SEL"          => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER1_RLM_SEL"             => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 RLM select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_NIBBLE_SEL"          => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TRIGGER0_RLM_SEL"             => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 RLM select" ],
);

%tio_01_00709_def =
( NAME    => "TIO_XN_DEBUG_TRIG_SEL",
  ADDRESS => 0x00000000d0031020,
  NOTE    => "XN Debug trigger Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00709_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_TRIGGER_COMPARE                                               #
#                                                                        #
##########################################################################

%tio_01_00710_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MASK"                         => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Mask to select Debug bits for trigger generation" ],
);

%tio_01_00710_def =
( NAME    => "TIO_XN_TRIGGER_COMPARE",
  ADDRESS => 0x00000000d0031040,
  NOTE    => "XN Debug Compare",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00710_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_TRIGGER_DATA                                                  #
#                                                                        #
##########################################################################

%tio_01_00711_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "COMPARE_PATTERN"              => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "debug bit pattern for trigger generation" ],
);

%tio_01_00711_def =
( NAME    => "TIO_XN_TRIGGER_DATA",
  ADDRESS => 0x00000000d0031050,
  NOTE    => "XN Debug Compare Data",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00711_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_IILB_DEBUG_SEL                                                #
#                                                                        #
##########################################################################

%tio_01_00712_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%tio_01_00712_def =
( NAME    => "TIO_XN_IILB_DEBUG_SEL",
  ADDRESS => 0x00000000d0031060,
  NOTE    => "XN IILB Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00712_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_IILB_LB_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%tio_01_00713_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%tio_01_00713_def =
( NAME    => "TIO_XN_IILB_LB_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031100,
  NOTE    => "IILB compare LB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00713_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_IILB_LB_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%tio_01_00714_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%tio_01_00714_def =
( NAME    => "TIO_XN_IILB_LB_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031110,
  NOTE    => "IILB compare LB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00714_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_IILB_LB_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%tio_01_00715_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%tio_01_00715_def =
( NAME    => "TIO_XN_IILB_LB_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031120,
  NOTE    => "IILB compare LB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00715_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_IILB_LB_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%tio_01_00716_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%tio_01_00716_def =
( NAME    => "TIO_XN_IILB_LB_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031130,
  NOTE    => "IILB compare LB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00716_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_IILB_II_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%tio_01_00717_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%tio_01_00717_def =
( NAME    => "TIO_XN_IILB_II_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031140,
  NOTE    => "IILB compare II input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00717_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_IILB_II_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%tio_01_00718_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%tio_01_00718_def =
( NAME    => "TIO_XN_IILB_II_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031150,
  NOTE    => "IILB compare II input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00718_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_IILB_II_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%tio_01_00719_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%tio_01_00719_def =
( NAME    => "TIO_XN_IILB_II_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031160,
  NOTE    => "IILB compare II input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00719_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_IILB_II_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%tio_01_00720_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%tio_01_00720_def =
( NAME    => "TIO_XN_IILB_II_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031170,
  NOTE    => "IILB compare II input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00720_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_IILB_NI0_CMP_EXP_DATA0                                        #
#                                                                        #
##########################################################################

%tio_01_00721_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%tio_01_00721_def =
( NAME    => "TIO_XN_IILB_NI0_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031280,
  NOTE    => "IILB compare NI0 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00721_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_IILB_NI0_CMP_EXP_DATA1                                        #
#                                                                        #
##########################################################################

%tio_01_00722_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%tio_01_00722_def =
( NAME    => "TIO_XN_IILB_NI0_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031290,
  NOTE    => "IILB compare NI0 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00722_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_IILB_NI0_CMP_ENABLE0                                          #
#                                                                        #
##########################################################################

%tio_01_00723_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%tio_01_00723_def =
( NAME    => "TIO_XN_IILB_NI0_CMP_ENABLE0",
  ADDRESS => 0x00000000d00312a0,
  NOTE    => "IILB compare NI0 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00723_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_IILB_NI0_CMP_ENABLE1                                          #
#                                                                        #
##########################################################################

%tio_01_00724_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%tio_01_00724_def =
( NAME    => "TIO_XN_IILB_NI0_CMP_ENABLE1",
  ADDRESS => 0x00000000d00312b0,
  NOTE    => "IILB compare NI0 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00724_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_IILB_NI1_CMP_EXP_DATA0                                        #
#                                                                        #
##########################################################################

%tio_01_00725_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%tio_01_00725_def =
( NAME    => "TIO_XN_IILB_NI1_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d00312c0,
  NOTE    => "IILB compare NI1 input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00725_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_IILB_NI1_CMP_EXP_DATA1                                        #
#                                                                        #
##########################################################################

%tio_01_00726_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%tio_01_00726_def =
( NAME    => "TIO_XN_IILB_NI1_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d00312d0,
  NOTE    => "IILB compare NI1 input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00726_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_IILB_NI1_CMP_ENABLE0                                          #
#                                                                        #
##########################################################################

%tio_01_00727_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%tio_01_00727_def =
( NAME    => "TIO_XN_IILB_NI1_CMP_ENABLE0",
  ADDRESS => 0x00000000d00312e0,
  NOTE    => "IILB compare NI1 input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00727_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_IILB_NI1_CMP_ENABLE1                                          #
#                                                                        #
##########################################################################

%tio_01_00728_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%tio_01_00728_def =
( NAME    => "TIO_XN_IILB_NI1_CMP_ENABLE1",
  ADDRESS => 0x00000000d00312f0,
  NOTE    => "IILB compare NI1 input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00728_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI0_DEBUG_SEL                                                 #
#                                                                        #
##########################################################################

%tio_01_00729_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%tio_01_00729_def =
( NAME    => "TIO_XN_NI0_DEBUG_SEL",
  ADDRESS => 0x00000000d00310c0,
  NOTE    => "XN NI0 Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00729_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI0_IILB_CMP_EXP_DATA0                                        #
#                                                                        #
##########################################################################

%tio_01_00730_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%tio_01_00730_def =
( NAME    => "TIO_XN_NI0_IILB_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031700,
  NOTE    => "NI0 compare IILB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00730_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI0_IILB_CMP_EXP_DATA1                                        #
#                                                                        #
##########################################################################

%tio_01_00731_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%tio_01_00731_def =
( NAME    => "TIO_XN_NI0_IILB_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031710,
  NOTE    => "NI0 compare IILB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00731_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI0_IILB_CMP_ENABLE0                                          #
#                                                                        #
##########################################################################

%tio_01_00732_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%tio_01_00732_def =
( NAME    => "TIO_XN_NI0_IILB_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031720,
  NOTE    => "NI0 compare IILB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00732_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI0_IILB_CMP_ENABLE1                                          #
#                                                                        #
##########################################################################

%tio_01_00733_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%tio_01_00733_def =
( NAME    => "TIO_XN_NI0_IILB_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031730,
  NOTE    => "NI0 compare IILB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00733_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI0_NI_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%tio_01_00734_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%tio_01_00734_def =
( NAME    => "TIO_XN_NI0_NI_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d00317c0,
  NOTE    => "Included only for Orbit - Begin",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00734_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI0_NI_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%tio_01_00735_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%tio_01_00735_def =
( NAME    => "TIO_XN_NI0_NI_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d00317d0,
  NOTE    => "NI0 compare NI input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00735_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI0_NI_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%tio_01_00736_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%tio_01_00736_def =
( NAME    => "TIO_XN_NI0_NI_CMP_ENABLE0",
  ADDRESS => 0x00000000d00317e0,
  NOTE    => "NI0 compare NI input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00736_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI0_NI_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%tio_01_00737_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%tio_01_00737_def =
( NAME    => "TIO_XN_NI0_NI_CMP_ENABLE1",
  ADDRESS => 0x00000000d00317f0,
  NOTE    => "NI0 compare NI input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00737_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI0_LLP_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%tio_01_00738_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%tio_01_00738_def =
( NAME    => "TIO_XN_NI0_LLP_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031800,
  NOTE    => "NI0 compare LLP input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00738_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI0_LLP_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%tio_01_00739_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%tio_01_00739_def =
( NAME    => "TIO_XN_NI0_LLP_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031810,
  NOTE    => "NI0 compare LLP input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00739_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI0_LLP_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%tio_01_00740_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%tio_01_00740_def =
( NAME    => "TIO_XN_NI0_LLP_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031820,
  NOTE    => "NI0 compare LLP input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00740_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI0_LLP_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%tio_01_00741_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%tio_01_00741_def =
( NAME    => "TIO_XN_NI0_LLP_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031830,
  NOTE    => "NI0 compare LLP input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00741_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI1_DEBUG_SEL                                                 #
#                                                                        #
##########################################################################

%tio_01_00742_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_NIBBLE_SEL"           => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE7_INPUT_SEL"            => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 input select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_NIBBLE_SEL"           => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE6_INPUT_SEL"            => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 input select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_NIBBLE_SEL"           => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE5_INPUT_SEL"            => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 input select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_NIBBLE_SEL"           => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE4_INPUT_SEL"            => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 input select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_NIBBLE_SEL"           => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE3_INPUT_SEL"            => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 input select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_NIBBLE_SEL"           => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE2_INPUT_SEL"            => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 input select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_NIBBLE_SEL"           => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE1_INPUT_SEL"            => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 input select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_NIBBLE_SEL"           => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIBBLE0_INPUT_SEL"            => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 input select" ],
);

%tio_01_00742_def =
( NAME    => "TIO_XN_NI1_DEBUG_SEL",
  ADDRESS => 0x00000000d00310e0,
  NOTE    => "XN NI1 Debug Port Select",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00742_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI1_IILB_CMP_EXP_DATA0                                        #
#                                                                        #
##########################################################################

%tio_01_00743_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%tio_01_00743_def =
( NAME    => "TIO_XN_NI1_IILB_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031900,
  NOTE    => "NI1 compare IILB input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00743_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI1_IILB_CMP_EXP_DATA1                                        #
#                                                                        #
##########################################################################

%tio_01_00744_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%tio_01_00744_def =
( NAME    => "TIO_XN_NI1_IILB_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031910,
  NOTE    => "NI1 compare IILB input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00744_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI1_IILB_CMP_ENABLE0                                          #
#                                                                        #
##########################################################################

%tio_01_00745_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%tio_01_00745_def =
( NAME    => "TIO_XN_NI1_IILB_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031920,
  NOTE    => "NI1 compare IILB input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00745_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI1_IILB_CMP_ENABLE1                                          #
#                                                                        #
##########################################################################

%tio_01_00746_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%tio_01_00746_def =
( NAME    => "TIO_XN_NI1_IILB_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031930,
  NOTE    => "NI1 compare IILB input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00746_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI1_NI_CMP_EXP_DATA0                                          #
#                                                                        #
##########################################################################

%tio_01_00747_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%tio_01_00747_def =
( NAME    => "TIO_XN_NI1_NI_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d00319c0,
  NOTE    => "Included only for Orbit - Begin",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00747_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI1_NI_CMP_EXP_DATA1                                          #
#                                                                        #
##########################################################################

%tio_01_00748_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%tio_01_00748_def =
( NAME    => "TIO_XN_NI1_NI_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d00319d0,
  NOTE    => "NI1 compare NI input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00748_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI1_NI_CMP_ENABLE0                                            #
#                                                                        #
##########################################################################

%tio_01_00749_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%tio_01_00749_def =
( NAME    => "TIO_XN_NI1_NI_CMP_ENABLE0",
  ADDRESS => 0x00000000d00319e0,
  NOTE    => "NI1 compare NI input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00749_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI1_NI_CMP_ENABLE1                                            #
#                                                                        #
##########################################################################

%tio_01_00750_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%tio_01_00750_def =
( NAME    => "TIO_XN_NI1_NI_CMP_ENABLE1",
  ADDRESS => 0x00000000d00319f0,
  NOTE    => "NI1 compare NI input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00750_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI1_LLP_CMP_EXP_DATA0                                         #
#                                                                        #
##########################################################################

%tio_01_00751_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 0" ],
);

%tio_01_00751_def =
( NAME    => "TIO_XN_NI1_LLP_CMP_EXP_DATA0",
  ADDRESS => 0x00000000d0031a00,
  NOTE    => "NI1 compare LLP input expected data0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00751_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI1_LLP_CMP_EXP_DATA1                                         #
#                                                                        #
##########################################################################

%tio_01_00752_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Expected data 1" ],
);

%tio_01_00752_def =
( NAME    => "TIO_XN_NI1_LLP_CMP_EXP_DATA1",
  ADDRESS => 0x00000000d0031a10,
  NOTE    => "NI1 compare LLP input expected data1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00752_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI1_LLP_CMP_ENABLE0                                           #
#                                                                        #
##########################################################################

%tio_01_00753_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable0" ],
);

%tio_01_00753_def =
( NAME    => "TIO_XN_NI1_LLP_CMP_ENABLE0",
  ADDRESS => 0x00000000d0031a20,
  NOTE    => "NI1 compare LLP input enable0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00753_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_NI1_LLP_CMP_ENABLE1                                           #
#                                                                        #
##########################################################################

%tio_01_00754_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ENABLE"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Enable1" ],
);

%tio_01_00754_def =
( NAME    => "TIO_XN_NI1_LLP_CMP_ENABLE1",
  ADDRESS => 0x00000000d0031a30,
  NOTE    => "NI1 compare LLP input enable1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00754_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_ERROR_SUMMARY_1                                              #
#                                                                        #
##########################################################################

%tio_01_00755_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "RSVD1"                        => [   5,  50,   8, 0x03FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [   6,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [   7,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [   9,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  10,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  11,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  12,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  13,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  14,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  15,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  16,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  17,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  18,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "RSVD2"                        => [  19,  33,   4, 0x0000001E00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  20,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  21,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  22,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  23,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  24,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "RSVD3"                        => [  25,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  26,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  27,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  28,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  29,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  30,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  31,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "RSVD4"                        => [  32,  10,   4, 0x0000000000003C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  33,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  34,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  35,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  36,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  37,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  38,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  39,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  40,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  41,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  42,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%tio_01_00755_def =
( NAME    => "TIO_NI0_ERROR_SUMMARY_1",
  ADDRESS => 0x00000000d0040500,
  NOTE    => "ni0 Error Summary Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00755_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_ERROR_SUMMARY_1_ALIAS                                        #
#                                                                        #
##########################################################################

%tio_01_00756_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "RSVD1"                        => [   5,  50,   8, 0x03FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [   6,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [   7,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [   9,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  10,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  11,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  12,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  13,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  14,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  15,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  16,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  17,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  18,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "RSVD2"                        => [  19,  33,   4, 0x0000001E00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  20,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  21,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  22,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  23,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  24,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "RSVD3"                        => [  25,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  26,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  27,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  28,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  29,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  30,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  31,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "RSVD4"                        => [  32,  10,   4, 0x0000000000003C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  33,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  34,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  35,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  36,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  37,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  38,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  39,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  40,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  41,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  42,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%tio_01_00756_def =
( NAME    => "TIO_NI0_ERROR_SUMMARY_1_ALIAS",
  ADDRESS => 0x00000000d0040508,
  NOTE    => "ni0 Error Summary Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00756_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_ERROR_SUMMARY_2                                              #
#                                                                        #
##########################################################################

%tio_01_00757_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   1,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [   2,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [   3,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [   4,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [   5,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [   7,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [   8,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [   9,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  11,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [  12,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_ILLEGAL_VC"                => [  13,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "RSVD2"                        => [  14,  37,   2, 0x0000006000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_ILLEGAL_VC"              => [  15,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  16,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "RSVD3"                        => [  17,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_ERROR"         => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "RSVD4"                        => [  20,  27,   4, 0x0000000078000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "RSVD5"                        => [  26,  14,   8, 0x00000000003FC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  27,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  28,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "RSVD6"                        => [  29,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%tio_01_00757_def =
( NAME    => "TIO_NI0_ERROR_SUMMARY_2",
  ADDRESS => 0x00000000d0040510,
  NOTE    => "ni0 Error Summary Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00757_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_ERROR_SUMMARY_2_ALIAS                                        #
#                                                                        #
##########################################################################

%tio_01_00758_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   1,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [   2,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [   3,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [   4,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [   5,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [   7,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [   8,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [   9,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  11,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [  12,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_ILLEGAL_VC"                => [  13,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "RSVD2"                        => [  14,  37,   2, 0x0000006000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_ILLEGAL_VC"              => [  15,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  16,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "RSVD3"                        => [  17,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_ERROR"         => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "RSVD4"                        => [  20,  27,   4, 0x0000000078000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "RSVD5"                        => [  26,  14,   8, 0x00000000003FC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  27,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  28,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "RSVD6"                        => [  29,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%tio_01_00758_def =
( NAME    => "TIO_NI0_ERROR_SUMMARY_2_ALIAS",
  ADDRESS => 0x00000000d0040518,
  NOTE    => "ni0 Error Summary Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00758_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_ERROR_OVERFLOW_1                                             #
#                                                                        #
##########################################################################

%tio_01_00759_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "RSVD1"                        => [   5,  50,   8, 0x03FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [   6,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [   7,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [   9,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  10,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  11,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  12,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  13,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  14,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  15,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  16,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  17,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  18,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "RSVD2"                        => [  19,  33,   4, 0x0000001E00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  20,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  21,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  22,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  23,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  24,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "RSVD3"                        => [  25,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  26,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  27,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  28,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  29,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  30,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  31,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "RSVD4"                        => [  32,  10,   4, 0x0000000000003C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  33,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  34,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  35,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  36,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  37,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  38,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  39,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  40,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  41,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  42,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%tio_01_00759_def =
( NAME    => "TIO_NI0_ERROR_OVERFLOW_1",
  ADDRESS => 0x00000000d0040520,
  NOTE    => "ni0 Error Overflow Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00759_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_ERROR_OVERFLOW_1_ALIAS                                       #
#                                                                        #
##########################################################################

%tio_01_00760_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "RSVD1"                        => [   5,  50,   8, 0x03FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [   6,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [   7,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [   9,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  10,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  11,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  12,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  13,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  14,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  15,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  16,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  17,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  18,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "RSVD2"                        => [  19,  33,   4, 0x0000001E00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  20,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  21,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  22,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  23,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  24,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "RSVD3"                        => [  25,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  26,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  27,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  28,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  29,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  30,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  31,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "RSVD4"                        => [  32,  10,   4, 0x0000000000003C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  33,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  34,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  35,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  36,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  37,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  38,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  39,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  40,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  41,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  42,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%tio_01_00760_def =
( NAME    => "TIO_NI0_ERROR_OVERFLOW_1_ALIAS",
  ADDRESS => 0x00000000d0040528,
  NOTE    => "ni0 Error Overflow Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00760_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_ERROR_OVERFLOW_2                                             #
#                                                                        #
##########################################################################

%tio_01_00761_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   1,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [   2,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [   3,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [   4,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [   5,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [   7,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [   8,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [   9,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  11,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [  12,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_ILLEGAL_VC"                => [  13,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "RSVD2"                        => [  14,  37,   2, 0x0000006000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_ILLEGAL_VC"              => [  15,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  16,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "RSVD3"                        => [  17,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_ERROR"         => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "RSVD4"                        => [  20,  27,   4, 0x0000000078000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "RSVD5"                        => [  26,  14,   8, 0x00000000003FC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  27,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  28,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "RSVD6"                        => [  29,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%tio_01_00761_def =
( NAME    => "TIO_NI0_ERROR_OVERFLOW_2",
  ADDRESS => 0x00000000d0040530,
  NOTE    => "ni0 Error Overflow Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00761_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_ERROR_OVERFLOW_2_ALIAS                                       #
#                                                                        #
##########################################################################

%tio_01_00762_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   1,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [   2,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [   3,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [   4,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [   5,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [   7,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [   8,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [   9,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  11,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [  12,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_ILLEGAL_VC"                => [  13,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "RSVD2"                        => [  14,  37,   2, 0x0000006000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_ILLEGAL_VC"              => [  15,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  16,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "RSVD3"                        => [  17,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_ERROR"         => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "RSVD4"                        => [  20,  27,   4, 0x0000000078000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "RSVD5"                        => [  26,  14,   8, 0x00000000003FC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  27,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  28,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "RSVD6"                        => [  29,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%tio_01_00762_def =
( NAME    => "TIO_NI0_ERROR_OVERFLOW_2_ALIAS",
  ADDRESS => 0x00000000d0040538,
  NOTE    => "ni0 Error Overflow Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00762_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_ERROR_MASK_1                                                 #
#                                                                        #
##########################################################################

%tio_01_00763_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc0" ],
   "RSVD1"                        => [   5,  50,   8, 0x03FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [   6,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [   7,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [   8,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [   9,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  10,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  11,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  12,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  13,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  14,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  15,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  16,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  17,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  18,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "NI fast tail overflow" ],
   "RSVD2"                        => [  19,  33,   4, 0x0000001E00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  20,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  21,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  22,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  23,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  24,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc0" ],
   "RSVD3"                        => [  25,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  26,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  27,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  28,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  29,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  30,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  31,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc0" ],
   "RSVD4"                        => [  32,  10,   4, 0x0000000000003C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  33,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  34,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  35,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  36,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  37,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  38,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  39,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  40,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  41,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  42,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
);

%tio_01_00763_def =
( NAME    => "TIO_NI0_ERROR_MASK_1",
  ADDRESS => 0x00000000d0040540,
  NOTE    => "ni0 Error Mask Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00763_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_ERROR_MASK_2                                                 #
#                                                                        #
##########################################################################

%tio_01_00764_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   1,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [   2,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [   3,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [   4,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [   5,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [   6,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [   7,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [   8,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [   9,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  10,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  11,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [  12,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_ILLEGAL_VC"                => [  13,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI illegal vc" ],
   "RSVD2"                        => [  14,  37,   2, 0x0000006000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_ILLEGAL_VC"              => [  15,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  16,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "NI fast tail error" ],
   "RSVD3"                        => [  17,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_ERROR"         => [  18,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  19,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI fast tail underflow" ],
   "RSVD4"                        => [  20,  27,   4, 0x0000000078000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  21,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  22,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  23,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  24,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  25,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc0" ],
   "RSVD5"                        => [  26,  14,   8, 0x00000000003FC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  27,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  28,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "RSVD6"                        => [  29,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  30,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  31,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  32,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  33,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  34,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  35,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  36,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  37,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "llp deadlock vc0" ],
);

%tio_01_00764_def =
( NAME    => "TIO_NI0_ERROR_MASK_2",
  ADDRESS => 0x00000000d0040550,
  NOTE    => "ni0 Error Mask Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00764_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_FIRST_ERROR_1                                                #
#                                                                        #
##########################################################################

%tio_01_00765_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "RSVD1"                        => [   5,  50,   8, 0x03FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [   6,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [   7,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [   9,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  10,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  11,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  12,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  13,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  14,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  15,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  16,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  17,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  18,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "RSVD2"                        => [  19,  33,   4, 0x0000001E00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  20,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  21,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  22,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  23,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  24,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "RSVD3"                        => [  25,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  26,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  27,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  28,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  29,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  30,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  31,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "RSVD4"                        => [  32,  10,   4, 0x0000000000003C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  33,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  34,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  35,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  36,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  37,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  38,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  39,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  40,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  41,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  42,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%tio_01_00765_def =
( NAME    => "TIO_NI0_FIRST_ERROR_1",
  ADDRESS => 0x00000000d0040560,
  NOTE    => "ni0 First Error Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00765_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_FIRST_ERROR_2                                                #
#                                                                        #
##########################################################################

%tio_01_00766_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   1,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [   2,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [   3,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [   4,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [   5,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [   7,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [   8,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [   9,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  11,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [  12,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_ILLEGAL_VC"                => [  13,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "RSVD2"                        => [  14,  37,   2, 0x0000006000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_ILLEGAL_VC"              => [  15,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  16,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "RSVD3"                        => [  17,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_ERROR"         => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "RSVD4"                        => [  20,  27,   4, 0x0000000078000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "RSVD5"                        => [  26,  14,   8, 0x00000000003FC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  27,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  28,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "RSVD6"                        => [  29,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%tio_01_00766_def =
( NAME    => "TIO_NI0_FIRST_ERROR_2",
  ADDRESS => 0x00000000d0040570,
  NOTE    => "ni0 First Error Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00766_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_ERROR_DETAIL_1                                               #
#                                                                        #
##########################################################################

%tio_01_00767_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header bits 63:0" ],
);

%tio_01_00767_def =
( NAME    => "TIO_NI0_ERROR_DETAIL_1",
  ADDRESS => 0x00000000d0040580,
  NOTE    => "ni0 Chiplet no match header bits 63:0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00767_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_ERROR_DETAIL_2                                               #
#                                                                        #
##########################################################################

%tio_01_00768_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header bits 127:64" ],
);

%tio_01_00768_def =
( NAME    => "TIO_NI0_ERROR_DETAIL_2",
  ADDRESS => 0x00000000d0040590,
  NOTE    => "ni0 Chiplet no match header bits 127:64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00768_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_ERROR_SUMMARY_1                                              #
#                                                                        #
##########################################################################

%tio_01_00769_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "RSVD1"                        => [   5,  50,   8, 0x03FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [   6,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [   7,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [   9,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  10,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  11,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  12,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  13,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  14,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  15,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  16,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  17,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  18,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "RSVD2"                        => [  19,  33,   4, 0x0000001E00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  20,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  21,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  22,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  23,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  24,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "RSVD3"                        => [  25,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  26,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  27,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  28,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  29,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  30,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  31,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "RSVD4"                        => [  32,  10,   4, 0x0000000000003C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  33,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  34,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  35,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  36,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  37,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  38,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  39,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  40,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  41,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  42,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%tio_01_00769_def =
( NAME    => "TIO_NI1_ERROR_SUMMARY_1",
  ADDRESS => 0x00000000d0040600,
  NOTE    => "ni1 Error Summary Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00769_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_ERROR_SUMMARY_1_ALIAS                                        #
#                                                                        #
##########################################################################

%tio_01_00770_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "RSVD1"                        => [   5,  50,   8, 0x03FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [   6,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [   7,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [   9,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  10,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  11,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  12,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  13,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  14,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  15,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  16,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  17,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  18,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "RSVD2"                        => [  19,  33,   4, 0x0000001E00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  20,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  21,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  22,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  23,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  24,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "RSVD3"                        => [  25,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  26,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  27,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  28,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  29,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  30,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  31,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "RSVD4"                        => [  32,  10,   4, 0x0000000000003C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  33,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  34,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  35,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  36,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  37,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  38,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  39,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  40,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  41,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  42,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%tio_01_00770_def =
( NAME    => "TIO_NI1_ERROR_SUMMARY_1_ALIAS",
  ADDRESS => 0x00000000d0040608,
  NOTE    => "ni1 Error Summary Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00770_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_ERROR_SUMMARY_2                                              #
#                                                                        #
##########################################################################

%tio_01_00771_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   1,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [   2,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [   3,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [   4,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [   5,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [   7,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [   8,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [   9,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  11,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [  12,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_ILLEGAL_VC"                => [  13,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "RSVD2"                        => [  14,  37,   2, 0x0000006000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_ILLEGAL_VC"              => [  15,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  16,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "RSVD3"                        => [  17,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_ERROR"         => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "RSVD4"                        => [  20,  27,   4, 0x0000000078000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "RSVD5"                        => [  26,  14,   8, 0x00000000003FC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  27,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  28,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "RSVD6"                        => [  29,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%tio_01_00771_def =
( NAME    => "TIO_NI1_ERROR_SUMMARY_2",
  ADDRESS => 0x00000000d0040610,
  NOTE    => "ni1 Error Summary Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00771_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_ERROR_SUMMARY_2_ALIAS                                        #
#                                                                        #
##########################################################################

%tio_01_00772_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   1,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [   2,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [   3,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [   4,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [   5,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [   7,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [   8,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [   9,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  11,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [  12,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_ILLEGAL_VC"                => [  13,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "RSVD2"                        => [  14,  37,   2, 0x0000006000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_ILLEGAL_VC"              => [  15,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  16,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "RSVD3"                        => [  17,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_ERROR"         => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "RSVD4"                        => [  20,  27,   4, 0x0000000078000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "RSVD5"                        => [  26,  14,   8, 0x00000000003FC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  27,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  28,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "RSVD6"                        => [  29,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%tio_01_00772_def =
( NAME    => "TIO_NI1_ERROR_SUMMARY_2_ALIAS",
  ADDRESS => 0x00000000d0040618,
  NOTE    => "ni1 Error Summary Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00772_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_ERROR_OVERFLOW_1                                             #
#                                                                        #
##########################################################################

%tio_01_00773_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "RSVD1"                        => [   5,  50,   8, 0x03FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [   6,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [   7,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [   9,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  10,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  11,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  12,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  13,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  14,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  15,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  16,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  17,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  18,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "RSVD2"                        => [  19,  33,   4, 0x0000001E00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  20,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  21,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  22,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  23,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  24,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "RSVD3"                        => [  25,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  26,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  27,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  28,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  29,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  30,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  31,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "RSVD4"                        => [  32,  10,   4, 0x0000000000003C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  33,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  34,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  35,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  36,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  37,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  38,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  39,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  40,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  41,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  42,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%tio_01_00773_def =
( NAME    => "TIO_NI1_ERROR_OVERFLOW_1",
  ADDRESS => 0x00000000d0040620,
  NOTE    => "ni1 Error Overflow Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00773_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_ERROR_OVERFLOW_1_ALIAS                                       #
#                                                                        #
##########################################################################

%tio_01_00774_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "RSVD1"                        => [   5,  50,   8, 0x03FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [   6,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [   7,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [   9,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  10,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  11,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  12,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  13,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  14,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  15,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  16,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  17,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  18,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "RSVD2"                        => [  19,  33,   4, 0x0000001E00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  20,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  21,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  22,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  23,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  24,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "RSVD3"                        => [  25,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  26,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  27,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  28,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  29,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  30,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  31,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "RSVD4"                        => [  32,  10,   4, 0x0000000000003C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  33,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  34,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  35,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  36,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  37,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  38,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  39,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  40,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  41,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  42,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%tio_01_00774_def =
( NAME    => "TIO_NI1_ERROR_OVERFLOW_1_ALIAS",
  ADDRESS => 0x00000000d0040628,
  NOTE    => "ni1 Error Overflow Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00774_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_ERROR_OVERFLOW_2                                             #
#                                                                        #
##########################################################################

%tio_01_00775_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   1,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [   2,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [   3,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [   4,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [   5,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [   7,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [   8,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [   9,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  11,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [  12,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_ILLEGAL_VC"                => [  13,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "RSVD2"                        => [  14,  37,   2, 0x0000006000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_ILLEGAL_VC"              => [  15,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  16,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "RSVD3"                        => [  17,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_ERROR"         => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "RSVD4"                        => [  20,  27,   4, 0x0000000078000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "RSVD5"                        => [  26,  14,   8, 0x00000000003FC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  27,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  28,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "RSVD6"                        => [  29,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%tio_01_00775_def =
( NAME    => "TIO_NI1_ERROR_OVERFLOW_2",
  ADDRESS => 0x00000000d0040630,
  NOTE    => "ni1 Error Overflow Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00775_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_ERROR_OVERFLOW_2_ALIAS                                       #
#                                                                        #
##########################################################################

%tio_01_00776_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   1,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [   2,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [   3,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [   4,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [   5,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [   7,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [   8,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [   9,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  11,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [  12,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_ILLEGAL_VC"                => [  13,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "RSVD2"                        => [  14,  37,   2, 0x0000006000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_ILLEGAL_VC"              => [  15,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  16,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "RSVD3"                        => [  17,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_ERROR"         => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "RSVD4"                        => [  20,  27,   4, 0x0000000078000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "RSVD5"                        => [  26,  14,   8, 0x00000000003FC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  27,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  28,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "RSVD6"                        => [  29,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%tio_01_00776_def =
( NAME    => "TIO_NI1_ERROR_OVERFLOW_2_ALIAS",
  ADDRESS => 0x00000000d0040638,
  NOTE    => "ni1 Error Overflow Bits Alias",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00776_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_ERROR_MASK_1                                                 #
#                                                                        #
##########################################################################

%tio_01_00777_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "NI tail timeout vc0" ],
   "RSVD1"                        => [   5,  50,   8, 0x03FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [   6,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [   7,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [   8,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [   9,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  10,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  11,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  12,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  13,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  14,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  15,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  16,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  17,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  18,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "NI fast tail overflow" ],
   "RSVD2"                        => [  19,  33,   4, 0x0000001E00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  20,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  21,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  22,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  23,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  24,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "NI fifo overflow vc0" ],
   "RSVD3"                        => [  25,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  26,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  27,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  28,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  29,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  30,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  31,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "NI debit overflow vc0" ],
   "RSVD4"                        => [  32,  10,   4, 0x0000000000003C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  33,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  34,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  35,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  36,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  37,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  38,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  39,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  40,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  41,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  42,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "llp debit overflow vc0" ],
);

%tio_01_00777_def =
( NAME    => "TIO_NI1_ERROR_MASK_1",
  ADDRESS => 0x00000000d0040640,
  NOTE    => "ni1 Error Mask Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00777_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_ERROR_MASK_2                                                 #
#                                                                        #
##########################################################################

%tio_01_00778_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   1,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [   2,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [   3,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [   4,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [   5,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [   6,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [   7,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [   8,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [   9,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  10,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  11,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [  12,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_ILLEGAL_VC"                => [  13,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI illegal vc" ],
   "RSVD2"                        => [  14,  37,   2, 0x0000006000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_ILLEGAL_VC"              => [  15,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  16,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "NI fast tail error" ],
   "RSVD3"                        => [  17,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_ERROR"         => [  18,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  19,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "NI fast tail underflow" ],
   "RSVD4"                        => [  20,  27,   4, 0x0000000078000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  21,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  22,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  23,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  24,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  25,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "NI fifo underflow vc0" ],
   "RSVD5"                        => [  26,  14,   8, 0x00000000003FC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  27,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  28,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "RSVD6"                        => [  29,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  30,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  31,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  32,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  33,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  34,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  35,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  36,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  37,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "llp deadlock vc0" ],
);

%tio_01_00778_def =
( NAME    => "TIO_NI1_ERROR_MASK_2",
  ADDRESS => 0x00000000d0040650,
  NOTE    => "ni1 Error Mask Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00778_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_FIRST_ERROR_1                                                #
#                                                                        #
##########################################################################

%tio_01_00779_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_TAIL_TIMEOUT_VC3"          => [   1,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc3" ],
   "NI_TAIL_TIMEOUT_VC2"          => [   2,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc2" ],
   "NI_TAIL_TIMEOUT_VC1"          => [   3,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc1" ],
   "NI_TAIL_TIMEOUT_VC0"          => [   4,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "NI tail timeout vc0" ],
   "RSVD1"                        => [   5,  50,   8, 0x03FC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_TAIL_TIMEOUT_VC3"        => [   6,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc3" ],
   "IILB_TAIL_TIMEOUT_VC2"        => [   7,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc2" ],
   "IILB_TAIL_TIMEOUT_VC1"        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc1" ],
   "IILB_TAIL_TIMEOUT_VC0"        => [   9,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB tail timeout vc0" ],
   "NI_DEBITSAVER_OVERFLOW_VC3"   => [  10,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc3" ],
   "NI_DEBITSAVER_OVERFLOW_VC2"   => [  11,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc2" ],
   "NI_DEBITSAVER_OVERFLOW_VC1"   => [  12,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc1" ],
   "NI_DEBITSAVER_OVERFLOW_VC0"   => [  13,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI debitsaver overflow vc0" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC3"   => [  14,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc3" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC2"   => [  15,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc2" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC1"   => [  16,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc1" ],
   "NI_QUEUE_CNTR_OVERFLOW_VC0"   => [  17,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI queue counter overflow vc0" ],
   "NI_FAST_TAIL_OVERFLOW"        => [  18,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "NI fast tail overflow" ],
   "RSVD2"                        => [  19,  33,   4, 0x0000001E00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_OVERFLOW"      => [  20,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC3"  => [  21,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc3" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC2"  => [  22,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc2" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC1"  => [  23,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc1" ],
   "NI_FIFO_CREDIT_OVERFLOW_VC0"  => [  24,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "NI fifo overflow vc0" ],
   "RSVD3"                        => [  25,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC2" => [  26,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc2" ],
   "IILB_FIFO_CREDIT_OVERFLOW_VC0" => [  27,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow vc0" ],
   "NI_DEBIT_OVERFLOW_VC3"        => [  28,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc3" ],
   "NI_DEBIT_OVERFLOW_VC2"        => [  29,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc2" ],
   "NI_DEBIT_OVERFLOW_VC1"        => [  30,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc1" ],
   "NI_DEBIT_OVERFLOW_VC0"        => [  31,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI debit overflow vc0" ],
   "RSVD4"                        => [  32,  10,   4, 0x0000000000003C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW_VC2"      => [  33,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc2" ],
   "IILB_DEBIT_OVERFLOW_VC0"      => [  34,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "IILB debit overflow vc0" ],
   "OVERFLOW_NI_VC3_CREDIT"       => [  35,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit overflow vc3" ],
   "OVERFLOW_NI_VC2_CREDIT"       => [  36,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit overflow vc2" ],
   "OVERFLOW_NI_VC1_CREDIT"       => [  37,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit overflow vc1" ],
   "OVERFLOW_NI_VC0_CREDIT"       => [  38,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT3"          => [  39,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT2"          => [  40,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT1"          => [  41,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
   "OVERFLOW_LLP_DEBIT0"          => [  42,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp debit overflow vc0" ],
);

%tio_01_00779_def =
( NAME    => "TIO_NI1_FIRST_ERROR_1",
  ADDRESS => 0x00000000d0040660,
  NOTE    => "ni1 First Error Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00779_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_FIRST_ERROR_2                                                #
#                                                                        #
##########################################################################

%tio_01_00780_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAM_NI_XMIT_MSG_VC3"          => [   1,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "NI VC3 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC2"          => [   2,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI VC2 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC1"          => [   3,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI VC1 Xmit Message Lost" ],
   "DAM_NI_XMIT_MSG_VC0"          => [   4,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "NI VC0 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC3"        => [   5,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "IILB VC3 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC2"        => [   6,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC1"        => [   7,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "IILB VC1 Xmit Message Lost" ],
   "DAM_IILB_XMIT_MSG_VC0"        => [   8,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 Xmit Message Lost" ],
   "RETRY_TIMEOUT_ERROR"          => [   9,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "Retry Timeout Error" ],
   "LUT_READ_ERROR"               => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [  11,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [  12,  40,   2, 0x0000030000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI_ILLEGAL_VC"                => [  13,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI illegal vc" ],
   "RSVD2"                        => [  14,  37,   2, 0x0000006000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_ILLEGAL_VC"              => [  15,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB illegal vc" ],
   "NI_FAST_TAIL_ERROR"           => [  16,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "NI fast tail error" ],
   "RSVD3"                        => [  17,  33,   2, 0x0000000600000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_ERROR"         => [  18,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "NI_FAST_TAIL_UNDERFLOW"       => [  19,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "NI fast tail underflow" ],
   "RSVD4"                        => [  20,  27,   4, 0x0000000078000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FAST_TAIL_UNDERFLOW"     => [  21,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC3" => [  22,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc3" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC2" => [  23,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc2" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC1" => [  24,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc1" ],
   "NI_FIFO_CREDIT_UNDERFLOW_VC0" => [  25,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "NI fifo underflow vc0" ],
   "RSVD5"                        => [  26,  14,   8, 0x00000000003FC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC2" => [  27,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc2" ],
   "IILB_FIFO_CREDIT_UNDERFLOW_VC0" => [  28,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow vc0" ],
   "RSVD6"                        => [  29,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI_VC3_CREDIT"      => [  30,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI credit underflow vc3" ],
   "UNDERFLOW_NI_VC2_CREDIT"      => [  31,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI credit underflow vc2" ],
   "UNDERFLOW_NI_VC1_CREDIT"      => [  32,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI credit underflow vc1" ],
   "UNDERFLOW_NI_VC0_CREDIT"      => [  33,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI credit underflow vc0" ],
   "LLP_DEADLOCK_VC3"             => [  34,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "llp deadlock vc3" ],
   "LLP_DEADLOCK_VC2"             => [  35,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "llp deadlock vc2" ],
   "LLP_DEADLOCK_VC1"             => [  36,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "llp deadlock vc1" ],
   "LLP_DEADLOCK_VC0"             => [  37,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "llp deadlock vc0" ],
);

%tio_01_00780_def =
( NAME    => "TIO_NI1_FIRST_ERROR_2",
  ADDRESS => 0x00000000d0040670,
  NOTE    => "ni1 First Error Bits",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00780_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_ERROR_DETAIL_1                                               #
#                                                                        #
##########################################################################

%tio_01_00781_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header bits 63:0" ],
);

%tio_01_00781_def =
( NAME    => "TIO_NI1_ERROR_DETAIL_1",
  ADDRESS => 0x00000000d0040680,
  NOTE    => "ni1 Chiplet no match header bits 63:0",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00781_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_ERROR_DETAIL_2                                               #
#                                                                        #
##########################################################################

%tio_01_00782_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Header bits 127:64" ],
);

%tio_01_00782_def =
( NAME    => "TIO_NI1_ERROR_DETAIL_2",
  ADDRESS => 0x00000000d0040690,
  NOTE    => "ni1 Chiplet no match header bits 127:64",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00782_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_ERROR_DETAIL_1                                            #
#                                                                        #
##########################################################################

%tio_01_00783_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "header bits [63:0]" ],
);

%tio_01_00783_def =
( NAME    => "TIO_XNIILB_ERROR_DETAIL_1",
  ADDRESS => 0x00000000d0040130,
  NOTE    => "This register contains the XN NI0 errors status bits.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00783_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_ERROR_DETAIL_2                                            #
#                                                                        #
##########################################################################

%tio_01_00784_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "HEADER"                       => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "header bits [127:64]" ],
);

%tio_01_00784_def =
( NAME    => "TIO_XNIILB_ERROR_DETAIL_2",
  ADDRESS => 0x00000000d0040140,
  NOTE    => "Chiplet NoMatch header [127:64]",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00784_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_ERROR_DETAIL_3                                            #
#                                                                        #
##########################################################################

%tio_01_00785_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%tio_01_00785_def =
( NAME    => "TIO_XNIILB_ERROR_DETAIL_3",
  ADDRESS => 0x00000000d0040150,
  NOTE    => "Look Up Table Address (iilb)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00785_flds
);


##########################################################################
#                                                                        #
#   TIO_NI0_ERROR_DETAIL_3                                               #
#                                                                        #
##########################################################################

%tio_01_00786_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%tio_01_00786_def =
( NAME    => "TIO_NI0_ERROR_DETAIL_3",
  ADDRESS => 0x00000000d0040160,
  NOTE    => "Look Up Table Address (ni0)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00786_flds
);


##########################################################################
#                                                                        #
#   TIO_NI1_ERROR_DETAIL_3                                               #
#                                                                        #
##########################################################################

%tio_01_00787_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_ADDR"                     => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "Look Up Table Read Address" ],
);

%tio_01_00787_def =
( NAME    => "TIO_NI1_ERROR_DETAIL_3",
  ADDRESS => 0x00000000d0040170,
  NOTE    => "Look Up Table Address (ni1)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00787_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_ERROR_SUMMARY                                                 #
#                                                                        #
##########################################################################

%tio_01_00788_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CHIPLET_OR_LUT"          => [   1,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [   2,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [   3,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [   4,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [   5,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "RSVD1"                        => [   6,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW"          => [   7,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [   9,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  10,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  11,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  12,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  13,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "RSVD2"                        => [  14,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_DEBIT_OVERFLOW"           => [  15,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  16,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  17,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  18,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  19,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  20,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  21,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "RSVD3"                        => [  22,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_DEBIT_OVERFLOW"           => [  23,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
);

%tio_01_00788_def =
( NAME    => "TIO_XN_ERROR_SUMMARY",
  ADDRESS => 0x00000000d0040000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00788_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_ERROR_SUMMARY_ALIAS                                           #
#                                                                        #
##########################################################################

%tio_01_00789_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CHIPLET_OR_LUT"          => [   1,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [   2,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [   3,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [   4,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [   5,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "RSVD1"                        => [   6,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW"          => [   7,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [   9,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  10,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  11,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  12,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  13,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "RSVD2"                        => [  14,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_DEBIT_OVERFLOW"           => [  15,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  16,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  17,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  18,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  19,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  20,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  21,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "RSVD3"                        => [  22,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_DEBIT_OVERFLOW"           => [  23,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
);

%tio_01_00789_def =
( NAME    => "TIO_XN_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x00000000d0040008,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00789_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_ERROR_OVERFLOW                                                #
#                                                                        #
##########################################################################

%tio_01_00790_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CHIPLET_OR_LUT"          => [   1,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [   2,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [   3,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [   4,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [   5,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "RSVD1"                        => [   6,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW"          => [   7,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [   9,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  10,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  11,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  12,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  13,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "RSVD2"                        => [  14,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_DEBIT_OVERFLOW"           => [  15,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  16,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  17,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  18,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  19,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  20,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  21,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "RSVD3"                        => [  22,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_DEBIT_OVERFLOW"           => [  23,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
);

%tio_01_00790_def =
( NAME    => "TIO_XN_ERROR_OVERFLOW",
  ADDRESS => 0x00000000d0040020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00790_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_ERROR_OVERFLOW_ALIAS                                          #
#                                                                        #
##########################################################################

%tio_01_00791_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CHIPLET_OR_LUT"          => [   1,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [   2,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [   3,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [   4,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [   5,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "RSVD1"                        => [   6,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW"          => [   7,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [   9,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  10,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  11,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  12,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  13,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "RSVD2"                        => [  14,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_DEBIT_OVERFLOW"           => [  15,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  16,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  17,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  18,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  19,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  20,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  21,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "RSVD3"                        => [  22,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_DEBIT_OVERFLOW"           => [  23,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
);

%tio_01_00791_def =
( NAME    => "TIO_XN_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x00000000d0040028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00791_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_ERROR_MASK                                                    #
#                                                                        #
##########################################################################

%tio_01_00792_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CHIPLET_OR_LUT"          => [   1,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [   2,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [   3,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [   4,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [   5,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "IILB credit overflow" ],
   "RSVD1"                        => [   6,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW"          => [   7,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [   8,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [   9,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  10,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  11,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  12,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  13,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "NI1 credit overflow" ],
   "RSVD2"                        => [  14,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_DEBIT_OVERFLOW"           => [  15,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  16,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  17,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  18,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  19,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  20,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  21,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "NI0 credit overflow" ],
   "RSVD3"                        => [  22,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_DEBIT_OVERFLOW"           => [  23,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "NI0 debit overflow" ],
);

%tio_01_00792_def =
( NAME    => "TIO_XN_ERROR_MASK",
  ADDRESS => 0x00000000d0040040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00792_flds
);


##########################################################################
#                                                                        #
#   TIO_XN_FIRST_ERROR                                                   #
#                                                                        #
##########################################################################

%tio_01_00793_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_CHIPLET_OR_LUT"          => [   1,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB chiplet nomatch or lut read error" ],
   "IILB_FIFO_UNDERFLOW"          => [   2,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "IILB fifo underflow" ],
   "IILB_FIFO_OVERFLOW"           => [   3,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "IILB fifo overflow" ],
   "IILB_CREDIT_UNDERFLOW"        => [   4,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "IILB credit underflow" ],
   "IILB_CREDIT_OVERFLOW"         => [   5,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "IILB credit overflow" ],
   "RSVD1"                        => [   6,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "IILB_DEBIT_OVERFLOW"          => [   7,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "IILB debit overflow" ],
   "NI1_LLP_ERROR"                => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "NI1 llp error" ],
   "NI1_PIPE_ERROR"               => [   9,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "NI1 pipe in/out error" ],
   "NI1_FIFO_UNDERFLOW"           => [  10,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "NI1 fifo underflow" ],
   "NI1_FIFO_OVERFLOW"            => [  11,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "NI1 fifo overflow" ],
   "NI1_CREDIT_UNDERFLOW"         => [  12,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "NI1 credit underflow" ],
   "NI1_CREDIT_OVERFLOW"          => [  13,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "NI1 credit overflow" ],
   "RSVD2"                        => [  14,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI1_DEBIT_OVERFLOW"           => [  15,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 debit overflow" ],
   "NI0_LLP_ERROR"                => [  16,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI0 llp error" ],
   "NI0_PIPE_ERROR"               => [  17,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI0 Pipe in/out errors" ],
   "NI0_FIFO_UNDERFLOW"           => [  18,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 fifo underflow" ],
   "NI0_FIFO_OVERFLOW"            => [  19,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 fifo overflow" ],
   "NI0_CREDIT_UNDERFLOW"         => [  20,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 credit underflow" ],
   "NI0_CREDIT_OVERFLOW"          => [  21,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 credit overflow" ],
   "RSVD3"                        => [  22,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NI0_DEBIT_OVERFLOW"           => [  23,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "NI0 debit overflow" ],
);

%tio_01_00793_def =
( NAME    => "TIO_XN_FIRST_ERROR",
  ADDRESS => 0x00000000d0040060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00793_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_ERROR_SUMMARY                                             #
#                                                                        #
##########################################################################

%tio_01_00794_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "II fast tail overflow" ],
   "RSVD1"                        => [   3,  57,   4, 0x1E00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   5,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   6,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [   7,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [   8,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [   9,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  10,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "II VC0 debit overflow" ],
   "RSVD2"                        => [  11,  46,   4, 0x0003C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_DEBIT3"          => [  12,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  13,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  14,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  15,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  16,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  17,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  18,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  20,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  21,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  22,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  23,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  24,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  25,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit overflow" ],
   "RSVD3"                        => [  26,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  27,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  28,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  29,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  30,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  31,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  32,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  33,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  34,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2"              => [  35,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  36,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "RSVD4"                        => [  37,  10,   8, 0x000000000003FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%tio_01_00794_def =
( NAME    => "TIO_XNIILB_ERROR_SUMMARY",
  ADDRESS => 0x00000000d0040200,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00794_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_ERROR_SUMMARY_ALIAS                                       #
#                                                                        #
##########################################################################

%tio_01_00795_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "II fast tail overflow" ],
   "RSVD1"                        => [   3,  57,   4, 0x1E00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   5,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   6,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [   7,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [   8,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [   9,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  10,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "II VC0 debit overflow" ],
   "RSVD2"                        => [  11,  46,   4, 0x0003C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_DEBIT3"          => [  12,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  13,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  14,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  15,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  16,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  17,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  18,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  20,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  21,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  22,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  23,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  24,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  25,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit overflow" ],
   "RSVD3"                        => [  26,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  27,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  28,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  29,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  30,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  31,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  32,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  33,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  34,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2"              => [  35,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  36,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "RSVD4"                        => [  37,  10,   8, 0x000000000003FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%tio_01_00795_def =
( NAME    => "TIO_XNIILB_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x00000000d0040208,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00795_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_ERROR_OVERFLOW                                            #
#                                                                        #
##########################################################################

%tio_01_00796_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "II fast tail overflow" ],
   "RSVD1"                        => [   3,  57,   4, 0x1E00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   5,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   6,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [   7,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [   8,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [   9,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  10,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "II VC0 debit overflow" ],
   "RSVD2"                        => [  11,  46,   4, 0x0003C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_DEBIT3"          => [  12,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  13,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  14,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  15,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  16,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  17,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  18,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  20,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  21,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  22,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  23,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  24,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  25,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit overflow" ],
   "RSVD3"                        => [  26,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  27,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  28,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  29,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  30,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  31,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  32,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  33,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  34,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2"              => [  35,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  36,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "RSVD4"                        => [  37,  10,   8, 0x000000000003FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%tio_01_00796_def =
( NAME    => "TIO_XNIILB_ERROR_OVERFLOW",
  ADDRESS => 0x00000000d0040220,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00796_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_ERROR_OVERFLOW_ALIAS                                      #
#                                                                        #
##########################################################################

%tio_01_00797_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "II fast tail overflow" ],
   "RSVD1"                        => [   3,  57,   4, 0x1E00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   5,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   6,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [   7,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [   8,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [   9,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  10,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "II VC0 debit overflow" ],
   "RSVD2"                        => [  11,  46,   4, 0x0003C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_DEBIT3"          => [  12,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  13,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  14,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  15,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  16,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  17,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  18,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  20,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  21,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  22,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  23,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  24,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  25,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit overflow" ],
   "RSVD3"                        => [  26,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  27,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  28,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  29,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  30,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  31,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  32,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  33,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  34,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2"              => [  35,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  36,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "RSVD4"                        => [  37,  10,   8, 0x000000000003FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%tio_01_00797_def =
( NAME    => "TIO_XNIILB_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x00000000d0040228,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00797_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_ERROR_MASK                                                #
#                                                                        #
##########################################################################

%tio_01_00798_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "II fast tail overflow" ],
   "RSVD1"                        => [   3,  57,   4, 0x1E00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   4,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   5,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   6,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [   7,  53,   1, 0x0020000000000000, 0x00, 1, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [   8,  52,   1, 0x0010000000000000, 0x00, 1, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [   9,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  10,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "II VC0 debit overflow" ],
   "RSVD2"                        => [  11,  46,   4, 0x0003C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_DEBIT3"          => [  12,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  13,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  14,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  15,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  16,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  17,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  18,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  20,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  21,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  22,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  23,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  24,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  25,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "II VC0 credit overflow" ],
   "RSVD3"                        => [  26,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  27,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  28,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  29,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  30,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  31,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  32,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  33,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  34,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2"              => [  35,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  36,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "II VC0 fifo overflow" ],
   "RSVD4"                        => [  37,  10,   8, 0x000000000003FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  38,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  39,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  40,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  41,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  42,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  43,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  44,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  45,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  46,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  47,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%tio_01_00798_def =
( NAME    => "TIO_XNIILB_ERROR_MASK",
  ADDRESS => 0x00000000d0040240,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00798_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_FIRST_ERROR                                               #
#                                                                        #
##########################################################################

%tio_01_00799_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_LB_FAST_TAIL"        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail overflow" ],
   "OVERFLOW_II_FAST_TAIL"        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "II fast tail overflow" ],
   "RSVD1"                        => [   3,  57,   4, 0x1E00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_FAST_TAIL"       => [   4,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail overflow" ],
   "OVERFLOW_NI0_FAST_TAIL"       => [   5,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail overflow" ],
   "OVERFLOW_IILB_FAST_TAIL"      => [   6,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail overflow" ],
   "OVERFLOW_LB_DEBIT2"           => [   7,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "LB VC2 debit overflow" ],
   "OVERFLOW_LB_DEBIT0"           => [   8,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "LB VC0 debit overflow" ],
   "OVERFLOW_II_DEBIT2"           => [   9,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "II VC2 debit overflow" ],
   "OVERFLOW_II_DEBIT0"           => [  10,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "II VC0 debit overflow" ],
   "RSVD2"                        => [  11,  46,   4, 0x0003C00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_DEBIT3"          => [  12,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT2"          => [  13,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT1"          => [  14,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo debit overflow" ],
   "OVERFLOW_NI1_DEBIT0"          => [  15,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT3"          => [  16,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT2"          => [  17,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT1"          => [  18,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo debit overflow" ],
   "OVERFLOW_NI0_DEBIT0"          => [  19,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT2"         => [  20,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo debit overflow" ],
   "OVERFLOW_IILB_DEBIT0"         => [  21,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo debit overflow" ],
   "OVERFLOW_LB_VC2_CREDIT_OUT"   => [  22,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit overflow" ],
   "OVERFLOW_LB_VC0_CREDIT_OUT"   => [  23,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit overflow" ],
   "OVERFLOW_II_VC2_CREDIT_OUT"   => [  24,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit overflow" ],
   "OVERFLOW_II_VC0_CREDIT_OUT"   => [  25,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit overflow" ],
   "RSVD3"                        => [  26,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_VC2_CREDIT_IN"   => [  27,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_IN"   => [  28,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_IN"   => [  29,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_IN"   => [  30,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_IN"  => [  31,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_IN"  => [  32,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit overflow" ],
   "OVERFLOW_LB_VC2"              => [  33,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo overflow" ],
   "OVERFLOW_LB_VC0"              => [  34,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo overflow" ],
   "OVERFLOW_II_VC2"              => [  35,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo overflow" ],
   "OVERFLOW_II_VC0"              => [  36,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo overflow" ],
   "RSVD4"                        => [  37,  10,   8, 0x000000000003FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "OVERFLOW_NI1_VC3_CREDIT_OUT"  => [  38,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo overflow" ],
   "OVERFLOW_NI1_VC2_CREDIT_OUT"  => [  39,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo overflow" ],
   "OVERFLOW_NI1_VC1_CREDIT_OUT"  => [  40,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo overflow" ],
   "OVERFLOW_NI1_VC0_CREDIT_OUT"  => [  41,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo overflow" ],
   "OVERFLOW_NI0_VC3_CREDIT_OUT"  => [  42,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo overflow" ],
   "OVERFLOW_NI0_VC2_CREDIT_OUT"  => [  43,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo overflow" ],
   "OVERFLOW_NI0_VC1_CREDIT_OUT"  => [  44,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo overflow" ],
   "OVERFLOW_NI0_VC0_CREDIT_OUT"  => [  45,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo overflow" ],
   "OVERFLOW_IILB_VC2_CREDIT_OUT" => [  46,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo overflow" ],
   "OVERFLOW_IILB_VC0_CREDIT_OUT" => [  47,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo overflow" ],
);

%tio_01_00799_def =
( NAME    => "TIO_XNIILB_FIRST_ERROR",
  ADDRESS => 0x00000000d0040260,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00799_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_ERROR_SUMMARY_1                                           #
#                                                                        #
##########################################################################

%tio_01_00800_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [   3,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_LB_FAST_TAIL"           => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   5,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "II fast tail error" ],
   "RSVD2"                        => [   6,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_NI1_FAST_TAIL"          => [   7,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [   8,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [   9,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  10,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  11,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "II fast tail underflow" ],
   "RSVD3"                        => [  12,  43,   4, 0x0000780000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  13,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  14,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  15,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "RSVD4"                        => [  16,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  17,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  18,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  19,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  20,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit underflow" ],
   "RSVD5"                        => [  21,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  22,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  23,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  24,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  25,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  26,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  27,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  28,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  29,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2"             => [  30,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  31,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "RSVD6"                        => [  32,  10,   8, 0x000000000003FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  33,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  34,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  35,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  36,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  37,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  38,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  39,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  40,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  41,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  42,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%tio_01_00800_def =
( NAME    => "TIO_XNIILB_ERROR_SUMMARY_1",
  ADDRESS => 0x00000000d0040210,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00800_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_ERROR_SUMMARY_ALIAS_1                                     #
#                                                                        #
##########################################################################

%tio_01_00801_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [   3,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_LB_FAST_TAIL"           => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   5,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "II fast tail error" ],
   "RSVD2"                        => [   6,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_NI1_FAST_TAIL"          => [   7,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [   8,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [   9,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  10,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  11,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "II fast tail underflow" ],
   "RSVD3"                        => [  12,  43,   4, 0x0000780000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  13,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  14,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  15,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "RSVD4"                        => [  16,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  17,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  18,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  19,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  20,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit underflow" ],
   "RSVD5"                        => [  21,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  22,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  23,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  24,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  25,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  26,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  27,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  28,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  29,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2"             => [  30,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  31,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "RSVD6"                        => [  32,  10,   8, 0x000000000003FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  33,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  34,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  35,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  36,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  37,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  38,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  39,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  40,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  41,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  42,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%tio_01_00801_def =
( NAME    => "TIO_XNIILB_ERROR_SUMMARY_ALIAS_1",
  ADDRESS => 0x00000000d0040218,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00801_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_ERROR_OVERFLOW_1                                          #
#                                                                        #
##########################################################################

%tio_01_00802_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [   3,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_LB_FAST_TAIL"           => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   5,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "II fast tail error" ],
   "RSVD2"                        => [   6,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_NI1_FAST_TAIL"          => [   7,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [   8,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [   9,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  10,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  11,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "II fast tail underflow" ],
   "RSVD3"                        => [  12,  43,   4, 0x0000780000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  13,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  14,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  15,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "RSVD4"                        => [  16,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  17,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  18,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  19,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  20,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit underflow" ],
   "RSVD5"                        => [  21,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  22,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  23,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  24,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  25,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  26,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  27,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  28,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  29,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2"             => [  30,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  31,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "RSVD6"                        => [  32,  10,   8, 0x000000000003FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  33,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  34,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  35,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  36,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  37,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  38,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  39,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  40,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  41,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  42,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%tio_01_00802_def =
( NAME    => "TIO_XNIILB_ERROR_OVERFLOW_1",
  ADDRESS => 0x00000000d0040230,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00802_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_ERROR_OVERFLOW_ALIAS_1                                     #
#                                                                        #
##########################################################################

%tio_01_00803_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [   3,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_LB_FAST_TAIL"           => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   5,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "II fast tail error" ],
   "RSVD2"                        => [   6,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_NI1_FAST_TAIL"          => [   7,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [   8,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [   9,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  10,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  11,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "II fast tail underflow" ],
   "RSVD3"                        => [  12,  43,   4, 0x0000780000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  13,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  14,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  15,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "RSVD4"                        => [  16,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  17,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  18,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  19,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  20,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit underflow" ],
   "RSVD5"                        => [  21,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  22,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  23,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  24,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  25,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  26,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  27,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  28,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  29,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2"             => [  30,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  31,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "RSVD6"                        => [  32,  10,   8, 0x000000000003FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  33,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  34,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  35,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  36,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  37,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  38,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  39,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  40,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  41,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  42,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%tio_01_00803_def =
( NAME    => "TIO_XNIILB_ERROR_OVERFLOW_ALIAS_1",
  ADDRESS => 0x00000000d0040238,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00803_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_ERROR_MASK_1                                              #
#                                                                        #
##########################################################################

%tio_01_00804_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 1, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 1, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [   3,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_LB_FAST_TAIL"           => [   4,  55,   1, 0x0080000000000000, 0x00, 1, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   5,  54,   1, 0x0040000000000000, 0x00, 1, 0x0000000000000000, "II fast tail error" ],
   "RSVD2"                        => [   6,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_NI1_FAST_TAIL"          => [   7,  51,   1, 0x0008000000000000, 0x00, 1, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [   8,  50,   1, 0x0004000000000000, 0x00, 1, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [   9,  49,   1, 0x0002000000000000, 0x00, 1, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  10,  48,   1, 0x0001000000000000, 0x00, 1, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  11,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "II fast tail underflow" ],
   "RSVD3"                        => [  12,  43,   4, 0x0000780000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  13,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  14,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  15,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "IILB fast tail underflow" ],
   "RSVD4"                        => [  16,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  17,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  18,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  19,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  20,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "II VC0 credit underflow" ],
   "RSVD5"                        => [  21,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  22,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  23,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  24,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  25,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  26,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  27,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  28,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  29,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2"             => [  30,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  31,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "II VC0 fifo underflow" ],
   "RSVD6"                        => [  32,  10,   8, 0x000000000003FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  33,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  34,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  35,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  36,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  37,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  38,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  39,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  40,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  41,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  42,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%tio_01_00804_def =
( NAME    => "TIO_XNIILB_ERROR_MASK_1",
  ADDRESS => 0x00000000d0040250,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00804_flds
);


##########################################################################
#                                                                        #
#   TIO_XNIILB_FIRST_ERROR_1                                             #
#                                                                        #
##########################################################################

%tio_01_00805_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LUT_READ_ERROR"               => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "LUT Read Error" ],
   "CHIPLET_NOMATCH"              => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "chiplet nomatch" ],
   "RSVD1"                        => [   3,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_LB_FAST_TAIL"           => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail error" ],
   "ERROR_II_FAST_TAIL"           => [   5,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "II fast tail error" ],
   "RSVD2"                        => [   6,  52,   2, 0x0030000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERROR_NI1_FAST_TAIL"          => [   7,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail error" ],
   "ERROR_NI0_FAST_TAIL"          => [   8,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail error" ],
   "ERROR_IILB_FAST_TAIL"         => [   9,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail error" ],
   "UNDERFLOW_LB_FAST_TAIL"       => [  10,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "LB fast tail underflow" ],
   "UNDERFLOW_II_FAST_TAIL"       => [  11,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "II fast tail underflow" ],
   "RSVD3"                        => [  12,  43,   4, 0x0000780000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_FAST_TAIL"      => [  13,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "NI1 fast tail underflow" ],
   "UNDERFLOW_NI0_FAST_TAIL"      => [  14,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "NI0 fast tail underflow" ],
   "UNDERFLOW_IILB_FAST_TAIL"     => [  15,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "IILB fast tail underflow" ],
   "RSVD4"                        => [  16,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_LB_VC2_CREDIT_OUT"  => [  17,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "LB VC2 credit underflow" ],
   "UNDERFLOW_LB_VC0_CREDIT_OUT"  => [  18,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "LB VC0 credit underflow" ],
   "UNDERFLOW_II_VC2_CREDIT_OUT"  => [  19,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "II VC2 credit underflow" ],
   "UNDERFLOW_II_VC0_CREDIT_OUT"  => [  20,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "II VC0 credit underflow" ],
   "RSVD5"                        => [  21,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_VC2_CREDIT_IN"  => [  22,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "NI1 VC2 credit underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_IN"  => [  23,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "NI1 VC0 credit underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_IN"  => [  24,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "NI0 VC2 credit underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_IN"  => [  25,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "NI0 VC0 credit underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_IN" => [  26,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "IILB VC2 credit underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_IN" => [  27,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "IILB VC0 credit underflow" ],
   "UNDERFLOW_LB_VC2"             => [  28,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "LB VC2 fifo underflow" ],
   "UNDERFLOW_LB_VC0"             => [  29,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "LB VC0 fifo underflow" ],
   "UNDERFLOW_II_VC2"             => [  30,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "II VC2 fifo underflow" ],
   "UNDERFLOW_II_VC0"             => [  31,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "II VC0 fifo underflow" ],
   "RSVD6"                        => [  32,  10,   8, 0x000000000003FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UNDERFLOW_NI1_VC3_CREDIT_OUT" => [  33,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "NI1 VC3 fifo underflow" ],
   "UNDERFLOW_NI1_VC2_CREDIT_OUT" => [  34,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "NI1 VC2 fifo underflow" ],
   "UNDERFLOW_NI1_VC1_CREDIT_OUT" => [  35,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "NI1 VC1 fifo underflow" ],
   "UNDERFLOW_NI1_VC0_CREDIT_OUT" => [  36,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "NI1 VC0 fifo underflow" ],
   "UNDERFLOW_NI0_VC3_CREDIT_OUT" => [  37,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "NI0 VC3 fifo underflow" ],
   "UNDERFLOW_NI0_VC2_CREDIT_OUT" => [  38,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "NI0 VC2 fifo underflow" ],
   "UNDERFLOW_NI0_VC1_CREDIT_OUT" => [  39,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "NI0 VC1 fifo underflow" ],
   "UNDERFLOW_NI0_VC0_CREDIT_OUT" => [  40,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "NI0 VC0 fifo underflow" ],
   "UNDERFLOW_IILB_VC2_CREDIT_OUT" => [  41,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "IILB VC2 fifo underflow" ],
   "UNDERFLOW_IILB_VC0_CREDIT_OUT" => [  42,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "IILB VC0 fifo underflow" ],
);

%tio_01_00805_def =
( NAME    => "TIO_XNIILB_FIRST_ERROR_1",
  ADDRESS => 0x00000000d0040270,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00805_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_IDENTIFICATION                                                #
#                                                                        #
##########################################################################

%tio_01_00806_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REV_NUM"                      => [   1,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Revision number" ],
   "PART_NUM"                     => [   2,  12,  16, 0x000000000FFFF000, 0x00, 1, 0x0000000000000000, "Part Number" ],
   "MFG_NUM"                      => [   3,   1,  11, 0x0000000000000FFE, 0x00, 1, 0x0000000000000000, "Manufacturing Number" ],
   "READ_ONE"                     => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Read One" ],
);

%tio_01_00806_def =
( NAME    => "TIO_CA_IDENTIFICATION",
  ADDRESS => 0x0000000020000000,
  NOTE    => "Uniquely identifies CA corelet and revision number.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00806_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_CONTROL1                                                      #
#                                                                        #
##########################################################################

%tio_01_00807_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  52,  12, 0xFFF0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_INT_LPCNT"                => [   1,  44,   8, 0x000FF00000000000, 0x00, 1, 0x0000000000000000, "PCI Pin Interrupt Low Pass Counter" ],
   "RSVD1"                        => [   2,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGPDMA_OP_ENB_COMBDELAY"      => [   3,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "AGP DMA OP Queue Request Enable Combining Delay" ],
   "RSVD2"                        => [   4,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "AGPDMA_OP_COMBDELAY"          => [   5,  36,   5, 0x000001F000000000, 0x00, 1, 0x0000000000000000, "AGP DMA OP Queue Request Combining Delay" ],
   "RSVD3"                        => [   6,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_ADDR_OFFSET"              => [   7,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "PIO Address Offset" ],
   "RSVD4"                        => [   8,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCIM_FAST_BTB_ENB"            => [   9,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "PCI Master Fast Back-to-back Enable" ],
   "PCIM_IO_NBE_AD"               => [  10,  16,   3, 0x0000000000070000, 0x00, 1, 0x0000000000000000, "PCI Master I/O No Byte Enable Address" ],
   "RSVD5"                        => [  11,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INJ_DATA_PERR"                => [  12,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "Inject Data Parity Error" ],
   "INJ_ADDR_PERR"                => [  13,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "Inject Address Parity Error" ],
   "AGP_INIT_CAL_ENB"             => [  14,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "AGP Initial Calibration Enable" ],
   "AGP_CAL_PRSCL_BYP"            => [  15,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "AGP Calibration Prescaler Bypass" ],
   "AGP_CAL_CYCLE"                => [  16,   7,   3, 0x0000000000000380, 0x00, 1, 0x0000000000000000, "AGP Calibration Cycle" ],
   "AGP_FW_ENABLE"                => [  17,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "AGP Fast Write Enable" ],
   "GFX_WR_SWAP"                  => [  18,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "GFX Write Swap" ],
   "PIO_MEM_SWAP"                 => [  19,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "PIO Memory Swap" ],
   "PIO_IO_SWAP"                  => [  20,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "PIO IO Swap" ],
   "DMA_PCI_SWAP"                 => [  21,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "DMA PCI Swap" ],
   "DMA_AGP_SWAP"                 => [  22,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "DMA AGP Swap" ],
   "SYS_BIG_END"                  => [  23,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "System Big Endian" ],
);

%tio_01_00807_def =
( NAME    => "TIO_CA_CONTROL1",
  ADDRESS => 0x0000000020000008,
  NOTE    => "Static control signals for CA (1 of 2 registers).",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00807_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_CONTROL2                                                      #
#                                                                        #
##########################################################################

%tio_01_00808_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRM_MAX_CREDIT"               => [   1,  60,   3, 0x7000000000000000, 0x00, 1, 0x0000000000000000, "CRM Maximum Credits" ],
   "RSVD1"                        => [   2,  58,   2, 0x0C00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRM_PRESCALER_BYP"            => [   3,  57,   1, 0x0200000000000000, 0x00, 1, 0x0000000000000000, "CRM Prescaler Bypass" ],
   "CRM_TNUMTO_ENB"               => [   4,  56,   1, 0x0100000000000000, 0x00, 1, 0x0000000000000000, "CRM TNUM Timeout Enable" ],
   "RSVD2"                        => [   5,  53,   3, 0x00E0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRM_TNUMTO_PERIOD"            => [   6,  40,  13, 0x001FFF0000000000, 0x00, 1, 0x0000000000000000, "CRM TNUM Timeout Period" ],
   "RSVD3"                        => [   7,  37,   3, 0x000000E000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GART_FLUSH_TLB"               => [   8,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "Gart Flush Translation Lookaside Buffer" ],
   "GART_WR_PREFETCH_ENB"         => [   9,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "GART Write Prefetch Enable" ],
   "GART_RD_PREFETCH_ENB"         => [  10,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "GART Read Prefetch Enable" ],
   "GART_MEM_PARAM"               => [  11,  32,   2, 0x0000000300000000, 0x00, 1, 0x0000000000000000, "GART Memory Parameter" ],
   "RSVD4"                        => [  12,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MSI_INT_ENB"                  => [  13,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "Message Signaling Interrupt Enable" ],
   "RT_INT_EN"                    => [  14,  28,   2, 0x0000000030000000, 0x00, 1, 0x0000000000000000, "Real-Time Interrupt Enable" ],
   "RSVD5"                        => [  15,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_MAX_RETRY"                => [  16,  16,  10, 0x0000000003FF0000, 0x00, 1, 0x0000000000000000, "PCI Maximum Retry" ],
   "PCI_LATENCY_TO"               => [  17,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "PCI Latency Timeout" ],
   "AGP_LATENCY_TO"               => [  18,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "AGP Latency Timeout" ],
);

%tio_01_00808_def =
( NAME    => "TIO_CA_CONTROL2",
  ADDRESS => 0x0000000020000010,
  NOTE    => "Static control signals for CA (2 of 2 registers).",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00808_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_STATUS1                                                       #
#                                                                        #
##########################################################################

%tio_01_00809_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GART_TLB_VAL"                 => [   1,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "GART Translation Lookaside Buffer Valid" ],
   "RSVD1"                        => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRM_SPACE_AVAIL"              => [   3,   8,   7, 0x0000000000007F00, 0x00, 1, 0x0000000000000000, "CRM Space Available" ],
   "RSVD2"                        => [   4,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRM_CREDIT_AVAIL"             => [   5,   4,   3, 0x0000000000000070, 0x00, 1, 0x0000000000000000, "CRM Credit Available" ],
   "INTB_N"                       => [   6,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "Pin Interrupt B" ],
   "INTA_N"                       => [   7,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "Pin Interrupt A" ],
   "CORELET_ID"                   => [   8,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Corelet Identification" ],
);

%tio_01_00809_def =
( NAME    => "TIO_CA_STATUS1",
  ADDRESS => 0x0000000020000018,
  NOTE    => "Miscellaneous status signals.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00809_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_STATUS2                                                       #
#                                                                        #
##########################################################################

%tio_01_00810_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  58,   6, 0xFC00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PDMA_RDBUFF_AVAIL"            => [   1,  56,   2, 0x0300000000000000, 0x00, 1, 0x0000000000000000, "PDMA Read Buffer Available" ],
   "PDMA_WRBUFF_AVAIL"            => [   2,  52,   4, 0x00F0000000000000, 0x00, 1, 0x0000000000000000, "PDMA Write Buffer Available" ],
   "PDMA_OPQ_AVAIL"               => [   3,  48,   4, 0x000F000000000000, 0x00, 1, 0x0000000000000000, "PDMA Op Queue Available" ],
   "PCI_PIO_OP_STAT"              => [   4,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "PCI PIO Op Status" ],
   "ADMA_RDBUFF_AVAIL"            => [   5,  40,   7, 0x00007F0000000000, 0x00, 1, 0x0000000000000000, "ADMA Read Buffer Available" ],
   "ADMA_WRBUFF_AVAIL"            => [   6,  32,   8, 0x000000FF00000000, 0x00, 1, 0x0000000000000000, "ADMA Write Buffer Available" ],
   "ADMA_OPQ_AVAIL"               => [   7,  24,   8, 0x00000000FF000000, 0x00, 1, 0x0000000000000000, "ADMA Op Queue Available" ],
   "GFX_WRBUFF_AVAIL"             => [   8,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "GFX Write Buffer Available" ],
   "GFX_OPQ_AVAIL"                => [   9,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "GFX Op Queue Available" ],
   "GFX_CREDIT_AVAIL"             => [  10,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "GFX Credit Available" ],
);

%tio_01_00810_def =
( NAME    => "TIO_CA_STATUS2",
  ADDRESS => 0x0000000020000020,
  NOTE    => "Buffer status.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00810_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_GART_APERTURE                                                 #
#                                                                        #
##########################################################################

%tio_01_00811_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "GART_AP_BASE"                 => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 1, 0x0000000000000000, "GART Aperture Base" ],
   "GART_AP_SIZE"                 => [   1,  12,  10, 0x00000000003FF000, 0x00, 1, 0x0000000000000000, "GART Aperture Size" ],
   "RSVD0"                        => [   2,   3,   9, 0x0000000000000FF8, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GART_AP_ENB_PCI"              => [   3,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "GART Aperture Enable PCI" ],
   "GART_PAGE_SIZE"               => [   4,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "GART Page Size" ],
   "GART_AP_ENB_AGP"              => [   5,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "GART Aperture Enable AGP" ],
);

%tio_01_00811_def =
( NAME    => "TIO_CA_GART_APERTURE",
  ADDRESS => 0x0000000020000028,
  NOTE    => "Defines location and size of GART aperture in virtual memory space. note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00811_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_GFX_DETACH                                                    #
#                                                                        #
##########################################################################

%tio_01_00812_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   1,  63, 0xFFFFFFFFFFFFFFFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_DETACH"                   => [   1,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "GFX Detach" ],
);

%tio_01_00812_def =
( NAME    => "TIO_CA_GFX_DETACH",
  ADDRESS => 0x0000000020000030,
  NOTE    => "Used to stop graphics credit transmission by software during note context switch. Writing a one prevents GFX Write from returnin",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00812_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_INTA_DEST_ADDR                                                #
#                                                                        #
##########################################################################

%tio_01_00813_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INTA_DEST_VECT"               => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Interrupt A Destination Vector" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INTA_DEST_ADDR"               => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Interrupt A Destination Address" ],
);

%tio_01_00813_def =
( NAME    => "TIO_CA_INTA_DEST_ADDR",
  ADDRESS => 0x0000000020000038,
  NOTE    => "Used as destination address vector for INTA# interrupt packets sent note to Coretalk.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00813_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_INTB_DEST_ADDR                                                #
#                                                                        #
##########################################################################

%tio_01_00814_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INTB_DEST_VECT"               => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Interrupt B Destination Vector" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INTB_DEST_ADDR"               => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Interrupt B Destination Address" ],
);

%tio_01_00814_def =
( NAME    => "TIO_CA_INTB_DEST_ADDR",
  ADDRESS => 0x0000000020000040,
  NOTE    => "Used as destination address and vector for INTB# interrupt packets note sent to Coretalk.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00814_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_ERR_INT_DEST_ADDR                                             #
#                                                                        #
##########################################################################

%tio_01_00815_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ERR_INT_DEST_VECT"            => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Error Interrupt Destination Vector" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ERR_INT_DEST_ADDR"            => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "Error Interrupt Destination Address" ],
);

%tio_01_00815_def =
( NAME    => "TIO_CA_ERR_INT_DEST_ADDR",
  ADDRESS => 0x0000000020000048,
  NOTE    => "Used as destination address and vector for error interrupt packets note sent to Coretalk.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00815_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_INT_STATUS                                                    #
#                                                                        #
##########################################################################

%tio_01_00816_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_CREDIT_OVFLW"             => [   1,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "GFX Credit Overflow" ],
   "MULT_INTB"                    => [   2,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Multiple INTB" ],
   "MULT_INTA"                    => [   3,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Multiple INTA" ],
   "INTB"                         => [   4,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "INTB" ],
   "INTA"                         => [   5,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "INTA" ],
   "RSVD1"                        => [   6,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SBA_TYPE1_ERR"                => [   7,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "SBA Type1 Command Error" ],
   "AGP_REQ_OFLOW"                => [   8,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "AGP Request Queue Overflow" ],
   "RSVD2"                        => [   9,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_INVALID_ADDR"             => [  10,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PIO Invalid Address" ],
   "CXM_REQ_CRED_OVFLW"           => [  11,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "CXM Request Credit Overflow" ],
   "CXM_RSP_CRED_OVFLW"           => [  12,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "CXM Response Credit Overflow" ],
   "CRM_TNUMTO"                   => [  13,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "CRM TNUM Timeout" ],
   "CRM_DVERR"                    => [  14,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "CRM Data Valid Error" ],
   "CRM_PKTERR"                   => [  15,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "CRM Packet Error" ],
   "PIO_REQ_OVFLW"                => [  16,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PIO Request Overflow" ],
   "GFX_WR_OVFLW"                 => [  17,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "GFX Write Overflow" ],
   "GART_FETCH_ERR"               => [  18,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "GART Fetch Error" ],
   "RSVD3"                        => [  19,   1,   3, 0x000000000000000E, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_ERR"                      => [  20,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PCI Error" ],
);

%tio_01_00816_def =
( NAME    => "TIO_CA_INT_STATUS",
  ADDRESS => 0x0000000020000050,
  NOTE    => "Each bit in the INT_STATUS register corresponds to the occurrence note of an interrupt event. With the exception of the INTA and",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00816_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_INT_STATUS_ALIAS                                              #
#                                                                        #
##########################################################################

%tio_01_00817_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_CREDIT_OVFLW"             => [   1,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "GFX Credit Overflow" ],
   "MULT_INTB"                    => [   2,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Multiple INTB" ],
   "MULT_INTA"                    => [   3,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Multiple INTA" ],
   "INTB"                         => [   4,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "INTB" ],
   "INTA"                         => [   5,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "INTA" ],
   "RSVD1"                        => [   6,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SBA_TYPE1_ERR"                => [   7,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "SBA Type1 Command Error" ],
   "AGP_REQ_OFLOW"                => [   8,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "AGP Request Queue Overflow" ],
   "RSVD2"                        => [   9,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_INVALID_ADDR"             => [  10,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PIO Invalid Address" ],
   "CXM_REQ_CRED_OVFLW"           => [  11,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "CXM Request Credit Overflow" ],
   "CXM_RSP_CRED_OVFLW"           => [  12,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "CXM Response Credit Overflow" ],
   "CRM_TNUMTO"                   => [  13,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "CRM TNUM Timeout" ],
   "CRM_DVERR"                    => [  14,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "CRM Data Valid Error" ],
   "CRM_PKTERR"                   => [  15,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "CRM Packet Error" ],
   "PIO_REQ_OVFLW"                => [  16,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PIO Request Overflow" ],
   "GFX_WR_OVFLW"                 => [  17,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "GFX Write Overflow" ],
   "GART_FETCH_ERR"               => [  18,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "GART Fetch Error" ],
   "RSVD3"                        => [  19,   1,   3, 0x000000000000000E, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_ERR"                      => [  20,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PCI Error" ],
);

%tio_01_00817_def =
( NAME    => "TIO_CA_INT_STATUS_ALIAS",
  ADDRESS => 0x0000000020000058,
  NOTE    => "Each bit in the INT_STATUS_ALIAS maps one-to-one to the bits in the note INT_STATUS. This provides a means to clear individual b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00817_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MULT_ERROR                                                    #
#                                                                        #
##########################################################################

%tio_01_00818_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  18,  46, 0xFFFFFFFFFFFC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULT_GFX_CREDIT_OVFLW"        => [   1,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Multiple GFX Credit Overflow" ],
   "RSVD1"                        => [   2,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULT_SBA_TYPE1_ERR"           => [   3,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "SBA Type1 Command Error" ],
   "MULT_AGP_REQ_OFLOW"           => [   4,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "AGP Request Queue Overflow" ],
   "RSVD2"                        => [   5,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULT_PIO_INVALID_ADDR"        => [   6,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PIO Invalid Address" ],
   "MULT_CXM_REQ_CRED_OVFLW"      => [   7,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "CXM Request Credit Overflow" ],
   "MULT_CXM_RSP_CRED_OVFLW"      => [   8,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "CXM Response Credit Overflow" ],
   "MULT_CRM_TNUMTO"              => [   9,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "CRM TNUM Timeout" ],
   "MULT_CRM_DVERR"               => [  10,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "CRM Data Valid Error" ],
   "MULT_CRM_PKTERR"              => [  11,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "CRM Packet Error" ],
   "MULT_PIO_REQ_OVFLW"           => [  12,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PIO Request Overflow" ],
   "MULT_GFX_WR_OVFLW"            => [  13,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "GFX Write Overflow" ],
   "MULT_GART_FETCH_ERR"          => [  14,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "GART Fetch Error" ],
   "RSVD3"                        => [  15,   1,   3, 0x000000000000000E, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULT_PCI_ERR"                 => [  16,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PCI Error" ],
);

%tio_01_00818_def =
( NAME    => "TIO_CA_MULT_ERROR",
  ADDRESS => 0x0000000020000060,
  NOTE    => "Bits are set if a CA error occurs when the INT_STATUS bit for that note error is already asserted. Bits [15:0] map to the same b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00818_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MULT_ERROR_ALIAS                                              #
#                                                                        #
##########################################################################

%tio_01_00819_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  18,  46, 0xFFFFFFFFFFFC0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULT_GFX_CREDIT_OVFLW"        => [   1,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Multiple GFX Credit Overflow" ],
   "RSVD1"                        => [   2,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULT_SBA_TYPE1_ERR"           => [   3,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "SBA Type1 Command Error" ],
   "MULT_AGP_REQ_OFLOW"           => [   4,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "AGP Request Queue Overflow" ],
   "RSVD2"                        => [   5,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULT_PIO_INVALID_ADDR"        => [   6,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PIO Invalid Address" ],
   "MULT_CXM_REQ_CRED_OVFLW"      => [   7,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "CXM Request Credit Overflow" ],
   "MULT_CXM_RSP_CRED_OVFLW"      => [   8,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "CXM Response Credit Overflow" ],
   "MULT_CRM_TNUMTO"              => [   9,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "CRM TNUM Timeout" ],
   "MULT_CRM_DVERR"               => [  10,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "CRM Data Valid Error" ],
   "MULT_CRM_PKTERR"              => [  11,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "CRM Packet Error" ],
   "MULT_PIO_REQ_OVFLW"           => [  12,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PIO Request Overflow" ],
   "MULT_GFX_WR_OVFLW"            => [  13,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "GFX Write Overflow" ],
   "MULT_GART_FETCH_ERR"          => [  14,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "GART Fetch Error" ],
   "RSVD3"                        => [  15,   1,   3, 0x000000000000000E, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULT_PCI_ERR"                 => [  16,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PCI Error" ],
);

%tio_01_00819_def =
( NAME    => "TIO_CA_MULT_ERROR_ALIAS",
  ADDRESS => 0x0000000020000068,
  NOTE    => "Each bit in MULTI_ERROR_ALIAS maps one-to-one to the bits in the note MULT_ERROR register. All non-reserved bits have W1C access",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00819_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_FIRST_ERROR                                                   #
#                                                                        #
##########################################################################

%tio_01_00820_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  20,  44, 0xFFFFFFFFFFF00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIRST_GFX_CREDIT_OVFLW"       => [   1,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "First GFX Credit Overflow" ],
   "FIRST_MULT_INTB"              => [   2,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "First Multiple INTB" ],
   "FIRST_MULT_INTA"              => [   3,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "First Multiple INTA" ],
   "RSVD1"                        => [   4,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIRST_SBA_TYPE1_ERR"          => [   5,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "SBA Type1 Command Error" ],
   "FIRST_AGP_REQ_OFLOW"          => [   6,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "AGP Request Queue Overflow" ],
   "RSVD2"                        => [   7,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIRST_PIO_INVALID_ADDR"       => [   8,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "PIO Invalid Address" ],
   "FIRST_CXM_REQ_CRED_OVFLW"     => [   9,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "CXM Request Credit Overflow" ],
   "FIRST_CXM_RSP_CRED_OVFLW"     => [  10,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "CXM Response Credit Overflow" ],
   "FIRST_CRM_TNUMTO"             => [  11,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "CRM TNUM Timeout" ],
   "FIRST_CRM_DVERR"              => [  12,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "CRM Data Valid Error" ],
   "FIRST_CRM_PKTERR"             => [  13,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "CRM Packet Error" ],
   "FIRST_PIO_REQ_OVFLW"          => [  14,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "PIO Request Overflow" ],
   "FIRST_GFX_WR_OVFLW"           => [  15,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "GFX Write Overflow" ],
   "FIRST_GART_FETCH_ERR"         => [  16,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "GART Fetch Error" ],
   "RSVD3"                        => [  17,   1,   3, 0x000000000000000E, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIRST_PEMN_PCI_ERR"           => [  18,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "PCI Error" ],
);

%tio_01_00820_def =
( NAME    => "TIO_CA_FIRST_ERROR",
  ADDRESS => 0x0000000020000070,
  NOTE    => "This register holds first error summary for CA errors. Once the note INT_STATUS register is cleared, the next error(s) that occu",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00820_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_INT_MASK                                                      #
#                                                                        #
##########################################################################

%tio_01_00821_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GFX_CREDIT_OVFLW_MASK"        => [   1,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "GFX Credit Overflow Mask" ],
   "MULT_INTB_MASK"               => [   2,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "Multiple INTB Mask" ],
   "MULT_INTA_MASK"               => [   3,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "Multiple INTA Mask" ],
   "INTB_MASK"                    => [   4,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "INTB Mask" ],
   "INTA_MASK"                    => [   5,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "INTA Mask" ],
   "RSVD1"                        => [   6,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SBA_TYPE1_ERR_MASK"           => [   7,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "SBA Type1 Command Error" ],
   "AGP_REQ_OFLOW_MASK"           => [   8,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "AGP Request Queue Overflow" ],
   "RSVD2"                        => [   9,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_INVALID_ADDR_MASK"        => [  10,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "PIO Invalid Address Mask" ],
   "CXM_REQ_CRED_OVFLW_MASK"      => [  11,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "CXM Request Credit Overflow Mask" ],
   "CXM_RSP_CRED_OVFLW_MASK"      => [  12,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "CXM Response Credit Overflow Mask" ],
   "CRM_TNUMTO_MASK"              => [  13,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "CRM TNUM Timeout Mask" ],
   "CRM_DVERR_MASK"               => [  14,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "CRM Data Valid Error Mask" ],
   "CRM_PKTERR_MASK"              => [  15,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "CRM Packet Error Mask" ],
   "PIO_REQ_OVFLW_MASK"           => [  16,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "PIO Request Overflow Mask" ],
   "GFX_WR_OVFLW_MASK"            => [  17,   5,   1, 0x0000000000000020, 0x00, 1, 0x0000000000000000, "GFX Write Overflow Mask" ],
   "GART_FETCH_ERR_MASK"          => [  18,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "GART Fetch Error Mask" ],
   "RSVD3"                        => [  19,   1,   3, 0x000000000000000E, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_ERR_MASK"                 => [  20,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "PCI Error Mask" ],
);

%tio_01_00821_def =
( NAME    => "TIO_CA_INT_MASK",
  ADDRESS => 0x0000000020000078,
  NOTE    => "Each bit in the INT_MASK maps one-to-one to the bits in the note INT_STATUS and FIRST_ERROR registers. A cleared mask bit allows",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00821_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_CRM_PKTERR_TYPE                                               #
#                                                                        #
##########################################################################

%tio_01_00822_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIRST_CRM_PKTERR_MSSNG_HDR"   => [   1,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Missing Header" ],
   "FIRST_CRM_PKTERR_MSSNG_TAIL"  => [   2,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Missing Tail" ],
   "FIRST_CRM_PKTERR_EARLY_TAIL"  => [   3,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Earlt Tail" ],
   "FIRST_CRM_PKTERR_EARLY_TERM"  => [   4,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Early Term" ],
   "FIRST_CRM_PKTERR_SBERR_NH"    => [   5,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Sideband Error Non-Head" ],
   "FIRST_CRM_PKTERR_CW_ERR"      => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Command Word Error" ],
   "FIRST_CRM_PKTERR_HDR_PARAM"   => [   7,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Header Paramater" ],
   "FIRST_CRM_PKTERR_ADDR_ALGN"   => [   8,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Address Alignment" ],
   "FIRST_CRM_PKTERR_ADDR_RNG"    => [   9,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Address Range" ],
   "FIRST_CRM_PKTERR_INV_TNUM"    => [  10,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Invalid TNUM" ],
   "FIRST_CRM_PKTERR_PACTYPE"     => [  11,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Packet Type" ],
   "FIRST_CRM_PKTERR_DIDN"        => [  12,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error DIDN" ],
   "FIRST_CRM_PKTERR_SBERR_HDR"   => [  13,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Sideband Error Header" ],
   "RSVD1"                        => [  14,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRM_PKTERR_MSSNG_HDR"         => [  15,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "CRM Packet Error Missing Header" ],
   "CRM_PKTERR_MSSNG_TAIL"        => [  16,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "CRM Packet Error Missing Tail" ],
   "CRM_PKTERR_EARLY_TAIL"        => [  17,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "CRM Packet Error Earlt Tail" ],
   "CRM_PKTERR_EARLY_TERM"        => [  18,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "CRM Packet Error Early Term" ],
   "CRM_PKTERR_SBERR_NH"          => [  19,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "CRM Packet Error Sideband Error Non-Head" ],
   "CRM_PKTERR_CW_ERR"            => [  20,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "CRM Packet Error Command Word Error" ],
   "CRM_PKTERR_HDR_PARAM"         => [  21,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "CRM Packet Error Header Paramater" ],
   "CRM_PKTERR_ADDR_ALGN"         => [  22,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "CRM Packet Error Address Alignment" ],
   "CRM_PKTERR_ADDR_RNG"          => [  23,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "CRM Packet Error Address Range" ],
   "CRM_PKTERR_INV_TNUM"          => [  24,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "CRM Packet Error Invalid TNUM" ],
   "CRM_PKTERR_PACTYPE"           => [  25,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "CRM Packet Error Packet Type" ],
   "CRM_PKTERR_DIDN"              => [  26,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "CRM Packet Error DIDN" ],
   "CRM_PKTERR_SBERR_HDR"         => [  27,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "CRM Packet Error Sideband Error Header" ],
);

%tio_01_00822_def =
( NAME    => "TIO_CA_CRM_PKTERR_TYPE",
  ADDRESS => 0x0000000020000080,
  NOTE    => "Diagnostic information specifying specific type of CRM packet error note that occurred. This includes a field for accumulated er",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00822_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_CRM_PKTERR_TYPE_ALIAS                                         #
#                                                                        #
##########################################################################

%tio_01_00823_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FIRST_CRM_PKTERR_MSSNG_HDR"   => [   1,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Missing Header" ],
   "FIRST_CRM_PKTERR_MSSNG_TAIL"  => [   2,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Missing Tail" ],
   "FIRST_CRM_PKTERR_EARLY_TAIL"  => [   3,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Earlt Tail" ],
   "FIRST_CRM_PKTERR_EARLY_TERM"  => [   4,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Early Term" ],
   "FIRST_CRM_PKTERR_SBERR_NH"    => [   5,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Sideband Error Non-Head" ],
   "FIRST_CRM_PKTERR_CW_ERR"      => [   6,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Command Word Error" ],
   "FIRST_CRM_PKTERR_HDR_PARAM"   => [   7,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Header Paramater" ],
   "FIRST_CRM_PKTERR_ADDR_ALGN"   => [   8,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Address Alignment" ],
   "FIRST_CRM_PKTERR_ADDR_RNG"    => [   9,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Address Range" ],
   "FIRST_CRM_PKTERR_INV_TNUM"    => [  10,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Invalid TNUM" ],
   "FIRST_CRM_PKTERR_PACTYPE"     => [  11,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Packet Type" ],
   "FIRST_CRM_PKTERR_DIDN"        => [  12,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error DIDN" ],
   "FIRST_CRM_PKTERR_SBERR_HDR"   => [  13,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "First CRM Packet Error Sideband Error Header" ],
   "RSVD1"                        => [  14,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRM_PKTERR_MSSNG_HDR"         => [  15,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "CRM Packet Error Missing Header" ],
   "CRM_PKTERR_MSSNG_TAIL"        => [  16,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "CRM Packet Error Missing Tail" ],
   "CRM_PKTERR_EARLY_TAIL"        => [  17,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "CRM Packet Error Earlt Tail" ],
   "CRM_PKTERR_EARLY_TERM"        => [  18,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "CRM Packet Error Early Term" ],
   "CRM_PKTERR_SBERR_NH"          => [  19,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "CRM Packet Error Sideband Error Non-Head" ],
   "CRM_PKTERR_CW_ERR"            => [  20,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "CRM Packet Error Command Word Error" ],
   "CRM_PKTERR_HDR_PARAM"         => [  21,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "CRM Packet Error Header Paramater" ],
   "CRM_PKTERR_ADDR_ALGN"         => [  22,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "CRM Packet Error Address Alignment" ],
   "CRM_PKTERR_ADDR_RNG"          => [  23,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "CRM Packet Error Address Range" ],
   "CRM_PKTERR_INV_TNUM"          => [  24,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "CRM Packet Error Invalid TNUM" ],
   "CRM_PKTERR_PACTYPE"           => [  25,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "CRM Packet Error Packet Type" ],
   "CRM_PKTERR_DIDN"              => [  26,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "CRM Packet Error DIDN" ],
   "CRM_PKTERR_SBERR_HDR"         => [  27,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "CRM Packet Error Sideband Error Header" ],
);

%tio_01_00823_def =
( NAME    => "TIO_CA_CRM_PKTERR_TYPE_ALIAS",
  ADDRESS => 0x0000000020000088,
  NOTE    => "Each bit in CRM_PKTERR_TYPE_ALIAS maps one-to-one to the bits in note the CRM_PKTERR_TYPE register. All non-reserved bits have W",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00823_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_CRM_CT_ERROR_DETAIL_1                                         #
#                                                                        #
##########################################################################

%tio_01_00824_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "RSVD0"                        => [   1,  36,  27, 0x7FFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CW_ERR"                       => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Command Word Error" ],
   "PIO_OP"                       => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PIO/Not Memory Operation" ],
   "MEM_RD_PARAM"                 => [   4,  32,   2, 0x0000000300000000, 0x00, 0, 0x0000000000000000, "Memory Read Parameters" ],
   "GFX_CRED"                     => [   5,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Graphics Credits" ],
   "DW_DATA_EN"                   => [   6,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Double Word Data Enables" ],
   "TNUM"                         => [   7,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Transaction Number" ],
   "DATA_SZ"                      => [   8,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Data Size" ],
   "SRC_ID"                       => [   9,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "Source Identification" ],
   "PKT_TYPE"                     => [  10,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Packet Type" ],
);

%tio_01_00824_def =
( NAME    => "TIO_CA_CRM_CT_ERROR_DETAIL_1",
  ADDRESS => 0x0000000020000090,
  NOTE    => "Diagnostic information related to CRM Coretalk packet errors. The note data is derived from the Coretalk Command Word.*newline**",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00824_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_CRM_CT_ERROR_DETAIL_2                                         #
#                                                                        #
##########################################################################

%tio_01_00825_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PKT_ADDR"                     => [   1,   3,  53, 0x00FFFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "CRM Packet Error Header Low" ],
);

%tio_01_00825_def =
( NAME    => "TIO_CA_CRM_CT_ERROR_DETAIL_2",
  ADDRESS => 0x0000000020000098,
  NOTE    => "Diagnostic information related to CRM Coretalk packet errors. This note is the address of an errant packet. Refer to Coretalk sp",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00825_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_CRM_TNUMTO                                                    #
#                                                                        #
##########################################################################

%tio_01_00826_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   9,  55, 0xFFFFFFFFFFFFFE00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRM_TNUMTO_WR"                => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "CRM TNUM Timeout Write" ],
   "CRM_TNUMTO_VAL"               => [   2,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "CRM TNUM Timeout Value" ],
);

%tio_01_00826_def =
( NAME    => "TIO_CA_CRM_TNUMTO",
  ADDRESS => 0x00000000200000a0,
  NOTE    => "Diagnostic information related to CRM TNUM timeout error. TNUM note detail in the following fields is captured on first error an",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00826_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_GART_ERR                                                      #
#                                                                        #
##########################################################################

%tio_01_00827_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  40,  24, 0xFFFFFF0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GART_ERR_ADDR"                => [   1,   4,  36, 0x000000FFFFFFFFF0, 0x00, 0, 0x0000000000000000, "GART Error Address" ],
   "RSVD1"                        => [   2,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GART_ERR_SOURCE"              => [   3,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "GART Error Source" ],
);

%tio_01_00827_def =
( NAME    => "TIO_CA_GART_ERR",
  ADDRESS => 0x00000000200000a8,
  NOTE    => "Diagnostic information related to GART invalid address. This type note of error occurs when an address lies within the GART aper",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00827_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_PCIERR_TYPE                                                   #
#                                                                        #
##########################################################################

%tio_01_00828_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  50,  14, 0xFFFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCIERR_MST_RETRY_TOUT"        => [   1,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "PCI Error Master Retry TOUT" ],
   "PCIERR_MST_TABT"              => [   2,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "PCI Error Master Target Abort" ],
   "PCIERR_MST_MABT"              => [   3,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "PCI Error Master Master Abort" ],
   "PCIERR_MST_RD_PERR"           => [   4,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "PCI Error Master Read Error" ],
   "PCIERR_MST_WR_PERR"           => [   5,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "PCI Error Master Write Error" ],
   "PCIERR_MST_SERR"              => [   6,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "PCI Error Master Error" ],
   "PCIERR_SLV_RD_PERR"           => [   7,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "PCI Error Slave Read Error" ],
   "PCIERR_SLV_WR_PERR"           => [   8,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "PCI Error Slave Write Error" ],
   "PCIERR_SLV_SERR"              => [   9,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "PCI Error Slave Error" ],
   "PCIERR_A64"                   => [  10,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "PCI Error A64" ],
   "PCIERR_CMD"                   => [  11,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "PCI Error Command" ],
   "PCIERR_ENB"                   => [  12,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "PCI Error Enable" ],
   "PCIERR_DATA"                  => [  13,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "PCI Error Data" ],
);

%tio_01_00828_def =
( NAME    => "TIO_CA_PCIERR_TYPE",
  ADDRESS => 0x00000000200000b0,
  NOTE    => "Diagnostic information pertaining to PCI transaction error. Error note detail in the following fields is captured on first error",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00828_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_PCIERR_ADDR                                                   #
#                                                                        #
##########################################################################

%tio_01_00829_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PCIERR_ADDR"                  => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "PCI Error Address" ],
);

%tio_01_00829_def =
( NAME    => "TIO_CA_PCIERR_ADDR",
  ADDRESS => 0x00000000200000b8,
  NOTE    => "Diagnostic information containing address of PCI transaction that note experienced an error. Error detail in the following field",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00829_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_PCI_RD_BUF_FLUSH                                              #
#                                                                        #
##########################################################################

%tio_01_00830_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_RD_BUF_FLUSH"             => [   1,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "PCI Read Buffer Flush" ],
);

%tio_01_00830_def =
( NAME    => "TIO_CA_PCI_RD_BUF_FLUSH",
  ADDRESS => 0x00000000200000d8,
  NOTE    => "Control that flushes the PCI read buffers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00830_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_PCI_DMA_ADDR_EXTN                                             #
#                                                                        #
##########################################################################

%tio_01_00831_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_MEM_TYPE"                 => [   1,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "PIO Memory Type" ],
   "RSVD1"                        => [   2,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   3,  12,  14, 0x0000000003FFF000, 0x00, 1, 0x0000000000000000, "Node Identification" ],
   "RSVD2"                        => [   4,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CHIPLET_ID"                   => [   5,   8,   2, 0x0000000000000300, 0x00, 1, 0x0000000000000000, "Chiplet Identification" ],
   "RSVD3"                        => [   6,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPPER_NODE_OFFSET"            => [   7,   0,   6, 0x000000000000003F, 0x00, 1, 0x0000000000000000, "Upper node offset" ],
);

%tio_01_00831_def =
( NAME    => "TIO_CA_PCI_DMA_ADDR_EXTN",
  ADDRESS => 0x00000000200000e0,
  NOTE    => "Address extension to PCI DMA.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00831_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_AGP_DMA_ADDR_EXTN                                             #
#                                                                        #
##########################################################################

%tio_01_00832_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_MEM_TYPE"                 => [   1,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "PIO Memory Type" ],
   "RSVD1"                        => [   2,  26,   2, 0x000000000C000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NODE_ID"                      => [   3,  20,   6, 0x0000000003F00000, 0x00, 1, 0x0000000000000000, "Node Identification" ],
);

%tio_01_00832_def =
( NAME    => "TIO_CA_AGP_DMA_ADDR_EXTN",
  ADDRESS => 0x00000000200000e8,
  NOTE    => "Address extension to AGP DMA.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00832_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_FORCE_INTA                                                    #
#                                                                        #
##########################################################################

%tio_01_00833_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTA"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force INTA#" ],
);

%tio_01_00833_def =
( NAME    => "TIO_CA_FORCE_INTA",
  ADDRESS => 0x00000000200000f0,
  NOTE    => "A write to this data independent write only register will cause an note interrupt packet to be generated IF the associated inter",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00833_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_FORCE_INTB                                                    #
#                                                                        #
##########################################################################

%tio_01_00834_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTB"                   => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force INTB#" ],
);

%tio_01_00834_def =
( NAME    => "TIO_CA_FORCE_INTB",
  ADDRESS => 0x00000000200000f8,
  NOTE    => "A write to this data independent write only register will cause an note interrupt packet to be generated IF the associated inter",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00834_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_DEBUG_VECTOR_SEL                                              #
#                                                                        #
##########################################################################

%tio_01_00835_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_PM_VSEL"                => [   1,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Debug PCI Master Vector Select" ],
   "DEBUG_PS_VSEL"                => [   2,  52,   4, 0x00F0000000000000, 0x00, 0, 0x0000000000000000, "Debug PCI Slave Vector Select" ],
   "DEBUG_AS_VSEL"                => [   3,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "Debug AGP Slave Vector Select" ],
   "DEBUG_BI_VSEL"                => [   4,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "Debug Busin Vector Select" ],
   "DEBUG_BO_VSEL"                => [   5,  40,   4, 0x00000F0000000000, 0x00, 0, 0x0000000000000000, "Debug Busout Vector Select" ],
   "DEBUG_PE_VSEL"                => [   6,  36,   4, 0x000000F000000000, 0x00, 0, 0x0000000000000000, "Debug PCI Errlog Vector Select" ],
   "DEBUG_BA_VSEL"                => [   7,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "Debug Busarb Vector Select" ],
   "DEBUG_CR_VSEL"                => [   8,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "Debug CRM Vector Select" ],
   "DEBUG_CX_VSEL"                => [   9,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Debug CXM Vector Select" ],
   "DEBUG_AD_VSEL"                => [  10,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "Debug AGP DMA Vector Select" ],
   "DEBUG_PD_VSEL"                => [  11,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "Debug PCI DMA Vector Select" ],
   "DEBUG_GT_VSEL"                => [  12,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Debug GART Vector Select" ],
   "DEBUG_GW_VSEL"                => [  13,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "Debug GFX WRite Vector Select" ],
   "DEBUG_PP_VSEL"                => [  14,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "Debug PCI PIO Vector Select" ],
   "DEBUG_MN_VSEL"                => [  15,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Debug Admin Vector Select" ],
);

%tio_01_00835_def =
( NAME    => "TIO_CA_DEBUG_VECTOR_SEL",
  ADDRESS => 0x0000000020000100,
  NOTE    => "Each 4-bit field drives select lines to each CA sub-block to choose note one of sixteen 32-bit test point vectors to be sent to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00835_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_DEBUG_MUX_CORE_SEL                                            #
#                                                                        #
##########################################################################

%tio_01_00836_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_CORE_NSEL7"             => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Debug Core Nibble Select 7" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_CORE_MSEL7"             => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Debug Core Module Select 7" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_CORE_NSEL6"             => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Debug Core Nibble Select 6" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_CORE_MSEL6"             => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Debug Core Module Select 6" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_CORE_NSEL5"             => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Debug Core Nibble Select 5" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_CORE_MSEL5"             => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Debug Core Module Select 5" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_CORE_NSEL4"             => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Debug Core Nibble Select 4" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_CORE_MSEL4"             => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Debug Core Module Select 4" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_CORE_NSEL3"             => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Debug Core Nibble Select 3" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_CORE_MSEL3"             => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Debug Core Module Select 3" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_CORE_NSEL2"             => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Debug Core Nibble Select 2" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_CORE_MSEL2"             => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Debug Core Module Select 2" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_CORE_NSEL1"             => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Debug Core Nibble Select 1" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_CORE_MSEL1"             => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Debug Core Module Select 1" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_CORE_NSEL0"             => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Debug Core Nibble Select 0" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_CORE_MSEL0"             => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Debug Core Module Select 0" ],
);

%tio_01_00836_def =
( NAME    => "TIO_CA_DEBUG_MUX_CORE_SEL",
  ADDRESS => 0x0000000020000108,
  NOTE    => "The following fields control the core domain debug vector port and note nibble muxing selects. CA top level debug mux has two st",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00836_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_DEBUG_MUX_PCI_SEL                                             #
#                                                                        #
##########################################################################

%tio_01_00837_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_PCI_NSEL7"              => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Debug PCI Nibble Select 7" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_PCI_MSEL7"              => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Debug PCI Module Select 7" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_PCI_NSEL6"              => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Debug PCI Nibble Select 6" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_PCI_MSEL6"              => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Debug PCI Module Select 6" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_PCI_NSEL5"              => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Debug PCI Nibble Select 5" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_PCI_MSEL5"              => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Debug PCI Module Select 5" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_PCI_NSEL4"              => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Debug PCI Nibble Select 4" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_PCI_MSEL4"              => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Debug PCI Module Select 4" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_PCI_NSEL3"              => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Debug PCI Nibble Select 3" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_PCI_MSEL3"              => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Debug PCI Module Select 3" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_PCI_NSEL2"              => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Debug PCI Nibble Select 2" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_PCI_MSEL2"              => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Debug PCI Module Select 2" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_PCI_NSEL1"              => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Debug PCI Nibble Select 1" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_PCI_MSEL1"              => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Debug PCI Module Select 1" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_PCI_NSEL0"              => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Debug PCI Nibble Select 0" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_PCI_MSEL0"              => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Debug PCI Module Select 0" ],
);

%tio_01_00837_def =
( NAME    => "TIO_CA_DEBUG_MUX_PCI_SEL",
  ADDRESS => 0x0000000020000110,
  NOTE    => "The following fields control the PCI domain debug vector port and note nibble muxing selects. The PCI domain debug mux has two s",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00837_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_DEBUG_DOMAIN_SEL                                              #
#                                                                        #
##########################################################################

%tio_01_00838_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   2,  62, 0xFFFFFFFFFFFFFFFC, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEBUG_DOMAIN_H"               => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "Debug Domain High" ],
   "DEBUG_DOMAIN_L"               => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "Debug Domain Low" ],
);

%tio_01_00838_def =
( NAME    => "TIO_CA_DEBUG_DOMAIN_SEL",
  ADDRESS => 0x0000000020000118,
  NOTE    => "The output of the top level CA debug mux is 32 bits wide. The note domain selects can be configured to send out debug signals fr",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00838_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_GART_PTR_TABLE                                                #
#                                                                        #
##########################################################################

%tio_01_00839_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GART_PTR_ADDR"                => [   1,  12,  44, 0x00FFFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "GART Pointer Address" ],
   "RSVD1"                        => [   2,   1,  11, 0x0000000000000FFE, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GART_PTR_VAL"                 => [   3,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "GART Pointer Valid" ],
);

%tio_01_00839_def =
( NAME    => "TIO_CA_GART_PTR_TABLE",
  ADDRESS => 0x0000000020000200,
  NOTE    => "This register stores the pointer to Coretalk physical memory space note used by the GART aperture. (Admin module circuitry insur",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00839_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_GART_TLB_ADDR_0                                               #
#                                                                        #
##########################################################################

%tio_01_00840_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "GART_TLB_VAL"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "GART Translation Lookaside Buffer Valid" ],
   "RSVD0"                        => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GART_TLB_ADDR"                => [   2,   0,  56, 0x00FFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "GART TLB Address" ],
);

%tio_01_00840_def =
( NAME    => "TIO_CA_GART_TLB_ADDR_0",
  ADDRESS => 0x0000000020000208,
  NOTE    => "This register contains the Cacheline physical address for one of note eight GART TLB and in the TLBs valid state.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00840_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_GART_TLB_ADDR_1                                               #
#                                                                        #
##########################################################################

%tio_01_00841_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "GART_TLB_VAL"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "GART Translation Lookaside Buffer Valid" ],
   "RSVD0"                        => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GART_TLB_ADDR"                => [   2,   0,  56, 0x00FFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "GART TLB Address" ],
);

%tio_01_00841_def =
( NAME    => "TIO_CA_GART_TLB_ADDR_1",
  ADDRESS => 0x0000000020000210,
  NOTE    => "This register contains the Cacheline physical address for one of note eight GART TLB and in the TLBs valid state.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00841_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_GART_TLB_ADDR_2                                               #
#                                                                        #
##########################################################################

%tio_01_00842_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "GART_TLB_VAL"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "GART Translation Lookaside Buffer Valid" ],
   "RSVD0"                        => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GART_TLB_ADDR"                => [   2,   0,  56, 0x00FFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "GART TLB Address" ],
);

%tio_01_00842_def =
( NAME    => "TIO_CA_GART_TLB_ADDR_2",
  ADDRESS => 0x0000000020000218,
  NOTE    => "This register contains the Cacheline physical address for one of note eight GART TLB and in the TLBs valid state.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00842_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_GART_TLB_ADDR_3                                               #
#                                                                        #
##########################################################################

%tio_01_00843_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "GART_TLB_VAL"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "GART Translation Lookaside Buffer Valid" ],
   "RSVD0"                        => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GART_TLB_ADDR"                => [   2,   0,  56, 0x00FFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "GART TLB Address" ],
);

%tio_01_00843_def =
( NAME    => "TIO_CA_GART_TLB_ADDR_3",
  ADDRESS => 0x0000000020000220,
  NOTE    => "This register contains the Cacheline physical address for one of note eight GART TLB and in the TLBs valid state.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00843_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_GART_TLB_ADDR_4                                               #
#                                                                        #
##########################################################################

%tio_01_00844_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "GART_TLB_VAL"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "GART Translation Lookaside Buffer Valid" ],
   "RSVD0"                        => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GART_TLB_ADDR"                => [   2,   0,  56, 0x00FFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "GART TLB Address" ],
);

%tio_01_00844_def =
( NAME    => "TIO_CA_GART_TLB_ADDR_4",
  ADDRESS => 0x0000000020000228,
  NOTE    => "This register contains the Cacheline physical address for one of note eight GART TLB and in the TLBs valid state.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00844_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_GART_TLB_ADDR_5                                               #
#                                                                        #
##########################################################################

%tio_01_00845_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "GART_TLB_VAL"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "GART Translation Lookaside Buffer Valid" ],
   "RSVD0"                        => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GART_TLB_ADDR"                => [   2,   0,  56, 0x00FFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "GART TLB Address" ],
);

%tio_01_00845_def =
( NAME    => "TIO_CA_GART_TLB_ADDR_5",
  ADDRESS => 0x0000000020000230,
  NOTE    => "This register contains the Cacheline physical address for one of note eight GART TLB and in the TLBs valid state.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00845_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_GART_TLB_ADDR_6                                               #
#                                                                        #
##########################################################################

%tio_01_00846_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "GART_TLB_VAL"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "GART Translation Lookaside Buffer Valid" ],
   "RSVD0"                        => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GART_TLB_ADDR"                => [   2,   0,  56, 0x00FFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "GART TLB Address" ],
);

%tio_01_00846_def =
( NAME    => "TIO_CA_GART_TLB_ADDR_6",
  ADDRESS => 0x0000000020000238,
  NOTE    => "This register contains the Cacheline physical address for one of note eight GART TLB and in the TLBs valid state.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00846_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_GART_TLB_ADDR_7                                               #
#                                                                        #
##########################################################################

%tio_01_00847_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "GART_TLB_VAL"                 => [   0,  63,   1, 0x8000000000000000, 0x00, 1, 0x0000000000000000, "GART Translation Lookaside Buffer Valid" ],
   "RSVD0"                        => [   1,  56,   7, 0x7F00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "GART_TLB_ADDR"                => [   2,   0,  56, 0x00FFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "GART TLB Address" ],
);

%tio_01_00847_def =
( NAME    => "TIO_CA_GART_TLB_ADDR_7",
  ADDRESS => 0x0000000020000240,
  NOTE    => "This register contains the Cacheline physical address for one of note eight GART TLB and in the TLBs valid state.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00847_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_WRT_WD_BUFF0                                            #
#                                                                        #
##########################################################################

%tio_01_00848_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "WRT_ADDR"                     => [   3,   6,   8, 0x0000000000003FC0, 0x00, 0, 0x0000000000000000, "Write Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits 63 to 0" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00848_def =
( NAME    => "TIO_CA_MAINT_WRT_WD_BUFF0",
  ADDRESS => 0x0000000020020000,
  NOTE    => "The ADMA write data buffer consists of 8 physical LPRAs, each 32 note bits wide and 256 elements deep. All 8 LPRAs work together",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00848_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_WRT_WD_BUFF1                                            #
#                                                                        #
##########################################################################

%tio_01_00849_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "WRT_ADDR"                     => [   3,   6,   8, 0x0000000000003FC0, 0x00, 0, 0x0000000000000000, "Write Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [127:64]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00849_def =
( NAME    => "TIO_CA_MAINT_WRT_WD_BUFF1",
  ADDRESS => 0x0000000020020008,
  NOTE    => "The ADMA write data buffer consists of 8 physical LPRAs, each 32 note bits wide and 256 elements deep. All 8 LPRAs work together",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00849_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_WRT_WD_BUFF2                                            #
#                                                                        #
##########################################################################

%tio_01_00850_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "WRT_ADDR"                     => [   3,   6,   8, 0x0000000000003FC0, 0x00, 0, 0x0000000000000000, "Write Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [191:128]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00850_def =
( NAME    => "TIO_CA_MAINT_WRT_WD_BUFF2",
  ADDRESS => 0x0000000020020010,
  NOTE    => "The ADMA write data buffer consists of 8 physical LPRAs, each 32 note bits wide and 256 elements deep. All 8 LPRAs work together",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00850_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_WRT_WD_BUFF3                                            #
#                                                                        #
##########################################################################

%tio_01_00851_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "WRT_ADDR"                     => [   3,   6,   8, 0x0000000000003FC0, 0x00, 0, 0x0000000000000000, "Write Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [255:192]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00851_def =
( NAME    => "TIO_CA_MAINT_WRT_WD_BUFF3",
  ADDRESS => 0x0000000020020018,
  NOTE    => "The ADMA write data buffer consists of 8 physical LPRAs, each 32 note bits wide and 256 elements deep. All 8 LPRAs work together",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00851_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_RD_WD_BUFF0                                             #
#                                                                        #
##########################################################################

%tio_01_00852_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "RD_ADDR"                      => [   3,   6,   9, 0x0000000000007FC0, 0x00, 0, 0x0000000000000000, "Read Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [63:0]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00852_def =
( NAME    => "TIO_CA_MAINT_RD_WD_BUFF0",
  ADDRESS => 0x0000000020020000,
  NOTE    => "The ADMA write data buffer consists of 8 physical LPRAs, each 32 note bits wide and 256 elements deep. All 8 LPRAs work together",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00852_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_RD_WD_BUFF1                                             #
#                                                                        #
##########################################################################

%tio_01_00853_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "RD_ADDR"                      => [   3,   6,   9, 0x0000000000007FC0, 0x00, 0, 0x0000000000000000, "Read Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [128:64]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00853_def =
( NAME    => "TIO_CA_MAINT_RD_WD_BUFF1",
  ADDRESS => 0x0000000020020008,
  NOTE    => "The ADMA write data buffer consists of 8 physical LPRAs, each 32 note bits wide and 256 elements deep. All 8 LPRAs work together",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00853_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_RD_WD_BUFF2                                             #
#                                                                        #
##########################################################################

%tio_01_00854_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "RD_ADDR"                      => [   3,   6,   9, 0x0000000000007FC0, 0x00, 0, 0x0000000000000000, "Read Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [191:128]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00854_def =
( NAME    => "TIO_CA_MAINT_RD_WD_BUFF2",
  ADDRESS => 0x0000000020020010,
  NOTE    => "The ADMA write data buffer consists of 8 physical LPRAs, each 32 note bits wide and 256 elements deep. All 8 LPRAs work together",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00854_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_RD_WD_BUFF3                                             #
#                                                                        #
##########################################################################

%tio_01_00855_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "RD_ADDR"                      => [   3,   6,   9, 0x0000000000007FC0, 0x00, 0, 0x0000000000000000, "Read Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [255:192]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00855_def =
( NAME    => "TIO_CA_MAINT_RD_WD_BUFF3",
  ADDRESS => 0x0000000020020018,
  NOTE    => "The ADMA write data buffer consists of 8 physical LPRAs, each 32 note bits wide and 256 elements deep. All 8 LPRAs work together",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00855_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_WRT_RD_BUFF0                                            #
#                                                                        #
##########################################################################

%tio_01_00856_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "WRT_ADDR"                     => [   3,   6,   9, 0x0000000000007FC0, 0x00, 0, 0x0000000000000000, "Write Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [63:0]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00856_def =
( NAME    => "TIO_CA_MAINT_WRT_RD_BUFF0",
  ADDRESS => 0x0000000020030000,
  NOTE    => "The ADMA read data buffer consists of 4 physical LPRAs, each 64 note bits wide and 128 elements deep. All 4 LPRAs work together ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00856_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_WRT_RD_BUFF1                                            #
#                                                                        #
##########################################################################

%tio_01_00857_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "WRT_ADDR"                     => [   3,   6,   7, 0x0000000000001FC0, 0x00, 0, 0x0000000000000000, "Wrtie Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [127:64]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00857_def =
( NAME    => "TIO_CA_MAINT_WRT_RD_BUFF1",
  ADDRESS => 0x0000000020030008,
  NOTE    => "The ADMA read data buffer consists of 4 physical LPRAs, each 64 note bits wide and 128 elements deep. All 4 LPRAs work together ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00857_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_WRT_RD_BUFF2                                            #
#                                                                        #
##########################################################################

%tio_01_00858_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "WRT_ADDR"                     => [   3,   6,   7, 0x0000000000001FC0, 0x00, 0, 0x0000000000000000, "Write Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [191:128]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00858_def =
( NAME    => "TIO_CA_MAINT_WRT_RD_BUFF2",
  ADDRESS => 0x0000000020030010,
  NOTE    => "The ADMA read data buffer consists of 4 physical LPRAs, each 64 note bits wide and 128 elements deep. All 4 LPRAs work together ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00858_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_WRT_RD_BUFF3                                            #
#                                                                        #
##########################################################################

%tio_01_00859_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "WRT_ADDR"                     => [   3,   6,   7, 0x0000000000001FC0, 0x00, 0, 0x0000000000000000, "Write Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [255:192]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00859_def =
( NAME    => "TIO_CA_MAINT_WRT_RD_BUFF3",
  ADDRESS => 0x0000000020030018,
  NOTE    => "The ADMA read data buffer consists of 4 physical LPRAs, each 64 note bits wide and 128 elements deep. All 4 LPRAs work together ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00859_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_RD_RD_BUFF0                                             #
#                                                                        #
##########################################################################

%tio_01_00860_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "RD_ADDR"                      => [   3,   6,   7, 0x0000000000001FC0, 0x00, 0, 0x0000000000000000, "Read Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [63:0]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00860_def =
( NAME    => "TIO_CA_MAINT_RD_RD_BUFF0",
  ADDRESS => 0x0000000020030000,
  NOTE    => "The ADMA read data buffer consists of 4 physical LPRAs, each 64 note bits wide and 128 elements deep. All 4 LPRAs work together ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00860_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_RD_RD_BUFF1                                             #
#                                                                        #
##########################################################################

%tio_01_00861_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "RD_ADDR"                      => [   3,   6,   7, 0x0000000000001FC0, 0x00, 0, 0x0000000000000000, "Read Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [127:64]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00861_def =
( NAME    => "TIO_CA_MAINT_RD_RD_BUFF1",
  ADDRESS => 0x0000000020030008,
  NOTE    => "The ADMA read data buffer consists of 4 physical LPRAs, each 64 note bits wide and 128 elements deep. All 4 LPRAs work together ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00861_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_RD_RD_BUFF2                                             #
#                                                                        #
##########################################################################

%tio_01_00862_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "RD_ADDR"                      => [   3,   6,   7, 0x0000000000001FC0, 0x00, 0, 0x0000000000000000, "Read Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [191:128]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00862_def =
( NAME    => "TIO_CA_MAINT_RD_RD_BUFF2",
  ADDRESS => 0x0000000020030010,
  NOTE    => "The ADMA read data buffer consists of 4 physical LPRAs, each 64 note bits wide and 128 elements deep. All 4 LPRAs work together ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00862_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_RD_RD_BUFF3                                             #
#                                                                        #
##########################################################################

%tio_01_00863_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "RD_ADDR"                      => [   3,   6,   7, 0x0000000000001FC0, 0x00, 0, 0x0000000000000000, "Read Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [255:192]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00863_def =
( NAME    => "TIO_CA_MAINT_RD_RD_BUFF3",
  ADDRESS => 0x0000000020030018,
  NOTE    => "The ADMA read data buffer consists of 4 physical LPRAs, each 64 note bits wide and 128 elements deep. All 4 LPRAs work together ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00863_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_RD_OP_QUEUE                                             #
#                                                                        #
##########################################################################

%tio_01_00864_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "RD_ADDR"                      => [   3,   6,   7, 0x0000000000001FC0, 0x00, 0, 0x0000000000000000, "Read Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [63:0]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00864_def =
( NAME    => "TIO_CA_MAINT_RD_OP_QUEUE",
  ADDRESS => 0x0000000020020028,
  NOTE    => "This register contains the first physical address for 128 entries note in the ADMA Op Queue Buffer[63:0]. Bits [12:6] of this re",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00864_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_RD_BE_BUFF0                                             #
#                                                                        #
##########################################################################

%tio_01_00865_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "RD_ADDR"                      => [   3,   6,   7, 0x0000000000001FC0, 0x00, 0, 0x0000000000000000, "Read Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [63:0]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00865_def =
( NAME    => "TIO_CA_MAINT_RD_BE_BUFF0",
  ADDRESS => 0x0000000020020030,
  NOTE    => "This register contains the first physical address for 128 entries note in the ADMA Byte Enable Buffer[63:0]. Bits [12:6] of this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00865_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_RD_BE_BUFF1                                             #
#                                                                        #
##########################################################################

%tio_01_00866_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "RD_ADDR"                      => [   3,   6,   9, 0x0000000000007FC0, 0x00, 0, 0x0000000000000000, "Read Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [71:64]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00866_def =
( NAME    => "TIO_CA_MAINT_RD_BE_BUFF1",
  ADDRESS => 0x0000000020020038,
  NOTE    => "This register contains the first physical address for 128 entries note in the ADMA Byte Enable Buffer[71:64]. Bits [12:6] of thi",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00866_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_WRT_RMT                                                 #
#                                                                        #
##########################################################################

%tio_01_00867_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "WRT_ADDR"                     => [   3,   6,   9, 0x0000000000007FC0, 0x00, 0, 0x0000000000000000, "Write Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [63:0]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00867_def =
( NAME    => "TIO_CA_MAINT_WRT_RMT",
  ADDRESS => 0x0000000020034000,
  NOTE    => "This register contains the first physical address for 128 entries note in the ADMA Reponse Mapping Table Buffer[63:0]. Bits [14:",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00867_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_RD_RMT                                                  #
#                                                                        #
##########################################################################

%tio_01_00868_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "RD_ADDR"                      => [   3,   6,   9, 0x0000000000007FC0, 0x00, 0, 0x0000000000000000, "Read Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [63:0]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00868_def =
( NAME    => "TIO_CA_MAINT_RD_RMT",
  ADDRESS => 0x0000000020024000,
  NOTE    => "This register contains the first physical address for 128 entries note in the ADMA Reponse Mapping Table Buffer[63:0]. Bits [14:",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00868_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_WRT_GFX0                                                #
#                                                                        #
##########################################################################

%tio_01_00869_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "WRT_ADDR"                     => [   3,   6,   9, 0x0000000000007FC0, 0x00, 0, 0x0000000000000000, "Write Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [63:0]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00869_def =
( NAME    => "TIO_CA_MAINT_WRT_GFX0",
  ADDRESS => 0x0000000020010000,
  NOTE    => "This register contains the first physical address for 128 entries note in the ADMA Reponse Mapping Table Buffer[63:0]. Bits [14:",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00869_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_WRT_GFX1                                                #
#                                                                        #
##########################################################################

%tio_01_00870_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "WRT_ADDR"                     => [   3,   6,   9, 0x0000000000007FC0, 0x00, 0, 0x0000000000000000, "Write Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [127:64]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00870_def =
( NAME    => "TIO_CA_MAINT_WRT_GFX1",
  ADDRESS => 0x0000000020010008,
  NOTE    => "This register contains the first physical address for 128 entries note in the ADMA Reponse Mapping Table Buffer[127:64]. Bits [1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00870_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_WRT_GFX2                                                #
#                                                                        #
##########################################################################

%tio_01_00871_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "WRT_ADDR"                     => [   3,   6,   9, 0x0000000000007FC0, 0x00, 0, 0x0000000000000000, "Write Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [191:128]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00871_def =
( NAME    => "TIO_CA_MAINT_WRT_GFX2",
  ADDRESS => 0x0000000020010010,
  NOTE    => "This register contains the first physical address for 128 entries note in the ADMA Reponse Mapping Table Buffer[191:128]. Bits [",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00871_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_WRT_GFX3                                                #
#                                                                        #
##########################################################################

%tio_01_00872_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "WRT_ADDR"                     => [   3,   6,   9, 0x0000000000007FC0, 0x00, 0, 0x0000000000000000, "Write Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [255:192]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00872_def =
( NAME    => "TIO_CA_MAINT_WRT_GFX3",
  ADDRESS => 0x0000000020010018,
  NOTE    => "This register contains the first physical address for 128 entries note in the ADMA Reponse Mapping Table Buffer[255:192]. Bits [",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00872_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_RD_GFX0                                                 #
#                                                                        #
##########################################################################

%tio_01_00873_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "RD_ADDR"                      => [   3,   6,   9, 0x0000000000007FC0, 0x00, 0, 0x0000000000000000, "Read Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [63:0]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00873_def =
( NAME    => "TIO_CA_MAINT_RD_GFX0",
  ADDRESS => 0x0000000020010000,
  NOTE    => "This register contains the first physical address for 128 entries note in the ADMA Reponse Mapping Table Buffer[63:0]. Bits [14:",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00873_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_RD_GFX1                                                 #
#                                                                        #
##########################################################################

%tio_01_00874_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "RD_ADDR"                      => [   3,   6,   9, 0x0000000000007FC0, 0x00, 0, 0x0000000000000000, "Read Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [127:64]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00874_def =
( NAME    => "TIO_CA_MAINT_RD_GFX1",
  ADDRESS => 0x0000000020010008,
  NOTE    => "This register contains the first physical address for 128 entries note in the ADMA Reponse Mapping Table Buffer[127:64]. Bits [1",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00874_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_RD_GFX2                                                 #
#                                                                        #
##########################################################################

%tio_01_00875_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "WRT_ADDR"                     => [   3,   6,   9, 0x0000000000007FC0, 0x00, 0, 0x0000000000000000, "Write Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [191:128]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00875_def =
( NAME    => "TIO_CA_MAINT_RD_GFX2",
  ADDRESS => 0x0000000020010010,
  NOTE    => "This register contains the first physical address for 128 entries note in the ADMA Reponse Mapping Table Buffer[191:128]. Bits [",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00875_flds
);


##########################################################################
#                                                                        #
#   TIO_CA_MAINT_RD_GFX3                                                 #
#                                                                        #
##########################################################################

%tio_01_00876_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_DEST"                     => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "PIO Destination Decode" ],
   "MBZ"                          => [   2,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Must be zero" ],
   "RD_ADDR"                      => [   3,   6,   9, 0x0000000000007FC0, 0x00, 0, 0x0000000000000000, "Read Address" ],
   "SEL_RAM"                      => [   4,   3,   3, 0x0000000000000038, 0x00, 0, 0x0000000000000000, "Select bits [255:192]" ],
   "RSVD_ZERO"                    => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Reserved zero" ],
);

%tio_01_00876_def =
( NAME    => "TIO_CA_MAINT_RD_GFX3",
  ADDRESS => 0x0000000020010018,
  NOTE    => "This register contains the first physical address for 128 entries note in the ADMA Reponse Mapping Table Buffer[255:192]. Bits [",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00876_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_IDENTIFICATION                                               #
#                                                                        #
##########################################################################

%tio_01_00877_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REV_NUM"                      => [   1,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Revision number" ],
   "PART_NUM"                     => [   2,  12,  16, 0x000000000FFFF000, 0x00, 1, 0x0000000000000000, "Part Number" ],
   "MFG_NUM"                      => [   3,   1,  11, 0x0000000000000FFE, 0x00, 1, 0x0000000000000000, "Manufacturing Number" ],
   "READ_ONE"                     => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Read One" ],
);

%tio_01_00877_def =
( NAME    => "TIO_CP0_IDENTIFICATION",
  ADDRESS => 0x0000000000000000,
  NOTE    => "The Identification register is a read only register used by the note host CPU during configuration to determine the type of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00877_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_STATUS                                                       #
#                                                                        #
##########################################################################

%tio_01_00878_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TX_REQ_CREDIT_CNT"            => [   1,  40,   4, 0x00000F0000000000, 0x00, 1, 0x0000000000000000, "Transmit Request Credit Count" ],
   "TX_RSP_CREDIT_CNT"            => [   2,  36,   4, 0x000000F000000000, 0x00, 1, 0x0000000000000000, "Transmit Response Credit Count" ],
   "PCI_X_SPEED"                  => [   3,  34,   2, 0x0000000C00000000, 0x00, 0, 0x0000000000000000, "PCI-X Speed" ],
   "PCI_X_ACTIVE"                 => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PCI-X Active Mode" ],
   "RSVD1"                        => [   5,  16,  17, 0x00000001FFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RX_REQ_CREDIT_CNT"            => [   6,  12,   4, 0x000000000000F000, 0x00, 1, 0x0000000000000000, "Receive Credit Count" ],
);

%tio_01_00878_def =
( NAME    => "TIO_CP0_STATUS",
  ADDRESS => 0x0000000000000008,
  NOTE    => "The status register is a read-only register which holds status note information of the Bus Subsection.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00878_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_BUS_SIDE_ERROR_ADDR_UPPER                                     #
#                                                                        #
##########################################################################

%tio_01_00879_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Upper Address Bits" ],
);

%tio_01_00879_def =
( NAME    => "TIO_CP0_BUS_SIDE_ERROR_ADDR_UPPER",
  ADDRESS => 0x0000000000000010,
  NOTE    => "The upper address holding register is a read only register which note contains the upper 24 bits of the address when certain err",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00879_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_BUS_SIDE_ERROR_ADDR_LOWER                                     #
#                                                                        #
##########################################################################

%tio_01_00880_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [   1,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "Upper Address Bits" ],
   "LOW_ADDR"                     => [   2,   3,  29, 0x00000000FFFFFFF8, 0x00, 0, 0x0000000000000000, "Lower Address Bits" ],
);

%tio_01_00880_def =
( NAME    => "TIO_CP0_BUS_SIDE_ERROR_ADDR_LOWER",
  ADDRESS => 0x0000000000000018,
  NOTE    => "The lower address holding register is a read only register which note contains the address which either can be accessed as a wor",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00880_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_CONTROL                                                      #
#                                                                        #
##########################################################################

%tio_01_00881_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NS"                           => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "No Snoop" ],
   "RO"                           => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Relaxed Ordering" ],
   "RSVD1"                        => [   3,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUS_NUM"                      => [   4,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Bus Number" ],
   "DEV_NUM"                      => [   5,  43,   5, 0x0000F80000000000, 0x00, 1, 0x0000000000000000, "Device Number" ],
   "FUN_NUM"                      => [   6,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Function Number" ],
   "RSVD2"                        => [   7,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PARITY_EN_ATE"                => [   8,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "Enable Parity Checking in ATE RAM" ],
   "PARITY_EN_RESP"               => [   9,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "Enable Parity Checking in Response RAM" ],
   "PARITY_EN_REQ"                => [  10,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "Enable Parity Checking in Request RAM" ],
   "RSVD3"                        => [  11,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RST_PIN_N"                    => [  12,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "Software Programmable Reset Pins" ],
   "RSVD4"                        => [  13,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MEM_SWAP"                     => [  14,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Memory Enable Swapping" ],
   "PAGE_SIZE"                    => [  15,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Page Size" ],
   "RSVD5"                        => [  16,  14,   7, 0x00000000001FC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRED_LIMIT"                   => [  17,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Request Credit Limit" ],
   "RSVD6"                        => [  18,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SYS_END"                      => [  19,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "System Endianess" ],
   "RSVD7"                        => [  20,   6,   3, 0x00000000000001C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_X_SPEED"                  => [  21,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "Read-only PCI-X Speed" ],
   "RSVD8"                        => [  22,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CORELET_ID"                   => [  23,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Core-let ID" ],
);

%tio_01_00881_def =
( NAME    => "TIO_CP0_CONTROL",
  ADDRESS => 0x0000000000000020,
  NOTE    => "The control register is a read/write register which holds control note information for the bus subsection. Note that the PCI-X f",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00881_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_REQUEST_TIMEOUT                                              #
#                                                                        #
##########################################################################

%tio_01_00882_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIME_OUT"                     => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Time-out Value" ],
);

%tio_01_00882_def =
( NAME    => "TIO_CP0_REQUEST_TIMEOUT",
  ADDRESS => 0x0000000000000028,
  NOTE    => "This register contains the reload value for the request timer. The note request timer counts decrements once every 1280ns (256 c",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00882_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_INTERRUPT_DEST_UPPER                                         #
#                                                                        #
##########################################################################

%tio_01_00883_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Upper Address" ],
);

%tio_01_00883_def =
( NAME    => "TIO_CP0_INTERRUPT_DEST_UPPER",
  ADDRESS => 0x0000000000000030,
  NOTE    => "The interrupt destination upper address register is a read/write note register containing the upper 22 bits of address of the ho",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00883_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_INTERRUPT_DEST_LOWER                                         #
#                                                                        #
##########################################################################

%tio_01_00884_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [   1,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "Upper Address" ],
   "LOW_ADDR"                     => [   2,   3,  29, 0x00000000FFFFFFF8, 0x00, 0, 0x0000000000000000, "Lower Address" ],
);

%tio_01_00884_def =
( NAME    => "TIO_CP0_INTERRUPT_DEST_LOWER",
  ADDRESS => 0x0000000000000038,
  NOTE    => "The interrupt destination lower address register is a read/write note register which contains the entire address of the host to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00884_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_BUS_SIDE_ERROR_CMD_WRD                                       #
#                                                                        #
##########################################################################

%tio_01_00885_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "RSVD0"                        => [   1,  36,  27, 0x7FFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CW_ERR"                       => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Coretalk Command Word Error Bit" ],
   "PIO_OP"                       => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PIO operation not memory operation" ],
   "RD_PARM"                      => [   4,  32,   2, 0x0000000300000000, 0x00, 0, 0x0000000000000000, "Memory Read Parameters" ],
   "RSVD1"                        => [   5,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DW_DATA_EN"                   => [   6,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Coretalk Double Word Data Enable" ],
   "TNUM"                         => [   7,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Coretalk Transaction Number" ],
   "DATA_SIZE"                    => [   8,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Coretalk Data Size" ],
   "RSVD2"                        => [   9,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PACTYP"                       => [  10,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Coretalk Packet Type" ],
);

%tio_01_00885_def =
( NAME    => "TIO_CP0_BUS_SIDE_ERROR_CMD_WRD",
  ADDRESS => 0x0000000000000040,
  NOTE    => "The command word holding is a read only register that holds the note command word of a Coretalk packet when errors occur on the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00885_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_TARGET_FLUSH                                                 #
#                                                                        #
##########################################################################

%tio_01_00886_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
);

%tio_01_00886_def =
( NAME    => "TIO_CP0_TARGET_FLUSH",
  ADDRESS => 0x0000000000000050,
  NOTE    => "When read, this register will not return a response until after all note previous PIO transfers to the PCI bus have been forward",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00886_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_LINK_SIDE_ERROR_CMD_WRD                                      #
#                                                                        #
##########################################################################

%tio_01_00887_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "RSVD0"                        => [   1,  50,  13, 0x7FFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_ERR"                     => [   2,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Data Error" ],
   "HDR_ERR"                      => [   3,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "Header Error" ],
   "RSVD1"                        => [   4,  36,  12, 0x0000FFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CW_ERR"                       => [   5,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Coretalk Command Word Error Bit" ],
   "PIO_OP"                       => [   6,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PIO operation not memory operation" ],
   "RD_PARM"                      => [   7,  32,   2, 0x0000000300000000, 0x00, 0, 0x0000000000000000, "Memory Read Parameters" ],
   "RSVD2"                        => [   8,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DW_DATA_EN"                   => [   9,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Coretalk Double Word Data Enable" ],
   "TNUM"                         => [  10,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Coretalk Transaction Number" ],
   "DATA_SIZE"                    => [  11,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Coretalk Data Size" ],
   "RSVD3"                        => [  12,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PACTYP"                       => [  13,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Coretalk Packet Type" ],
);

%tio_01_00887_def =
( NAME    => "TIO_CP0_LINK_SIDE_ERROR_CMD_WRD",
  ADDRESS => 0x0000000000000058,
  NOTE    => "The command word holding is a read-only register that holds the note command word of a Coretalk packet when request fifo overflo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00887_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_RSP_BUFFER_UPPER                                             #
#                                                                        #
##########################################################################

%tio_01_00888_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEV_NUM"                      => [   1,  28,   2, 0x0000000030000000, 0x00, 0, 0x0000000000000000, "Device Number" ],
   "BUFF_NUM"                     => [   2,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Buffer Number" ],
   "RSVD1"                        => [   3,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [   4,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Upper Address" ],
);

%tio_01_00888_def =
( NAME    => "TIO_CP0_RSP_BUFFER_UPPER",
  ADDRESS => 0x0000000000000060,
  NOTE    => "The response buffer error upper address holding register is a read note only register which contains the upper 22-bits of the ad",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00888_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_RSP_BUFFER_LOWER                                             #
#                                                                        #
##########################################################################

%tio_01_00889_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEV_NUM"                      => [   1,  60,   2, 0x3000000000000000, 0x00, 0, 0x0000000000000000, "Device Number" ],
   "BUFF_NUM"                     => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Buffer Number" ],
   "RSVD1"                        => [   3,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [   4,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "Upper Address" ],
   "LOW_ADDR"                     => [   5,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower Address" ],
);

%tio_01_00889_def =
( NAME    => "TIO_CP0_RSP_BUFFER_LOWER",
  ADDRESS => 0x0000000000000068,
  NOTE    => "The response buffer error lower address holding register is a read note only register which contains the address of the error as",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00889_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_DEBUG_PORT_CONTROL                                           #
#                                                                        #
##########################################################################

%tio_01_00890_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_SEL"                     => [   1,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "NIB6_SEL"                     => [   2,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "NIB5_SEL"                     => [   3,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "NIB4_SEL"                     => [   4,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "NIB3_SEL"                     => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "NIB2_SEL"                     => [   6,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "NIB1_SEL"                     => [   7,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "NIB0_SEL"                     => [   8,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_00890_def =
( NAME    => "TIO_CP0_DEBUG_PORT_CONTROL",
  ADDRESS => 0x0000000000000070,
  NOTE    => "This register controls the final output mux of CP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00890_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_LINK_SIDE_ERROR_ADDR_HOLD                                     #
#                                                                        #
##########################################################################

%tio_01_00891_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [   1,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "Upper Address" ],
   "LOW_ADDR"                     => [   2,   3,  29, 0x00000000FFFFFFF8, 0x00, 0, 0x0000000000000000, "Lower Address" ],
);

%tio_01_00891_def =
( NAME    => "TIO_CP0_LINK_SIDE_ERROR_ADDR_HOLD",
  ADDRESS => 0x0000000000000078,
  NOTE    => "The address holding register is a read only register which contains note the address which either can be accessed as a word or d",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00891_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_DIRECT_MAPPING                                           #
#                                                                        #
##########################################################################

%tio_01_00892_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  26,  38, 0xFFFFFFFFFC000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_OFF_UP"                   => [   1,  20,   6, 0x0000000003F00000, 0x00, 1, 0x0000000000000000, "Upper Address Bits" ],
   "RSVD1"                        => [   2,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ADD512"                   => [   3,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Direct Map 512MB Offset" ],
   "DIR_OFF"                      => [   4,   0,  17, 0x000000000001FFFF, 0x00, 1, 0x0000000000000000, "Direct Map Offset" ],
);

%tio_01_00892_def =
( NAME    => "TIO_CP0_PCI_DIRECT_MAPPING",
  ADDRESS => 0x0000000000000080,
  NOTE    => "This register is used to relocate a 2 GByte region for PCI to note Coretalk transfers. The fields DIR_OFF and DIR_OFF_UP are not",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00892_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PAGE_MAP_FAULT_ADD                                           #
#                                                                        #
##########################################################################

%tio_01_00893_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_ADDR"                     => [   1,   4,  18, 0x00000000003FFFF0, 0x00, 0, 0x0000000000000000, "PCI Address" ],
   "RSVD1"                        => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_DEV_NUM"                  => [   3,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "PCI Device Number" ],
);

%tio_01_00893_def =
( NAME    => "TIO_CP0_PAGE_MAP_FAULT_ADD",
  ADDRESS => 0x0000000000000090,
  NOTE    => "This register contains the address and device number when a page note map fault occurred.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00893_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_ARBITRATION_PRIORITY                                         #
#                                                                        #
##########################################################################

%tio_01_00894_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUS_DISABLE"                  => [   1,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "Disable PCI(-X) Bus" ],
   "RSVD1"                        => [   2,  25,   3, 0x000000000E000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEV_BROKE_EN"                 => [   3,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Device Broken Enable" ],
   "DEV_BROKE"                    => [   4,  20,   4, 0x0000000000F00000, 0x00, 1, 0x0000000000000000, "Device Broken" ],
   "RSVD2"                        => [   5,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_WAIT_TICK"                => [   6,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Request Wait Time" ],
   "RSVD3"                        => [   7,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_WAIT_EN"                  => [   8,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Request Wait Enable" ],
   "RSVD4"                        => [   9,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FREEZE_GNT"                   => [  10,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Freeze Grant" ],
   "RSVD5"                        => [  11,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_BRIDGE_HI"                 => [  12,   3,   2, 0x0000000000000018, 0x00, 1, 0x0000000000000000, "Enable High" ],
   "RSVD6"                        => [  13,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_BRIDGE_LO"                 => [  14,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Enable Low" ],
);

%tio_01_00894_def =
( NAME    => "TIO_CP0_ARBITRATION_PRIORITY",
  ADDRESS => 0x00000000000000a0,
  NOTE    => "This register defines the priority and bus time out timing in PCI note bus arbitration.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00894_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_INTERNAL_RAM_PARITY_ERROR                                     #
#                                                                        #
##########################################################################

%tio_01_00895_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  58,   6, 0xFC00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR_ATE"                     => [   1,  48,  10, 0x03FF000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,  41,   7, 0x0000FE0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR_RESP"                    => [   3,  32,   9, 0x000001FF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADDR_REQ"                     => [   4,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD2"                        => [   5,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRT_ERR_ATE"                  => [   6,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "" ],
   "WRT_ERR_RESP"                 => [   7,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "" ],
   "WRT_ERR_REQ"                  => [   8,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD3"                        => [   9,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DBE_REQ"                      => [  10,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00895_def =
( NAME    => "TIO_CP0_INTERNAL_RAM_PARITY_ERROR",
  ADDRESS => 0x00000000000000b0,
  NOTE    => "This register logs information about parity errors on internal ram note access. For errors to be logged, the parity_en_ate and/o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00895_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_TIMEOUT                                                      #
#                                                                        #
##########################################################################

%tio_01_00896_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  21,  43, 0xFFFFFFFFFFE00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_RETRY_HLD"                => [   1,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_RETRY_CNT"                => [   3,   0,  10, 0x00000000000003FF, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00896_def =
( NAME    => "TIO_CP0_TIMEOUT",
  ADDRESS => 0x00000000000000c0,
  NOTE    => "This register determines retry hold off and max retries allowed for note PIO accesses to PCI/PCI-X.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00896_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_TYPE1_CONFIGURATION                                          #
#                                                                        #
##########################################################################

%tio_01_00897_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUS_NUM"                      => [   1,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_NUM"                      => [   2,  11,   5, 0x000000000000F800, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00897_def =
( NAME    => "TIO_CP0_TYPE1_CONFIGURATION",
  ADDRESS => 0x00000000000000c8,
  NOTE    => "This register is used during accesses to the PCI/PCI-X type 1 note configuration space. The bits in this register are used to no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00897_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_BUS_ERROR_ADDR_UPPER                                         #
#                                                                        #
##########################################################################

%tio_01_00898_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_CMD"                      => [   1,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_DAC"                      => [   2,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_DEV_MASTER"               => [   3,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_VDEV"                     => [   4,  24,   2, 0x0000000003000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_DEV_NUM"                  => [   5,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_UADDR_ERR"                => [   6,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00898_def =
( NAME    => "TIO_CP0_BUS_ERROR_ADDR_UPPER",
  ADDRESS => 0x00000000000000d0,
  NOTE    => "This register holds the value of the upper address on the PCI Bus note when an error occurs.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00898_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_BUS_ERROR_ADDR_LOWER                                         #
#                                                                        #
##########################################################################

%tio_01_00899_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PCI_CMD"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_DAC"                      => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_DEV_MASTER"               => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_VDEV"                     => [   3,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_DEV_NUM"                  => [   4,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_UADDR_ERR"                => [   5,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_LADDR_ERR"                => [   6,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00899_def =
( NAME    => "TIO_CP0_BUS_ERROR_ADDR_LOWER",
  ADDRESS => 0x00000000000000d8,
  NOTE    => "This register holds the value of the address on the PCI Bus when an note error occurs.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00899_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_INT_STATUS                                                   #
#                                                                        #
##########################################################################

%tio_01_00900_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CWRT_REQ_TOUT"                => [   1,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CTALK_PROT_ERROR"             => [   2,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_MES_PE"           => [   3,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_EMESS"            => [   4,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_TO"               => [   5,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_UNEX_COMP"              => [   6,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_RAM_PERR"                 => [   7,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_ARB_ERR"                => [   8,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_REQ_TOUT"               => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_TABORT"                 => [  10,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_PERR"                   => [  11,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SERR"                   => [  12,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_MRETRY"                 => [  13,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_MTOUT"                  => [  14,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_DA_PARITY"              => [  15,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_AD_PARITY"              => [  16,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [  17,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PMU_PAGE_FAULT"               => [  18,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNEXPECTED_RESP"              => [  19,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_CRESP_PACKET"             => [  20,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_CREQ_PACKET"              => [  21,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "RESP_CTALK_ERROR"             => [  22,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "REQ_CTALK_ERROR"              => [  23,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "INVALID_ACCESS"               => [  24,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNSUPPORTED_COP"              => [  25,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "" ],
   "CREQ_FIFO_OFLOW"              => [  26,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD2"                        => [  27,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_ABORT"                    => [  28,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_PARITY"                   => [  29,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_SERR"                     => [  30,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_PERR"                     => [  31,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_MASTER_TOUT"              => [  32,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_RETRY_CNT"                => [  33,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "CREAD_REQ_TOUT"               => [  34,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD3"                        => [  35,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_STATE"                    => [  36,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00900_def =
( NAME    => "TIO_CP0_INT_STATUS",
  ADDRESS => 0x0000000000000100,
  NOTE    => "This is the current interrupt status register which maintains the note current status of all the interrupting devices and error ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00900_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_INTERRUPT_ENABLE                                             #
#                                                                        #
##########################################################################

%tio_01_00901_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_CWRT_REQ_TOUT"             => [   1,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_CTALK_PROT_ERROR"          => [   2,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_SPLIT_MES_PE"        => [   3,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_SPLIT_EMESS"         => [   4,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_SPLIT_TO"            => [   5,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_UNEX_COMP"           => [   6,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_INT_RAM_PERR"              => [   7,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_ARB_ERR"             => [   8,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_REQ_TOUT"            => [   9,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_TABORT"              => [  10,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_PERR"                => [  11,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_SERR"                => [  12,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_MRETRY"              => [  13,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_MTOUT"               => [  14,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_DA_PARITY"           => [  15,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_AD_PARITY"           => [  16,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [  17,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_PMU_PAGE_FAULT"            => [  18,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_UNEXPECTED_RESP"           => [  19,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_BAD_CRESP_PACKET"          => [  20,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_BAD_CREQ_PACKET"           => [  21,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_RESP_CTALK_ERROR"          => [  22,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_REQ_CTALK_ERROR"           => [  23,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_INVALID_ACCESS"            => [  24,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_UNSUPPORTED_XOP"           => [  25,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_CREQ_FIFO_OFLOW"           => [  26,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [  27,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_PCI_ABORT"                 => [  28,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_PARITY"                => [  29,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_SERR"                  => [  30,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_PERR"                  => [  31,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_MASTER_TOUT"           => [  32,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_RETRY_CNT"             => [  33,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "" ],
   "EN_CREAD_REQ_TOUT"            => [  34,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD3"                        => [  35,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_INT_STATE"                 => [  36,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00901_def =
( NAME    => "TIO_CP0_INTERRUPT_ENABLE",
  ADDRESS => 0x0000000000000108,
  NOTE    => "This register enables the reporting of interrupt to the host. Each note bit in this register corresponds to the same bit in Inte",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00901_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_RESET_INTERRUPT                                              #
#                                                                        #
##########################################################################

%tio_01_00902_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOGV_CWRT_REQ_TOUT"           => [   1,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_CTALK_PROT_ERROR"        => [   2,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_SPLIT_MES_PE"      => [   3,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_SPLIT_EMESS"       => [   4,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_SPLIT_TO"          => [   5,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_UNEX_COMP"         => [   6,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_INT_RAM_PERR"            => [   7,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_ARB_ERR"           => [   8,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_REQ_TOUT"          => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_TABORT"            => [  10,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_PERR"              => [  11,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_SERR"              => [  12,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_MRETRY"            => [  13,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_MTOUT"             => [  14,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_DA_PARITY"         => [  15,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_AD_PARITY"         => [  16,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [  17,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOGV_PMU_PAGE_FAULT"          => [  18,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_UNEXPECTED_RESP"         => [  19,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_BAD_CRESP_PACKET"        => [  20,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_BAD_CREQ_PACKET"         => [  21,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_RESP_CTALK_ERROR"        => [  22,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_REQ_CTALK_ERROR"         => [  23,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_INVALID_ACCESS"          => [  24,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_UNSUPPORTED_XOP"         => [  25,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_CREQ_FIFO_OFLOW"         => [  26,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD2"                        => [  27,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOGV_PCI_ABORT"               => [  28,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_PARITY"              => [  29,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_SERR"                => [  30,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_PERR"                => [  31,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_MASTER_TOUT"         => [  32,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_RETRY_CNT"           => [  33,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_CREAD_REQ_TOUT"          => [  34,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD3"                        => [  35,   7,   2, 0x0000000000000180, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_CLR"                    => [  36,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "CRP_GRP_CLR"                  => [  37,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "RESP_BUF_GRP_CLR"             => [  38,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "REQ_DSP_GRP_CLR"              => [  39,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD4"                        => [  40,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PMU_PAGE_FAULT"               => [  41,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_GRP_CLR"                  => [  42,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00902_def =
( NAME    => "TIO_CP0_RESET_INTERRUPT",
  ADDRESS => 0x0000000000000110,
  NOTE    => "A write of a &quot;1&quot; clears the bit and rearms the error note registers. Writes also clear the error view register. Note t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00902_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_INTERRUPT_MODE                                               #
#                                                                        #
##########################################################################

%tio_01_00903_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_TRANS_TIME_SEL"           => [   1,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Interrupt Transition Time Select" ],
   "EN_CLR_PKT"                   => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00903_def =
( NAME    => "TIO_CP0_INTERRUPT_MODE",
  ADDRESS => 0x0000000000000118,
  NOTE    => "This register defines the interrupting mode of the INT_N pins.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00903_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_INTERRUPT_DEVICE                                             #
#                                                                        #
##########################################################################

%tio_01_00904_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT7_DEV"                     => [   1,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT6_DEV"                     => [   3,  18,   2, 0x00000000000C0000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [   4,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT5_DEV"                     => [   5,  15,   2, 0x0000000000018000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD3"                        => [   6,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT4_DEV"                     => [   7,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD4"                        => [   8,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT3_DEV"                     => [   9,   9,   2, 0x0000000000000600, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD5"                        => [  10,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT2_DEV"                     => [  11,   6,   2, 0x00000000000000C0, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD6"                        => [  12,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT1_DEV"                     => [  13,   3,   2, 0x0000000000000018, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD7"                        => [  14,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT0_DEV"                     => [  15,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00904_def =
( NAME    => "TIO_CP0_INTERRUPT_DEVICE",
  ADDRESS => 0x0000000000000120,
  NOTE    => "This register associates interrupt pins with devices thus allowing note buffer management (flushing) when a device interrupt occ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00904_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_HOST_ERROR_INTERRUPT                                         #
#                                                                        #
##########################################################################

%tio_01_00905_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BRIDGE_ERR_FLD"               => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00905_def =
( NAME    => "TIO_CP0_HOST_ERROR_INTERRUPT",
  ADDRESS => 0x0000000000000128,
  NOTE    => "This register contains the value to write into the host interrupt note register when an error interrupt is generated.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00905_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_INTERRUPT_0_HOST_ADDRESS                                     #
#                                                                        #
##########################################################################

%tio_01_00906_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_FLD"                      => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_ADDR"                     => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00906_def =
( NAME    => "TIO_CP0_INTERRUPT_0_HOST_ADDRESS",
  ADDRESS => 0x0000000000000130,
  NOTE    => "This register allows different host addresses to be assigned to note each interrupt pin and the bit in the host.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00906_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_INTERRUPT_1_HOST_ADDRESS                                     #
#                                                                        #
##########################################################################

%tio_01_00907_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_FLD"                      => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_ADDR"                     => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00907_def =
( NAME    => "TIO_CP0_INTERRUPT_1_HOST_ADDRESS",
  ADDRESS => 0x0000000000000138,
  NOTE    => "This register allows different host addresses to be assigned to note each interrupt pin and the bit in the host.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00907_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_INTERRUPT_2_HOST_ADDRESS                                     #
#                                                                        #
##########################################################################

%tio_01_00908_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_FLD"                      => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_ADDR"                     => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00908_def =
( NAME    => "TIO_CP0_INTERRUPT_2_HOST_ADDRESS",
  ADDRESS => 0x0000000000000140,
  NOTE    => "This register allows different host addresses to be assigned to note each interrupt pin and the bit in the host.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00908_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_INTERRUPT_3_HOST_ADDRESS                                     #
#                                                                        #
##########################################################################

%tio_01_00909_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_FLD"                      => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_ADDR"                     => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00909_def =
( NAME    => "TIO_CP0_INTERRUPT_3_HOST_ADDRESS",
  ADDRESS => 0x0000000000000148,
  NOTE    => "This register allows different host addresses to be assigned to note each interrupt pin and the bit in the host.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00909_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_INTERRUPT_4_HOST_ADDRESS                                     #
#                                                                        #
##########################################################################

%tio_01_00910_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_FLD"                      => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_ADDR"                     => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00910_def =
( NAME    => "TIO_CP0_INTERRUPT_4_HOST_ADDRESS",
  ADDRESS => 0x0000000000000150,
  NOTE    => "This register allows different host addresses to be assigned to note each interrupt pin and the bit in the host.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00910_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_INTERRUPT_5_HOST_ADDRESS                                     #
#                                                                        #
##########################################################################

%tio_01_00911_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_FLD"                      => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_ADDR"                     => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00911_def =
( NAME    => "TIO_CP0_INTERRUPT_5_HOST_ADDRESS",
  ADDRESS => 0x0000000000000158,
  NOTE    => "This register allows different host addresses to be assigned to note each interrupt pin and the bit in the host.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00911_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_INTERRUPT_6_HOST_ADDRESS                                     #
#                                                                        #
##########################################################################

%tio_01_00912_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_FLD"                      => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_ADDR"                     => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00912_def =
( NAME    => "TIO_CP0_INTERRUPT_6_HOST_ADDRESS",
  ADDRESS => 0x0000000000000160,
  NOTE    => "This register allows different host addresses to be assigned to note each interrupt pin and the bit in the host.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00912_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_INTERRUPT_7_HOST_ADDRESS                                     #
#                                                                        #
##########################################################################

%tio_01_00913_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_FLD"                      => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_ADDR"                     => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00913_def =
( NAME    => "TIO_CP0_INTERRUPT_7_HOST_ADDRESS",
  ADDRESS => 0x0000000000000168,
  NOTE    => "This register allows different host addresses to be assigned to note each interrupt pin and the bit in the host.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00913_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_ERROR_INTERRUPT_VIEW                                         #
#                                                                        #
##########################################################################

%tio_01_00914_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CWRT_REQ_TOUT"                => [   1,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CTALK_PROT_ERROR"             => [   2,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_MES_PE"           => [   3,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_EMESS"            => [   4,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_TO"               => [   5,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_UNEX_COMP"              => [   6,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_RAM_PERR"                 => [   7,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_ARB_ERR"                => [   8,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_REQ_TOUT"               => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_TABORT"                 => [  10,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_PERR"                   => [  11,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SERR"                   => [  12,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_MRETRY"                 => [  13,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_MTOUT"                  => [  14,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_DA_PARITY"              => [  15,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_AD_PARITY"              => [  16,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [  17,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PMU_PAGE_FAULT"               => [  18,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNEXPECTED_RESP"              => [  19,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_CRESP_PACKET"             => [  20,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_CREQ_PACKET"              => [  21,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "RESP_CTALK_ERROR"             => [  22,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "REQ_CTALK_ERROR"              => [  23,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "INVALID_ACCESS"               => [  24,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNSUPPORTED_XOP"              => [  25,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "" ],
   "CREQ_FIFO_OFLOW"              => [  26,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD2"                        => [  27,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_ABORT"                    => [  28,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_PARITY"                   => [  29,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_SERR"                     => [  30,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_PERR"                     => [  31,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_MASTER_TOUT"              => [  32,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_RETRY_CNT"                => [  33,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "CREAD_REQ_TOUT"               => [  34,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00914_def =
( NAME    => "TIO_CP0_ERROR_INTERRUPT_VIEW",
  ADDRESS => 0x0000000000000170,
  NOTE    => "This register contains the view of which interrupt occur even if note they are not currently enabled. This register is reset by ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00914_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_MULTIPLE_INTERRUPT                                           #
#                                                                        #
##########################################################################

%tio_01_00915_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_CTALK_WRITE_TIMEOUT"      => [   1,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CTALK_PROT_ERROR"             => [   2,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_MES_PE"           => [   3,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_EMESS"            => [   4,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_TO"               => [   5,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_UNEX_COMP"              => [   6,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_RAM_PERR"                 => [   7,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_ARB_ERR"                => [   8,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_REQ_TOUT"               => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_TABORT"                 => [  10,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_PERR"                   => [  11,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SERR"                   => [  12,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_MRETRY"                 => [  13,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_MTOUT"                  => [  14,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_DA_PARITY"              => [  15,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_AD_PARITY"              => [  16,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [  17,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PMU_PAGE_FAULT"               => [  18,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNEXPECTED_RESP"              => [  19,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_CRESP_PACKET"             => [  20,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_CREQ_PACKET"              => [  21,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "RESP_CTALK_ERROR"             => [  22,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "REQ_CTALK_ERROR"              => [  23,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "INVALID_ACCESS"               => [  24,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNSUPPORTED_XOP"              => [  25,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "" ],
   "CREQ_FIFO_OFLOW"              => [  26,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD2"                        => [  27,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_ABORT"                    => [  28,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_PARITY"                   => [  29,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_SERR"                     => [  30,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_PERR"                     => [  31,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_MASTER_TOUT"              => [  32,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_RETRY_CNT"                => [  33,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "CREAD_REQ_TOUT"               => [  34,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00915_def =
( NAME    => "TIO_CP0_MULTIPLE_INTERRUPT",
  ADDRESS => 0x0000000000000178,
  NOTE    => "This register indicates if any interrupt occurs more than once note without being cleared. This register is reset by the MULTI_C",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00915_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_FORCE_ALWAYS_INTERRUPT_0                                     #
#                                                                        #
##########################################################################

%tio_01_00916_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_ALWAYS"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Always" ],
);

%tio_01_00916_def =
( NAME    => "TIO_CP0_FORCE_ALWAYS_INTERRUPT_0",
  ADDRESS => 0x0000000000000180,
  NOTE    => "A write to this data independent write-only register will force a note set interrupt to occur as if the interrupt line had trans",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00916_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_FORCE_ALWAYS_INTERRUPT_1                                     #
#                                                                        #
##########################################################################

%tio_01_00917_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_ALWAYS"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Always" ],
);

%tio_01_00917_def =
( NAME    => "TIO_CP0_FORCE_ALWAYS_INTERRUPT_1",
  ADDRESS => 0x0000000000000188,
  NOTE    => "A write to this data independent write-only register will force a note set interrupt to occur as if the interrupt line had trans",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00917_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_FORCE_ALWAYS_INTERRUPT_2                                     #
#                                                                        #
##########################################################################

%tio_01_00918_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_ALWAYS"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Always" ],
);

%tio_01_00918_def =
( NAME    => "TIO_CP0_FORCE_ALWAYS_INTERRUPT_2",
  ADDRESS => 0x0000000000000190,
  NOTE    => "A write to this data independent write-only register will force a note set interrupt to occur as if the interrupt line had trans",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00918_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_FORCE_ALWAYS_INTERRUPT_3                                     #
#                                                                        #
##########################################################################

%tio_01_00919_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_ALWAYS"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Always" ],
);

%tio_01_00919_def =
( NAME    => "TIO_CP0_FORCE_ALWAYS_INTERRUPT_3",
  ADDRESS => 0x0000000000000198,
  NOTE    => "A write to this data independent write-only register will force a note set interrupt to occur as if the interrupt line had trans",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00919_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_FORCE_ALWAYS_INTERRUPT_4                                     #
#                                                                        #
##########################################################################

%tio_01_00920_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_ALWAYS"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Always" ],
);

%tio_01_00920_def =
( NAME    => "TIO_CP0_FORCE_ALWAYS_INTERRUPT_4",
  ADDRESS => 0x00000000000001a0,
  NOTE    => "A write to this data independent write-only register will force a note set interrupt to occur as if the interrupt line had trans",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00920_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_FORCE_ALWAYS_INTERRUPT_5                                     #
#                                                                        #
##########################################################################

%tio_01_00921_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_ALWAYS"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Always" ],
);

%tio_01_00921_def =
( NAME    => "TIO_CP0_FORCE_ALWAYS_INTERRUPT_5",
  ADDRESS => 0x00000000000001a8,
  NOTE    => "A write to this data independent write-only register will force a note set interrupt to occur as if the interrupt line had trans",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00921_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_FORCE_ALWAYS_INTERRUPT_6                                     #
#                                                                        #
##########################################################################

%tio_01_00922_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_ALWAYS"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Always" ],
);

%tio_01_00922_def =
( NAME    => "TIO_CP0_FORCE_ALWAYS_INTERRUPT_6",
  ADDRESS => 0x00000000000001b0,
  NOTE    => "A write to this data independent write-only register will force a note set interrupt to occur as if the interrupt line had trans",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00922_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_FORCE_ALWAYS_INTERRUPT_7                                     #
#                                                                        #
##########################################################################

%tio_01_00923_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_ALWAYS"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Always" ],
);

%tio_01_00923_def =
( NAME    => "TIO_CP0_FORCE_ALWAYS_INTERRUPT_7",
  ADDRESS => 0x00000000000001b8,
  NOTE    => "A write to this data independent write-only register will force a note set interrupt to occur as if the interrupt line had trans",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00923_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_FORCE_INTERRUPT_0                                            #
#                                                                        #
##########################################################################

%tio_01_00924_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTERRUPT"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Interrupt" ],
);

%tio_01_00924_def =
( NAME    => "TIO_CP0_FORCE_INTERRUPT_0",
  ADDRESS => 0x00000000000001c0,
  NOTE    => "A write to this data independent write-only register in conjunction note with the assertion of the corresponding interrupt line ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00924_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_FORCE_INTERRUPT_1                                            #
#                                                                        #
##########################################################################

%tio_01_00925_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTERRUPT"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Interrupt" ],
);

%tio_01_00925_def =
( NAME    => "TIO_CP0_FORCE_INTERRUPT_1",
  ADDRESS => 0x00000000000001c8,
  NOTE    => "A write to this data independent write-only register in conjunction note with the assertion of the corresponding interrupt line ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00925_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_FORCE_INTERRUPT_2                                            #
#                                                                        #
##########################################################################

%tio_01_00926_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTERRUPT"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Interrupt" ],
);

%tio_01_00926_def =
( NAME    => "TIO_CP0_FORCE_INTERRUPT_2",
  ADDRESS => 0x00000000000001d0,
  NOTE    => "A write to this data independent write-only register in conjunction note with the assertion of the corresponding interrupt line ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00926_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_FORCE_INTERRUPT_3                                            #
#                                                                        #
##########################################################################

%tio_01_00927_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTERRUPT"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Interrupt" ],
);

%tio_01_00927_def =
( NAME    => "TIO_CP0_FORCE_INTERRUPT_3",
  ADDRESS => 0x00000000000001d8,
  NOTE    => "A write to this data independent write-only register in conjunction note with the assertion of the corresponding interrupt line ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00927_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_FORCE_INTERRUPT_4                                            #
#                                                                        #
##########################################################################

%tio_01_00928_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTERRUPT"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Interrupt" ],
);

%tio_01_00928_def =
( NAME    => "TIO_CP0_FORCE_INTERRUPT_4",
  ADDRESS => 0x00000000000001e0,
  NOTE    => "A write to this data independent write-only register in conjunction note with the assertion of the corresponding interrupt line ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00928_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_FORCE_INTERRUPT_5                                            #
#                                                                        #
##########################################################################

%tio_01_00929_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTERRUPT"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Interrupt" ],
);

%tio_01_00929_def =
( NAME    => "TIO_CP0_FORCE_INTERRUPT_5",
  ADDRESS => 0x00000000000001e8,
  NOTE    => "A write to this data independent write-only register in conjunction note with the assertion of the corresponding interrupt line ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00929_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_FORCE_INTERRUPT_6                                            #
#                                                                        #
##########################################################################

%tio_01_00930_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTERRUPT"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Interrupt" ],
);

%tio_01_00930_def =
( NAME    => "TIO_CP0_FORCE_INTERRUPT_6",
  ADDRESS => 0x00000000000001f0,
  NOTE    => "A write to this data independent write-only register in conjunction note with the assertion of the corresponding interrupt line ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00930_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_FORCE_INTERRUPT_7                                            #
#                                                                        #
##########################################################################

%tio_01_00931_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTERRUPT"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Interrupt" ],
);

%tio_01_00931_def =
( NAME    => "TIO_CP0_FORCE_INTERRUPT_7",
  ADDRESS => 0x00000000000001f8,
  NOTE    => "A write to this data independent write-only register in conjunction note with the assertion of the corresponding interrupt line ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00931_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_DEVICE_0                                                     #
#                                                                        #
##########################################################################

%tio_01_00932_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_OP"                       => [   1,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_ERROR_LOCK"                => [   2,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PAGE_CHK"                  => [   3,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "FORCE_PCI_PAR"                => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_VIRTUAL"                   => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   6,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_WRT_GEN"                  => [   7,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_SIZE"                     => [   8,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "" ],
   "REAL_TIME"                    => [   9,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [  10,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SWAP_DIRECT"                  => [  11,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "" ],
   "PREFETCH"                     => [  12,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "" ],
   "PRECISE"                      => [  13,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD3"                        => [  14,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BARRIER"                      => [  15,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "" ],
   "CTALK_ARB"                    => [  16,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Coretalk High Priority Arbitration" ],
   "DEV_SWAP"                     => [  17,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_IO_MEM"                   => [  18,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_OFF"                      => [  19,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00932_def =
( NAME    => "TIO_CP0_DEVICE_0",
  ADDRESS => 0x0000000000000200,
  NOTE    => "The Device registers contain device specific and mapping note information.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00932_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_DEVICE_1                                                     #
#                                                                        #
##########################################################################

%tio_01_00933_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_OP"                       => [   1,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_ERROR_LOCK"                => [   2,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PAGE_CHK"                  => [   3,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "FORCE_PCI_PAR"                => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_VIRTUAL"                   => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   6,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_WRT_GEN"                  => [   7,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_SIZE"                     => [   8,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "" ],
   "REAL_TIME"                    => [   9,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [  10,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SWAP_DIRECT"                  => [  11,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "" ],
   "PREFETCH"                     => [  12,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "" ],
   "PRECISE"                      => [  13,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD3"                        => [  14,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BARRIER"                      => [  15,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "" ],
   "CTALK_ARB"                    => [  16,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Coretalk High Priority Arbitration" ],
   "DEV_SWAP"                     => [  17,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_IO_MEM"                   => [  18,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_OFF"                      => [  19,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00933_def =
( NAME    => "TIO_CP0_DEVICE_1",
  ADDRESS => 0x0000000000000208,
  NOTE    => "The Device registers contain device specific and mapping note information.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00933_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_DEVICE_2                                                     #
#                                                                        #
##########################################################################

%tio_01_00934_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_OP"                       => [   1,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_ERROR_LOCK"                => [   2,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PAGE_CHK"                  => [   3,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "FORCE_PCI_PAR"                => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_VIRTUAL"                   => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   6,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_WRT_GEN"                  => [   7,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_SIZE"                     => [   8,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "" ],
   "REAL_TIME"                    => [   9,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [  10,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SWAP_DIRECT"                  => [  11,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "" ],
   "PREFETCH"                     => [  12,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "" ],
   "PRECISE"                      => [  13,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD3"                        => [  14,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BARRIER"                      => [  15,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "" ],
   "CTALK_ARB"                    => [  16,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Coretalk High Priority Arbitration" ],
   "DEV_SWAP"                     => [  17,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_IO_MEM"                   => [  18,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_OFF"                      => [  19,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00934_def =
( NAME    => "TIO_CP0_DEVICE_2",
  ADDRESS => 0x0000000000000210,
  NOTE    => "The Device registers contain device specific and mapping note information.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00934_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_DEVICE_3                                                     #
#                                                                        #
##########################################################################

%tio_01_00935_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_OP"                       => [   1,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_ERROR_LOCK"                => [   2,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PAGE_CHK"                  => [   3,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "FORCE_PCI_PAR"                => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_VIRTUAL"                   => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   6,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_WRT_GEN"                  => [   7,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_SIZE"                     => [   8,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "" ],
   "REAL_TIME"                    => [   9,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [  10,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SWAP_DIRECT"                  => [  11,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "" ],
   "PREFETCH"                     => [  12,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "" ],
   "PRECISE"                      => [  13,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD3"                        => [  14,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BARRIER"                      => [  15,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "" ],
   "CTALK_ARB"                    => [  16,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Coretalk High Priority Arbitration" ],
   "DEV_SWAP"                     => [  17,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_IO_MEM"                   => [  18,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_OFF"                      => [  19,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00935_def =
( NAME    => "TIO_CP0_DEVICE_3",
  ADDRESS => 0x0000000000000218,
  NOTE    => "The Device registers contain device specific and mapping note information.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00935_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_DEVICE_0_WRITE_FLUSH                                         #
#                                                                        #
##########################################################################

%tio_01_00936_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VERIFY_FLUSH"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Verify Flush" ],
);

%tio_01_00936_def =
( NAME    => "TIO_CP0_DEVICE_0_WRITE_FLUSH",
  ADDRESS => 0x0000000000000240,
  NOTE    => "This register will return a 0x0 after the write buffers associated note with the device have been flushed and the data has enter",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00936_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_DEVICE_1_WRITE_FLUSH                                         #
#                                                                        #
##########################################################################

%tio_01_00937_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VERIFY_FLUSH"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Verify Flush" ],
);

%tio_01_00937_def =
( NAME    => "TIO_CP0_DEVICE_1_WRITE_FLUSH",
  ADDRESS => 0x0000000000000248,
  NOTE    => "This register will return a 0x0 after the write buffers associated note with the device have been flushed and the data has enter",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00937_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_DEVICE_2_WRITE_FLUSH                                         #
#                                                                        #
##########################################################################

%tio_01_00938_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VERIFY_FLUSH"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Verify Flush" ],
);

%tio_01_00938_def =
( NAME    => "TIO_CP0_DEVICE_2_WRITE_FLUSH",
  ADDRESS => 0x0000000000000250,
  NOTE    => "This register will return a 0x0 after the write buffers associated note with the device have been flushed and the data has enter",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00938_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_DEVICE_3_WRITE_FLUSH                                         #
#                                                                        #
##########################################################################

%tio_01_00939_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VERIFY_FLUSH"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Verify Flush" ],
);

%tio_01_00939_def =
( NAME    => "TIO_CP0_DEVICE_3_WRITE_FLUSH",
  ADDRESS => 0x0000000000000258,
  NOTE    => "This register will return a 0x0 after the write buffers associated note with the device have been flushed and the data has enter",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00939_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_EVEN_READ_RSP_BUFFER                                         #
#                                                                        #
##########################################################################

%tio_01_00940_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUFF_14_EN"                   => [   1,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_14_VDEV"                 => [   2,  29,   2, 0x0000000060000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_14_PDEV"                 => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_12_EN"                   => [   4,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_12_VDEV"                 => [   5,  25,   2, 0x0000000006000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_12_PDEV"                 => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_10_EN"                   => [   7,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_10_VDEV"                 => [   8,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_10_PDEV"                 => [   9,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_8_EN"                    => [  10,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_8_VDEV"                  => [  11,  17,   2, 0x0000000000060000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_8_PDEV"                  => [  12,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_6_EN"                    => [  13,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_6_VDEV"                  => [  14,  13,   2, 0x0000000000006000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_6_PDEV"                  => [  15,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_4_EN"                    => [  16,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_4_VDEV"                  => [  17,   9,   2, 0x0000000000000600, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_4_PDEV"                  => [  18,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_2_EN"                    => [  19,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_2_VDEV"                  => [  20,   5,   2, 0x0000000000000060, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_2_PDEV"                  => [  21,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_0_EN"                    => [  22,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_0_VDEV"                  => [  23,   1,   2, 0x0000000000000006, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_0_PDEV"                  => [  24,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00940_def =
( NAME    => "TIO_CP0_EVEN_READ_RSP_BUFFER",
  ADDRESS => 0x0000000000000280,
  NOTE    => "This register is use to allocate the read response buffers for the note even numbered devices. (0,2)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00940_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_ODD_READ_RSP_BUFFER                                          #
#                                                                        #
##########################################################################

%tio_01_00941_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUFF_15_EN"                   => [   1,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_15_VDEV"                 => [   2,  29,   2, 0x0000000060000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_15_PDEV"                 => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_13_EN"                   => [   4,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_13_VDEV"                 => [   5,  25,   2, 0x0000000006000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_13_PDEV"                 => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_11_EN"                   => [   7,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_11_VDEV"                 => [   8,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_11_PDEV"                 => [   9,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_9_EN"                    => [  10,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_9_VDEV"                  => [  11,  17,   2, 0x0000000000060000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_9_PDEV"                  => [  12,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_7_EN"                    => [  13,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_7_VDEV"                  => [  14,  13,   2, 0x0000000000006000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_7_PDEV"                  => [  15,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_5_EN"                    => [  16,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_5_VDEV"                  => [  17,   9,   2, 0x0000000000000600, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_5_PDEV"                  => [  18,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_3_EN"                    => [  19,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_3_VDEV"                  => [  20,   5,   2, 0x0000000000000060, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_3_PDEV"                  => [  21,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_1_EN"                    => [  22,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_1_VDEV"                  => [  23,   1,   2, 0x0000000000000006, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_1_PDEV"                  => [  24,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00941_def =
( NAME    => "TIO_CP0_ODD_READ_RSP_BUFFER",
  ADDRESS => 0x0000000000000288,
  NOTE    => "This register is use to allocate the read response buffers for the note odd numbered devices. (1,3))",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00941_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_READ_RSP_BUFFER_STATUS                                       #
#                                                                        #
##########################################################################

%tio_01_00942_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRB_VALID"                    => [   1,  16,  16, 0x00000000FFFF0000, 0x00, 1, 0x0000000000000000, "" ],
   "RRB_INUSE"                    => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_00942_def =
( NAME    => "TIO_CP0_READ_RSP_BUFFER_STATUS",
  ADDRESS => 0x0000000000000290,
  NOTE    => "This read only register contains the current response buffer note status.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00942_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_READ_RSP_BUFFER_CLEAR                                        #
#                                                                        #
##########################################################################

%tio_01_00943_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRB_CLEAR"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00943_def =
( NAME    => "TIO_CP0_READ_RSP_BUFFER_CLEAR",
  ADDRESS => 0x0000000000000298,
  NOTE    => "A write to this register clears the current contents of the buffer. note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00943_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_0                                     #
#                                                                        #
##########################################################################

%tio_01_00944_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00944_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_0",
  ADDRESS => 0x0000000000000300,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00944_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_1                                     #
#                                                                        #
##########################################################################

%tio_01_00945_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00945_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_1",
  ADDRESS => 0x0000000000000310,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00945_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_2                                     #
#                                                                        #
##########################################################################

%tio_01_00946_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00946_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_2",
  ADDRESS => 0x0000000000000320,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00946_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_3                                     #
#                                                                        #
##########################################################################

%tio_01_00947_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00947_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_3",
  ADDRESS => 0x0000000000000330,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00947_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_4                                     #
#                                                                        #
##########################################################################

%tio_01_00948_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00948_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_4",
  ADDRESS => 0x0000000000000340,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00948_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_5                                     #
#                                                                        #
##########################################################################

%tio_01_00949_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00949_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_5",
  ADDRESS => 0x0000000000000350,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00949_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_6                                     #
#                                                                        #
##########################################################################

%tio_01_00950_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00950_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_6",
  ADDRESS => 0x0000000000000360,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00950_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_7                                     #
#                                                                        #
##########################################################################

%tio_01_00951_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00951_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_7",
  ADDRESS => 0x0000000000000370,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00951_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_8                                     #
#                                                                        #
##########################################################################

%tio_01_00952_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00952_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_8",
  ADDRESS => 0x0000000000000380,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00952_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_9                                     #
#                                                                        #
##########################################################################

%tio_01_00953_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00953_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_9",
  ADDRESS => 0x0000000000000390,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00953_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_10                                     #
#                                                                        #
##########################################################################

%tio_01_00954_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00954_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_10",
  ADDRESS => 0x00000000000003a0,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00954_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_11                                     #
#                                                                        #
##########################################################################

%tio_01_00955_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00955_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_11",
  ADDRESS => 0x00000000000003b0,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00955_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_12                                     #
#                                                                        #
##########################################################################

%tio_01_00956_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00956_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_12",
  ADDRESS => 0x00000000000003c0,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00956_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_13                                     #
#                                                                        #
##########################################################################

%tio_01_00957_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00957_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_13",
  ADDRESS => 0x00000000000003d0,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00957_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_14                                     #
#                                                                        #
##########################################################################

%tio_01_00958_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00958_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_14",
  ADDRESS => 0x00000000000003e0,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00958_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_15                                     #
#                                                                        #
##########################################################################

%tio_01_00959_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00959_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_15",
  ADDRESS => 0x00000000000003f0,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00959_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_0                                     #
#                                                                        #
##########################################################################

%tio_01_00960_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00960_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_0",
  ADDRESS => 0x0000000000000308,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00960_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_1                                     #
#                                                                        #
##########################################################################

%tio_01_00961_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00961_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_1",
  ADDRESS => 0x0000000000000318,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00961_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_2                                     #
#                                                                        #
##########################################################################

%tio_01_00962_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00962_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_2",
  ADDRESS => 0x0000000000000328,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00962_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_3                                     #
#                                                                        #
##########################################################################

%tio_01_00963_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00963_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_3",
  ADDRESS => 0x0000000000000338,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00963_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_4                                     #
#                                                                        #
##########################################################################

%tio_01_00964_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00964_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_4",
  ADDRESS => 0x0000000000000348,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00964_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_5                                     #
#                                                                        #
##########################################################################

%tio_01_00965_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00965_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_5",
  ADDRESS => 0x0000000000000358,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00965_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_6                                     #
#                                                                        #
##########################################################################

%tio_01_00966_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00966_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_6",
  ADDRESS => 0x0000000000000368,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00966_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_7                                     #
#                                                                        #
##########################################################################

%tio_01_00967_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00967_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_7",
  ADDRESS => 0x0000000000000378,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00967_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_8                                     #
#                                                                        #
##########################################################################

%tio_01_00968_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00968_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_8",
  ADDRESS => 0x0000000000000388,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00968_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_9                                     #
#                                                                        #
##########################################################################

%tio_01_00969_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00969_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_9",
  ADDRESS => 0x0000000000000398,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00969_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_10                                     #
#                                                                        #
##########################################################################

%tio_01_00970_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00970_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_10",
  ADDRESS => 0x00000000000003a8,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00970_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_11                                     #
#                                                                        #
##########################################################################

%tio_01_00971_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00971_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_11",
  ADDRESS => 0x00000000000003b8,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00971_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_12                                     #
#                                                                        #
##########################################################################

%tio_01_00972_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00972_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_12",
  ADDRESS => 0x00000000000003c8,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00972_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_13                                     #
#                                                                        #
##########################################################################

%tio_01_00973_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00973_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_13",
  ADDRESS => 0x00000000000003d8,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00973_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_14                                     #
#                                                                        #
##########################################################################

%tio_01_00974_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00974_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_14",
  ADDRESS => 0x00000000000003e8,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00974_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_15                                     #
#                                                                        #
##########################################################################

%tio_01_00975_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00975_def =
( NAME    => "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_15",
  ADDRESS => 0x00000000000003f8,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00975_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_0_FLUSH_COUNT_TOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_00976_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOUCH_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00976_def =
( NAME    => "TIO_CP0_PCI_BUFFER_0_FLUSH_COUNT_TOUCH",
  ADDRESS => 0x0000000000000400,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed after at least a single data element in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00976_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_1_FLUSH_COUNT_TOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_00977_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOUCH_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00977_def =
( NAME    => "TIO_CP0_PCI_BUFFER_1_FLUSH_COUNT_TOUCH",
  ADDRESS => 0x0000000000000440,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed after at least a single data element in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00977_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_2_FLUSH_COUNT_TOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_00978_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOUCH_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00978_def =
( NAME    => "TIO_CP0_PCI_BUFFER_2_FLUSH_COUNT_TOUCH",
  ADDRESS => 0x0000000000000480,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed after at least a single data element in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00978_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_3_FLUSH_COUNT_TOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_00979_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOUCH_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00979_def =
( NAME    => "TIO_CP0_PCI_BUFFER_3_FLUSH_COUNT_TOUCH",
  ADDRESS => 0x00000000000004c0,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed after at least a single data element in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00979_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_4_FLUSH_COUNT_TOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_00980_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOUCH_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00980_def =
( NAME    => "TIO_CP0_PCI_BUFFER_4_FLUSH_COUNT_TOUCH",
  ADDRESS => 0x0000000000000500,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed after at least a single data element in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00980_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_5_FLUSH_COUNT_TOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_00981_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOUCH_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00981_def =
( NAME    => "TIO_CP0_PCI_BUFFER_5_FLUSH_COUNT_TOUCH",
  ADDRESS => 0x0000000000000540,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed after at least a single data element in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00981_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_6_FLUSH_COUNT_TOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_00982_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOUCH_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00982_def =
( NAME    => "TIO_CP0_PCI_BUFFER_6_FLUSH_COUNT_TOUCH",
  ADDRESS => 0x0000000000000580,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed after at least a single data element in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00982_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_7_FLUSH_COUNT_TOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_00983_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOUCH_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00983_def =
( NAME    => "TIO_CP0_PCI_BUFFER_7_FLUSH_COUNT_TOUCH",
  ADDRESS => 0x00000000000005c0,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed after at least a single data element in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00983_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_0_FLUSH_COUNT_NOTOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_00984_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTOUCH_CNT"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00984_def =
( NAME    => "TIO_CP0_PCI_BUFFER_0_FLUSH_COUNT_NOTOUCH",
  ADDRESS => 0x0000000000000408,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed without any data element in the buffer b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00984_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_1_FLUSH_COUNT_NOTOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_00985_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTOUCH_CNT"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00985_def =
( NAME    => "TIO_CP0_PCI_BUFFER_1_FLUSH_COUNT_NOTOUCH",
  ADDRESS => 0x0000000000000448,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed without any data element in the buffer b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00985_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_2_FLUSH_COUNT_NOTOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_00986_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTOUCH_CNT"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00986_def =
( NAME    => "TIO_CP0_PCI_BUFFER_2_FLUSH_COUNT_NOTOUCH",
  ADDRESS => 0x0000000000000488,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed without any data element in the buffer b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00986_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_3_FLUSH_COUNT_NOTOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_00987_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTOUCH_CNT"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00987_def =
( NAME    => "TIO_CP0_PCI_BUFFER_3_FLUSH_COUNT_NOTOUCH",
  ADDRESS => 0x00000000000004c8,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed without any data element in the buffer b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00987_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_4_FLUSH_COUNT_NOTOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_00988_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTOUCH_CNT"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00988_def =
( NAME    => "TIO_CP0_PCI_BUFFER_4_FLUSH_COUNT_NOTOUCH",
  ADDRESS => 0x0000000000000508,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed without any data element in the buffer b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00988_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_5_FLUSH_COUNT_NOTOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_00989_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTOUCH_CNT"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00989_def =
( NAME    => "TIO_CP0_PCI_BUFFER_5_FLUSH_COUNT_NOTOUCH",
  ADDRESS => 0x0000000000000548,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed without any data element in the buffer b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00989_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_6_FLUSH_COUNT_NOTOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_00990_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTOUCH_CNT"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00990_def =
( NAME    => "TIO_CP0_PCI_BUFFER_6_FLUSH_COUNT_NOTOUCH",
  ADDRESS => 0x0000000000000588,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed without any data element in the buffer b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00990_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_7_FLUSH_COUNT_NOTOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_00991_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTOUCH_CNT"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00991_def =
( NAME    => "TIO_CP0_PCI_BUFFER_7_FLUSH_COUNT_NOTOUCH",
  ADDRESS => 0x00000000000005c8,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed without any data element in the buffer b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00991_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_0_REQ_COUNT                                       #
#                                                                        #
##########################################################################

%tio_01_00992_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INFLIGHT_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00992_def =
( NAME    => "TIO_CP0_PCI_BUFFER_0_REQ_COUNT",
  ADDRESS => 0x0000000000000410,
  NOTE    => "This counter is incremented on each bus clock while the request is note in-flight. A word write to this address clears the count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00992_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_1_REQ_COUNT                                       #
#                                                                        #
##########################################################################

%tio_01_00993_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INFLIGHT_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00993_def =
( NAME    => "TIO_CP0_PCI_BUFFER_1_REQ_COUNT",
  ADDRESS => 0x0000000000000450,
  NOTE    => "This counter is incremented on each bus clock while the request is note in-flight. A word write to this address clears the count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00993_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_2_REQ_COUNT                                       #
#                                                                        #
##########################################################################

%tio_01_00994_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INFLIGHT_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00994_def =
( NAME    => "TIO_CP0_PCI_BUFFER_2_REQ_COUNT",
  ADDRESS => 0x0000000000000490,
  NOTE    => "This counter is incremented on each bus clock while the request is note in-flight. A word write to this address clears the count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00994_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_3_REQ_COUNT                                       #
#                                                                        #
##########################################################################

%tio_01_00995_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INFLIGHT_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00995_def =
( NAME    => "TIO_CP0_PCI_BUFFER_3_REQ_COUNT",
  ADDRESS => 0x00000000000004d0,
  NOTE    => "This counter is incremented on each bus clock while the request is note in-flight. A word write to this address clears the count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00995_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_4_REQ_COUNT                                       #
#                                                                        #
##########################################################################

%tio_01_00996_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INFLIGHT_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00996_def =
( NAME    => "TIO_CP0_PCI_BUFFER_4_REQ_COUNT",
  ADDRESS => 0x0000000000000510,
  NOTE    => "This counter is incremented on each bus clock while the request is note in-flight. A word write to this address clears the count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00996_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_5_REQ_COUNT                                       #
#                                                                        #
##########################################################################

%tio_01_00997_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INFLIGHT_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00997_def =
( NAME    => "TIO_CP0_PCI_BUFFER_5_REQ_COUNT",
  ADDRESS => 0x0000000000000550,
  NOTE    => "This counter is incremented on each bus clock while the request is note in-flight. A word write to this address clears the count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00997_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_6_REQ_COUNT                                       #
#                                                                        #
##########################################################################

%tio_01_00998_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INFLIGHT_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00998_def =
( NAME    => "TIO_CP0_PCI_BUFFER_6_REQ_COUNT",
  ADDRESS => 0x0000000000000590,
  NOTE    => "This counter is incremented on each bus clock while the request is note in-flight. A word write to this address clears the count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00998_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_7_REQ_COUNT                                       #
#                                                                        #
##########################################################################

%tio_01_00999_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INFLIGHT_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_00999_def =
( NAME    => "TIO_CP0_PCI_BUFFER_7_REQ_COUNT",
  ADDRESS => 0x00000000000005d0,
  NOTE    => "This counter is incremented on each bus clock while the request is note in-flight. A word write to this address clears the count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_00999_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_0_PREFETCH_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01000_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PREFETCH_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01000_def =
( NAME    => "TIO_CP0_PCI_BUFFER_0_PREFETCH_COUNT",
  ADDRESS => 0x0000000000000418,
  NOTE    => "This counter is incremented each time the request using this buffer note was generated from the prefetcher. A word write to this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01000_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_1_PREFETCH_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01001_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PREFETCH_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01001_def =
( NAME    => "TIO_CP0_PCI_BUFFER_1_PREFETCH_COUNT",
  ADDRESS => 0x0000000000000458,
  NOTE    => "This counter is incremented each time the request using this buffer note was generated from the prefetcher. A word write to this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01001_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_2_PREFETCH_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01002_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PREFETCH_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01002_def =
( NAME    => "TIO_CP0_PCI_BUFFER_2_PREFETCH_COUNT",
  ADDRESS => 0x0000000000000498,
  NOTE    => "This counter is incremented each time the request using this buffer note was generated from the prefetcher. A word write to this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01002_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_3_PREFETCH_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01003_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PREFETCH_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01003_def =
( NAME    => "TIO_CP0_PCI_BUFFER_3_PREFETCH_COUNT",
  ADDRESS => 0x00000000000004d8,
  NOTE    => "This counter is incremented each time the request using this buffer note was generated from the prefetcher. A word write to this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01003_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_4_PREFETCH_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01004_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PREFETCH_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01004_def =
( NAME    => "TIO_CP0_PCI_BUFFER_4_PREFETCH_COUNT",
  ADDRESS => 0x0000000000000518,
  NOTE    => "This counter is incremented each time the request using this buffer note was generated from the prefetcher. A word write to this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01004_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_5_PREFETCH_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01005_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PREFETCH_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01005_def =
( NAME    => "TIO_CP0_PCI_BUFFER_5_PREFETCH_COUNT",
  ADDRESS => 0x0000000000000558,
  NOTE    => "This counter is incremented each time the request using this buffer note was generated from the prefetcher. A word write to this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01005_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_6_PREFETCH_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01006_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PREFETCH_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01006_def =
( NAME    => "TIO_CP0_PCI_BUFFER_6_PREFETCH_COUNT",
  ADDRESS => 0x0000000000000598,
  NOTE    => "This counter is incremented each time the request using this buffer note was generated from the prefetcher. A word write to this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01006_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_7_PREFETCH_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01007_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PREFETCH_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01007_def =
( NAME    => "TIO_CP0_PCI_BUFFER_7_PREFETCH_COUNT",
  ADDRESS => 0x00000000000005d8,
  NOTE    => "This counter is incremented each time the request using this buffer note was generated from the prefetcher. A word write to this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01007_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_0_RETRY_TOTAL_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01008_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01008_def =
( NAME    => "TIO_CP0_PCI_BUFFER_0_RETRY_TOTAL_COUNT",
  ADDRESS => 0x0000000000000420,
  NOTE    => "This counter is incremented each time a PCI bus retry occurs and note the address matches the tag for the selected buffer. The b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01008_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_1_RETRY_TOTAL_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01009_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01009_def =
( NAME    => "TIO_CP0_PCI_BUFFER_1_RETRY_TOTAL_COUNT",
  ADDRESS => 0x0000000000000460,
  NOTE    => "This counter is incremented each time a PCI bus retry occurs and note the address matches the tag for the selected buffer. The b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01009_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_2_RETRY_TOTAL_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01010_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01010_def =
( NAME    => "TIO_CP0_PCI_BUFFER_2_RETRY_TOTAL_COUNT",
  ADDRESS => 0x00000000000004a0,
  NOTE    => "This counter is incremented each time a PCI bus retry occurs and note the address matches the tag for the selected buffer. The b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01010_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_3_RETRY_TOTAL_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01011_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01011_def =
( NAME    => "TIO_CP0_PCI_BUFFER_3_RETRY_TOTAL_COUNT",
  ADDRESS => 0x00000000000004e0,
  NOTE    => "This counter is incremented each time a PCI bus retry occurs and note the address matches the tag for the selected buffer. The b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01011_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_4_RETRY_TOTAL_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01012_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01012_def =
( NAME    => "TIO_CP0_PCI_BUFFER_4_RETRY_TOTAL_COUNT",
  ADDRESS => 0x0000000000000520,
  NOTE    => "This counter is incremented each time a PCI bus retry occurs and note the address matches the tag for the selected buffer. The b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01012_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_5_RETRY_TOTAL_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01013_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01013_def =
( NAME    => "TIO_CP0_PCI_BUFFER_5_RETRY_TOTAL_COUNT",
  ADDRESS => 0x0000000000000560,
  NOTE    => "This counter is incremented each time a PCI bus retry occurs and note the address matches the tag for the selected buffer. The b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01013_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_6_RETRY_TOTAL_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01014_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01014_def =
( NAME    => "TIO_CP0_PCI_BUFFER_6_RETRY_TOTAL_COUNT",
  ADDRESS => 0x00000000000005a0,
  NOTE    => "This counter is incremented each time a PCI bus retry occurs and note the address matches the tag for the selected buffer. The b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01014_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_7_RETRY_TOTAL_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01015_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01015_def =
( NAME    => "TIO_CP0_PCI_BUFFER_7_RETRY_TOTAL_COUNT",
  ADDRESS => 0x00000000000005e0,
  NOTE    => "This counter is incremented each time a PCI bus retry occurs and note the address matches the tag for the selected buffer. The b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01015_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_0_RETRY_MAX_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01016_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_RETRY_CNT"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01016_def =
( NAME    => "TIO_CP0_PCI_BUFFER_0_RETRY_MAX_COUNT",
  ADDRESS => 0x0000000000000428,
  NOTE    => "This counter is contains the maximum retry count for a single note request which was in-flight for this buffer. A word write to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01016_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_1_RETRY_MAX_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01017_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_RETRY_CNT"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01017_def =
( NAME    => "TIO_CP0_PCI_BUFFER_1_RETRY_MAX_COUNT",
  ADDRESS => 0x0000000000000468,
  NOTE    => "This counter is contains the maximum retry count for a single note request which was in-flight for this buffer. A word write to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01017_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_2_RETRY_MAX_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01018_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_RETRY_CNT"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01018_def =
( NAME    => "TIO_CP0_PCI_BUFFER_2_RETRY_MAX_COUNT",
  ADDRESS => 0x00000000000004a8,
  NOTE    => "This counter is contains the maximum retry count for a single note request which was in-flight for this buffer. A word write to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01018_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_3_RETRY_MAX_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01019_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_RETRY_CNT"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01019_def =
( NAME    => "TIO_CP0_PCI_BUFFER_3_RETRY_MAX_COUNT",
  ADDRESS => 0x00000000000004e8,
  NOTE    => "This counter is contains the maximum retry count for a single note request which was in-flight for this buffer. A word write to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01019_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_4_RETRY_MAX_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01020_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_RETRY_CNT"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01020_def =
( NAME    => "TIO_CP0_PCI_BUFFER_4_RETRY_MAX_COUNT",
  ADDRESS => 0x0000000000000528,
  NOTE    => "This counter is contains the maximum retry count for a single note request which was in-flight for this buffer. A word write to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01020_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_5_RETRY_MAX_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01021_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_RETRY_CNT"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01021_def =
( NAME    => "TIO_CP0_PCI_BUFFER_5_RETRY_MAX_COUNT",
  ADDRESS => 0x0000000000000568,
  NOTE    => "This counter is contains the maximum retry count for a single note request which was in-flight for this buffer. A word write to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01021_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_6_RETRY_MAX_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01022_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_RETRY_CNT"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01022_def =
( NAME    => "TIO_CP0_PCI_BUFFER_6_RETRY_MAX_COUNT",
  ADDRESS => 0x00000000000005a8,
  NOTE    => "This counter is contains the maximum retry count for a single note request which was in-flight for this buffer. A word write to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01022_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_7_RETRY_MAX_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01023_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_RETRY_CNT"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01023_def =
( NAME    => "TIO_CP0_PCI_BUFFER_7_RETRY_MAX_COUNT",
  ADDRESS => 0x00000000000005e8,
  NOTE    => "This counter is contains the maximum retry count for a single note request which was in-flight for this buffer. A word write to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01023_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_0_MAX_LATENCY                                     #
#                                                                        #
##########################################################################

%tio_01_01024_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_LATENCY_CNT"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01024_def =
( NAME    => "TIO_CP0_PCI_BUFFER_0_MAX_LATENCY",
  ADDRESS => 0x0000000000000430,
  NOTE    => "This counter is contains the maximum count (in bus clocks) for a note single request which was in-flight for this buffer. A word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01024_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_1_MAX_LATENCY                                     #
#                                                                        #
##########################################################################

%tio_01_01025_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_LATENCY_CNT"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01025_def =
( NAME    => "TIO_CP0_PCI_BUFFER_1_MAX_LATENCY",
  ADDRESS => 0x0000000000000470,
  NOTE    => "This counter is contains the maximum count (in bus clocks) for a note single request which was in-flight for this buffer. A word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01025_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_2_MAX_LATENCY                                     #
#                                                                        #
##########################################################################

%tio_01_01026_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_LATENCY_CNT"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01026_def =
( NAME    => "TIO_CP0_PCI_BUFFER_2_MAX_LATENCY",
  ADDRESS => 0x00000000000004b0,
  NOTE    => "This counter is contains the maximum count (in bus clocks) for a note single request which was in-flight for this buffer. A word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01026_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_3_MAX_LATENCY                                     #
#                                                                        #
##########################################################################

%tio_01_01027_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_LATENCY_CNT"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01027_def =
( NAME    => "TIO_CP0_PCI_BUFFER_3_MAX_LATENCY",
  ADDRESS => 0x00000000000004f0,
  NOTE    => "This counter is contains the maximum count (in bus clocks) for a note single request which was in-flight for this buffer. A word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01027_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_4_MAX_LATENCY                                     #
#                                                                        #
##########################################################################

%tio_01_01028_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_LATENCY_CNT"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01028_def =
( NAME    => "TIO_CP0_PCI_BUFFER_4_MAX_LATENCY",
  ADDRESS => 0x0000000000000530,
  NOTE    => "This counter is contains the maximum count (in bus clocks) for a note single request which was in-flight for this buffer. A word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01028_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_5_MAX_LATENCY                                     #
#                                                                        #
##########################################################################

%tio_01_01029_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_LATENCY_CNT"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01029_def =
( NAME    => "TIO_CP0_PCI_BUFFER_5_MAX_LATENCY",
  ADDRESS => 0x0000000000000570,
  NOTE    => "This counter is contains the maximum count (in bus clocks) for a note single request which was in-flight for this buffer. A word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01029_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_6_MAX_LATENCY                                     #
#                                                                        #
##########################################################################

%tio_01_01030_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_LATENCY_CNT"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01030_def =
( NAME    => "TIO_CP0_PCI_BUFFER_6_MAX_LATENCY",
  ADDRESS => 0x00000000000005b0,
  NOTE    => "This counter is contains the maximum count (in bus clocks) for a note single request which was in-flight for this buffer. A word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01030_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_7_MAX_LATENCY                                     #
#                                                                        #
##########################################################################

%tio_01_01031_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_LATENCY_CNT"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01031_def =
( NAME    => "TIO_CP0_PCI_BUFFER_7_MAX_LATENCY",
  ADDRESS => 0x00000000000005f0,
  NOTE    => "This counter is contains the maximum count (in bus clocks) for a note single request which was in-flight for this buffer. A word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01031_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_0_CLEAR                                           #
#                                                                        #
##########################################################################

%tio_01_01032_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Clear Buffer Registers" ],
);

%tio_01_01032_def =
( NAME    => "TIO_CP0_PCI_BUFFER_0_CLEAR",
  ADDRESS => 0x0000000000000438,
  NOTE    => "Any access to this register clears all the count values for the (x) note registers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01032_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_1_CLEAR                                           #
#                                                                        #
##########################################################################

%tio_01_01033_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Clear Buffer Registers" ],
);

%tio_01_01033_def =
( NAME    => "TIO_CP0_PCI_BUFFER_1_CLEAR",
  ADDRESS => 0x0000000000000478,
  NOTE    => "Any access to this register clears all the count values for the (x) note registers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01033_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_2_CLEAR                                           #
#                                                                        #
##########################################################################

%tio_01_01034_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Clear Buffer Registers" ],
);

%tio_01_01034_def =
( NAME    => "TIO_CP0_PCI_BUFFER_2_CLEAR",
  ADDRESS => 0x00000000000004b8,
  NOTE    => "Any access to this register clears all the count values for the (x) note registers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01034_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_3_CLEAR                                           #
#                                                                        #
##########################################################################

%tio_01_01035_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Clear Buffer Registers" ],
);

%tio_01_01035_def =
( NAME    => "TIO_CP0_PCI_BUFFER_3_CLEAR",
  ADDRESS => 0x00000000000004f8,
  NOTE    => "Any access to this register clears all the count values for the (x) note registers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01035_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_4_CLEAR                                           #
#                                                                        #
##########################################################################

%tio_01_01036_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Clear Buffer Registers" ],
);

%tio_01_01036_def =
( NAME    => "TIO_CP0_PCI_BUFFER_4_CLEAR",
  ADDRESS => 0x0000000000000538,
  NOTE    => "Any access to this register clears all the count values for the (x) note registers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01036_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_5_CLEAR                                           #
#                                                                        #
##########################################################################

%tio_01_01037_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Clear Buffer Registers" ],
);

%tio_01_01037_def =
( NAME    => "TIO_CP0_PCI_BUFFER_5_CLEAR",
  ADDRESS => 0x0000000000000578,
  NOTE    => "Any access to this register clears all the count values for the (x) note registers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01037_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_6_CLEAR                                           #
#                                                                        #
##########################################################################

%tio_01_01038_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Clear Buffer Registers" ],
);

%tio_01_01038_def =
( NAME    => "TIO_CP0_PCI_BUFFER_6_CLEAR",
  ADDRESS => 0x00000000000005b8,
  NOTE    => "Any access to this register clears all the count values for the (x) note registers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01038_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUFFER_7_CLEAR                                           #
#                                                                        #
##########################################################################

%tio_01_01039_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Clear Buffer Registers" ],
);

%tio_01_01039_def =
( NAME    => "TIO_CP0_PCI_BUFFER_7_CLEAR",
  ADDRESS => 0x00000000000005f8,
  NOTE    => "Any access to this register clears all the count values for the (x) note registers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01039_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUS_ERROR_ADDRESS                                        #
#                                                                        #
##########################################################################

%tio_01_01040_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PCIX_ERR_ADDR"                => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01040_def =
( NAME    => "TIO_CP0_PCI_BUS_ERROR_ADDRESS",
  ADDRESS => 0x0000000000000600,
  NOTE    => "This register contains the address on the PCI-X bus when an error note occurred.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01040_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUS_ERROR_ATTRIBUTE                                      #
#                                                                        #
##########################################################################

%tio_01_01041_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAC"                          => [   1,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "BUS_CMD"                      => [   2,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "" ],
   "BYTE_CNT"                     => [   3,  32,  12, 0x00000FFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NS"                           => [   5,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "RO"                           => [   6,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "TAG"                          => [   7,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "" ],
   "BUS_NUM"                      => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "DEV_NUM"                      => [   9,  11,   5, 0x000000000000F800, 0x00, 0, 0x0000000000000000, "" ],
   "FUN_NUM"                      => [  10,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "L_BYTE_CNT"                   => [  11,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01041_def =
( NAME    => "TIO_CP0_PCI_BUS_ERROR_ATTRIBUTE",
  ADDRESS => 0x0000000000000608,
  NOTE    => "This register contains the attribute data on the PCI-X bus when an note error occurred. Note that the bit definitions in the reg",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01041_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCI_BUS_ERROR_DATA                                           #
#                                                                        #
##########################################################################

%tio_01_01042_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PCIX_ERR_DATA"                => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01042_def =
( NAME    => "TIO_CP0_PCI_BUS_ERROR_DATA",
  ADDRESS => 0x0000000000000610,
  NOTE    => "This register contains the Data on the PCI-X bus when an error note occurred.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01042_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_SPLIT_REQUEST_ADDRESS                                        #
#                                                                        #
##########################################################################

%tio_01_01043_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCIX_ERR_ADDR"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01043_def =
( NAME    => "TIO_CP0_SPLIT_REQUEST_ADDRESS",
  ADDRESS => 0x0000000000000618,
  NOTE    => "This register contains the address data on the PCI-X bus during the note request from a pio split transaction",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01043_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_SPLIT_REQUEST_ATTRIBUTE                                      #
#                                                                        #
##########################################################################

%tio_01_01044_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  36,  28, 0xFFFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUSCMD"                       => [   1,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NS"                           => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "RO"                           => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "TAG"                          => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "" ],
   "BUS_NUM"                      => [   6,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "DEV_NUM"                      => [   7,  11,   5, 0x000000000000F800, 0x00, 0, 0x0000000000000000, "" ],
   "FUN_NUM"                      => [   8,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "LOWER_BYTE_CNT"               => [   9,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01044_def =
( NAME    => "TIO_CP0_SPLIT_REQUEST_ATTRIBUTE",
  ADDRESS => 0x0000000000000620,
  NOTE    => "This register contains the attribute data on the PCI-X bus during note the request from a pio split transaction. Note: Because a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01044_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_DMA_ERROR_ATTRIBUTE                                          #
#                                                                        #
##########################################################################

%tio_01_01045_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XDMA_ERR_EVT_CODE"            => [   1,  49,   4, 0x001E000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_OP_INDEX"            => [   2,  45,   4, 0x0001E00000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_CL_INDEX"            => [   3,  39,   6, 0x00001F8000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_NS"                  => [   4,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_DEV_NUM_L"           => [   5,  36,   2, 0x0000003000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_D64"                 => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_RD_IS_DW"            => [   7,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_BYTE_CNT"            => [   8,  22,  12, 0x00000003FFC00000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_RO"                  => [   9,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_TAG"                 => [  10,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_BUS_NUM"             => [  11,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_DEV_NUM"             => [  12,   3,   5, 0x00000000000000F8, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_FUN_NUM"             => [  13,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01045_def =
( NAME    => "TIO_CP0_DMA_ERROR_ATTRIBUTE",
  ADDRESS => 0x0000000000000628,
  NOTE    => "This register contains attribute and other information from the note PCI-X bus DMA read transaction for which this error is asso",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01045_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_DMA_ERROR_ADDRESS                                            #
#                                                                        #
##########################################################################

%tio_01_01046_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "XDMA_ERR_ADDR"                => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01046_def =
( NAME    => "TIO_CP0_DMA_ERROR_ADDRESS",
  ADDRESS => 0x0000000000000630,
  NOTE    => "This register contains the address from the PCI-X bus DMA read note transaction for which this error is associated.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01046_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_PCIX_TIMEOUT                                                 #
#                                                                        #
##########################################################################

%tio_01_01047_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIME_OUT"                     => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01047_def =
( NAME    => "TIO_CP0_PCIX_TIMEOUT",
  ADDRESS => 0x0000000000000638,
  NOTE    => "This contains the reload value for the timeout counter based on the note current bus speed.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01047_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_CT_DEBUG_CTL                                                 #
#                                                                        #
##########################################################################

%tio_01_01048_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_NIB_SEL"                 => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_PORT_SEL"                => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_NIB_SEL"                 => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_PORT_SEL"                => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_NIB_SEL"                 => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_PORT_SEL"                => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_NIB_SEL"                 => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_PORT_SEL"                => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_NIB_SEL"                 => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_PORT_SEL"                => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_NIB_SEL"                 => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_PORT_SEL"                => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_NIB_SEL"                 => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_PORT_SEL"                => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_NIB_SEL"                 => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_PORT_SEL"                => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_01048_def =
( NAME    => "TIO_CP0_CT_DEBUG_CTL",
  ADDRESS => 0x0000000000000700,
  NOTE    => "This register controls the first-level debug mux located in the note Coretalk clock domain.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01048_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_BR_DEBUG_CTL                                                 #
#                                                                        #
##########################################################################

%tio_01_01049_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_PORT_SEL"                => [   1,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD1"                        => [   2,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_PORT_SEL"                => [   3,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD2"                        => [   4,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_PORT_SEL"                => [   5,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD3"                        => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_PORT_SEL"                => [   7,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_PORT_SEL"                => [   9,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD5"                        => [  10,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_PORT_SEL"                => [  11,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD6"                        => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_PORT_SEL"                => [  13,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD7"                        => [  14,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_PORT_SEL"                => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_01049_def =
( NAME    => "TIO_CP0_BR_DEBUG_CTL",
  ADDRESS => 0x0000000000000708,
  NOTE    => "This register controls the final-level debug mux located in the PCI note clock domain.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01049_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_MUX3_DEBUG_CTL                                               #
#                                                                        #
##########################################################################

%tio_01_01050_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_NIB_SEL"                 => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_PORT_SEL"                => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_NIB_SEL"                 => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_PORT_SEL"                => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_NIB_SEL"                 => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_PORT_SEL"                => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_NIB_SEL"                 => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_PORT_SEL"                => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_NIB_SEL"                 => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_PORT_SEL"                => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_NIB_SEL"                 => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_PORT_SEL"                => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_NIB_SEL"                 => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_PORT_SEL"                => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_NIB_SEL"                 => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_PORT_SEL"                => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_01050_def =
( NAME    => "TIO_CP0_MUX3_DEBUG_CTL",
  ADDRESS => 0x0000000000000710,
  NOTE    => "This register controls first-level debug mux number 3 located in note the PCI clock domain.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01050_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_MUX4_DEBUG_CTL                                               #
#                                                                        #
##########################################################################

%tio_01_01051_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_NIB_SEL"                 => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_PORT_SEL"                => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_NIB_SEL"                 => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_PORT_SEL"                => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_NIB_SEL"                 => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_PORT_SEL"                => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_NIB_SEL"                 => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_PORT_SEL"                => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_NIB_SEL"                 => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_PORT_SEL"                => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_NIB_SEL"                 => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_PORT_SEL"                => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_NIB_SEL"                 => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_PORT_SEL"                => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_NIB_SEL"                 => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_PORT_SEL"                => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_01051_def =
( NAME    => "TIO_CP0_MUX4_DEBUG_CTL",
  ADDRESS => 0x0000000000000718,
  NOTE    => "This register controls first-level debug mux number 4 located in note the PCI clock domain.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01051_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_MUX5_DEBUG_CTL                                               #
#                                                                        #
##########################################################################

%tio_01_01052_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_NIB_SEL"                 => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_PORT_SEL"                => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_NIB_SEL"                 => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_PORT_SEL"                => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_NIB_SEL"                 => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_PORT_SEL"                => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_NIB_SEL"                 => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_PORT_SEL"                => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_NIB_SEL"                 => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_PORT_SEL"                => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_NIB_SEL"                 => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_PORT_SEL"                => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_NIB_SEL"                 => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_PORT_SEL"                => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_NIB_SEL"                 => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_PORT_SEL"                => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_01052_def =
( NAME    => "TIO_CP0_MUX5_DEBUG_CTL",
  ADDRESS => 0x0000000000000720,
  NOTE    => "This register controls first-level debug mux number 5 located in note the PCI clock domain.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01052_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_MUX6_DEBUG_CTL                                               #
#                                                                        #
##########################################################################

%tio_01_01053_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_NIB_SEL"                 => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_PORT_SEL"                => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_NIB_SEL"                 => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_PORT_SEL"                => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_NIB_SEL"                 => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_PORT_SEL"                => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_NIB_SEL"                 => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_PORT_SEL"                => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_NIB_SEL"                 => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_PORT_SEL"                => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_NIB_SEL"                 => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_PORT_SEL"                => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_NIB_SEL"                 => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_PORT_SEL"                => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_NIB_SEL"                 => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_PORT_SEL"                => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_01053_def =
( NAME    => "TIO_CP0_MUX6_DEBUG_CTL",
  ADDRESS => 0x0000000000000728,
  NOTE    => "This register controls first-level debug mux number 6 located in note the PCI clock domain.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01053_flds
);


##########################################################################
#                                                                        #
#   TIO_CP0_MUX7_DEBUG_CTL                                               #
#                                                                        #
##########################################################################

%tio_01_01054_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_NIB_SEL"                 => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_PORT_SEL"                => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_NIB_SEL"                 => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_PORT_SEL"                => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_NIB_SEL"                 => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_PORT_SEL"                => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_NIB_SEL"                 => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_PORT_SEL"                => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_NIB_SEL"                 => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_PORT_SEL"                => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_NIB_SEL"                 => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_PORT_SEL"                => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_NIB_SEL"                 => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_PORT_SEL"                => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_NIB_SEL"                 => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_PORT_SEL"                => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_01054_def =
( NAME    => "TIO_CP0_MUX7_DEBUG_CTL",
  ADDRESS => 0x0000000000000730,
  NOTE    => "This register controls first-level debug mux number 7 located in note the PCI clock domain.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01054_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_IDENTIFICATION                                               #
#                                                                        #
##########################################################################

%tio_01_01055_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REV_NUM"                      => [   1,  28,   4, 0x00000000F0000000, 0x00, 1, 0x0000000000000000, "Revision number" ],
   "PART_NUM"                     => [   2,  12,  16, 0x000000000FFFF000, 0x00, 1, 0x0000000000000000, "Part Number" ],
   "MFG_NUM"                      => [   3,   1,  11, 0x0000000000000FFE, 0x00, 1, 0x0000000000000000, "Manufacturing Number" ],
   "READ_ONE"                     => [   4,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "Read One" ],
);

%tio_01_01055_def =
( NAME    => "TIO_CP1_IDENTIFICATION",
  ADDRESS => 0x0000000010000000,
  NOTE    => "The Identification register is a read only register used by the note host CPU during configuration to determine the type of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01055_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_STATUS                                                       #
#                                                                        #
##########################################################################

%tio_01_01056_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  44,  20, 0xFFFFF00000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TX_REQ_CREDIT_CNT"            => [   1,  40,   4, 0x00000F0000000000, 0x00, 1, 0x0000000000000000, "Transmit Request Credit Count" ],
   "TX_RSP_CREDIT_CNT"            => [   2,  36,   4, 0x000000F000000000, 0x00, 1, 0x0000000000000000, "Transmit Response Credit Count" ],
   "PCI_X_SPEED"                  => [   3,  34,   2, 0x0000000C00000000, 0x00, 0, 0x0000000000000000, "PCI-X Speed" ],
   "PCI_X_ACTIVE"                 => [   4,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "PCI-X Active Mode" ],
   "RSVD1"                        => [   5,  16,  17, 0x00000001FFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RX_REQ_CREDIT_CNT"            => [   6,  12,   4, 0x000000000000F000, 0x00, 1, 0x0000000000000000, "Receive Credit Count" ],
);

%tio_01_01056_def =
( NAME    => "TIO_CP1_STATUS",
  ADDRESS => 0x0000000010000008,
  NOTE    => "The status register is a read-only register which holds status note information of the Bus Subsection.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01056_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_BUS_SIDE_ERROR_ADDR_UPPER                                     #
#                                                                        #
##########################################################################

%tio_01_01057_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Upper Address Bits" ],
);

%tio_01_01057_def =
( NAME    => "TIO_CP1_BUS_SIDE_ERROR_ADDR_UPPER",
  ADDRESS => 0x0000000010000010,
  NOTE    => "The upper address holding register is a read only register which note contains the upper 24 bits of the address when certain err",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01057_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_BUS_SIDE_ERROR_ADDR_LOWER                                     #
#                                                                        #
##########################################################################

%tio_01_01058_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [   1,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "Upper Address Bits" ],
   "LOW_ADDR"                     => [   2,   3,  29, 0x00000000FFFFFFF8, 0x00, 0, 0x0000000000000000, "Lower Address Bits" ],
);

%tio_01_01058_def =
( NAME    => "TIO_CP1_BUS_SIDE_ERROR_ADDR_LOWER",
  ADDRESS => 0x0000000010000018,
  NOTE    => "The lower address holding register is a read only register which note contains the address which either can be accessed as a wor",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01058_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_CONTROL                                                      #
#                                                                        #
##########################################################################

%tio_01_01059_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NS"                           => [   1,  62,   1, 0x4000000000000000, 0x00, 1, 0x0000000000000000, "No Snoop" ],
   "RO"                           => [   2,  61,   1, 0x2000000000000000, 0x00, 1, 0x0000000000000000, "Relaxed Ordering" ],
   "RSVD1"                        => [   3,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUS_NUM"                      => [   4,  48,   8, 0x00FF000000000000, 0x00, 1, 0x0000000000000000, "Bus Number" ],
   "DEV_NUM"                      => [   5,  43,   5, 0x0000F80000000000, 0x00, 1, 0x0000000000000000, "Device Number" ],
   "FUN_NUM"                      => [   6,  40,   3, 0x0000070000000000, 0x00, 1, 0x0000000000000000, "Function Number" ],
   "RSVD2"                        => [   7,  32,   8, 0x000000FF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PARITY_EN_ATE"                => [   8,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "Enable Parity Checking in ATE RAM" ],
   "PARITY_EN_RESP"               => [   9,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "Enable Parity Checking in Response RAM" ],
   "PARITY_EN_REQ"                => [  10,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "Enable Parity Checking in Request RAM" ],
   "RSVD3"                        => [  11,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RST_PIN_N"                    => [  12,  24,   4, 0x000000000F000000, 0x00, 1, 0x0000000000000000, "Software Programmable Reset Pins" ],
   "RSVD4"                        => [  13,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MEM_SWAP"                     => [  14,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "Memory Enable Swapping" ],
   "PAGE_SIZE"                    => [  15,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "Page Size" ],
   "RSVD5"                        => [  16,  14,   7, 0x00000000001FC000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CRED_LIMIT"                   => [  17,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "Request Credit Limit" ],
   "RSVD6"                        => [  18,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SYS_END"                      => [  19,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "System Endianess" ],
   "RSVD7"                        => [  20,   6,   3, 0x00000000000001C0, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_X_SPEED"                  => [  21,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "Read-only PCI-X Speed" ],
   "RSVD8"                        => [  22,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CORELET_ID"                   => [  23,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Core-let ID" ],
);

%tio_01_01059_def =
( NAME    => "TIO_CP1_CONTROL",
  ADDRESS => 0x0000000010000020,
  NOTE    => "The control register is a read/write register which holds control note information for the bus subsection. Note that the PCI-X f",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01059_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_REQUEST_TIMEOUT                                              #
#                                                                        #
##########################################################################

%tio_01_01060_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIME_OUT"                     => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "Time-out Value" ],
);

%tio_01_01060_def =
( NAME    => "TIO_CP1_REQUEST_TIMEOUT",
  ADDRESS => 0x0000000010000028,
  NOTE    => "This register contains the reload value for the request timer. The note request timer counts decrements once every 1280ns (256 c",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01060_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_INTERRUPT_DEST_UPPER                                         #
#                                                                        #
##########################################################################

%tio_01_01061_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [   1,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Upper Address" ],
);

%tio_01_01061_def =
( NAME    => "TIO_CP1_INTERRUPT_DEST_UPPER",
  ADDRESS => 0x0000000010000030,
  NOTE    => "The interrupt destination upper address register is a read/write note register containing the upper 22 bits of address of the ho",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01061_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_INTERRUPT_DEST_LOWER                                         #
#                                                                        #
##########################################################################

%tio_01_01062_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [   1,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "Upper Address" ],
   "LOW_ADDR"                     => [   2,   3,  29, 0x00000000FFFFFFF8, 0x00, 0, 0x0000000000000000, "Lower Address" ],
);

%tio_01_01062_def =
( NAME    => "TIO_CP1_INTERRUPT_DEST_LOWER",
  ADDRESS => 0x0000000010000038,
  NOTE    => "The interrupt destination lower address register is a read/write note register which contains the entire address of the host to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01062_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_BUS_SIDE_ERROR_CMD_WRD                                       #
#                                                                        #
##########################################################################

%tio_01_01063_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "RSVD0"                        => [   1,  36,  27, 0x7FFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CW_ERR"                       => [   2,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Coretalk Command Word Error Bit" ],
   "PIO_OP"                       => [   3,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PIO operation not memory operation" ],
   "RD_PARM"                      => [   4,  32,   2, 0x0000000300000000, 0x00, 0, 0x0000000000000000, "Memory Read Parameters" ],
   "RSVD1"                        => [   5,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DW_DATA_EN"                   => [   6,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Coretalk Double Word Data Enable" ],
   "TNUM"                         => [   7,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Coretalk Transaction Number" ],
   "DATA_SIZE"                    => [   8,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Coretalk Data Size" ],
   "RSVD2"                        => [   9,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PACTYP"                       => [  10,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Coretalk Packet Type" ],
);

%tio_01_01063_def =
( NAME    => "TIO_CP1_BUS_SIDE_ERROR_CMD_WRD",
  ADDRESS => 0x0000000010000040,
  NOTE    => "The command word holding is a read only register that holds the note command word of a Coretalk packet when errors occur on the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01063_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_TARGET_FLUSH                                                 #
#                                                                        #
##########################################################################

%tio_01_01064_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
);

%tio_01_01064_def =
( NAME    => "TIO_CP1_TARGET_FLUSH",
  ADDRESS => 0x0000000010000050,
  NOTE    => "When read, this register will not return a response until after all note previous PIO transfers to the PCI bus have been forward",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01064_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_LINK_SIDE_ERROR_CMD_WRD                                      #
#                                                                        #
##########################################################################

%tio_01_01065_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Valid" ],
   "RSVD0"                        => [   1,  50,  13, 0x7FFC000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DATA_ERR"                     => [   2,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "Data Error" ],
   "HDR_ERR"                      => [   3,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "Header Error" ],
   "RSVD1"                        => [   4,  36,  12, 0x0000FFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CW_ERR"                       => [   5,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Coretalk Command Word Error Bit" ],
   "PIO_OP"                       => [   6,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "PIO operation not memory operation" ],
   "RD_PARM"                      => [   7,  32,   2, 0x0000000300000000, 0x00, 0, 0x0000000000000000, "Memory Read Parameters" ],
   "RSVD2"                        => [   8,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DW_DATA_EN"                   => [   9,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "Coretalk Double Word Data Enable" ],
   "TNUM"                         => [  10,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "Coretalk Transaction Number" ],
   "DATA_SIZE"                    => [  11,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Coretalk Data Size" ],
   "RSVD3"                        => [  12,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PACTYP"                       => [  13,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "Coretalk Packet Type" ],
);

%tio_01_01065_def =
( NAME    => "TIO_CP1_LINK_SIDE_ERROR_CMD_WRD",
  ADDRESS => 0x0000000010000058,
  NOTE    => "The command word holding is a read-only register that holds the note command word of a Coretalk packet when request fifo overflo",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01065_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_RSP_BUFFER_UPPER                                             #
#                                                                        #
##########################################################################

%tio_01_01066_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEV_NUM"                      => [   1,  28,   2, 0x0000000030000000, 0x00, 0, 0x0000000000000000, "Device Number" ],
   "BUFF_NUM"                     => [   2,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "Buffer Number" ],
   "RSVD1"                        => [   3,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [   4,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "Upper Address" ],
);

%tio_01_01066_def =
( NAME    => "TIO_CP1_RSP_BUFFER_UPPER",
  ADDRESS => 0x0000000010000060,
  NOTE    => "The response buffer error upper address holding register is a read note only register which contains the upper 22-bits of the ad",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01066_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_RSP_BUFFER_LOWER                                             #
#                                                                        #
##########################################################################

%tio_01_01067_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  62,   2, 0xC000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEV_NUM"                      => [   1,  60,   2, 0x3000000000000000, 0x00, 0, 0x0000000000000000, "Device Number" ],
   "BUFF_NUM"                     => [   2,  56,   4, 0x0F00000000000000, 0x00, 0, 0x0000000000000000, "Buffer Number" ],
   "RSVD1"                        => [   3,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [   4,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "Upper Address" ],
   "LOW_ADDR"                     => [   5,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "Lower Address" ],
);

%tio_01_01067_def =
( NAME    => "TIO_CP1_RSP_BUFFER_LOWER",
  ADDRESS => 0x0000000010000068,
  NOTE    => "The response buffer error lower address holding register is a read note only register which contains the address of the error as",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01067_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_DEBUG_PORT_CONTROL                                           #
#                                                                        #
##########################################################################

%tio_01_01068_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_SEL"                     => [   1,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "NIB6_SEL"                     => [   2,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "NIB5_SEL"                     => [   3,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "NIB4_SEL"                     => [   4,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "NIB3_SEL"                     => [   5,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "NIB2_SEL"                     => [   6,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "NIB1_SEL"                     => [   7,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "NIB0_SEL"                     => [   8,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_01068_def =
( NAME    => "TIO_CP1_DEBUG_PORT_CONTROL",
  ADDRESS => 0x0000000010000070,
  NOTE    => "This register controls the final output mux of CP.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01068_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_LINK_SIDE_ERROR_ADDR_HOLD                                     #
#                                                                        #
##########################################################################

%tio_01_01069_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  54,  10, 0xFFC0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [   1,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "Upper Address" ],
   "LOW_ADDR"                     => [   2,   3,  29, 0x00000000FFFFFFF8, 0x00, 0, 0x0000000000000000, "Lower Address" ],
);

%tio_01_01069_def =
( NAME    => "TIO_CP1_LINK_SIDE_ERROR_ADDR_HOLD",
  ADDRESS => 0x0000000010000078,
  NOTE    => "The address holding register is a read only register which contains note the address which either can be accessed as a word or d",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01069_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_DIRECT_MAPPING                                           #
#                                                                        #
##########################################################################

%tio_01_01070_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  26,  38, 0xFFFFFFFFFC000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_OFF_UP"                   => [   1,  20,   6, 0x0000000003F00000, 0x00, 1, 0x0000000000000000, "Upper Address Bits" ],
   "RSVD1"                        => [   2,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_ADD512"                   => [   3,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "Direct Map 512MB Offset" ],
   "DIR_OFF"                      => [   4,   0,  17, 0x000000000001FFFF, 0x00, 1, 0x0000000000000000, "Direct Map Offset" ],
);

%tio_01_01070_def =
( NAME    => "TIO_CP1_PCI_DIRECT_MAPPING",
  ADDRESS => 0x0000000010000080,
  NOTE    => "This register is used to relocate a 2 GByte region for PCI to note Coretalk transfers. The fields DIR_OFF and DIR_OFF_UP are not",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01070_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PAGE_MAP_FAULT_ADD                                           #
#                                                                        #
##########################################################################

%tio_01_01071_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  22,  42, 0xFFFFFFFFFFC00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_ADDR"                     => [   1,   4,  18, 0x00000000003FFFF0, 0x00, 0, 0x0000000000000000, "PCI Address" ],
   "RSVD1"                        => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_DEV_NUM"                  => [   3,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "PCI Device Number" ],
);

%tio_01_01071_def =
( NAME    => "TIO_CP1_PAGE_MAP_FAULT_ADD",
  ADDRESS => 0x0000000010000090,
  NOTE    => "This register contains the address and device number when a page note map fault occurred.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01071_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_ARBITRATION_PRIORITY                                         #
#                                                                        #
##########################################################################

%tio_01_01072_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  29,  35, 0xFFFFFFFFE0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUS_DISABLE"                  => [   1,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "Disable PCI(-X) Bus" ],
   "RSVD1"                        => [   2,  25,   3, 0x000000000E000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DEV_BROKE_EN"                 => [   3,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "Device Broken Enable" ],
   "DEV_BROKE"                    => [   4,  20,   4, 0x0000000000F00000, 0x00, 1, 0x0000000000000000, "Device Broken" ],
   "RSVD2"                        => [   5,  18,   2, 0x00000000000C0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_WAIT_TICK"                => [   6,  16,   2, 0x0000000000030000, 0x00, 1, 0x0000000000000000, "Request Wait Time" ],
   "RSVD3"                        => [   7,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "REQ_WAIT_EN"                  => [   8,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "Request Wait Enable" ],
   "RSVD4"                        => [   9,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FREEZE_GNT"                   => [  10,   6,   1, 0x0000000000000040, 0x00, 1, 0x0000000000000000, "Freeze Grant" ],
   "RSVD5"                        => [  11,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_BRIDGE_HI"                 => [  12,   3,   2, 0x0000000000000018, 0x00, 1, 0x0000000000000000, "Enable High" ],
   "RSVD6"                        => [  13,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_BRIDGE_LO"                 => [  14,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "Enable Low" ],
);

%tio_01_01072_def =
( NAME    => "TIO_CP1_ARBITRATION_PRIORITY",
  ADDRESS => 0x00000000100000a0,
  NOTE    => "This register defines the priority and bus time out timing in PCI note bus arbitration.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01072_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_INTERNAL_RAM_PARITY_ERROR                                     #
#                                                                        #
##########################################################################

%tio_01_01073_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  58,   6, 0xFC00000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR_ATE"                     => [   1,  48,  10, 0x03FF000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,  41,   7, 0x0000FE0000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "ADDR_RESP"                    => [   3,  32,   9, 0x000001FF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADDR_REQ"                     => [   4,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD2"                        => [   5,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "WRT_ERR_ATE"                  => [   6,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "" ],
   "WRT_ERR_RESP"                 => [   7,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "" ],
   "WRT_ERR_REQ"                  => [   8,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD3"                        => [   9,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DBE_REQ"                      => [  10,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01073_def =
( NAME    => "TIO_CP1_INTERNAL_RAM_PARITY_ERROR",
  ADDRESS => 0x00000000100000b0,
  NOTE    => "This register logs information about parity errors on internal ram note access. For errors to be logged, the parity_en_ate and/o",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01073_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_TIMEOUT                                                      #
#                                                                        #
##########################################################################

%tio_01_01074_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  21,  43, 0xFFFFFFFFFFE00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_RETRY_HLD"                => [   1,  16,   5, 0x00000000001F0000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,  10,   6, 0x000000000000FC00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_RETRY_CNT"                => [   3,   0,  10, 0x00000000000003FF, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01074_def =
( NAME    => "TIO_CP1_TIMEOUT",
  ADDRESS => 0x00000000100000c0,
  NOTE    => "This register determines retry hold off and max retries allowed for note PIO accesses to PCI/PCI-X.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01074_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_TYPE1_CONFIGURATION                                          #
#                                                                        #
##########################################################################

%tio_01_01075_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUS_NUM"                      => [   1,  16,   8, 0x0000000000FF0000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_NUM"                      => [   2,  11,   5, 0x000000000000F800, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01075_def =
( NAME    => "TIO_CP1_TYPE1_CONFIGURATION",
  ADDRESS => 0x00000000100000c8,
  NOTE    => "This register is used during accesses to the PCI/PCI-X type 1 note configuration space. The bits in this register are used to no",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01075_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_BUS_ERROR_ADDR_UPPER                                         #
#                                                                        #
##########################################################################

%tio_01_01076_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_CMD"                      => [   1,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_DAC"                      => [   2,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_DEV_MASTER"               => [   3,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_VDEV"                     => [   4,  24,   2, 0x0000000003000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_DEV_NUM"                  => [   5,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_UADDR_ERR"                => [   6,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01076_def =
( NAME    => "TIO_CP1_BUS_ERROR_ADDR_UPPER",
  ADDRESS => 0x00000000100000d0,
  NOTE    => "This register holds the value of the upper address on the PCI Bus note when an error occurs.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01076_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_BUS_ERROR_ADDR_LOWER                                         #
#                                                                        #
##########################################################################

%tio_01_01077_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PCI_CMD"                      => [   0,  60,   4, 0xF000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_DAC"                      => [   1,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_DEV_MASTER"               => [   2,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_VDEV"                     => [   3,  56,   2, 0x0300000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_DEV_NUM"                  => [   4,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_UADDR_ERR"                => [   5,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_LADDR_ERR"                => [   6,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01077_def =
( NAME    => "TIO_CP1_BUS_ERROR_ADDR_LOWER",
  ADDRESS => 0x00000000100000d8,
  NOTE    => "This register holds the value of the address on the PCI Bus when an note error occurs.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01077_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_INT_STATUS                                                   #
#                                                                        #
##########################################################################

%tio_01_01078_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CWRT_REQ_TOUT"                => [   1,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CTALK_PROT_ERROR"             => [   2,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_MES_PE"           => [   3,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_EMESS"            => [   4,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_TO"               => [   5,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_UNEX_COMP"              => [   6,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_RAM_PERR"                 => [   7,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_ARB_ERR"                => [   8,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_REQ_TOUT"               => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_TABORT"                 => [  10,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_PERR"                   => [  11,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SERR"                   => [  12,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_MRETRY"                 => [  13,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_MTOUT"                  => [  14,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_DA_PARITY"              => [  15,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_AD_PARITY"              => [  16,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [  17,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PMU_PAGE_FAULT"               => [  18,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNEXPECTED_RESP"              => [  19,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_CRESP_PACKET"             => [  20,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_CREQ_PACKET"              => [  21,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "RESP_CTALK_ERROR"             => [  22,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "REQ_CTALK_ERROR"              => [  23,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "INVALID_ACCESS"               => [  24,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNSUPPORTED_COP"              => [  25,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "" ],
   "CREQ_FIFO_OFLOW"              => [  26,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD2"                        => [  27,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_ABORT"                    => [  28,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_PARITY"                   => [  29,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_SERR"                     => [  30,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_PERR"                     => [  31,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_MASTER_TOUT"              => [  32,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_RETRY_CNT"                => [  33,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "CREAD_REQ_TOUT"               => [  34,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD3"                        => [  35,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_STATE"                    => [  36,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01078_def =
( NAME    => "TIO_CP1_INT_STATUS",
  ADDRESS => 0x0000000010000100,
  NOTE    => "This is the current interrupt status register which maintains the note current status of all the interrupting devices and error ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01078_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_INTERRUPT_ENABLE                                             #
#                                                                        #
##########################################################################

%tio_01_01079_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_CWRT_REQ_TOUT"             => [   1,  47,   1, 0x0000800000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_CTALK_PROT_ERROR"          => [   2,  46,   1, 0x0000400000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_SPLIT_MES_PE"        => [   3,  45,   1, 0x0000200000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_SPLIT_EMESS"         => [   4,  44,   1, 0x0000100000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_SPLIT_TO"            => [   5,  43,   1, 0x0000080000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_UNEX_COMP"           => [   6,  42,   1, 0x0000040000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_INT_RAM_PERR"              => [   7,  41,   1, 0x0000020000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_ARB_ERR"             => [   8,  40,   1, 0x0000010000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_REQ_TOUT"            => [   9,  39,   1, 0x0000008000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_TABORT"              => [  10,  38,   1, 0x0000004000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_PERR"                => [  11,  37,   1, 0x0000002000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_SERR"                => [  12,  36,   1, 0x0000001000000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_MRETRY"              => [  13,  35,   1, 0x0000000800000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_MTOUT"               => [  14,  34,   1, 0x0000000400000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_DA_PARITY"           => [  15,  33,   1, 0x0000000200000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_X_AD_PARITY"           => [  16,  32,   1, 0x0000000100000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [  17,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_PMU_PAGE_FAULT"            => [  18,  30,   1, 0x0000000040000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_UNEXPECTED_RESP"           => [  19,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_BAD_CRESP_PACKET"          => [  20,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_BAD_CREQ_PACKET"           => [  21,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_RESP_CTALK_ERROR"          => [  22,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_REQ_CTALK_ERROR"           => [  23,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_INVALID_ACCESS"            => [  24,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_UNSUPPORTED_XOP"           => [  25,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_CREQ_FIFO_OFLOW"           => [  26,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [  27,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_PCI_ABORT"                 => [  28,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_PARITY"                => [  29,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_SERR"                  => [  30,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_PERR"                  => [  31,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_MASTER_TOUT"           => [  32,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PCI_RETRY_CNT"             => [  33,  10,   1, 0x0000000000000400, 0x00, 1, 0x0000000000000000, "" ],
   "EN_CREAD_REQ_TOUT"            => [  34,   9,   1, 0x0000000000000200, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD3"                        => [  35,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "EN_INT_STATE"                 => [  36,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01079_def =
( NAME    => "TIO_CP1_INTERRUPT_ENABLE",
  ADDRESS => 0x0000000010000108,
  NOTE    => "This register enables the reporting of interrupt to the host. Each note bit in this register corresponds to the same bit in Inte",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01079_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_RESET_INTERRUPT                                              #
#                                                                        #
##########################################################################

%tio_01_01080_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOGV_CWRT_REQ_TOUT"           => [   1,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_CTALK_PROT_ERROR"        => [   2,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_SPLIT_MES_PE"      => [   3,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_SPLIT_EMESS"       => [   4,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_SPLIT_TO"          => [   5,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_UNEX_COMP"         => [   6,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_INT_RAM_PERR"            => [   7,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_ARB_ERR"           => [   8,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_REQ_TOUT"          => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_TABORT"            => [  10,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_PERR"              => [  11,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_SERR"              => [  12,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_MRETRY"            => [  13,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_MTOUT"             => [  14,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_DA_PARITY"         => [  15,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_X_AD_PARITY"         => [  16,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [  17,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOGV_PMU_PAGE_FAULT"          => [  18,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_UNEXPECTED_RESP"         => [  19,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_BAD_CRESP_PACKET"        => [  20,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_BAD_CREQ_PACKET"         => [  21,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_RESP_CTALK_ERROR"        => [  22,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_REQ_CTALK_ERROR"         => [  23,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_INVALID_ACCESS"          => [  24,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_UNSUPPORTED_XOP"         => [  25,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_CREQ_FIFO_OFLOW"         => [  26,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD2"                        => [  27,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "LOGV_PCI_ABORT"               => [  28,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_PARITY"              => [  29,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_SERR"                => [  30,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_PERR"                => [  31,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_MASTER_TOUT"         => [  32,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_PCI_RETRY_CNT"           => [  33,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LOGV_CREAD_REQ_TOUT"          => [  34,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD3"                        => [  35,   7,   2, 0x0000000000000180, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MULTI_CLR"                    => [  36,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "CRP_GRP_CLR"                  => [  37,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "RESP_BUF_GRP_CLR"             => [  38,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "REQ_DSP_GRP_CLR"              => [  39,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD4"                        => [  40,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PMU_PAGE_FAULT"               => [  41,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_GRP_CLR"                  => [  42,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01080_def =
( NAME    => "TIO_CP1_RESET_INTERRUPT",
  ADDRESS => 0x0000000010000110,
  NOTE    => "A write of a &quot;1&quot; clears the bit and rearms the error note registers. Writes also clear the error view register. Note t",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01080_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_INTERRUPT_MODE                                               #
#                                                                        #
##########################################################################

%tio_01_01081_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_TRANS_TIME_SEL"           => [   1,   8,   8, 0x000000000000FF00, 0x00, 1, 0x0000000000000000, "Interrupt Transition Time Select" ],
   "EN_CLR_PKT"                   => [   2,   0,   8, 0x00000000000000FF, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01081_def =
( NAME    => "TIO_CP1_INTERRUPT_MODE",
  ADDRESS => 0x0000000010000118,
  NOTE    => "This register defines the interrupting mode of the INT_N pins.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01081_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_INTERRUPT_DEVICE                                             #
#                                                                        #
##########################################################################

%tio_01_01082_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  23,  41, 0xFFFFFFFFFF800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT7_DEV"                     => [   1,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT6_DEV"                     => [   3,  18,   2, 0x00000000000C0000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [   4,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT5_DEV"                     => [   5,  15,   2, 0x0000000000018000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD3"                        => [   6,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT4_DEV"                     => [   7,  12,   2, 0x0000000000003000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD4"                        => [   8,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT3_DEV"                     => [   9,   9,   2, 0x0000000000000600, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD5"                        => [  10,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT2_DEV"                     => [  11,   6,   2, 0x00000000000000C0, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD6"                        => [  12,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT1_DEV"                     => [  13,   3,   2, 0x0000000000000018, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD7"                        => [  14,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT0_DEV"                     => [  15,   0,   2, 0x0000000000000003, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01082_def =
( NAME    => "TIO_CP1_INTERRUPT_DEVICE",
  ADDRESS => 0x0000000010000120,
  NOTE    => "This register associates interrupt pins with devices thus allowing note buffer management (flushing) when a device interrupt occ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01082_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_HOST_ERROR_INTERRUPT                                         #
#                                                                        #
##########################################################################

%tio_01_01083_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,   8,  56, 0xFFFFFFFFFFFFFF00, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BRIDGE_ERR_FLD"               => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01083_def =
( NAME    => "TIO_CP1_HOST_ERROR_INTERRUPT",
  ADDRESS => 0x0000000010000128,
  NOTE    => "This register contains the value to write into the host interrupt note register when an error interrupt is generated.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01083_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_INTERRUPT_0_HOST_ADDRESS                                     #
#                                                                        #
##########################################################################

%tio_01_01084_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_FLD"                      => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_ADDR"                     => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01084_def =
( NAME    => "TIO_CP1_INTERRUPT_0_HOST_ADDRESS",
  ADDRESS => 0x0000000010000130,
  NOTE    => "This register allows different host addresses to be assigned to note each interrupt pin and the bit in the host.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01084_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_INTERRUPT_1_HOST_ADDRESS                                     #
#                                                                        #
##########################################################################

%tio_01_01085_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_FLD"                      => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_ADDR"                     => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01085_def =
( NAME    => "TIO_CP1_INTERRUPT_1_HOST_ADDRESS",
  ADDRESS => 0x0000000010000138,
  NOTE    => "This register allows different host addresses to be assigned to note each interrupt pin and the bit in the host.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01085_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_INTERRUPT_2_HOST_ADDRESS                                     #
#                                                                        #
##########################################################################

%tio_01_01086_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_FLD"                      => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_ADDR"                     => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01086_def =
( NAME    => "TIO_CP1_INTERRUPT_2_HOST_ADDRESS",
  ADDRESS => 0x0000000010000140,
  NOTE    => "This register allows different host addresses to be assigned to note each interrupt pin and the bit in the host.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01086_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_INTERRUPT_3_HOST_ADDRESS                                     #
#                                                                        #
##########################################################################

%tio_01_01087_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_FLD"                      => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_ADDR"                     => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01087_def =
( NAME    => "TIO_CP1_INTERRUPT_3_HOST_ADDRESS",
  ADDRESS => 0x0000000010000148,
  NOTE    => "This register allows different host addresses to be assigned to note each interrupt pin and the bit in the host.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01087_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_INTERRUPT_4_HOST_ADDRESS                                     #
#                                                                        #
##########################################################################

%tio_01_01088_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_FLD"                      => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_ADDR"                     => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01088_def =
( NAME    => "TIO_CP1_INTERRUPT_4_HOST_ADDRESS",
  ADDRESS => 0x0000000010000150,
  NOTE    => "This register allows different host addresses to be assigned to note each interrupt pin and the bit in the host.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01088_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_INTERRUPT_5_HOST_ADDRESS                                     #
#                                                                        #
##########################################################################

%tio_01_01089_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_FLD"                      => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_ADDR"                     => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01089_def =
( NAME    => "TIO_CP1_INTERRUPT_5_HOST_ADDRESS",
  ADDRESS => 0x0000000010000158,
  NOTE    => "This register allows different host addresses to be assigned to note each interrupt pin and the bit in the host.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01089_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_INTERRUPT_6_HOST_ADDRESS                                     #
#                                                                        #
##########################################################################

%tio_01_01090_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_FLD"                      => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_ADDR"                     => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01090_def =
( NAME    => "TIO_CP1_INTERRUPT_6_HOST_ADDRESS",
  ADDRESS => 0x0000000010000160,
  NOTE    => "This register allows different host addresses to be assigned to note each interrupt pin and the bit in the host.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01090_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_INTERRUPT_7_HOST_ADDRESS                                     #
#                                                                        #
##########################################################################

%tio_01_01091_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_FLD"                      => [   0,  56,   8, 0xFF00000000000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD0"                        => [   1,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INT_ADDR"                     => [   2,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01091_def =
( NAME    => "TIO_CP1_INTERRUPT_7_HOST_ADDRESS",
  ADDRESS => 0x0000000010000168,
  NOTE    => "This register allows different host addresses to be assigned to note each interrupt pin and the bit in the host.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01091_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_ERROR_INTERRUPT_VIEW                                         #
#                                                                        #
##########################################################################

%tio_01_01092_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "CWRT_REQ_TOUT"                => [   1,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CTALK_PROT_ERROR"             => [   2,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_MES_PE"           => [   3,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_EMESS"            => [   4,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_TO"               => [   5,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_UNEX_COMP"              => [   6,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_RAM_PERR"                 => [   7,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_ARB_ERR"                => [   8,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_REQ_TOUT"               => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_TABORT"                 => [  10,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_PERR"                   => [  11,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SERR"                   => [  12,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_MRETRY"                 => [  13,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_MTOUT"                  => [  14,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_DA_PARITY"              => [  15,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_AD_PARITY"              => [  16,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [  17,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PMU_PAGE_FAULT"               => [  18,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNEXPECTED_RESP"              => [  19,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_CRESP_PACKET"             => [  20,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_CREQ_PACKET"              => [  21,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "RESP_CTALK_ERROR"             => [  22,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "REQ_CTALK_ERROR"              => [  23,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "INVALID_ACCESS"               => [  24,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNSUPPORTED_XOP"              => [  25,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "" ],
   "CREQ_FIFO_OFLOW"              => [  26,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD2"                        => [  27,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_ABORT"                    => [  28,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_PARITY"                   => [  29,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_SERR"                     => [  30,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_PERR"                     => [  31,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_MASTER_TOUT"              => [  32,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_RETRY_CNT"                => [  33,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "CREAD_REQ_TOUT"               => [  34,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01092_def =
( NAME    => "TIO_CP1_ERROR_INTERRUPT_VIEW",
  ADDRESS => 0x0000000010000170,
  NOTE    => "This register contains the view of which interrupt occur even if note they are not currently enabled. This register is reset by ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01092_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_MULTIPLE_INTERRUPT                                           #
#                                                                        #
##########################################################################

%tio_01_01093_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  48,  16, 0xFFFF000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_CTALK_WRITE_TIMEOUT"      => [   1,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CTALK_PROT_ERROR"             => [   2,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_MES_PE"           => [   3,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_EMESS"            => [   4,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SPLIT_TO"               => [   5,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_UNEX_COMP"              => [   6,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_RAM_PERR"                 => [   7,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_ARB_ERR"                => [   8,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_REQ_TOUT"               => [   9,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_TABORT"                 => [  10,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_PERR"                   => [  11,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_SERR"                   => [  12,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_MRETRY"                 => [  13,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_MTOUT"                  => [  14,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_DA_PARITY"              => [  15,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_X_AD_PARITY"              => [  16,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [  17,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PMU_PAGE_FAULT"               => [  18,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNEXPECTED_RESP"              => [  19,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_CRESP_PACKET"             => [  20,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_CREQ_PACKET"              => [  21,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "RESP_CTALK_ERROR"             => [  22,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "REQ_CTALK_ERROR"              => [  23,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "INVALID_ACCESS"               => [  24,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNSUPPORTED_XOP"              => [  25,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "" ],
   "CREQ_FIFO_OFLOW"              => [  26,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD2"                        => [  27,  16,   6, 0x00000000003F0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCI_ABORT"                    => [  28,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_PARITY"                   => [  29,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_SERR"                     => [  30,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_PERR"                     => [  31,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_MASTER_TOUT"              => [  32,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "PCI_RETRY_CNT"                => [  33,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "CREAD_REQ_TOUT"               => [  34,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01093_def =
( NAME    => "TIO_CP1_MULTIPLE_INTERRUPT",
  ADDRESS => 0x0000000010000178,
  NOTE    => "This register indicates if any interrupt occurs more than once note without being cleared. This register is reset by the MULTI_C",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01093_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_FORCE_ALWAYS_INTERRUPT_0                                     #
#                                                                        #
##########################################################################

%tio_01_01094_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_ALWAYS"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Always" ],
);

%tio_01_01094_def =
( NAME    => "TIO_CP1_FORCE_ALWAYS_INTERRUPT_0",
  ADDRESS => 0x0000000010000180,
  NOTE    => "A write to this data independent write-only register will force a note set interrupt to occur as if the interrupt line had trans",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01094_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_FORCE_ALWAYS_INTERRUPT_1                                     #
#                                                                        #
##########################################################################

%tio_01_01095_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_ALWAYS"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Always" ],
);

%tio_01_01095_def =
( NAME    => "TIO_CP1_FORCE_ALWAYS_INTERRUPT_1",
  ADDRESS => 0x0000000010000188,
  NOTE    => "A write to this data independent write-only register will force a note set interrupt to occur as if the interrupt line had trans",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01095_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_FORCE_ALWAYS_INTERRUPT_2                                     #
#                                                                        #
##########################################################################

%tio_01_01096_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_ALWAYS"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Always" ],
);

%tio_01_01096_def =
( NAME    => "TIO_CP1_FORCE_ALWAYS_INTERRUPT_2",
  ADDRESS => 0x0000000010000190,
  NOTE    => "A write to this data independent write-only register will force a note set interrupt to occur as if the interrupt line had trans",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01096_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_FORCE_ALWAYS_INTERRUPT_3                                     #
#                                                                        #
##########################################################################

%tio_01_01097_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_ALWAYS"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Always" ],
);

%tio_01_01097_def =
( NAME    => "TIO_CP1_FORCE_ALWAYS_INTERRUPT_3",
  ADDRESS => 0x0000000010000198,
  NOTE    => "A write to this data independent write-only register will force a note set interrupt to occur as if the interrupt line had trans",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01097_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_FORCE_ALWAYS_INTERRUPT_4                                     #
#                                                                        #
##########################################################################

%tio_01_01098_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_ALWAYS"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Always" ],
);

%tio_01_01098_def =
( NAME    => "TIO_CP1_FORCE_ALWAYS_INTERRUPT_4",
  ADDRESS => 0x00000000100001a0,
  NOTE    => "A write to this data independent write-only register will force a note set interrupt to occur as if the interrupt line had trans",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01098_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_FORCE_ALWAYS_INTERRUPT_5                                     #
#                                                                        #
##########################################################################

%tio_01_01099_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_ALWAYS"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Always" ],
);

%tio_01_01099_def =
( NAME    => "TIO_CP1_FORCE_ALWAYS_INTERRUPT_5",
  ADDRESS => 0x00000000100001a8,
  NOTE    => "A write to this data independent write-only register will force a note set interrupt to occur as if the interrupt line had trans",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01099_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_FORCE_ALWAYS_INTERRUPT_6                                     #
#                                                                        #
##########################################################################

%tio_01_01100_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_ALWAYS"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Always" ],
);

%tio_01_01100_def =
( NAME    => "TIO_CP1_FORCE_ALWAYS_INTERRUPT_6",
  ADDRESS => 0x00000000100001b0,
  NOTE    => "A write to this data independent write-only register will force a note set interrupt to occur as if the interrupt line had trans",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01100_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_FORCE_ALWAYS_INTERRUPT_7                                     #
#                                                                        #
##########################################################################

%tio_01_01101_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_ALWAYS"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Always" ],
);

%tio_01_01101_def =
( NAME    => "TIO_CP1_FORCE_ALWAYS_INTERRUPT_7",
  ADDRESS => 0x00000000100001b8,
  NOTE    => "A write to this data independent write-only register will force a note set interrupt to occur as if the interrupt line had trans",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01101_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_FORCE_INTERRUPT_0                                            #
#                                                                        #
##########################################################################

%tio_01_01102_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTERRUPT"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Interrupt" ],
);

%tio_01_01102_def =
( NAME    => "TIO_CP1_FORCE_INTERRUPT_0",
  ADDRESS => 0x00000000100001c0,
  NOTE    => "A write to this data independent write-only register in conjunction note with the assertion of the corresponding interrupt line ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01102_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_FORCE_INTERRUPT_1                                            #
#                                                                        #
##########################################################################

%tio_01_01103_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTERRUPT"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Interrupt" ],
);

%tio_01_01103_def =
( NAME    => "TIO_CP1_FORCE_INTERRUPT_1",
  ADDRESS => 0x00000000100001c8,
  NOTE    => "A write to this data independent write-only register in conjunction note with the assertion of the corresponding interrupt line ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01103_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_FORCE_INTERRUPT_2                                            #
#                                                                        #
##########################################################################

%tio_01_01104_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTERRUPT"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Interrupt" ],
);

%tio_01_01104_def =
( NAME    => "TIO_CP1_FORCE_INTERRUPT_2",
  ADDRESS => 0x00000000100001d0,
  NOTE    => "A write to this data independent write-only register in conjunction note with the assertion of the corresponding interrupt line ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01104_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_FORCE_INTERRUPT_3                                            #
#                                                                        #
##########################################################################

%tio_01_01105_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTERRUPT"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Interrupt" ],
);

%tio_01_01105_def =
( NAME    => "TIO_CP1_FORCE_INTERRUPT_3",
  ADDRESS => 0x00000000100001d8,
  NOTE    => "A write to this data independent write-only register in conjunction note with the assertion of the corresponding interrupt line ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01105_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_FORCE_INTERRUPT_4                                            #
#                                                                        #
##########################################################################

%tio_01_01106_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTERRUPT"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Interrupt" ],
);

%tio_01_01106_def =
( NAME    => "TIO_CP1_FORCE_INTERRUPT_4",
  ADDRESS => 0x00000000100001e0,
  NOTE    => "A write to this data independent write-only register in conjunction note with the assertion of the corresponding interrupt line ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01106_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_FORCE_INTERRUPT_5                                            #
#                                                                        #
##########################################################################

%tio_01_01107_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTERRUPT"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Interrupt" ],
);

%tio_01_01107_def =
( NAME    => "TIO_CP1_FORCE_INTERRUPT_5",
  ADDRESS => 0x00000000100001e8,
  NOTE    => "A write to this data independent write-only register in conjunction note with the assertion of the corresponding interrupt line ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01107_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_FORCE_INTERRUPT_6                                            #
#                                                                        #
##########################################################################

%tio_01_01108_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTERRUPT"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Interrupt" ],
);

%tio_01_01108_def =
( NAME    => "TIO_CP1_FORCE_INTERRUPT_6",
  ADDRESS => 0x00000000100001f0,
  NOTE    => "A write to this data independent write-only register in conjunction note with the assertion of the corresponding interrupt line ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01108_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_FORCE_INTERRUPT_7                                            #
#                                                                        #
##########################################################################

%tio_01_01109_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_INTERRUPT"              => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Force Interrupt" ],
);

%tio_01_01109_def =
( NAME    => "TIO_CP1_FORCE_INTERRUPT_7",
  ADDRESS => 0x00000000100001f8,
  NOTE    => "A write to this data independent write-only register in conjunction note with the assertion of the corresponding interrupt line ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01109_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_DEVICE_0                                                     #
#                                                                        #
##########################################################################

%tio_01_01110_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_OP"                       => [   1,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_ERROR_LOCK"                => [   2,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PAGE_CHK"                  => [   3,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "FORCE_PCI_PAR"                => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_VIRTUAL"                   => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   6,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_WRT_GEN"                  => [   7,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_SIZE"                     => [   8,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "" ],
   "REAL_TIME"                    => [   9,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [  10,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SWAP_DIRECT"                  => [  11,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "" ],
   "PREFETCH"                     => [  12,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "" ],
   "PRECISE"                      => [  13,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD3"                        => [  14,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BARRIER"                      => [  15,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "" ],
   "CTALK_ARB"                    => [  16,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Coretalk High Priority Arbitration" ],
   "DEV_SWAP"                     => [  17,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_IO_MEM"                   => [  18,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_OFF"                      => [  19,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01110_def =
( NAME    => "TIO_CP1_DEVICE_0",
  ADDRESS => 0x0000000010000200,
  NOTE    => "The Device registers contain device specific and mapping note information.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01110_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_DEVICE_1                                                     #
#                                                                        #
##########################################################################

%tio_01_01111_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_OP"                       => [   1,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_ERROR_LOCK"                => [   2,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PAGE_CHK"                  => [   3,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "FORCE_PCI_PAR"                => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_VIRTUAL"                   => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   6,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_WRT_GEN"                  => [   7,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_SIZE"                     => [   8,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "" ],
   "REAL_TIME"                    => [   9,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [  10,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SWAP_DIRECT"                  => [  11,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "" ],
   "PREFETCH"                     => [  12,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "" ],
   "PRECISE"                      => [  13,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD3"                        => [  14,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BARRIER"                      => [  15,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "" ],
   "CTALK_ARB"                    => [  16,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Coretalk High Priority Arbitration" ],
   "DEV_SWAP"                     => [  17,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_IO_MEM"                   => [  18,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_OFF"                      => [  19,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01111_def =
( NAME    => "TIO_CP1_DEVICE_1",
  ADDRESS => 0x0000000010000208,
  NOTE    => "The Device registers contain device specific and mapping note information.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01111_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_DEVICE_2                                                     #
#                                                                        #
##########################################################################

%tio_01_01112_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_OP"                       => [   1,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_ERROR_LOCK"                => [   2,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PAGE_CHK"                  => [   3,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "FORCE_PCI_PAR"                => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_VIRTUAL"                   => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   6,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_WRT_GEN"                  => [   7,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_SIZE"                     => [   8,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "" ],
   "REAL_TIME"                    => [   9,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [  10,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SWAP_DIRECT"                  => [  11,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "" ],
   "PREFETCH"                     => [  12,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "" ],
   "PRECISE"                      => [  13,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD3"                        => [  14,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BARRIER"                      => [  15,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "" ],
   "CTALK_ARB"                    => [  16,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Coretalk High Priority Arbitration" ],
   "DEV_SWAP"                     => [  17,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_IO_MEM"                   => [  18,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_OFF"                      => [  19,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01112_def =
( NAME    => "TIO_CP1_DEVICE_2",
  ADDRESS => 0x0000000010000210,
  NOTE    => "The Device registers contain device specific and mapping note information.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01112_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_DEVICE_3                                                     #
#                                                                        #
##########################################################################

%tio_01_01113_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  30,  34, 0xFFFFFFFFC0000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PIO_OP"                       => [   1,  29,   1, 0x0000000020000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_ERROR_LOCK"                => [   2,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_PAGE_CHK"                  => [   3,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "FORCE_PCI_PAR"                => [   4,  26,   1, 0x0000000004000000, 0x00, 1, 0x0000000000000000, "" ],
   "EN_VIRTUAL"                   => [   5,  25,   1, 0x0000000002000000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD1"                        => [   6,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DIR_WRT_GEN"                  => [   7,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_SIZE"                     => [   8,  22,   1, 0x0000000000400000, 0x00, 1, 0x0000000000000000, "" ],
   "REAL_TIME"                    => [   9,  21,   1, 0x0000000000200000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD2"                        => [  10,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "SWAP_DIRECT"                  => [  11,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "" ],
   "PREFETCH"                     => [  12,  18,   1, 0x0000000000040000, 0x00, 1, 0x0000000000000000, "" ],
   "PRECISE"                      => [  13,  17,   1, 0x0000000000020000, 0x00, 1, 0x0000000000000000, "" ],
   "RSVD3"                        => [  14,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BARRIER"                      => [  15,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "" ],
   "CTALK_ARB"                    => [  16,  14,   1, 0x0000000000004000, 0x00, 1, 0x0000000000000000, "Coretalk High Priority Arbitration" ],
   "DEV_SWAP"                     => [  17,  13,   1, 0x0000000000002000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_IO_MEM"                   => [  18,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "" ],
   "DEV_OFF"                      => [  19,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01113_def =
( NAME    => "TIO_CP1_DEVICE_3",
  ADDRESS => 0x0000000010000218,
  NOTE    => "The Device registers contain device specific and mapping note information.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01113_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_DEVICE_0_WRITE_FLUSH                                         #
#                                                                        #
##########################################################################

%tio_01_01114_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VERIFY_FLUSH"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Verify Flush" ],
);

%tio_01_01114_def =
( NAME    => "TIO_CP1_DEVICE_0_WRITE_FLUSH",
  ADDRESS => 0x0000000010000240,
  NOTE    => "This register will return a 0x0 after the write buffers associated note with the device have been flushed and the data has enter",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01114_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_DEVICE_1_WRITE_FLUSH                                         #
#                                                                        #
##########################################################################

%tio_01_01115_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VERIFY_FLUSH"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Verify Flush" ],
);

%tio_01_01115_def =
( NAME    => "TIO_CP1_DEVICE_1_WRITE_FLUSH",
  ADDRESS => 0x0000000010000248,
  NOTE    => "This register will return a 0x0 after the write buffers associated note with the device have been flushed and the data has enter",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01115_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_DEVICE_2_WRITE_FLUSH                                         #
#                                                                        #
##########################################################################

%tio_01_01116_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VERIFY_FLUSH"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Verify Flush" ],
);

%tio_01_01116_def =
( NAME    => "TIO_CP1_DEVICE_2_WRITE_FLUSH",
  ADDRESS => 0x0000000010000250,
  NOTE    => "This register will return a 0x0 after the write buffers associated note with the device have been flushed and the data has enter",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01116_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_DEVICE_3_WRITE_FLUSH                                         #
#                                                                        #
##########################################################################

%tio_01_01117_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VERIFY_FLUSH"                 => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 1, 0x0000000000000000, "Verify Flush" ],
);

%tio_01_01117_def =
( NAME    => "TIO_CP1_DEVICE_3_WRITE_FLUSH",
  ADDRESS => 0x0000000010000258,
  NOTE    => "This register will return a 0x0 after the write buffers associated note with the device have been flushed and the data has enter",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01117_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_EVEN_READ_RSP_BUFFER                                         #
#                                                                        #
##########################################################################

%tio_01_01118_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUFF_14_EN"                   => [   1,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_14_VDEV"                 => [   2,  29,   2, 0x0000000060000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_14_PDEV"                 => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_12_EN"                   => [   4,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_12_VDEV"                 => [   5,  25,   2, 0x0000000006000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_12_PDEV"                 => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_10_EN"                   => [   7,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_10_VDEV"                 => [   8,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_10_PDEV"                 => [   9,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_8_EN"                    => [  10,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_8_VDEV"                  => [  11,  17,   2, 0x0000000000060000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_8_PDEV"                  => [  12,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_6_EN"                    => [  13,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_6_VDEV"                  => [  14,  13,   2, 0x0000000000006000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_6_PDEV"                  => [  15,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_4_EN"                    => [  16,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_4_VDEV"                  => [  17,   9,   2, 0x0000000000000600, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_4_PDEV"                  => [  18,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_2_EN"                    => [  19,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_2_VDEV"                  => [  20,   5,   2, 0x0000000000000060, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_2_PDEV"                  => [  21,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_0_EN"                    => [  22,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_0_VDEV"                  => [  23,   1,   2, 0x0000000000000006, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_0_PDEV"                  => [  24,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01118_def =
( NAME    => "TIO_CP1_EVEN_READ_RSP_BUFFER",
  ADDRESS => 0x0000000010000280,
  NOTE    => "This register is use to allocate the read response buffers for the note even numbered devices. (0,2)",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01118_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_ODD_READ_RSP_BUFFER                                          #
#                                                                        #
##########################################################################

%tio_01_01119_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUFF_15_EN"                   => [   1,  31,   1, 0x0000000080000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_15_VDEV"                 => [   2,  29,   2, 0x0000000060000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_15_PDEV"                 => [   3,  28,   1, 0x0000000010000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_13_EN"                   => [   4,  27,   1, 0x0000000008000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_13_VDEV"                 => [   5,  25,   2, 0x0000000006000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_13_PDEV"                 => [   6,  24,   1, 0x0000000001000000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_11_EN"                   => [   7,  23,   1, 0x0000000000800000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_11_VDEV"                 => [   8,  21,   2, 0x0000000000600000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_11_PDEV"                 => [   9,  20,   1, 0x0000000000100000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_9_EN"                    => [  10,  19,   1, 0x0000000000080000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_9_VDEV"                  => [  11,  17,   2, 0x0000000000060000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_9_PDEV"                  => [  12,  16,   1, 0x0000000000010000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_7_EN"                    => [  13,  15,   1, 0x0000000000008000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_7_VDEV"                  => [  14,  13,   2, 0x0000000000006000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_7_PDEV"                  => [  15,  12,   1, 0x0000000000001000, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_5_EN"                    => [  16,  11,   1, 0x0000000000000800, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_5_VDEV"                  => [  17,   9,   2, 0x0000000000000600, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_5_PDEV"                  => [  18,   8,   1, 0x0000000000000100, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_3_EN"                    => [  19,   7,   1, 0x0000000000000080, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_3_VDEV"                  => [  20,   5,   2, 0x0000000000000060, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_3_PDEV"                  => [  21,   4,   1, 0x0000000000000010, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_1_EN"                    => [  22,   3,   1, 0x0000000000000008, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_1_VDEV"                  => [  23,   1,   2, 0x0000000000000006, 0x00, 1, 0x0000000000000000, "" ],
   "BUFF_1_PDEV"                  => [  24,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01119_def =
( NAME    => "TIO_CP1_ODD_READ_RSP_BUFFER",
  ADDRESS => 0x0000000010000288,
  NOTE    => "This register is use to allocate the read response buffers for the note odd numbered devices. (1,3))",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01119_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_READ_RSP_BUFFER_STATUS                                       #
#                                                                        #
##########################################################################

%tio_01_01120_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRB_VALID"                    => [   1,  16,  16, 0x00000000FFFF0000, 0x00, 1, 0x0000000000000000, "" ],
   "RRB_INUSE"                    => [   2,   0,  16, 0x000000000000FFFF, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01120_def =
( NAME    => "TIO_CP1_READ_RSP_BUFFER_STATUS",
  ADDRESS => 0x0000000010000290,
  NOTE    => "This read only register contains the current response buffer note status.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01120_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_READ_RSP_BUFFER_CLEAR                                        #
#                                                                        #
##########################################################################

%tio_01_01121_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RRB_CLEAR"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01121_def =
( NAME    => "TIO_CP1_READ_RSP_BUFFER_CLEAR",
  ADDRESS => 0x0000000010000298,
  NOTE    => "A write to this register clears the current contents of the buffer. note",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01121_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_0                                     #
#                                                                        #
##########################################################################

%tio_01_01122_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01122_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_0",
  ADDRESS => 0x0000000010000300,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01122_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_1                                     #
#                                                                        #
##########################################################################

%tio_01_01123_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01123_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_1",
  ADDRESS => 0x0000000010000310,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01123_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_2                                     #
#                                                                        #
##########################################################################

%tio_01_01124_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01124_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_2",
  ADDRESS => 0x0000000010000320,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01124_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_3                                     #
#                                                                        #
##########################################################################

%tio_01_01125_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01125_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_3",
  ADDRESS => 0x0000000010000330,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01125_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_4                                     #
#                                                                        #
##########################################################################

%tio_01_01126_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01126_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_4",
  ADDRESS => 0x0000000010000340,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01126_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_5                                     #
#                                                                        #
##########################################################################

%tio_01_01127_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01127_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_5",
  ADDRESS => 0x0000000010000350,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01127_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_6                                     #
#                                                                        #
##########################################################################

%tio_01_01128_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01128_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_6",
  ADDRESS => 0x0000000010000360,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01128_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_7                                     #
#                                                                        #
##########################################################################

%tio_01_01129_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01129_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_7",
  ADDRESS => 0x0000000010000370,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01129_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_8                                     #
#                                                                        #
##########################################################################

%tio_01_01130_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01130_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_8",
  ADDRESS => 0x0000000010000380,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01130_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_9                                     #
#                                                                        #
##########################################################################

%tio_01_01131_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01131_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_9",
  ADDRESS => 0x0000000010000390,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01131_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_10                                     #
#                                                                        #
##########################################################################

%tio_01_01132_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01132_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_10",
  ADDRESS => 0x00000000100003a0,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01132_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_11                                     #
#                                                                        #
##########################################################################

%tio_01_01133_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01133_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_11",
  ADDRESS => 0x00000000100003b0,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01133_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_12                                     #
#                                                                        #
##########################################################################

%tio_01_01134_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01134_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_12",
  ADDRESS => 0x00000000100003c0,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01134_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_13                                     #
#                                                                        #
##########################################################################

%tio_01_01135_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01135_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_13",
  ADDRESS => 0x00000000100003d0,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01135_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_14                                     #
#                                                                        #
##########################################################################

%tio_01_01136_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01136_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_14",
  ADDRESS => 0x00000000100003e0,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01136_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_15                                     #
#                                                                        #
##########################################################################

%tio_01_01137_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "FILLED"                       => [   1,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   2,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   3,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   4,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   5,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   6,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   7,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   8,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   9,  22,   2, 0x0000000000C00000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "UPP_ADDR"                     => [  10,   0,  22, 0x00000000003FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01137_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_15",
  ADDRESS => 0x00000000100003f0,
  NOTE    => "The PCI Bridge read response buffer upper address register is a note read only register which contains the upper 16-bits of the ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01137_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_0                                     #
#                                                                        #
##########################################################################

%tio_01_01138_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01138_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_0",
  ADDRESS => 0x0000000010000308,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01138_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_1                                     #
#                                                                        #
##########################################################################

%tio_01_01139_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01139_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_1",
  ADDRESS => 0x0000000010000318,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01139_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_2                                     #
#                                                                        #
##########################################################################

%tio_01_01140_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01140_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_2",
  ADDRESS => 0x0000000010000328,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01140_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_3                                     #
#                                                                        #
##########################################################################

%tio_01_01141_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01141_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_3",
  ADDRESS => 0x0000000010000338,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01141_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_4                                     #
#                                                                        #
##########################################################################

%tio_01_01142_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01142_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_4",
  ADDRESS => 0x0000000010000348,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01142_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_5                                     #
#                                                                        #
##########################################################################

%tio_01_01143_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01143_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_5",
  ADDRESS => 0x0000000010000358,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01143_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_6                                     #
#                                                                        #
##########################################################################

%tio_01_01144_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01144_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_6",
  ADDRESS => 0x0000000010000368,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01144_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_7                                     #
#                                                                        #
##########################################################################

%tio_01_01145_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01145_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_7",
  ADDRESS => 0x0000000010000378,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01145_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_8                                     #
#                                                                        #
##########################################################################

%tio_01_01146_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01146_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_8",
  ADDRESS => 0x0000000010000388,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01146_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_9                                     #
#                                                                        #
##########################################################################

%tio_01_01147_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01147_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_9",
  ADDRESS => 0x0000000010000398,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01147_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_10                                     #
#                                                                        #
##########################################################################

%tio_01_01148_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01148_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_10",
  ADDRESS => 0x00000000100003a8,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01148_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_11                                     #
#                                                                        #
##########################################################################

%tio_01_01149_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01149_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_11",
  ADDRESS => 0x00000000100003b8,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01149_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_12                                     #
#                                                                        #
##########################################################################

%tio_01_01150_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01150_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_12",
  ADDRESS => 0x00000000100003c8,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01150_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_13                                     #
#                                                                        #
##########################################################################

%tio_01_01151_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01151_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_13",
  ADDRESS => 0x00000000100003d8,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01151_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_14                                     #
#                                                                        #
##########################################################################

%tio_01_01152_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01152_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_14",
  ADDRESS => 0x00000000100003e8,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01152_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_15                                     #
#                                                                        #
##########################################################################

%tio_01_01153_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FILLED"                       => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ARMED"                        => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FLUSH"                        => [   2,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XERR"                         => [   3,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKTERR"                       => [   4,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TIMEOUT"                      => [   5,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PREFETCH"                     => [   6,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PRECISE"                      => [   7,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   8,  54,   2, 0x00C0000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPP_ADDR"                     => [   9,  32,  22, 0x003FFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "LOW_ADDR"                     => [  10,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01153_def =
( NAME    => "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_15",
  ADDRESS => 0x00000000100003f8,
  NOTE    => "The PCI Bridge read response buffer lower address Match register is note a read only register which contains the address and sta",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01153_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_0_FLUSH_COUNT_TOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_01154_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOUCH_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01154_def =
( NAME    => "TIO_CP1_PCI_BUFFER_0_FLUSH_COUNT_TOUCH",
  ADDRESS => 0x0000000010000400,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed after at least a single data element in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01154_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_1_FLUSH_COUNT_TOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_01155_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOUCH_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01155_def =
( NAME    => "TIO_CP1_PCI_BUFFER_1_FLUSH_COUNT_TOUCH",
  ADDRESS => 0x0000000010000440,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed after at least a single data element in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01155_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_2_FLUSH_COUNT_TOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_01156_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOUCH_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01156_def =
( NAME    => "TIO_CP1_PCI_BUFFER_2_FLUSH_COUNT_TOUCH",
  ADDRESS => 0x0000000010000480,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed after at least a single data element in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01156_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_3_FLUSH_COUNT_TOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_01157_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOUCH_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01157_def =
( NAME    => "TIO_CP1_PCI_BUFFER_3_FLUSH_COUNT_TOUCH",
  ADDRESS => 0x00000000100004c0,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed after at least a single data element in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01157_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_4_FLUSH_COUNT_TOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_01158_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOUCH_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01158_def =
( NAME    => "TIO_CP1_PCI_BUFFER_4_FLUSH_COUNT_TOUCH",
  ADDRESS => 0x0000000010000500,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed after at least a single data element in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01158_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_5_FLUSH_COUNT_TOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_01159_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOUCH_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01159_def =
( NAME    => "TIO_CP1_PCI_BUFFER_5_FLUSH_COUNT_TOUCH",
  ADDRESS => 0x0000000010000540,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed after at least a single data element in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01159_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_6_FLUSH_COUNT_TOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_01160_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOUCH_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01160_def =
( NAME    => "TIO_CP1_PCI_BUFFER_6_FLUSH_COUNT_TOUCH",
  ADDRESS => 0x0000000010000580,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed after at least a single data element in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01160_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_7_FLUSH_COUNT_TOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_01161_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TOUCH_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01161_def =
( NAME    => "TIO_CP1_PCI_BUFFER_7_FLUSH_COUNT_TOUCH",
  ADDRESS => 0x00000000100005c0,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed after at least a single data element in ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01161_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_0_FLUSH_COUNT_NOTOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_01162_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTOUCH_CNT"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01162_def =
( NAME    => "TIO_CP1_PCI_BUFFER_0_FLUSH_COUNT_NOTOUCH",
  ADDRESS => 0x0000000010000408,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed without any data element in the buffer b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01162_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_1_FLUSH_COUNT_NOTOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_01163_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTOUCH_CNT"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01163_def =
( NAME    => "TIO_CP1_PCI_BUFFER_1_FLUSH_COUNT_NOTOUCH",
  ADDRESS => 0x0000000010000448,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed without any data element in the buffer b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01163_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_2_FLUSH_COUNT_NOTOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_01164_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTOUCH_CNT"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01164_def =
( NAME    => "TIO_CP1_PCI_BUFFER_2_FLUSH_COUNT_NOTOUCH",
  ADDRESS => 0x0000000010000488,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed without any data element in the buffer b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01164_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_3_FLUSH_COUNT_NOTOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_01165_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTOUCH_CNT"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01165_def =
( NAME    => "TIO_CP1_PCI_BUFFER_3_FLUSH_COUNT_NOTOUCH",
  ADDRESS => 0x00000000100004c8,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed without any data element in the buffer b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01165_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_4_FLUSH_COUNT_NOTOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_01166_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTOUCH_CNT"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01166_def =
( NAME    => "TIO_CP1_PCI_BUFFER_4_FLUSH_COUNT_NOTOUCH",
  ADDRESS => 0x0000000010000508,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed without any data element in the buffer b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01166_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_5_FLUSH_COUNT_NOTOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_01167_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTOUCH_CNT"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01167_def =
( NAME    => "TIO_CP1_PCI_BUFFER_5_FLUSH_COUNT_NOTOUCH",
  ADDRESS => 0x0000000010000548,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed without any data element in the buffer b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01167_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_6_FLUSH_COUNT_NOTOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_01168_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTOUCH_CNT"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01168_def =
( NAME    => "TIO_CP1_PCI_BUFFER_6_FLUSH_COUNT_NOTOUCH",
  ADDRESS => 0x0000000010000588,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed without any data element in the buffer b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01168_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_7_FLUSH_COUNT_NOTOUCH                                     #
#                                                                        #
##########################################################################

%tio_01_01169_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NOTOUCH_CNT"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01169_def =
( NAME    => "TIO_CP1_PCI_BUFFER_7_FLUSH_COUNT_NOTOUCH",
  ADDRESS => 0x00000000100005c8,
  NOTE    => "This counter is incremented each time the corresponding response note buffer is flushed without any data element in the buffer b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01169_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_0_REQ_COUNT                                       #
#                                                                        #
##########################################################################

%tio_01_01170_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INFLIGHT_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01170_def =
( NAME    => "TIO_CP1_PCI_BUFFER_0_REQ_COUNT",
  ADDRESS => 0x0000000010000410,
  NOTE    => "This counter is incremented on each bus clock while the request is note in-flight. A word write to this address clears the count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01170_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_1_REQ_COUNT                                       #
#                                                                        #
##########################################################################

%tio_01_01171_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INFLIGHT_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01171_def =
( NAME    => "TIO_CP1_PCI_BUFFER_1_REQ_COUNT",
  ADDRESS => 0x0000000010000450,
  NOTE    => "This counter is incremented on each bus clock while the request is note in-flight. A word write to this address clears the count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01171_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_2_REQ_COUNT                                       #
#                                                                        #
##########################################################################

%tio_01_01172_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INFLIGHT_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01172_def =
( NAME    => "TIO_CP1_PCI_BUFFER_2_REQ_COUNT",
  ADDRESS => 0x0000000010000490,
  NOTE    => "This counter is incremented on each bus clock while the request is note in-flight. A word write to this address clears the count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01172_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_3_REQ_COUNT                                       #
#                                                                        #
##########################################################################

%tio_01_01173_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INFLIGHT_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01173_def =
( NAME    => "TIO_CP1_PCI_BUFFER_3_REQ_COUNT",
  ADDRESS => 0x00000000100004d0,
  NOTE    => "This counter is incremented on each bus clock while the request is note in-flight. A word write to this address clears the count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01173_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_4_REQ_COUNT                                       #
#                                                                        #
##########################################################################

%tio_01_01174_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INFLIGHT_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01174_def =
( NAME    => "TIO_CP1_PCI_BUFFER_4_REQ_COUNT",
  ADDRESS => 0x0000000010000510,
  NOTE    => "This counter is incremented on each bus clock while the request is note in-flight. A word write to this address clears the count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01174_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_5_REQ_COUNT                                       #
#                                                                        #
##########################################################################

%tio_01_01175_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INFLIGHT_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01175_def =
( NAME    => "TIO_CP1_PCI_BUFFER_5_REQ_COUNT",
  ADDRESS => 0x0000000010000550,
  NOTE    => "This counter is incremented on each bus clock while the request is note in-flight. A word write to this address clears the count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01175_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_6_REQ_COUNT                                       #
#                                                                        #
##########################################################################

%tio_01_01176_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INFLIGHT_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01176_def =
( NAME    => "TIO_CP1_PCI_BUFFER_6_REQ_COUNT",
  ADDRESS => 0x0000000010000590,
  NOTE    => "This counter is incremented on each bus clock while the request is note in-flight. A word write to this address clears the count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01176_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_7_REQ_COUNT                                       #
#                                                                        #
##########################################################################

%tio_01_01177_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "INFLIGHT_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01177_def =
( NAME    => "TIO_CP1_PCI_BUFFER_7_REQ_COUNT",
  ADDRESS => 0x00000000100005d0,
  NOTE    => "This counter is incremented on each bus clock while the request is note in-flight. A word write to this address clears the count",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01177_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_0_PREFETCH_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01178_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PREFETCH_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01178_def =
( NAME    => "TIO_CP1_PCI_BUFFER_0_PREFETCH_COUNT",
  ADDRESS => 0x0000000010000418,
  NOTE    => "This counter is incremented each time the request using this buffer note was generated from the prefetcher. A word write to this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01178_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_1_PREFETCH_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01179_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PREFETCH_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01179_def =
( NAME    => "TIO_CP1_PCI_BUFFER_1_PREFETCH_COUNT",
  ADDRESS => 0x0000000010000458,
  NOTE    => "This counter is incremented each time the request using this buffer note was generated from the prefetcher. A word write to this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01179_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_2_PREFETCH_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01180_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PREFETCH_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01180_def =
( NAME    => "TIO_CP1_PCI_BUFFER_2_PREFETCH_COUNT",
  ADDRESS => 0x0000000010000498,
  NOTE    => "This counter is incremented each time the request using this buffer note was generated from the prefetcher. A word write to this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01180_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_3_PREFETCH_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01181_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PREFETCH_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01181_def =
( NAME    => "TIO_CP1_PCI_BUFFER_3_PREFETCH_COUNT",
  ADDRESS => 0x00000000100004d8,
  NOTE    => "This counter is incremented each time the request using this buffer note was generated from the prefetcher. A word write to this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01181_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_4_PREFETCH_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01182_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PREFETCH_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01182_def =
( NAME    => "TIO_CP1_PCI_BUFFER_4_PREFETCH_COUNT",
  ADDRESS => 0x0000000010000518,
  NOTE    => "This counter is incremented each time the request using this buffer note was generated from the prefetcher. A word write to this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01182_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_5_PREFETCH_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01183_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PREFETCH_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01183_def =
( NAME    => "TIO_CP1_PCI_BUFFER_5_PREFETCH_COUNT",
  ADDRESS => 0x0000000010000558,
  NOTE    => "This counter is incremented each time the request using this buffer note was generated from the prefetcher. A word write to this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01183_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_6_PREFETCH_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01184_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PREFETCH_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01184_def =
( NAME    => "TIO_CP1_PCI_BUFFER_6_PREFETCH_COUNT",
  ADDRESS => 0x0000000010000598,
  NOTE    => "This counter is incremented each time the request using this buffer note was generated from the prefetcher. A word write to this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01184_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_7_PREFETCH_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01185_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PREFETCH_CNT"                 => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01185_def =
( NAME    => "TIO_CP1_PCI_BUFFER_7_PREFETCH_COUNT",
  ADDRESS => 0x00000000100005d8,
  NOTE    => "This counter is incremented each time the request using this buffer note was generated from the prefetcher. A word write to this",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01185_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_0_RETRY_TOTAL_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01186_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01186_def =
( NAME    => "TIO_CP1_PCI_BUFFER_0_RETRY_TOTAL_COUNT",
  ADDRESS => 0x0000000010000420,
  NOTE    => "This counter is incremented each time a PCI bus retry occurs and note the address matches the tag for the selected buffer. The b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01186_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_1_RETRY_TOTAL_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01187_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01187_def =
( NAME    => "TIO_CP1_PCI_BUFFER_1_RETRY_TOTAL_COUNT",
  ADDRESS => 0x0000000010000460,
  NOTE    => "This counter is incremented each time a PCI bus retry occurs and note the address matches the tag for the selected buffer. The b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01187_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_2_RETRY_TOTAL_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01188_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01188_def =
( NAME    => "TIO_CP1_PCI_BUFFER_2_RETRY_TOTAL_COUNT",
  ADDRESS => 0x00000000100004a0,
  NOTE    => "This counter is incremented each time a PCI bus retry occurs and note the address matches the tag for the selected buffer. The b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01188_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_3_RETRY_TOTAL_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01189_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01189_def =
( NAME    => "TIO_CP1_PCI_BUFFER_3_RETRY_TOTAL_COUNT",
  ADDRESS => 0x00000000100004e0,
  NOTE    => "This counter is incremented each time a PCI bus retry occurs and note the address matches the tag for the selected buffer. The b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01189_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_4_RETRY_TOTAL_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01190_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01190_def =
( NAME    => "TIO_CP1_PCI_BUFFER_4_RETRY_TOTAL_COUNT",
  ADDRESS => 0x0000000010000520,
  NOTE    => "This counter is incremented each time a PCI bus retry occurs and note the address matches the tag for the selected buffer. The b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01190_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_5_RETRY_TOTAL_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01191_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01191_def =
( NAME    => "TIO_CP1_PCI_BUFFER_5_RETRY_TOTAL_COUNT",
  ADDRESS => 0x0000000010000560,
  NOTE    => "This counter is incremented each time a PCI bus retry occurs and note the address matches the tag for the selected buffer. The b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01191_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_6_RETRY_TOTAL_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01192_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01192_def =
( NAME    => "TIO_CP1_PCI_BUFFER_6_RETRY_TOTAL_COUNT",
  ADDRESS => 0x00000000100005a0,
  NOTE    => "This counter is incremented each time a PCI bus retry occurs and note the address matches the tag for the selected buffer. The b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01192_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_7_RETRY_TOTAL_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01193_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "RETRY_CNT"                    => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01193_def =
( NAME    => "TIO_CP1_PCI_BUFFER_7_RETRY_TOTAL_COUNT",
  ADDRESS => 0x00000000100005e0,
  NOTE    => "This counter is incremented each time a PCI bus retry occurs and note the address matches the tag for the selected buffer. The b",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01193_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_0_RETRY_MAX_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01194_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_RETRY_CNT"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01194_def =
( NAME    => "TIO_CP1_PCI_BUFFER_0_RETRY_MAX_COUNT",
  ADDRESS => 0x0000000010000428,
  NOTE    => "This counter is contains the maximum retry count for a single note request which was in-flight for this buffer. A word write to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01194_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_1_RETRY_MAX_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01195_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_RETRY_CNT"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01195_def =
( NAME    => "TIO_CP1_PCI_BUFFER_1_RETRY_MAX_COUNT",
  ADDRESS => 0x0000000010000468,
  NOTE    => "This counter is contains the maximum retry count for a single note request which was in-flight for this buffer. A word write to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01195_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_2_RETRY_MAX_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01196_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_RETRY_CNT"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01196_def =
( NAME    => "TIO_CP1_PCI_BUFFER_2_RETRY_MAX_COUNT",
  ADDRESS => 0x00000000100004a8,
  NOTE    => "This counter is contains the maximum retry count for a single note request which was in-flight for this buffer. A word write to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01196_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_3_RETRY_MAX_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01197_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_RETRY_CNT"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01197_def =
( NAME    => "TIO_CP1_PCI_BUFFER_3_RETRY_MAX_COUNT",
  ADDRESS => 0x00000000100004e8,
  NOTE    => "This counter is contains the maximum retry count for a single note request which was in-flight for this buffer. A word write to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01197_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_4_RETRY_MAX_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01198_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_RETRY_CNT"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01198_def =
( NAME    => "TIO_CP1_PCI_BUFFER_4_RETRY_MAX_COUNT",
  ADDRESS => 0x0000000010000528,
  NOTE    => "This counter is contains the maximum retry count for a single note request which was in-flight for this buffer. A word write to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01198_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_5_RETRY_MAX_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01199_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_RETRY_CNT"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01199_def =
( NAME    => "TIO_CP1_PCI_BUFFER_5_RETRY_MAX_COUNT",
  ADDRESS => 0x0000000010000568,
  NOTE    => "This counter is contains the maximum retry count for a single note request which was in-flight for this buffer. A word write to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01199_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_6_RETRY_MAX_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01200_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_RETRY_CNT"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01200_def =
( NAME    => "TIO_CP1_PCI_BUFFER_6_RETRY_MAX_COUNT",
  ADDRESS => 0x00000000100005a8,
  NOTE    => "This counter is contains the maximum retry count for a single note request which was in-flight for this buffer. A word write to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01200_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_7_RETRY_MAX_COUNT                                     #
#                                                                        #
##########################################################################

%tio_01_01201_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_RETRY_CNT"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01201_def =
( NAME    => "TIO_CP1_PCI_BUFFER_7_RETRY_MAX_COUNT",
  ADDRESS => 0x00000000100005e8,
  NOTE    => "This counter is contains the maximum retry count for a single note request which was in-flight for this buffer. A word write to ",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01201_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_0_MAX_LATENCY                                     #
#                                                                        #
##########################################################################

%tio_01_01202_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_LATENCY_CNT"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01202_def =
( NAME    => "TIO_CP1_PCI_BUFFER_0_MAX_LATENCY",
  ADDRESS => 0x0000000010000430,
  NOTE    => "This counter is contains the maximum count (in bus clocks) for a note single request which was in-flight for this buffer. A word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01202_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_1_MAX_LATENCY                                     #
#                                                                        #
##########################################################################

%tio_01_01203_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_LATENCY_CNT"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01203_def =
( NAME    => "TIO_CP1_PCI_BUFFER_1_MAX_LATENCY",
  ADDRESS => 0x0000000010000470,
  NOTE    => "This counter is contains the maximum count (in bus clocks) for a note single request which was in-flight for this buffer. A word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01203_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_2_MAX_LATENCY                                     #
#                                                                        #
##########################################################################

%tio_01_01204_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_LATENCY_CNT"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01204_def =
( NAME    => "TIO_CP1_PCI_BUFFER_2_MAX_LATENCY",
  ADDRESS => 0x00000000100004b0,
  NOTE    => "This counter is contains the maximum count (in bus clocks) for a note single request which was in-flight for this buffer. A word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01204_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_3_MAX_LATENCY                                     #
#                                                                        #
##########################################################################

%tio_01_01205_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_LATENCY_CNT"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01205_def =
( NAME    => "TIO_CP1_PCI_BUFFER_3_MAX_LATENCY",
  ADDRESS => 0x00000000100004f0,
  NOTE    => "This counter is contains the maximum count (in bus clocks) for a note single request which was in-flight for this buffer. A word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01205_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_4_MAX_LATENCY                                     #
#                                                                        #
##########################################################################

%tio_01_01206_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_LATENCY_CNT"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01206_def =
( NAME    => "TIO_CP1_PCI_BUFFER_4_MAX_LATENCY",
  ADDRESS => 0x0000000010000530,
  NOTE    => "This counter is contains the maximum count (in bus clocks) for a note single request which was in-flight for this buffer. A word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01206_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_5_MAX_LATENCY                                     #
#                                                                        #
##########################################################################

%tio_01_01207_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_LATENCY_CNT"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01207_def =
( NAME    => "TIO_CP1_PCI_BUFFER_5_MAX_LATENCY",
  ADDRESS => 0x0000000010000570,
  NOTE    => "This counter is contains the maximum count (in bus clocks) for a note single request which was in-flight for this buffer. A word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01207_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_6_MAX_LATENCY                                     #
#                                                                        #
##########################################################################

%tio_01_01208_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_LATENCY_CNT"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01208_def =
( NAME    => "TIO_CP1_PCI_BUFFER_6_MAX_LATENCY",
  ADDRESS => 0x00000000100005b0,
  NOTE    => "This counter is contains the maximum count (in bus clocks) for a note single request which was in-flight for this buffer. A word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01208_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_7_MAX_LATENCY                                     #
#                                                                        #
##########################################################################

%tio_01_01209_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  16,  48, 0xFFFFFFFFFFFF0000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "MAX_LATENCY_CNT"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01209_def =
( NAME    => "TIO_CP1_PCI_BUFFER_7_MAX_LATENCY",
  ADDRESS => 0x00000000100005f0,
  NOTE    => "This counter is contains the maximum count (in bus clocks) for a note single request which was in-flight for this buffer. A word",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01209_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_0_CLEAR                                           #
#                                                                        #
##########################################################################

%tio_01_01210_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Clear Buffer Registers" ],
);

%tio_01_01210_def =
( NAME    => "TIO_CP1_PCI_BUFFER_0_CLEAR",
  ADDRESS => 0x0000000010000438,
  NOTE    => "Any access to this register clears all the count values for the (x) note registers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01210_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_1_CLEAR                                           #
#                                                                        #
##########################################################################

%tio_01_01211_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Clear Buffer Registers" ],
);

%tio_01_01211_def =
( NAME    => "TIO_CP1_PCI_BUFFER_1_CLEAR",
  ADDRESS => 0x0000000010000478,
  NOTE    => "Any access to this register clears all the count values for the (x) note registers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01211_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_2_CLEAR                                           #
#                                                                        #
##########################################################################

%tio_01_01212_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Clear Buffer Registers" ],
);

%tio_01_01212_def =
( NAME    => "TIO_CP1_PCI_BUFFER_2_CLEAR",
  ADDRESS => 0x00000000100004b8,
  NOTE    => "Any access to this register clears all the count values for the (x) note registers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01212_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_3_CLEAR                                           #
#                                                                        #
##########################################################################

%tio_01_01213_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Clear Buffer Registers" ],
);

%tio_01_01213_def =
( NAME    => "TIO_CP1_PCI_BUFFER_3_CLEAR",
  ADDRESS => 0x00000000100004f8,
  NOTE    => "Any access to this register clears all the count values for the (x) note registers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01213_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_4_CLEAR                                           #
#                                                                        #
##########################################################################

%tio_01_01214_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Clear Buffer Registers" ],
);

%tio_01_01214_def =
( NAME    => "TIO_CP1_PCI_BUFFER_4_CLEAR",
  ADDRESS => 0x0000000010000538,
  NOTE    => "Any access to this register clears all the count values for the (x) note registers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01214_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_5_CLEAR                                           #
#                                                                        #
##########################################################################

%tio_01_01215_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Clear Buffer Registers" ],
);

%tio_01_01215_def =
( NAME    => "TIO_CP1_PCI_BUFFER_5_CLEAR",
  ADDRESS => 0x0000000010000578,
  NOTE    => "Any access to this register clears all the count values for the (x) note registers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01215_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_6_CLEAR                                           #
#                                                                        #
##########################################################################

%tio_01_01216_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Clear Buffer Registers" ],
);

%tio_01_01216_def =
( NAME    => "TIO_CP1_PCI_BUFFER_6_CLEAR",
  ADDRESS => 0x00000000100005b8,
  NOTE    => "Any access to this register clears all the count values for the (x) note registers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01216_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUFFER_7_CLEAR                                           #
#                                                                        #
##########################################################################

%tio_01_01217_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CLEAR"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "Clear Buffer Registers" ],
);

%tio_01_01217_def =
( NAME    => "TIO_CP1_PCI_BUFFER_7_CLEAR",
  ADDRESS => 0x00000000100005f8,
  NOTE    => "Any access to this register clears all the count values for the (x) note registers.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01217_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUS_ERROR_ADDRESS                                        #
#                                                                        #
##########################################################################

%tio_01_01218_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PCIX_ERR_ADDR"                => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01218_def =
( NAME    => "TIO_CP1_PCI_BUS_ERROR_ADDRESS",
  ADDRESS => 0x0000000010000600,
  NOTE    => "This register contains the address on the PCI-X bus when an error note occurred.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01218_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUS_ERROR_ATTRIBUTE                                      #
#                                                                        #
##########################################################################

%tio_01_01219_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  49,  15, 0xFFFE000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "DAC"                          => [   1,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "BUS_CMD"                      => [   2,  44,   4, 0x0000F00000000000, 0x00, 0, 0x0000000000000000, "" ],
   "BYTE_CNT"                     => [   3,  32,  12, 0x00000FFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   4,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NS"                           => [   5,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "RO"                           => [   6,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "TAG"                          => [   7,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "" ],
   "BUS_NUM"                      => [   8,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "DEV_NUM"                      => [   9,  11,   5, 0x000000000000F800, 0x00, 0, 0x0000000000000000, "" ],
   "FUN_NUM"                      => [  10,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "L_BYTE_CNT"                   => [  11,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01219_def =
( NAME    => "TIO_CP1_PCI_BUS_ERROR_ATTRIBUTE",
  ADDRESS => 0x0000000010000608,
  NOTE    => "This register contains the attribute data on the PCI-X bus when an note error occurred. Note that the bit definitions in the reg",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01219_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCI_BUS_ERROR_DATA                                           #
#                                                                        #
##########################################################################

%tio_01_01220_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PCIX_ERR_DATA"                => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01220_def =
( NAME    => "TIO_CP1_PCI_BUS_ERROR_DATA",
  ADDRESS => 0x0000000010000610,
  NOTE    => "This register contains the Data on the PCI-X bus when an error note occurred.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01220_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_SPLIT_REQUEST_ADDRESS                                        #
#                                                                        #
##########################################################################

%tio_01_01221_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "PCIX_ERR_ADDR"                => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01221_def =
( NAME    => "TIO_CP1_SPLIT_REQUEST_ADDRESS",
  ADDRESS => 0x0000000010000618,
  NOTE    => "This register contains the address data on the PCI-X bus during the note request from a pio split transaction",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01221_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_SPLIT_REQUEST_ATTRIBUTE                                      #
#                                                                        #
##########################################################################

%tio_01_01222_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  36,  28, 0xFFFFFFF000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "BUSCMD"                       => [   1,  32,   4, 0x0000000F00000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   2,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NS"                           => [   3,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "RO"                           => [   4,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "TAG"                          => [   5,  24,   5, 0x000000001F000000, 0x00, 0, 0x0000000000000000, "" ],
   "BUS_NUM"                      => [   6,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "DEV_NUM"                      => [   7,  11,   5, 0x000000000000F800, 0x00, 0, 0x0000000000000000, "" ],
   "FUN_NUM"                      => [   8,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "LOWER_BYTE_CNT"               => [   9,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01222_def =
( NAME    => "TIO_CP1_SPLIT_REQUEST_ATTRIBUTE",
  ADDRESS => 0x0000000010000620,
  NOTE    => "This register contains the attribute data on the PCI-X bus during note the request from a pio split transaction. Note: Because a",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01222_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_DMA_ERROR_ATTRIBUTE                                          #
#                                                                        #
##########################################################################

%tio_01_01223_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  53,  11, 0xFFE0000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "XDMA_ERR_EVT_CODE"            => [   1,  49,   4, 0x001E000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_OP_INDEX"            => [   2,  45,   4, 0x0001E00000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_CL_INDEX"            => [   3,  39,   6, 0x00001F8000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_NS"                  => [   4,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_DEV_NUM_L"           => [   5,  36,   2, 0x0000003000000000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_D64"                 => [   6,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_RD_IS_DW"            => [   7,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_BYTE_CNT"            => [   8,  22,  12, 0x00000003FFC00000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_RO"                  => [   9,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_TAG"                 => [  10,  16,   5, 0x00000000001F0000, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_BUS_NUM"             => [  11,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_DEV_NUM"             => [  12,   3,   5, 0x00000000000000F8, 0x00, 0, 0x0000000000000000, "" ],
   "XDMA_ERR_FUN_NUM"             => [  13,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01223_def =
( NAME    => "TIO_CP1_DMA_ERROR_ATTRIBUTE",
  ADDRESS => 0x0000000010000628,
  NOTE    => "This register contains attribute and other information from the note PCI-X bus DMA read transaction for which this error is asso",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01223_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_DMA_ERROR_ADDRESS                                            #
#                                                                        #
##########################################################################

%tio_01_01224_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "XDMA_ERR_ADDR"                => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01224_def =
( NAME    => "TIO_CP1_DMA_ERROR_ADDRESS",
  ADDRESS => 0x0000000010000630,
  NOTE    => "This register contains the address from the PCI-X bus DMA read note transaction for which this error is associated.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01224_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_PCIX_TIMEOUT                                                 #
#                                                                        #
##########################################################################

%tio_01_01225_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  24,  40, 0xFFFFFFFFFF000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "TIME_OUT"                     => [   1,   0,  24, 0x0000000000FFFFFF, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01225_def =
( NAME    => "TIO_CP1_PCIX_TIMEOUT",
  ADDRESS => 0x0000000010000638,
  NOTE    => "This contains the reload value for the timeout counter based on the note current bus speed.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01225_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_CT_DEBUG_CTL                                                 #
#                                                                        #
##########################################################################

%tio_01_01226_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_NIB_SEL"                 => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_PORT_SEL"                => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_NIB_SEL"                 => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_PORT_SEL"                => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_NIB_SEL"                 => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_PORT_SEL"                => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_NIB_SEL"                 => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_PORT_SEL"                => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_NIB_SEL"                 => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_PORT_SEL"                => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_NIB_SEL"                 => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_PORT_SEL"                => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_NIB_SEL"                 => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_PORT_SEL"                => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_NIB_SEL"                 => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_PORT_SEL"                => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_01226_def =
( NAME    => "TIO_CP1_CT_DEBUG_CTL",
  ADDRESS => 0x0000000010000700,
  NOTE    => "This register controls the first-level debug mux located in the note Coretalk clock domain.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01226_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_BR_DEBUG_CTL                                                 #
#                                                                        #
##########################################################################

%tio_01_01227_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  31,  33, 0xFFFFFFFF80000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_PORT_SEL"                => [   1,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD1"                        => [   2,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_PORT_SEL"                => [   3,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD2"                        => [   4,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_PORT_SEL"                => [   5,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD3"                        => [   6,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_PORT_SEL"                => [   7,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD4"                        => [   8,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_PORT_SEL"                => [   9,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD5"                        => [  10,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_PORT_SEL"                => [  11,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD6"                        => [  12,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_PORT_SEL"                => [  13,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD7"                        => [  14,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_PORT_SEL"                => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_01227_def =
( NAME    => "TIO_CP1_BR_DEBUG_CTL",
  ADDRESS => 0x0000000010000708,
  NOTE    => "This register controls the final-level debug mux located in the PCI note clock domain.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01227_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_MUX3_DEBUG_CTL                                               #
#                                                                        #
##########################################################################

%tio_01_01228_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_NIB_SEL"                 => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_PORT_SEL"                => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_NIB_SEL"                 => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_PORT_SEL"                => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_NIB_SEL"                 => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_PORT_SEL"                => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_NIB_SEL"                 => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_PORT_SEL"                => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_NIB_SEL"                 => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_PORT_SEL"                => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_NIB_SEL"                 => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_PORT_SEL"                => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_NIB_SEL"                 => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_PORT_SEL"                => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_NIB_SEL"                 => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_PORT_SEL"                => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_01228_def =
( NAME    => "TIO_CP1_MUX3_DEBUG_CTL",
  ADDRESS => 0x0000000010000710,
  NOTE    => "This register controls first-level debug mux number 3 located in note the PCI clock domain.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01228_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_MUX4_DEBUG_CTL                                               #
#                                                                        #
##########################################################################

%tio_01_01229_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_NIB_SEL"                 => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_PORT_SEL"                => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_NIB_SEL"                 => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_PORT_SEL"                => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_NIB_SEL"                 => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_PORT_SEL"                => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_NIB_SEL"                 => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_PORT_SEL"                => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_NIB_SEL"                 => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_PORT_SEL"                => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_NIB_SEL"                 => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_PORT_SEL"                => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_NIB_SEL"                 => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_PORT_SEL"                => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_NIB_SEL"                 => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_PORT_SEL"                => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_01229_def =
( NAME    => "TIO_CP1_MUX4_DEBUG_CTL",
  ADDRESS => 0x0000000010000718,
  NOTE    => "This register controls first-level debug mux number 4 located in note the PCI clock domain.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01229_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_MUX5_DEBUG_CTL                                               #
#                                                                        #
##########################################################################

%tio_01_01230_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_NIB_SEL"                 => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_PORT_SEL"                => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_NIB_SEL"                 => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_PORT_SEL"                => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_NIB_SEL"                 => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_PORT_SEL"                => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_NIB_SEL"                 => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_PORT_SEL"                => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_NIB_SEL"                 => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_PORT_SEL"                => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_NIB_SEL"                 => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_PORT_SEL"                => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_NIB_SEL"                 => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_PORT_SEL"                => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_NIB_SEL"                 => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_PORT_SEL"                => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_01230_def =
( NAME    => "TIO_CP1_MUX5_DEBUG_CTL",
  ADDRESS => 0x0000000010000720,
  NOTE    => "This register controls first-level debug mux number 5 located in note the PCI clock domain.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01230_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_MUX6_DEBUG_CTL                                               #
#                                                                        #
##########################################################################

%tio_01_01231_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_NIB_SEL"                 => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_PORT_SEL"                => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_NIB_SEL"                 => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_PORT_SEL"                => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_NIB_SEL"                 => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_PORT_SEL"                => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_NIB_SEL"                 => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_PORT_SEL"                => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_NIB_SEL"                 => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_PORT_SEL"                => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_NIB_SEL"                 => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_PORT_SEL"                => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_NIB_SEL"                 => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_PORT_SEL"                => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_NIB_SEL"                 => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_PORT_SEL"                => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_01231_def =
( NAME    => "TIO_CP1_MUX6_DEBUG_CTL",
  ADDRESS => 0x0000000010000728,
  NOTE    => "This register controls first-level debug mux number 6 located in note the PCI clock domain.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01231_flds
);


##########################################################################
#                                                                        #
#   TIO_CP1_MUX7_DEBUG_CTL                                               #
#                                                                        #
##########################################################################

%tio_01_01232_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSVD0"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_NIB_SEL"                 => [   1,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Nibble Select" ],
   "RSVD1"                        => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB7_PORT_SEL"                => [   3,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "Nibble 7 Port Select" ],
   "RSVD2"                        => [   4,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_NIB_SEL"                 => [   5,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Nibble Select" ],
   "RSVD3"                        => [   6,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB6_PORT_SEL"                => [   7,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "Nibble 6 Port Select" ],
   "RSVD4"                        => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_NIB_SEL"                 => [   9,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Nibble Select" ],
   "RSVD5"                        => [  10,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB5_PORT_SEL"                => [  11,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "Nibble 5 Port Select" ],
   "RSVD6"                        => [  12,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_NIB_SEL"                 => [  13,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Nibble Select" ],
   "RSVD7"                        => [  14,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB4_PORT_SEL"                => [  15,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "Nibble 4 Port Select" ],
   "RSVD8"                        => [  16,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_NIB_SEL"                 => [  17,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Nibble Select" ],
   "RSVD9"                        => [  18,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB3_PORT_SEL"                => [  19,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "Nibble 3 Port Select" ],
   "RSVD10"                       => [  20,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_NIB_SEL"                 => [  21,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "Nibble 2 Nibble Select" ],
   "RSVD11"                       => [  22,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB2_PORT_SEL"                => [  23,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "Nibble 2 Port Select" ],
   "RSVD12"                       => [  24,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_NIB_SEL"                 => [  25,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "Nibble 1 Nibble Select" ],
   "RSVD13"                       => [  26,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB1_PORT_SEL"                => [  27,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "Nibble 1 Port Select" ],
   "RSVD14"                       => [  28,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_NIB_SEL"                 => [  29,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "Nibble 0 Nibble Select" ],
   "RSVD15"                       => [  30,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "Reserved" ],
   "NIB0_PORT_SEL"                => [  31,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "Nibble 0 Port Select" ],
);

%tio_01_01232_def =
( NAME    => "TIO_CP1_MUX7_DEBUG_CTL",
  ADDRESS => 0x0000000010000730,
  NOTE    => "This register controls first-level debug mux number 7 located in note the PCI clock domain.",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01232_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_CE_ID                                                    #
#                                                                        #
##########################################################################

%tio_01_01233_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "REV_NUM"                      => [   0,  28,   8, 0x0000000FF0000000, 0x00, 0, 0x0000000000000000, "" ],
   "PART_NUM"                     => [   1,  12,  16, 0x000000000FFFF000, 0x00, 0, 0x0000000000000000, "" ],
   "SRC_ID"                       => [   2,   1,  11, 0x0000000000000FFE, 0x00, 0, 0x0000000000000000, "" ],
   "ONE"                          => [   3,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01233_def =
( NAME    => "XCE_ADM_CE_ID",
  ADDRESS => 0x30000000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01233_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_DYN_CREDIT_STATUS                                        #
#                                                                        #
##########################################################################

%tio_01_01234_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DTL2_BAP_CREDITS_RCVD"        => [   0,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_BAP_CREDITS_RCVD"        => [   1,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "CXM_RSP_CREDITS_RCVD"         => [   2,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "CXM_REQ_CREDITS_RCVD"         => [   3,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_REQ_CREDIT_SENT"          => [   4,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "URE_MSG_CREDITS_SENT"         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01234_def =
( NAME    => "XCE_ADM_DYN_CREDIT_STATUS",
  ADDRESS => 0x30000010,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01234_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_LAST_CREDIT_STATUS                                       #
#                                                                        #
##########################################################################

%tio_01_01235_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DTL2_BAP_CREDITS_RCVD"        => [   0,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_BAP_CREDITS_RCVD"        => [   1,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "CXM_RSP_CREDITS_RCVD"         => [   2,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "CXM_REQ_CREDITS_RCVD"         => [   3,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_REQ_CREDITS_SENT"         => [   4,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "URE_MSG_CREDITS_SENT"         => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01235_def =
( NAME    => "XCE_ADM_LAST_CREDIT_STATUS",
  ADDRESS => 0x30000018,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01235_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_CREDIT_LIMIT                                             #
#                                                                        #
##########################################################################

%tio_01_01236_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DTL2_CREDIT_RCVD_LIMIT"       => [   0,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_CREDIT_RCVD_LIMIT"       => [   1,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "" ],
   "CXM_RSP_CREDIT_RCVD_LIMIT"    => [   2,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "CXM_REQ_CREDIT_RCVD_LIMIT"    => [   3,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_CREDIT_SEND_LIMIT"        => [   4,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "URE_CREDIT_SEND_LIMIT"        => [   5,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01236_def =
( NAME    => "XCE_ADM_CREDIT_LIMIT",
  ADDRESS => 0x30000020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01236_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_FORCE_CREDIT                                             #
#                                                                        #
##########################################################################

%tio_01_01237_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "URE_FORCE_CREDIT"             => [   0,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_FORCE_CREDIT"             => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01237_def =
( NAME    => "XCE_ADM_FORCE_CREDIT",
  ADDRESS => 0x30000028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01237_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_CONTROL                                                  #
#                                                                        #
##########################################################################

%tio_01_01238_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PCIE_HST_BRG_ACC_EN"          => [   0,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "BAP_BUF_PAR_DISABLE"          => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "MSG_BUF_PAR_DISABLE"          => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01238_def =
( NAME    => "XCE_ADM_CONTROL",
  ADDRESS => 0x30000030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01238_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_MMR_CHN_TIMEOUT_CTRL                                     #
#                                                                        #
##########################################################################

%tio_01_01239_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MMR_CHN_TIMEOUT_PERIOD"       => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01239_def =
( NAME    => "XCE_ADM_MMR_CHN_TIMEOUT_CTRL",
  ADDRESS => 0x30000038,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01239_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_SSP_URE_TIMEOUT_CTRL                                     #
#                                                                        #
##########################################################################

%tio_01_01240_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "URE_SSP_TIMEOUT_PERIOD"       => [   0,  24,  13, 0x0000001FFF000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_SSP_TIMEOUT_PRESCALE"     => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01240_def =
( NAME    => "XCE_ADM_SSP_URE_TIMEOUT_CTRL",
  ADDRESS => 0x30000040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01240_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_SSP_DRE_TIMEOUT_CTRL                                     #
#                                                                        #
##########################################################################

%tio_01_01241_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DRE_SSP_TIMEOUT_PERIOD"       => [   0,  24,  13, 0x0000001FFF000000, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_SSP_TIMEOUT_PRESCALE"     => [   1,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01241_def =
( NAME    => "XCE_ADM_SSP_DRE_TIMEOUT_CTRL",
  ADDRESS => 0x30000048,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01241_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_SSP_DEBUG_SEL                                            #
#                                                                        #
##########################################################################

%tio_01_01242_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_NIB7_SEL"               => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT7_SEL"              => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB6_SEL"               => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT6_SEL"              => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB5_SEL"               => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT5_SEL"              => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB4_SEL"               => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT4_SEL"              => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB3_SEL"               => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT3_SEL"              => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB2_SEL"               => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT2_SEL"              => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB1_SEL"               => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT1_SEL"              => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB0_SEL"               => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT0_SEL"              => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01242_def =
( NAME    => "XCE_ADM_SSP_DEBUG_SEL",
  ADDRESS => 0x30000050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01242_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_STATUS                                               #
#                                                                        #
##########################################################################

%tio_01_01243_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PORT2_PM_PME_MSG"             => [   0,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_PM_PME_MSG"             => [   1,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_MSG_SLOT_PERR"           => [   2,  18,   4, 0x00000000003C0000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_MSG_SLOT_3"              => [   3,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_MSG_SLOT_2"              => [   4,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_MSG_SLOT_1"              => [   5,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_MSG_SLOT_0"              => [   6,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT2_DEV_D"             => [   7,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT2_DEV_C"             => [   8,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT2_DEV_B"             => [   9,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT2_DEV_A"             => [  10,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT1_DEV_D"             => [  11,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT1_DEV_C"             => [  12,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT1_DEV_B"             => [  13,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT1_DEV_A"             => [  14,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "PORT2_HOTPLUG_EVENT"          => [  15,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_HOTPLUG_EVENT"          => [  16,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_ERROR"                   => [  17,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "LSI2_IP_ERROR"                => [  18,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "LSI1_IP_ERROR"                => [  19,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "CE_ERROR"                     => [  20,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01243_def =
( NAME    => "XCE_ADM_INT_STATUS",
  ADDRESS => 0x30000058,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01243_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_STATUS_ALIAS                                         #
#                                                                        #
##########################################################################

%tio_01_01244_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
);

%tio_01_01244_def =
( NAME    => "XCE_ADM_INT_STATUS_ALIAS",
  ADDRESS => 0x30000060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01244_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_MASK                                                 #
#                                                                        #
##########################################################################

%tio_01_01245_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PORT2_PM_PME_MSG"             => [   0,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_PM_PME_MSG"             => [   1,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_MSG"                     => [   2,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT2_DEV_D"             => [   3,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT2_DEV_C"             => [   4,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT2_DEV_B"             => [   5,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT2_DEV_A"             => [   6,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT1_DEV_D"             => [   7,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT1_DEV_C"             => [   8,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT1_DEV_B"             => [   9,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT1_DEV_A"             => [  10,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "PORT2_HOTPLUG_EVENT"          => [  11,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_HOTPLUG_EVENT"          => [  12,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_ERROR"                   => [  13,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "LSI2_IP_ERROR"                => [  14,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "LSI1_IP_ERROR"                => [  15,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "CE_ERROR"                     => [  16,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01245_def =
( NAME    => "XCE_ADM_INT_MASK",
  ADDRESS => 0x30000068,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01245_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_PENDING                                              #
#                                                                        #
##########################################################################

%tio_01_01246_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PORT2_PM_PME_MSG"             => [   0,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_PM_PME_MSG"             => [   1,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_MSG"                     => [   2,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT2_DEV_D"             => [   3,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT2_DEV_C"             => [   4,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT2_DEV_B"             => [   5,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT2_DEV_A"             => [   6,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT1_DEV_D"             => [   7,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT1_DEV_C"             => [   8,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT1_DEV_B"             => [   9,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_PORT1_DEV_A"             => [  10,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "PORT2_HOTPLUG_EVENT"          => [  11,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_HOTPLUG_EVENT"          => [  12,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_ERROR"                   => [  13,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "LSI2_INT"                     => [  14,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "LSI1_INT"                     => [  15,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "CE_ERROR"                     => [  16,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01246_def =
( NAME    => "XCE_ADM_INT_PENDING",
  ADDRESS => 0x30000070,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01246_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_FORCE_INT                                                #
#                                                                        #
##########################################################################

%tio_01_01247_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FRC_ALWS_PCIE_PORT_DEV_INT"   => [   0,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_PCIE_PORT2_DEV_D_INT"     => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_PCIE_PORT2_DEV_C_INT"     => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_PCIE_PORT2_DEV_B_INT"     => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_PCIE_PORT2_DEV_A_INT"     => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_PCIE_PORT1_DEV_D_INT"     => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_PCIE_PORT1_DEV_C_INT"     => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_PCIE_PORT1_DEV_B_INT"     => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_PCIE_PORT1_DEV_A_INT"     => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01247_def =
( NAME    => "XCE_ADM_FORCE_INT",
  ADDRESS => 0x30000078,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01247_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_URE_UPS_BUF_BARRIER_FLUSH_SEL                                     #
#                                                                        #
##########################################################################

%tio_01_01248_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PORT2_BUFFER3"                => [   0,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT2_BUFFER2"                => [   1,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT2_BUFFER1"                => [   2,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT2_BUFFER0"                => [   3,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_BUFFER3"                => [   4,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_BUFFER2"                => [   5,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_BUFFER1"                => [   6,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_BUFFER0"                => [   7,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01248_def =
( NAME    => "XCE_ADM_URE_UPS_BUF_BARRIER_FLUSH_SEL",
  ADDRESS => 0x30000080,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01248_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_DEST_0                                               #
#                                                                        #
##########################################################################

%tio_01_01249_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_VECT"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_ADDR"                     => [   1,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01249_def =
( NAME    => "XCE_ADM_INT_DEST_0",
  ADDRESS => 0x30000088,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01249_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_DEST_1                                               #
#                                                                        #
##########################################################################

%tio_01_01250_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_VECT"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_ADDR"                     => [   1,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01250_def =
( NAME    => "XCE_ADM_INT_DEST_1",
  ADDRESS => 0x30000090,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01250_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_DEST_2                                               #
#                                                                        #
##########################################################################

%tio_01_01251_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_VECT"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_ADDR"                     => [   1,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01251_def =
( NAME    => "XCE_ADM_INT_DEST_2",
  ADDRESS => 0x30000098,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01251_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_DEST_3                                               #
#                                                                        #
##########################################################################

%tio_01_01252_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_VECT"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_ADDR"                     => [   1,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01252_def =
( NAME    => "XCE_ADM_INT_DEST_3",
  ADDRESS => 0x300000A0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01252_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_DEST_4                                               #
#                                                                        #
##########################################################################

%tio_01_01253_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_VECT"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_ADDR"                     => [   1,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01253_def =
( NAME    => "XCE_ADM_INT_DEST_4",
  ADDRESS => 0x300000A8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01253_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_DEST_5                                               #
#                                                                        #
##########################################################################

%tio_01_01254_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_VECT"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_ADDR"                     => [   1,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01254_def =
( NAME    => "XCE_ADM_INT_DEST_5",
  ADDRESS => 0x300000B0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01254_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_DEST_6                                               #
#                                                                        #
##########################################################################

%tio_01_01255_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_VECT"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_ADDR"                     => [   1,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01255_def =
( NAME    => "XCE_ADM_INT_DEST_6",
  ADDRESS => 0x300000B8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01255_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_DEST_7                                               #
#                                                                        #
##########################################################################

%tio_01_01256_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_VECT"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_ADDR"                     => [   1,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01256_def =
( NAME    => "XCE_ADM_INT_DEST_7",
  ADDRESS => 0x300000C0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01256_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_DEST_8                                               #
#                                                                        #
##########################################################################

%tio_01_01257_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_VECT"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_ADDR"                     => [   1,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01257_def =
( NAME    => "XCE_ADM_INT_DEST_8",
  ADDRESS => 0x300000C8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01257_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_DEST_9                                               #
#                                                                        #
##########################################################################

%tio_01_01258_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_VECT"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_ADDR"                     => [   1,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01258_def =
( NAME    => "XCE_ADM_INT_DEST_9",
  ADDRESS => 0x300000D0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01258_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_DEST_10                                              #
#                                                                        #
##########################################################################

%tio_01_01259_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_VECT"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_ADDR"                     => [   1,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01259_def =
( NAME    => "XCE_ADM_INT_DEST_10",
  ADDRESS => 0x300000D8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01259_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_DEST_11                                              #
#                                                                        #
##########################################################################

%tio_01_01260_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_VECT"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_ADDR"                     => [   1,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01260_def =
( NAME    => "XCE_ADM_INT_DEST_11",
  ADDRESS => 0x300000E0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01260_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_DEST_12                                              #
#                                                                        #
##########################################################################

%tio_01_01261_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_VECT"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_ADDR"                     => [   1,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01261_def =
( NAME    => "XCE_ADM_INT_DEST_12",
  ADDRESS => 0x300000E8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01261_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_DEST_13                                              #
#                                                                        #
##########################################################################

%tio_01_01262_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_VECT"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_ADDR"                     => [   1,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01262_def =
( NAME    => "XCE_ADM_INT_DEST_13",
  ADDRESS => 0x300000F0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01262_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_INT_DEST_14                                              #
#                                                                        #
##########################################################################

%tio_01_01263_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_VECT"                     => [   0,  56,   8, 0xFF00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "INT_ADDR"                     => [   1,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01263_def =
( NAME    => "XCE_ADM_INT_DEST_14",
  ADDRESS => 0x300000F8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01263_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_ERROR_SUMMARY                                            #
#                                                                        #
##########################################################################

%tio_01_01264_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PORT2_PCIE_FAT_ERR"           => [   0,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT2_PCIE_NFAT_ERR"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT2_PCIE_COR_ERR"           => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_PCIE_FAT_ERR"           => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_PCIE_NFAT_ERR"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_PCIE_COR_ERR"           => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_POSTED_D_CRED_MAX_ERR"   => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_POSTED_HD_CRED_MAX_ERR"  => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_NPOSTED_D_CRED_MAX_ERR"  => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_NPOSTED_HD_CRED_MAX_ERR" => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_COMP_D_CRED_MAX_ERR"     => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_COMP_HD_CRED_MAX_ERR"    => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_INF_NPOSTED_CRED_UPDT_ERR" => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_INF_POSTED_CRED_UPDT_ERR" => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_INF_COMPL_CRED_UPDT_ERR" => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_MIN_PDATA_CREDIT_ERR"    => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_POSTED_D_CRED_MAX_ERR"   => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_POSTED_HD_CRED_MAX_ERR"  => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_NPOSTED_D_CRED_MAX_ERR"  => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_NPOSTED_HD_CRED_MAX_ERR" => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_COMP_D_CRED_MAX_ERR"     => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_COMP_HD_CRED_MAX_ERR"    => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_INF_NPOSTED_CRED_UPDT_ERR" => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_INF_POSTED_CRED_UPDT_ERR" => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_INF_COMPL_CRED_UPDT_ERR" => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_MIN_PDATA_CREDIT_ERR"    => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_SRAM_PE"                  => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_CREDIT_OFLOW"             => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "" ],
   "MMR_ADDR_ERROR"               => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "" ],
   "MMR_ACCESS_ERROR"             => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_SSP_REQ_TIMEOUT"          => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_SSP_RSP_UNEXP"            => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_SRAM_PE"                  => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_CREDIT_OFLOW"             => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_ATE40_PAGE_FAULT"         => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_ATE3240_PAGE_FAULT"       => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_SSP_RD_REQ_TIMEOUT"       => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_SSP_WR_REQ_TIMEOUT"       => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_SSP_RSP_UNEXP"            => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_SIDEBAND"             => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_SHORT"                => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_LONG"                 => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_INVALID"              => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_SRAM_PE"                  => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_CREDIT_OFLOW"             => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_ERR_COMPL"               => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_UNEXP_COMPL"             => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_COMPL_TIMEOUT"           => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_BAD_BE"               => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_ADDR_ERR"             => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_SIDEBAND"             => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_SHORT"                => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_OFLOW"                => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_LONG"                 => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_SSP_REQ_INVAL"            => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "CXM_CREDIT_OFLOW"             => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_MBE"                      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_SBE"                      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_PROTOCOL_ERROR"           => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_HEADER"               => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_HEADER"               => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "CRM_SSP_REQ_INVALID"          => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01264_def =
( NAME    => "XCE_ADM_ERROR_SUMMARY",
  ADDRESS => 0x30000100,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01264_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_ERROR_SUMMARY_ALIAS                                      #
#                                                                        #
##########################################################################

%tio_01_01265_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
);

%tio_01_01265_def =
( NAME    => "XCE_ADM_ERROR_SUMMARY_ALIAS",
  ADDRESS => 0x30000108,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01265_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_ERROR_MASK                                               #
#                                                                        #
##########################################################################

%tio_01_01266_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PORT2_PCIE_FAT_ERR"           => [   0,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT2_PCIE_NFAT_ERR"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT2_PCIE_COR_ERR"           => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_PCIE_FAT_ERR"           => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_PCIE_NFAT_ERR"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_PCIE_COR_ERR"           => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_POSTED_D_CRED_MAX_ERR"   => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_POSTED_HD_CRED_MAX_ERR"  => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_NPOSTED_D_CRED_MAX_ERR"  => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_NPOSTED_HD_CRED_MAX_ERR" => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_COMP_D_CRED_MAX_ERR"     => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_COMP_HD_CRED_MAX_ERR"    => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_INF_NPOSTED_CRED_UPDT_ERR" => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_INF_POSTED_CRED_UPDT_ERR" => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_INF_COMPL_CRED_UPDT_ERR" => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_MIN_PDATA_CREDIT_ERR"    => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_POSTED_D_CRED_MAX_ERR"   => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_POSTED_HD_CRED_MAX_ERR"  => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_NPOSTED_D_CRED_MAX_ERR"  => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_NPOSTED_HD_CRED_MAX_ERR" => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_COMP_D_CRED_MAX_ERR"     => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_COMP_HD_CRED_MAX_ERR"    => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_INF_NPOSTED_CRED_UPDT_ERR" => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_INF_POSTED_CRED_UPDT_ERR" => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_INF_COMPL_CRED_UPDT_ERR" => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_MIN_PDATA_CREDIT_ERR"    => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_SRAM_PE"                  => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_CREDIT_OFLOW"             => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "" ],
   "MMR_ADDR_ERROR"               => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "" ],
   "MMR_ACCESS_ERROR"             => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_SSP_REQ_TIMEOUT"          => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_SSP_RSP_UNEXP"            => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_SRAM_PE"                  => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_CREDIT_OFLOW"             => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_ATE40_PAGE_FAULT"         => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_ATE3240_PAGE_FAULT"       => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_SSP_RD_REQ_TIMEOUT"       => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_SSP_WR_REQ_TIMEOUT"       => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_SSP_RSP_UNEXP"            => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_SIDEBAND"             => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_SHORT"                => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_LONG"                 => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_INVALID"              => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_SRAM_PE"                  => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_CREDIT_OFLOW"             => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_ERR_COMPL"               => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_UNEXP_COMPL"             => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_COMPL_TIMEOUT"           => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_BAD_BE"               => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_ADDR_ERR"             => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_SIDEBAND"             => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_SHORT"                => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_OFLOW"                => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_LONG"                 => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_SSP_REQ_INVAL"            => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "CXM_CREDIT_OFLOW"             => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_MBE"                      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_SBE"                      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_PROTOCOL_ERROR"           => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_HEADER"               => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_HEADER"               => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "CRM_SSP_REQ_INVALID"          => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01266_def =
( NAME    => "XCE_ADM_ERROR_MASK",
  ADDRESS => 0x30000110,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01266_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_FIRST_ERROR                                              #
#                                                                        #
##########################################################################

%tio_01_01267_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PORT2_PCIE_FAT_ERR"           => [   0,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT2_PCIE_NFAT_ERR"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT2_PCIE_COR_ERR"           => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_PCIE_FAT_ERR"           => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_PCIE_NFAT_ERR"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_PCIE_COR_ERR"           => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_POSTED_D_CRED_MAX_ERR"   => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_POSTED_HD_CRED_MAX_ERR"  => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_NPOSTED_D_CRED_MAX_ERR"  => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_NPOSTED_HD_CRED_MAX_ERR" => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_COMP_D_CRED_MAX_ERR"     => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_COMP_HD_CRED_MAX_ERR"    => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_INF_NPOSTED_CRED_UPDT_ERR" => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_INF_POSTED_CRED_UPDT_ERR" => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_INF_COMPL_CRED_UPDT_ERR" => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_MIN_PDATA_CREDIT_ERR"    => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_POSTED_D_CRED_MAX_ERR"   => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_POSTED_HD_CRED_MAX_ERR"  => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_NPOSTED_D_CRED_MAX_ERR"  => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_NPOSTED_HD_CRED_MAX_ERR" => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_COMP_D_CRED_MAX_ERR"     => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_COMP_HD_CRED_MAX_ERR"    => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_INF_NPOSTED_CRED_UPDT_ERR" => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_INF_POSTED_CRED_UPDT_ERR" => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_INF_COMPL_CRED_UPDT_ERR" => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_MIN_PDATA_CREDIT_ERR"    => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_SRAM_PE"                  => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_CREDIT_OFLOW"             => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "" ],
   "MMR_ADDR_ERROR"               => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "" ],
   "MMR_ACCESS_ERROR"             => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_SSP_REQ_TIMEOUT"          => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_SSP_RSP_UNEXP"            => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_SRAM_PE"                  => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_CREDIT_OFLOW"             => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_ATE40_PAGE_FAULT"         => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_ATE3240_PAGE_FAULT"       => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_SSP_RD_REQ_TIMEOUT"       => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_SSP_WR_REQ_TIMEOUT"       => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_SSP_RSP_UNEXP"            => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_SIDEBAND"             => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_SHORT"                => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_LONG"                 => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_INVALID"              => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_SRAM_PE"                  => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_CREDIT_OFLOW"             => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_ERR_COMPL"               => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_UNEXP_COMPL"             => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_COMPL_TIMEOUT"           => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_BAD_BE"               => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_ADDR_ERR"             => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_SIDEBAND"             => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_SHORT"                => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_OFLOW"                => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_LONG"                 => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_SSP_REQ_INVAL"            => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "CXM_CREDIT_OFLOW"             => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_MBE"                      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_SBE"                      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_PROTOCOL_ERROR"           => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_HEADER"               => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_HEADER"               => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "CRM_SSP_REQ_INVALID"          => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01267_def =
( NAME    => "XCE_ADM_FIRST_ERROR",
  ADDRESS => 0x30000118,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01267_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_ERROR_OVERFLOW                                           #
#                                                                        #
##########################################################################

%tio_01_01268_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PORT2_PCIE_FAT_ERR"           => [   0,  61,   1, 0x2000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT2_PCIE_NFAT_ERR"          => [   1,  60,   1, 0x1000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT2_PCIE_COR_ERR"           => [   2,  59,   1, 0x0800000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_PCIE_FAT_ERR"           => [   3,  58,   1, 0x0400000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_PCIE_NFAT_ERR"          => [   4,  57,   1, 0x0200000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_PCIE_COR_ERR"           => [   5,  56,   1, 0x0100000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_POSTED_D_CRED_MAX_ERR"   => [   6,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_POSTED_HD_CRED_MAX_ERR"  => [   7,  54,   1, 0x0040000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_NPOSTED_D_CRED_MAX_ERR"  => [   8,  53,   1, 0x0020000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_NPOSTED_HD_CRED_MAX_ERR" => [   9,  52,   1, 0x0010000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_COMP_D_CRED_MAX_ERR"     => [  10,  51,   1, 0x0008000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_COMP_HD_CRED_MAX_ERR"    => [  11,  50,   1, 0x0004000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_INF_NPOSTED_CRED_UPDT_ERR" => [  12,  49,   1, 0x0002000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_INF_POSTED_CRED_UPDT_ERR" => [  13,  48,   1, 0x0001000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_INF_COMPL_CRED_UPDT_ERR" => [  14,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2_MIN_PDATA_CREDIT_ERR"    => [  15,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_POSTED_D_CRED_MAX_ERR"   => [  16,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_POSTED_HD_CRED_MAX_ERR"  => [  17,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_NPOSTED_D_CRED_MAX_ERR"  => [  18,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_NPOSTED_HD_CRED_MAX_ERR" => [  19,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_COMP_D_CRED_MAX_ERR"     => [  20,  41,   1, 0x0000020000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_COMP_HD_CRED_MAX_ERR"    => [  21,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_INF_NPOSTED_CRED_UPDT_ERR" => [  22,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_INF_POSTED_CRED_UPDT_ERR" => [  23,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_INF_COMPL_CRED_UPDT_ERR" => [  24,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_MIN_PDATA_CREDIT_ERR"    => [  25,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_SRAM_PE"                  => [  26,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_CREDIT_OFLOW"             => [  27,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "" ],
   "MMR_ADDR_ERROR"               => [  28,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "" ],
   "MMR_ACCESS_ERROR"             => [  29,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_SSP_REQ_TIMEOUT"          => [  30,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_SSP_RSP_UNEXP"            => [  31,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_SRAM_PE"                  => [  32,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_CREDIT_OFLOW"             => [  33,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_ATE40_PAGE_FAULT"         => [  34,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_ATE3240_PAGE_FAULT"       => [  35,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_SSP_RD_REQ_TIMEOUT"       => [  36,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_SSP_WR_REQ_TIMEOUT"       => [  37,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_SSP_RSP_UNEXP"            => [  38,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_SIDEBAND"             => [  39,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_SHORT"                => [  40,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_LONG"                 => [  41,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_INVALID"              => [  42,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_SRAM_PE"                  => [  43,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_CREDIT_OFLOW"             => [  44,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_ERR_COMPL"               => [  45,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_UNEXP_COMPL"             => [  46,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "PCIE_COMPL_TIMEOUT"           => [  47,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_BAD_BE"               => [  48,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_ADDR_ERR"             => [  49,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_SIDEBAND"             => [  50,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_SHORT"                => [  51,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_OFLOW"                => [  52,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_LONG"                 => [  53,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_SSP_REQ_INVAL"            => [  54,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "CXM_CREDIT_OFLOW"             => [  55,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_MBE"                      => [  56,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_SBE"                      => [  57,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_PROTOCOL_ERROR"           => [  58,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_RSP_HEADER"               => [  59,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_HEADER"               => [  60,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "CRM_SSP_REQ_INVALID"          => [  61,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01268_def =
( NAME    => "XCE_ADM_ERROR_OVERFLOW",
  ADDRESS => 0x30000120,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01268_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_ERROR_OVERFLOW_ALIAS                                     #
#                                                                        #
##########################################################################

%tio_01_01269_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
);

%tio_01_01269_def =
( NAME    => "XCE_ADM_ERROR_OVERFLOW_ALIAS",
  ADDRESS => 0x30000128,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01269_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_TNUM_ERROR                                               #
#                                                                        #
##########################################################################

%tio_01_01270_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ADM_UNEXP_TNUM_VAL"           => [   0,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_TNUMTO_VAL"               => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01270_def =
( NAME    => "XCE_ADM_TNUM_ERROR",
  ADDRESS => 0x30000140,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01270_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_MMR_ERR_DETAIL                                           #
#                                                                        #
##########################################################################

%tio_01_01271_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MMR_REQ_ERR"                  => [   0,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "" ],
   "MMR_ADDR_ERR"                 => [   1,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "" ],
   "MMR_BE_ERR"                   => [   2,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "" ],
   "MMR_RSP_ERR"                  => [   3,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "" ],
   "MMR_WR_REQ"                   => [   4,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "" ],
   "MMR_ADDR"                     => [   5,   3,  29, 0x00000000FFFFFFF8, 0x00, 0, 0x0000000000000000, "" ],
   "RESERVED"                     => [   6,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01271_def =
( NAME    => "XCE_ADM_MMR_ERR_DETAIL",
  ADDRESS => 0x30000148,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01271_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_MSG_SRAM_PERR_DETAIL                                     #
#                                                                        #
##########################################################################

%tio_01_01272_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MSG_SRAM_PERR_ADDR"           => [   0,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01272_def =
( NAME    => "XCE_ADM_MSG_SRAM_PERR_DETAIL",
  ADDRESS => 0x30000150,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01272_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_BAP_SRAM_PERR_DETAIL                                     #
#                                                                        #
##########################################################################

%tio_01_01273_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BAP_SRAM_PERR_ADDR"           => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01273_def =
( NAME    => "XCE_ADM_BAP_SRAM_PERR_DETAIL",
  ADDRESS => 0x30000158,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01273_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_CE_SRAM_PERR_DETAIL                                      #
#                                                                        #
##########################################################################

%tio_01_01274_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ADM_BAP_PE"                   => [   0,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_MSG_PE"                   => [   1,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_DNS_DB_PE"                => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_DNS_HB_PE"                => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_RSPQ_PE"                  => [   4,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "URE_RCI_PE"                   => [   5,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "URE_ATE40_PE"                 => [   6,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "URE_ATE3240_PE"               => [   7,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "URE_UPS_DB1_PE"               => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "URE_UPS_DB0_PE"               => [   9,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "URE_UPS_HB1_PE"               => [  10,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "URE_UPS_HB0_PE"               => [  11,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_USRSP_PE"                 => [  12,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_USWRT_PE"                 => [  13,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_DSDATA_PE"                => [  14,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_DSHEAD_PE"                => [  15,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01274_def =
( NAME    => "XCE_ADM_CE_SRAM_PERR_DETAIL",
  ADDRESS => 0x30000160,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01274_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_CE_CREDIT_OFLOW_DETAIL                                     #
#                                                                        #
##########################################################################

%tio_01_01275_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ADM_DTL2_CREDIT_OFLOW"        => [   0,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_DTL1_CREDIT_OFLOW"        => [   1,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_CXM_REQ_CREDIT_OFLOW"     => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_CXM_RSP_CREDIT_OFLOW"     => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_DTL2_CREDIT_OFLOW"        => [   4,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "URE_DTL1_CREDIT_OFLOW"        => [   5,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "URE_CXM_CREDIT_OFLOW"         => [   6,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "URE_DRE_CREDIT_OFLOW"         => [   7,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "URE_ADM_CREDIT_OFLOW"         => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_RSP_ERR_CREDIT_OFLOW"     => [   9,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_DTL2_CREDIT_OFLOW"        => [  10,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_DTL1_CREDIT_OFLOW"        => [  11,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_CXM_CREDIT_OFLOW"         => [  12,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_ADM_CREDIT_OFLOW"         => [  13,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "CXM_SSP_RSP_CREDIT_OFLOW"     => [  14,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "CXM_SSP_REQ_CREDIT_OFLOW"     => [  15,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01275_def =
( NAME    => "XCE_ADM_CE_CREDIT_OFLOW_DETAIL",
  ADDRESS => 0x30000168,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01275_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_TX_LINK_IDLE_MAX_TIME                                     #
#                                                                        #
##########################################################################

%tio_01_01276_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PORT2_TX_LINK_IDLE_MAX_TIME"  => [   0,  16,  11, 0x0000000007FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT1_TX_LINK_IDLE_MAX_TIME"  => [   1,   0,  11, 0x00000000000007FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01276_def =
( NAME    => "XCE_ADM_TX_LINK_IDLE_MAX_TIME",
  ADDRESS => 0x30000170,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01276_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_PCIE_DEBUG_SEL                                           #
#                                                                        #
##########################################################################

%tio_01_01277_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_NIB7_SEL"               => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT7_SEL"              => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB6_SEL"               => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT6_SEL"              => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB5_SEL"               => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT5_SEL"              => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB4_SEL"               => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT4_SEL"              => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB3_SEL"               => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT3_SEL"              => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB2_SEL"               => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT2_SEL"              => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB1_SEL"               => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT1_SEL"              => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB0_SEL"               => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT0_SEL"              => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01277_def =
( NAME    => "XCE_ADM_PCIE_DEBUG_SEL",
  ADDRESS => 0x30000198,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01277_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_PCIE_DEBUG_SEL_TOP                                       #
#                                                                        #
##########################################################################

%tio_01_01278_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_PORT7_SEL"              => [   0,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT6_SEL"              => [   1,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT5_SEL"              => [   2,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT4_SEL"              => [   3,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT3_SEL"              => [   4,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT2_SEL"              => [   5,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT1_SEL"              => [   6,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT0_SEL"              => [   7,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01278_def =
( NAME    => "XCE_ADM_PCIE_DEBUG_SEL_TOP",
  ADDRESS => 0x30000200,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01278_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_PCIE_DEBUG_LAT_SEL_LO_TOP                                     #
#                                                                        #
##########################################################################

%tio_01_01279_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_LAT_SEL_15"             => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_14"             => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_13"             => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_12"             => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_11"             => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_10"             => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_9"              => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_8"              => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_7"              => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_6"              => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_5"              => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_4"              => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_3"              => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_2"              => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_1"              => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_0"              => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01279_def =
( NAME    => "XCE_ADM_PCIE_DEBUG_LAT_SEL_LO_TOP",
  ADDRESS => 0x30000208,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01279_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_PCIE_DEBUG_LAT_SEL_HI_TOP                                     #
#                                                                        #
##########################################################################

%tio_01_01280_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_LAT_SEL_31"             => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_30"             => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_29"             => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_28"             => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_27"             => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_26"             => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_25"             => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_24"             => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_23"             => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_22"             => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_21"             => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_20"             => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_19"             => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_18"             => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_17"             => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_16"             => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01280_def =
( NAME    => "XCE_ADM_PCIE_DEBUG_LAT_SEL_HI_TOP",
  ADDRESS => 0x30000210,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01280_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_PCIE_DEBUG_TRIG_SEL_TOP                                     #
#                                                                        #
##########################################################################

%tio_01_01281_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_TRIG_EN"                => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_PORT7_SEL"         => [   1,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_PORT6_SEL"         => [   2,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_PORT5_SEL"         => [   3,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_PORT4_SEL"         => [   4,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_PORT3_SEL"         => [   5,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_PORT2_SEL"         => [   6,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_PORT0_SEL"         => [   7,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01281_def =
( NAME    => "XCE_ADM_PCIE_DEBUG_TRIG_SEL_TOP",
  ADDRESS => 0x30000218,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01281_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_PCIE_DEBUG_TRIG_LAT_SEL_LO_TOP                                     #
#                                                                        #
##########################################################################

%tio_01_01282_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_TRIG_LAT_SEL_15"        => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_14"        => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_13"        => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_12"        => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_11"        => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_10"        => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_9"         => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_8"         => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_7"         => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_6"         => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_5"         => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_4"         => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_3"         => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_2"         => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_1"         => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_0"         => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01282_def =
( NAME    => "XCE_ADM_PCIE_DEBUG_TRIG_LAT_SEL_LO_TOP",
  ADDRESS => 0x30000220,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01282_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_PCIE_DEBUG_TRIG_LAT_SEL_HI_TOP                                     #
#                                                                        #
##########################################################################

%tio_01_01283_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_TRIG_LAT_SEL_31"        => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_30"        => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_29"        => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_28"        => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_27"        => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_26"        => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_25"        => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_24"        => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_23"        => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_22"        => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_21"        => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_20"        => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_19"        => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_18"        => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_17"        => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_16"        => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01283_def =
( NAME    => "XCE_ADM_PCIE_DEBUG_TRIG_LAT_SEL_HI_TOP",
  ADDRESS => 0x30000228,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01283_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_PCIE_TRIG_COMPARE_TOP                                     #
#                                                                        #
##########################################################################

%tio_01_01284_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_TRIG_CMP"               => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01284_def =
( NAME    => "XCE_ADM_PCIE_TRIG_COMPARE_TOP",
  ADDRESS => 0x30000230,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01284_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_PCIE_TRIG_COMPARE_EN_TOP                                     #
#                                                                        #
##########################################################################

%tio_01_01285_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_TRIG_CMP_EN"            => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01285_def =
( NAME    => "XCE_ADM_PCIE_TRIG_COMPARE_EN_TOP",
  ADDRESS => 0x30000238,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01285_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_SSP_DEBUG_SEL_TOP                                        #
#                                                                        #
##########################################################################

%tio_01_01286_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_PORT7_SEL"              => [   0,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT6_SEL"              => [   1,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT5_SEL"              => [   2,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT4_SEL"              => [   3,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT3_SEL"              => [   4,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT2_SEL"              => [   5,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT1_SEL"              => [   6,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT0_SEL"              => [   7,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01286_def =
( NAME    => "XCE_ADM_SSP_DEBUG_SEL_TOP",
  ADDRESS => 0x30000240,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01286_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_SSP_DEBUG_LAT_SEL_LO_TOP                                     #
#                                                                        #
##########################################################################

%tio_01_01287_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_LAT_SEL_15"             => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_14"             => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_13"             => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_12"             => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_11"             => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_10"             => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_9"              => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_8"              => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_7"              => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_6"              => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_5"              => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_4"              => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_3"              => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_2"              => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_1"              => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_0"              => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01287_def =
( NAME    => "XCE_ADM_SSP_DEBUG_LAT_SEL_LO_TOP",
  ADDRESS => 0x30000248,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01287_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_SSP_DEBUG_LAT_SEL_HI_TOP                                     #
#                                                                        #
##########################################################################

%tio_01_01288_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_LAT_SEL_31"             => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_30"             => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_29"             => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_28"             => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_27"             => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_26"             => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_25"             => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_24"             => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_23"             => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_22"             => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_21"             => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_20"             => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_19"             => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_18"             => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_17"             => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_LAT_SEL_16"             => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01288_def =
( NAME    => "XCE_ADM_SSP_DEBUG_LAT_SEL_HI_TOP",
  ADDRESS => 0x30000250,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01288_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_SSP_DEBUG_TRIG_SEL_TOP                                     #
#                                                                        #
##########################################################################

%tio_01_01289_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_TRIG_EN"                => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_PORT7_SEL"         => [   1,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_PORT6_SEL"         => [   2,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_PORT5_SEL"         => [   3,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_PORT4_SEL"         => [   4,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_PORT3_SEL"         => [   5,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_PORT2_SEL"         => [   6,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_PORT1_SEL"         => [   7,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_PORT0_SEL"         => [   8,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01289_def =
( NAME    => "XCE_ADM_SSP_DEBUG_TRIG_SEL_TOP",
  ADDRESS => 0x30000258,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01289_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_SSP_DEBUG_TRIG_LAT_SEL_LO_TOP                                     #
#                                                                        #
##########################################################################

%tio_01_01290_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_TRIG_LAT_SEL_15"        => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_14"        => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_13"        => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_12"        => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_11"        => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_10"        => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_9"         => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_8"         => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_7"         => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_6"         => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_5"         => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_4"         => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_3"         => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_2"         => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_1"         => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_0"         => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01290_def =
( NAME    => "XCE_ADM_SSP_DEBUG_TRIG_LAT_SEL_LO_TOP",
  ADDRESS => 0x30000260,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01290_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_SSP_DEBUG_TRIG_LAT_SEL_HI_TOP                                     #
#                                                                        #
##########################################################################

%tio_01_01291_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_TRIG_LAT_SEL_31"        => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_30"        => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_29"        => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_28"        => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_27"        => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_26"        => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_25"        => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_24"        => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_23"        => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_22"        => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_21"        => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_20"        => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_19"        => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_18"        => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_17"        => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_TRIG_LAT_SEL_16"        => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01291_def =
( NAME    => "XCE_ADM_SSP_DEBUG_TRIG_LAT_SEL_HI_TOP",
  ADDRESS => 0x30000268,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01291_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_SSP_TRIG_COMPARE_TOP                                     #
#                                                                        #
##########################################################################

%tio_01_01292_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_TRIG_CMP"               => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01292_def =
( NAME    => "XCE_ADM_SSP_TRIG_COMPARE_TOP",
  ADDRESS => 0x30000270,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01292_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_SSP_TRIG_COMPARE_EN_TOP                                     #
#                                                                        #
##########################################################################

%tio_01_01293_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_TRIG_CMP_EN"            => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01293_def =
( NAME    => "XCE_ADM_SSP_TRIG_COMPARE_EN_TOP",
  ADDRESS => 0x30000278,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01293_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_BAP_CTRL                                                 #
#                                                                        #
##########################################################################

%tio_01_01294_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BUSY"                         => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SEND"                         => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT_SEL"                     => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "XFER_LEN"                     => [   3,   0,  10, 0x00000000000003FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01294_def =
( NAME    => "XCE_ADM_BAP_CTRL",
  ADDRESS => 0x30000400,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01294_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_MAINT_MSG_BUF_DATA63_0                                     #
#                                                                        #
##########################################################################

%tio_01_01295_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01295_def =
( NAME    => "XCE_ADM_MAINT_MSG_BUF_DATA63_0",
  ADDRESS => 0x30000800,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01295_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_MAINT_MSG_BUF_DATA127_64                                     #
#                                                                        #
##########################################################################

%tio_01_01296_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,  64,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01296_def =
( NAME    => "XCE_ADM_MAINT_MSG_BUF_DATA127_64",
  ADDRESS => 0x30000A00,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01296_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_MAINT_MSG_BUF_PARITY                                     #
#                                                                        #
##########################################################################

%tio_01_01297_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PARITY"                       => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01297_def =
( NAME    => "XCE_ADM_MAINT_MSG_BUF_PARITY",
  ADDRESS => 0x30000C00,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01297_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LPU_ID                                                  #
#                                                                        #
##########################################################################

%tio_01_01298_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LK_TYPE_BW"                   => [   0,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "" ],
   "PHY_TYPE_LANE_W"              => [   1,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "" ],
   "TP_REV_ID"                    => [   2,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "" ],
   "LK_REV_ID"                    => [   3,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "" ],
   "PHY_REV_ID"                   => [   4,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "" ],
   "GB_REV_ID"                    => [   5,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01298_def =
( NAME    => "XCE_LSI1_LPU_ID",
  ADDRESS => 0x30002000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01298_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_RST_REG                                                 #
#                                                                        #
##########################################################################

%tio_01_01299_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RST_WE"                       => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "U_RST"                        => [   1,   9,   3, 0x0000000000000E00, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_ERR"                  => [   2,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_TXL"                  => [   3,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_RXL"                  => [   4,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_SML"                  => [   5,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_LTSSM"                => [   6,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_TXPHY"                => [   7,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_RXPHY"                => [   8,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_TXPCS"                => [   9,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_RXPCS"                => [  10,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01299_def =
( NAME    => "XCE_LSI1_RST_REG",
  ADDRESS => 0x30002008,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01299_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_DBG_STAT                                                #
#                                                                        #
##########################################################################

%tio_01_01300_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DBG_B_STAT"                   => [   0,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "DBG_A_STAT"                   => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01300_def =
( NAME    => "XCE_LSI1_DBG_STAT",
  ADDRESS => 0x30002010,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01300_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_DBG_CFG                                                 #
#                                                                        #
##########################################################################

%tio_01_01301_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DBG_B_CFG"                    => [   0,  16,  12, 0x000000000FFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "DBG_A_CFG"                    => [   1,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01301_def =
( NAME    => "XCE_LSI1_DBG_CFG",
  ADDRESS => 0x30002018,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01301_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LTSSM_CTRL                                              #
#                                                                        #
##########################################################################

%tio_01_01302_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WR_EN"                        => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TO_CFG"                   => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "L0_TO_RCV"                    => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "GOTO_DET_QUT"                 => [   3,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "DSBL_SCRAM_REQ"               => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "LK_LB_REQ"                    => [   5,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "LK_DSBL_REQ"                  => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "HOT_RST_REQ"                  => [   7,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01302_def =
( NAME    => "XCE_LSI1_LTSSM_CTRL",
  ADDRESS => 0x30002020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01302_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LK_STAT                                                 #
#                                                                        #
##########################################################################

%tio_01_01303_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SLT_CLK_CFG"                  => [   0,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "LK_TRN"                       => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "LK_TRN_ERR"                   => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "NEG_W"                        => [   3,   4,   6, 0x00000000000003F0, 0x00, 0, 0x0000000000000000, "" ],
   "LK_SPD"                       => [   4,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01303_def =
( NAME    => "XCE_LSI1_LK_STAT",
  ADDRESS => 0x30002028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01303_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_INT_AND_STAT                                            #
#                                                                        #
##########################################################################

%tio_01_01304_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_ACTV"                     => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "PERF_CNT2_OFLOW"              => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "PERF_CNT1_OFLOW"              => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "LK_INT"                       => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "PHY_ERR_INT"                  => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INT"                    => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PHY_INT"                   => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "RX_PHY_INT"                   => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "PHY_GB_INT"                   => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01304_def =
( NAME    => "XCE_LSI1_INT_AND_STAT",
  ADDRESS => 0x30002040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01304_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_INT_MASK                                                #
#                                                                        #
##########################################################################

%tio_01_01305_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_EN"                       => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "PERF_CNT2_OFLOW"              => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "PERF_CNT1_OFLOW"              => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "LK_MASK"                      => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "PHY_ERR_MASK"                 => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_MASK"                   => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PHY_MASK"                  => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "RX_PHY_MASK"                  => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "PHY_GB_MASK"                  => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01305_def =
( NAME    => "XCE_LSI1_INT_MASK",
  ADDRESS => 0x30002048,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01305_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LK_PERF_CNT_SEL                                         #
#                                                                        #
##########################################################################

%tio_01_01306_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PERF_CNT2_SEL"                => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "PERF_CNT1_SEL"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01306_def =
( NAME    => "XCE_LSI1_LK_PERF_CNT_SEL",
  ADDRESS => 0x30002100,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01306_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LK_PERF_CNT_CTRL                                        #
#                                                                        #
##########################################################################

%tio_01_01307_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SET_PERF_CNT_OFLOW2"          => [   0,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "SET_PERF_CNT_OFLOW1"          => [   1,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "RST_PERF_CNT2_OFLOW"          => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "RST_PERF_CNT2"                => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "RST_PERF_CNT1_OFLOW"          => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "RST_PERF_CNT1"                => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01307_def =
( NAME    => "XCE_LSI1_LK_PERF_CNT_CTRL",
  ADDRESS => 0x30002110,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01307_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LK_PERF_CNT1                                            #
#                                                                        #
##########################################################################

%tio_01_01308_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PERF_CNT1"                    => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01308_def =
( NAME    => "XCE_LSI1_LK_PERF_CNT1",
  ADDRESS => 0x30002120,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01308_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LK_PERF_CNT1_TEST                                       #
#                                                                        #
##########################################################################

%tio_01_01309_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PERF_CNT1_TEST"               => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01309_def =
( NAME    => "XCE_LSI1_LK_PERF_CNT1_TEST",
  ADDRESS => 0x30002128,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01309_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LK_PERF_CNT2                                            #
#                                                                        #
##########################################################################

%tio_01_01310_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PERF_CNT2"                    => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01310_def =
( NAME    => "XCE_LSI1_LK_PERF_CNT2",
  ADDRESS => 0x30002130,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01310_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LK_PERF_CNT2_TEST                                       #
#                                                                        #
##########################################################################

%tio_01_01311_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PERF_CNT2_TEST"               => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01311_def =
( NAME    => "XCE_LSI1_LK_PERF_CNT2_TEST",
  ADDRESS => 0x30002138,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01311_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LK_LYR_CFG                                              #
#                                                                        #
##########################################################################

%tio_01_01312_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AUTO_UPDT_DSBL"               => [   0,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "" ],
   "FREQ_NAK_EN"                  => [   1,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "" ],
   "RPLY_POST_RECRY_EN"           => [   2,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "" ],
   "LAT_THRES_WR_EN"              => [   3,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "VC0_EN"                       => [   4,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "L0S_ADJ_FCT_EN"               => [   5,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "TLP_TX_FC_INIT2_EN"           => [   6,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "FRQ_ACK_EN"                   => [   7,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_DSBL"                   => [   8,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01312_def =
( NAME    => "XCE_LSI1_LK_LYR_CFG",
  ADDRESS => 0x30002200,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01312_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LK_LYR_STATUS                                           #
#                                                                        #
##########################################################################

%tio_01_01313_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INIT_FLW_CTL_SM_EN"           => [   0,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "LK_ST_DL_UP_EN"               => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "INIT_FLW_CTRL_SM_STAT"        => [   2,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "" ],
   "DL_UP_STAT"                   => [   3,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "LK_SM_STAT"                   => [   4,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01313_def =
( NAME    => "XCE_LSI1_LK_LYR_STATUS",
  ADDRESS => 0x30002208,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01313_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LK_LYR_INT_STAT                                         #
#                                                                        #
##########################################################################

%tio_01_01314_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LK_ERR_ACT_INT"               => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNSUP_DLLP"                   => [   1,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "DLLP_RCV_ERR"                 => [   2,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_DLLP"                     => [   3,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "" ],
   "TLP_RCV_ERR"                  => [   4,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "" ],
   "SRC_ERR_TLP"                  => [   5,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_TLP"                      => [   6,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_UFLOW_ERR"            => [   7,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_OFLOW_ERR"            => [   8,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "EG_TLP_MIN_L_ERR"             => [   9,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "EG_TRUNC_FRM_ERR"             => [  10,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_PAR_ERR"              => [  11,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "EG_PAR_ERR"                   => [  12,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "RPLY_TMR_TO"                  => [  13,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "RPLY_NUM_RLVR"                => [  14,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "DATA_LK_PROT_ERR"             => [  15,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01314_def =
( NAME    => "XCE_LSI1_LK_LYR_INT_STAT",
  ADDRESS => 0x30002210,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01314_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LK_LY_INT_STAT_TEST                                     #
#                                                                        #
##########################################################################

%tio_01_01315_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "UNSUP_DLLP_TEST"              => [   0,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "DLLP_RCV_ERR_TEST"            => [   1,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_DLLP_TEST"                => [   2,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "" ],
   "TLP_RCV_ERR_TEST"             => [   3,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "" ],
   "SRC_ERR_TLP_TEST"             => [   4,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_TLP_TEST"                 => [   5,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_UFLOW_ERR_TEST"       => [   6,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_OFLOW_ERR_TEST"       => [   7,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "EG_TLP_MIN_L_ERR_TEST"        => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "EG_TRUNC_FRM_ERR_TEST"        => [   9,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_PAR_ERR_TEST"         => [  10,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "EG_PAR_ERR_TEST"              => [  11,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "RPLY_TMR_TO_TEST"             => [  12,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "RPLY_NUM_RLVR_TEST"           => [  13,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "DATA_LK_PROT_ERR_TEST"        => [  14,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01315_def =
( NAME    => "XCE_LSI1_LK_LY_INT_STAT_TEST",
  ADDRESS => 0x30002218,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01315_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LK_LY_INT_MASK                                          #
#                                                                        #
##########################################################################

%tio_01_01316_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LK_ERR_ACT_INT_MASK"          => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNSUP_DLLP_MASK"              => [   1,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "DLLP_RCV_ERR_MASK"            => [   2,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_DLLP_MASK"                => [   3,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "" ],
   "TLP_RCV_ERR_MASK"             => [   4,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "" ],
   "SRC_ERR_TLP_MASK"             => [   5,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_TLP_MASK"                 => [   6,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_UFLOW_ERR_MASK"       => [   7,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_OFLOW_ERR_MASK"       => [   8,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "EG_TLP_MIN_L_ERR_MASK"        => [   9,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "EG_TRUNC_FRM_ERR_MASK"        => [  10,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_PAR_ERR_MASK"         => [  11,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "EG_PAR_ERR_MASK"              => [  12,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "RPLY_TMR_TO_MASK"             => [  13,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "RPLY_NUM_RLVR_MASK"           => [  14,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "DATA_LK_PROT_ERR_MASK"        => [  15,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01316_def =
( NAME    => "XCE_LSI1_LK_LY_INT_MASK",
  ADDRESS => 0x30002220,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01316_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_FC_UPD_CTL                                              #
#                                                                        #
##########################################################################

%tio_01_01317_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FC0_UPD_C_EN"                 => [   0,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "FC0_UPD_NP_EN"                => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "FC0_UPD_P_EN"                 => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01317_def =
( NAME    => "XCE_LSI1_FC_UPD_CTL",
  ADDRESS => 0x30002240,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01317_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_FLW_CTL_UPD_TO_TIMER                                     #
#                                                                        #
##########################################################################

%tio_01_01318_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FLW_CTL_TIMER_VAL"            => [   0,   0,  15, 0x0000000000007FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01318_def =
( NAME    => "XCE_LSI1_FLW_CTL_UPD_TO_TIMER",
  ADDRESS => 0x30002260,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01318_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_VC0_FLW_CTL_UPD_TIMER0                                     #
#                                                                        #
##########################################################################

%tio_01_01319_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC0_FLW_CTL_NP_TIMER_VAL"     => [   0,  16,  15, 0x000000007FFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "VC0_FLW_CTL_P_TIMER_VAL"      => [   1,   0,  15, 0x0000000000007FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01319_def =
( NAME    => "XCE_LSI1_VC0_FLW_CTL_UPD_TIMER0",
  ADDRESS => 0x30002268,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01319_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_VC0_FLW_CTL_UPD_TIMER1                                     #
#                                                                        #
##########################################################################

%tio_01_01320_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC0_FLW_CTL_C_TIMER_VAL"      => [   0,   0,  15, 0x0000000000007FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01320_def =
( NAME    => "XCE_LSI1_VC0_FLW_CTL_UPD_TIMER1",
  ADDRESS => 0x30002270,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01320_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_FREQ_NAK_LAT_THRSH                                      #
#                                                                        #
##########################################################################

%tio_01_01321_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NAK_LAT_TIMER_THRSH"          => [   0,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01321_def =
( NAME    => "XCE_LSI1_FREQ_NAK_LAT_THRSH",
  ADDRESS => 0x30002400,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01321_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_ACK_NAK_LAT_TMR                                         #
#                                                                        #
##########################################################################

%tio_01_01322_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACKNAK_LATENCY_TIMER"         => [   0,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01322_def =
( NAME    => "XCE_LSI1_ACK_NAK_LAT_TMR",
  ADDRESS => 0x30002408,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01322_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_RPLY_TMR_THR                                            #
#                                                                        #
##########################################################################

%tio_01_01323_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RPLY_TMR_THR"                 => [   0,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01323_def =
( NAME    => "XCE_LSI1_RPLY_TMR_THR",
  ADDRESS => 0x30002410,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01323_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_RPLY_TMR                                                #
#                                                                        #
##########################################################################

%tio_01_01324_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RPLY_TMR_THR"                 => [   0,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01324_def =
( NAME    => "XCE_LSI1_RPLY_TMR",
  ADDRESS => 0x30002418,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01324_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_RPLY_NUM_STAT                                           #
#                                                                        #
##########################################################################

%tio_01_01325_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RPLY_NUMBER_CNT"              => [   0,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01325_def =
( NAME    => "XCE_LSI1_RPLY_NUM_STAT",
  ADDRESS => 0x30002420,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01325_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_RTY_BUF_MAX_ADDR                                        #
#                                                                        #
##########################################################################

%tio_01_01326_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RTY_BUF_MAX_ADDR"             => [   0,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01326_def =
( NAME    => "XCE_LSI1_RTY_BUF_MAX_ADDR",
  ADDRESS => 0x30002428,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01326_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_RTY_FIFO_PTR                                            #
#                                                                        #
##########################################################################

%tio_01_01327_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RTY_FIFO_TL_PTR"              => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_FIFO_HD_PTR"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01327_def =
( NAME    => "XCE_LSI1_RTY_FIFO_PTR",
  ADDRESS => 0x30002430,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01327_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_RTY_FIFO_RD_WR_PTR                                      #
#                                                                        #
##########################################################################

%tio_01_01328_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RTY_FIFO_WR_PTR"              => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_FIFO_RD_PTR"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01328_def =
( NAME    => "XCE_LSI1_RTY_FIFO_RD_WR_PTR",
  ADDRESS => 0x30002438,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01328_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_RTY_FIFO_CRED                                           #
#                                                                        #
##########################################################################

%tio_01_01329_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RTY_FIFO_CRED"                => [   0,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01329_def =
( NAME    => "XCE_LSI1_RTY_FIFO_CRED",
  ADDRESS => 0x30002440,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01329_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_SEQ_CNT                                                 #
#                                                                        #
##########################################################################

%tio_01_01330_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NXT_TX_SEQ_CNT_EN"            => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ACKD_SEQ_CNT_EN"              => [   1,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "ACKD_SEQ_CNT"                 => [   2,  16,  12, 0x000000000FFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "NXT_TX_SEQ_CNT"               => [   3,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01330_def =
( NAME    => "XCE_LSI1_SEQ_CNT",
  ADDRESS => 0x30002448,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01330_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_ACK_SENT_SEQ_NUM                                        #
#                                                                        #
##########################################################################

%tio_01_01331_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACK_SENT_SEQ_NUM"             => [   0,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01331_def =
( NAME    => "XCE_LSI1_ACK_SENT_SEQ_NUM",
  ADDRESS => 0x30002450,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01331_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_SEQ_CNT_FIFO_MAX_ADDR                                     #
#                                                                        #
##########################################################################

%tio_01_01332_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SEQ_CNT_FIFO_MAX_ADDR"        => [   0,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01332_def =
( NAME    => "XCE_LSI1_SEQ_CNT_FIFO_MAX_ADDR",
  ADDRESS => 0x30002458,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01332_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_SEQ_CNT_FIFO_PTR                                        #
#                                                                        #
##########################################################################

%tio_01_01333_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SEQ_CNT_TL_PTR"               => [   0,  16,  12, 0x000000000FFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "SEQ_CNT_HD_PTR"               => [   1,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01333_def =
( NAME    => "XCE_LSI1_SEQ_CNT_FIFO_PTR",
  ADDRESS => 0x30002460,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01333_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_SEQ_CNT_RD_WR_PTR                                       #
#                                                                        #
##########################################################################

%tio_01_01334_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SEQ_CNT_WR_PTR"               => [   0,  16,  12, 0x000000000FFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "SEQ_CNT_RD_PTR"               => [   1,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01334_def =
( NAME    => "XCE_LSI1_SEQ_CNT_RD_WR_PTR",
  ADDRESS => 0x30002468,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01334_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_TX_LK_TS_CTL                                            #
#                                                                        #
##########################################################################

%tio_01_01335_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DSB_ACKL"                     => [   0,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_NAK"                      => [   1,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_BD_TLP_CRC"               => [   2,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_RETX_TLP"                 => [   3,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01335_def =
( NAME    => "XCE_LSI1_TX_LK_TS_CTL",
  ADDRESS => 0x30002470,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01335_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_MEM_ADDR_CTL                                            #
#                                                                        #
##########################################################################

%tio_01_01336_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DONE"                         => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "GO_BIT"                       => [   1,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "RD_WR_SEL"                    => [   2,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "FIFO_SEL"                     => [   3,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "MEM_ADDR"                     => [   4,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01336_def =
( NAME    => "XCE_LSI1_MEM_ADDR_CTL",
  ADDRESS => 0x30002480,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01336_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_MEM_D_LD0                                               #
#                                                                        #
##########################################################################

%tio_01_01337_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MEM_RD_WR_DATA0"              => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01337_def =
( NAME    => "XCE_LSI1_MEM_D_LD0",
  ADDRESS => 0x30002488,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01337_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_MEM_D_LD1                                               #
#                                                                        #
##########################################################################

%tio_01_01338_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MEM_RD_WR_DATA1"              => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01338_def =
( NAME    => "XCE_LSI1_MEM_D_LD1",
  ADDRESS => 0x30002490,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01338_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_MEM_D_LD2                                               #
#                                                                        #
##########################################################################

%tio_01_01339_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MEM_RD_WR_DATA2"              => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01339_def =
( NAME    => "XCE_LSI1_MEM_D_LD2",
  ADDRESS => 0x30002498,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01339_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_MEM_D_LD3                                               #
#                                                                        #
##########################################################################

%tio_01_01340_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MEM_RD_WR_DATA3"              => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01340_def =
( NAME    => "XCE_LSI1_MEM_D_LD3",
  ADDRESS => 0x300024A0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01340_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_MEM_D_LD4                                               #
#                                                                        #
##########################################################################

%tio_01_01341_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MEM_RD_WR_DATA4"              => [   0,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01341_def =
( NAME    => "XCE_LSI1_MEM_D_LD4",
  ADDRESS => 0x300024A8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01341_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_RTY_D_CNT                                               #
#                                                                        #
##########################################################################

%tio_01_01342_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RTY_D_CNT"                    => [   0,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01342_def =
( NAME    => "XCE_LSI1_RTY_D_CNT",
  ADDRESS => 0x300024C0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01342_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_SEQ_BUF_CNT                                             #
#                                                                        #
##########################################################################

%tio_01_01343_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SEQ_BUF_CNT"                  => [   0,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01343_def =
( NAME    => "XCE_LSI1_SEQ_BUF_CNT",
  ADDRESS => 0x300024C8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01343_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_SEQ_BUF_BT_D                                            #
#                                                                        #
##########################################################################

%tio_01_01344_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SBUF_BDATA_PAR"               => [   0,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "SBDATA_SEQ_NUM"               => [   1,  18,  12, 0x000000003FFC0000, 0x00, 0, 0x0000000000000000, "" ],
   "SBDATA_RTY_PTR"               => [   2,   2,  16, 0x000000000003FFFC, 0x00, 0, 0x0000000000000000, "" ],
   "SBDATA_EOP_POS"               => [   3,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01344_def =
( NAME    => "XCE_LSI1_SEQ_BUF_BT_D",
  ADDRESS => 0x300024D0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01344_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_ACK_LAT_THR                                             #
#                                                                        #
##########################################################################

%tio_01_01345_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACK_LAT_THR"                  => [   0,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01345_def =
( NAME    => "XCE_LSI1_ACK_LAT_THR",
  ADDRESS => 0x300024E0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01345_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_NXT_RCV_SEQ_1_CNTR                                      #
#                                                                        #
##########################################################################

%tio_01_01346_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NXT_RCV_SEQ_1_CNTR"           => [   0,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01346_def =
( NAME    => "XCE_LSI1_NXT_RCV_SEQ_1_CNTR",
  ADDRESS => 0x30002500,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01346_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_UNSP_DLLP_RCVD                                          #
#                                                                        #
##########################################################################

%tio_01_01347_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DLLP_RCVD_BYTE3"              => [   0,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "" ],
   "DLLP_RCVD_BYTE2"              => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "DLLP_RCVD_BYTE1"              => [   2,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "DLLP_RCVD_BYTE0"              => [   3,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01347_def =
( NAME    => "XCE_LSI1_UNSP_DLLP_RCVD",
  ADDRESS => 0x30002508,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01347_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_RCV_LK_TS_CTL                                           #
#                                                                        #
##########################################################################

%tio_01_01348_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FRC_INIT_FLW_CTL_DLLP"        => [   0,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_DLLP_PERR"                => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01348_def =
( NAME    => "XCE_LSI1_RCV_LK_TS_CTL",
  ADDRESS => 0x30002510,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01348_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_PHY_LYR_CFG                                             #
#                                                                        #
##########################################################################

%tio_01_01349_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PHY_TS_MD_ENB"                => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "FST_SIM_MD"                   => [   1,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_DSBL_SCRAM"               => [   2,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_EXTD_SYNC_BIT"            => [   3,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNUSED_CTL_BITS"              => [   4,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "TX_ORD_SET_POSAM_VAL"         => [   5,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "TX_ORD_SET_BYTE_SEL"          => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "TX_ORD_SET_PREAM_VAL"         => [   7,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "TX_RDET_BYP_MD"               => [   8,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "TX_RDET_SF_MD"                => [   9,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PER_RPLC"                  => [  10,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01349_def =
( NAME    => "XCE_LSI1_PHY_LYR_CFG",
  ADDRESS => 0x30002600,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01349_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_PHY_LYR_INT_STAT                                        #
#                                                                        #
##########################################################################

%tio_01_01350_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PHY_LYR_ERR"                  => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "KCHAR_DLLP_ERR"               => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_END_POS"                 => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LK_ERR"                       => [   3,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "TRN_ERR"                      => [   4,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "EDB_DET"                      => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "SDP_WO_END"                   => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "STP_WO_END_EDB"               => [   7,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_PAD_POS"                 => [   8,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "MULT_SDP"                     => [   9,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "MULT_STP"                     => [  10,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_SDP_POS"                 => [  11,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_STP_POS"                 => [  12,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01350_def =
( NAME    => "XCE_LSI1_PHY_LYR_INT_STAT",
  ADDRESS => 0x30002610,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01350_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_PHY_LYR_INT_STAT_TEST                                     #
#                                                                        #
##########################################################################

%tio_01_01351_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "KCHAR_DLLP_ERR_TEST"          => [   0,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_END_POS_TEST"            => [   1,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LK_ERR_TEST"                  => [   2,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "TRN_ERR_TEST"                 => [   3,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "EDB_DET_TEST"                 => [   4,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "SDP_WO_END_TEST"              => [   5,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "STP_WO_END_EDB_TEST"          => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_PAD_POS_TEST"            => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "MULT_SDP_TEST"                => [   8,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "MULT_STP_TEST"                => [   9,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_SDP_POS_TEST"            => [  10,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_STP_POS_TEST"            => [  11,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01351_def =
( NAME    => "XCE_LSI1_PHY_LYR_INT_STAT_TEST",
  ADDRESS => 0x30002618,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01351_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_PHY_LYR_INT_MASK                                        #
#                                                                        #
##########################################################################

%tio_01_01352_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PHY_LYR_ERR_MASK"             => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "KCHAR_DLLP_ERR_MASK"          => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_END_POS_MASK"            => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LK_ERR_MASK"                  => [   3,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "TRN_ERR_MASK"                 => [   4,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "EDB_DET_MASK"                 => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "SDP_WO_END_MASK"              => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "STP_WO_END_EDB_MASK"          => [   7,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_PAD_POS_MASK"            => [   8,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "MULT_SDP_MASK"                => [   9,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "MULT_STP_MASK"                => [  10,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_SDP_POS_MASK"            => [  11,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_STP_POS_MASK"            => [  12,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01352_def =
( NAME    => "XCE_LSI1_PHY_LYR_INT_MASK",
  ADDRESS => 0x30002620,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01352_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_RCV_PHY_CFG                                             #
#                                                                        #
##########################################################################

%tio_01_01353_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCV_PHY_TS_MD"                => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ELAST_FIFO_MK_SEL"            => [   1,  16,   2, 0x0000000000030000, 0x00, 0, 0x0000000000000000, "" ],
   "RST_RCV_LN"                   => [   2,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01353_def =
( NAME    => "XCE_LSI1_RCV_PHY_CFG",
  ADDRESS => 0x30002680,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01353_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_RCV_PHY_STAT1                                           #
#                                                                        #
##########################################################################

%tio_01_01354_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ALGN_STAT"                    => [   0,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_PHY_STAT_LTSSM"           => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01354_def =
( NAME    => "XCE_LSI1_RCV_PHY_STAT1",
  ADDRESS => 0x30002688,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01354_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_RCV_PHY_STAT2                                           #
#                                                                        #
##########################################################################

%tio_01_01355_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCVD_DSBL_SCRAM"              => [   0,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_EN_LPBK"                 => [   1,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_DSBL_LK"                 => [   2,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_HOT_RST"                 => [   3,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_DATA_RT"                 => [   4,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_FTS_NUM"                 => [   5,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_LK_NUM"                  => [   6,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01355_def =
( NAME    => "XCE_LSI1_RCV_PHY_STAT2",
  ADDRESS => 0x30002690,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01355_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_RCV_PHY_STAT3                                           #
#                                                                        #
##########################################################################

%tio_01_01356_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "POL_RVSL"                     => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "BYTE_SYNC_STAT"               => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01356_def =
( NAME    => "XCE_LSI1_RCV_PHY_STAT3",
  ADDRESS => 0x30002698,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01356_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_RCV_PHY_INT_STAT                                        #
#                                                                        #
##########################################################################

%tio_01_01357_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCV_PHY_INT"                  => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ALGN_ERR"                     => [   1,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "ELAST_FIFO_OFLOW"             => [   2,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ELAST_FIFO_UFLOW"             => [   3,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01357_def =
( NAME    => "XCE_LSI1_RCV_PHY_INT_STAT",
  ADDRESS => 0x300026A0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01357_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_RCV_PHY_INT_STAT_TEST                                     #
#                                                                        #
##########################################################################

%tio_01_01358_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ALGN_ERR_TEST"                => [   0,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "ELAST_FIFO_OFLOW_TEST"        => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ELAST_FIFO_UFLOW_TEST"        => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01358_def =
( NAME    => "XCE_LSI1_RCV_PHY_INT_STAT_TEST",
  ADDRESS => 0x300026A8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01358_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_RCV_PHY_INT_MASK                                        #
#                                                                        #
##########################################################################

%tio_01_01359_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCV_PHY_INT_MASK"             => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ALGN_ERR_MASK"                => [   1,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "ELAST_FIFO_OFLOW_MASK"        => [   2,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ELAST_FIFO_UFLOW_MASK"        => [   3,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01359_def =
( NAME    => "XCE_LSI1_RCV_PHY_INT_MASK",
  ADDRESS => 0x300026B0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01359_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_TX_PHY_CFG                                              #
#                                                                        #
##########################################################################

%tio_01_01360_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FRC_RCV_DET"                  => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_ELE_IDL"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01360_def =
( NAME    => "XCE_LSI1_TX_PHY_CFG",
  ADDRESS => 0x30002700,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01360_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_TX_PHY_STAT                                             #
#                                                                        #
##########################################################################

%tio_01_01361_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NEG_LN_WD"                    => [   0,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PHY_SCRB_EN"               => [   1,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_LN_RVSL"                   => [   2,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_TS1_TS2_LN_PAD"            => [   3,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_TS1_TS2_LK_PAD"            => [   4,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PHY_FSM_ST"                => [   5,   0,  23, 0x00000000007FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01361_def =
( NAME    => "XCE_LSI1_TX_PHY_STAT",
  ADDRESS => 0x30002708,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01361_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_TX_PHY_INT_STAT                                         #
#                                                                        #
##########################################################################

%tio_01_01362_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ANY_UNMASK_INT"               => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_IDLE_INT"                => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_TS2_INT"                 => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_TS1_INT"                 => [   3,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_ERR"                      => [   4,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_DN_BK_BK"                 => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_ACK_DEC"                  => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_DN_DEC"                   => [   7,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_TRIG"                     => [   8,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_DET_VAL_VLD"              => [   9,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PERR"                      => [  10,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01362_def =
( NAME    => "XCE_LSI1_TX_PHY_INT_STAT",
  ADDRESS => 0x30002710,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01362_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_TX_PHY_INT_STAT_TEST                                     #
#                                                                        #
##########################################################################

%tio_01_01363_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCVD_IDLE_INT_TEST"           => [   0,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_TS2_INT_TEST"            => [   1,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_TS1_INT_TEST"            => [   2,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_ERR_TEST"                 => [   3,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_DN_BK_BK_TEST"            => [   4,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_ACK_DEC_TEST"             => [   5,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_DN_DEC_TEST"              => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_TRIG_TEST"                => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_DET_VAL_VLD_TEST"         => [   8,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PERR_TEST"                 => [   9,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01363_def =
( NAME    => "XCE_LSI1_TX_PHY_INT_STAT_TEST",
  ADDRESS => 0x30002718,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01363_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_TX_PHY_INT_MASK                                         #
#                                                                        #
##########################################################################

%tio_01_01364_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ANY_UNMASK_INT_MASK"          => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_IDLE_INT_MASK"           => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_TS2_INT_MASK"            => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_TS1_INT_MASK"            => [   3,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_ERR_MASK"                 => [   4,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_DN_BK_BK_MASK"            => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_ACK_DEC_MASK"             => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_DN_DEC_MASK"              => [   7,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_TRIG_MASK"                => [   8,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_DET_VAL_VLD_MASK"         => [   9,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PERR_MASK"                 => [  10,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01364_def =
( NAME    => "XCE_LSI1_TX_PHY_INT_MASK",
  ADDRESS => 0x30002720,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01364_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_TX_PHY_STAT2                                            #
#                                                                        #
##########################################################################

%tio_01_01365_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TX_PHY_RCVR_DET_PRES"         => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PHY_RCVR_DET_TERM_EN"      => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01365_def =
( NAME    => "XCE_LSI1_TX_PHY_STAT2",
  ADDRESS => 0x30002728,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01365_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LTSSM_CFG1                                              #
#                                                                        #
##########################################################################

%tio_01_01366_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LTSSM_TS_MD"                  => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "LPBK_MST"                     => [   1,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "" ],
   "HGR_DATA_RT_SUP"              => [   2,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_8_TO_VAL"               => [   3,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_20_TO_VAL"              => [   4,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01366_def =
( NAME    => "XCE_LSI1_LTSSM_CFG1",
  ADDRESS => 0x30002780,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01366_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LTSSM_CFG2                                              #
#                                                                        #
##########################################################################

%tio_01_01367_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TWELVE_MS_TIMER"              => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01367_def =
( NAME    => "XCE_LSI1_LTSSM_CFG2",
  ADDRESS => 0x30002788,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01367_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LTSSM_CFG3                                              #
#                                                                        #
##########################################################################

%tio_01_01368_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TWO_MS_TIMER"                 => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01368_def =
( NAME    => "XCE_LSI1_LTSSM_CFG3",
  ADDRESS => 0x30002790,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01368_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LTSSM_CFG4                                              #
#                                                                        #
##########################################################################

%tio_01_01369_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TX_TRN_CTL"                   => [   0,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_DATA_RT"                   => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_FTS_NUM"                   => [   2,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "LK_NUM"                       => [   3,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01369_def =
( NAME    => "XCE_LSI1_LTSSM_CFG4",
  ADDRESS => 0x30002798,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01369_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LTSSM_CFG5                                              #
#                                                                        #
##########################################################################

%tio_01_01370_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCVR_DET_TS_MD"               => [   0,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "POLL_COMP_DSBL"               => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "TXL0S_IDLE_TO_TXL0S_FTS"      => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "RXL0S_FTS_TO_REC_RCVRLK"      => [   3,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "LPBK_ENT_TO_LPBK_ACT"         => [   4,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "LPBK_ENT_TO_LPBK_EXT"         => [   5,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "LPBK_TO_LPBK_EXIT"            => [   6,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "L1_IDLE_TO_REC_RCVRLOCK"      => [   7,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "L0_TO_TRN_CTL_RST"            => [   8,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "L0_TO_LPBK"                   => [   9,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01370_def =
( NAME    => "XCE_LSI1_LTSSM_CFG5",
  ADDRESS => 0x300027A0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01370_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LTSSM_STAT1                                             #
#                                                                        #
##########################################################################

%tio_01_01371_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCV_LN_EN_MASK"               => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_ALG_CMD"                  => [   1,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "MST_LN_SEL"                   => [   2,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "LK_OP_RCV"                    => [   3,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "LK_OP_TX"                     => [   4,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "LN_REV"                       => [   5,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "LK_UP_DN_STAT"                => [   6,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_ST"                     => [   7,   4,   6, 0x00000000000003F0, 0x00, 0, 0x0000000000000000, "" ],
   "CFG_LK_WD"                    => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01371_def =
( NAME    => "XCE_LSI1_LTSSM_STAT1",
  ADDRESS => 0x300027A8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01371_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LTSSM_STAT2                                             #
#                                                                        #
##########################################################################

%tio_01_01372_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TX_CMD_TX_PHY"                => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_CMD_RCV_PHY"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01372_def =
( NAME    => "XCE_LSI1_LTSSM_STAT2",
  ADDRESS => 0x300027B0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01372_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LTSSM_INT_STAT                                          #
#                                                                        #
##########################################################################

%tio_01_01373_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LTSSM_INT_ACT"                => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_SKIP_OS"      => [   1,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_FTS"          => [   2,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS2_RECOV"    => [   3,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_8IDLE_DATA"   => [   4,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_IDLE_DATA"    => [   5,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_POLL"     => [   6,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_INV"      => [   7,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_EIDLE_EXIT"   => [   8,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_COMP"     => [   9,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_LB"       => [  10,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_DIS"      => [  11,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_RST"      => [  12,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_EIDLE"        => [  13,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS2"          => [  14,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS1"          => [  15,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_NONE"              => [  16,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01373_def =
( NAME    => "XCE_LSI1_LTSSM_INT_STAT",
  ADDRESS => 0x300027B8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01373_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LTSSM_INT_STAT_TEST                                     #
#                                                                        #
##########################################################################

%tio_01_01374_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LTSSM_INTR_RCVD_SKIP_OS_TEST" => [   0,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_FTS_TEST"     => [   1,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS2_RECOV_TEST" => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_8IDLE_DATA_TEST" => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_IDLE_DATA_TEST" => [   4,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_POLL_TEST" => [   5,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_INV_TEST" => [   6,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_EIDLE_EXIT_TEST" => [   7,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_COMP_TEST" => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_LB_TEST"  => [   9,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_DIS_TEST" => [  10,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_RST_TEST" => [  11,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_EIDLE_TEST"   => [  12,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS2_TEST"     => [  13,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS1_TEST"     => [  14,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_NONE_TEST"         => [  15,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01374_def =
( NAME    => "XCE_LSI1_LTSSM_INT_STAT_TEST",
  ADDRESS => 0x300027C0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01374_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LTSSM_INT_MASK                                          #
#                                                                        #
##########################################################################

%tio_01_01375_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LTSSM_INT_ACT_MASK"           => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_SKIP_OS_MASK" => [   1,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_FTS_MASK"     => [   2,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS2_RECOV_MASK" => [   3,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_8IDLE_DATA_MASK" => [   4,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_IDLE_DATA_MASK" => [   5,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_POLL_MASK" => [   6,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_INV_MASK" => [   7,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_EIDLE_EXIT_MASK" => [   8,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_COMP_MASK" => [   9,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_LB_MASK"  => [  10,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_DIS_MASK" => [  11,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_RST_MASK" => [  12,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_EIDLE_MASK"   => [  13,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS2_MASK"     => [  14,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS1_MASK"     => [  15,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_NONE_MASK"         => [  16,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01375_def =
( NAME    => "XCE_LSI1_LTSSM_INT_MASK",
  ADDRESS => 0x300027C8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01375_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_LTSSM_STAT_WR_EN                                        #
#                                                                        #
##########################################################################

%tio_01_01376_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WR_EN_LTSSM_STAT2_31_16"      => [   0,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT2_15_0"       => [   1,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_31_16"      => [   2,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_15"         => [   3,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_14"         => [   4,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_13"         => [   5,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_12"         => [   6,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_11"         => [   7,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_10"         => [   8,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_9_4"        => [   9,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_3_0"        => [  10,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01376_def =
( NAME    => "XCE_LSI1_LTSSM_STAT_WR_EN",
  ADDRESS => 0x300027D0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01376_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_GB_CFG1                                                 #
#                                                                        #
##########################################################################

%tio_01_01377_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SLF_TS_MD_SEL"                => [   0,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "" ],
   "RVRS_LPBK_TX_CLK_SEL"         => [   1,  20,   2, 0x0000000000300000, 0x00, 0, 0x0000000000000000, "" ],
   "RVRS_LB_MD"                   => [   2,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "" ],
   "LPBK_EN"                      => [   3,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "" ],
   "LPBK_MD_SEL"                  => [   4,  16,   2, 0x0000000000030000, 0x00, 0, 0x0000000000000000, "" ],
   "RXL0S_FLT_EN"                 => [   5,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "RXL0S_ADJ"                    => [   6,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "RXL0S_SMP_RT"                 => [   7,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "" ],
   "RXL0S_THS_CNT"                => [   8,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01377_def =
( NAME    => "XCE_LSI1_GB_CFG1",
  ADDRESS => 0x30002800,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01377_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_GB_CFG2                                                 #
#                                                                        #
##########################################################################

%tio_01_01378_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TX_VLT_PLS_CTL"               => [   0,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_VLT_MUX_CTL"               => [   1,  28,   2, 0x0000000030000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_RS_FL_SLW_CTL"             => [   2,  25,   3, 0x000000000E000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PRE_EPH_CTL"               => [   3,  22,   3, 0x0000000001C00000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_VLT_SW_CTL"                => [   4,  18,   4, 0x00000000003C0000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PLL_ZERO_CTL"              => [   5,  16,   2, 0x0000000000030000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PLL_PL_CTL"                => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_PLL_ZERO_CTL"             => [   7,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_PLL_PL_CTL"               => [   8,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_EQ_CTL"                   => [   9,   6,   4, 0x00000000000003C0, 0x00, 0, 0x0000000000000000, "" ],
   "OHM_50_75_SEL"                => [  10,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "RTRIM_EN"                     => [  11,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "TX_TERM"                      => [  12,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "" ],
   "RVC_TERM"                     => [  13,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01378_def =
( NAME    => "XCE_LSI1_GB_CFG2",
  ADDRESS => 0x30002808,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01378_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_GB_CFG3                                                 #
#                                                                        #
##########################################################################

%tio_01_01379_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "OUT_BIAS_CTL"                 => [   0,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_RCVR_DET_WIN"              => [   1,  24,   2, 0x0000000003000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_HLF_RT_CTL"                => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PLL_FDBK_DIV"              => [   3,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_HLF_RT_CTL"               => [   4,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_PLL_FDBK_DIV"             => [   5,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "BIT_LCK_TM"                   => [   6,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01379_def =
( NAME    => "XCE_LSI1_GB_CFG3",
  ADDRESS => 0x30002810,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01379_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_GB_CFG4                                                 #
#                                                                        #
##########################################################################

%tio_01_01380_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCV_PLL_LK_TM"                => [   0,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01380_def =
( NAME    => "XCE_LSI1_GB_CFG4",
  ADDRESS => 0x30002818,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01380_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_GB_STAT                                                 #
#                                                                        #
##########################################################################

%tio_01_01381_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCVD_ELEC_IDLE"               => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "BIT_SYNC_DN_STAT"             => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01381_def =
( NAME    => "XCE_LSI1_GB_STAT",
  ADDRESS => 0x30002820,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01381_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_GB_INT_STAT                                             #
#                                                                        #
##########################################################################

%tio_01_01382_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "GLB_UNMSK_INT"                => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "BYTE_SYNC_STAT_CHG"           => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01382_def =
( NAME    => "XCE_LSI1_GB_INT_STAT",
  ADDRESS => 0x30002828,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01382_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_GB_INT_STAT_TEST                                        #
#                                                                        #
##########################################################################

%tio_01_01383_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BYTE_SYNC_STAT_CHG_TEST"      => [   0,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01383_def =
( NAME    => "XCE_LSI1_GB_INT_STAT_TEST",
  ADDRESS => 0x30002830,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01383_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_GB_INT_MASK                                             #
#                                                                        #
##########################################################################

%tio_01_01384_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "GLB_UNMSK_INT_MASK"           => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "BYTE_SYNC_STAT_CHG_MASK"      => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01384_def =
( NAME    => "XCE_LSI1_GB_INT_MASK",
  ADDRESS => 0x30002838,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01384_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_GB_PWR_DN1                                              #
#                                                                        #
##########################################################################

%tio_01_01385_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TX_PWR_DN"                    => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_LN_PWR_DN"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01385_def =
( NAME    => "XCE_LSI1_GB_PWR_DN1",
  ADDRESS => 0x30002840,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01385_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI1_GB_PWR_DN2                                              #
#                                                                        #
##########################################################################

%tio_01_01386_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PWE_DN_CLK_BUF"               => [   0,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "" ],
   "PWR_DN_REST_TRM"              => [   1,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PLL_PWR_DN"                => [   2,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "" ],
   "RVC_RXL0S_PWR_DN"             => [   3,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01386_def =
( NAME    => "XCE_LSI1_GB_PWR_DN2",
  ADDRESS => 0x30002848,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01386_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LPU_ID                                                  #
#                                                                        #
##########################################################################

%tio_01_01387_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LK_TYPE_BW"                   => [   0,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "" ],
   "PHY_TYPE_LANE_W"              => [   1,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "" ],
   "TP_REV_ID"                    => [   2,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "" ],
   "LK_REV_ID"                    => [   3,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "" ],
   "PHY_REV_ID"                   => [   4,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "" ],
   "GB_REV_ID"                    => [   5,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01387_def =
( NAME    => "XCE_LSI2_LPU_ID",
  ADDRESS => 0x30003000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01387_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_RST_REG                                                 #
#                                                                        #
##########################################################################

%tio_01_01388_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RST_WE"                       => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "U_RST"                        => [   1,   9,   3, 0x0000000000000E00, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_ERR"                  => [   2,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_TXL"                  => [   3,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_RXL"                  => [   4,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_SML"                  => [   5,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_LTSSM"                => [   6,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_TXPHY"                => [   7,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_RXPHY"                => [   8,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_TXPCS"                => [   9,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "GLB_RST_RXPCS"                => [  10,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01388_def =
( NAME    => "XCE_LSI2_RST_REG",
  ADDRESS => 0x30003008,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01388_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_DBG_STAT                                                #
#                                                                        #
##########################################################################

%tio_01_01389_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DBG_B_STAT"                   => [   0,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "DBG_A_STAT"                   => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01389_def =
( NAME    => "XCE_LSI2_DBG_STAT",
  ADDRESS => 0x30003010,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01389_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_DBG_CFG                                                 #
#                                                                        #
##########################################################################

%tio_01_01390_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DBG_B_CFG"                    => [   0,  16,  12, 0x000000000FFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "DBG_A_CFG"                    => [   1,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01390_def =
( NAME    => "XCE_LSI2_DBG_CFG",
  ADDRESS => 0x30003018,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01390_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LTSSM_CTRL                                              #
#                                                                        #
##########################################################################

%tio_01_01391_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WR_EN"                        => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_TO_CFG"                   => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "L0_TO_RCV"                    => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "GOTO_DET_QUT"                 => [   3,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "DSBL_SCRAM_REQ"               => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "LK_LB_REQ"                    => [   5,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "LK_DSBL_REQ"                  => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "HOT_RST_REQ"                  => [   7,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01391_def =
( NAME    => "XCE_LSI2_LTSSM_CTRL",
  ADDRESS => 0x30003020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01391_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LK_STAT                                                 #
#                                                                        #
##########################################################################

%tio_01_01392_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SLT_CLK_CFG"                  => [   0,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "LK_TRN"                       => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "LK_TRN_ERR"                   => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "NEG_W"                        => [   3,   4,   6, 0x00000000000003F0, 0x00, 0, 0x0000000000000000, "" ],
   "LK_SPD"                       => [   4,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01392_def =
( NAME    => "XCE_LSI2_LK_STAT",
  ADDRESS => 0x30003028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01392_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_INT_AND_STAT                                            #
#                                                                        #
##########################################################################

%tio_01_01393_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_ACTV"                     => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "PERF_CNT2_OFLOW"              => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "PERF_CNT1_OFLOW"              => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "LK_INT"                       => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "PHY_ERR_INT"                  => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INT"                    => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PHY_INT"                   => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "RX_PHY_INT"                   => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "PHY_GB_INT"                   => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01393_def =
( NAME    => "XCE_LSI2_INT_AND_STAT",
  ADDRESS => 0x30003040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01393_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_INT_MASK                                                #
#                                                                        #
##########################################################################

%tio_01_01394_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INT_EN"                       => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "PERF_CNT2_OFLOW"              => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "PERF_CNT1_OFLOW"              => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "LK_MASK"                      => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "PHY_ERR_MASK"                 => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_MASK"                   => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PHY_MASK"                  => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "RX_PHY_MASK"                  => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "PHY_GB_MASK"                  => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01394_def =
( NAME    => "XCE_LSI2_INT_MASK",
  ADDRESS => 0x30003048,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01394_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LK_PERF_CNT_SEL                                         #
#                                                                        #
##########################################################################

%tio_01_01395_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PERF_CNT2_SEL"                => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "PERF_CNT1_SEL"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01395_def =
( NAME    => "XCE_LSI2_LK_PERF_CNT_SEL",
  ADDRESS => 0x30003100,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01395_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LK_PERF_CNT_CTRL                                        #
#                                                                        #
##########################################################################

%tio_01_01396_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SET_PERF_CNT_OFLOW2"          => [   0,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "SET_PERF_CNT_OFLOW1"          => [   1,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "RST_PERF_CNT2_OFLOW"          => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "RST_PERF_CNT2"                => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "RST_PERF_CNT1_OFLOW"          => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "RST_PERF_CNT1"                => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01396_def =
( NAME    => "XCE_LSI2_LK_PERF_CNT_CTRL",
  ADDRESS => 0x30003110,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01396_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LK_PERF_CNT1                                            #
#                                                                        #
##########################################################################

%tio_01_01397_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PERF_CNT1"                    => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01397_def =
( NAME    => "XCE_LSI2_LK_PERF_CNT1",
  ADDRESS => 0x30003120,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01397_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LK_PERF_CNT1_TEST                                       #
#                                                                        #
##########################################################################

%tio_01_01398_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PERF_CNT1_TEST"               => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01398_def =
( NAME    => "XCE_LSI2_LK_PERF_CNT1_TEST",
  ADDRESS => 0x30003128,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01398_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LK_PERF_CNT2                                            #
#                                                                        #
##########################################################################

%tio_01_01399_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PERF_CNT2"                    => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01399_def =
( NAME    => "XCE_LSI2_LK_PERF_CNT2",
  ADDRESS => 0x30003130,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01399_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LK_PERF_CNT2_TEST                                       #
#                                                                        #
##########################################################################

%tio_01_01400_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PERF_CNT2_TEST"               => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01400_def =
( NAME    => "XCE_LSI2_LK_PERF_CNT2_TEST",
  ADDRESS => 0x30003138,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01400_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LK_LYR_CFG                                              #
#                                                                        #
##########################################################################

%tio_01_01401_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "AUTO_UPDT_DSBL"               => [   0,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "" ],
   "FREQ_NAK_EN"                  => [   1,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "" ],
   "RPLY_POST_RECRY_EN"           => [   2,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "" ],
   "LAT_THRES_WR_EN"              => [   3,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "VC0_EN"                       => [   4,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "L0S_ADJ_FCT_EN"               => [   5,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "TLP_TX_FC_INIT2_EN"           => [   6,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "FRQ_ACK_EN"                   => [   7,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "RETRY_DSBL"                   => [   8,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01401_def =
( NAME    => "XCE_LSI2_LK_LYR_CFG",
  ADDRESS => 0x30003200,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01401_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LK_LYR_STATUS                                           #
#                                                                        #
##########################################################################

%tio_01_01402_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "INIT_FLW_CTL_SM_EN"           => [   0,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "LK_ST_DL_UP_EN"               => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "INIT_FLW_CTRL_SM_STAT"        => [   2,   4,   2, 0x0000000000000030, 0x00, 0, 0x0000000000000000, "" ],
   "DL_UP_STAT"                   => [   3,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "LK_SM_STAT"                   => [   4,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01402_def =
( NAME    => "XCE_LSI2_LK_LYR_STATUS",
  ADDRESS => 0x30003208,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01402_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LK_LYR_INT_STAT                                         #
#                                                                        #
##########################################################################

%tio_01_01403_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LK_ERR_ACT_INT"               => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNSUP_DLLP"                   => [   1,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "DLLP_RCV_ERR"                 => [   2,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_DLLP"                     => [   3,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "" ],
   "TLP_RCV_ERR"                  => [   4,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "" ],
   "SRC_ERR_TLP"                  => [   5,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_TLP"                      => [   6,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_UFLOW_ERR"            => [   7,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_OFLOW_ERR"            => [   8,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "EG_TLP_MIN_L_ERR"             => [   9,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "EG_TRUNC_FRM_ERR"             => [  10,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_PAR_ERR"              => [  11,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "EG_PAR_ERR"                   => [  12,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "RPLY_TMR_TO"                  => [  13,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "RPLY_NUM_RLVR"                => [  14,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "DATA_LK_PROT_ERR"             => [  15,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01403_def =
( NAME    => "XCE_LSI2_LK_LYR_INT_STAT",
  ADDRESS => 0x30003210,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01403_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LK_LY_INT_STAT_TEST                                     #
#                                                                        #
##########################################################################

%tio_01_01404_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "UNSUP_DLLP_TEST"              => [   0,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "DLLP_RCV_ERR_TEST"            => [   1,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_DLLP_TEST"                => [   2,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "" ],
   "TLP_RCV_ERR_TEST"             => [   3,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "" ],
   "SRC_ERR_TLP_TEST"             => [   4,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_TLP_TEST"                 => [   5,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_UFLOW_ERR_TEST"       => [   6,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_OFLOW_ERR_TEST"       => [   7,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "EG_TLP_MIN_L_ERR_TEST"        => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "EG_TRUNC_FRM_ERR_TEST"        => [   9,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_PAR_ERR_TEST"         => [  10,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "EG_PAR_ERR_TEST"              => [  11,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "RPLY_TMR_TO_TEST"             => [  12,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "RPLY_NUM_RLVR_TEST"           => [  13,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "DATA_LK_PROT_ERR_TEST"        => [  14,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01404_def =
( NAME    => "XCE_LSI2_LK_LY_INT_STAT_TEST",
  ADDRESS => 0x30003218,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01404_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LK_LY_INT_MASK                                          #
#                                                                        #
##########################################################################

%tio_01_01405_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LK_ERR_ACT_INT_MASK"          => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNSUP_DLLP_MASK"              => [   1,  22,   1, 0x0000000000400000, 0x00, 0, 0x0000000000000000, "" ],
   "DLLP_RCV_ERR_MASK"            => [   2,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_DLLP_MASK"                => [   3,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "" ],
   "TLP_RCV_ERR_MASK"             => [   4,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "" ],
   "SRC_ERR_TLP_MASK"             => [   5,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "" ],
   "BAD_TLP_MASK"                 => [   6,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_UFLOW_ERR_MASK"       => [   7,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_OFLOW_ERR_MASK"       => [   8,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "EG_TLP_MIN_L_ERR_MASK"        => [   9,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "EG_TRUNC_FRM_ERR_MASK"        => [  10,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_BUF_PAR_ERR_MASK"         => [  11,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "EG_PAR_ERR_MASK"              => [  12,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "RPLY_TMR_TO_MASK"             => [  13,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "RPLY_NUM_RLVR_MASK"           => [  14,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "DATA_LK_PROT_ERR_MASK"        => [  15,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01405_def =
( NAME    => "XCE_LSI2_LK_LY_INT_MASK",
  ADDRESS => 0x30003220,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01405_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_FC_UPD_CTL                                              #
#                                                                        #
##########################################################################

%tio_01_01406_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FC0_UPD_C_EN"                 => [   0,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "FC0_UPD_NP_EN"                => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "FC0_UPD_P_EN"                 => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01406_def =
( NAME    => "XCE_LSI2_FC_UPD_CTL",
  ADDRESS => 0x30003240,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01406_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_FLW_CTL_UPD_TO_TIMER                                     #
#                                                                        #
##########################################################################

%tio_01_01407_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FLW_CTL_TIMER_VAL"            => [   0,   0,  15, 0x0000000000007FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01407_def =
( NAME    => "XCE_LSI2_FLW_CTL_UPD_TO_TIMER",
  ADDRESS => 0x30003260,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01407_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_VC0_FLW_CTL_UPD_TIMER0                                     #
#                                                                        #
##########################################################################

%tio_01_01408_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC0_FLW_CTL_NP_TIMER_VAL"     => [   0,  16,  15, 0x000000007FFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "VC0_FLW_CTL_P_TIMER_VAL"      => [   1,   0,  15, 0x0000000000007FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01408_def =
( NAME    => "XCE_LSI2_VC0_FLW_CTL_UPD_TIMER0",
  ADDRESS => 0x30003268,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01408_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_VC0_FLW_CTL_UPD_TIMER1                                     #
#                                                                        #
##########################################################################

%tio_01_01409_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VC0_FLW_CTL_C_TIMER_VAL"      => [   0,   0,  15, 0x0000000000007FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01409_def =
( NAME    => "XCE_LSI2_VC0_FLW_CTL_UPD_TIMER1",
  ADDRESS => 0x30003270,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01409_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_FREQ_NAK_LAT_THRSH                                      #
#                                                                        #
##########################################################################

%tio_01_01410_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NAK_LAT_TIMER_THRSH"          => [   0,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01410_def =
( NAME    => "XCE_LSI2_FREQ_NAK_LAT_THRSH",
  ADDRESS => 0x30003400,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01410_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_ACK_NAK_LAT_TMR                                         #
#                                                                        #
##########################################################################

%tio_01_01411_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACKNAK_LATENCY_TIMER"         => [   0,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01411_def =
( NAME    => "XCE_LSI2_ACK_NAK_LAT_TMR",
  ADDRESS => 0x30003408,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01411_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_RPLY_TMR_THR                                            #
#                                                                        #
##########################################################################

%tio_01_01412_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RPLY_TMR_THR"                 => [   0,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01412_def =
( NAME    => "XCE_LSI2_RPLY_TMR_THR",
  ADDRESS => 0x30003410,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01412_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_RPLY_TMR                                                #
#                                                                        #
##########################################################################

%tio_01_01413_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RPLY_TMR_THR"                 => [   0,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01413_def =
( NAME    => "XCE_LSI2_RPLY_TMR",
  ADDRESS => 0x30003418,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01413_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_RPLY_NUM_STAT                                           #
#                                                                        #
##########################################################################

%tio_01_01414_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RPLY_NUMBER_CNT"              => [   0,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01414_def =
( NAME    => "XCE_LSI2_RPLY_NUM_STAT",
  ADDRESS => 0x30003420,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01414_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_RTY_BUF_MAX_ADDR                                        #
#                                                                        #
##########################################################################

%tio_01_01415_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RTY_BUF_MAX_ADDR"             => [   0,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01415_def =
( NAME    => "XCE_LSI2_RTY_BUF_MAX_ADDR",
  ADDRESS => 0x30003428,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01415_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_RTY_FIFO_PTR                                            #
#                                                                        #
##########################################################################

%tio_01_01416_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RTY_FIFO_TL_PTR"              => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_FIFO_HD_PTR"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01416_def =
( NAME    => "XCE_LSI2_RTY_FIFO_PTR",
  ADDRESS => 0x30003430,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01416_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_RTY_FIFO_RD_WR_PTR                                      #
#                                                                        #
##########################################################################

%tio_01_01417_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RTY_FIFO_WR_PTR"              => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "RTY_FIFO_RD_PTR"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01417_def =
( NAME    => "XCE_LSI2_RTY_FIFO_RD_WR_PTR",
  ADDRESS => 0x30003438,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01417_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_RTY_FIFO_CRED                                           #
#                                                                        #
##########################################################################

%tio_01_01418_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RTY_FIFO_CRED"                => [   0,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01418_def =
( NAME    => "XCE_LSI2_RTY_FIFO_CRED",
  ADDRESS => 0x30003440,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01418_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_SEQ_CNT                                                 #
#                                                                        #
##########################################################################

%tio_01_01419_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NXT_TX_SEQ_CNT_EN"            => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ACKD_SEQ_CNT_EN"              => [   1,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "ACKD_SEQ_CNT"                 => [   2,  16,  12, 0x000000000FFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "NXT_TX_SEQ_CNT"               => [   3,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01419_def =
( NAME    => "XCE_LSI2_SEQ_CNT",
  ADDRESS => 0x30003448,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01419_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_ACK_SENT_SEQ_NUM                                        #
#                                                                        #
##########################################################################

%tio_01_01420_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACK_SENT_SEQ_NUM"             => [   0,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01420_def =
( NAME    => "XCE_LSI2_ACK_SENT_SEQ_NUM",
  ADDRESS => 0x30003450,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01420_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_SEQ_CNT_FIFO_MAX_ADDR                                     #
#                                                                        #
##########################################################################

%tio_01_01421_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SEQ_CNT_FIFO_MAX_ADDR"        => [   0,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01421_def =
( NAME    => "XCE_LSI2_SEQ_CNT_FIFO_MAX_ADDR",
  ADDRESS => 0x30003458,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01421_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_SEQ_CNT_FIFO_PTR                                        #
#                                                                        #
##########################################################################

%tio_01_01422_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SEQ_CNT_TL_PTR"               => [   0,  16,  12, 0x000000000FFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "SEQ_CNT_HD_PTR"               => [   1,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01422_def =
( NAME    => "XCE_LSI2_SEQ_CNT_FIFO_PTR",
  ADDRESS => 0x30003460,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01422_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_SEQ_CNT_RD_WR_PTR                                       #
#                                                                        #
##########################################################################

%tio_01_01423_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SEQ_CNT_WR_PTR"               => [   0,  16,  12, 0x000000000FFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "SEQ_CNT_RD_PTR"               => [   1,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01423_def =
( NAME    => "XCE_LSI2_SEQ_CNT_RD_WR_PTR",
  ADDRESS => 0x30003468,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01423_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_TX_LK_TS_CTL                                            #
#                                                                        #
##########################################################################

%tio_01_01424_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DSB_ACKL"                     => [   0,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_NAK"                      => [   1,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_BD_TLP_CRC"               => [   2,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_RETX_TLP"                 => [   3,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01424_def =
( NAME    => "XCE_LSI2_TX_LK_TS_CTL",
  ADDRESS => 0x30003470,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01424_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_MEM_ADDR_CTL                                            #
#                                                                        #
##########################################################################

%tio_01_01425_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DONE"                         => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "GO_BIT"                       => [   1,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "RD_WR_SEL"                    => [   2,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "FIFO_SEL"                     => [   3,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "MEM_ADDR"                     => [   4,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01425_def =
( NAME    => "XCE_LSI2_MEM_ADDR_CTL",
  ADDRESS => 0x30003480,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01425_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_MEM_D_LD0                                               #
#                                                                        #
##########################################################################

%tio_01_01426_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MEM_RD_WR_DATA0"              => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01426_def =
( NAME    => "XCE_LSI2_MEM_D_LD0",
  ADDRESS => 0x30003488,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01426_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_MEM_D_LD1                                               #
#                                                                        #
##########################################################################

%tio_01_01427_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MEM_RD_WR_DATA1"              => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01427_def =
( NAME    => "XCE_LSI2_MEM_D_LD1",
  ADDRESS => 0x30003490,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01427_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_MEM_D_LD2                                               #
#                                                                        #
##########################################################################

%tio_01_01428_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MEM_RD_WR_DATA2"              => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01428_def =
( NAME    => "XCE_LSI2_MEM_D_LD2",
  ADDRESS => 0x30003498,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01428_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_MEM_D_LD3                                               #
#                                                                        #
##########################################################################

%tio_01_01429_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MEM_RD_WR_DATA3"              => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01429_def =
( NAME    => "XCE_LSI2_MEM_D_LD3",
  ADDRESS => 0x300034A0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01429_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_MEM_D_LD4                                               #
#                                                                        #
##########################################################################

%tio_01_01430_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MEM_RD_WR_DATA4"              => [   0,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01430_def =
( NAME    => "XCE_LSI2_MEM_D_LD4",
  ADDRESS => 0x300034A8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01430_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_RTY_D_CNT                                               #
#                                                                        #
##########################################################################

%tio_01_01431_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RTY_D_CNT"                    => [   0,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01431_def =
( NAME    => "XCE_LSI2_RTY_D_CNT",
  ADDRESS => 0x300034C0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01431_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_SEQ_BUF_CNT                                             #
#                                                                        #
##########################################################################

%tio_01_01432_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SEQ_BUF_CNT"                  => [   0,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01432_def =
( NAME    => "XCE_LSI2_SEQ_BUF_CNT",
  ADDRESS => 0x300034C8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01432_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_SEQ_BUF_BT_D                                            #
#                                                                        #
##########################################################################

%tio_01_01433_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SBUF_BDATA_PAR"               => [   0,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "SBDATA_SEQ_NUM"               => [   1,  18,  12, 0x000000003FFC0000, 0x00, 0, 0x0000000000000000, "" ],
   "SBDATA_RTY_PTR"               => [   2,   2,  16, 0x000000000003FFFC, 0x00, 0, 0x0000000000000000, "" ],
   "SBDATA_EOP_POS"               => [   3,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01433_def =
( NAME    => "XCE_LSI2_SEQ_BUF_BT_D",
  ADDRESS => 0x300034D0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01433_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_ACK_LAT_THR                                             #
#                                                                        #
##########################################################################

%tio_01_01434_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ACK_LAT_THR"                  => [   0,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01434_def =
( NAME    => "XCE_LSI2_ACK_LAT_THR",
  ADDRESS => 0x300034E0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01434_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_NXT_RCV_SEQ_1_CNTR                                      #
#                                                                        #
##########################################################################

%tio_01_01435_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NXT_RCV_SEQ_1_CNTR"           => [   0,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01435_def =
( NAME    => "XCE_LSI2_NXT_RCV_SEQ_1_CNTR",
  ADDRESS => 0x30003500,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01435_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_UNSP_DLLP_RCVD                                          #
#                                                                        #
##########################################################################

%tio_01_01436_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DLLP_RCVD_BYTE3"              => [   0,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "" ],
   "DLLP_RCVD_BYTE2"              => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "DLLP_RCVD_BYTE1"              => [   2,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "DLLP_RCVD_BYTE0"              => [   3,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01436_def =
( NAME    => "XCE_LSI2_UNSP_DLLP_RCVD",
  ADDRESS => 0x30003508,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01436_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_RCV_LK_TS_CTL                                           #
#                                                                        #
##########################################################################

%tio_01_01437_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FRC_INIT_FLW_CTL_DLLP"        => [   0,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_DLLP_PERR"                => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01437_def =
( NAME    => "XCE_LSI2_RCV_LK_TS_CTL",
  ADDRESS => 0x30003510,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01437_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_PHY_LYR_CFG                                             #
#                                                                        #
##########################################################################

%tio_01_01438_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PHY_TS_MD_ENB"                => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "FST_SIM_MD"                   => [   1,  30,   1, 0x0000000040000000, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_DSBL_SCRAM"               => [   2,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_EXTD_SYNC_BIT"            => [   3,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNUSED_CTL_BITS"              => [   4,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "TX_ORD_SET_POSAM_VAL"         => [   5,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "TX_ORD_SET_BYTE_SEL"          => [   6,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "TX_ORD_SET_PREAM_VAL"         => [   7,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "TX_RDET_BYP_MD"               => [   8,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "TX_RDET_SF_MD"                => [   9,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PER_RPLC"                  => [  10,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01438_def =
( NAME    => "XCE_LSI2_PHY_LYR_CFG",
  ADDRESS => 0x30003600,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01438_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_PHY_LYR_INT_STAT                                        #
#                                                                        #
##########################################################################

%tio_01_01439_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PHY_LYR_ERR"                  => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "KCHAR_DLLP_ERR"               => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_END_POS"                 => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LK_ERR"                       => [   3,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "TRN_ERR"                      => [   4,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "EDB_DET"                      => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "SDP_WO_END"                   => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "STP_WO_END_EDB"               => [   7,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_PAD_POS"                 => [   8,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "MULT_SDP"                     => [   9,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "MULT_STP"                     => [  10,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_SDP_POS"                 => [  11,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_STP_POS"                 => [  12,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01439_def =
( NAME    => "XCE_LSI2_PHY_LYR_INT_STAT",
  ADDRESS => 0x30003610,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01439_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_PHY_LYR_INT_STAT_TEST                                     #
#                                                                        #
##########################################################################

%tio_01_01440_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "KCHAR_DLLP_ERR_TEST"          => [   0,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_END_POS_TEST"            => [   1,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LK_ERR_TEST"                  => [   2,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "TRN_ERR_TEST"                 => [   3,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "EDB_DET_TEST"                 => [   4,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "SDP_WO_END_TEST"              => [   5,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "STP_WO_END_EDB_TEST"          => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_PAD_POS_TEST"            => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "MULT_SDP_TEST"                => [   8,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "MULT_STP_TEST"                => [   9,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_SDP_POS_TEST"            => [  10,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_STP_POS_TEST"            => [  11,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01440_def =
( NAME    => "XCE_LSI2_PHY_LYR_INT_STAT_TEST",
  ADDRESS => 0x30003618,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01440_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_PHY_LYR_INT_MASK                                        #
#                                                                        #
##########################################################################

%tio_01_01441_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PHY_LYR_ERR_MASK"             => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "KCHAR_DLLP_ERR_MASK"          => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_END_POS_MASK"            => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LK_ERR_MASK"                  => [   3,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "TRN_ERR_MASK"                 => [   4,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "EDB_DET_MASK"                 => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "SDP_WO_END_MASK"              => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "STP_WO_END_EDB_MASK"          => [   7,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_PAD_POS_MASK"            => [   8,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "MULT_SDP_MASK"                => [   9,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "MULT_STP_MASK"                => [  10,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_SDP_POS_MASK"            => [  11,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ILGL_STP_POS_MASK"            => [  12,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01441_def =
( NAME    => "XCE_LSI2_PHY_LYR_INT_MASK",
  ADDRESS => 0x30003620,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01441_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_RCV_PHY_CFG                                             #
#                                                                        #
##########################################################################

%tio_01_01442_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCV_PHY_TS_MD"                => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ELAST_FIFO_MK_SEL"            => [   1,  16,   2, 0x0000000000030000, 0x00, 0, 0x0000000000000000, "" ],
   "RST_RCV_LN"                   => [   2,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01442_def =
( NAME    => "XCE_LSI2_RCV_PHY_CFG",
  ADDRESS => 0x30003680,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01442_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_RCV_PHY_STAT1                                           #
#                                                                        #
##########################################################################

%tio_01_01443_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ALGN_STAT"                    => [   0,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_PHY_STAT_LTSSM"           => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01443_def =
( NAME    => "XCE_LSI2_RCV_PHY_STAT1",
  ADDRESS => 0x30003688,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01443_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_RCV_PHY_STAT2                                           #
#                                                                        #
##########################################################################

%tio_01_01444_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCVD_DSBL_SCRAM"              => [   0,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_EN_LPBK"                 => [   1,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_DSBL_LK"                 => [   2,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_HOT_RST"                 => [   3,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_DATA_RT"                 => [   4,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_FTS_NUM"                 => [   5,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_LK_NUM"                  => [   6,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01444_def =
( NAME    => "XCE_LSI2_RCV_PHY_STAT2",
  ADDRESS => 0x30003690,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01444_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_RCV_PHY_STAT3                                           #
#                                                                        #
##########################################################################

%tio_01_01445_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "POL_RVSL"                     => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "BYTE_SYNC_STAT"               => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01445_def =
( NAME    => "XCE_LSI2_RCV_PHY_STAT3",
  ADDRESS => 0x30003698,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01445_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_RCV_PHY_INT_STAT                                        #
#                                                                        #
##########################################################################

%tio_01_01446_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCV_PHY_INT"                  => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ALGN_ERR"                     => [   1,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "ELAST_FIFO_OFLOW"             => [   2,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ELAST_FIFO_UFLOW"             => [   3,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01446_def =
( NAME    => "XCE_LSI2_RCV_PHY_INT_STAT",
  ADDRESS => 0x300036A0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01446_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_RCV_PHY_INT_STAT_TEST                                     #
#                                                                        #
##########################################################################

%tio_01_01447_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ALGN_ERR_TEST"                => [   0,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "ELAST_FIFO_OFLOW_TEST"        => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ELAST_FIFO_UFLOW_TEST"        => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01447_def =
( NAME    => "XCE_LSI2_RCV_PHY_INT_STAT_TEST",
  ADDRESS => 0x300036A8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01447_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_RCV_PHY_INT_MASK                                        #
#                                                                        #
##########################################################################

%tio_01_01448_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCV_PHY_INT_MASK"             => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "ALGN_ERR_MASK"                => [   1,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "ELAST_FIFO_OFLOW_MASK"        => [   2,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ELAST_FIFO_UFLOW_MASK"        => [   3,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01448_def =
( NAME    => "XCE_LSI2_RCV_PHY_INT_MASK",
  ADDRESS => 0x300036B0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01448_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_TX_PHY_CFG                                              #
#                                                                        #
##########################################################################

%tio_01_01449_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FRC_RCV_DET"                  => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "FRC_ELE_IDL"                  => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01449_def =
( NAME    => "XCE_LSI2_TX_PHY_CFG",
  ADDRESS => 0x30003700,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01449_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_TX_PHY_STAT                                             #
#                                                                        #
##########################################################################

%tio_01_01450_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NEG_LN_WD"                    => [   0,  28,   4, 0x00000000F0000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PHY_SCRB_EN"               => [   1,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_LN_RVSL"                   => [   2,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_TS1_TS2_LN_PAD"            => [   3,  25,   1, 0x0000000002000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_TS1_TS2_LK_PAD"            => [   4,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PHY_FSM_ST"                => [   5,   0,  23, 0x00000000007FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01450_def =
( NAME    => "XCE_LSI2_TX_PHY_STAT",
  ADDRESS => 0x30003708,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01450_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_TX_PHY_INT_STAT                                         #
#                                                                        #
##########################################################################

%tio_01_01451_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ANY_UNMASK_INT"               => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_IDLE_INT"                => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_TS2_INT"                 => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_TS1_INT"                 => [   3,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_ERR"                      => [   4,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_DN_BK_BK"                 => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_ACK_DEC"                  => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_DN_DEC"                   => [   7,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_TRIG"                     => [   8,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_DET_VAL_VLD"              => [   9,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PERR"                      => [  10,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01451_def =
( NAME    => "XCE_LSI2_TX_PHY_INT_STAT",
  ADDRESS => 0x30003710,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01451_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_TX_PHY_INT_STAT_TEST                                     #
#                                                                        #
##########################################################################

%tio_01_01452_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCVD_IDLE_INT_TEST"           => [   0,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_TS2_INT_TEST"            => [   1,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_TS1_INT_TEST"            => [   2,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_ERR_TEST"                 => [   3,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_DN_BK_BK_TEST"            => [   4,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_ACK_DEC_TEST"             => [   5,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_DN_DEC_TEST"              => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_TRIG_TEST"                => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_DET_VAL_VLD_TEST"         => [   8,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PERR_TEST"                 => [   9,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01452_def =
( NAME    => "XCE_LSI2_TX_PHY_INT_STAT_TEST",
  ADDRESS => 0x30003718,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01452_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_TX_PHY_INT_MASK                                         #
#                                                                        #
##########################################################################

%tio_01_01453_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ANY_UNMASK_INT_MASK"          => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_IDLE_INT_MASK"           => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_TS2_INT_MASK"            => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "RCVD_TS1_INT_MASK"            => [   3,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_ERR_MASK"                 => [   4,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_DN_BK_BK_MASK"            => [   5,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_ACK_DEC_MASK"             => [   6,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_DN_DEC_MASK"              => [   7,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "SKP_TRIG_MASK"                => [   8,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_DET_VAL_VLD_MASK"         => [   9,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PERR_MASK"                 => [  10,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01453_def =
( NAME    => "XCE_LSI2_TX_PHY_INT_MASK",
  ADDRESS => 0x30003720,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01453_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_TX_PHY_STAT2                                            #
#                                                                        #
##########################################################################

%tio_01_01454_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TX_PHY_RCVR_DET_PRES"         => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PHY_RCVR_DET_TERM_EN"      => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01454_def =
( NAME    => "XCE_LSI2_TX_PHY_STAT2",
  ADDRESS => 0x30003728,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01454_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LTSSM_CFG1                                              #
#                                                                        #
##########################################################################

%tio_01_01455_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LTSSM_TS_MD"                  => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "LPBK_MST"                     => [   1,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "" ],
   "HGR_DATA_RT_SUP"              => [   2,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_8_TO_VAL"               => [   3,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_20_TO_VAL"              => [   4,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01455_def =
( NAME    => "XCE_LSI2_LTSSM_CFG1",
  ADDRESS => 0x30003780,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01455_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LTSSM_CFG2                                              #
#                                                                        #
##########################################################################

%tio_01_01456_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TWELVE_MS_TIMER"              => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01456_def =
( NAME    => "XCE_LSI2_LTSSM_CFG2",
  ADDRESS => 0x30003788,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01456_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LTSSM_CFG3                                              #
#                                                                        #
##########################################################################

%tio_01_01457_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TWO_MS_TIMER"                 => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01457_def =
( NAME    => "XCE_LSI2_LTSSM_CFG3",
  ADDRESS => 0x30003790,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01457_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LTSSM_CFG4                                              #
#                                                                        #
##########################################################################

%tio_01_01458_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TX_TRN_CTL"                   => [   0,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_DATA_RT"                   => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_FTS_NUM"                   => [   2,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "LK_NUM"                       => [   3,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01458_def =
( NAME    => "XCE_LSI2_LTSSM_CFG4",
  ADDRESS => 0x30003798,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01458_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LTSSM_CFG5                                              #
#                                                                        #
##########################################################################

%tio_01_01459_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCVR_DET_TS_MD"               => [   0,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "POLL_COMP_DSBL"               => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "TXL0S_IDLE_TO_TXL0S_FTS"      => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "RXL0S_FTS_TO_REC_RCVRLK"      => [   3,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "LPBK_ENT_TO_LPBK_ACT"         => [   4,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "LPBK_ENT_TO_LPBK_EXT"         => [   5,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "LPBK_TO_LPBK_EXIT"            => [   6,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "L1_IDLE_TO_REC_RCVRLOCK"      => [   7,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "L0_TO_TRN_CTL_RST"            => [   8,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "L0_TO_LPBK"                   => [   9,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01459_def =
( NAME    => "XCE_LSI2_LTSSM_CFG5",
  ADDRESS => 0x300037A0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01459_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LTSSM_STAT1                                             #
#                                                                        #
##########################################################################

%tio_01_01460_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCV_LN_EN_MASK"               => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_ALG_CMD"                  => [   1,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "MST_LN_SEL"                   => [   2,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "LK_OP_RCV"                    => [   3,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "LK_OP_TX"                     => [   4,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "LN_REV"                       => [   5,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "LK_UP_DN_STAT"                => [   6,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_ST"                     => [   7,   4,   6, 0x00000000000003F0, 0x00, 0, 0x0000000000000000, "" ],
   "CFG_LK_WD"                    => [   8,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01460_def =
( NAME    => "XCE_LSI2_LTSSM_STAT1",
  ADDRESS => 0x300037A8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01460_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LTSSM_STAT2                                             #
#                                                                        #
##########################################################################

%tio_01_01461_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TX_CMD_TX_PHY"                => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_CMD_RCV_PHY"              => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01461_def =
( NAME    => "XCE_LSI2_LTSSM_STAT2",
  ADDRESS => 0x300037B0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01461_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LTSSM_INT_STAT                                          #
#                                                                        #
##########################################################################

%tio_01_01462_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LTSSM_INT_ACT"                => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_SKIP_OS"      => [   1,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_FTS"          => [   2,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS2_RECOV"    => [   3,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_8IDLE_DATA"   => [   4,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_IDLE_DATA"    => [   5,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_POLL"     => [   6,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_INV"      => [   7,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_EIDLE_EXIT"   => [   8,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_COMP"     => [   9,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_LB"       => [  10,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_DIS"      => [  11,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_RST"      => [  12,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_EIDLE"        => [  13,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS2"          => [  14,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS1"          => [  15,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_NONE"              => [  16,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01462_def =
( NAME    => "XCE_LSI2_LTSSM_INT_STAT",
  ADDRESS => 0x300037B8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01462_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LTSSM_INT_STAT_TEST                                     #
#                                                                        #
##########################################################################

%tio_01_01463_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LTSSM_INTR_RCVD_SKIP_OS_TEST" => [   0,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_FTS_TEST"     => [   1,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS2_RECOV_TEST" => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_8IDLE_DATA_TEST" => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_IDLE_DATA_TEST" => [   4,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_POLL_TEST" => [   5,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_INV_TEST" => [   6,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_EIDLE_EXIT_TEST" => [   7,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_COMP_TEST" => [   8,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_LB_TEST"  => [   9,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_DIS_TEST" => [  10,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_RST_TEST" => [  11,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_EIDLE_TEST"   => [  12,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS2_TEST"     => [  13,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS1_TEST"     => [  14,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_NONE_TEST"         => [  15,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01463_def =
( NAME    => "XCE_LSI2_LTSSM_INT_STAT_TEST",
  ADDRESS => 0x300037C0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01463_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LTSSM_INT_MASK                                          #
#                                                                        #
##########################################################################

%tio_01_01464_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LTSSM_INT_ACT_MASK"           => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_SKIP_OS_MASK" => [   1,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_FTS_MASK"     => [   2,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS2_RECOV_MASK" => [   3,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_8IDLE_DATA_MASK" => [   4,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_IDLE_DATA_MASK" => [   5,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_POLL_MASK" => [   6,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_INV_MASK" => [   7,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_EIDLE_EXIT_MASK" => [   8,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_COMP_MASK" => [   9,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_LB_MASK"  => [  10,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_DIS_MASK" => [  11,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TSX_RST_MASK" => [  12,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_EIDLE_MASK"   => [  13,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS2_MASK"     => [  14,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_RCVD_TS1_MASK"     => [  15,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "LTSSM_INTR_NONE_MASK"         => [  16,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01464_def =
( NAME    => "XCE_LSI2_LTSSM_INT_MASK",
  ADDRESS => 0x300037C8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01464_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_LTSSM_STAT_WR_EN                                        #
#                                                                        #
##########################################################################

%tio_01_01465_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "WR_EN_LTSSM_STAT2_31_16"      => [   0,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT2_15_0"       => [   1,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_31_16"      => [   2,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_15"         => [   3,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_14"         => [   4,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_13"         => [   5,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_12"         => [   6,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_11"         => [   7,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_10"         => [   8,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_9_4"        => [   9,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "WR_EN_LTSSM_STAT1_3_0"        => [  10,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01465_def =
( NAME    => "XCE_LSI2_LTSSM_STAT_WR_EN",
  ADDRESS => 0x300037D0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01465_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_GB_CFG1                                                 #
#                                                                        #
##########################################################################

%tio_01_01466_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SLF_TS_MD_SEL"                => [   0,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "" ],
   "RVRS_LPBK_TX_CLK_SEL"         => [   1,  20,   2, 0x0000000000300000, 0x00, 0, 0x0000000000000000, "" ],
   "RVRS_LB_MD"                   => [   2,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "" ],
   "LPBK_EN"                      => [   3,  18,   1, 0x0000000000040000, 0x00, 0, 0x0000000000000000, "" ],
   "LPBK_MD_SEL"                  => [   4,  16,   2, 0x0000000000030000, 0x00, 0, 0x0000000000000000, "" ],
   "RXL0S_FLT_EN"                 => [   5,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "RXL0S_ADJ"                    => [   6,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "RXL0S_SMP_RT"                 => [   7,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "" ],
   "RXL0S_THS_CNT"                => [   8,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01466_def =
( NAME    => "XCE_LSI2_GB_CFG1",
  ADDRESS => 0x30003800,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01466_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_GB_CFG2                                                 #
#                                                                        #
##########################################################################

%tio_01_01467_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TX_VLT_PLS_CTL"               => [   0,  30,   2, 0x00000000C0000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_VLT_MUX_CTL"               => [   1,  28,   2, 0x0000000030000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_RS_FL_SLW_CTL"             => [   2,  25,   3, 0x000000000E000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PRE_EPH_CTL"               => [   3,  22,   3, 0x0000000001C00000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_VLT_SW_CTL"                => [   4,  18,   4, 0x00000000003C0000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PLL_ZERO_CTL"              => [   5,  16,   2, 0x0000000000030000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PLL_PL_CTL"                => [   6,  14,   2, 0x000000000000C000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_PLL_ZERO_CTL"             => [   7,  12,   2, 0x0000000000003000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_PLL_PL_CTL"               => [   8,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_EQ_CTL"                   => [   9,   6,   4, 0x00000000000003C0, 0x00, 0, 0x0000000000000000, "" ],
   "OHM_50_75_SEL"                => [  10,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "RTRIM_EN"                     => [  11,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "TX_TERM"                      => [  12,   2,   2, 0x000000000000000C, 0x00, 0, 0x0000000000000000, "" ],
   "RVC_TERM"                     => [  13,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01467_def =
( NAME    => "XCE_LSI2_GB_CFG2",
  ADDRESS => 0x30003808,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01467_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_GB_CFG3                                                 #
#                                                                        #
##########################################################################

%tio_01_01468_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "OUT_BIAS_CTL"                 => [   0,  26,   1, 0x0000000004000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_RCVR_DET_WIN"              => [   1,  24,   2, 0x0000000003000000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_HLF_RT_CTL"                => [   2,  23,   1, 0x0000000000800000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PLL_FDBK_DIV"              => [   3,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_HLF_RT_CTL"               => [   4,  19,   1, 0x0000000000080000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_PLL_FDBK_DIV"             => [   5,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "BIT_LCK_TM"                   => [   6,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01468_def =
( NAME    => "XCE_LSI2_GB_CFG3",
  ADDRESS => 0x30003810,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01468_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_GB_CFG4                                                 #
#                                                                        #
##########################################################################

%tio_01_01469_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCV_PLL_LK_TM"                => [   0,   0,  20, 0x00000000000FFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01469_def =
( NAME    => "XCE_LSI2_GB_CFG4",
  ADDRESS => 0x30003818,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01469_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_GB_STAT                                                 #
#                                                                        #
##########################################################################

%tio_01_01470_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RCVD_ELEC_IDLE"               => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "BIT_SYNC_DN_STAT"             => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01470_def =
( NAME    => "XCE_LSI2_GB_STAT",
  ADDRESS => 0x30003820,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01470_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_GB_INT_STAT                                             #
#                                                                        #
##########################################################################

%tio_01_01471_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "GLB_UNMSK_INT"                => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "BYTE_SYNC_STAT_CHG"           => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01471_def =
( NAME    => "XCE_LSI2_GB_INT_STAT",
  ADDRESS => 0x30003828,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01471_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_GB_INT_STAT_TEST                                        #
#                                                                        #
##########################################################################

%tio_01_01472_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BYTE_SYNC_STAT_CHG_TEST"      => [   0,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01472_def =
( NAME    => "XCE_LSI2_GB_INT_STAT_TEST",
  ADDRESS => 0x30003830,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01472_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_GB_INT_MASK                                             #
#                                                                        #
##########################################################################

%tio_01_01473_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "GLB_UNMSK_INT_MASK"           => [   0,  31,   1, 0x0000000080000000, 0x00, 0, 0x0000000000000000, "" ],
   "BYTE_SYNC_STAT_CHG_MASK"      => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01473_def =
( NAME    => "XCE_LSI2_GB_INT_MASK",
  ADDRESS => 0x30003838,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01473_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_GB_PWR_DN1                                              #
#                                                                        #
##########################################################################

%tio_01_01474_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TX_PWR_DN"                    => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "RCV_LN_PWR_DN"                => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01474_def =
( NAME    => "XCE_LSI2_GB_PWR_DN1",
  ADDRESS => 0x30003840,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01474_flds
);


##########################################################################
#                                                                        #
#   XCE_LSI2_GB_PWR_DN2                                              #
#                                                                        #
##########################################################################

%tio_01_01475_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PWE_DN_CLK_BUF"               => [   0,  21,   1, 0x0000000000200000, 0x00, 0, 0x0000000000000000, "" ],
   "PWR_DN_REST_TRM"              => [   1,  20,   1, 0x0000000000100000, 0x00, 0, 0x0000000000000000, "" ],
   "TX_PLL_PWR_DN"                => [   2,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "" ],
   "RVC_RXL0S_PWR_DN"             => [   3,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01475_def =
( NAME    => "XCE_LSI2_GB_PWR_DN2",
  ADDRESS => 0x30003848,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01475_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_MAINT_BAP_BUF_DATA63_0                                     #
#                                                                        #
##########################################################################

%tio_01_01476_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01476_def =
( NAME    => "XCE_ADM_MAINT_BAP_BUF_DATA63_0",
  ADDRESS => 0x30024000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01476_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_MAINT_BAP_BUF_DATA127_64                                     #
#                                                                        #
##########################################################################

%tio_01_01477_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,  64,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01477_def =
( NAME    => "XCE_ADM_MAINT_BAP_BUF_DATA127_64",
  ADDRESS => 0x30024800,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01477_flds
);


##########################################################################
#                                                                        #
#   XCE_ADM_MAINT_BAP_BUF_PARITY                                     #
#                                                                        #
##########################################################################

%tio_01_01478_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PARITY"                       => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01478_def =
( NAME    => "XCE_ADM_MAINT_BAP_BUF_PARITY",
  ADDRESS => 0x30025000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01478_flds
);


##########################################################################
#                                                                        #
#   XCE_CRM_DEBUG_MUX                                                #
#                                                                        #
##########################################################################

%tio_01_01479_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_NIB7_SEL"               => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_GRP7_SEL"               => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB6_SEL"               => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_GRP6_SEL"               => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB5_SEL"               => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_GRP5_SEL"               => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB4_SEL"               => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_GRP4_SEL"               => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB3_SEL"               => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_GRP3_SEL"               => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB2_SEL"               => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_GRP2_SEL"               => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB1_SEL"               => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_GRP1_SEL"               => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB0_SEL"               => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_GRP0_SEL"               => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01479_def =
( NAME    => "XCE_CRM_DEBUG_MUX",
  ADDRESS => 0x30004050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01479_flds
);


##########################################################################
#                                                                        #
#   XCE_CRM_SSP_ERR_CMD_WRD                                          #
#                                                                        #
##########################################################################

%tio_01_01480_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CMD_WRD"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01480_def =
( NAME    => "XCE_CRM_SSP_ERR_CMD_WRD",
  ADDRESS => 0x30004060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01480_flds
);


##########################################################################
#                                                                        #
#   XCE_CRM_SSP_ERR_ADDR                                             #
#                                                                        #
##########################################################################

%tio_01_01481_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CMD_WRD_VALID"                => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKT_ADDR"                     => [   1,   0,  54, 0x003FFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01481_def =
( NAME    => "XCE_CRM_SSP_ERR_ADDR",
  ADDRESS => 0x30004068,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01481_flds
);


##########################################################################
#                                                                        #
#   XCE_CRM_SSP_ERR_SYN                                              #
#                                                                        #
##########################################################################

%tio_01_01482_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SYN_MBE"                      => [   0,  24,   2, 0x0000000003000000, 0x00, 0, 0x0000000000000000, "" ],
   "SYN_SBE"                      => [   1,  16,   2, 0x0000000000030000, 0x00, 0, 0x0000000000000000, "" ],
   "SYN_HI"                       => [   2,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "SYN_LO"                       => [   3,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01482_def =
( NAME    => "XCE_CRM_SSP_ERR_SYN",
  ADDRESS => 0x30004070,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01482_flds
);


##########################################################################
#                                                                        #
#   XCE_CXM_DYN_CREDIT_STATUS                                        #
#                                                                        #
##########################################################################

%tio_01_01483_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SSP_RSP_CREDIT_RCVD"          => [   0,  40,   6, 0x00003F0000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_CREDIT_RCVD"          => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_CREDIT_USED"              => [   2,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_CREDIT_SENT"              => [   3,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_REQ_CREDIT_USED"          => [   4,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_REQ_CREDIT_SENT"          => [   5,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_RSP_CREDIT_USED"          => [   6,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_RSP_CREDIT_SENT"          => [   7,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_CREDIT_USED"              => [   8,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_CREDIT_SENT"              => [   9,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01483_def =
( NAME    => "XCE_CXM_DYN_CREDIT_STATUS",
  ADDRESS => 0x30005010,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01483_flds
);


##########################################################################
#                                                                        #
#   XCE_CXM_LAST_CREDIT_STATUS                                       #
#                                                                        #
##########################################################################

%tio_01_01484_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SSP_RSP_CREDIT_RCVD"          => [   0,  40,   5, 0x00001F0000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_REQ_CREDIT_RCVD"          => [   1,  32,   5, 0x0000001F00000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_CREDIT_USED"              => [   2,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_CREDIT_SENT"              => [   3,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_REQ_CREDITS_USED"         => [   4,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_REQ_CREDIT_SENT"          => [   5,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_RSP_CREDITS_USED"         => [   6,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_RSP_CREDIT_SENT"          => [   7,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_CREDIT_USED"              => [   8,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_CREDIT_SENT"              => [   9,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01484_def =
( NAME    => "XCE_CXM_LAST_CREDIT_STATUS",
  ADDRESS => 0x30005018,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01484_flds
);


##########################################################################
#                                                                        #
#   XCE_CXM_CREDIT_LIMIT                                             #
#                                                                        #
##########################################################################

%tio_01_01485_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "URE_CREDIT_LIMIT"             => [   0,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_REQ_CREDIT_LIMIT"         => [   1,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_RSP_CREDIT_LIMIT"         => [   2,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_CREDIT_LIMIT"             => [   3,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01485_def =
( NAME    => "XCE_CXM_CREDIT_LIMIT",
  ADDRESS => 0x30005020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01485_flds
);


##########################################################################
#                                                                        #
#   XCE_CXM_FORCE_CREDIT                                             #
#                                                                        #
##########################################################################

%tio_01_01486_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "URE_FORCE_CREDIT"             => [   0,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_RSP_FORCE_CREDIT"         => [   1,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_REQ_FORCE_CREDIT"         => [   2,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "DRE_FORCE_CREDIT"             => [   3,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01486_def =
( NAME    => "XCE_CXM_FORCE_CREDIT",
  ADDRESS => 0x30005028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01486_flds
);


##########################################################################
#                                                                        #
#   XCE_CXM_DISABLE_BYPASS                                           #
#                                                                        #
##########################################################################

%tio_01_01487_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SEL"                          => [   0,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01487_def =
( NAME    => "XCE_CXM_DISABLE_BYPASS",
  ADDRESS => 0x30005030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01487_flds
);


##########################################################################
#                                                                        #
#   XCE_CXM_DEBUG_MUX                                                #
#                                                                        #
##########################################################################

%tio_01_01488_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_NIB7_SEL"               => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT7_SEL"              => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB6_SEL"               => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT6_SEL"              => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB5_SEL"               => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT5_SEL"              => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB4_SEL"               => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT4_SEL"              => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB3_SEL"               => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT3_SEL"              => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB2_SEL"               => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT2_SEL"              => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB1_SEL"               => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT1_SEL"              => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB0_SEL"               => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT0_SEL"              => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01488_def =
( NAME    => "XCE_CXM_DEBUG_MUX",
  ADDRESS => 0x30005050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01488_flds
);


##########################################################################
#                                                                        #
#   XCE_DTL1_DTDR_CREDIT_LIMIT                                       #
#                                                                        #
##########################################################################

%tio_01_01489_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DRQCL"                        => [   0,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "" ],
   "DRSCL"                        => [   1,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "" ],
   "DMSCL"                        => [   2,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01489_def =
( NAME    => "XCE_DTL1_DTDR_CREDIT_LIMIT",
  ADDRESS => 0x30006000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01489_flds
);


##########################################################################
#                                                                        #
#   XCE_DTL1_DTDR_CREDIT_FORCE                                       #
#                                                                        #
##########################################################################

%tio_01_01490_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DRQCF"                        => [   0,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "" ],
   "DRSCF"                        => [   1,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "" ],
   "DMSCF"                        => [   2,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01490_def =
( NAME    => "XCE_DTL1_DTDR_CREDIT_FORCE",
  ADDRESS => 0x30006008,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01490_flds
);


##########################################################################
#                                                                        #
#   XCE_DTL1_DTL_DYN_CREDIT_STATUS                                     #
#                                                                        #
##########################################################################

%tio_01_01491_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DRQCC"                        => [   0,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "" ],
   "DRSCC"                        => [   1,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "" ],
   "DMSCC"                        => [   2,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01491_def =
( NAME    => "XCE_DTL1_DTL_DYN_CREDIT_STATUS",
  ADDRESS => 0x30006010,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01491_flds
);


##########################################################################
#                                                                        #
#   XCE_DTL1_DTL_LAST_CREDIT_STATUS                                     #
#                                                                        #
##########################################################################

%tio_01_01492_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DRQLC"                        => [   0,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "" ],
   "DRSLC"                        => [   1,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "" ],
   "DMSLC"                        => [   2,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01492_def =
( NAME    => "XCE_DTL1_DTL_LAST_CREDIT_STATUS",
  ADDRESS => 0x30006018,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01492_flds
);


##########################################################################
#                                                                        #
#   XCE_DTL1_DEBUG_SEL                                               #
#                                                                        #
##########################################################################

%tio_01_01493_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_NIB7_SEL"               => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT7_SEL"              => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB6_SEL"               => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT6_SEL"              => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB5_SEL"               => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT5_SEL"              => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB4_SEL"               => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT4_SEL"              => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB3_SEL"               => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT3_SEL"              => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB2_SEL"               => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT2_SEL"              => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB1_SEL"               => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT1_SEL"              => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB0_SEL"               => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT0_SEL"              => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01493_def =
( NAME    => "XCE_DTL1_DEBUG_SEL",
  ADDRESS => 0x30006050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01493_flds
);


##########################################################################
#                                                                        #
#   XCE_DTL2_DTDR_CREDIT_LIMIT                                       #
#                                                                        #
##########################################################################

%tio_01_01494_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DRQCL"                        => [   0,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "" ],
   "DRSCL"                        => [   1,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "" ],
   "DMSCL"                        => [   2,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01494_def =
( NAME    => "XCE_DTL2_DTDR_CREDIT_LIMIT",
  ADDRESS => 0x30008000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01494_flds
);


##########################################################################
#                                                                        #
#   XCE_DTL2_DTDR_CREDIT_FORCE                                       #
#                                                                        #
##########################################################################

%tio_01_01495_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DRQCF"                        => [   0,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "" ],
   "DRSCF"                        => [   1,   1,   1, 0x0000000000000002, 0x00, 1, 0x0000000000000000, "" ],
   "DMSCF"                        => [   2,   2,   1, 0x0000000000000004, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01495_def =
( NAME    => "XCE_DTL2_DTDR_CREDIT_FORCE",
  ADDRESS => 0x30008008,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01495_flds
);


##########################################################################
#                                                                        #
#   XCE_DTL2_DTL_DYN_CREDIT_STATUS                                     #
#                                                                        #
##########################################################################

%tio_01_01496_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DRQCC"                        => [   0,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "" ],
   "DRSCC"                        => [   1,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "" ],
   "DMSCC"                        => [   2,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01496_def =
( NAME    => "XCE_DTL2_DTL_DYN_CREDIT_STATUS",
  ADDRESS => 0x30008010,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01496_flds
);


##########################################################################
#                                                                        #
#   XCE_DTL2_DTL_LAST_CREDIT_STATUS                                     #
#                                                                        #
##########################################################################

%tio_01_01497_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DRQLC"                        => [   0,   0,   4, 0x000000000000000F, 0x00, 1, 0x0000000000000000, "" ],
   "DRSLC"                        => [   1,   4,   4, 0x00000000000000F0, 0x00, 1, 0x0000000000000000, "" ],
   "DMSLC"                        => [   2,   8,   4, 0x0000000000000F00, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01497_def =
( NAME    => "XCE_DTL2_DTL_LAST_CREDIT_STATUS",
  ADDRESS => 0x30008018,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01497_flds
);


##########################################################################
#                                                                        #
#   XCE_DTL2_DEBUG_SEL                                               #
#                                                                        #
##########################################################################

%tio_01_01498_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_NIB7_SEL"               => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT7_SEL"              => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB6_SEL"               => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT6_SEL"              => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB5_SEL"               => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT5_SEL"              => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB4_SEL"               => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT4_SEL"              => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB3_SEL"               => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT3_SEL"              => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB2_SEL"               => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT2_SEL"              => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB1_SEL"               => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT1_SEL"              => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB0_SEL"               => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT0_SEL"              => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01498_def =
( NAME    => "XCE_DTL2_DEBUG_SEL",
  ADDRESS => 0x30008050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01498_flds
);


##########################################################################
#                                                                        #
#   XCE_UTL1_UTL_CTRL                                                #
#                                                                        #
##########################################################################

%tio_01_01499_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DLLP_HI_PRI"                  => [   0,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01499_def =
( NAME    => "XCE_UTL1_UTL_CTRL",
  ADDRESS => 0x30007000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01499_flds
);


##########################################################################
#                                                                        #
#   XCE_UTL1_DEBUG_SEL                                               #
#                                                                        #
##########################################################################

%tio_01_01500_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_NIB7_SEL"               => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT7_SEL"              => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB6_SEL"               => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT6_SEL"              => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB5_SEL"               => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT5_SEL"              => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB4_SEL"               => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT4_SEL"              => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB3_SEL"               => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT3_SEL"              => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB2_SEL"               => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT2_SEL"              => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB1_SEL"               => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT1_SEL"              => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB0_SEL"               => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT0_SEL"              => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01500_def =
( NAME    => "XCE_UTL1_DEBUG_SEL",
  ADDRESS => 0x30007008,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01500_flds
);


##########################################################################
#                                                                        #
#   XCE_UTL2_UTL_CTRL                                                #
#                                                                        #
##########################################################################

%tio_01_01501_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DLLP_HI_PRI"                  => [   0,   0,   1, 0x0000000000000001, 0x00, 1, 0x0000000000000000, "" ],
);

%tio_01_01501_def =
( NAME    => "XCE_UTL2_UTL_CTRL",
  ADDRESS => 0x30009000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01501_flds
);


##########################################################################
#                                                                        #
#   XCE_UTL2_DEBUG_SEL                                               #
#                                                                        #
##########################################################################

%tio_01_01502_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_NIB7_SEL"               => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT7_SEL"              => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB6_SEL"               => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT6_SEL"              => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB5_SEL"               => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT5_SEL"              => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB4_SEL"               => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT4_SEL"              => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB3_SEL"               => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT3_SEL"              => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB2_SEL"               => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT2_SEL"              => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB1_SEL"               => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT1_SEL"              => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB0_SEL"               => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT0_SEL"              => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01502_def =
( NAME    => "XCE_UTL2_DEBUG_SEL",
  ADDRESS => 0x30009008,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01502_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_DYN_CREDIT_STATUS1                                       #
#                                                                        #
##########################################################################

%tio_01_01503_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CXM_CREDIT_COUNT"             => [   0,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_CREDIT_USED"              => [   1,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_CREDIT_SENT"              => [   2,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_CREDIT_USED"              => [   3,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_CREDIT_SENT"              => [   4,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01503_def =
( NAME    => "XCE_DRE_DYN_CREDIT_STATUS1",
  ADDRESS => 0x30040010,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01503_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_DYN_CREDIT_STATUS2                                       #
#                                                                        #
##########################################################################

%tio_01_01504_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSPBUF_CREDIT_USED"           => [   0,  40,   6, 0x00003F0000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSPBUF_CREDIT_SENT"           => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSPBUF_CREDIT_RCVD"           => [   2,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_CREDIT_RCVD"              => [   3,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_CREDIT_RCVD"             => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "" ],
   "DTL0_CREDIT_RCVD"             => [   5,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01504_def =
( NAME    => "XCE_DRE_DYN_CREDIT_STATUS2",
  ADDRESS => 0x30040018,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01504_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_DYN_FIFO                                                 #
#                                                                        #
##########################################################################

%tio_01_01505_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "US_WRTRSP_QUEUE_RDADDR"       => [   0,  36,   5, 0x000001F000000000, 0x00, 0, 0x0000000000000000, "" ],
   "US_WRTRSP_QUEUE_WRTADDR"      => [   1,  28,   5, 0x00000001F0000000, 0x00, 0, 0x0000000000000000, "" ],
   "US_URE_QUEUE_RDADDR"          => [   2,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "US_URE_QUEUE_WRTADDR"         => [   3,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DS_HEAD_QUEUE_RDADDR"         => [   4,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "" ],
   "DS_HEAD_QUEUE_WRTADDR"        => [   5,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01505_def =
( NAME    => "XCE_DRE_DYN_FIFO",
  ADDRESS => 0x30040100,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01505_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_LAST_CREDIT_STATUS1                                      #
#                                                                        #
##########################################################################

%tio_01_01506_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CXM_CREDIT_COUNT"             => [   0,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_CREDIT_USED"              => [   1,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_CREDIT_SENT"              => [   2,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_CREDIT_USED"              => [   3,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_CREDIT_SENT"              => [   4,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01506_def =
( NAME    => "XCE_DRE_LAST_CREDIT_STATUS1",
  ADDRESS => 0x30040020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01506_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_LAST_CREDIT_STATUS2                                      #
#                                                                        #
##########################################################################

%tio_01_01507_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSPBUF_CREDIT_USED"           => [   0,  40,   6, 0x00003F0000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSPBUF_CREDIT_SENT"           => [   1,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSPBUF_CREDIT_RCVD"           => [   2,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_CREDIT_RCVD"              => [   3,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_CREDIT_RCVD"             => [   4,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "" ],
   "DTL0_CREDIT_RCVD"             => [   5,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01507_def =
( NAME    => "XCE_DRE_LAST_CREDIT_STATUS2",
  ADDRESS => 0x30040028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01507_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_LAST_FIFO                                                #
#                                                                        #
##########################################################################

%tio_01_01508_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "US_WRTRSP_QUEUE_RDADDR"       => [   0,  36,   5, 0x000001F000000000, 0x00, 0, 0x0000000000000000, "" ],
   "US_WRTRSP_QUEUE_WRTADDR"      => [   1,  28,   5, 0x00000001F0000000, 0x00, 0, 0x0000000000000000, "" ],
   "US_URE_QUEUE_RDADDR"          => [   2,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "" ],
   "US_URE_QUEUE_WRTADDR"         => [   3,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "" ],
   "DS_HEAD_QUEUE_RDADDR"         => [   4,   8,   5, 0x0000000000001F00, 0x00, 0, 0x0000000000000000, "" ],
   "DS_HEAD_QUEUE_WRTADDR"        => [   5,   0,   5, 0x000000000000001F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01508_def =
( NAME    => "XCE_DRE_LAST_FIFO",
  ADDRESS => 0x30040120,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01508_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_CREDIT_LIMIT1                                            #
#                                                                        #
##########################################################################

%tio_01_01509_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CXM_CREDIT_LIMIT"             => [   0,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "URE_CREDIT_LIMIT"             => [   1,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_FIFO_CREDIT_LIMIT"        => [   2,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_CREDIT_LIMIT"             => [   3,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01509_def =
( NAME    => "XCE_DRE_CREDIT_LIMIT1",
  ADDRESS => 0x30040030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01509_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_CREDIT_LIMIT2                                            #
#                                                                        #
##########################################################################

%tio_01_01510_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSPBUF_CREDIT_SENT"           => [   0,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSPBUF_CREDIT_RCVD"           => [   1,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADM_CREDIT_RCVD"              => [   2,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1_CREDIT_RCVD"             => [   3,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "" ],
   "DTL0_CREDIT_RCVD"             => [   4,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01510_def =
( NAME    => "XCE_DRE_CREDIT_LIMIT2",
  ADDRESS => 0x30040038,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01510_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_FORCE_CREDIT1                                            #
#                                                                        #
##########################################################################

%tio_01_01511_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "URE_FORCE_CREDIT"             => [   0,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "SSP_FORCE_CREDIT"             => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01511_def =
( NAME    => "XCE_DRE_FORCE_CREDIT1",
  ADDRESS => 0x30040040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01511_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_FORCE_CREDIT2                                            #
#                                                                        #
##########################################################################

%tio_01_01512_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSPBUF_FORCE_CREDIT"          => [   0,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01512_def =
( NAME    => "XCE_DRE_FORCE_CREDIT2",
  ADDRESS => 0x30040048,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01512_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_DEBUG_MUX1                                               #
#                                                                        #
##########################################################################

%tio_01_01513_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_NIB7_SEL"               => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT7_SEL"              => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB6_SEL"               => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT6_SEL"              => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB5_SEL"               => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT5_SEL"              => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB4_SEL"               => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT4_SEL"              => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB3_SEL"               => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT3_SEL"              => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB2_SEL"               => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT2_SEL"              => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB1_SEL"               => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT1_SEL"              => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB0_SEL"               => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT0_SEL"              => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01513_def =
( NAME    => "XCE_DRE_DEBUG_MUX1",
  ADDRESS => 0x30040050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01513_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_DEBUG_MUX2                                               #
#                                                                        #
##########################################################################

%tio_01_01514_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_NIB7_SEL"               => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT7_SEL"              => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB6_SEL"               => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT6_SEL"              => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB5_SEL"               => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT5_SEL"              => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB4_SEL"               => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT4_SEL"              => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB3_SEL"               => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT3_SEL"              => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB2_SEL"               => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT2_SEL"              => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB1_SEL"               => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT1_SEL"              => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB0_SEL"               => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT0_SEL"              => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01514_def =
( NAME    => "XCE_DRE_DEBUG_MUX2",
  ADDRESS => 0x30040058,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01514_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_SSP_ERR_CMD_WRD                                          #
#                                                                        #
##########################################################################

%tio_01_01515_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CMD_WRD"                      => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01515_def =
( NAME    => "XCE_DRE_SSP_ERR_CMD_WRD",
  ADDRESS => 0x30040060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01515_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_SSP_ERR_ADDR                                             #
#                                                                        #
##########################################################################

%tio_01_01516_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CMD_WRD_VALID"                => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKT_ADDR"                     => [   1,   0,  56, 0x00FFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01516_def =
( NAME    => "XCE_DRE_SSP_ERR_ADDR",
  ADDRESS => 0x30040068,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01516_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_COMP_ERR_CMD_WRD                                         #
#                                                                        #
##########################################################################

%tio_01_01517_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CMD_WRD"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01517_def =
( NAME    => "XCE_DRE_COMP_ERR_CMD_WRD",
  ADDRESS => 0x30040070,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01517_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_COMP_ERR_ADDR                                            #
#                                                                        #
##########################################################################

%tio_01_01518_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "COMP_ERR_VALID"               => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKT_ADDR"                     => [   1,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01518_def =
( NAME    => "XCE_DRE_COMP_ERR_ADDR",
  ADDRESS => 0x30040078,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01518_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_REQ_STATUS                                               #
#                                                                        #
##########################################################################

%tio_01_01519_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TNUM_IN_USE"                  => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01519_def =
( NAME    => "XCE_DRE_REQ_STATUS",
  ADDRESS => 0x30040080,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01519_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_CONFIG1                                                  #
#                                                                        #
##########################################################################

%tio_01_01520_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FORCE_RCB_4DW_RD"             => [   0,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "SUP_URE_RSP_P_ERROR"          => [   1,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "SUP_WRT_RSP_P_ERROR"          => [   2,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "ADDR_MODE"                    => [   3,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "SUP_IO_LEGACY_ERROR"          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "SUP_CONFIG_COMP_ERROR"        => [   5,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "DYN_RO_ENABLE"                => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "RO_ENABLE"                    => [   7,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01520_def =
( NAME    => "XCE_DRE_CONFIG1",
  ADDRESS => 0x30040088,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01520_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_CONFIG2                                                  #
#                                                                        #
##########################################################################

%tio_01_01521_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SUP_DSBUF_DATA_P_ERROR"       => [   0,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "SUP_DSBUF_HEAD_P_ERROR"       => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01521_def =
( NAME    => "XCE_DRE_CONFIG2",
  ADDRESS => 0x30040090,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01521_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_CONFIG_REQ_STATUS                                        #
#                                                                        #
##########################################################################

%tio_01_01522_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CONFIG_REQUEST_ACTIVE"        => [   0,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "CONFIG_COMPLETION_VALID"      => [   1,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "DOWNSTREAM_CONFIG_ERROR"      => [   2,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "LAST_CONFIG_COMPLETION"       => [   3,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01522_def =
( NAME    => "XCE_DRE_CONFIG_REQ_STATUS",
  ADDRESS => 0x30040098,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01522_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_MAINT_DS_HEAD_QUEUE_MISC                                     #
#                                                                        #
##########################################################################

%tio_01_01523_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01523_def =
( NAME    => "XCE_DRE_MAINT_DS_HEAD_QUEUE_MISC",
  ADDRESS => 0x30040400,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01523_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_MAINT_DS_HEAD_QUEUE_DATA127_64                                     #
#                                                                        #
##########################################################################

%tio_01_01524_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01524_def =
( NAME    => "XCE_DRE_MAINT_DS_HEAD_QUEUE_DATA127_64",
  ADDRESS => 0x30040300,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01524_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_MAINT_DS_HEAD_QUEUE_DATA63_0                                     #
#                                                                        #
##########################################################################

%tio_01_01525_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01525_def =
( NAME    => "XCE_DRE_MAINT_DS_HEAD_QUEUE_DATA63_0",
  ADDRESS => 0x30040200,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01525_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_MAINT_DS_DATA_QUEUE_MISC                                     #
#                                                                        #
##########################################################################

%tio_01_01526_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,   9, 0x00000000000001FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01526_def =
( NAME    => "XCE_DRE_MAINT_DS_DATA_QUEUE_MISC",
  ADDRESS => 0x30043000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01526_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_MAINT_DS_DATA_QUEUE_DATA127_64                                     #
#                                                                        #
##########################################################################

%tio_01_01527_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01527_def =
( NAME    => "XCE_DRE_MAINT_DS_DATA_QUEUE_DATA127_64",
  ADDRESS => 0x30042000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01527_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_MAINT_DS_DATA_QUEUE_DATA63_0                                     #
#                                                                        #
##########################################################################

%tio_01_01528_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01528_def =
( NAME    => "XCE_DRE_MAINT_DS_DATA_QUEUE_DATA63_0",
  ADDRESS => 0x30041000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01528_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_MAINT_URE_US_RSP_QUEUE_MISC                                     #
#                                                                        #
##########################################################################

%tio_01_01529_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01529_def =
( NAME    => "XCE_DRE_MAINT_URE_US_RSP_QUEUE_MISC",
  ADDRESS => 0x30044200,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01529_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_MAINT_URE_US_RSP_QUEUE_DATA127_64                                     #
#                                                                        #
##########################################################################

%tio_01_01530_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01530_def =
( NAME    => "XCE_DRE_MAINT_URE_US_RSP_QUEUE_DATA127_64",
  ADDRESS => 0x30044100,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01530_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_MAINT_URE_US_RSP_QUEUE_DATA63_0                                     #
#                                                                        #
##########################################################################

%tio_01_01531_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01531_def =
( NAME    => "XCE_DRE_MAINT_URE_US_RSP_QUEUE_DATA63_0",
  ADDRESS => 0x30044000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01531_flds
);


##########################################################################
#                                                                        #
#   XCE_DRE_MAINT_US_WRT_RSP_QUEUE                                     #
#                                                                        #
##########################################################################

%tio_01_01532_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01532_def =
( NAME    => "XCE_DRE_MAINT_US_WRT_RSP_QUEUE",
  ADDRESS => 0x30044300,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01532_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_DYN_CREDIT_STATUS                                        #
#                                                                        #
##########################################################################

%tio_01_01533_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ADM"                          => [   0,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "CXM"                          => [   1,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "" ],
   "DRE"                          => [   2,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2"                         => [   3,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1"                         => [   4,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01533_def =
( NAME    => "XCE_URE_DYN_CREDIT_STATUS",
  ADDRESS => 0x3000B010,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01533_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_LAST_CREDIT_STATUS                                       #
#                                                                        #
##########################################################################

%tio_01_01534_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ADM"                          => [   0,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "CXM"                          => [   1,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "" ],
   "DRE"                          => [   2,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2"                         => [   3,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1"                         => [   4,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01534_def =
( NAME    => "XCE_URE_LAST_CREDIT_STATUS",
  ADDRESS => 0x3000B018,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01534_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_CREDIT_LIMIT                                             #
#                                                                        #
##########################################################################

%tio_01_01535_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ADM"                          => [   0,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "CXM"                          => [   1,  12,   4, 0x000000000000F000, 0x00, 0, 0x0000000000000000, "" ],
   "DRE"                          => [   2,   8,   4, 0x0000000000000F00, 0x00, 0, 0x0000000000000000, "" ],
   "DTL2"                         => [   3,   4,   4, 0x00000000000000F0, 0x00, 0, 0x0000000000000000, "" ],
   "DTL1"                         => [   4,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01535_def =
( NAME    => "XCE_URE_CREDIT_LIMIT",
  ADDRESS => 0x3000B020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01535_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_CONTROL                                                  #
#                                                                        #
##########################################################################

%tio_01_01536_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "UNSUP_DISABLE"                => [   0,  45,   1, 0x0000200000000000, 0x00, 0, 0x0000000000000000, "" ],
   "MALFORM_DISABLE"              => [   1,  44,   1, 0x0000100000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DNS_HDR_PAR_DISABLE"          => [   2,  40,   1, 0x0000010000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DNS_DAT_PAR_DISABLE"          => [   3,  39,   1, 0x0000008000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSPQ_PAR_DISABLE"             => [   4,  38,   1, 0x0000004000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCI_PAR_DISABLE"              => [   5,  37,   1, 0x0000002000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ATE_PAR_DISABLE"              => [   6,  36,   1, 0x0000001000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_HDR2_PAR_DISABLE"         => [   7,  35,   1, 0x0000000800000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_DAT2_PAR_DISABLE"         => [   8,  34,   1, 0x0000000400000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_HDR1_PAR_DISABLE"         => [   9,  33,   1, 0x0000000200000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_DAT1_PAR_DISABLE"         => [  10,  32,   1, 0x0000000100000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSPQ_BYPASS_DISABLE"          => [  11,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "WRT_MERGE_TIMER"              => [  12,  12,  11, 0x00000000007FF000, 0x00, 0, 0x0000000000000000, "" ],
   "WRT_MRG_ENABLE2"              => [  13,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "WRT_MRG_ENABLE1"              => [  14,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "RD_MRG_ENABLE"                => [  15,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01536_def =
( NAME    => "XCE_URE_CONTROL",
  ADDRESS => 0x3000B030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01536_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_STATUS                                                   #
#                                                                        #
##########################################################################

%tio_01_01537_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CDAT_OFLOW2"                  => [   0,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "CHDR_OFLOW2"                  => [   1,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "NDAT_OFLOW2"                  => [   2,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "NHDR_OFLOW2"                  => [   3,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "PDAT_OFLOW2"                  => [   4,   9,   1, 0x0000000000000200, 0x00, 0, 0x0000000000000000, "" ],
   "PHDR_OFLOW2"                  => [   5,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "CDAT_OFLOW1"                  => [   6,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "CHDR_OFLOW1"                  => [   7,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "NDAT_OFLOW1"                  => [   8,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "NHDR_OFLOW1"                  => [   9,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "PDAT_OFLOW1"                  => [  10,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "PHDR_OFLOW1"                  => [  11,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01537_def =
( NAME    => "XCE_URE_STATUS",
  ADDRESS => 0x3000B038,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01537_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_SSP_DEBUG_SEL                                            #
#                                                                        #
##########################################################################

%tio_01_01538_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_NIB7_SEL"               => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT7_SEL"              => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB6_SEL"               => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT6_SEL"              => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB5_SEL"               => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT5_SEL"              => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB4_SEL"               => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT4_SEL"              => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB3_SEL"               => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT3_SEL"              => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB2_SEL"               => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT2_SEL"              => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB1_SEL"               => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT1_SEL"              => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB0_SEL"               => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT0_SEL"              => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01538_def =
( NAME    => "XCE_URE_SSP_DEBUG_SEL",
  ADDRESS => 0x3000B050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01538_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_PCIE_DEBUG_SEL                                           #
#                                                                        #
##########################################################################

%tio_01_01539_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DEBUG_NIB7_SEL"               => [   0,  60,   3, 0x7000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT7_SEL"              => [   1,  56,   3, 0x0700000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB6_SEL"               => [   2,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT6_SEL"              => [   3,  48,   3, 0x0007000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB5_SEL"               => [   4,  44,   3, 0x0000700000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT5_SEL"              => [   5,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB4_SEL"               => [   6,  36,   3, 0x0000007000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT4_SEL"              => [   7,  32,   3, 0x0000000700000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB3_SEL"               => [   8,  28,   3, 0x0000000070000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT3_SEL"              => [   9,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB2_SEL"               => [  10,  20,   3, 0x0000000000700000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT2_SEL"              => [  11,  16,   3, 0x0000000000070000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB1_SEL"               => [  12,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT1_SEL"              => [  13,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_NIB0_SEL"               => [  14,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "DEBUG_PORT0_SEL"              => [  15,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01539_def =
( NAME    => "XCE_URE_PCIE_DEBUG_SEL",
  ADDRESS => 0x3000B058,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01539_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_SSP_ERR_CMD_WRD                                          #
#                                                                        #
##########################################################################

%tio_01_01540_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CMD_WRD"                      => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01540_def =
( NAME    => "XCE_URE_SSP_ERR_CMD_WRD",
  ADDRESS => 0x3000B060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01540_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_SSP_ERR_ADDR                                             #
#                                                                        #
##########################################################################

%tio_01_01541_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CMD_WRD_VALID"                => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PKT_ADDR"                     => [   1,   3,  51, 0x003FFFFFFFFFFFF8, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01541_def =
( NAME    => "XCE_URE_SSP_ERR_ADDR",
  ADDRESS => 0x3000B068,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01541_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_PAGE_MAP                                                 #
#                                                                        #
##########################################################################

%tio_01_01542_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PAGE_SIZE"                    => [   0,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "MAN_PAR_ENABLE"               => [   1,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "ATE40_ENABLE"                 => [   2,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ATE3240_ENABLE"               => [   3,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01542_def =
( NAME    => "XCE_URE_PAGE_MAP",
  ADDRESS => 0x3000B070,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01542_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_DIR_MAP1                                                 #
#                                                                        #
##########################################################################

%tio_01_01543_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DIR_OFFSET"                   => [   0,  30,  24, 0x003FFFFFC0000000, 0x00, 0, 0x0000000000000000, "" ],
   "MSI_DBL_WRD"                  => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01543_def =
( NAME    => "XCE_URE_DIR_MAP1",
  ADDRESS => 0x3000B078,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01543_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_DIR_MAP2                                                 #
#                                                                        #
##########################################################################

%tio_01_01544_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DIR_OFFSET"                   => [   0,  30,  24, 0x003FFFFFC0000000, 0x00, 0, 0x0000000000000000, "" ],
   "MSI_DBL_WRD"                  => [   1,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01544_def =
( NAME    => "XCE_URE_DIR_MAP2",
  ADDRESS => 0x3000B080,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01544_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_PIPE_SEL1                                                #
#                                                                        #
##########################################################################

%tio_01_01545_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SELECT3"                      => [   0,  40,  19, 0x07FFFF0000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SELECT2"                      => [   1,  20,  19, 0x0000007FFFF00000, 0x00, 0, 0x0000000000000000, "" ],
   "SELECT1"                      => [   2,   0,  19, 0x000000000007FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01545_def =
( NAME    => "XCE_URE_PIPE_SEL1",
  ADDRESS => 0x3000B088,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01545_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_PIPE_MASK1                                               #
#                                                                        #
##########################################################################

%tio_01_01546_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK3"                        => [   0,  40,  19, 0x07FFFF0000000000, 0x00, 0, 0x0000000000000000, "" ],
   "MASK2"                        => [   1,  20,  19, 0x0000007FFFF00000, 0x00, 0, 0x0000000000000000, "" ],
   "MASK1"                        => [   2,   0,  19, 0x000000000007FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01546_def =
( NAME    => "XCE_URE_PIPE_MASK1",
  ADDRESS => 0x3000B090,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01546_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_PIPE_SEL2                                                #
#                                                                        #
##########################################################################

%tio_01_01547_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SELECT3"                      => [   0,  40,  19, 0x07FFFF0000000000, 0x00, 0, 0x0000000000000000, "" ],
   "SELECT2"                      => [   1,  20,  19, 0x0000007FFFF00000, 0x00, 0, 0x0000000000000000, "" ],
   "SELECT1"                      => [   2,   0,  19, 0x000000000007FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01547_def =
( NAME    => "XCE_URE_PIPE_SEL2",
  ADDRESS => 0x3000B098,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01547_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_PIPE_MASK2                                               #
#                                                                        #
##########################################################################

%tio_01_01548_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MASK3"                        => [   0,  40,  19, 0x07FFFF0000000000, 0x00, 0, 0x0000000000000000, "" ],
   "MASK2"                        => [   1,  20,  19, 0x0000007FFFF00000, 0x00, 0, 0x0000000000000000, "" ],
   "MASK1"                        => [   2,   0,  19, 0x000000000007FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01548_def =
( NAME    => "XCE_URE_PIPE_MASK2",
  ADDRESS => 0x3000B0A0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01548_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_PCIE1_CREDITS_SENT                                       #
#                                                                        #
##########################################################################

%tio_01_01549_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CDAT_CREDITS"                 => [   0,  48,  12, 0x0FFF000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CHDR_CREDITS"                 => [   1,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "" ],
   "NDAT_CREDITS"                 => [   2,  28,  12, 0x000000FFF0000000, 0x00, 0, 0x0000000000000000, "" ],
   "NHDR_CREDITS"                 => [   3,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "" ],
   "PDAT_CREDITS"                 => [   4,   8,  12, 0x00000000000FFF00, 0x00, 0, 0x0000000000000000, "" ],
   "PHDR_CREDITS"                 => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01549_def =
( NAME    => "XCE_URE_PCIE1_CREDITS_SENT",
  ADDRESS => 0x3000B0A8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01549_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_PCIE1_CREDITS_USED                                       #
#                                                                        #
##########################################################################

%tio_01_01550_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CDAT_CREDITS"                 => [   0,  48,  12, 0x0FFF000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CHDR_CREDITS"                 => [   1,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "" ],
   "NDAT_CREDITS"                 => [   2,  28,  12, 0x000000FFF0000000, 0x00, 0, 0x0000000000000000, "" ],
   "NHDR_CREDITS"                 => [   3,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "" ],
   "PDAT_CREDITS"                 => [   4,   8,  12, 0x00000000000FFF00, 0x00, 0, 0x0000000000000000, "" ],
   "PHDR_CREDITS"                 => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01550_def =
( NAME    => "XCE_URE_PCIE1_CREDITS_USED",
  ADDRESS => 0x3000B0B0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01550_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_PCIE1_CREDIT_LIMIT                                       #
#                                                                        #
##########################################################################

%tio_01_01551_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MPS"                          => [   0,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "NDAT_CREDITS"                 => [   1,  28,  12, 0x000000FFF0000000, 0x00, 0, 0x0000000000000000, "" ],
   "NHDR_CREDITS"                 => [   2,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "" ],
   "PDAT_CREDITS"                 => [   3,   8,  12, 0x00000000000FFF00, 0x00, 0, 0x0000000000000000, "" ],
   "PHDR_CREDITS"                 => [   4,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01551_def =
( NAME    => "XCE_URE_PCIE1_CREDIT_LIMIT",
  ADDRESS => 0x3000B0B8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01551_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_PCIE2_CREDITS_SENT                                       #
#                                                                        #
##########################################################################

%tio_01_01552_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CDAT_CREDITS"                 => [   0,  48,  12, 0x0FFF000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CHDR_CREDITS"                 => [   1,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "" ],
   "NDAT_CREDITS"                 => [   2,  28,  12, 0x000000FFF0000000, 0x00, 0, 0x0000000000000000, "" ],
   "NHDR_CREDITS"                 => [   3,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "" ],
   "PDAT_CREDITS"                 => [   4,   8,  12, 0x00000000000FFF00, 0x00, 0, 0x0000000000000000, "" ],
   "PHDR_CREDITS"                 => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01552_def =
( NAME    => "XCE_URE_PCIE2_CREDITS_SENT",
  ADDRESS => 0x3000B0C0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01552_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_PCIE2_CREDITS_USED                                       #
#                                                                        #
##########################################################################

%tio_01_01553_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CDAT_CREDITS"                 => [   0,  48,  12, 0x0FFF000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "CHDR_CREDITS"                 => [   1,  40,   8, 0x0000FF0000000000, 0x00, 0, 0x0000000000000000, "" ],
   "NDAT_CREDITS"                 => [   2,  28,  12, 0x000000FFF0000000, 0x00, 0, 0x0000000000000000, "" ],
   "NHDR_CREDITS"                 => [   3,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "" ],
   "PDAT_CREDITS"                 => [   4,   8,  12, 0x00000000000FFF00, 0x00, 0, 0x0000000000000000, "" ],
   "PHDR_CREDITS"                 => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01553_def =
( NAME    => "XCE_URE_PCIE2_CREDITS_USED",
  ADDRESS => 0x3000B0C8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01553_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_PCIE2_CREDIT_LIMIT                                       #
#                                                                        #
##########################################################################

%tio_01_01554_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MPS"                          => [   0,  40,   3, 0x0000070000000000, 0x00, 0, 0x0000000000000000, "" ],
   "NDAT_CREDITS"                 => [   1,  28,  12, 0x000000FFF0000000, 0x00, 0, 0x0000000000000000, "" ],
   "NHDR_CREDITS"                 => [   2,  20,   8, 0x000000000FF00000, 0x00, 0, 0x0000000000000000, "" ],
   "PDAT_CREDITS"                 => [   3,   8,  12, 0x00000000000FFF00, 0x00, 0, 0x0000000000000000, "" ],
   "PHDR_CREDITS"                 => [   4,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01554_def =
( NAME    => "XCE_URE_PCIE2_CREDIT_LIMIT",
  ADDRESS => 0x3000B0D0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01554_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_PCIE_FORCE_CREDIT                                        #
#                                                                        #
##########################################################################

%tio_01_01555_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "NDAT_CREDIT2"                 => [   0,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "NHDR_CREDIT2"                 => [   1,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "PDAT_CREDIT2"                 => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "PHDR_CREDIT2"                 => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "NDAT_CREDIT1"                 => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "NHDR_CREDIT1"                 => [   5,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "PDAT_CREDIT1"                 => [   6,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "PHDR_CREDIT1"                 => [   7,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01555_def =
( NAME    => "XCE_URE_PCIE_FORCE_CREDIT",
  ADDRESS => 0x3000B0D8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01555_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_RD_TNUM_VAL                                              #
#                                                                        #
##########################################################################

%tio_01_01556_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01556_def =
( NAME    => "XCE_URE_RD_TNUM_VAL",
  ADDRESS => 0x3000B0E0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01556_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_RD_TNUM_RSP_RCVD                                         #
#                                                                        #
##########################################################################

%tio_01_01557_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSP_RCVD"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01557_def =
( NAME    => "XCE_URE_RD_TNUM_RSP_RCVD",
  ADDRESS => 0x3000B0E8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01557_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_RD_TNUM_ESENT                                            #
#                                                                        #
##########################################################################

%tio_01_01558_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ESENT"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01558_def =
( NAME    => "XCE_URE_RD_TNUM_ESENT",
  ADDRESS => 0x3000B0F0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01558_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_RD_TNUM_ERROR                                            #
#                                                                        #
##########################################################################

%tio_01_01559_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ERROR"                        => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01559_def =
( NAME    => "XCE_URE_RD_TNUM_ERROR",
  ADDRESS => 0x3000B0F8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01559_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_RD_TNUM_FIRST_CL                                         #
#                                                                        #
##########################################################################

%tio_01_01560_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "FIRST_CL"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01560_def =
( NAME    => "XCE_URE_RD_TNUM_FIRST_CL",
  ADDRESS => 0x3000B100,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01560_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_RD_TNUM_LINK_BUF                                         #
#                                                                        #
##########################################################################

%tio_01_01561_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LINK_BUF"                     => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01561_def =
( NAME    => "XCE_URE_RD_TNUM_LINK_BUF",
  ADDRESS => 0x3000B108,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01561_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_WR_TNUM_VAL                                              #
#                                                                        #
##########################################################################

%tio_01_01562_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01562_def =
( NAME    => "XCE_URE_WR_TNUM_VAL",
  ADDRESS => 0x3000B110,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01562_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_SRAM_ERR_ADDR0                                           #
#                                                                        #
##########################################################################

%tio_01_01563_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "UPS_DAT2_ADDR"                => [   0,  36,   9, 0x00001FF000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_HDR2_ADDR"                => [   1,  24,   9, 0x00000001FF000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_DAT1_ADDR"                => [   2,  12,   9, 0x00000000001FF000, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_HDR1_ADDR"                => [   3,   0,   9, 0x00000000000001FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01563_def =
( NAME    => "XCE_URE_SRAM_ERR_ADDR0",
  ADDRESS => 0x3000B118,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01563_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_SRAM_ERR_ADDR1                                           #
#                                                                        #
##########################################################################

%tio_01_01564_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSPQ_ADDR"                    => [   0,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "" ],
   "RCI_ADDR"                     => [   1,  24,   6, 0x000000003F000000, 0x00, 0, 0x0000000000000000, "" ],
   "ATE3240_ADDR"                 => [   2,  12,  11, 0x00000000007FF000, 0x00, 0, 0x0000000000000000, "" ],
   "ATE40_ADDR"                   => [   3,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01564_def =
( NAME    => "XCE_URE_SRAM_ERR_ADDR1",
  ADDRESS => 0x3000B120,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01564_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_SRAM_ERR_ADDR2                                           #
#                                                                        #
##########################################################################

%tio_01_01565_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DNS_DAT_ADDR"                 => [   0,   8,   9, 0x000000000001FF00, 0x00, 0, 0x0000000000000000, "" ],
   "DNS_HDR_ADDR"                 => [   1,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01565_def =
( NAME    => "XCE_URE_SRAM_ERR_ADDR2",
  ADDRESS => 0x3000B128,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01565_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_SRAM_RD_ADDR0                                            #
#                                                                        #
##########################################################################

%tio_01_01566_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "UPS_HDR1_PIPE3_ADDR"          => [   0,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_HDR1_PIPE2_ADDR"          => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_HDR1_PIPE1_ADDR"          => [   2,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_HDR1_PIPE0_ADDR"          => [   3,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01566_def =
( NAME    => "XCE_URE_SRAM_RD_ADDR0",
  ADDRESS => 0x3000B130,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01566_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_SRAM_RD_ADDR1                                            #
#                                                                        #
##########################################################################

%tio_01_01567_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSPQ_ADDR"                    => [   0,  32,   6, 0x0000003F00000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_HDR2_PIPE3_ADDR"          => [   1,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_HDR2_PIPE2_ADDR"          => [   2,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_HDR2_PIPE1_ADDR"          => [   3,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_HDR2_PIPE0_ADDR"          => [   4,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01567_def =
( NAME    => "XCE_URE_SRAM_RD_ADDR1",
  ADDRESS => 0x3000B138,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01567_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_SRAM_RD_ADDR2                                            #
#                                                                        #
##########################################################################

%tio_01_01568_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DNS_HDR_ADDR"                 => [   0,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01568_def =
( NAME    => "XCE_URE_SRAM_RD_ADDR2",
  ADDRESS => 0x3000B140,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01568_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_SRAM_WR_ADDR0                                            #
#                                                                        #
##########################################################################

%tio_01_01569_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "UPS_HDR1_PIPE3_ADDR"          => [   0,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_HDR1_PIPE2_ADDR"          => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_HDR1_PIPE1_ADDR"          => [   2,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_HDR1_PIPE0_ADDR"          => [   3,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01569_def =
( NAME    => "XCE_URE_SRAM_WR_ADDR0",
  ADDRESS => 0x3000B148,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01569_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_SRAM_WR_ADDR1                                            #
#                                                                        #
##########################################################################

%tio_01_01570_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "UPS_HDR2_PIPE3_ADDR"          => [   0,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_HDR2_PIPE2_ADDR"          => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_HDR2_PIPE1_ADDR"          => [   2,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_HDR2_PIPE0_ADDR"          => [   3,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01570_def =
( NAME    => "XCE_URE_SRAM_WR_ADDR1",
  ADDRESS => 0x3000B150,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01570_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_SRAM_WR_ADDR2                                            #
#                                                                        #
##########################################################################

%tio_01_01571_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "RSPQ_ADDR"                    => [   0,   8,   6, 0x0000000000003F00, 0x00, 0, 0x0000000000000000, "" ],
   "DNS_HDR_ADDR"                 => [   1,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01571_def =
( NAME    => "XCE_URE_SRAM_WR_ADDR2",
  ADDRESS => 0x3000B158,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01571_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_BUF_FLUSH10                                              #
#                                                                        #
##########################################################################

%tio_01_01572_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "UNUSED"                       => [   0,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01572_def =
( NAME    => "XCE_URE_BUF_FLUSH10",
  ADDRESS => 0x3000B160,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01572_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_BUF_FLUSH11                                              #
#                                                                        #
##########################################################################

%tio_01_01573_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "UNUSED"                       => [   0,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01573_def =
( NAME    => "XCE_URE_BUF_FLUSH11",
  ADDRESS => 0x3000B168,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01573_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_BUF_FLUSH12                                              #
#                                                                        #
##########################################################################

%tio_01_01574_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "UNUSED"                       => [   0,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01574_def =
( NAME    => "XCE_URE_BUF_FLUSH12",
  ADDRESS => 0x3000B170,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01574_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_BUF_FLUSH13                                              #
#                                                                        #
##########################################################################

%tio_01_01575_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "UNUSED"                       => [   0,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01575_def =
( NAME    => "XCE_URE_BUF_FLUSH13",
  ADDRESS => 0x3000B178,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01575_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_BUF_FLUSH20                                              #
#                                                                        #
##########################################################################

%tio_01_01576_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "UNUSED"                       => [   0,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01576_def =
( NAME    => "XCE_URE_BUF_FLUSH20",
  ADDRESS => 0x3000B180,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01576_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_BUF_FLUSH21                                              #
#                                                                        #
##########################################################################

%tio_01_01577_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "UNUSED"                       => [   0,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01577_def =
( NAME    => "XCE_URE_BUF_FLUSH21",
  ADDRESS => 0x3000B188,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01577_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_BUF_FLUSH22                                              #
#                                                                        #
##########################################################################

%tio_01_01578_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "UNUSED"                       => [   0,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01578_def =
( NAME    => "XCE_URE_BUF_FLUSH22",
  ADDRESS => 0x3000B190,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01578_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_BUF_FLUSH23                                              #
#                                                                        #
##########################################################################

%tio_01_01579_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "UNUSED"                       => [   0,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01579_def =
( NAME    => "XCE_URE_BUF_FLUSH23",
  ADDRESS => 0x3000B198,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01579_flds
);


##########################################################################
#                                                                        #
#   XCE_PCIE_CONTROL1                                                #
#                                                                        #
##########################################################################

%tio_01_01580_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PN2"                          => [   0,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "" ],
   "PN1"                          => [   1,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "SCC"                          => [   2,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "ELAL1"                        => [   3,   8,   3, 0x0000000000000700, 0x00, 0, 0x0000000000000000, "" ],
   "ELAL"                         => [   4,   4,   3, 0x0000000000000070, 0x00, 0, 0x0000000000000000, "" ],
   "SI"                           => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01580_def =
( NAME    => "XCE_PCIE_CONTROL1",
  ADDRESS => 0x3000B1A0,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01580_flds
);


##########################################################################
#                                                                        #
#   XCE_PCIE_CONTROL2                                                #
#                                                                        #
##########################################################################

%tio_01_01581_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PSN2"                         => [   0,  32,  13, 0x00001FFF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "PSN1"                         => [   1,  19,  13, 0x00000000FFF80000, 0x00, 0, 0x0000000000000000, "" ],
   "SPLS"                         => [   2,  15,   2, 0x0000000000018000, 0x00, 0, 0x0000000000000000, "" ],
   "SPLV"                         => [   3,   7,   8, 0x0000000000007F80, 0x00, 0, 0x0000000000000000, "" ],
   "HPC"                          => [   4,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "HPS"                          => [   5,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "PIP"                          => [   6,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "AIP"                          => [   7,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "MSP"                          => [   8,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "PCP"                          => [   9,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ABP"                          => [  10,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01581_def =
( NAME    => "XCE_PCIE_CONTROL2",
  ADDRESS => 0x3000B1A8,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01581_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_UPS_DAT1_DATA63_0                                     #
#                                                                        #
##########################################################################

%tio_01_01582_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01582_def =
( NAME    => "XCE_URE_MAINT_UPS_DAT1_DATA63_0",
  ADDRESS => 0x3000C000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01582_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_UPS_DAT1_DATA127_64                                     #
#                                                                        #
##########################################################################

%tio_01_01583_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01583_def =
( NAME    => "XCE_URE_MAINT_UPS_DAT1_DATA127_64",
  ADDRESS => 0x3000D000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01583_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_UPS_DAT1_PARITY                                     #
#                                                                        #
##########################################################################

%tio_01_01584_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PARITY"                       => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01584_def =
( NAME    => "XCE_URE_MAINT_UPS_DAT1_PARITY",
  ADDRESS => 0x3000E000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01584_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_UPS_HDR1_DATA63_0                                     #
#                                                                        #
##########################################################################

%tio_01_01585_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DW3"                          => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
   "DW2"                          => [   1,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01585_def =
( NAME    => "XCE_URE_MAINT_UPS_HDR1_DATA63_0",
  ADDRESS => 0x3000F000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01585_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_UPS_HDR1_DATA127_64                                     #
#                                                                        #
##########################################################################

%tio_01_01586_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BYTE7"                        => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
   "BYTE6"                        => [   1,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "ID"                           => [   2,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "LENGTH"                       => [   3,  32,  10, 0x000003FF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "ALIGN"                        => [   4,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNSUP"                        => [   5,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ATTR"                         => [   6,  44,   2, 0x0000300000000000, 0x00, 0, 0x0000000000000000, "" ],
   "EP"                           => [   7,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TD"                           => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DB3_0"                        => [   9,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TC"                           => [  10,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DB4"                          => [  11,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TYPE"                         => [  12,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FMT"                          => [  13,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DB5"                          => [  14,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01586_def =
( NAME    => "XCE_URE_MAINT_UPS_HDR1_DATA127_64",
  ADDRESS => 0x30010000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01586_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_UPS_HDR1_PARITY                                     #
#                                                                        #
##########################################################################

%tio_01_01587_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PARITY"                       => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01587_def =
( NAME    => "XCE_URE_MAINT_UPS_HDR1_PARITY",
  ADDRESS => 0x30011000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01587_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_UPS_DAT2_DATA63_0                                     #
#                                                                        #
##########################################################################

%tio_01_01588_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01588_def =
( NAME    => "XCE_URE_MAINT_UPS_DAT2_DATA63_0",
  ADDRESS => 0x30012000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01588_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_UPS_DAT2_DATA127_64                                     #
#                                                                        #
##########################################################################

%tio_01_01589_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01589_def =
( NAME    => "XCE_URE_MAINT_UPS_DAT2_DATA127_64",
  ADDRESS => 0x30013000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01589_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_UPS_DAT2_PARITY                                     #
#                                                                        #
##########################################################################

%tio_01_01590_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PARITY"                       => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01590_def =
( NAME    => "XCE_URE_MAINT_UPS_DAT2_PARITY",
  ADDRESS => 0x30014000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01590_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_UPS_HDR2_DATA63_0                                     #
#                                                                        #
##########################################################################

%tio_01_01591_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DW3"                          => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
   "DW2"                          => [   1,  32,  32, 0xFFFFFFFF00000000, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01591_def =
( NAME    => "XCE_URE_MAINT_UPS_HDR2_DATA63_0",
  ADDRESS => 0x30015000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01591_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_UPS_HDR2_DATA127_64                                     #
#                                                                        #
##########################################################################

%tio_01_01592_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BYTE7"                        => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
   "BYTE6"                        => [   1,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "ID"                           => [   2,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "LENGTH"                       => [   3,  32,  10, 0x000003FF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "ALIGN"                        => [   4,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "UNSUP"                        => [   5,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ATTR"                         => [   6,  44,   2, 0x0000300000000000, 0x00, 0, 0x0000000000000000, "" ],
   "EP"                           => [   7,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TD"                           => [   8,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DB3_0"                        => [   9,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TC"                           => [  10,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DB4"                          => [  11,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TYPE"                         => [  12,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FMT"                          => [  13,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DB5"                          => [  14,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01592_def =
( NAME    => "XCE_URE_MAINT_UPS_HDR2_DATA127_64",
  ADDRESS => 0x30016000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01592_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_UPS_HDR2_PARITY                                     #
#                                                                        #
##########################################################################

%tio_01_01593_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PARITY"                       => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01593_def =
( NAME    => "XCE_URE_MAINT_UPS_HDR2_PARITY",
  ADDRESS => 0x30017000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01593_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_DNS_DAT_DATA63_0                                     #
#                                                                        #
##########################################################################

%tio_01_01594_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01594_def =
( NAME    => "XCE_URE_MAINT_DNS_DAT_DATA63_0",
  ADDRESS => 0x30018000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01594_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_DNS_DAT_DATA127_64                                     #
#                                                                        #
##########################################################################

%tio_01_01595_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DATA"                         => [   0,   0,  64, 0xFFFFFFFFFFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01595_def =
( NAME    => "XCE_URE_MAINT_DNS_DAT_DATA127_64",
  ADDRESS => 0x30019000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01595_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_DNS_DAT_PARITY                                     #
#                                                                        #
##########################################################################

%tio_01_01596_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PARITY"                       => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01596_def =
( NAME    => "XCE_URE_MAINT_DNS_DAT_PARITY",
  ADDRESS => 0x3001A000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01596_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_DNS_HDR_DATA31_0                                     #
#                                                                        #
##########################################################################

%tio_01_01597_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ADDR"                         => [   0,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD"                         => [   1,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "TAG"                          => [   2,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "REQID"                        => [   3,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01597_def =
( NAME    => "XCE_URE_MAINT_DNS_HDR_DATA31_0",
  ADDRESS => 0x3001B000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01597_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_DNS_HDR_DATA95_32                                     #
#                                                                        #
##########################################################################

%tio_01_01598_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "BYTE_COUNT"                   => [   0,   0,  12, 0x0000000000000FFF, 0x00, 0, 0x0000000000000000, "" ],
   "BCM"                          => [   1,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "STAT"                         => [   2,  13,   3, 0x000000000000E000, 0x00, 0, 0x0000000000000000, "" ],
   "ID"                           => [   3,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "LENGTH"                       => [   4,  32,  10, 0x000003FF00000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD2"                        => [   5,  42,   1, 0x0000040000000000, 0x00, 0, 0x0000000000000000, "" ],
   "RSVD1"                        => [   6,  43,   1, 0x0000080000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ATTR"                         => [   7,  44,   2, 0x0000300000000000, 0x00, 0, 0x0000000000000000, "" ],
   "EP"                           => [   8,  46,   1, 0x0000400000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TD"                           => [   9,  47,   1, 0x0000800000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DB3_0"                        => [  10,  48,   4, 0x000F000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TC"                           => [  11,  52,   3, 0x0070000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DB4"                          => [  12,  55,   1, 0x0080000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "TYPE"                         => [  13,  56,   5, 0x1F00000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "FMT"                          => [  14,  61,   2, 0x6000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "DB5"                          => [  15,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01598_def =
( NAME    => "XCE_URE_MAINT_DNS_HDR_DATA95_32",
  ADDRESS => 0x3001B200,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01598_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_DNS_HDR_PARITY                                     #
#                                                                        #
##########################################################################

%tio_01_01599_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PARITY"                       => [   0,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01599_def =
( NAME    => "XCE_URE_MAINT_DNS_HDR_PARITY",
  ADDRESS => 0x3001B400,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01599_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_RCI_DATA41_0                                       #
#                                                                        #
##########################################################################

%tio_01_01600_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "LENGTH"                       => [   0,  30,  12, 0x000003FFC0000000, 0x00, 0, 0x0000000000000000, "" ],
   "PORT"                         => [   1,  29,   1, 0x0000000020000000, 0x00, 0, 0x0000000000000000, "" ],
   "RO"                           => [   2,  28,   1, 0x0000000010000000, 0x00, 0, 0x0000000000000000, "" ],
   "NOSNOOP"                      => [   3,  27,   1, 0x0000000008000000, 0x00, 0, 0x0000000000000000, "" ],
   "TC"                           => [   4,  24,   3, 0x0000000007000000, 0x00, 0, 0x0000000000000000, "" ],
   "REQID"                        => [   5,   8,  16, 0x0000000000FFFF00, 0x00, 0, 0x0000000000000000, "" ],
   "TAG"                          => [   6,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01600_def =
( NAME    => "XCE_URE_MAINT_RCI_DATA41_0",
  ADDRESS => 0x3001B600,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01600_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_RCI_DATA69_42                                      #
#                                                                        #
##########################################################################

%tio_01_01601_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PARITY"                       => [   0,  24,   4, 0x000000000F000000, 0x00, 0, 0x0000000000000000, "" ],
   "UPS_BUF"                      => [   1,  14,   9, 0x00000000007FC000, 0x00, 0, 0x0000000000000000, "" ],
   "MERGE"                        => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "NEXT"                         => [   3,   7,   6, 0x0000000000001F80, 0x00, 0, 0x0000000000000000, "" ],
   "SADDR"                        => [   4,   0,   7, 0x000000000000007F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01601_def =
( NAME    => "XCE_URE_MAINT_RCI_DATA69_42",
  ADDRESS => 0x3001B800,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01601_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_MAINT_RSPQ                                               #
#                                                                        #
##########################################################################

%tio_01_01602_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PARITY"                       => [   0,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "TNUM"                         => [   1,   0,   6, 0x000000000000003F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01602_def =
( NAME    => "XCE_URE_MAINT_RSPQ",
  ADDRESS => 0x3001BA00,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01602_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_ATE40                                                    #
#                                                                        #
##########################################################################

%tio_01_01603_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PARITY"                       => [   1,  60,   2, 0x3000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADDR"                         => [   2,  26,  28, 0x003FFFFFFC000000, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01603_def =
( NAME    => "XCE_URE_ATE40",
  ADDRESS => 0x30030000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01603_flds
);


##########################################################################
#                                                                        #
#   XCE_URE_ATE3240                                                  #
#                                                                        #
##########################################################################

%tio_01_01604_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "VALID"                        => [   0,  63,   1, 0x8000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "MSI"                          => [   1,  62,   1, 0x4000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "PARITY"                       => [   2,  60,   2, 0x3000000000000000, 0x00, 0, 0x0000000000000000, "" ],
   "ADDR"                         => [   3,  12,  42, 0x003FFFFFFFFFF000, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01604_def =
( NAME    => "XCE_URE_ATE3240",
  ADDRESS => 0x30038000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01604_flds
);


##########################################################################
#                                                                        #
#   XCE_HST_ID_COMP                                                  #
#                                                                        #
##########################################################################

%tio_01_01605_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DID"                          => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "SVI"                          => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01605_def =
( NAME    => "XCE_HST_ID_COMP",
  ADDRESS => 0x34000000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01605_flds
);


##########################################################################
#                                                                        #
#   XCE_HST_CMD_COMP                                                 #
#                                                                        #
##########################################################################

%tio_01_01606_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "IDIS"                         => [   0,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "SEN"                          => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "PEN"                          => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "BME"                          => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "MDE"                          => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "IDE"                          => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01606_def =
( NAME    => "XCE_HST_CMD_COMP",
  ADDRESS => 0x34000004,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01606_flds
);


##########################################################################
#                                                                        #
#   XCE_HST_STAT_COMP                                                #
#                                                                        #
##########################################################################

%tio_01_01607_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DPE"                          => [   0,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "SSE"                          => [   1,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "RMA"                          => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "RTA"                          => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "STA"                          => [   4,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "MDPE"                         => [   5,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "CLIST"                        => [   6,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "ISTAT"                        => [   7,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01607_def =
( NAME    => "XCE_HST_STAT_COMP",
  ADDRESS => 0x34000006,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01607_flds
);


##########################################################################
#                                                                        #
#   XCE_HST_CCR_COMP                                                 #
#                                                                        #
##########################################################################

%tio_01_01608_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CCD"                          => [   0,   8,  24, 0x00000000FFFFFF00, 0x00, 0, 0x0000000000000000, "" ],
   "RID"                          => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01608_def =
( NAME    => "XCE_HST_CCR_COMP",
  ADDRESS => 0x34000008,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01608_flds
);


##########################################################################
#                                                                        #
#   XCE_HST_CLS_COMP                                                 #
#                                                                        #
##########################################################################

%tio_01_01609_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SIZE"                         => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01609_def =
( NAME    => "XCE_HST_CLS_COMP",
  ADDRESS => 0x3400000C,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01609_flds
);


##########################################################################
#                                                                        #
#   XCE_HST_HTR_COMP                                                 #
#                                                                        #
##########################################################################

%tio_01_01610_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TYPE"                         => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01610_def =
( NAME    => "XCE_HST_HTR_COMP",
  ADDRESS => 0x3400000E,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01610_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_ID_COMP                                                 #
#                                                                        #
##########################################################################

%tio_01_01611_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DID"                          => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "SVI"                          => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01611_def =
( NAME    => "XCE_PPB1_ID_COMP",
  ADDRESS => 0x34000800,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01611_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_CMD_COMP                                                #
#                                                                        #
##########################################################################

%tio_01_01612_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "IDIS"                         => [   0,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "SEN"                          => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "PEN"                          => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "BME"                          => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "MDE"                          => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "IDE"                          => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01612_def =
( NAME    => "XCE_PPB1_CMD_COMP",
  ADDRESS => 0x34000804,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01612_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_STAT_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01613_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DPE"                          => [   0,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "SSE"                          => [   1,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "RMA"                          => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "RTA"                          => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "STA"                          => [   4,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "MDPE"                         => [   5,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "CLIST"                        => [   6,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "ISTAT"                        => [   7,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01613_def =
( NAME    => "XCE_PPB1_STAT_COMP",
  ADDRESS => 0x34000806,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01613_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_CCR_COMP                                                #
#                                                                        #
##########################################################################

%tio_01_01614_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CCD"                          => [   0,   8,  24, 0x00000000FFFFFF00, 0x00, 0, 0x0000000000000000, "" ],
   "RID"                          => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01614_def =
( NAME    => "XCE_PPB1_CCR_COMP",
  ADDRESS => 0x34000808,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01614_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_CLS_COMP                                                #
#                                                                        #
##########################################################################

%tio_01_01615_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SIZE"                         => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01615_def =
( NAME    => "XCE_PPB1_CLS_COMP",
  ADDRESS => 0x3400080C,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01615_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_HTR_COMP                                                #
#                                                                        #
##########################################################################

%tio_01_01616_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TYPE"                         => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01616_def =
( NAME    => "XCE_PPB1_HTR_COMP",
  ADDRESS => 0x3400080E,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01616_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_BUS_ID_COMP                                             #
#                                                                        #
##########################################################################

%tio_01_01617_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SUBBN"                        => [   0,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "SBN"                          => [   1,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "PBN"                          => [   2,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01617_def =
( NAME    => "XCE_PPB1_BUS_ID_COMP",
  ADDRESS => 0x34000818,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01617_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_IOLB_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01618_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "IOLIMIT"                      => [   0,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "IOBASE"                       => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01618_def =
( NAME    => "XCE_PPB1_IOLB_COMP",
  ADDRESS => 0x3400081C,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01618_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_SECSTAT_COMP                                            #
#                                                                        #
##########################################################################

%tio_01_01619_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DPE"                          => [   0,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "RSE"                          => [   1,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "RMA"                          => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "RTA"                          => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "STA"                          => [   4,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "MDPE"                         => [   5,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01619_def =
( NAME    => "XCE_PPB1_SECSTAT_COMP",
  ADDRESS => 0x3400081E,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01619_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_MEMLIMIT_COMP                                           #
#                                                                        #
##########################################################################

%tio_01_01620_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MEMLIMIT"                     => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "MEMBASE"                      => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01620_def =
( NAME    => "XCE_PPB1_MEMLIMIT_COMP",
  ADDRESS => 0x34000820,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01620_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_PMEMLIMIT_COMP                                          #
#                                                                        #
##########################################################################

%tio_01_01621_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PMEMLIMIT"                    => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "PMEMBASE"                     => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01621_def =
( NAME    => "XCE_PPB1_PMEMLIMIT_COMP",
  ADDRESS => 0x34000824,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01621_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_PMEMUBASE_COMP                                          #
#                                                                        #
##########################################################################

%tio_01_01622_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PMEMUBASE"                    => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01622_def =
( NAME    => "XCE_PPB1_PMEMUBASE_COMP",
  ADDRESS => 0x34000828,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01622_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_PMEMULIMIT_COMP                                         #
#                                                                        #
##########################################################################

%tio_01_01623_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PMEMULIMIT"                   => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01623_def =
( NAME    => "XCE_PPB1_PMEMULIMIT_COMP",
  ADDRESS => 0x3400082C,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01623_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_IOULB_COMP                                              #
#                                                                        #
##########################################################################

%tio_01_01624_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "IOULIMIT"                     => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "IOUBASE"                      => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01624_def =
( NAME    => "XCE_PPB1_IOULB_COMP",
  ADDRESS => 0x34000830,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01624_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_CPTR_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01625_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CPTR"                         => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01625_def =
( NAME    => "XCE_PPB1_CPTR_COMP",
  ADDRESS => 0x34000834,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01625_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_BCTRL_COMP                                              #
#                                                                        #
##########################################################################

%tio_01_01626_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SBR"                          => [   0,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "SEN"                          => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "PER"                          => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01626_def =
( NAME    => "XCE_PPB1_BCTRL_COMP",
  ADDRESS => 0x3400083E,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01626_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_PCAP_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01627_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "IMN"                          => [   0,  25,   5, 0x000000003E000000, 0x00, 0, 0x0000000000000000, "" ],
   "SI"                           => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "DPT"                          => [   2,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "" ],
   "VERSION"                      => [   3,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "" ],
   "NEXT"                         => [   4,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "CAPID"                        => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01627_def =
( NAME    => "XCE_PPB1_PCAP_COMP",
  ADDRESS => 0x34000840,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01627_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_DCAP_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01628_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CSP"                          => [   0,  18,  10, 0x000000000FFC0000, 0x00, 0, 0x0000000000000000, "" ],
   "HPIP"                         => [   1,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "ELAL1"                        => [   2,   9,   3, 0x0000000000000E00, 0x00, 0, 0x0000000000000000, "" ],
   "ELAL"                         => [   3,   6,   3, 0x00000000000001C0, 0x00, 0, 0x0000000000000000, "" ],
   "ETFS"                         => [   4,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "PFS"                          => [   5,   3,   2, 0x0000000000000018, 0x00, 0, 0x0000000000000000, "" ],
   "MPSS"                         => [   6,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01628_def =
( NAME    => "XCE_PPB1_DCAP_COMP",
  ADDRESS => 0x34000844,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01628_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_DCON_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01629_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MRRS"                         => [   0,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "ETFE"                         => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "MPS"                          => [   2,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "" ],
   "URRE"                         => [   3,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "FERE"                         => [   4,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "NERE"                         => [   5,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "CERE"                         => [   6,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01629_def =
( NAME    => "XCE_PPB1_DCON_COMP",
  ADDRESS => 0x34000848,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01629_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_DSTAT_COMP                                              #
#                                                                        #
##########################################################################

%tio_01_01630_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "URD"                          => [   0,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "FED"                          => [   1,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "NED"                          => [   2,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "CED"                          => [   3,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01630_def =
( NAME    => "XCE_PPB1_DSTAT_COMP",
  ADDRESS => 0x3400084A,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01630_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_LCAP_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01631_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PN"                           => [   0,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "" ],
   "L1EL"                         => [   1,  15,   3, 0x0000000000038000, 0x00, 0, 0x0000000000000000, "" ],
   "L0EL"                         => [   2,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "ASPMS"                        => [   3,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "" ],
   "MLW"                          => [   4,   4,   6, 0x00000000000003F0, 0x00, 0, 0x0000000000000000, "" ],
   "MLS"                          => [   5,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01631_def =
( NAME    => "XCE_PPB1_LCAP_COMP",
  ADDRESS => 0x3400084C,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01631_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_LCON_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01632_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ES"                           => [   0,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "CCC"                          => [   1,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "RL"                           => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "LD"                           => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "RCB"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "ASPMC"                        => [   5,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01632_def =
( NAME    => "XCE_PPB1_LCON_COMP",
  ADDRESS => 0x34000850,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01632_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_LSTAT_COMP                                              #
#                                                                        #
##########################################################################

%tio_01_01633_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCC"                          => [   0,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "LT"                           => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "TE"                           => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LW"                           => [   3,   4,   6, 0x00000000000003F0, 0x00, 0, 0x0000000000000000, "" ],
   "LS"                           => [   4,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01633_def =
( NAME    => "XCE_PPB1_LSTAT_COMP",
  ADDRESS => 0x34000852,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01633_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_SCAP_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01634_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PSN"                          => [   0,  19,  13, 0x00000000FFF80000, 0x00, 0, 0x0000000000000000, "" ],
   "SPLS"                         => [   1,  15,   2, 0x0000000000018000, 0x00, 0, 0x0000000000000000, "" ],
   "SPLV"                         => [   2,   7,   8, 0x0000000000007F80, 0x00, 0, 0x0000000000000000, "" ],
   "HPC"                          => [   3,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "HPS"                          => [   4,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "PIP"                          => [   5,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "AIP"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "MSP"                          => [   7,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "PCP"                          => [   8,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ABP"                          => [   9,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01634_def =
( NAME    => "XCE_PPB1_SCAP_COMP",
  ADDRESS => 0x34000854,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01634_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_SCON_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01635_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PCC"                          => [   0,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "PIC"                          => [   1,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "" ],
   "AIC"                          => [   2,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "" ],
   "HPIE"                         => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "CCIE"                         => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "PDCE"                         => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "MSCE"                         => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "PFDE"                         => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ABPE"                         => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01635_def =
( NAME    => "XCE_PPB1_SCON_COMP",
  ADDRESS => 0x34000858,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01635_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_SSTAT_COMP                                              #
#                                                                        #
##########################################################################

%tio_01_01636_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PDS"                          => [   0,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "MSS"                          => [   1,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "CC"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "PDC"                          => [   3,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "MSC"                          => [   4,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "PFD"                          => [   5,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ABP"                          => [   6,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01636_def =
( NAME    => "XCE_PPB1_SSTAT_COMP",
  ADDRESS => 0x3400085A,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01636_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_RCON_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01637_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PIE"                          => [   0,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "SEFEE"                        => [   1,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "SENEE"                        => [   2,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "SECEE"                        => [   3,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01637_def =
( NAME    => "XCE_PPB1_RCON_COMP",
  ADDRESS => 0x3400085C,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01637_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB1_RSTAT_COMP                                              #
#                                                                        #
##########################################################################

%tio_01_01638_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PP"                           => [   0,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "" ],
   "PS"                           => [   1,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "PRI"                          => [   2,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01638_def =
( NAME    => "XCE_PPB1_RSTAT_COMP",
  ADDRESS => 0x34000860,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01638_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_ID_COMP                                                 #
#                                                                        #
##########################################################################

%tio_01_01639_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DID"                          => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "SVI"                          => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01639_def =
( NAME    => "XCE_PPB2_ID_COMP",
  ADDRESS => 0x34001000,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01639_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_CMD_COMP                                                #
#                                                                        #
##########################################################################

%tio_01_01640_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "IDIS"                         => [   0,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "SEN"                          => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "PEN"                          => [   2,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "BME"                          => [   3,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "MDE"                          => [   4,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "IDE"                          => [   5,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01640_def =
( NAME    => "XCE_PPB2_CMD_COMP",
  ADDRESS => 0x34001004,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01640_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_STAT_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01641_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DPE"                          => [   0,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "SSE"                          => [   1,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "RMA"                          => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "RTA"                          => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "STA"                          => [   4,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "MDPE"                         => [   5,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "CLIST"                        => [   6,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "ISTAT"                        => [   7,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01641_def =
( NAME    => "XCE_PPB2_STAT_COMP",
  ADDRESS => 0x34001006,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01641_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_CCR_COMP                                                #
#                                                                        #
##########################################################################

%tio_01_01642_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CCD"                          => [   0,   8,  24, 0x00000000FFFFFF00, 0x00, 0, 0x0000000000000000, "" ],
   "RID"                          => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01642_def =
( NAME    => "XCE_PPB2_CCR_COMP",
  ADDRESS => 0x34001008,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01642_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_CLS_COMP                                                #
#                                                                        #
##########################################################################

%tio_01_01643_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SIZE"                         => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01643_def =
( NAME    => "XCE_PPB2_CLS_COMP",
  ADDRESS => 0x3400100C,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01643_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_HTR_COMP                                                #
#                                                                        #
##########################################################################

%tio_01_01644_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "TYPE"                         => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01644_def =
( NAME    => "XCE_PPB2_HTR_COMP",
  ADDRESS => 0x3400100E,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01644_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_BUS_ID_COMP                                             #
#                                                                        #
##########################################################################

%tio_01_01645_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SUBBN"                        => [   0,  16,   8, 0x0000000000FF0000, 0x00, 0, 0x0000000000000000, "" ],
   "SBN"                          => [   1,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "PBN"                          => [   2,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01645_def =
( NAME    => "XCE_PPB2_BUS_ID_COMP",
  ADDRESS => 0x34001018,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01645_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_IOLB_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01646_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "IOLIMIT"                      => [   0,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "IOBASE"                       => [   1,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01646_def =
( NAME    => "XCE_PPB2_IOLB_COMP",
  ADDRESS => 0x3400101C,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01646_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_SECSTAT_COMP                                            #
#                                                                        #
##########################################################################

%tio_01_01647_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "DPE"                          => [   0,  15,   1, 0x0000000000008000, 0x00, 0, 0x0000000000000000, "" ],
   "RSE"                          => [   1,  14,   1, 0x0000000000004000, 0x00, 0, 0x0000000000000000, "" ],
   "RMA"                          => [   2,  13,   1, 0x0000000000002000, 0x00, 0, 0x0000000000000000, "" ],
   "RTA"                          => [   3,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "STA"                          => [   4,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "MDPE"                         => [   5,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01647_def =
( NAME    => "XCE_PPB2_SECSTAT_COMP",
  ADDRESS => 0x3400101E,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01647_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_MEMLIMIT_COMP                                           #
#                                                                        #
##########################################################################

%tio_01_01648_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MEMLIMIT"                     => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "MEMBASE"                      => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01648_def =
( NAME    => "XCE_PPB2_MEMLIMIT_COMP",
  ADDRESS => 0x34001020,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01648_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_PMEMLIMIT_COMP                                          #
#                                                                        #
##########################################################################

%tio_01_01649_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PMEMLIMIT"                    => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "PMEMBASE"                     => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01649_def =
( NAME    => "XCE_PPB2_PMEMLIMIT_COMP",
  ADDRESS => 0x34001024,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01649_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_PMEMUBASE_COMP                                          #
#                                                                        #
##########################################################################

%tio_01_01650_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PMEMUBASE"                    => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01650_def =
( NAME    => "XCE_PPB2_PMEMUBASE_COMP",
  ADDRESS => 0x34001028,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01650_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_PMEMULIMIT_COMP                                         #
#                                                                        #
##########################################################################

%tio_01_01651_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PMEMULIMIT"                   => [   0,   0,  32, 0x00000000FFFFFFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01651_def =
( NAME    => "XCE_PPB2_PMEMULIMIT_COMP",
  ADDRESS => 0x3400102C,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01651_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_IOULB_COMP                                              #
#                                                                        #
##########################################################################

%tio_01_01652_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "IOULIMIT"                     => [   0,  16,  16, 0x00000000FFFF0000, 0x00, 0, 0x0000000000000000, "" ],
   "IOUBASE"                      => [   1,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01652_def =
( NAME    => "XCE_PPB2_IOULB_COMP",
  ADDRESS => 0x34001030,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01652_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_CPTR_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01653_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CPTR"                         => [   0,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01653_def =
( NAME    => "XCE_PPB2_CPTR_COMP",
  ADDRESS => 0x34001034,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01653_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_BCTRL_COMP                                              #
#                                                                        #
##########################################################################

%tio_01_01654_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SBR"                          => [   0,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "SEN"                          => [   1,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "PER"                          => [   2,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01654_def =
( NAME    => "XCE_PPB2_BCTRL_COMP",
  ADDRESS => 0x3400103E,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01654_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_PCAP_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01655_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "IMN"                          => [   0,  25,   5, 0x000000003E000000, 0x00, 0, 0x0000000000000000, "" ],
   "SI"                           => [   1,  24,   1, 0x0000000001000000, 0x00, 0, 0x0000000000000000, "" ],
   "DPT"                          => [   2,  20,   4, 0x0000000000F00000, 0x00, 0, 0x0000000000000000, "" ],
   "VERSION"                      => [   3,  16,   4, 0x00000000000F0000, 0x00, 0, 0x0000000000000000, "" ],
   "NEXT"                         => [   4,   8,   8, 0x000000000000FF00, 0x00, 0, 0x0000000000000000, "" ],
   "CAPID"                        => [   5,   0,   8, 0x00000000000000FF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01655_def =
( NAME    => "XCE_PPB2_PCAP_COMP",
  ADDRESS => 0x34001040,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01655_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_DCAP_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01656_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "CSP"                          => [   0,  18,  10, 0x000000000FFC0000, 0x00, 0, 0x0000000000000000, "" ],
   "HPIP"                         => [   1,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "ELAL1"                        => [   2,   9,   3, 0x0000000000000E00, 0x00, 0, 0x0000000000000000, "" ],
   "ELAL"                         => [   3,   6,   3, 0x00000000000001C0, 0x00, 0, 0x0000000000000000, "" ],
   "ETFS"                         => [   4,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "PFS"                          => [   5,   3,   2, 0x0000000000000018, 0x00, 0, 0x0000000000000000, "" ],
   "MPSS"                         => [   6,   0,   3, 0x0000000000000007, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01656_def =
( NAME    => "XCE_PPB2_DCAP_COMP",
  ADDRESS => 0x34001044,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01656_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_DCON_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01657_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "MRRS"                         => [   0,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "ETFE"                         => [   1,   8,   1, 0x0000000000000100, 0x00, 0, 0x0000000000000000, "" ],
   "MPS"                          => [   2,   5,   3, 0x00000000000000E0, 0x00, 0, 0x0000000000000000, "" ],
   "URRE"                         => [   3,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "FERE"                         => [   4,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "NERE"                         => [   5,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "CERE"                         => [   6,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01657_def =
( NAME    => "XCE_PPB2_DCON_COMP",
  ADDRESS => 0x34001048,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01657_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_DSTAT_COMP                                              #
#                                                                        #
##########################################################################

%tio_01_01658_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "URD"                          => [   0,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "FED"                          => [   1,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "NED"                          => [   2,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "CED"                          => [   3,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01658_def =
( NAME    => "XCE_PPB2_DSTAT_COMP",
  ADDRESS => 0x3400104A,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01658_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_LCAP_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01659_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PN"                           => [   0,  24,   8, 0x00000000FF000000, 0x00, 0, 0x0000000000000000, "" ],
   "L1EL"                         => [   1,  15,   3, 0x0000000000038000, 0x00, 0, 0x0000000000000000, "" ],
   "L0EL"                         => [   2,  12,   3, 0x0000000000007000, 0x00, 0, 0x0000000000000000, "" ],
   "ASPMS"                        => [   3,  10,   2, 0x0000000000000C00, 0x00, 0, 0x0000000000000000, "" ],
   "MLW"                          => [   4,   4,   6, 0x00000000000003F0, 0x00, 0, 0x0000000000000000, "" ],
   "MLS"                          => [   5,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01659_def =
( NAME    => "XCE_PPB2_LCAP_COMP",
  ADDRESS => 0x3400104C,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01659_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_LCON_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01660_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "ES"                           => [   0,   7,   1, 0x0000000000000080, 0x00, 0, 0x0000000000000000, "" ],
   "CCC"                          => [   1,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "RL"                           => [   2,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "LD"                           => [   3,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "RCB"                          => [   4,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "ASPMC"                        => [   5,   0,   2, 0x0000000000000003, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01660_def =
( NAME    => "XCE_PPB2_LCON_COMP",
  ADDRESS => 0x34001050,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01660_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_LSTAT_COMP                                              #
#                                                                        #
##########################################################################

%tio_01_01661_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "SCC"                          => [   0,  12,   1, 0x0000000000001000, 0x00, 0, 0x0000000000000000, "" ],
   "LT"                           => [   1,  11,   1, 0x0000000000000800, 0x00, 0, 0x0000000000000000, "" ],
   "TE"                           => [   2,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "LW"                           => [   3,   4,   6, 0x00000000000003F0, 0x00, 0, 0x0000000000000000, "" ],
   "LS"                           => [   4,   0,   4, 0x000000000000000F, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01661_def =
( NAME    => "XCE_PPB2_LSTAT_COMP",
  ADDRESS => 0x34001052,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01661_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_SCAP_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01662_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PSN"                          => [   0,  19,  13, 0x00000000FFF80000, 0x00, 0, 0x0000000000000000, "" ],
   "SPLS"                         => [   1,  15,   2, 0x0000000000018000, 0x00, 0, 0x0000000000000000, "" ],
   "SPLV"                         => [   2,   7,   8, 0x0000000000007F80, 0x00, 0, 0x0000000000000000, "" ],
   "HPC"                          => [   3,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "HPS"                          => [   4,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "PIP"                          => [   5,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "AIP"                          => [   6,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "MSP"                          => [   7,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "PCP"                          => [   8,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ABP"                          => [   9,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01662_def =
( NAME    => "XCE_PPB2_SCAP_COMP",
  ADDRESS => 0x34001054,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01662_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_SCON_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01663_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PCC"                          => [   0,  10,   1, 0x0000000000000400, 0x00, 0, 0x0000000000000000, "" ],
   "PIC"                          => [   1,   8,   2, 0x0000000000000300, 0x00, 0, 0x0000000000000000, "" ],
   "AIC"                          => [   2,   6,   2, 0x00000000000000C0, 0x00, 0, 0x0000000000000000, "" ],
   "HPIE"                         => [   3,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "CCIE"                         => [   4,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "PDCE"                         => [   5,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "MSCE"                         => [   6,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "PFDE"                         => [   7,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ABPE"                         => [   8,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01663_def =
( NAME    => "XCE_PPB2_SCON_COMP",
  ADDRESS => 0x34001058,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01663_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_SSTAT_COMP                                              #
#                                                                        #
##########################################################################

%tio_01_01664_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PDS"                          => [   0,   6,   1, 0x0000000000000040, 0x00, 0, 0x0000000000000000, "" ],
   "MSS"                          => [   1,   5,   1, 0x0000000000000020, 0x00, 0, 0x0000000000000000, "" ],
   "CC"                           => [   2,   4,   1, 0x0000000000000010, 0x00, 0, 0x0000000000000000, "" ],
   "PDC"                          => [   3,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "MSC"                          => [   4,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "PFD"                          => [   5,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "ABP"                          => [   6,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01664_def =
( NAME    => "XCE_PPB2_SSTAT_COMP",
  ADDRESS => 0x3400105A,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01664_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_RCON_COMP                                               #
#                                                                        #
##########################################################################

%tio_01_01665_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PIE"                          => [   0,   3,   1, 0x0000000000000008, 0x00, 0, 0x0000000000000000, "" ],
   "SEFEE"                        => [   1,   2,   1, 0x0000000000000004, 0x00, 0, 0x0000000000000000, "" ],
   "SENEE"                        => [   2,   1,   1, 0x0000000000000002, 0x00, 0, 0x0000000000000000, "" ],
   "SECEE"                        => [   3,   0,   1, 0x0000000000000001, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01665_def =
( NAME    => "XCE_PPB2_RCON_COMP",
  ADDRESS => 0x3400105C,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01665_flds
);


##########################################################################
#                                                                        #
#   XCE_PPB2_RSTAT_COMP                                              #
#                                                                        #
##########################################################################

%tio_01_01666_flds =
(
#  LABEL                               IND  POS  LEN  FIELD_DATA_MASK     MODE  F  RESET_VALUE         DESCRIPTION
#  ------------------------------      ---  ---  ---  ------------------  ----  -  ------------------  -----------
   "PP"                           => [   0,  17,   1, 0x0000000000020000, 0x00, 0, 0x0000000000000000, "" ],
   "PS"                           => [   1,  16,   1, 0x0000000000010000, 0x00, 0, 0x0000000000000000, "" ],
   "PRI"                          => [   2,   0,  16, 0x000000000000FFFF, 0x00, 0, 0x0000000000000000, "" ],
);

%tio_01_01666_def =
( NAME    => "XCE_PPB2_RSTAT_COMP",
  ADDRESS => 0x34001060,
  NOTE    => "",
  RESET   => 0x0000000000000000,
  FIELDS  => \%tio_01_01666_flds
);


##########################################################################
#                                                                        #
#   MMR LOOKUP TABLES (BY NAME OR ADDRESS)                               #
#                                                                        #
##########################################################################

%tio_01_mmr_by_name = 
(
   TIO_ICE_GMS_ERROR_SUMMARY    => \%tio_01_00000_def,
   TIO_ICE_GMS_ERROR_SUMMARY_ALIAS => \%tio_01_00001_def,
   TIO_ICE_GMS_ERROR_OVERFLOW   => \%tio_01_00002_def,
   TIO_ICE_GMS_ERROR_OVERFLOW_ALIAS => \%tio_01_00003_def,
   TIO_ICE_GMS_FIRST_ERROR      => \%tio_01_00004_def,
   TIO_ICE_GMS_ERROR_MASK       => \%tio_01_00005_def,
   TIO_ICE_GMS_DBG_TRIG_COMPARE => \%tio_01_00006_def,
   TIO_ICE_GMS_DBG_TRIG_SELECT  => \%tio_01_00007_def,
   TIO_ICE_GMS_DBG_TRIG_ENABLE  => \%tio_01_00008_def,
   TIO_ICE_GMS_DBG_MUX_SELECT   => \%tio_01_00009_def,
   TIO_ICE_GMS_TIMEOUT_PULSE    => \%tio_01_00010_def,
   TIO_ICE_GMS_TIMEOUT_PRESCALE => \%tio_01_00011_def,
   TIO_ICE_GMS_REQ_NACK_LIMIT   => \%tio_01_00012_def,
   TIO_ICE_GMS_REQ_PRIORITY     => \%tio_01_00013_def,
   TIO_ICE_NPA_ERROR_SUMMARY    => \%tio_01_00014_def,
   TIO_ICE_NPA_ERROR_SUMMARY_ALIAS => \%tio_01_00015_def,
   TIO_ICE_NPA_FIRST_ERROR      => \%tio_01_00016_def,
   TIO_ICE_NPA_XN_ERROR_DETAIL_1 => \%tio_01_00017_def,
   TIO_ICE_NPA_XN_ERROR_DETAIL_2 => \%tio_01_00018_def,
   TIO_ICE_NPA_XN_DATA0_CMP     => \%tio_01_00019_def,
   TIO_ICE_NPA_XN_DATA1_CMP     => \%tio_01_00020_def,
   TIO_ICE_NPA_XN_DATA0_EN      => \%tio_01_00021_def,
   TIO_ICE_NPA_XN_DATA1_EN      => \%tio_01_00022_def,
   TIO_ICE_NPA_DBG_MUX_SELECT   => \%tio_01_00023_def,
   TIO_ICE_NPA_WR_ACC_CFG       => \%tio_01_00024_def,
   TIO_ICE_NPA_WR_REQ_CFG       => \%tio_01_00025_def,
   TIO_ICE_NPA_RD_ACC_CFG       => \%tio_01_00026_def,
   TIO_ICE_NPA_RD_REQ_CFG       => \%tio_01_00027_def,
   TIO_ICE_NPA_NOQ_REQ_CFG      => \%tio_01_00028_def,
   TIO_ICE_NPA_NOQ_RSP_CFG      => \%tio_01_00029_def,
   TIO_ICE_NPA_RIQ_CFG          => \%tio_01_00030_def,
   TIO_ICE_NPA_RD_WR_DYN_CREDIT_STAT => \%tio_01_00031_def,
   TIO_ICE_NPA_RD_WR_LAST_CREDIT_STAT => \%tio_01_00032_def,
   TIO_ICE_NPA_NOQ_DYN_CREDIT_STAT => \%tio_01_00033_def,
   TIO_ICE_NPA_NOQ_LAST_CREDIT_STAT => \%tio_01_00034_def,
   TIO_ICE_NPA_RIQ_DYN_STAT     => \%tio_01_00035_def,
   TIO_ICE_NPA_RIQ_LAST_STAT    => \%tio_01_00036_def,
   TIO_ICE_NPA_NIQ_REQ_CFG      => \%tio_01_00037_def,
   TIO_ICE_NPA_NIQ_RSP_CFG      => \%tio_01_00038_def,
   TIO_ICE_NPA_NIQ_DYN_CREDIT_STAT => \%tio_01_00039_def,
   TIO_ICE_NPA_NIQ_LAST_CREDIT_STAT => \%tio_01_00040_def,
   TIO_ICE_NPA_HQ_VAL_DETAIL0   => \%tio_01_00041_def,
   TIO_ICE_NPA_HQ_VAL_DETAIL1   => \%tio_01_00042_def,
   TIO_ICE_NPA_HQ_ENTRY0        => \%tio_01_00043_def,
   TIO_ICE_NPA_HQ_EJECT_HEAD    => \%tio_01_00044_def,
   TIO_ICE_WRC_ERROR_SUMMARY    => \%tio_01_00045_def,
   TIO_ICE_WRC_ERROR_SUMMARY_ALIAS => \%tio_01_00046_def,
   TIO_ICE_WRC_FIRST_ERROR      => \%tio_01_00047_def,
   TIO_ICE_WRC_XN_ERROR_DETAIL_1 => \%tio_01_00048_def,
   TIO_ICE_WRC_XN_ERROR_DETAIL_2 => \%tio_01_00049_def,
   TIO_ICE_WRC_CT_ERROR_DETAIL_1 => \%tio_01_00050_def,
   TIO_ICE_WRC_CT_ERROR_DETAIL_2 => \%tio_01_00051_def,
   TIO_ICE_WRC_DBG_MUX_SELECT   => \%tio_01_00052_def,
   TIO_ICE_WRC_CFG              => \%tio_01_00053_def,
   TIO_ICE_WRC_TIMEOUT_DETAIL   => \%tio_01_00054_def,
   TIO_ICE_WRC_DYN_CREDIT_STAT  => \%tio_01_00055_def,
   TIO_ICE_WRC_LAST_CREDIT_STAT => \%tio_01_00056_def,
   TIO_ICE_WRC_IQ_STAT          => \%tio_01_00057_def,
   TIO_ICE_WRC_CRB_0            => \%tio_01_00058_def,
   TIO_ICE_WRC_CRB_1            => \%tio_01_00059_def,
   TIO_ICE_WRC_CRB_2            => \%tio_01_00060_def,
   TIO_ICE_WRC_CRB_3            => \%tio_01_00061_def,
   TIO_ICE_WRC_CRB_4            => \%tio_01_00062_def,
   TIO_ICE_WRC_CRB_5            => \%tio_01_00063_def,
   TIO_ICE_WRC_CRB_6            => \%tio_01_00064_def,
   TIO_ICE_WRC_CRB_7            => \%tio_01_00065_def,
   TIO_ICE_WRC_CRB_8            => \%tio_01_00066_def,
   TIO_ICE_WRC_CRB_9            => \%tio_01_00067_def,
   TIO_ICE_WRC_CRB_10           => \%tio_01_00068_def,
   TIO_ICE_WRC_CRB_11           => \%tio_01_00069_def,
   TIO_ICE_WRC_CRB_12           => \%tio_01_00070_def,
   TIO_ICE_WRC_CRB_13           => \%tio_01_00071_def,
   TIO_ICE_WRC_CRB_14           => \%tio_01_00072_def,
   TIO_ICE_WRC_CRB_15           => \%tio_01_00073_def,
   TIO_ICE_WRC_CRB_16           => \%tio_01_00074_def,
   TIO_ICE_WRC_CRB_17           => \%tio_01_00075_def,
   TIO_ICE_WRC_CRB_18           => \%tio_01_00076_def,
   TIO_ICE_WRC_CRB_19           => \%tio_01_00077_def,
   TIO_ICE_WRC_CRB_20           => \%tio_01_00078_def,
   TIO_ICE_WRC_CRB_21           => \%tio_01_00079_def,
   TIO_ICE_WRC_CRB_22           => \%tio_01_00080_def,
   TIO_ICE_WRC_CRB_23           => \%tio_01_00081_def,
   TIO_ICE_WRC_CRB_24           => \%tio_01_00082_def,
   TIO_ICE_WRC_CRB_25           => \%tio_01_00083_def,
   TIO_ICE_WRC_CRB_26           => \%tio_01_00084_def,
   TIO_ICE_WRC_CRB_27           => \%tio_01_00085_def,
   TIO_ICE_WRC_CRB_28           => \%tio_01_00086_def,
   TIO_ICE_WRC_CRB_29           => \%tio_01_00087_def,
   TIO_ICE_WRC_CRB_30           => \%tio_01_00088_def,
   TIO_ICE_WRC_CRB_31           => \%tio_01_00089_def,
   TIO_ICE_WRC_CRB_ADDR_0       => \%tio_01_00090_def,
   TIO_ICE_WRC_CRB_ADDR_1       => \%tio_01_00091_def,
   TIO_ICE_WRC_CRB_ADDR_2       => \%tio_01_00092_def,
   TIO_ICE_WRC_CRB_ADDR_3       => \%tio_01_00093_def,
   TIO_ICE_WRC_CRB_ADDR_4       => \%tio_01_00094_def,
   TIO_ICE_WRC_CRB_ADDR_5       => \%tio_01_00095_def,
   TIO_ICE_WRC_CRB_ADDR_6       => \%tio_01_00096_def,
   TIO_ICE_WRC_CRB_ADDR_7       => \%tio_01_00097_def,
   TIO_ICE_WRC_CRB_ADDR_8       => \%tio_01_00098_def,
   TIO_ICE_WRC_CRB_ADDR_9       => \%tio_01_00099_def,
   TIO_ICE_WRC_CRB_ADDR_10      => \%tio_01_00100_def,
   TIO_ICE_WRC_CRB_ADDR_11      => \%tio_01_00101_def,
   TIO_ICE_WRC_CRB_ADDR_12      => \%tio_01_00102_def,
   TIO_ICE_WRC_CRB_ADDR_13      => \%tio_01_00103_def,
   TIO_ICE_WRC_CRB_ADDR_14      => \%tio_01_00104_def,
   TIO_ICE_WRC_CRB_ADDR_15      => \%tio_01_00105_def,
   TIO_ICE_WRC_CRB_ADDR_16      => \%tio_01_00106_def,
   TIO_ICE_WRC_CRB_ADDR_17      => \%tio_01_00107_def,
   TIO_ICE_WRC_CRB_ADDR_18      => \%tio_01_00108_def,
   TIO_ICE_WRC_CRB_ADDR_19      => \%tio_01_00109_def,
   TIO_ICE_WRC_CRB_ADDR_20      => \%tio_01_00110_def,
   TIO_ICE_WRC_CRB_ADDR_21      => \%tio_01_00111_def,
   TIO_ICE_WRC_CRB_ADDR_22      => \%tio_01_00112_def,
   TIO_ICE_WRC_CRB_ADDR_23      => \%tio_01_00113_def,
   TIO_ICE_WRC_CRB_ADDR_24      => \%tio_01_00114_def,
   TIO_ICE_WRC_CRB_ADDR_25      => \%tio_01_00115_def,
   TIO_ICE_WRC_CRB_ADDR_26      => \%tio_01_00116_def,
   TIO_ICE_WRC_CRB_ADDR_27      => \%tio_01_00117_def,
   TIO_ICE_WRC_CRB_ADDR_28      => \%tio_01_00118_def,
   TIO_ICE_WRC_CRB_ADDR_29      => \%tio_01_00119_def,
   TIO_ICE_WRC_CRB_ADDR_30      => \%tio_01_00120_def,
   TIO_ICE_WRC_CRB_ADDR_31      => \%tio_01_00121_def,
   TIO_ICE_RRC_ERROR_SUMMARY    => \%tio_01_00122_def,
   TIO_ICE_RRC_ERROR_SUMMARY_ALIAS => \%tio_01_00123_def,
   TIO_ICE_RRC_FIRST_ERROR      => \%tio_01_00124_def,
   TIO_ICE_RRC_XN_ERROR_DETAIL_1 => \%tio_01_00125_def,
   TIO_ICE_RRC_XN_ERROR_DETAIL_2 => \%tio_01_00126_def,
   TIO_ICE_RRC_CT_ERROR_DETAIL_1 => \%tio_01_00127_def,
   TIO_ICE_RRC_CT_ERROR_DETAIL_2 => \%tio_01_00128_def,
   TIO_ICE_RRC_DBG_MUX_SELECT   => \%tio_01_00129_def,
   TIO_ICE_RRC_CFG              => \%tio_01_00130_def,
   TIO_ICE_RRC_TIMEOUT_DETAIL   => \%tio_01_00131_def,
   TIO_ICE_RRC_DYN_CREDIT_STAT  => \%tio_01_00132_def,
   TIO_ICE_RRC_LAST_CREDIT_STAT => \%tio_01_00133_def,
   TIO_ICE_RRC_IQ_STAT          => \%tio_01_00134_def,
   TIO_ICE_RRC_CRB_0            => \%tio_01_00135_def,
   TIO_ICE_RRC_CRB_1            => \%tio_01_00136_def,
   TIO_ICE_RRC_CRB_2            => \%tio_01_00137_def,
   TIO_ICE_RRC_CRB_3            => \%tio_01_00138_def,
   TIO_ICE_RRC_CRB_4            => \%tio_01_00139_def,
   TIO_ICE_RRC_CRB_5            => \%tio_01_00140_def,
   TIO_ICE_RRC_CRB_6            => \%tio_01_00141_def,
   TIO_ICE_RRC_CRB_7            => \%tio_01_00142_def,
   TIO_ICE_RRC_CRB_8            => \%tio_01_00143_def,
   TIO_ICE_RRC_CRB_9            => \%tio_01_00144_def,
   TIO_ICE_RRC_CRB_10           => \%tio_01_00145_def,
   TIO_ICE_RRC_CRB_11           => \%tio_01_00146_def,
   TIO_ICE_RRC_CRB_12           => \%tio_01_00147_def,
   TIO_ICE_RRC_CRB_13           => \%tio_01_00148_def,
   TIO_ICE_RRC_CRB_14           => \%tio_01_00149_def,
   TIO_ICE_RRC_CRB_15           => \%tio_01_00150_def,
   TIO_ICE_RRC_CRB_16           => \%tio_01_00151_def,
   TIO_ICE_RRC_CRB_17           => \%tio_01_00152_def,
   TIO_ICE_RRC_CRB_18           => \%tio_01_00153_def,
   TIO_ICE_RRC_CRB_19           => \%tio_01_00154_def,
   TIO_ICE_RRC_CRB_20           => \%tio_01_00155_def,
   TIO_ICE_RRC_CRB_21           => \%tio_01_00156_def,
   TIO_ICE_RRC_CRB_22           => \%tio_01_00157_def,
   TIO_ICE_RRC_CRB_23           => \%tio_01_00158_def,
   TIO_ICE_RRC_CRB_24           => \%tio_01_00159_def,
   TIO_ICE_RRC_CRB_25           => \%tio_01_00160_def,
   TIO_ICE_RRC_CRB_26           => \%tio_01_00161_def,
   TIO_ICE_RRC_CRB_27           => \%tio_01_00162_def,
   TIO_ICE_RRC_CRB_28           => \%tio_01_00163_def,
   TIO_ICE_RRC_CRB_29           => \%tio_01_00164_def,
   TIO_ICE_RRC_CRB_30           => \%tio_01_00165_def,
   TIO_ICE_RRC_CRB_31           => \%tio_01_00166_def,
   TIO_ICE_RRC_CRB_32           => \%tio_01_00167_def,
   TIO_ICE_RRC_CRB_33           => \%tio_01_00168_def,
   TIO_ICE_RRC_CRB_34           => \%tio_01_00169_def,
   TIO_ICE_RRC_CRB_35           => \%tio_01_00170_def,
   TIO_ICE_RRC_CRB_36           => \%tio_01_00171_def,
   TIO_ICE_RRC_CRB_37           => \%tio_01_00172_def,
   TIO_ICE_RRC_CRB_38           => \%tio_01_00173_def,
   TIO_ICE_RRC_CRB_39           => \%tio_01_00174_def,
   TIO_ICE_RRC_CRB_40           => \%tio_01_00175_def,
   TIO_ICE_RRC_CRB_41           => \%tio_01_00176_def,
   TIO_ICE_RRC_CRB_42           => \%tio_01_00177_def,
   TIO_ICE_RRC_CRB_43           => \%tio_01_00178_def,
   TIO_ICE_RRC_CRB_44           => \%tio_01_00179_def,
   TIO_ICE_RRC_CRB_45           => \%tio_01_00180_def,
   TIO_ICE_RRC_CRB_46           => \%tio_01_00181_def,
   TIO_ICE_RRC_CRB_47           => \%tio_01_00182_def,
   TIO_ICE_RRC_CRB_48           => \%tio_01_00183_def,
   TIO_ICE_RRC_CRB_49           => \%tio_01_00184_def,
   TIO_ICE_RRC_CRB_50           => \%tio_01_00185_def,
   TIO_ICE_RRC_CRB_51           => \%tio_01_00186_def,
   TIO_ICE_RRC_CRB_52           => \%tio_01_00187_def,
   TIO_ICE_RRC_CRB_53           => \%tio_01_00188_def,
   TIO_ICE_RRC_CRB_54           => \%tio_01_00189_def,
   TIO_ICE_RRC_CRB_55           => \%tio_01_00190_def,
   TIO_ICE_RRC_CRB_56           => \%tio_01_00191_def,
   TIO_ICE_RRC_CRB_57           => \%tio_01_00192_def,
   TIO_ICE_RRC_CRB_58           => \%tio_01_00193_def,
   TIO_ICE_RRC_CRB_59           => \%tio_01_00194_def,
   TIO_ICE_RRC_CRB_60           => \%tio_01_00195_def,
   TIO_ICE_RRC_CRB_61           => \%tio_01_00196_def,
   TIO_ICE_RRC_CRB_62           => \%tio_01_00197_def,
   TIO_ICE_RRC_CRB_63           => \%tio_01_00198_def,
   TIO_ICE_RRC_CRB_ADDR_0       => \%tio_01_00199_def,
   TIO_ICE_RRC_CRB_ADDR_1       => \%tio_01_00200_def,
   TIO_ICE_RRC_CRB_ADDR_2       => \%tio_01_00201_def,
   TIO_ICE_RRC_CRB_ADDR_3       => \%tio_01_00202_def,
   TIO_ICE_RRC_CRB_ADDR_4       => \%tio_01_00203_def,
   TIO_ICE_RRC_CRB_ADDR_5       => \%tio_01_00204_def,
   TIO_ICE_RRC_CRB_ADDR_6       => \%tio_01_00205_def,
   TIO_ICE_RRC_CRB_ADDR_7       => \%tio_01_00206_def,
   TIO_ICE_RRC_CRB_ADDR_8       => \%tio_01_00207_def,
   TIO_ICE_RRC_CRB_ADDR_9       => \%tio_01_00208_def,
   TIO_ICE_RRC_CRB_ADDR_10      => \%tio_01_00209_def,
   TIO_ICE_RRC_CRB_ADDR_11      => \%tio_01_00210_def,
   TIO_ICE_RRC_CRB_ADDR_12      => \%tio_01_00211_def,
   TIO_ICE_RRC_CRB_ADDR_13      => \%tio_01_00212_def,
   TIO_ICE_RRC_CRB_ADDR_14      => \%tio_01_00213_def,
   TIO_ICE_RRC_CRB_ADDR_15      => \%tio_01_00214_def,
   TIO_ICE_RRC_CRB_ADDR_16      => \%tio_01_00215_def,
   TIO_ICE_RRC_CRB_ADDR_17      => \%tio_01_00216_def,
   TIO_ICE_RRC_CRB_ADDR_18      => \%tio_01_00217_def,
   TIO_ICE_RRC_CRB_ADDR_19      => \%tio_01_00218_def,
   TIO_ICE_RRC_CRB_ADDR_20      => \%tio_01_00219_def,
   TIO_ICE_RRC_CRB_ADDR_21      => \%tio_01_00220_def,
   TIO_ICE_RRC_CRB_ADDR_22      => \%tio_01_00221_def,
   TIO_ICE_RRC_CRB_ADDR_23      => \%tio_01_00222_def,
   TIO_ICE_RRC_CRB_ADDR_24      => \%tio_01_00223_def,
   TIO_ICE_RRC_CRB_ADDR_25      => \%tio_01_00224_def,
   TIO_ICE_RRC_CRB_ADDR_26      => \%tio_01_00225_def,
   TIO_ICE_RRC_CRB_ADDR_27      => \%tio_01_00226_def,
   TIO_ICE_RRC_CRB_ADDR_28      => \%tio_01_00227_def,
   TIO_ICE_RRC_CRB_ADDR_29      => \%tio_01_00228_def,
   TIO_ICE_RRC_CRB_ADDR_30      => \%tio_01_00229_def,
   TIO_ICE_RRC_CRB_ADDR_31      => \%tio_01_00230_def,
   TIO_ICE_RRC_CRB_ADDR_32      => \%tio_01_00231_def,
   TIO_ICE_RRC_CRB_ADDR_33      => \%tio_01_00232_def,
   TIO_ICE_RRC_CRB_ADDR_34      => \%tio_01_00233_def,
   TIO_ICE_RRC_CRB_ADDR_35      => \%tio_01_00234_def,
   TIO_ICE_RRC_CRB_ADDR_36      => \%tio_01_00235_def,
   TIO_ICE_RRC_CRB_ADDR_37      => \%tio_01_00236_def,
   TIO_ICE_RRC_CRB_ADDR_38      => \%tio_01_00237_def,
   TIO_ICE_RRC_CRB_ADDR_39      => \%tio_01_00238_def,
   TIO_ICE_RRC_CRB_ADDR_40      => \%tio_01_00239_def,
   TIO_ICE_RRC_CRB_ADDR_41      => \%tio_01_00240_def,
   TIO_ICE_RRC_CRB_ADDR_42      => \%tio_01_00241_def,
   TIO_ICE_RRC_CRB_ADDR_43      => \%tio_01_00242_def,
   TIO_ICE_RRC_CRB_ADDR_44      => \%tio_01_00243_def,
   TIO_ICE_RRC_CRB_ADDR_45      => \%tio_01_00244_def,
   TIO_ICE_RRC_CRB_ADDR_46      => \%tio_01_00245_def,
   TIO_ICE_RRC_CRB_ADDR_47      => \%tio_01_00246_def,
   TIO_ICE_RRC_CRB_ADDR_48      => \%tio_01_00247_def,
   TIO_ICE_RRC_CRB_ADDR_49      => \%tio_01_00248_def,
   TIO_ICE_RRC_CRB_ADDR_50      => \%tio_01_00249_def,
   TIO_ICE_RRC_CRB_ADDR_51      => \%tio_01_00250_def,
   TIO_ICE_RRC_CRB_ADDR_52      => \%tio_01_00251_def,
   TIO_ICE_RRC_CRB_ADDR_53      => \%tio_01_00252_def,
   TIO_ICE_RRC_CRB_ADDR_54      => \%tio_01_00253_def,
   TIO_ICE_RRC_CRB_ADDR_55      => \%tio_01_00254_def,
   TIO_ICE_RRC_CRB_ADDR_56      => \%tio_01_00255_def,
   TIO_ICE_RRC_CRB_ADDR_57      => \%tio_01_00256_def,
   TIO_ICE_RRC_CRB_ADDR_58      => \%tio_01_00257_def,
   TIO_ICE_RRC_CRB_ADDR_59      => \%tio_01_00258_def,
   TIO_ICE_RRC_CRB_ADDR_60      => \%tio_01_00259_def,
   TIO_ICE_RRC_CRB_ADDR_61      => \%tio_01_00260_def,
   TIO_ICE_RRC_CRB_ADDR_62      => \%tio_01_00261_def,
   TIO_ICE_RRC_CRB_ADDR_63      => \%tio_01_00262_def,
   TIO_ICE_FRZ_ERROR_SUMMARY    => \%tio_01_00263_def,
   TIO_ICE_FRZ_ERROR_SUMMARY_ALIAS => \%tio_01_00264_def,
   TIO_ICE_FRZ_FIRST_ERROR      => \%tio_01_00265_def,
   TIO_ICE_FRZ_XN_ERROR_DETAIL_1A => \%tio_01_00266_def,
   TIO_ICE_FRZ_XN_ERROR_DETAIL_2A => \%tio_01_00267_def,
   TIO_ICE_FRZ_XN_ERROR_DETAIL_1B => \%tio_01_00268_def,
   TIO_ICE_FRZ_XN_ERROR_DETAIL_2B => \%tio_01_00269_def,
   TIO_ICE_FRZ_CT_ERROR_DETAIL_1 => \%tio_01_00270_def,
   TIO_ICE_FRZ_DBG_MUX_SELECT   => \%tio_01_00271_def,
   TIO_ICE_FRZ_CFG              => \%tio_01_00272_def,
   TIO_ICE_FRZ_RIQ_STAT         => \%tio_01_00273_def,
   TIO_ICE_FRZ_RIQ_LAST_STAT    => \%tio_01_00274_def,
   TIO_ICE_FRZ_LAST_CREDIT_STAT => \%tio_01_00275_def,
   TIO_ICE_FRZ_PRB_TIMEOUT_DETAIL => \%tio_01_00276_def,
   TIO_ICE_FRZ_DYN_CREDIT_STAT  => \%tio_01_00277_def,
   TIO_ICE_FRZ_PRB_0            => \%tio_01_00278_def,
   TIO_ICE_FRZ_PRB_1            => \%tio_01_00279_def,
   TIO_ICE_FRZ_PRB_2            => \%tio_01_00280_def,
   TIO_ICE_FRZ_PRB_3            => \%tio_01_00281_def,
   TIO_ICE_FRZ_PRB_4            => \%tio_01_00282_def,
   TIO_ICE_FRZ_PRB_5            => \%tio_01_00283_def,
   TIO_ICE_FRZ_PRB_6            => \%tio_01_00284_def,
   TIO_ICE_FRZ_PRB_7            => \%tio_01_00285_def,
   TIO_ICE_FRZ_PRB_8            => \%tio_01_00286_def,
   TIO_ICE_FRZ_PRB_9            => \%tio_01_00287_def,
   TIO_ICE_FRZ_PRB_10           => \%tio_01_00288_def,
   TIO_ICE_FRZ_PRB_11           => \%tio_01_00289_def,
   TIO_ICE_FRZ_PRB_12           => \%tio_01_00290_def,
   TIO_ICE_FRZ_PRB_13           => \%tio_01_00291_def,
   TIO_ICE_FRZ_PRB_14           => \%tio_01_00292_def,
   TIO_ICE_FRZ_PRB_15           => \%tio_01_00293_def,
   TIO_ICE_FRZ_PRB_16           => \%tio_01_00294_def,
   TIO_ICE_FRZ_PRB_17           => \%tio_01_00295_def,
   TIO_ICE_FRZ_PRB_18           => \%tio_01_00296_def,
   TIO_ICE_FRZ_PRB_19           => \%tio_01_00297_def,
   TIO_ICE_FRZ_PRB_20           => \%tio_01_00298_def,
   TIO_ICE_FRZ_PRB_21           => \%tio_01_00299_def,
   TIO_ICE_FRZ_PRB_22           => \%tio_01_00300_def,
   TIO_ICE_FRZ_PRB_23           => \%tio_01_00301_def,
   TIO_ICE_FRZ_PRB_24           => \%tio_01_00302_def,
   TIO_ICE_FRZ_PRB_25           => \%tio_01_00303_def,
   TIO_ICE_FRZ_PRB_26           => \%tio_01_00304_def,
   TIO_ICE_FRZ_PRB_27           => \%tio_01_00305_def,
   TIO_ICE_FRZ_PRB_28           => \%tio_01_00306_def,
   TIO_ICE_FRZ_PRB_29           => \%tio_01_00307_def,
   TIO_ICE_FRZ_PRB_30           => \%tio_01_00308_def,
   TIO_ICE_FRZ_PRB_31           => \%tio_01_00309_def,
   TIO_ICE_FRZ_PIO_BIG_WINDOW_1 => \%tio_01_00310_def,
   TIO_ICE_FRZ_PIO_BIG_WINDOW_2 => \%tio_01_00311_def,
   TIO_ICE_FRZ_PIO_BIG_WINDOW_3 => \%tio_01_00312_def,
   TIO_ICE_FRZ_PIO_BIG_WINDOW_4 => \%tio_01_00313_def,
   TIO_ICE_FRZ_PIO_BIG_WINDOW_5 => \%tio_01_00314_def,
   TIO_ICE_FRZ_PIO_BIG_WINDOW_6 => \%tio_01_00315_def,
   TIO_ICE_FRZ_PIO_BIG_WINDOW_7 => \%tio_01_00316_def,
   TIO_ICE_FRZ_PIO_HUGE_WINDOW  => \%tio_01_00317_def,
   TIO_ICE_FRZ_GFX_BIG_WINDOW_0 => \%tio_01_00318_def,
   TIO_ICE_FRZ_GFX_BIG_WINDOW_1 => \%tio_01_00319_def,
   TIO_ICE_FRZ_GFX_BIG_WINDOW_2 => \%tio_01_00320_def,
   TIO_ICE_FRZ_GFX_BIG_WINDOW_3 => \%tio_01_00321_def,
   TIO_ICE_FRZ_GFX_BIG_WINDOW_4 => \%tio_01_00322_def,
   TIO_ICE_FRZ_GFX_BIG_WINDOW_5 => \%tio_01_00323_def,
   TIO_ICE_FRZ_GFX_BIG_WINDOW_6 => \%tio_01_00324_def,
   TIO_ICE_FRZ_GFX_BIG_WINDOW_7 => \%tio_01_00325_def,
   TIO_ICE_FRZ_CPU_PERM0        => \%tio_01_00326_def,
   TIO_ICE_FRZ_CPU_PERM1        => \%tio_01_00327_def,
   TIO_ICE_FRZ_CPU_PERM2        => \%tio_01_00328_def,
   TIO_ICE_FRZ_CPU_PERM3        => \%tio_01_00329_def,
   TIO_ICE_FRZ_EXT_IO_PERM0     => \%tio_01_00330_def,
   TIO_ICE_FRZ_EXT_IO_PERM1     => \%tio_01_00331_def,
   TIO_ICE_FRZ_EXT_IO_PERM2     => \%tio_01_00332_def,
   TIO_ICE_FRZ_EXT_IO_PERM3     => \%tio_01_00333_def,
   TIO_ICE_FRZ_CHIPLET_ID_CONFIG => \%tio_01_00334_def,
   TIO_ICE_FRZ_GRC_SIR_0        => \%tio_01_00335_def,
   TIO_ICE_FRZ_GRC_SIR_1        => \%tio_01_00336_def,
   TIO_ICE_FRZ_GRC_SIR_2        => \%tio_01_00337_def,
   TIO_ICE_FRZ_GRC_SIR_3        => \%tio_01_00338_def,
   TIO_ICE_FRZ_GRC_GFX_RSP_0    => \%tio_01_00339_def,
   TIO_ICE_FRZ_GRC_GFX_RSP_1    => \%tio_01_00340_def,
   TIO_ICE_FRZ_GRC_GFX_RSP_2    => \%tio_01_00341_def,
   TIO_ICE_FRZ_GRC_GFX_RSP_3    => \%tio_01_00342_def,
   TIO_ICE_FRZ_GRC_GFX_RSP_4    => \%tio_01_00343_def,
   TIO_ICE_FRZ_GRC_GFX_RSP_5    => \%tio_01_00344_def,
   TIO_ICE_FRZ_GRC_GFX_RSP_6    => \%tio_01_00345_def,
   TIO_ICE_FRZ_GRC_GFX_RSP_7    => \%tio_01_00346_def,
   TIO_ICE_FRZ_GRC_CREDIT       => \%tio_01_00347_def,
   TIO_ICE_PMI_RX_ERROR_SUMMARY => \%tio_01_00348_def,
   TIO_ICE_PMI_RX_ERROR_SUMMARY_ALIAS => \%tio_01_00349_def,
   TIO_ICE_PMI_RX_FIRST_ERROR   => \%tio_01_00350_def,
   TIO_ICE_PMI_RX_CT_ERROR_DETAIL_1 => \%tio_01_00351_def,
   TIO_ICE_PMI_RX_CT_ERROR_DETAIL_2 => \%tio_01_00352_def,
   TIO_ICE_PMI_RX_CT_DATA0_CMP  => \%tio_01_00353_def,
   TIO_ICE_PMI_RX_CT_DATA1_CMP  => \%tio_01_00354_def,
   TIO_ICE_PMI_RX_CT_DATA0_EN   => \%tio_01_00355_def,
   TIO_ICE_PMI_RX_CT_DATA1_EN   => \%tio_01_00356_def,
   TIO_ICE_PMI_RX_DBG_MUX_SELECT => \%tio_01_00357_def,
   TIO_ICE_PMI_RX_REQ_BUF_CFG   => \%tio_01_00358_def,
   TIO_ICE_PMI_RX_REQ_DYN_CREDIT_STAT => \%tio_01_00359_def,
   TIO_ICE_PMI_RX_REQ_LAST_CREDIT_STAT => \%tio_01_00360_def,
   TIO_ICE_PMI_RX_RSP_BUF_CFG   => \%tio_01_00361_def,
   TIO_ICE_PMI_RX_RSP_DYN_CREDIT_STAT => \%tio_01_00362_def,
   TIO_ICE_PMI_RX_RSP_LAST_CREDIT_STAT => \%tio_01_00363_def,
   TIO_ICE_PMI_TX_ERROR_SUMMARY => \%tio_01_00364_def,
   TIO_ICE_PMI_TX_ERROR_SUMMARY_ALIAS => \%tio_01_00365_def,
   TIO_ICE_PMI_TX_ERROR_OVERFLOW => \%tio_01_00366_def,
   TIO_ICE_PMI_TX_ERROR_OF_ALIAS => \%tio_01_00367_def,
   TIO_ICE_PMI_TX_FIRST_ERROR   => \%tio_01_00368_def,
   TIO_ICE_PMI_TX_CFG           => \%tio_01_00369_def,
   TIO_ICE_PMI_TX_LAST_CRED_STAT => \%tio_01_00370_def,
   TIO_ICE_PMI_TX_FORCE_ECC_ERR => \%tio_01_00371_def,
   TIO_ICE_PMI_TX_NACK_CFG_CB0  => \%tio_01_00372_def,
   TIO_ICE_PMI_TX_NACK_CFG_CB1  => \%tio_01_00373_def,
   TIO_ICE_PMI_TX_NACK_CFG_CB2  => \%tio_01_00374_def,
   TIO_ICE_PMI_TX_NACK_CFG_CB3  => \%tio_01_00375_def,
   TIO_ICE_PMI_TX_NACK_STAT_CB0 => \%tio_01_00376_def,
   TIO_ICE_PMI_TX_NACK_STAT_CB1 => \%tio_01_00377_def,
   TIO_ICE_PMI_TX_NACK_STAT_CB2 => \%tio_01_00378_def,
   TIO_ICE_PMI_TX_NACK_STAT_CB3 => \%tio_01_00379_def,
   TIO_ICE_PMI_TX_CREDIT_CFG_CB0 => \%tio_01_00380_def,
   TIO_ICE_PMI_TX_CREDIT_CFG_CB1 => \%tio_01_00381_def,
   TIO_ICE_PMI_TX_CREDIT_CFG_CB2 => \%tio_01_00382_def,
   TIO_ICE_PMI_TX_CREDIT_CFG_CB3 => \%tio_01_00383_def,
   TIO_ICE_PMI_TX_DYN_CREDIT_STAT_CB0 => \%tio_01_00384_def,
   TIO_ICE_PMI_TX_DYN_CREDIT_STAT_CB1 => \%tio_01_00385_def,
   TIO_ICE_PMI_TX_DYN_CREDIT_STAT_CB2 => \%tio_01_00386_def,
   TIO_ICE_PMI_TX_DYN_CREDIT_STAT_CB3 => \%tio_01_00387_def,
   TIO_ICE_CMA_ERROR_SUMMARY    => \%tio_01_00388_def,
   TIO_ICE_CMA_ERROR_SUMMARY_ALIAS => \%tio_01_00389_def,
   TIO_ICE_CMA_ERROR_OVERFLOW   => \%tio_01_00390_def,
   TIO_ICE_CMA_ERROR_OVERFLOW_ALIAS => \%tio_01_00391_def,
   TIO_ICE_CMA_FIRST_ERROR      => \%tio_01_00392_def,
   TIO_ICE_CMA_DBG_MUX_SELECT   => \%tio_01_00393_def,
   TIO_ICE_CMA_CFG              => \%tio_01_00394_def,
   TIO_ICE_CMA_TIMEOUT_CFG      => \%tio_01_00395_def,
   TIO_ICE_CMA_READ_CFG         => \%tio_01_00396_def,
   TIO_ICE_CMA_WRITE_CFG        => \%tio_01_00397_def,
   TIO_ICE_CMA_PORT_CFG_0       => \%tio_01_00398_def,
   TIO_ICE_CMA_PORT_CFG_1       => \%tio_01_00399_def,
   TIO_ICE_CMA_PORT_CFG_2       => \%tio_01_00400_def,
   TIO_ICE_CMA_PORT_CFG_3       => \%tio_01_00401_def,
   TIO_ICE_CMA_CORELET_DBG_MUX_SELECT => \%tio_01_00402_def,
   TIO_ICE_CMA_SYNDROME         => \%tio_01_00403_def,
   TIO_ICE_CMA_CL0_DYN_CREDIT_STAT => \%tio_01_00404_def,
   TIO_ICE_CMA_CL1_DYN_CREDIT_STAT => \%tio_01_00405_def,
   TIO_ICE_CMA_CL2_DYN_CREDIT_STAT => \%tio_01_00406_def,
   TIO_ICE_CMA_CL3_DYN_CREDIT_STAT => \%tio_01_00407_def,
   TIO_ICE_CMA_CL0_LAST_CREDIT_STAT => \%tio_01_00408_def,
   TIO_ICE_CMA_CL1_LAST_CREDIT_STAT => \%tio_01_00409_def,
   TIO_ICE_CMA_CL2_LAST_CREDIT_STAT => \%tio_01_00410_def,
   TIO_ICE_CMA_CL3_LAST_CREDIT_STAT => \%tio_01_00411_def,
   TIO_ICE_CMA_PMI_DYN_CREDIT_STAT => \%tio_01_00412_def,
   TIO_ICE_CMA_PMI_LAST_CREDIT_STAT => \%tio_01_00413_def,
   TIO_LB_LIQ_CTL               => \%tio_01_00414_def,
   TIO_LB_LOQ_CTL               => \%tio_01_00415_def,
   TIO_LB_MAX_REP_CREDIT_CNT    => \%tio_01_00416_def,
   TIO_LB_MAX_REQ_CREDIT_CNT    => \%tio_01_00417_def,
   TIO_PIO_TIME_OUT             => \%tio_01_00418_def,
   TIO_LB_CREDIT_STATUS         => \%tio_01_00419_def,
   TIO_LB_DEBUG_LOCAL_SEL       => \%tio_01_00420_def,
   TIO_LB_DEBUG_MUX0_SEL        => \%tio_01_00421_def,
   TIO_LB_DEBUG_MUX1_SEL        => \%tio_01_00422_def,
   TIO_LB_DEBUG_COMPARE_SEL     => \%tio_01_00423_def,
   TIO_LB_ERROR_DETAIL_1        => \%tio_01_00424_def,
   TIO_LB_ERROR_DETAIL_2        => \%tio_01_00425_def,
   TIO_LB_ERROR_DETAIL_3        => \%tio_01_00426_def,
   TIO_LB_ERROR_DETAIL_4        => \%tio_01_00427_def,
   TIO_LB_ERROR_MASK            => \%tio_01_00428_def,
   TIO_LB_ERROR_OVERFLOW        => \%tio_01_00429_def,
   TIO_LB_ERROR_OVERFLOW_ALIAS  => \%tio_01_00430_def,
   TIO_LB_ERROR_SUMMARY         => \%tio_01_00431_def,
   TIO_LB_ERROR_SUMMARY_ALIAS   => \%tio_01_00432_def,
   TIO_LB_FIRST_ERROR           => \%tio_01_00433_def,
   TIO_LB_LAST_CREDIT           => \%tio_01_00434_def,
   TIO_LB_COMPARE_COMPARE       => \%tio_01_00435_def,
   TIO_LB_TRIGGER_DATA          => \%tio_01_00436_def,
   TIO_AUTO_REPLY_ENABLE0       => \%tio_01_00437_def,
   TIO_AUTO_REPLY_ENABLE1       => \%tio_01_00438_def,
   TIO_AUTO_REPLY_HEADER0       => \%tio_01_00439_def,
   TIO_AUTO_REPLY_HEADER1       => \%tio_01_00440_def,
   TIO_ENABLE_RP_AUTO_REPLY     => \%tio_01_00441_def,
   TIO_ENABLE_RQ_AUTO_REPLY     => \%tio_01_00442_def,
   TIO_DIAG_MSG_CNTRL           => \%tio_01_00443_def,
   TIO_DIAG_MSG_DATA0L          => \%tio_01_00444_def,
   TIO_DIAG_MSG_DATA0U          => \%tio_01_00445_def,
   TIO_DIAG_MSG_DATA1L          => \%tio_01_00446_def,
   TIO_DIAG_MSG_DATA1U          => \%tio_01_00447_def,
   TIO_DIAG_MSG_DATA2L          => \%tio_01_00448_def,
   TIO_DIAG_MSG_DATA2U          => \%tio_01_00449_def,
   TIO_DIAG_MSG_DATA3L          => \%tio_01_00450_def,
   TIO_DIAG_MSG_DATA3U          => \%tio_01_00451_def,
   TIO_DIAG_MSG_DATA4L          => \%tio_01_00452_def,
   TIO_DIAG_MSG_DATA4U          => \%tio_01_00453_def,
   TIO_DIAG_MSG_DATA5L          => \%tio_01_00454_def,
   TIO_DIAG_MSG_DATA5U          => \%tio_01_00455_def,
   TIO_DIAG_MSG_DATA6L          => \%tio_01_00456_def,
   TIO_DIAG_MSG_DATA6U          => \%tio_01_00457_def,
   TIO_DIAG_MSG_DATA7L          => \%tio_01_00458_def,
   TIO_DIAG_MSG_DATA7U          => \%tio_01_00459_def,
   TIO_DIAG_MSG_DATA8L          => \%tio_01_00460_def,
   TIO_DIAG_MSG_DATA8U          => \%tio_01_00461_def,
   TIO_DIAG_MSG_HDR0            => \%tio_01_00462_def,
   TIO_DIAG_MSG_HDR1            => \%tio_01_00463_def,
   TIO_DEBUG_SELECT             => \%tio_01_00464_def,
   TIO_COMPARE_COMPARE_MASK     => \%tio_01_00465_def,
   TIO_COMPARE_COMPARE_PATTERN  => \%tio_01_00466_def,
   TIO_COMPARE_SEL              => \%tio_01_00467_def,
   TIO_OB_LA_CONTROL            => \%tio_01_00468_def,
   TIO_OB_LA_START_CONTROL      => \%tio_01_00469_def,
   TIO_OB_LA_STOP_CONTROL       => \%tio_01_00470_def,
   TIO_OB_LA_START_ADDRESS      => \%tio_01_00471_def,
   TIO_OB_LA_END_ADDRESS        => \%tio_01_00472_def,
   TIO_STOP_CLK_CONTROL         => \%tio_01_00473_def,
   TIO_STOP_CLK_DELAY_PHASE     => \%tio_01_00474_def,
   TIO_TSF_ARM_MASK             => \%tio_01_00475_def,
   TIO_TSF_COUNTER_PRESETS      => \%tio_01_00476_def,
   TIO_TSF_DECREMENT_CTL        => \%tio_01_00477_def,
   TIO_TSF_DIAG_MSG_CTL         => \%tio_01_00478_def,
   TIO_TSF_DISARM_MASK          => \%tio_01_00479_def,
   TIO_TSF_ENABLE_CTL           => \%tio_01_00480_def,
   TIO_TSF_SOFTWARE_ARM         => \%tio_01_00481_def,
   TIO_TSF_SOFTWARE_DISARM      => \%tio_01_00482_def,
   TIO_TSF_SOFTWARE_TRIGGERED   => \%tio_01_00483_def,
   TIO_TSF_TRIGGER_MASK         => \%tio_01_00484_def,
   TIO_VEC_DATA                 => \%tio_01_00485_def,
   TIO_VEC_PARMS                => \%tio_01_00486_def,
   TIO_VEC_ROUTE                => \%tio_01_00487_def,
   TIO_CPU_PERM0                => \%tio_01_00488_def,
   TIO_CPU_PERM1                => \%tio_01_00489_def,
   TIO_CPU_PERM2                => \%tio_01_00490_def,
   TIO_CPU_PERM3                => \%tio_01_00491_def,
   TIO_CPU_PERM_OVR             => \%tio_01_00492_def,
   TIO_EXT_IO_PERM0             => \%tio_01_00493_def,
   TIO_EXT_IO_PERM1             => \%tio_01_00494_def,
   TIO_EXT_IO_PERM2             => \%tio_01_00495_def,
   TIO_EXT_IO_PERM3             => \%tio_01_00496_def,
   TIO_CHIPLET_ID_CONFIG        => \%tio_01_00497_def,
   TIO_GC_FIL_CTRL              => \%tio_01_00498_def,
   TIO_GC_SRC_CTRL              => \%tio_01_00499_def,
   TIO_HARD_RESET               => \%tio_01_00500_def,
   TIO_CPU_ACCESS0              => \%tio_01_00501_def,
   TIO_CPU_ACCESS1              => \%tio_01_00502_def,
   TIO_CPU_ACCESS2              => \%tio_01_00503_def,
   TIO_CPU_ACCESS3              => \%tio_01_00504_def,
   TIO_EXT_IOI_ACCESS0          => \%tio_01_00505_def,
   TIO_EXT_IOI_ACCESS1          => \%tio_01_00506_def,
   TIO_EXT_IOI_ACCESS2          => \%tio_01_00507_def,
   TIO_EXT_IOI_ACCESS3          => \%tio_01_00508_def,
   TIO_JTAG_CONFIG              => \%tio_01_00509_def,
   TIO_NODE_ID                  => \%tio_01_00510_def,
   TIO_SOFT_RESET               => \%tio_01_00511_def,
   TIO_THROTTLE_INTERVAL        => \%tio_01_00512_def,
   TIO_THROTTLE_TIME            => \%tio_01_00513_def,
   TIO_THROTTLE_ENABLE          => \%tio_01_00514_def,
   TIO_FIRST_ERROR              => \%tio_01_00515_def,
   TIO_LB_HW_TIME_STAMP         => \%tio_01_00516_def,
   TIO_ICE_HW_TIME_STAMP        => \%tio_01_00517_def,
   TIO_XN_COR_TIME_STAMP        => \%tio_01_00518_def,
   TIO_XN_HW_TIME_STAMP         => \%tio_01_00519_def,
   TIO_XN_UNCOR_TIME_STAMP      => \%tio_01_00520_def,
   TIO_CA_HW_TIME_STAMP         => \%tio_01_00521_def,
   TIO_DEBUG_PORT               => \%tio_01_00522_def,
   TIO_AEGIS_DEBUG_DATA         => \%tio_01_00523_def,
   TIO_LB_DEBUG_DATA            => \%tio_01_00524_def,
   TIO_ICE_DEBUG_DATA           => \%tio_01_00525_def,
   TIO_XN_DEBUG_DATA            => \%tio_01_00526_def,
   TIO_OB_LA_STATUS             => \%tio_01_00527_def,
   TIO_OB_LA_SEQUENCE           => \%tio_01_00528_def,
   TIO_OB_LA_CURRENT_ADDR       => \%tio_01_00529_def,
   TIO_TSF_ARMED_STATE          => \%tio_01_00530_def,
   TIO_TSF_COUNTER_VALUE        => \%tio_01_00531_def,
   TIO_TSF_TRIGGERED_STATE      => \%tio_01_00532_def,
   TIO_VEC_RDDATA               => \%tio_01_00533_def,
   TIO_VEC_RETURN               => \%tio_01_00534_def,
   TIO_VEC_STATUS               => \%tio_01_00535_def,
   TIO_VEC_STATUS_ALIAS         => \%tio_01_00536_def,
   TIO_LOGIC_ANALYZER_BUFFER    => \%tio_01_00537_def,
   TIO_THROTTLE_STATUS          => \%tio_01_00538_def,
   TIO_PERFORMANCE_COUNT0_CONTROL => \%tio_01_00539_def,
   TIO_PERFORMANCE_COUNT1_CONTROL => \%tio_01_00540_def,
   TIO_PERFORMANCE_COUNT2_CONTROL => \%tio_01_00541_def,
   TIO_PERFORMANCE_COUNT3_CONTROL => \%tio_01_00542_def,
   TIO_PERFORMANCE_COUNT4_CONTROL => \%tio_01_00543_def,
   TIO_PERFORMANCE_COUNT5_CONTROL => \%tio_01_00544_def,
   TIO_PERFORMANCE_COUNT6_CONTROL => \%tio_01_00545_def,
   TIO_PERFORMANCE_COUNT7_CONTROL => \%tio_01_00546_def,
   TIO_PROFILE_DN_CONTROL       => \%tio_01_00547_def,
   TIO_PROFILE_PEAK_CONTROL     => \%tio_01_00548_def,
   TIO_PROFILE_RANGE            => \%tio_01_00549_def,
   TIO_PROFILE_UP_CONTROL       => \%tio_01_00550_def,
   TIO_PERFORMANCE_MONITOR_DESKEW => \%tio_01_00551_def,
   TIO_PERFORMANCE_COUNTER0     => \%tio_01_00552_def,
   TIO_PERFORMANCE_COUNTER1     => \%tio_01_00553_def,
   TIO_PERFORMANCE_COUNTER2     => \%tio_01_00554_def,
   TIO_PERFORMANCE_COUNTER3     => \%tio_01_00555_def,
   TIO_PERFORMANCE_COUNTER4     => \%tio_01_00556_def,
   TIO_PERFORMANCE_COUNTER5     => \%tio_01_00557_def,
   TIO_PERFORMANCE_COUNTER6     => \%tio_01_00558_def,
   TIO_PERFORMANCE_COUNTER7     => \%tio_01_00559_def,
   TIO_PROFILE_COUNTER          => \%tio_01_00560_def,
   TIO_PROFILE_PEAK             => \%tio_01_00561_def,
   TIO_RTC                      => \%tio_01_00562_def,
   TIO_SCRATCH0                 => \%tio_01_00563_def,
   TIO_SCRATCH0_ALIAS           => \%tio_01_00564_def,
   TIO_SCRATCH1                 => \%tio_01_00565_def,
   TIO_SCRATCH1_ALIAS           => \%tio_01_00566_def,
   TIO_SCRATCH2                 => \%tio_01_00567_def,
   TIO_SCRATCH2_ALIAS           => \%tio_01_00568_def,
   TIO_SCRATCH3                 => \%tio_01_00569_def,
   TIO_SCRATCH3_ALIAS           => \%tio_01_00570_def,
   TIO_SCRATCH4                 => \%tio_01_00571_def,
   TIO_SCRATCH4_ALIAS           => \%tio_01_00572_def,
   TIO_INT_NODE_ID_CONFIG       => \%tio_01_00573_def,
   TIO_LOCAL_INT0_CONFIG        => \%tio_01_00574_def,
   TIO_LOCAL_INT0_ENABLE        => \%tio_01_00575_def,
   TIO_LOCAL_INT1_CONFIG        => \%tio_01_00576_def,
   TIO_LOCAL_INT1_ENABLE        => \%tio_01_00577_def,
   TIO_LOCAL_INT2_CONFIG        => \%tio_01_00578_def,
   TIO_LOCAL_INT2_ENABLE        => \%tio_01_00579_def,
   TIO_LOCAL_INT3_CONFIG        => \%tio_01_00580_def,
   TIO_LOCAL_INT3_ENABLE        => \%tio_01_00581_def,
   TIO_LOCAL_INT4_CONFIG        => \%tio_01_00582_def,
   TIO_LOCAL_INT4_ENABLE        => \%tio_01_00583_def,
   TIO_LOCAL_INT5_CONFIG        => \%tio_01_00584_def,
   TIO_LOCAL_INT5_ENABLE        => \%tio_01_00585_def,
   TIO_INT0                     => \%tio_01_00586_def,
   TIO_INT0_CONFIG              => \%tio_01_00587_def,
   TIO_INT1                     => \%tio_01_00588_def,
   TIO_INT1_CONFIG              => \%tio_01_00589_def,
   TIO_INT2                     => \%tio_01_00590_def,
   TIO_INT2_CONFIG              => \%tio_01_00591_def,
   TIO_INT3                     => \%tio_01_00592_def,
   TIO_INT3_CONFIG              => \%tio_01_00593_def,
   TIO_INT4                     => \%tio_01_00594_def,
   TIO_INT4_CONFIG              => \%tio_01_00595_def,
   TIO_INT5                     => \%tio_01_00596_def,
   TIO_INT5_CONFIG              => \%tio_01_00597_def,
   TIO_INT6                     => \%tio_01_00598_def,
   TIO_INT6_CONFIG              => \%tio_01_00599_def,
   TIO_INT7                     => \%tio_01_00600_def,
   TIO_INT7_CONFIG              => \%tio_01_00601_def,
   TIO_INT0_ENABLE              => \%tio_01_00602_def,
   TIO_INT1_ENABLE              => \%tio_01_00603_def,
   TIO_INT2_ENABLE              => \%tio_01_00604_def,
   TIO_INT3_ENABLE              => \%tio_01_00605_def,
   TIO_INT4_ENABLE              => \%tio_01_00606_def,
   TIO_INT5_ENABLE              => \%tio_01_00607_def,
   TIO_INT6_ENABLE              => \%tio_01_00608_def,
   TIO_INT7_ENABLE              => \%tio_01_00609_def,
   TIO_EVENT_OCCURRED           => \%tio_01_00610_def,
   TIO_EVENT_OCCURRED_ALIAS     => \%tio_01_00611_def,
   TIO_EVENT_OVERFLOW           => \%tio_01_00612_def,
   TIO_EVENT_OVERFLOW_ALIAS     => \%tio_01_00613_def,
   TIO_ASIC_TO_L1_DATA          => \%tio_01_00614_def,
   TIO_ASIC_TO_L1_STATUS        => \%tio_01_00615_def,
   TIO_L1_TO_ASIC_DATA          => \%tio_01_00616_def,
   TIO_L1_TO_ASIC_STATUS        => \%tio_01_00617_def,
   TIO_NI0_LLP_STAT             => \%tio_01_00618_def,
   TIO_NI0_LLP_RESET            => \%tio_01_00619_def,
   TIO_NI0_LLP_RESET_EN         => \%tio_01_00620_def,
   TIO_NI0_LLP_CHAN_MODE        => \%tio_01_00621_def,
   TIO_NI0_LLP_CONFIG           => \%tio_01_00622_def,
   TIO_NI0_LLP_TEST_CTL         => \%tio_01_00623_def,
   TIO_NI0_LLP_CAPT_WD1         => \%tio_01_00624_def,
   TIO_NI0_LLP_CAPT_WD2         => \%tio_01_00625_def,
   TIO_NI0_LLP_CAPT_SBCB        => \%tio_01_00626_def,
   TIO_NI0_LLP_ERR              => \%tio_01_00627_def,
   TIO_NI1_LLP_STAT             => \%tio_01_00628_def,
   TIO_NI1_LLP_RESET            => \%tio_01_00629_def,
   TIO_NI1_LLP_RESET_EN         => \%tio_01_00630_def,
   TIO_NI1_LLP_CHAN_MODE        => \%tio_01_00631_def,
   TIO_NI1_LLP_CONFIG           => \%tio_01_00632_def,
   TIO_NI1_LLP_TEST_CTL         => \%tio_01_00633_def,
   TIO_NI1_LLP_CAPT_WD1         => \%tio_01_00634_def,
   TIO_NI1_LLP_CAPT_WD2         => \%tio_01_00635_def,
   TIO_NI1_LLP_CAPT_SBCB        => \%tio_01_00636_def,
   TIO_NI1_LLP_ERR              => \%tio_01_00637_def,
   TIO_XNNI0_LLP_DEBIT_FLOW     => \%tio_01_00638_def,
   TIO_XNNI0_LINK_0_FLOW        => \%tio_01_00639_def,
   TIO_XNNI0_LINK_1_FLOW        => \%tio_01_00640_def,
   TIO_XNNI0_LINK_2_FLOW        => \%tio_01_00641_def,
   TIO_XNNI0_LINK_3_FLOW        => \%tio_01_00642_def,
   TIO_XNNI1_LLP_DEBIT_FLOW     => \%tio_01_00643_def,
   TIO_XNNI1_LINK_0_FLOW        => \%tio_01_00644_def,
   TIO_XNNI1_LINK_1_FLOW        => \%tio_01_00645_def,
   TIO_XNNI1_LINK_2_FLOW        => \%tio_01_00646_def,
   TIO_XNNI1_LINK_3_FLOW        => \%tio_01_00647_def,
   TIO_IILB_LOCAL_TABLE         => \%tio_01_00648_def,
   TIO_IILB_GLOBAL_TABLE        => \%tio_01_00649_def,
   TIO_IILB_OVER_RIDE_TABLE     => \%tio_01_00650_def,
   TIO_NI0_LOCAL_TABLE          => \%tio_01_00651_def,
   TIO_NI0_GLOBAL_TABLE         => \%tio_01_00652_def,
   TIO_NI0_OVER_RIDE_TABLE      => \%tio_01_00653_def,
   TIO_NI1_LOCAL_TABLE          => \%tio_01_00654_def,
   TIO_NI1_GLOBAL_TABLE         => \%tio_01_00655_def,
   TIO_NI1_OVER_RIDE_TABLE      => \%tio_01_00656_def,
   TIO_XNII_INTRA_FLOW          => \%tio_01_00657_def,
   TIO_XNLB_INTRA_FLOW          => \%tio_01_00658_def,
   TIO_XNIILB_TO_NI0_INTRA_FLOW_DEBIT => \%tio_01_00659_def,
   TIO_XNIILB_TO_NI0_INTRA_FLOW_DEBIT13 => \%tio_01_00660_def,
   TIO_XNIILB_TO_NI1_INTRA_FLOW_DEBIT => \%tio_01_00661_def,
   TIO_XNIILB_TO_NI1_INTRA_FLOW_DEBIT13 => \%tio_01_00662_def,
   TIO_XNIILB_TO_IILB_INTRA_FLOW_DEBIT => \%tio_01_00663_def,
   TIO_XNIILB_FR_NI0_INTRA_FLOW_CREDIT => \%tio_01_00664_def,
   TIO_XNIILB_FR_NI1_INTRA_FLOW_CREDIT => \%tio_01_00665_def,
   TIO_XNIILB_FR_IILB_INTRA_FLOW_CREDIT => \%tio_01_00666_def,
   TIO_XNIILB_II_FIFO_CREDIT_CNT => \%tio_01_00667_def,
   TIO_XNIILB_LB_FIFO_CREDIT_CNT => \%tio_01_00668_def,
   TIO_XNIILB_ARB_CONFIG_SI     => \%tio_01_00669_def,
   TIO_XNIILB_ARB_CONFIG_SO     => \%tio_01_00670_def,
   TIO_XNIILB_AGE_WRAP0         => \%tio_01_00671_def,
   TIO_XNIILB_AGE_WRAP1         => \%tio_01_00672_def,
   TIO_XNIILB_AGE_WRAP2         => \%tio_01_00673_def,
   TIO_XNNI0_TO_IILB_INTRA_FLOW_DEBIT => \%tio_01_00674_def,
   TIO_XNNI0_0_INTRANI_FLOW     => \%tio_01_00675_def,
   TIO_XNNI0_1_INTRANI_FLOW     => \%tio_01_00676_def,
   TIO_XNNI0_2_INTRANI_FLOW     => \%tio_01_00677_def,
   TIO_XNNI0_3_INTRANI_FLOW     => \%tio_01_00678_def,
   TIO_XNNI0_VCSWITCH_FLOW      => \%tio_01_00679_def,
   TIO_XNNI0_TIMER_REG          => \%tio_01_00680_def,
   TIO_XNNI0_IILB_TAILTO        => \%tio_01_00681_def,
   TIO_XNNI0_NI_TAILTO          => \%tio_01_00682_def,
   TIO_XNNI0_NI_TAILTO_SUPPORT  => \%tio_01_00683_def,
   TIO_XNNI0_DEADLCK_FLOW       => \%tio_01_00684_def,
   TIO_XNNI0_DEADLCK_FLOW_SUPPORT => \%tio_01_00685_def,
   TIO_XNNI0_INJECT_AGE         => \%tio_01_00686_def,
   TIO_XNNI0_NETWORK_AGE        => \%tio_01_00687_def,
   TIO_XNNI0_ARB_CONFIG         => \%tio_01_00688_def,
   TIO_XNNI0_LOCAL_AGE0         => \%tio_01_00689_def,
   TIO_XNNI0_QUEUE_CNTR         => \%tio_01_00690_def,
   TIO_XNNI1_TO_IILB_INTRA_FLOW_DEBIT => \%tio_01_00691_def,
   TIO_XNNI1_0_INTRANI_FLOW     => \%tio_01_00692_def,
   TIO_XNNI1_1_INTRANI_FLOW     => \%tio_01_00693_def,
   TIO_XNNI1_2_INTRANI_FLOW     => \%tio_01_00694_def,
   TIO_XNNI1_3_INTRANI_FLOW     => \%tio_01_00695_def,
   TIO_XNNI1_VCSWITCH_FLOW      => \%tio_01_00696_def,
   TIO_XNNI1_TIMER_REG          => \%tio_01_00697_def,
   TIO_XNNI1_IILB_TAILTO        => \%tio_01_00698_def,
   TIO_XNNI1_NI_TAILTO          => \%tio_01_00699_def,
   TIO_XNNI1_NI_TAILTO_SUPPORT  => \%tio_01_00700_def,
   TIO_XNNI1_DEADLCK_FLOW       => \%tio_01_00701_def,
   TIO_XNNI1_DEADLCK_FLOW_SUPPORT => \%tio_01_00702_def,
   TIO_XNNI1_INJECT_AGE         => \%tio_01_00703_def,
   TIO_XNNI1_NETWORK_AGE        => \%tio_01_00704_def,
   TIO_XNNI1_ARB_CONFIG         => \%tio_01_00705_def,
   TIO_XNNI1_LOCAL_AGE0         => \%tio_01_00706_def,
   TIO_XNNI1_QUEUE_CNTR         => \%tio_01_00707_def,
   TIO_XN_DEBUG_SEL             => \%tio_01_00708_def,
   TIO_XN_DEBUG_TRIG_SEL        => \%tio_01_00709_def,
   TIO_XN_TRIGGER_COMPARE       => \%tio_01_00710_def,
   TIO_XN_TRIGGER_DATA          => \%tio_01_00711_def,
   TIO_XN_IILB_DEBUG_SEL        => \%tio_01_00712_def,
   TIO_XN_IILB_LB_CMP_EXP_DATA0 => \%tio_01_00713_def,
   TIO_XN_IILB_LB_CMP_EXP_DATA1 => \%tio_01_00714_def,
   TIO_XN_IILB_LB_CMP_ENABLE0   => \%tio_01_00715_def,
   TIO_XN_IILB_LB_CMP_ENABLE1   => \%tio_01_00716_def,
   TIO_XN_IILB_II_CMP_EXP_DATA0 => \%tio_01_00717_def,
   TIO_XN_IILB_II_CMP_EXP_DATA1 => \%tio_01_00718_def,
   TIO_XN_IILB_II_CMP_ENABLE0   => \%tio_01_00719_def,
   TIO_XN_IILB_II_CMP_ENABLE1   => \%tio_01_00720_def,
   TIO_XN_IILB_NI0_CMP_EXP_DATA0 => \%tio_01_00721_def,
   TIO_XN_IILB_NI0_CMP_EXP_DATA1 => \%tio_01_00722_def,
   TIO_XN_IILB_NI0_CMP_ENABLE0  => \%tio_01_00723_def,
   TIO_XN_IILB_NI0_CMP_ENABLE1  => \%tio_01_00724_def,
   TIO_XN_IILB_NI1_CMP_EXP_DATA0 => \%tio_01_00725_def,
   TIO_XN_IILB_NI1_CMP_EXP_DATA1 => \%tio_01_00726_def,
   TIO_XN_IILB_NI1_CMP_ENABLE0  => \%tio_01_00727_def,
   TIO_XN_IILB_NI1_CMP_ENABLE1  => \%tio_01_00728_def,
   TIO_XN_NI0_DEBUG_SEL         => \%tio_01_00729_def,
   TIO_XN_NI0_IILB_CMP_EXP_DATA0 => \%tio_01_00730_def,
   TIO_XN_NI0_IILB_CMP_EXP_DATA1 => \%tio_01_00731_def,
   TIO_XN_NI0_IILB_CMP_ENABLE0  => \%tio_01_00732_def,
   TIO_XN_NI0_IILB_CMP_ENABLE1  => \%tio_01_00733_def,
   TIO_XN_NI0_NI_CMP_EXP_DATA0  => \%tio_01_00734_def,
   TIO_XN_NI0_NI_CMP_EXP_DATA1  => \%tio_01_00735_def,
   TIO_XN_NI0_NI_CMP_ENABLE0    => \%tio_01_00736_def,
   TIO_XN_NI0_NI_CMP_ENABLE1    => \%tio_01_00737_def,
   TIO_XN_NI0_LLP_CMP_EXP_DATA0 => \%tio_01_00738_def,
   TIO_XN_NI0_LLP_CMP_EXP_DATA1 => \%tio_01_00739_def,
   TIO_XN_NI0_LLP_CMP_ENABLE0   => \%tio_01_00740_def,
   TIO_XN_NI0_LLP_CMP_ENABLE1   => \%tio_01_00741_def,
   TIO_XN_NI1_DEBUG_SEL         => \%tio_01_00742_def,
   TIO_XN_NI1_IILB_CMP_EXP_DATA0 => \%tio_01_00743_def,
   TIO_XN_NI1_IILB_CMP_EXP_DATA1 => \%tio_01_00744_def,
   TIO_XN_NI1_IILB_CMP_ENABLE0  => \%tio_01_00745_def,
   TIO_XN_NI1_IILB_CMP_ENABLE1  => \%tio_01_00746_def,
   TIO_XN_NI1_NI_CMP_EXP_DATA0  => \%tio_01_00747_def,
   TIO_XN_NI1_NI_CMP_EXP_DATA1  => \%tio_01_00748_def,
   TIO_XN_NI1_NI_CMP_ENABLE0    => \%tio_01_00749_def,
   TIO_XN_NI1_NI_CMP_ENABLE1    => \%tio_01_00750_def,
   TIO_XN_NI1_LLP_CMP_EXP_DATA0 => \%tio_01_00751_def,
   TIO_XN_NI1_LLP_CMP_EXP_DATA1 => \%tio_01_00752_def,
   TIO_XN_NI1_LLP_CMP_ENABLE0   => \%tio_01_00753_def,
   TIO_XN_NI1_LLP_CMP_ENABLE1   => \%tio_01_00754_def,
   TIO_NI0_ERROR_SUMMARY_1      => \%tio_01_00755_def,
   TIO_NI0_ERROR_SUMMARY_1_ALIAS => \%tio_01_00756_def,
   TIO_NI0_ERROR_SUMMARY_2      => \%tio_01_00757_def,
   TIO_NI0_ERROR_SUMMARY_2_ALIAS => \%tio_01_00758_def,
   TIO_NI0_ERROR_OVERFLOW_1     => \%tio_01_00759_def,
   TIO_NI0_ERROR_OVERFLOW_1_ALIAS => \%tio_01_00760_def,
   TIO_NI0_ERROR_OVERFLOW_2     => \%tio_01_00761_def,
   TIO_NI0_ERROR_OVERFLOW_2_ALIAS => \%tio_01_00762_def,
   TIO_NI0_ERROR_MASK_1         => \%tio_01_00763_def,
   TIO_NI0_ERROR_MASK_2         => \%tio_01_00764_def,
   TIO_NI0_FIRST_ERROR_1        => \%tio_01_00765_def,
   TIO_NI0_FIRST_ERROR_2        => \%tio_01_00766_def,
   TIO_NI0_ERROR_DETAIL_1       => \%tio_01_00767_def,
   TIO_NI0_ERROR_DETAIL_2       => \%tio_01_00768_def,
   TIO_NI1_ERROR_SUMMARY_1      => \%tio_01_00769_def,
   TIO_NI1_ERROR_SUMMARY_1_ALIAS => \%tio_01_00770_def,
   TIO_NI1_ERROR_SUMMARY_2      => \%tio_01_00771_def,
   TIO_NI1_ERROR_SUMMARY_2_ALIAS => \%tio_01_00772_def,
   TIO_NI1_ERROR_OVERFLOW_1     => \%tio_01_00773_def,
   TIO_NI1_ERROR_OVERFLOW_1_ALIAS => \%tio_01_00774_def,
   TIO_NI1_ERROR_OVERFLOW_2     => \%tio_01_00775_def,
   TIO_NI1_ERROR_OVERFLOW_2_ALIAS => \%tio_01_00776_def,
   TIO_NI1_ERROR_MASK_1         => \%tio_01_00777_def,
   TIO_NI1_ERROR_MASK_2         => \%tio_01_00778_def,
   TIO_NI1_FIRST_ERROR_1        => \%tio_01_00779_def,
   TIO_NI1_FIRST_ERROR_2        => \%tio_01_00780_def,
   TIO_NI1_ERROR_DETAIL_1       => \%tio_01_00781_def,
   TIO_NI1_ERROR_DETAIL_2       => \%tio_01_00782_def,
   TIO_XNIILB_ERROR_DETAIL_1    => \%tio_01_00783_def,
   TIO_XNIILB_ERROR_DETAIL_2    => \%tio_01_00784_def,
   TIO_XNIILB_ERROR_DETAIL_3    => \%tio_01_00785_def,
   TIO_NI0_ERROR_DETAIL_3       => \%tio_01_00786_def,
   TIO_NI1_ERROR_DETAIL_3       => \%tio_01_00787_def,
   TIO_XN_ERROR_SUMMARY         => \%tio_01_00788_def,
   TIO_XN_ERROR_SUMMARY_ALIAS   => \%tio_01_00789_def,
   TIO_XN_ERROR_OVERFLOW        => \%tio_01_00790_def,
   TIO_XN_ERROR_OVERFLOW_ALIAS  => \%tio_01_00791_def,
   TIO_XN_ERROR_MASK            => \%tio_01_00792_def,
   TIO_XN_FIRST_ERROR           => \%tio_01_00793_def,
   TIO_XNIILB_ERROR_SUMMARY     => \%tio_01_00794_def,
   TIO_XNIILB_ERROR_SUMMARY_ALIAS => \%tio_01_00795_def,
   TIO_XNIILB_ERROR_OVERFLOW    => \%tio_01_00796_def,
   TIO_XNIILB_ERROR_OVERFLOW_ALIAS => \%tio_01_00797_def,
   TIO_XNIILB_ERROR_MASK        => \%tio_01_00798_def,
   TIO_XNIILB_FIRST_ERROR       => \%tio_01_00799_def,
   TIO_XNIILB_ERROR_SUMMARY_1   => \%tio_01_00800_def,
   TIO_XNIILB_ERROR_SUMMARY_ALIAS_1 => \%tio_01_00801_def,
   TIO_XNIILB_ERROR_OVERFLOW_1  => \%tio_01_00802_def,
   TIO_XNIILB_ERROR_OVERFLOW_ALIAS_1 => \%tio_01_00803_def,
   TIO_XNIILB_ERROR_MASK_1      => \%tio_01_00804_def,
   TIO_XNIILB_FIRST_ERROR_1     => \%tio_01_00805_def,
   TIO_CA_IDENTIFICATION        => \%tio_01_00806_def,
   TIO_CA_CONTROL1              => \%tio_01_00807_def,
   TIO_CA_CONTROL2              => \%tio_01_00808_def,
   TIO_CA_STATUS1               => \%tio_01_00809_def,
   TIO_CA_STATUS2               => \%tio_01_00810_def,
   TIO_CA_GART_APERTURE         => \%tio_01_00811_def,
   TIO_CA_GFX_DETACH            => \%tio_01_00812_def,
   TIO_CA_INTA_DEST_ADDR        => \%tio_01_00813_def,
   TIO_CA_INTB_DEST_ADDR        => \%tio_01_00814_def,
   TIO_CA_ERR_INT_DEST_ADDR     => \%tio_01_00815_def,
   TIO_CA_INT_STATUS            => \%tio_01_00816_def,
   TIO_CA_INT_STATUS_ALIAS      => \%tio_01_00817_def,
   TIO_CA_MULT_ERROR            => \%tio_01_00818_def,
   TIO_CA_MULT_ERROR_ALIAS      => \%tio_01_00819_def,
   TIO_CA_FIRST_ERROR           => \%tio_01_00820_def,
   TIO_CA_INT_MASK              => \%tio_01_00821_def,
   TIO_CA_CRM_PKTERR_TYPE       => \%tio_01_00822_def,
   TIO_CA_CRM_PKTERR_TYPE_ALIAS => \%tio_01_00823_def,
   TIO_CA_CRM_CT_ERROR_DETAIL_1 => \%tio_01_00824_def,
   TIO_CA_CRM_CT_ERROR_DETAIL_2 => \%tio_01_00825_def,
   TIO_CA_CRM_TNUMTO            => \%tio_01_00826_def,
   TIO_CA_GART_ERR              => \%tio_01_00827_def,
   TIO_CA_PCIERR_TYPE           => \%tio_01_00828_def,
   TIO_CA_PCIERR_ADDR           => \%tio_01_00829_def,
   TIO_CA_PCI_RD_BUF_FLUSH      => \%tio_01_00830_def,
   TIO_CA_PCI_DMA_ADDR_EXTN     => \%tio_01_00831_def,
   TIO_CA_AGP_DMA_ADDR_EXTN     => \%tio_01_00832_def,
   TIO_CA_FORCE_INTA            => \%tio_01_00833_def,
   TIO_CA_FORCE_INTB            => \%tio_01_00834_def,
   TIO_CA_DEBUG_VECTOR_SEL      => \%tio_01_00835_def,
   TIO_CA_DEBUG_MUX_CORE_SEL    => \%tio_01_00836_def,
   TIO_CA_DEBUG_MUX_PCI_SEL     => \%tio_01_00837_def,
   TIO_CA_DEBUG_DOMAIN_SEL      => \%tio_01_00838_def,
   TIO_CA_GART_PTR_TABLE        => \%tio_01_00839_def,
   TIO_CA_GART_TLB_ADDR_0       => \%tio_01_00840_def,
   TIO_CA_GART_TLB_ADDR_1       => \%tio_01_00841_def,
   TIO_CA_GART_TLB_ADDR_2       => \%tio_01_00842_def,
   TIO_CA_GART_TLB_ADDR_3       => \%tio_01_00843_def,
   TIO_CA_GART_TLB_ADDR_4       => \%tio_01_00844_def,
   TIO_CA_GART_TLB_ADDR_5       => \%tio_01_00845_def,
   TIO_CA_GART_TLB_ADDR_6       => \%tio_01_00846_def,
   TIO_CA_GART_TLB_ADDR_7       => \%tio_01_00847_def,
   TIO_CA_MAINT_WRT_WD_BUFF0    => \%tio_01_00848_def,
   TIO_CA_MAINT_WRT_WD_BUFF1    => \%tio_01_00849_def,
   TIO_CA_MAINT_WRT_WD_BUFF2    => \%tio_01_00850_def,
   TIO_CA_MAINT_WRT_WD_BUFF3    => \%tio_01_00851_def,
   TIO_CA_MAINT_RD_WD_BUFF0     => \%tio_01_00852_def,
   TIO_CA_MAINT_RD_WD_BUFF1     => \%tio_01_00853_def,
   TIO_CA_MAINT_RD_WD_BUFF2     => \%tio_01_00854_def,
   TIO_CA_MAINT_RD_WD_BUFF3     => \%tio_01_00855_def,
   TIO_CA_MAINT_WRT_RD_BUFF0    => \%tio_01_00856_def,
   TIO_CA_MAINT_WRT_RD_BUFF1    => \%tio_01_00857_def,
   TIO_CA_MAINT_WRT_RD_BUFF2    => \%tio_01_00858_def,
   TIO_CA_MAINT_WRT_RD_BUFF3    => \%tio_01_00859_def,
   TIO_CA_MAINT_RD_RD_BUFF0     => \%tio_01_00860_def,
   TIO_CA_MAINT_RD_RD_BUFF1     => \%tio_01_00861_def,
   TIO_CA_MAINT_RD_RD_BUFF2     => \%tio_01_00862_def,
   TIO_CA_MAINT_RD_RD_BUFF3     => \%tio_01_00863_def,
   TIO_CA_MAINT_RD_OP_QUEUE     => \%tio_01_00864_def,
   TIO_CA_MAINT_RD_BE_BUFF0     => \%tio_01_00865_def,
   TIO_CA_MAINT_RD_BE_BUFF1     => \%tio_01_00866_def,
   TIO_CA_MAINT_WRT_RMT         => \%tio_01_00867_def,
   TIO_CA_MAINT_RD_RMT          => \%tio_01_00868_def,
   TIO_CA_MAINT_WRT_GFX0        => \%tio_01_00869_def,
   TIO_CA_MAINT_WRT_GFX1        => \%tio_01_00870_def,
   TIO_CA_MAINT_WRT_GFX2        => \%tio_01_00871_def,
   TIO_CA_MAINT_WRT_GFX3        => \%tio_01_00872_def,
   TIO_CA_MAINT_RD_GFX0         => \%tio_01_00873_def,
   TIO_CA_MAINT_RD_GFX1         => \%tio_01_00874_def,
   TIO_CA_MAINT_RD_GFX2         => \%tio_01_00875_def,
   TIO_CA_MAINT_RD_GFX3         => \%tio_01_00876_def,
   TIO_CP0_IDENTIFICATION       => \%tio_01_00877_def,
   TIO_CP0_STATUS               => \%tio_01_00878_def,
   TIO_CP0_BUS_SIDE_ERROR_ADDR_UPPER => \%tio_01_00879_def,
   TIO_CP0_BUS_SIDE_ERROR_ADDR_LOWER => \%tio_01_00880_def,
   TIO_CP0_CONTROL              => \%tio_01_00881_def,
   TIO_CP0_REQUEST_TIMEOUT      => \%tio_01_00882_def,
   TIO_CP0_INTERRUPT_DEST_UPPER => \%tio_01_00883_def,
   TIO_CP0_INTERRUPT_DEST_LOWER => \%tio_01_00884_def,
   TIO_CP0_BUS_SIDE_ERROR_CMD_WRD => \%tio_01_00885_def,
   TIO_CP0_TARGET_FLUSH         => \%tio_01_00886_def,
   TIO_CP0_LINK_SIDE_ERROR_CMD_WRD => \%tio_01_00887_def,
   TIO_CP0_RSP_BUFFER_UPPER     => \%tio_01_00888_def,
   TIO_CP0_RSP_BUFFER_LOWER     => \%tio_01_00889_def,
   TIO_CP0_DEBUG_PORT_CONTROL   => \%tio_01_00890_def,
   TIO_CP0_LINK_SIDE_ERROR_ADDR_HOLD => \%tio_01_00891_def,
   TIO_CP0_PCI_DIRECT_MAPPING   => \%tio_01_00892_def,
   TIO_CP0_PAGE_MAP_FAULT_ADD   => \%tio_01_00893_def,
   TIO_CP0_ARBITRATION_PRIORITY => \%tio_01_00894_def,
   TIO_CP0_INTERNAL_RAM_PARITY_ERROR => \%tio_01_00895_def,
   TIO_CP0_TIMEOUT              => \%tio_01_00896_def,
   TIO_CP0_TYPE1_CONFIGURATION  => \%tio_01_00897_def,
   TIO_CP0_BUS_ERROR_ADDR_UPPER => \%tio_01_00898_def,
   TIO_CP0_BUS_ERROR_ADDR_LOWER => \%tio_01_00899_def,
   TIO_CP0_INT_STATUS           => \%tio_01_00900_def,
   TIO_CP0_INTERRUPT_ENABLE     => \%tio_01_00901_def,
   TIO_CP0_RESET_INTERRUPT      => \%tio_01_00902_def,
   TIO_CP0_INTERRUPT_MODE       => \%tio_01_00903_def,
   TIO_CP0_INTERRUPT_DEVICE     => \%tio_01_00904_def,
   TIO_CP0_HOST_ERROR_INTERRUPT => \%tio_01_00905_def,
   TIO_CP0_INTERRUPT_0_HOST_ADDRESS => \%tio_01_00906_def,
   TIO_CP0_INTERRUPT_1_HOST_ADDRESS => \%tio_01_00907_def,
   TIO_CP0_INTERRUPT_2_HOST_ADDRESS => \%tio_01_00908_def,
   TIO_CP0_INTERRUPT_3_HOST_ADDRESS => \%tio_01_00909_def,
   TIO_CP0_INTERRUPT_4_HOST_ADDRESS => \%tio_01_00910_def,
   TIO_CP0_INTERRUPT_5_HOST_ADDRESS => \%tio_01_00911_def,
   TIO_CP0_INTERRUPT_6_HOST_ADDRESS => \%tio_01_00912_def,
   TIO_CP0_INTERRUPT_7_HOST_ADDRESS => \%tio_01_00913_def,
   TIO_CP0_ERROR_INTERRUPT_VIEW => \%tio_01_00914_def,
   TIO_CP0_MULTIPLE_INTERRUPT   => \%tio_01_00915_def,
   TIO_CP0_FORCE_ALWAYS_INTERRUPT_0 => \%tio_01_00916_def,
   TIO_CP0_FORCE_ALWAYS_INTERRUPT_1 => \%tio_01_00917_def,
   TIO_CP0_FORCE_ALWAYS_INTERRUPT_2 => \%tio_01_00918_def,
   TIO_CP0_FORCE_ALWAYS_INTERRUPT_3 => \%tio_01_00919_def,
   TIO_CP0_FORCE_ALWAYS_INTERRUPT_4 => \%tio_01_00920_def,
   TIO_CP0_FORCE_ALWAYS_INTERRUPT_5 => \%tio_01_00921_def,
   TIO_CP0_FORCE_ALWAYS_INTERRUPT_6 => \%tio_01_00922_def,
   TIO_CP0_FORCE_ALWAYS_INTERRUPT_7 => \%tio_01_00923_def,
   TIO_CP0_FORCE_INTERRUPT_0    => \%tio_01_00924_def,
   TIO_CP0_FORCE_INTERRUPT_1    => \%tio_01_00925_def,
   TIO_CP0_FORCE_INTERRUPT_2    => \%tio_01_00926_def,
   TIO_CP0_FORCE_INTERRUPT_3    => \%tio_01_00927_def,
   TIO_CP0_FORCE_INTERRUPT_4    => \%tio_01_00928_def,
   TIO_CP0_FORCE_INTERRUPT_5    => \%tio_01_00929_def,
   TIO_CP0_FORCE_INTERRUPT_6    => \%tio_01_00930_def,
   TIO_CP0_FORCE_INTERRUPT_7    => \%tio_01_00931_def,
   TIO_CP0_DEVICE_0             => \%tio_01_00932_def,
   TIO_CP0_DEVICE_1             => \%tio_01_00933_def,
   TIO_CP0_DEVICE_2             => \%tio_01_00934_def,
   TIO_CP0_DEVICE_3             => \%tio_01_00935_def,
   TIO_CP0_DEVICE_0_WRITE_FLUSH => \%tio_01_00936_def,
   TIO_CP0_DEVICE_1_WRITE_FLUSH => \%tio_01_00937_def,
   TIO_CP0_DEVICE_2_WRITE_FLUSH => \%tio_01_00938_def,
   TIO_CP0_DEVICE_3_WRITE_FLUSH => \%tio_01_00939_def,
   TIO_CP0_EVEN_READ_RSP_BUFFER => \%tio_01_00940_def,
   TIO_CP0_ODD_READ_RSP_BUFFER  => \%tio_01_00941_def,
   TIO_CP0_READ_RSP_BUFFER_STATUS => \%tio_01_00942_def,
   TIO_CP0_READ_RSP_BUFFER_CLEAR => \%tio_01_00943_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_0 => \%tio_01_00944_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_1 => \%tio_01_00945_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_2 => \%tio_01_00946_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_3 => \%tio_01_00947_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_4 => \%tio_01_00948_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_5 => \%tio_01_00949_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_6 => \%tio_01_00950_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_7 => \%tio_01_00951_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_8 => \%tio_01_00952_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_9 => \%tio_01_00953_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_10 => \%tio_01_00954_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_11 => \%tio_01_00955_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_12 => \%tio_01_00956_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_13 => \%tio_01_00957_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_14 => \%tio_01_00958_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_15 => \%tio_01_00959_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_0 => \%tio_01_00960_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_1 => \%tio_01_00961_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_2 => \%tio_01_00962_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_3 => \%tio_01_00963_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_4 => \%tio_01_00964_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_5 => \%tio_01_00965_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_6 => \%tio_01_00966_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_7 => \%tio_01_00967_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_8 => \%tio_01_00968_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_9 => \%tio_01_00969_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_10 => \%tio_01_00970_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_11 => \%tio_01_00971_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_12 => \%tio_01_00972_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_13 => \%tio_01_00973_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_14 => \%tio_01_00974_def,
   TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_15 => \%tio_01_00975_def,
   TIO_CP0_PCI_BUFFER_0_FLUSH_COUNT_TOUCH => \%tio_01_00976_def,
   TIO_CP0_PCI_BUFFER_1_FLUSH_COUNT_TOUCH => \%tio_01_00977_def,
   TIO_CP0_PCI_BUFFER_2_FLUSH_COUNT_TOUCH => \%tio_01_00978_def,
   TIO_CP0_PCI_BUFFER_3_FLUSH_COUNT_TOUCH => \%tio_01_00979_def,
   TIO_CP0_PCI_BUFFER_4_FLUSH_COUNT_TOUCH => \%tio_01_00980_def,
   TIO_CP0_PCI_BUFFER_5_FLUSH_COUNT_TOUCH => \%tio_01_00981_def,
   TIO_CP0_PCI_BUFFER_6_FLUSH_COUNT_TOUCH => \%tio_01_00982_def,
   TIO_CP0_PCI_BUFFER_7_FLUSH_COUNT_TOUCH => \%tio_01_00983_def,
   TIO_CP0_PCI_BUFFER_0_FLUSH_COUNT_NOTOUCH => \%tio_01_00984_def,
   TIO_CP0_PCI_BUFFER_1_FLUSH_COUNT_NOTOUCH => \%tio_01_00985_def,
   TIO_CP0_PCI_BUFFER_2_FLUSH_COUNT_NOTOUCH => \%tio_01_00986_def,
   TIO_CP0_PCI_BUFFER_3_FLUSH_COUNT_NOTOUCH => \%tio_01_00987_def,
   TIO_CP0_PCI_BUFFER_4_FLUSH_COUNT_NOTOUCH => \%tio_01_00988_def,
   TIO_CP0_PCI_BUFFER_5_FLUSH_COUNT_NOTOUCH => \%tio_01_00989_def,
   TIO_CP0_PCI_BUFFER_6_FLUSH_COUNT_NOTOUCH => \%tio_01_00990_def,
   TIO_CP0_PCI_BUFFER_7_FLUSH_COUNT_NOTOUCH => \%tio_01_00991_def,
   TIO_CP0_PCI_BUFFER_0_REQ_COUNT => \%tio_01_00992_def,
   TIO_CP0_PCI_BUFFER_1_REQ_COUNT => \%tio_01_00993_def,
   TIO_CP0_PCI_BUFFER_2_REQ_COUNT => \%tio_01_00994_def,
   TIO_CP0_PCI_BUFFER_3_REQ_COUNT => \%tio_01_00995_def,
   TIO_CP0_PCI_BUFFER_4_REQ_COUNT => \%tio_01_00996_def,
   TIO_CP0_PCI_BUFFER_5_REQ_COUNT => \%tio_01_00997_def,
   TIO_CP0_PCI_BUFFER_6_REQ_COUNT => \%tio_01_00998_def,
   TIO_CP0_PCI_BUFFER_7_REQ_COUNT => \%tio_01_00999_def,
   TIO_CP0_PCI_BUFFER_0_PREFETCH_COUNT => \%tio_01_01000_def,
   TIO_CP0_PCI_BUFFER_1_PREFETCH_COUNT => \%tio_01_01001_def,
   TIO_CP0_PCI_BUFFER_2_PREFETCH_COUNT => \%tio_01_01002_def,
   TIO_CP0_PCI_BUFFER_3_PREFETCH_COUNT => \%tio_01_01003_def,
   TIO_CP0_PCI_BUFFER_4_PREFETCH_COUNT => \%tio_01_01004_def,
   TIO_CP0_PCI_BUFFER_5_PREFETCH_COUNT => \%tio_01_01005_def,
   TIO_CP0_PCI_BUFFER_6_PREFETCH_COUNT => \%tio_01_01006_def,
   TIO_CP0_PCI_BUFFER_7_PREFETCH_COUNT => \%tio_01_01007_def,
   TIO_CP0_PCI_BUFFER_0_RETRY_TOTAL_COUNT => \%tio_01_01008_def,
   TIO_CP0_PCI_BUFFER_1_RETRY_TOTAL_COUNT => \%tio_01_01009_def,
   TIO_CP0_PCI_BUFFER_2_RETRY_TOTAL_COUNT => \%tio_01_01010_def,
   TIO_CP0_PCI_BUFFER_3_RETRY_TOTAL_COUNT => \%tio_01_01011_def,
   TIO_CP0_PCI_BUFFER_4_RETRY_TOTAL_COUNT => \%tio_01_01012_def,
   TIO_CP0_PCI_BUFFER_5_RETRY_TOTAL_COUNT => \%tio_01_01013_def,
   TIO_CP0_PCI_BUFFER_6_RETRY_TOTAL_COUNT => \%tio_01_01014_def,
   TIO_CP0_PCI_BUFFER_7_RETRY_TOTAL_COUNT => \%tio_01_01015_def,
   TIO_CP0_PCI_BUFFER_0_RETRY_MAX_COUNT => \%tio_01_01016_def,
   TIO_CP0_PCI_BUFFER_1_RETRY_MAX_COUNT => \%tio_01_01017_def,
   TIO_CP0_PCI_BUFFER_2_RETRY_MAX_COUNT => \%tio_01_01018_def,
   TIO_CP0_PCI_BUFFER_3_RETRY_MAX_COUNT => \%tio_01_01019_def,
   TIO_CP0_PCI_BUFFER_4_RETRY_MAX_COUNT => \%tio_01_01020_def,
   TIO_CP0_PCI_BUFFER_5_RETRY_MAX_COUNT => \%tio_01_01021_def,
   TIO_CP0_PCI_BUFFER_6_RETRY_MAX_COUNT => \%tio_01_01022_def,
   TIO_CP0_PCI_BUFFER_7_RETRY_MAX_COUNT => \%tio_01_01023_def,
   TIO_CP0_PCI_BUFFER_0_MAX_LATENCY => \%tio_01_01024_def,
   TIO_CP0_PCI_BUFFER_1_MAX_LATENCY => \%tio_01_01025_def,
   TIO_CP0_PCI_BUFFER_2_MAX_LATENCY => \%tio_01_01026_def,
   TIO_CP0_PCI_BUFFER_3_MAX_LATENCY => \%tio_01_01027_def,
   TIO_CP0_PCI_BUFFER_4_MAX_LATENCY => \%tio_01_01028_def,
   TIO_CP0_PCI_BUFFER_5_MAX_LATENCY => \%tio_01_01029_def,
   TIO_CP0_PCI_BUFFER_6_MAX_LATENCY => \%tio_01_01030_def,
   TIO_CP0_PCI_BUFFER_7_MAX_LATENCY => \%tio_01_01031_def,
   TIO_CP0_PCI_BUFFER_0_CLEAR   => \%tio_01_01032_def,
   TIO_CP0_PCI_BUFFER_1_CLEAR   => \%tio_01_01033_def,
   TIO_CP0_PCI_BUFFER_2_CLEAR   => \%tio_01_01034_def,
   TIO_CP0_PCI_BUFFER_3_CLEAR   => \%tio_01_01035_def,
   TIO_CP0_PCI_BUFFER_4_CLEAR   => \%tio_01_01036_def,
   TIO_CP0_PCI_BUFFER_5_CLEAR   => \%tio_01_01037_def,
   TIO_CP0_PCI_BUFFER_6_CLEAR   => \%tio_01_01038_def,
   TIO_CP0_PCI_BUFFER_7_CLEAR   => \%tio_01_01039_def,
   TIO_CP0_PCI_BUS_ERROR_ADDRESS => \%tio_01_01040_def,
   TIO_CP0_PCI_BUS_ERROR_ATTRIBUTE => \%tio_01_01041_def,
   TIO_CP0_PCI_BUS_ERROR_DATA   => \%tio_01_01042_def,
   TIO_CP0_SPLIT_REQUEST_ADDRESS => \%tio_01_01043_def,
   TIO_CP0_SPLIT_REQUEST_ATTRIBUTE => \%tio_01_01044_def,
   TIO_CP0_DMA_ERROR_ATTRIBUTE  => \%tio_01_01045_def,
   TIO_CP0_DMA_ERROR_ADDRESS    => \%tio_01_01046_def,
   TIO_CP0_PCIX_TIMEOUT         => \%tio_01_01047_def,
   TIO_CP0_CT_DEBUG_CTL         => \%tio_01_01048_def,
   TIO_CP0_BR_DEBUG_CTL         => \%tio_01_01049_def,
   TIO_CP0_MUX3_DEBUG_CTL       => \%tio_01_01050_def,
   TIO_CP0_MUX4_DEBUG_CTL       => \%tio_01_01051_def,
   TIO_CP0_MUX5_DEBUG_CTL       => \%tio_01_01052_def,
   TIO_CP0_MUX6_DEBUG_CTL       => \%tio_01_01053_def,
   TIO_CP0_MUX7_DEBUG_CTL       => \%tio_01_01054_def,
   TIO_CP1_IDENTIFICATION       => \%tio_01_01055_def,
   TIO_CP1_STATUS               => \%tio_01_01056_def,
   TIO_CP1_BUS_SIDE_ERROR_ADDR_UPPER => \%tio_01_01057_def,
   TIO_CP1_BUS_SIDE_ERROR_ADDR_LOWER => \%tio_01_01058_def,
   TIO_CP1_CONTROL              => \%tio_01_01059_def,
   TIO_CP1_REQUEST_TIMEOUT      => \%tio_01_01060_def,
   TIO_CP1_INTERRUPT_DEST_UPPER => \%tio_01_01061_def,
   TIO_CP1_INTERRUPT_DEST_LOWER => \%tio_01_01062_def,
   TIO_CP1_BUS_SIDE_ERROR_CMD_WRD => \%tio_01_01063_def,
   TIO_CP1_TARGET_FLUSH         => \%tio_01_01064_def,
   TIO_CP1_LINK_SIDE_ERROR_CMD_WRD => \%tio_01_01065_def,
   TIO_CP1_RSP_BUFFER_UPPER     => \%tio_01_01066_def,
   TIO_CP1_RSP_BUFFER_LOWER     => \%tio_01_01067_def,
   TIO_CP1_DEBUG_PORT_CONTROL   => \%tio_01_01068_def,
   TIO_CP1_LINK_SIDE_ERROR_ADDR_HOLD => \%tio_01_01069_def,
   TIO_CP1_PCI_DIRECT_MAPPING   => \%tio_01_01070_def,
   TIO_CP1_PAGE_MAP_FAULT_ADD   => \%tio_01_01071_def,
   TIO_CP1_ARBITRATION_PRIORITY => \%tio_01_01072_def,
   TIO_CP1_INTERNAL_RAM_PARITY_ERROR => \%tio_01_01073_def,
   TIO_CP1_TIMEOUT              => \%tio_01_01074_def,
   TIO_CP1_TYPE1_CONFIGURATION  => \%tio_01_01075_def,
   TIO_CP1_BUS_ERROR_ADDR_UPPER => \%tio_01_01076_def,
   TIO_CP1_BUS_ERROR_ADDR_LOWER => \%tio_01_01077_def,
   TIO_CP1_INT_STATUS           => \%tio_01_01078_def,
   TIO_CP1_INTERRUPT_ENABLE     => \%tio_01_01079_def,
   TIO_CP1_RESET_INTERRUPT      => \%tio_01_01080_def,
   TIO_CP1_INTERRUPT_MODE       => \%tio_01_01081_def,
   TIO_CP1_INTERRUPT_DEVICE     => \%tio_01_01082_def,
   TIO_CP1_HOST_ERROR_INTERRUPT => \%tio_01_01083_def,
   TIO_CP1_INTERRUPT_0_HOST_ADDRESS => \%tio_01_01084_def,
   TIO_CP1_INTERRUPT_1_HOST_ADDRESS => \%tio_01_01085_def,
   TIO_CP1_INTERRUPT_2_HOST_ADDRESS => \%tio_01_01086_def,
   TIO_CP1_INTERRUPT_3_HOST_ADDRESS => \%tio_01_01087_def,
   TIO_CP1_INTERRUPT_4_HOST_ADDRESS => \%tio_01_01088_def,
   TIO_CP1_INTERRUPT_5_HOST_ADDRESS => \%tio_01_01089_def,
   TIO_CP1_INTERRUPT_6_HOST_ADDRESS => \%tio_01_01090_def,
   TIO_CP1_INTERRUPT_7_HOST_ADDRESS => \%tio_01_01091_def,
   TIO_CP1_ERROR_INTERRUPT_VIEW => \%tio_01_01092_def,
   TIO_CP1_MULTIPLE_INTERRUPT   => \%tio_01_01093_def,
   TIO_CP1_FORCE_ALWAYS_INTERRUPT_0 => \%tio_01_01094_def,
   TIO_CP1_FORCE_ALWAYS_INTERRUPT_1 => \%tio_01_01095_def,
   TIO_CP1_FORCE_ALWAYS_INTERRUPT_2 => \%tio_01_01096_def,
   TIO_CP1_FORCE_ALWAYS_INTERRUPT_3 => \%tio_01_01097_def,
   TIO_CP1_FORCE_ALWAYS_INTERRUPT_4 => \%tio_01_01098_def,
   TIO_CP1_FORCE_ALWAYS_INTERRUPT_5 => \%tio_01_01099_def,
   TIO_CP1_FORCE_ALWAYS_INTERRUPT_6 => \%tio_01_01100_def,
   TIO_CP1_FORCE_ALWAYS_INTERRUPT_7 => \%tio_01_01101_def,
   TIO_CP1_FORCE_INTERRUPT_0    => \%tio_01_01102_def,
   TIO_CP1_FORCE_INTERRUPT_1    => \%tio_01_01103_def,
   TIO_CP1_FORCE_INTERRUPT_2    => \%tio_01_01104_def,
   TIO_CP1_FORCE_INTERRUPT_3    => \%tio_01_01105_def,
   TIO_CP1_FORCE_INTERRUPT_4    => \%tio_01_01106_def,
   TIO_CP1_FORCE_INTERRUPT_5    => \%tio_01_01107_def,
   TIO_CP1_FORCE_INTERRUPT_6    => \%tio_01_01108_def,
   TIO_CP1_FORCE_INTERRUPT_7    => \%tio_01_01109_def,
   TIO_CP1_DEVICE_0             => \%tio_01_01110_def,
   TIO_CP1_DEVICE_1             => \%tio_01_01111_def,
   TIO_CP1_DEVICE_2             => \%tio_01_01112_def,
   TIO_CP1_DEVICE_3             => \%tio_01_01113_def,
   TIO_CP1_DEVICE_0_WRITE_FLUSH => \%tio_01_01114_def,
   TIO_CP1_DEVICE_1_WRITE_FLUSH => \%tio_01_01115_def,
   TIO_CP1_DEVICE_2_WRITE_FLUSH => \%tio_01_01116_def,
   TIO_CP1_DEVICE_3_WRITE_FLUSH => \%tio_01_01117_def,
   TIO_CP1_EVEN_READ_RSP_BUFFER => \%tio_01_01118_def,
   TIO_CP1_ODD_READ_RSP_BUFFER  => \%tio_01_01119_def,
   TIO_CP1_READ_RSP_BUFFER_STATUS => \%tio_01_01120_def,
   TIO_CP1_READ_RSP_BUFFER_CLEAR => \%tio_01_01121_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_0 => \%tio_01_01122_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_1 => \%tio_01_01123_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_2 => \%tio_01_01124_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_3 => \%tio_01_01125_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_4 => \%tio_01_01126_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_5 => \%tio_01_01127_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_6 => \%tio_01_01128_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_7 => \%tio_01_01129_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_8 => \%tio_01_01130_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_9 => \%tio_01_01131_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_10 => \%tio_01_01132_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_11 => \%tio_01_01133_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_12 => \%tio_01_01134_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_13 => \%tio_01_01135_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_14 => \%tio_01_01136_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_15 => \%tio_01_01137_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_0 => \%tio_01_01138_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_1 => \%tio_01_01139_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_2 => \%tio_01_01140_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_3 => \%tio_01_01141_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_4 => \%tio_01_01142_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_5 => \%tio_01_01143_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_6 => \%tio_01_01144_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_7 => \%tio_01_01145_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_8 => \%tio_01_01146_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_9 => \%tio_01_01147_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_10 => \%tio_01_01148_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_11 => \%tio_01_01149_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_12 => \%tio_01_01150_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_13 => \%tio_01_01151_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_14 => \%tio_01_01152_def,
   TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_15 => \%tio_01_01153_def,
   TIO_CP1_PCI_BUFFER_0_FLUSH_COUNT_TOUCH => \%tio_01_01154_def,
   TIO_CP1_PCI_BUFFER_1_FLUSH_COUNT_TOUCH => \%tio_01_01155_def,
   TIO_CP1_PCI_BUFFER_2_FLUSH_COUNT_TOUCH => \%tio_01_01156_def,
   TIO_CP1_PCI_BUFFER_3_FLUSH_COUNT_TOUCH => \%tio_01_01157_def,
   TIO_CP1_PCI_BUFFER_4_FLUSH_COUNT_TOUCH => \%tio_01_01158_def,
   TIO_CP1_PCI_BUFFER_5_FLUSH_COUNT_TOUCH => \%tio_01_01159_def,
   TIO_CP1_PCI_BUFFER_6_FLUSH_COUNT_TOUCH => \%tio_01_01160_def,
   TIO_CP1_PCI_BUFFER_7_FLUSH_COUNT_TOUCH => \%tio_01_01161_def,
   TIO_CP1_PCI_BUFFER_0_FLUSH_COUNT_NOTOUCH => \%tio_01_01162_def,
   TIO_CP1_PCI_BUFFER_1_FLUSH_COUNT_NOTOUCH => \%tio_01_01163_def,
   TIO_CP1_PCI_BUFFER_2_FLUSH_COUNT_NOTOUCH => \%tio_01_01164_def,
   TIO_CP1_PCI_BUFFER_3_FLUSH_COUNT_NOTOUCH => \%tio_01_01165_def,
   TIO_CP1_PCI_BUFFER_4_FLUSH_COUNT_NOTOUCH => \%tio_01_01166_def,
   TIO_CP1_PCI_BUFFER_5_FLUSH_COUNT_NOTOUCH => \%tio_01_01167_def,
   TIO_CP1_PCI_BUFFER_6_FLUSH_COUNT_NOTOUCH => \%tio_01_01168_def,
   TIO_CP1_PCI_BUFFER_7_FLUSH_COUNT_NOTOUCH => \%tio_01_01169_def,
   TIO_CP1_PCI_BUFFER_0_REQ_COUNT => \%tio_01_01170_def,
   TIO_CP1_PCI_BUFFER_1_REQ_COUNT => \%tio_01_01171_def,
   TIO_CP1_PCI_BUFFER_2_REQ_COUNT => \%tio_01_01172_def,
   TIO_CP1_PCI_BUFFER_3_REQ_COUNT => \%tio_01_01173_def,
   TIO_CP1_PCI_BUFFER_4_REQ_COUNT => \%tio_01_01174_def,
   TIO_CP1_PCI_BUFFER_5_REQ_COUNT => \%tio_01_01175_def,
   TIO_CP1_PCI_BUFFER_6_REQ_COUNT => \%tio_01_01176_def,
   TIO_CP1_PCI_BUFFER_7_REQ_COUNT => \%tio_01_01177_def,
   TIO_CP1_PCI_BUFFER_0_PREFETCH_COUNT => \%tio_01_01178_def,
   TIO_CP1_PCI_BUFFER_1_PREFETCH_COUNT => \%tio_01_01179_def,
   TIO_CP1_PCI_BUFFER_2_PREFETCH_COUNT => \%tio_01_01180_def,
   TIO_CP1_PCI_BUFFER_3_PREFETCH_COUNT => \%tio_01_01181_def,
   TIO_CP1_PCI_BUFFER_4_PREFETCH_COUNT => \%tio_01_01182_def,
   TIO_CP1_PCI_BUFFER_5_PREFETCH_COUNT => \%tio_01_01183_def,
   TIO_CP1_PCI_BUFFER_6_PREFETCH_COUNT => \%tio_01_01184_def,
   TIO_CP1_PCI_BUFFER_7_PREFETCH_COUNT => \%tio_01_01185_def,
   TIO_CP1_PCI_BUFFER_0_RETRY_TOTAL_COUNT => \%tio_01_01186_def,
   TIO_CP1_PCI_BUFFER_1_RETRY_TOTAL_COUNT => \%tio_01_01187_def,
   TIO_CP1_PCI_BUFFER_2_RETRY_TOTAL_COUNT => \%tio_01_01188_def,
   TIO_CP1_PCI_BUFFER_3_RETRY_TOTAL_COUNT => \%tio_01_01189_def,
   TIO_CP1_PCI_BUFFER_4_RETRY_TOTAL_COUNT => \%tio_01_01190_def,
   TIO_CP1_PCI_BUFFER_5_RETRY_TOTAL_COUNT => \%tio_01_01191_def,
   TIO_CP1_PCI_BUFFER_6_RETRY_TOTAL_COUNT => \%tio_01_01192_def,
   TIO_CP1_PCI_BUFFER_7_RETRY_TOTAL_COUNT => \%tio_01_01193_def,
   TIO_CP1_PCI_BUFFER_0_RETRY_MAX_COUNT => \%tio_01_01194_def,
   TIO_CP1_PCI_BUFFER_1_RETRY_MAX_COUNT => \%tio_01_01195_def,
   TIO_CP1_PCI_BUFFER_2_RETRY_MAX_COUNT => \%tio_01_01196_def,
   TIO_CP1_PCI_BUFFER_3_RETRY_MAX_COUNT => \%tio_01_01197_def,
   TIO_CP1_PCI_BUFFER_4_RETRY_MAX_COUNT => \%tio_01_01198_def,
   TIO_CP1_PCI_BUFFER_5_RETRY_MAX_COUNT => \%tio_01_01199_def,
   TIO_CP1_PCI_BUFFER_6_RETRY_MAX_COUNT => \%tio_01_01200_def,
   TIO_CP1_PCI_BUFFER_7_RETRY_MAX_COUNT => \%tio_01_01201_def,
   TIO_CP1_PCI_BUFFER_0_MAX_LATENCY => \%tio_01_01202_def,
   TIO_CP1_PCI_BUFFER_1_MAX_LATENCY => \%tio_01_01203_def,
   TIO_CP1_PCI_BUFFER_2_MAX_LATENCY => \%tio_01_01204_def,
   TIO_CP1_PCI_BUFFER_3_MAX_LATENCY => \%tio_01_01205_def,
   TIO_CP1_PCI_BUFFER_4_MAX_LATENCY => \%tio_01_01206_def,
   TIO_CP1_PCI_BUFFER_5_MAX_LATENCY => \%tio_01_01207_def,
   TIO_CP1_PCI_BUFFER_6_MAX_LATENCY => \%tio_01_01208_def,
   TIO_CP1_PCI_BUFFER_7_MAX_LATENCY => \%tio_01_01209_def,
   TIO_CP1_PCI_BUFFER_0_CLEAR   => \%tio_01_01210_def,
   TIO_CP1_PCI_BUFFER_1_CLEAR   => \%tio_01_01211_def,
   TIO_CP1_PCI_BUFFER_2_CLEAR   => \%tio_01_01212_def,
   TIO_CP1_PCI_BUFFER_3_CLEAR   => \%tio_01_01213_def,
   TIO_CP1_PCI_BUFFER_4_CLEAR   => \%tio_01_01214_def,
   TIO_CP1_PCI_BUFFER_5_CLEAR   => \%tio_01_01215_def,
   TIO_CP1_PCI_BUFFER_6_CLEAR   => \%tio_01_01216_def,
   TIO_CP1_PCI_BUFFER_7_CLEAR   => \%tio_01_01217_def,
   TIO_CP1_PCI_BUS_ERROR_ADDRESS => \%tio_01_01218_def,
   TIO_CP1_PCI_BUS_ERROR_ATTRIBUTE => \%tio_01_01219_def,
   TIO_CP1_PCI_BUS_ERROR_DATA   => \%tio_01_01220_def,
   TIO_CP1_SPLIT_REQUEST_ADDRESS => \%tio_01_01221_def,
   TIO_CP1_SPLIT_REQUEST_ATTRIBUTE => \%tio_01_01222_def,
   TIO_CP1_DMA_ERROR_ATTRIBUTE  => \%tio_01_01223_def,
   TIO_CP1_DMA_ERROR_ADDRESS    => \%tio_01_01224_def,
   TIO_CP1_PCIX_TIMEOUT         => \%tio_01_01225_def,
   TIO_CP1_CT_DEBUG_CTL         => \%tio_01_01226_def,
   TIO_CP1_BR_DEBUG_CTL         => \%tio_01_01227_def,
   TIO_CP1_MUX3_DEBUG_CTL       => \%tio_01_01228_def,
   TIO_CP1_MUX4_DEBUG_CTL       => \%tio_01_01229_def,
   TIO_CP1_MUX5_DEBUG_CTL       => \%tio_01_01230_def,
   TIO_CP1_MUX6_DEBUG_CTL       => \%tio_01_01231_def,
   TIO_CP1_MUX7_DEBUG_CTL       => \%tio_01_01232_def,
   XCE_ADM_CE_ID            => \%tio_01_01233_def,
   XCE_ADM_DYN_CREDIT_STATUS => \%tio_01_01234_def,
   XCE_ADM_LAST_CREDIT_STATUS => \%tio_01_01235_def,
   XCE_ADM_CREDIT_LIMIT     => \%tio_01_01236_def,
   XCE_ADM_FORCE_CREDIT     => \%tio_01_01237_def,
   XCE_ADM_CONTROL          => \%tio_01_01238_def,
   XCE_ADM_MMR_CHN_TIMEOUT_CTRL => \%tio_01_01239_def,
   XCE_ADM_SSP_URE_TIMEOUT_CTRL => \%tio_01_01240_def,
   XCE_ADM_SSP_DRE_TIMEOUT_CTRL => \%tio_01_01241_def,
   XCE_ADM_SSP_DEBUG_SEL    => \%tio_01_01242_def,
   XCE_ADM_INT_STATUS       => \%tio_01_01243_def,
   XCE_ADM_INT_STATUS_ALIAS => \%tio_01_01244_def,
   XCE_ADM_INT_MASK         => \%tio_01_01245_def,
   XCE_ADM_INT_PENDING      => \%tio_01_01246_def,
   XCE_ADM_FORCE_INT        => \%tio_01_01247_def,
   XCE_ADM_URE_UPS_BUF_BARRIER_FLUSH_SEL => \%tio_01_01248_def,
   XCE_ADM_INT_DEST_0       => \%tio_01_01249_def,
   XCE_ADM_INT_DEST_1       => \%tio_01_01250_def,
   XCE_ADM_INT_DEST_2       => \%tio_01_01251_def,
   XCE_ADM_INT_DEST_3       => \%tio_01_01252_def,
   XCE_ADM_INT_DEST_4       => \%tio_01_01253_def,
   XCE_ADM_INT_DEST_5       => \%tio_01_01254_def,
   XCE_ADM_INT_DEST_6       => \%tio_01_01255_def,
   XCE_ADM_INT_DEST_7       => \%tio_01_01256_def,
   XCE_ADM_INT_DEST_8       => \%tio_01_01257_def,
   XCE_ADM_INT_DEST_9       => \%tio_01_01258_def,
   XCE_ADM_INT_DEST_10      => \%tio_01_01259_def,
   XCE_ADM_INT_DEST_11      => \%tio_01_01260_def,
   XCE_ADM_INT_DEST_12      => \%tio_01_01261_def,
   XCE_ADM_INT_DEST_13      => \%tio_01_01262_def,
   XCE_ADM_INT_DEST_14      => \%tio_01_01263_def,
   XCE_ADM_ERROR_SUMMARY    => \%tio_01_01264_def,
   XCE_ADM_ERROR_SUMMARY_ALIAS => \%tio_01_01265_def,
   XCE_ADM_ERROR_MASK       => \%tio_01_01266_def,
   XCE_ADM_FIRST_ERROR      => \%tio_01_01267_def,
   XCE_ADM_ERROR_OVERFLOW   => \%tio_01_01268_def,
   XCE_ADM_ERROR_OVERFLOW_ALIAS => \%tio_01_01269_def,
   XCE_ADM_TNUM_ERROR       => \%tio_01_01270_def,
   XCE_ADM_MMR_ERR_DETAIL   => \%tio_01_01271_def,
   XCE_ADM_MSG_SRAM_PERR_DETAIL => \%tio_01_01272_def,
   XCE_ADM_BAP_SRAM_PERR_DETAIL => \%tio_01_01273_def,
   XCE_ADM_CE_SRAM_PERR_DETAIL => \%tio_01_01274_def,
   XCE_ADM_CE_CREDIT_OFLOW_DETAIL => \%tio_01_01275_def,
   XCE_ADM_TX_LINK_IDLE_MAX_TIME => \%tio_01_01276_def,
   XCE_ADM_PCIE_DEBUG_SEL   => \%tio_01_01277_def,
   XCE_ADM_PCIE_DEBUG_SEL_TOP => \%tio_01_01278_def,
   XCE_ADM_PCIE_DEBUG_LAT_SEL_LO_TOP => \%tio_01_01279_def,
   XCE_ADM_PCIE_DEBUG_LAT_SEL_HI_TOP => \%tio_01_01280_def,
   XCE_ADM_PCIE_DEBUG_TRIG_SEL_TOP => \%tio_01_01281_def,
   XCE_ADM_PCIE_DEBUG_TRIG_LAT_SEL_LO_TOP => \%tio_01_01282_def,
   XCE_ADM_PCIE_DEBUG_TRIG_LAT_SEL_HI_TOP => \%tio_01_01283_def,
   XCE_ADM_PCIE_TRIG_COMPARE_TOP => \%tio_01_01284_def,
   XCE_ADM_PCIE_TRIG_COMPARE_EN_TOP => \%tio_01_01285_def,
   XCE_ADM_SSP_DEBUG_SEL_TOP => \%tio_01_01286_def,
   XCE_ADM_SSP_DEBUG_LAT_SEL_LO_TOP => \%tio_01_01287_def,
   XCE_ADM_SSP_DEBUG_LAT_SEL_HI_TOP => \%tio_01_01288_def,
   XCE_ADM_SSP_DEBUG_TRIG_SEL_TOP => \%tio_01_01289_def,
   XCE_ADM_SSP_DEBUG_TRIG_LAT_SEL_LO_TOP => \%tio_01_01290_def,
   XCE_ADM_SSP_DEBUG_TRIG_LAT_SEL_HI_TOP => \%tio_01_01291_def,
   XCE_ADM_SSP_TRIG_COMPARE_TOP => \%tio_01_01292_def,
   XCE_ADM_SSP_TRIG_COMPARE_EN_TOP => \%tio_01_01293_def,
   XCE_ADM_BAP_CTRL         => \%tio_01_01294_def,
   XCE_ADM_MAINT_MSG_BUF_DATA63_0 => \%tio_01_01295_def,
   XCE_ADM_MAINT_MSG_BUF_DATA127_64 => \%tio_01_01296_def,
   XCE_ADM_MAINT_MSG_BUF_PARITY => \%tio_01_01297_def,
   XCE_LSI1_LPU_ID          => \%tio_01_01298_def,
   XCE_LSI1_RST_REG         => \%tio_01_01299_def,
   XCE_LSI1_DBG_STAT        => \%tio_01_01300_def,
   XCE_LSI1_DBG_CFG         => \%tio_01_01301_def,
   XCE_LSI1_LTSSM_CTRL      => \%tio_01_01302_def,
   XCE_LSI1_LK_STAT         => \%tio_01_01303_def,
   XCE_LSI1_INT_AND_STAT    => \%tio_01_01304_def,
   XCE_LSI1_INT_MASK        => \%tio_01_01305_def,
   XCE_LSI1_LK_PERF_CNT_SEL => \%tio_01_01306_def,
   XCE_LSI1_LK_PERF_CNT_CTRL => \%tio_01_01307_def,
   XCE_LSI1_LK_PERF_CNT1    => \%tio_01_01308_def,
   XCE_LSI1_LK_PERF_CNT1_TEST => \%tio_01_01309_def,
   XCE_LSI1_LK_PERF_CNT2    => \%tio_01_01310_def,
   XCE_LSI1_LK_PERF_CNT2_TEST => \%tio_01_01311_def,
   XCE_LSI1_LK_LYR_CFG      => \%tio_01_01312_def,
   XCE_LSI1_LK_LYR_STATUS   => \%tio_01_01313_def,
   XCE_LSI1_LK_LYR_INT_STAT => \%tio_01_01314_def,
   XCE_LSI1_LK_LY_INT_STAT_TEST => \%tio_01_01315_def,
   XCE_LSI1_LK_LY_INT_MASK  => \%tio_01_01316_def,
   XCE_LSI1_FC_UPD_CTL      => \%tio_01_01317_def,
   XCE_LSI1_FLW_CTL_UPD_TO_TIMER => \%tio_01_01318_def,
   XCE_LSI1_VC0_FLW_CTL_UPD_TIMER0 => \%tio_01_01319_def,
   XCE_LSI1_VC0_FLW_CTL_UPD_TIMER1 => \%tio_01_01320_def,
   XCE_LSI1_FREQ_NAK_LAT_THRSH => \%tio_01_01321_def,
   XCE_LSI1_ACK_NAK_LAT_TMR => \%tio_01_01322_def,
   XCE_LSI1_RPLY_TMR_THR    => \%tio_01_01323_def,
   XCE_LSI1_RPLY_TMR        => \%tio_01_01324_def,
   XCE_LSI1_RPLY_NUM_STAT   => \%tio_01_01325_def,
   XCE_LSI1_RTY_BUF_MAX_ADDR => \%tio_01_01326_def,
   XCE_LSI1_RTY_FIFO_PTR    => \%tio_01_01327_def,
   XCE_LSI1_RTY_FIFO_RD_WR_PTR => \%tio_01_01328_def,
   XCE_LSI1_RTY_FIFO_CRED   => \%tio_01_01329_def,
   XCE_LSI1_SEQ_CNT         => \%tio_01_01330_def,
   XCE_LSI1_ACK_SENT_SEQ_NUM => \%tio_01_01331_def,
   XCE_LSI1_SEQ_CNT_FIFO_MAX_ADDR => \%tio_01_01332_def,
   XCE_LSI1_SEQ_CNT_FIFO_PTR => \%tio_01_01333_def,
   XCE_LSI1_SEQ_CNT_RD_WR_PTR => \%tio_01_01334_def,
   XCE_LSI1_TX_LK_TS_CTL    => \%tio_01_01335_def,
   XCE_LSI1_MEM_ADDR_CTL    => \%tio_01_01336_def,
   XCE_LSI1_MEM_D_LD0       => \%tio_01_01337_def,
   XCE_LSI1_MEM_D_LD1       => \%tio_01_01338_def,
   XCE_LSI1_MEM_D_LD2       => \%tio_01_01339_def,
   XCE_LSI1_MEM_D_LD3       => \%tio_01_01340_def,
   XCE_LSI1_MEM_D_LD4       => \%tio_01_01341_def,
   XCE_LSI1_RTY_D_CNT       => \%tio_01_01342_def,
   XCE_LSI1_SEQ_BUF_CNT     => \%tio_01_01343_def,
   XCE_LSI1_SEQ_BUF_BT_D    => \%tio_01_01344_def,
   XCE_LSI1_ACK_LAT_THR     => \%tio_01_01345_def,
   XCE_LSI1_NXT_RCV_SEQ_1_CNTR => \%tio_01_01346_def,
   XCE_LSI1_UNSP_DLLP_RCVD  => \%tio_01_01347_def,
   XCE_LSI1_RCV_LK_TS_CTL   => \%tio_01_01348_def,
   XCE_LSI1_PHY_LYR_CFG     => \%tio_01_01349_def,
   XCE_LSI1_PHY_LYR_INT_STAT => \%tio_01_01350_def,
   XCE_LSI1_PHY_LYR_INT_STAT_TEST => \%tio_01_01351_def,
   XCE_LSI1_PHY_LYR_INT_MASK => \%tio_01_01352_def,
   XCE_LSI1_RCV_PHY_CFG     => \%tio_01_01353_def,
   XCE_LSI1_RCV_PHY_STAT1   => \%tio_01_01354_def,
   XCE_LSI1_RCV_PHY_STAT2   => \%tio_01_01355_def,
   XCE_LSI1_RCV_PHY_STAT3   => \%tio_01_01356_def,
   XCE_LSI1_RCV_PHY_INT_STAT => \%tio_01_01357_def,
   XCE_LSI1_RCV_PHY_INT_STAT_TEST => \%tio_01_01358_def,
   XCE_LSI1_RCV_PHY_INT_MASK => \%tio_01_01359_def,
   XCE_LSI1_TX_PHY_CFG      => \%tio_01_01360_def,
   XCE_LSI1_TX_PHY_STAT     => \%tio_01_01361_def,
   XCE_LSI1_TX_PHY_INT_STAT => \%tio_01_01362_def,
   XCE_LSI1_TX_PHY_INT_STAT_TEST => \%tio_01_01363_def,
   XCE_LSI1_TX_PHY_INT_MASK => \%tio_01_01364_def,
   XCE_LSI1_TX_PHY_STAT2    => \%tio_01_01365_def,
   XCE_LSI1_LTSSM_CFG1      => \%tio_01_01366_def,
   XCE_LSI1_LTSSM_CFG2      => \%tio_01_01367_def,
   XCE_LSI1_LTSSM_CFG3      => \%tio_01_01368_def,
   XCE_LSI1_LTSSM_CFG4      => \%tio_01_01369_def,
   XCE_LSI1_LTSSM_CFG5      => \%tio_01_01370_def,
   XCE_LSI1_LTSSM_STAT1     => \%tio_01_01371_def,
   XCE_LSI1_LTSSM_STAT2     => \%tio_01_01372_def,
   XCE_LSI1_LTSSM_INT_STAT  => \%tio_01_01373_def,
   XCE_LSI1_LTSSM_INT_STAT_TEST => \%tio_01_01374_def,
   XCE_LSI1_LTSSM_INT_MASK  => \%tio_01_01375_def,
   XCE_LSI1_LTSSM_STAT_WR_EN => \%tio_01_01376_def,
   XCE_LSI1_GB_CFG1         => \%tio_01_01377_def,
   XCE_LSI1_GB_CFG2         => \%tio_01_01378_def,
   XCE_LSI1_GB_CFG3         => \%tio_01_01379_def,
   XCE_LSI1_GB_CFG4         => \%tio_01_01380_def,
   XCE_LSI1_GB_STAT         => \%tio_01_01381_def,
   XCE_LSI1_GB_INT_STAT     => \%tio_01_01382_def,
   XCE_LSI1_GB_INT_STAT_TEST => \%tio_01_01383_def,
   XCE_LSI1_GB_INT_MASK     => \%tio_01_01384_def,
   XCE_LSI1_GB_PWR_DN1      => \%tio_01_01385_def,
   XCE_LSI1_GB_PWR_DN2      => \%tio_01_01386_def,
   XCE_LSI2_LPU_ID          => \%tio_01_01387_def,
   XCE_LSI2_RST_REG         => \%tio_01_01388_def,
   XCE_LSI2_DBG_STAT        => \%tio_01_01389_def,
   XCE_LSI2_DBG_CFG         => \%tio_01_01390_def,
   XCE_LSI2_LTSSM_CTRL      => \%tio_01_01391_def,
   XCE_LSI2_LK_STAT         => \%tio_01_01392_def,
   XCE_LSI2_INT_AND_STAT    => \%tio_01_01393_def,
   XCE_LSI2_INT_MASK        => \%tio_01_01394_def,
   XCE_LSI2_LK_PERF_CNT_SEL => \%tio_01_01395_def,
   XCE_LSI2_LK_PERF_CNT_CTRL => \%tio_01_01396_def,
   XCE_LSI2_LK_PERF_CNT1    => \%tio_01_01397_def,
   XCE_LSI2_LK_PERF_CNT1_TEST => \%tio_01_01398_def,
   XCE_LSI2_LK_PERF_CNT2    => \%tio_01_01399_def,
   XCE_LSI2_LK_PERF_CNT2_TEST => \%tio_01_01400_def,
   XCE_LSI2_LK_LYR_CFG      => \%tio_01_01401_def,
   XCE_LSI2_LK_LYR_STATUS   => \%tio_01_01402_def,
   XCE_LSI2_LK_LYR_INT_STAT => \%tio_01_01403_def,
   XCE_LSI2_LK_LY_INT_STAT_TEST => \%tio_01_01404_def,
   XCE_LSI2_LK_LY_INT_MASK  => \%tio_01_01405_def,
   XCE_LSI2_FC_UPD_CTL      => \%tio_01_01406_def,
   XCE_LSI2_FLW_CTL_UPD_TO_TIMER => \%tio_01_01407_def,
   XCE_LSI2_VC0_FLW_CTL_UPD_TIMER0 => \%tio_01_01408_def,
   XCE_LSI2_VC0_FLW_CTL_UPD_TIMER1 => \%tio_01_01409_def,
   XCE_LSI2_FREQ_NAK_LAT_THRSH => \%tio_01_01410_def,
   XCE_LSI2_ACK_NAK_LAT_TMR => \%tio_01_01411_def,
   XCE_LSI2_RPLY_TMR_THR    => \%tio_01_01412_def,
   XCE_LSI2_RPLY_TMR        => \%tio_01_01413_def,
   XCE_LSI2_RPLY_NUM_STAT   => \%tio_01_01414_def,
   XCE_LSI2_RTY_BUF_MAX_ADDR => \%tio_01_01415_def,
   XCE_LSI2_RTY_FIFO_PTR    => \%tio_01_01416_def,
   XCE_LSI2_RTY_FIFO_RD_WR_PTR => \%tio_01_01417_def,
   XCE_LSI2_RTY_FIFO_CRED   => \%tio_01_01418_def,
   XCE_LSI2_SEQ_CNT         => \%tio_01_01419_def,
   XCE_LSI2_ACK_SENT_SEQ_NUM => \%tio_01_01420_def,
   XCE_LSI2_SEQ_CNT_FIFO_MAX_ADDR => \%tio_01_01421_def,
   XCE_LSI2_SEQ_CNT_FIFO_PTR => \%tio_01_01422_def,
   XCE_LSI2_SEQ_CNT_RD_WR_PTR => \%tio_01_01423_def,
   XCE_LSI2_TX_LK_TS_CTL    => \%tio_01_01424_def,
   XCE_LSI2_MEM_ADDR_CTL    => \%tio_01_01425_def,
   XCE_LSI2_MEM_D_LD0       => \%tio_01_01426_def,
   XCE_LSI2_MEM_D_LD1       => \%tio_01_01427_def,
   XCE_LSI2_MEM_D_LD2       => \%tio_01_01428_def,
   XCE_LSI2_MEM_D_LD3       => \%tio_01_01429_def,
   XCE_LSI2_MEM_D_LD4       => \%tio_01_01430_def,
   XCE_LSI2_RTY_D_CNT       => \%tio_01_01431_def,
   XCE_LSI2_SEQ_BUF_CNT     => \%tio_01_01432_def,
   XCE_LSI2_SEQ_BUF_BT_D    => \%tio_01_01433_def,
   XCE_LSI2_ACK_LAT_THR     => \%tio_01_01434_def,
   XCE_LSI2_NXT_RCV_SEQ_1_CNTR => \%tio_01_01435_def,
   XCE_LSI2_UNSP_DLLP_RCVD  => \%tio_01_01436_def,
   XCE_LSI2_RCV_LK_TS_CTL   => \%tio_01_01437_def,
   XCE_LSI2_PHY_LYR_CFG     => \%tio_01_01438_def,
   XCE_LSI2_PHY_LYR_INT_STAT => \%tio_01_01439_def,
   XCE_LSI2_PHY_LYR_INT_STAT_TEST => \%tio_01_01440_def,
   XCE_LSI2_PHY_LYR_INT_MASK => \%tio_01_01441_def,
   XCE_LSI2_RCV_PHY_CFG     => \%tio_01_01442_def,
   XCE_LSI2_RCV_PHY_STAT1   => \%tio_01_01443_def,
   XCE_LSI2_RCV_PHY_STAT2   => \%tio_01_01444_def,
   XCE_LSI2_RCV_PHY_STAT3   => \%tio_01_01445_def,
   XCE_LSI2_RCV_PHY_INT_STAT => \%tio_01_01446_def,
   XCE_LSI2_RCV_PHY_INT_STAT_TEST => \%tio_01_01447_def,
   XCE_LSI2_RCV_PHY_INT_MASK => \%tio_01_01448_def,
   XCE_LSI2_TX_PHY_CFG      => \%tio_01_01449_def,
   XCE_LSI2_TX_PHY_STAT     => \%tio_01_01450_def,
   XCE_LSI2_TX_PHY_INT_STAT => \%tio_01_01451_def,
   XCE_LSI2_TX_PHY_INT_STAT_TEST => \%tio_01_01452_def,
   XCE_LSI2_TX_PHY_INT_MASK => \%tio_01_01453_def,
   XCE_LSI2_TX_PHY_STAT2    => \%tio_01_01454_def,
   XCE_LSI2_LTSSM_CFG1      => \%tio_01_01455_def,
   XCE_LSI2_LTSSM_CFG2      => \%tio_01_01456_def,
   XCE_LSI2_LTSSM_CFG3      => \%tio_01_01457_def,
   XCE_LSI2_LTSSM_CFG4      => \%tio_01_01458_def,
   XCE_LSI2_LTSSM_CFG5      => \%tio_01_01459_def,
   XCE_LSI2_LTSSM_STAT1     => \%tio_01_01460_def,
   XCE_LSI2_LTSSM_STAT2     => \%tio_01_01461_def,
   XCE_LSI2_LTSSM_INT_STAT  => \%tio_01_01462_def,
   XCE_LSI2_LTSSM_INT_STAT_TEST => \%tio_01_01463_def,
   XCE_LSI2_LTSSM_INT_MASK  => \%tio_01_01464_def,
   XCE_LSI2_LTSSM_STAT_WR_EN => \%tio_01_01465_def,
   XCE_LSI2_GB_CFG1         => \%tio_01_01466_def,
   XCE_LSI2_GB_CFG2         => \%tio_01_01467_def,
   XCE_LSI2_GB_CFG3         => \%tio_01_01468_def,
   XCE_LSI2_GB_CFG4         => \%tio_01_01469_def,
   XCE_LSI2_GB_STAT         => \%tio_01_01470_def,
   XCE_LSI2_GB_INT_STAT     => \%tio_01_01471_def,
   XCE_LSI2_GB_INT_STAT_TEST => \%tio_01_01472_def,
   XCE_LSI2_GB_INT_MASK     => \%tio_01_01473_def,
   XCE_LSI2_GB_PWR_DN1      => \%tio_01_01474_def,
   XCE_LSI2_GB_PWR_DN2      => \%tio_01_01475_def,
   XCE_ADM_MAINT_BAP_BUF_DATA63_0 => \%tio_01_01476_def,
   XCE_ADM_MAINT_BAP_BUF_DATA127_64 => \%tio_01_01477_def,
   XCE_ADM_MAINT_BAP_BUF_PARITY => \%tio_01_01478_def,
   XCE_CRM_DEBUG_MUX        => \%tio_01_01479_def,
   XCE_CRM_SSP_ERR_CMD_WRD  => \%tio_01_01480_def,
   XCE_CRM_SSP_ERR_ADDR     => \%tio_01_01481_def,
   XCE_CRM_SSP_ERR_SYN      => \%tio_01_01482_def,
   XCE_CXM_DYN_CREDIT_STATUS => \%tio_01_01483_def,
   XCE_CXM_LAST_CREDIT_STATUS => \%tio_01_01484_def,
   XCE_CXM_CREDIT_LIMIT     => \%tio_01_01485_def,
   XCE_CXM_FORCE_CREDIT     => \%tio_01_01486_def,
   XCE_CXM_DISABLE_BYPASS   => \%tio_01_01487_def,
   XCE_CXM_DEBUG_MUX        => \%tio_01_01488_def,
   XCE_DTL1_DTDR_CREDIT_LIMIT => \%tio_01_01489_def,
   XCE_DTL1_DTDR_CREDIT_FORCE => \%tio_01_01490_def,
   XCE_DTL1_DTL_DYN_CREDIT_STATUS => \%tio_01_01491_def,
   XCE_DTL1_DTL_LAST_CREDIT_STATUS => \%tio_01_01492_def,
   XCE_DTL1_DEBUG_SEL       => \%tio_01_01493_def,
   XCE_DTL2_DTDR_CREDIT_LIMIT => \%tio_01_01494_def,
   XCE_DTL2_DTDR_CREDIT_FORCE => \%tio_01_01495_def,
   XCE_DTL2_DTL_DYN_CREDIT_STATUS => \%tio_01_01496_def,
   XCE_DTL2_DTL_LAST_CREDIT_STATUS => \%tio_01_01497_def,
   XCE_DTL2_DEBUG_SEL       => \%tio_01_01498_def,
   XCE_UTL1_UTL_CTRL        => \%tio_01_01499_def,
   XCE_UTL1_DEBUG_SEL       => \%tio_01_01500_def,
   XCE_UTL2_UTL_CTRL        => \%tio_01_01501_def,
   XCE_UTL2_DEBUG_SEL       => \%tio_01_01502_def,
   XCE_DRE_DYN_CREDIT_STATUS1 => \%tio_01_01503_def,
   XCE_DRE_DYN_CREDIT_STATUS2 => \%tio_01_01504_def,
   XCE_DRE_DYN_FIFO         => \%tio_01_01505_def,
   XCE_DRE_LAST_CREDIT_STATUS1 => \%tio_01_01506_def,
   XCE_DRE_LAST_CREDIT_STATUS2 => \%tio_01_01507_def,
   XCE_DRE_LAST_FIFO        => \%tio_01_01508_def,
   XCE_DRE_CREDIT_LIMIT1    => \%tio_01_01509_def,
   XCE_DRE_CREDIT_LIMIT2    => \%tio_01_01510_def,
   XCE_DRE_FORCE_CREDIT1    => \%tio_01_01511_def,
   XCE_DRE_FORCE_CREDIT2    => \%tio_01_01512_def,
   XCE_DRE_DEBUG_MUX1       => \%tio_01_01513_def,
   XCE_DRE_DEBUG_MUX2       => \%tio_01_01514_def,
   XCE_DRE_SSP_ERR_CMD_WRD  => \%tio_01_01515_def,
   XCE_DRE_SSP_ERR_ADDR     => \%tio_01_01516_def,
   XCE_DRE_COMP_ERR_CMD_WRD => \%tio_01_01517_def,
   XCE_DRE_COMP_ERR_ADDR    => \%tio_01_01518_def,
   XCE_DRE_REQ_STATUS       => \%tio_01_01519_def,
   XCE_DRE_CONFIG1          => \%tio_01_01520_def,
   XCE_DRE_CONFIG2          => \%tio_01_01521_def,
   XCE_DRE_CONFIG_REQ_STATUS => \%tio_01_01522_def,
   XCE_DRE_MAINT_DS_HEAD_QUEUE_MISC => \%tio_01_01523_def,
   XCE_DRE_MAINT_DS_HEAD_QUEUE_DATA127_64 => \%tio_01_01524_def,
   XCE_DRE_MAINT_DS_HEAD_QUEUE_DATA63_0 => \%tio_01_01525_def,
   XCE_DRE_MAINT_DS_DATA_QUEUE_MISC => \%tio_01_01526_def,
   XCE_DRE_MAINT_DS_DATA_QUEUE_DATA127_64 => \%tio_01_01527_def,
   XCE_DRE_MAINT_DS_DATA_QUEUE_DATA63_0 => \%tio_01_01528_def,
   XCE_DRE_MAINT_URE_US_RSP_QUEUE_MISC => \%tio_01_01529_def,
   XCE_DRE_MAINT_URE_US_RSP_QUEUE_DATA127_64 => \%tio_01_01530_def,
   XCE_DRE_MAINT_URE_US_RSP_QUEUE_DATA63_0 => \%tio_01_01531_def,
   XCE_DRE_MAINT_US_WRT_RSP_QUEUE => \%tio_01_01532_def,
   XCE_URE_DYN_CREDIT_STATUS => \%tio_01_01533_def,
   XCE_URE_LAST_CREDIT_STATUS => \%tio_01_01534_def,
   XCE_URE_CREDIT_LIMIT     => \%tio_01_01535_def,
   XCE_URE_CONTROL          => \%tio_01_01536_def,
   XCE_URE_STATUS           => \%tio_01_01537_def,
   XCE_URE_SSP_DEBUG_SEL    => \%tio_01_01538_def,
   XCE_URE_PCIE_DEBUG_SEL   => \%tio_01_01539_def,
   XCE_URE_SSP_ERR_CMD_WRD  => \%tio_01_01540_def,
   XCE_URE_SSP_ERR_ADDR     => \%tio_01_01541_def,
   XCE_URE_PAGE_MAP         => \%tio_01_01542_def,
   XCE_URE_DIR_MAP1         => \%tio_01_01543_def,
   XCE_URE_DIR_MAP2         => \%tio_01_01544_def,
   XCE_URE_PIPE_SEL1        => \%tio_01_01545_def,
   XCE_URE_PIPE_MASK1       => \%tio_01_01546_def,
   XCE_URE_PIPE_SEL2        => \%tio_01_01547_def,
   XCE_URE_PIPE_MASK2       => \%tio_01_01548_def,
   XCE_URE_PCIE1_CREDITS_SENT => \%tio_01_01549_def,
   XCE_URE_PCIE1_CREDITS_USED => \%tio_01_01550_def,
   XCE_URE_PCIE1_CREDIT_LIMIT => \%tio_01_01551_def,
   XCE_URE_PCIE2_CREDITS_SENT => \%tio_01_01552_def,
   XCE_URE_PCIE2_CREDITS_USED => \%tio_01_01553_def,
   XCE_URE_PCIE2_CREDIT_LIMIT => \%tio_01_01554_def,
   XCE_URE_PCIE_FORCE_CREDIT => \%tio_01_01555_def,
   XCE_URE_RD_TNUM_VAL      => \%tio_01_01556_def,
   XCE_URE_RD_TNUM_RSP_RCVD => \%tio_01_01557_def,
   XCE_URE_RD_TNUM_ESENT    => \%tio_01_01558_def,
   XCE_URE_RD_TNUM_ERROR    => \%tio_01_01559_def,
   XCE_URE_RD_TNUM_FIRST_CL => \%tio_01_01560_def,
   XCE_URE_RD_TNUM_LINK_BUF => \%tio_01_01561_def,
   XCE_URE_WR_TNUM_VAL      => \%tio_01_01562_def,
   XCE_URE_SRAM_ERR_ADDR0   => \%tio_01_01563_def,
   XCE_URE_SRAM_ERR_ADDR1   => \%tio_01_01564_def,
   XCE_URE_SRAM_ERR_ADDR2   => \%tio_01_01565_def,
   XCE_URE_SRAM_RD_ADDR0    => \%tio_01_01566_def,
   XCE_URE_SRAM_RD_ADDR1    => \%tio_01_01567_def,
   XCE_URE_SRAM_RD_ADDR2    => \%tio_01_01568_def,
   XCE_URE_SRAM_WR_ADDR0    => \%tio_01_01569_def,
   XCE_URE_SRAM_WR_ADDR1    => \%tio_01_01570_def,
   XCE_URE_SRAM_WR_ADDR2    => \%tio_01_01571_def,
   XCE_URE_BUF_FLUSH10      => \%tio_01_01572_def,
   XCE_URE_BUF_FLUSH11      => \%tio_01_01573_def,
   XCE_URE_BUF_FLUSH12      => \%tio_01_01574_def,
   XCE_URE_BUF_FLUSH13      => \%tio_01_01575_def,
   XCE_URE_BUF_FLUSH20      => \%tio_01_01576_def,
   XCE_URE_BUF_FLUSH21      => \%tio_01_01577_def,
   XCE_URE_BUF_FLUSH22      => \%tio_01_01578_def,
   XCE_URE_BUF_FLUSH23      => \%tio_01_01579_def,
   XCE_PCIE_CONTROL1        => \%tio_01_01580_def,
   XCE_PCIE_CONTROL2        => \%tio_01_01581_def,
   XCE_URE_MAINT_UPS_DAT1_DATA63_0 => \%tio_01_01582_def,
   XCE_URE_MAINT_UPS_DAT1_DATA127_64 => \%tio_01_01583_def,
   XCE_URE_MAINT_UPS_DAT1_PARITY => \%tio_01_01584_def,
   XCE_URE_MAINT_UPS_HDR1_DATA63_0 => \%tio_01_01585_def,
   XCE_URE_MAINT_UPS_HDR1_DATA127_64 => \%tio_01_01586_def,
   XCE_URE_MAINT_UPS_HDR1_PARITY => \%tio_01_01587_def,
   XCE_URE_MAINT_UPS_DAT2_DATA63_0 => \%tio_01_01588_def,
   XCE_URE_MAINT_UPS_DAT2_DATA127_64 => \%tio_01_01589_def,
   XCE_URE_MAINT_UPS_DAT2_PARITY => \%tio_01_01590_def,
   XCE_URE_MAINT_UPS_HDR2_DATA63_0 => \%tio_01_01591_def,
   XCE_URE_MAINT_UPS_HDR2_DATA127_64 => \%tio_01_01592_def,
   XCE_URE_MAINT_UPS_HDR2_PARITY => \%tio_01_01593_def,
   XCE_URE_MAINT_DNS_DAT_DATA63_0 => \%tio_01_01594_def,
   XCE_URE_MAINT_DNS_DAT_DATA127_64 => \%tio_01_01595_def,
   XCE_URE_MAINT_DNS_DAT_PARITY => \%tio_01_01596_def,
   XCE_URE_MAINT_DNS_HDR_DATA31_0 => \%tio_01_01597_def,
   XCE_URE_MAINT_DNS_HDR_DATA95_32 => \%tio_01_01598_def,
   XCE_URE_MAINT_DNS_HDR_PARITY => \%tio_01_01599_def,
   XCE_URE_MAINT_RCI_DATA41_0 => \%tio_01_01600_def,
   XCE_URE_MAINT_RCI_DATA69_42 => \%tio_01_01601_def,
   XCE_URE_MAINT_RSPQ       => \%tio_01_01602_def,
   XCE_URE_ATE40            => \%tio_01_01603_def,
   XCE_URE_ATE3240          => \%tio_01_01604_def,
   XCE_HST_ID_COMP          => \%tio_01_01605_def,
   XCE_HST_CMD_COMP         => \%tio_01_01606_def,
   XCE_HST_STAT_COMP        => \%tio_01_01607_def,
   XCE_HST_CCR_COMP         => \%tio_01_01608_def,
   XCE_HST_CLS_COMP         => \%tio_01_01609_def,
   XCE_HST_HTR_COMP         => \%tio_01_01610_def,
   XCE_PPB1_ID_COMP         => \%tio_01_01611_def,
   XCE_PPB1_CMD_COMP        => \%tio_01_01612_def,
   XCE_PPB1_STAT_COMP       => \%tio_01_01613_def,
   XCE_PPB1_CCR_COMP        => \%tio_01_01614_def,
   XCE_PPB1_CLS_COMP        => \%tio_01_01615_def,
   XCE_PPB1_HTR_COMP        => \%tio_01_01616_def,
   XCE_PPB1_BUS_ID_COMP     => \%tio_01_01617_def,
   XCE_PPB1_IOLB_COMP       => \%tio_01_01618_def,
   XCE_PPB1_SECSTAT_COMP    => \%tio_01_01619_def,
   XCE_PPB1_MEMLIMIT_COMP   => \%tio_01_01620_def,
   XCE_PPB1_PMEMLIMIT_COMP  => \%tio_01_01621_def,
   XCE_PPB1_PMEMUBASE_COMP  => \%tio_01_01622_def,
   XCE_PPB1_PMEMULIMIT_COMP => \%tio_01_01623_def,
   XCE_PPB1_IOULB_COMP      => \%tio_01_01624_def,
   XCE_PPB1_CPTR_COMP       => \%tio_01_01625_def,
   XCE_PPB1_BCTRL_COMP      => \%tio_01_01626_def,
   XCE_PPB1_PCAP_COMP       => \%tio_01_01627_def,
   XCE_PPB1_DCAP_COMP       => \%tio_01_01628_def,
   XCE_PPB1_DCON_COMP       => \%tio_01_01629_def,
   XCE_PPB1_DSTAT_COMP      => \%tio_01_01630_def,
   XCE_PPB1_LCAP_COMP       => \%tio_01_01631_def,
   XCE_PPB1_LCON_COMP       => \%tio_01_01632_def,
   XCE_PPB1_LSTAT_COMP      => \%tio_01_01633_def,
   XCE_PPB1_SCAP_COMP       => \%tio_01_01634_def,
   XCE_PPB1_SCON_COMP       => \%tio_01_01635_def,
   XCE_PPB1_SSTAT_COMP      => \%tio_01_01636_def,
   XCE_PPB1_RCON_COMP       => \%tio_01_01637_def,
   XCE_PPB1_RSTAT_COMP      => \%tio_01_01638_def,
   XCE_PPB2_ID_COMP         => \%tio_01_01639_def,
   XCE_PPB2_CMD_COMP        => \%tio_01_01640_def,
   XCE_PPB2_STAT_COMP       => \%tio_01_01641_def,
   XCE_PPB2_CCR_COMP        => \%tio_01_01642_def,
   XCE_PPB2_CLS_COMP        => \%tio_01_01643_def,
   XCE_PPB2_HTR_COMP        => \%tio_01_01644_def,
   XCE_PPB2_BUS_ID_COMP     => \%tio_01_01645_def,
   XCE_PPB2_IOLB_COMP       => \%tio_01_01646_def,
   XCE_PPB2_SECSTAT_COMP    => \%tio_01_01647_def,
   XCE_PPB2_MEMLIMIT_COMP   => \%tio_01_01648_def,
   XCE_PPB2_PMEMLIMIT_COMP  => \%tio_01_01649_def,
   XCE_PPB2_PMEMUBASE_COMP  => \%tio_01_01650_def,
   XCE_PPB2_PMEMULIMIT_COMP => \%tio_01_01651_def,
   XCE_PPB2_IOULB_COMP      => \%tio_01_01652_def,
   XCE_PPB2_CPTR_COMP       => \%tio_01_01653_def,
   XCE_PPB2_BCTRL_COMP      => \%tio_01_01654_def,
   XCE_PPB2_PCAP_COMP       => \%tio_01_01655_def,
   XCE_PPB2_DCAP_COMP       => \%tio_01_01656_def,
   XCE_PPB2_DCON_COMP       => \%tio_01_01657_def,
   XCE_PPB2_DSTAT_COMP      => \%tio_01_01658_def,
   XCE_PPB2_LCAP_COMP       => \%tio_01_01659_def,
   XCE_PPB2_LCON_COMP       => \%tio_01_01660_def,
   XCE_PPB2_LSTAT_COMP      => \%tio_01_01661_def,
   XCE_PPB2_SCAP_COMP       => \%tio_01_01662_def,
   XCE_PPB2_SCON_COMP       => \%tio_01_01663_def,
   XCE_PPB2_SSTAT_COMP      => \%tio_01_01664_def,
   XCE_PPB2_RCON_COMP       => \%tio_01_01665_def,
   XCE_PPB2_RSTAT_COMP      => \%tio_01_01666_def,
);

%tio_01_mmr_by_addr = 
(
   0x00000000B0000000 => \%tio_01_00000_def,
   0x00000000B0000008 => \%tio_01_00001_def,
   0x00000000B0000010 => \%tio_01_00002_def,
   0x00000000B0000018 => \%tio_01_00003_def,
   0x00000000B0000020 => \%tio_01_00004_def,
   0x00000000B0000028 => \%tio_01_00005_def,
   0x00000000B00000E0 => \%tio_01_00006_def,
   0x00000000B00000E8 => \%tio_01_00007_def,
   0x00000000B00000F0 => \%tio_01_00008_def,
   0x00000000B00000F8 => \%tio_01_00009_def,
   0x00000000B0000100 => \%tio_01_00010_def,
   0x00000000B0000108 => \%tio_01_00011_def,
   0x00000000B0000110 => \%tio_01_00012_def,
   0x00000000B0000118 => \%tio_01_00013_def,
   0x00000000B0002000 => \%tio_01_00014_def,
   0x00000000B0002008 => \%tio_01_00015_def,
   0x00000000B0002020 => \%tio_01_00016_def,
   0x00000000B0002040 => \%tio_01_00017_def,
   0x00000000B0002048 => \%tio_01_00018_def,
   0x00000000B00020C0 => \%tio_01_00019_def,
   0x00000000B00020C8 => \%tio_01_00020_def,
   0x00000000B00020D0 => \%tio_01_00021_def,
   0x00000000B00020D8 => \%tio_01_00022_def,
   0x00000000B00020F8 => \%tio_01_00023_def,
   0x00000000B0002100 => \%tio_01_00024_def,
   0x00000000B0002108 => \%tio_01_00025_def,
   0x00000000B0002110 => \%tio_01_00026_def,
   0x00000000B0002118 => \%tio_01_00027_def,
   0x00000000B0002120 => \%tio_01_00028_def,
   0x00000000B0002128 => \%tio_01_00029_def,
   0x00000000B0002130 => \%tio_01_00030_def,
   0x00000000B0002140 => \%tio_01_00031_def,
   0x00000000B0002148 => \%tio_01_00032_def,
   0x00000000B0002150 => \%tio_01_00033_def,
   0x00000000B0002158 => \%tio_01_00034_def,
   0x00000000B0002160 => \%tio_01_00035_def,
   0x00000000B0002168 => \%tio_01_00036_def,
   0x00000000B0002180 => \%tio_01_00037_def,
   0x00000000B0002188 => \%tio_01_00038_def,
   0x00000000B0002190 => \%tio_01_00039_def,
   0x00000000B0002198 => \%tio_01_00040_def,
   0x00000000B0002200 => \%tio_01_00041_def,
   0x00000000B0002208 => \%tio_01_00042_def,
   0x00000000B0002210 => \%tio_01_00043_def,
   0x00000000B0002218 => \%tio_01_00044_def,
   0x00000000B0004000 => \%tio_01_00045_def,
   0x00000000B0004008 => \%tio_01_00046_def,
   0x00000000B0004020 => \%tio_01_00047_def,
   0x00000000B0004040 => \%tio_01_00048_def,
   0x00000000B0004048 => \%tio_01_00049_def,
   0x00000000B0004060 => \%tio_01_00050_def,
   0x00000000B0004068 => \%tio_01_00051_def,
   0x00000000B00040F8 => \%tio_01_00052_def,
   0x00000000B0004100 => \%tio_01_00053_def,
   0x00000000B0004108 => \%tio_01_00054_def,
   0x00000000B0004110 => \%tio_01_00055_def,
   0x00000000B0004118 => \%tio_01_00056_def,
   0x00000000B0004120 => \%tio_01_00057_def,
   0x00000000B0004800 => \%tio_01_00058_def,
   0x00000000B0004810 => \%tio_01_00059_def,
   0x00000000B0004820 => \%tio_01_00060_def,
   0x00000000B0004830 => \%tio_01_00061_def,
   0x00000000B0004840 => \%tio_01_00062_def,
   0x00000000B0004850 => \%tio_01_00063_def,
   0x00000000B0004860 => \%tio_01_00064_def,
   0x00000000B0004870 => \%tio_01_00065_def,
   0x00000000B0004880 => \%tio_01_00066_def,
   0x00000000B0004890 => \%tio_01_00067_def,
   0x00000000B00048A0 => \%tio_01_00068_def,
   0x00000000B00048B0 => \%tio_01_00069_def,
   0x00000000B00048C0 => \%tio_01_00070_def,
   0x00000000B00048D0 => \%tio_01_00071_def,
   0x00000000B00048E0 => \%tio_01_00072_def,
   0x00000000B00048F0 => \%tio_01_00073_def,
   0x00000000B0004900 => \%tio_01_00074_def,
   0x00000000B0004910 => \%tio_01_00075_def,
   0x00000000B0004920 => \%tio_01_00076_def,
   0x00000000B0004930 => \%tio_01_00077_def,
   0x00000000B0004940 => \%tio_01_00078_def,
   0x00000000B0004950 => \%tio_01_00079_def,
   0x00000000B0004960 => \%tio_01_00080_def,
   0x00000000B0004970 => \%tio_01_00081_def,
   0x00000000B0004980 => \%tio_01_00082_def,
   0x00000000B0004990 => \%tio_01_00083_def,
   0x00000000B00049A0 => \%tio_01_00084_def,
   0x00000000B00049B0 => \%tio_01_00085_def,
   0x00000000B00049C0 => \%tio_01_00086_def,
   0x00000000B00049D0 => \%tio_01_00087_def,
   0x00000000B00049E0 => \%tio_01_00088_def,
   0x00000000B00049F0 => \%tio_01_00089_def,
   0x00000000B0004808 => \%tio_01_00090_def,
   0x00000000B0004818 => \%tio_01_00091_def,
   0x00000000B0004828 => \%tio_01_00092_def,
   0x00000000B0004838 => \%tio_01_00093_def,
   0x00000000B0004848 => \%tio_01_00094_def,
   0x00000000B0004858 => \%tio_01_00095_def,
   0x00000000B0004868 => \%tio_01_00096_def,
   0x00000000B0004878 => \%tio_01_00097_def,
   0x00000000B0004888 => \%tio_01_00098_def,
   0x00000000B0004898 => \%tio_01_00099_def,
   0x00000000B00048A8 => \%tio_01_00100_def,
   0x00000000B00048B8 => \%tio_01_00101_def,
   0x00000000B00048C8 => \%tio_01_00102_def,
   0x00000000B00048D8 => \%tio_01_00103_def,
   0x00000000B00048E8 => \%tio_01_00104_def,
   0x00000000B00048F8 => \%tio_01_00105_def,
   0x00000000B0004908 => \%tio_01_00106_def,
   0x00000000B0004918 => \%tio_01_00107_def,
   0x00000000B0004928 => \%tio_01_00108_def,
   0x00000000B0004938 => \%tio_01_00109_def,
   0x00000000B0004948 => \%tio_01_00110_def,
   0x00000000B0004958 => \%tio_01_00111_def,
   0x00000000B0004968 => \%tio_01_00112_def,
   0x00000000B0004978 => \%tio_01_00113_def,
   0x00000000B0004988 => \%tio_01_00114_def,
   0x00000000B0004998 => \%tio_01_00115_def,
   0x00000000B00049A8 => \%tio_01_00116_def,
   0x00000000B00049B8 => \%tio_01_00117_def,
   0x00000000B00049C8 => \%tio_01_00118_def,
   0x00000000B00049D8 => \%tio_01_00119_def,
   0x00000000B00049E8 => \%tio_01_00120_def,
   0x00000000B00049F8 => \%tio_01_00121_def,
   0x00000000B0006000 => \%tio_01_00122_def,
   0x00000000B0006008 => \%tio_01_00123_def,
   0x00000000B0006020 => \%tio_01_00124_def,
   0x00000000B0006040 => \%tio_01_00125_def,
   0x00000000B0006048 => \%tio_01_00126_def,
   0x00000000B0006060 => \%tio_01_00127_def,
   0x00000000B0006068 => \%tio_01_00128_def,
   0x00000000B00060F8 => \%tio_01_00129_def,
   0x00000000B0006100 => \%tio_01_00130_def,
   0x00000000B0006108 => \%tio_01_00131_def,
   0x00000000B0006118 => \%tio_01_00132_def,
   0x00000000B0006120 => \%tio_01_00133_def,
   0x00000000B0006128 => \%tio_01_00134_def,
   0x00000000B0006800 => \%tio_01_00135_def,
   0x00000000B0006810 => \%tio_01_00136_def,
   0x00000000B0006820 => \%tio_01_00137_def,
   0x00000000B0006830 => \%tio_01_00138_def,
   0x00000000B0006840 => \%tio_01_00139_def,
   0x00000000B0006850 => \%tio_01_00140_def,
   0x00000000B0006860 => \%tio_01_00141_def,
   0x00000000B0006870 => \%tio_01_00142_def,
   0x00000000B0006880 => \%tio_01_00143_def,
   0x00000000B0006890 => \%tio_01_00144_def,
   0x00000000B00068A0 => \%tio_01_00145_def,
   0x00000000B00068B0 => \%tio_01_00146_def,
   0x00000000B00068C0 => \%tio_01_00147_def,
   0x00000000B00068D0 => \%tio_01_00148_def,
   0x00000000B00068E0 => \%tio_01_00149_def,
   0x00000000B00068F0 => \%tio_01_00150_def,
   0x00000000B0006900 => \%tio_01_00151_def,
   0x00000000B0006910 => \%tio_01_00152_def,
   0x00000000B0006920 => \%tio_01_00153_def,
   0x00000000B0006930 => \%tio_01_00154_def,
   0x00000000B0006940 => \%tio_01_00155_def,
   0x00000000B0006950 => \%tio_01_00156_def,
   0x00000000B0006960 => \%tio_01_00157_def,
   0x00000000B0006970 => \%tio_01_00158_def,
   0x00000000B0006980 => \%tio_01_00159_def,
   0x00000000B0006990 => \%tio_01_00160_def,
   0x00000000B00069A0 => \%tio_01_00161_def,
   0x00000000B00069B0 => \%tio_01_00162_def,
   0x00000000B00069C0 => \%tio_01_00163_def,
   0x00000000B00069D0 => \%tio_01_00164_def,
   0x00000000B00069E0 => \%tio_01_00165_def,
   0x00000000B00069F0 => \%tio_01_00166_def,
   0x00000000B0006A00 => \%tio_01_00167_def,
   0x00000000B0006A10 => \%tio_01_00168_def,
   0x00000000B0006A20 => \%tio_01_00169_def,
   0x00000000B0006A30 => \%tio_01_00170_def,
   0x00000000B0006A40 => \%tio_01_00171_def,
   0x00000000B0006A50 => \%tio_01_00172_def,
   0x00000000B0006A60 => \%tio_01_00173_def,
   0x00000000B0006A70 => \%tio_01_00174_def,
   0x00000000B0006A80 => \%tio_01_00175_def,
   0x00000000B0006A90 => \%tio_01_00176_def,
   0x00000000B0006AA0 => \%tio_01_00177_def,
   0x00000000B0006AB0 => \%tio_01_00178_def,
   0x00000000B0006AC0 => \%tio_01_00179_def,
   0x00000000B0006AD0 => \%tio_01_00180_def,
   0x00000000B0006AE0 => \%tio_01_00181_def,
   0x00000000B0006AF0 => \%tio_01_00182_def,
   0x00000000B0006B00 => \%tio_01_00183_def,
   0x00000000B0006B10 => \%tio_01_00184_def,
   0x00000000B0006B20 => \%tio_01_00185_def,
   0x00000000B0006B30 => \%tio_01_00186_def,
   0x00000000B0006B40 => \%tio_01_00187_def,
   0x00000000B0006B50 => \%tio_01_00188_def,
   0x00000000B0006B60 => \%tio_01_00189_def,
   0x00000000B0006B70 => \%tio_01_00190_def,
   0x00000000B0006B80 => \%tio_01_00191_def,
   0x00000000B0006B90 => \%tio_01_00192_def,
   0x00000000B0006BA0 => \%tio_01_00193_def,
   0x00000000B0006BB0 => \%tio_01_00194_def,
   0x00000000B0006BC0 => \%tio_01_00195_def,
   0x00000000B0006BD0 => \%tio_01_00196_def,
   0x00000000B0006BE0 => \%tio_01_00197_def,
   0x00000000B0006BF0 => \%tio_01_00198_def,
   0x00000000B0006808 => \%tio_01_00199_def,
   0x00000000B0006818 => \%tio_01_00200_def,
   0x00000000B0006828 => \%tio_01_00201_def,
   0x00000000B0006838 => \%tio_01_00202_def,
   0x00000000B0006848 => \%tio_01_00203_def,
   0x00000000B0006858 => \%tio_01_00204_def,
   0x00000000B0006868 => \%tio_01_00205_def,
   0x00000000B0006878 => \%tio_01_00206_def,
   0x00000000B0006888 => \%tio_01_00207_def,
   0x00000000B0006898 => \%tio_01_00208_def,
   0x00000000B00068A8 => \%tio_01_00209_def,
   0x00000000B00068B8 => \%tio_01_00210_def,
   0x00000000B00068C8 => \%tio_01_00211_def,
   0x00000000B00068D8 => \%tio_01_00212_def,
   0x00000000B00068E8 => \%tio_01_00213_def,
   0x00000000B00068F8 => \%tio_01_00214_def,
   0x00000000B0006908 => \%tio_01_00215_def,
   0x00000000B0006918 => \%tio_01_00216_def,
   0x00000000B0006928 => \%tio_01_00217_def,
   0x00000000B0006938 => \%tio_01_00218_def,
   0x00000000B0006948 => \%tio_01_00219_def,
   0x00000000B0006958 => \%tio_01_00220_def,
   0x00000000B0006968 => \%tio_01_00221_def,
   0x00000000B0006978 => \%tio_01_00222_def,
   0x00000000B0006988 => \%tio_01_00223_def,
   0x00000000B0006998 => \%tio_01_00224_def,
   0x00000000B00069A8 => \%tio_01_00225_def,
   0x00000000B00069B8 => \%tio_01_00226_def,
   0x00000000B00069C8 => \%tio_01_00227_def,
   0x00000000B00069D8 => \%tio_01_00228_def,
   0x00000000B00069E8 => \%tio_01_00229_def,
   0x00000000B00069F8 => \%tio_01_00230_def,
   0x00000000B0006A08 => \%tio_01_00231_def,
   0x00000000B0006A18 => \%tio_01_00232_def,
   0x00000000B0006A28 => \%tio_01_00233_def,
   0x00000000B0006A38 => \%tio_01_00234_def,
   0x00000000B0006A48 => \%tio_01_00235_def,
   0x00000000B0006A58 => \%tio_01_00236_def,
   0x00000000B0006A68 => \%tio_01_00237_def,
   0x00000000B0006A78 => \%tio_01_00238_def,
   0x00000000B0006A88 => \%tio_01_00239_def,
   0x00000000B0006A98 => \%tio_01_00240_def,
   0x00000000B0006AA8 => \%tio_01_00241_def,
   0x00000000B0006AB8 => \%tio_01_00242_def,
   0x00000000B0006AC8 => \%tio_01_00243_def,
   0x00000000B0006AD8 => \%tio_01_00244_def,
   0x00000000B0006AE8 => \%tio_01_00245_def,
   0x00000000B0006AF8 => \%tio_01_00246_def,
   0x00000000B0006B08 => \%tio_01_00247_def,
   0x00000000B0006B18 => \%tio_01_00248_def,
   0x00000000B0006B28 => \%tio_01_00249_def,
   0x00000000B0006B38 => \%tio_01_00250_def,
   0x00000000B0006B48 => \%tio_01_00251_def,
   0x00000000B0006B58 => \%tio_01_00252_def,
   0x00000000B0006B68 => \%tio_01_00253_def,
   0x00000000B0006B78 => \%tio_01_00254_def,
   0x00000000B0006B88 => \%tio_01_00255_def,
   0x00000000B0006B98 => \%tio_01_00256_def,
   0x00000000B0006BA8 => \%tio_01_00257_def,
   0x00000000B0006BB8 => \%tio_01_00258_def,
   0x00000000B0006BC8 => \%tio_01_00259_def,
   0x00000000B0006BD8 => \%tio_01_00260_def,
   0x00000000B0006BE8 => \%tio_01_00261_def,
   0x00000000B0006BF8 => \%tio_01_00262_def,
   0x00000000B0008000 => \%tio_01_00263_def,
   0x00000000B0008008 => \%tio_01_00264_def,
   0x00000000B0008020 => \%tio_01_00265_def,
   0x00000000B0008040 => \%tio_01_00266_def,
   0x00000000B0008048 => \%tio_01_00267_def,
   0x00000000B0008050 => \%tio_01_00268_def,
   0x00000000B0008058 => \%tio_01_00269_def,
   0x00000000B0008060 => \%tio_01_00270_def,
   0x00000000B00080F8 => \%tio_01_00271_def,
   0x00000000B0008100 => \%tio_01_00272_def,
   0x00000000B0008128 => \%tio_01_00273_def,
   0x00000000B0008108 => \%tio_01_00274_def,
   0x00000000B0008110 => \%tio_01_00275_def,
   0x00000000B0008118 => \%tio_01_00276_def,
   0x00000000B0008120 => \%tio_01_00277_def,
   0x00000000B0008200 => \%tio_01_00278_def,
   0x00000000B0008210 => \%tio_01_00279_def,
   0x00000000B0008220 => \%tio_01_00280_def,
   0x00000000B0008230 => \%tio_01_00281_def,
   0x00000000B0008240 => \%tio_01_00282_def,
   0x00000000B0008250 => \%tio_01_00283_def,
   0x00000000B0008260 => \%tio_01_00284_def,
   0x00000000B0008270 => \%tio_01_00285_def,
   0x00000000B0008280 => \%tio_01_00286_def,
   0x00000000B0008290 => \%tio_01_00287_def,
   0x00000000B00082A0 => \%tio_01_00288_def,
   0x00000000B00082B0 => \%tio_01_00289_def,
   0x00000000B00082C0 => \%tio_01_00290_def,
   0x00000000B00082D0 => \%tio_01_00291_def,
   0x00000000B00082E0 => \%tio_01_00292_def,
   0x00000000B00082F0 => \%tio_01_00293_def,
   0x00000000B0008300 => \%tio_01_00294_def,
   0x00000000B0008310 => \%tio_01_00295_def,
   0x00000000B0008320 => \%tio_01_00296_def,
   0x00000000B0008330 => \%tio_01_00297_def,
   0x00000000B0008340 => \%tio_01_00298_def,
   0x00000000B0008350 => \%tio_01_00299_def,
   0x00000000B0008360 => \%tio_01_00300_def,
   0x00000000B0008370 => \%tio_01_00301_def,
   0x00000000B0008380 => \%tio_01_00302_def,
   0x00000000B0008390 => \%tio_01_00303_def,
   0x00000000B00083A0 => \%tio_01_00304_def,
   0x00000000B00083B0 => \%tio_01_00305_def,
   0x00000000B00083C0 => \%tio_01_00306_def,
   0x00000000B00083D0 => \%tio_01_00307_def,
   0x00000000B00083E0 => \%tio_01_00308_def,
   0x00000000B00083F0 => \%tio_01_00309_def,
   0x00000000B0008800 => \%tio_01_00310_def,
   0x00000000B0008808 => \%tio_01_00311_def,
   0x00000000B0008810 => \%tio_01_00312_def,
   0x00000000B0008818 => \%tio_01_00313_def,
   0x00000000B0008820 => \%tio_01_00314_def,
   0x00000000B0008828 => \%tio_01_00315_def,
   0x00000000B0008830 => \%tio_01_00316_def,
   0x00000000B0008838 => \%tio_01_00317_def,
   0x00000000B0008840 => \%tio_01_00318_def,
   0x00000000B0008848 => \%tio_01_00319_def,
   0x00000000B0008850 => \%tio_01_00320_def,
   0x00000000B0008858 => \%tio_01_00321_def,
   0x00000000B0008860 => \%tio_01_00322_def,
   0x00000000B0008868 => \%tio_01_00323_def,
   0x00000000B0008870 => \%tio_01_00324_def,
   0x00000000B0008878 => \%tio_01_00325_def,
   0x00000000B0008880 => \%tio_01_00326_def,
   0x00000000B0008888 => \%tio_01_00327_def,
   0x00000000B0008890 => \%tio_01_00328_def,
   0x00000000B0008898 => \%tio_01_00329_def,
   0x00000000B00088A0 => \%tio_01_00330_def,
   0x00000000B00088A8 => \%tio_01_00331_def,
   0x00000000B00088B0 => \%tio_01_00332_def,
   0x00000000B00088B8 => \%tio_01_00333_def,
   0x00000000B00088C0 => \%tio_01_00334_def,
   0x00000000B0009000 => \%tio_01_00335_def,
   0x00000000B0009008 => \%tio_01_00336_def,
   0x00000000B0009010 => \%tio_01_00337_def,
   0x00000000B0009018 => \%tio_01_00338_def,
   0x00000000B0009020 => \%tio_01_00339_def,
   0x00000000B0009028 => \%tio_01_00340_def,
   0x00000000B0009030 => \%tio_01_00341_def,
   0x00000000B0009038 => \%tio_01_00342_def,
   0x00000000B0009040 => \%tio_01_00343_def,
   0x00000000B0009048 => \%tio_01_00344_def,
   0x00000000B0009050 => \%tio_01_00345_def,
   0x00000000B0009058 => \%tio_01_00346_def,
   0x00000000B0009060 => \%tio_01_00347_def,
   0x00000000B000A000 => \%tio_01_00348_def,
   0x00000000B000A008 => \%tio_01_00349_def,
   0x00000000B000A020 => \%tio_01_00350_def,
   0x00000000B000A060 => \%tio_01_00351_def,
   0x00000000B000A068 => \%tio_01_00352_def,
   0x00000000B000A0C0 => \%tio_01_00353_def,
   0x00000000B000A0C8 => \%tio_01_00354_def,
   0x00000000B000A0D0 => \%tio_01_00355_def,
   0x00000000B000A0D8 => \%tio_01_00356_def,
   0x00000000B000A0F8 => \%tio_01_00357_def,
   0x00000000B000A100 => \%tio_01_00358_def,
   0x00000000B000A108 => \%tio_01_00359_def,
   0x00000000B000A110 => \%tio_01_00360_def,
   0x00000000B000A118 => \%tio_01_00361_def,
   0x00000000B000A120 => \%tio_01_00362_def,
   0x00000000B000A128 => \%tio_01_00363_def,
   0x00000000B000B000 => \%tio_01_00364_def,
   0x00000000B000B008 => \%tio_01_00365_def,
   0x00000000B000B010 => \%tio_01_00366_def,
   0x00000000B000B018 => \%tio_01_00367_def,
   0x00000000B000B020 => \%tio_01_00368_def,
   0x00000000B000B100 => \%tio_01_00369_def,
   0x00000000B000B108 => \%tio_01_00370_def,
   0x00000000B000B110 => \%tio_01_00371_def,
   0x00000000B000B800 => \%tio_01_00372_def,
   0x00000000B000BA00 => \%tio_01_00373_def,
   0x00000000B000BC00 => \%tio_01_00374_def,
   0x00000000B000BE00 => \%tio_01_00375_def,
   0x00000000B000B808 => \%tio_01_00376_def,
   0x00000000B000BA08 => \%tio_01_00377_def,
   0x00000000B000BC08 => \%tio_01_00378_def,
   0x00000000B000BE08 => \%tio_01_00379_def,
   0x00000000B000B810 => \%tio_01_00380_def,
   0x00000000B000BA10 => \%tio_01_00381_def,
   0x00000000B000BC10 => \%tio_01_00382_def,
   0x00000000B000BE10 => \%tio_01_00383_def,
   0x00000000B000B818 => \%tio_01_00384_def,
   0x00000000B000BA18 => \%tio_01_00385_def,
   0x00000000B000BC18 => \%tio_01_00386_def,
   0x00000000B000BE18 => \%tio_01_00387_def,
   0x00000000B000E000 => \%tio_01_00388_def,
   0x00000000B000E008 => \%tio_01_00389_def,
   0x00000000B000E010 => \%tio_01_00390_def,
   0x00000000B000E018 => \%tio_01_00391_def,
   0x00000000B000E020 => \%tio_01_00392_def,
   0x00000000B000E0F8 => \%tio_01_00393_def,
   0x00000000B000E100 => \%tio_01_00394_def,
   0x00000000B000E108 => \%tio_01_00395_def,
   0x00000000B000E110 => \%tio_01_00396_def,
   0x00000000B000E118 => \%tio_01_00397_def,
   0x00000000B000E120 => \%tio_01_00398_def,
   0x00000000B000E128 => \%tio_01_00399_def,
   0x00000000B000E130 => \%tio_01_00400_def,
   0x00000000B000E138 => \%tio_01_00401_def,
   0x00000000B000E140 => \%tio_01_00402_def,
   0x00000000B000E148 => \%tio_01_00403_def,
   0x00000000B000E150 => \%tio_01_00404_def,
   0x00000000B000E158 => \%tio_01_00405_def,
   0x00000000B000E160 => \%tio_01_00406_def,
   0x00000000B000E168 => \%tio_01_00407_def,
   0x00000000B000E170 => \%tio_01_00408_def,
   0x00000000B000E178 => \%tio_01_00409_def,
   0x00000000B000E180 => \%tio_01_00410_def,
   0x00000000B000E188 => \%tio_01_00411_def,
   0x00000000B000E190 => \%tio_01_00412_def,
   0x00000000B000E198 => \%tio_01_00413_def,
   0x0000000090040000 => \%tio_01_00414_def,
   0x0000000090040080 => \%tio_01_00415_def,
   0x0000000090040100 => \%tio_01_00416_def,
   0x0000000090040180 => \%tio_01_00417_def,
   0x0000000090040200 => \%tio_01_00418_def,
   0x0000000090050000 => \%tio_01_00419_def,
   0x0000000090050080 => \%tio_01_00420_def,
   0x0000000090050100 => \%tio_01_00421_def,
   0x0000000090050180 => \%tio_01_00422_def,
   0x0000000090050200 => \%tio_01_00423_def,
   0x0000000090050280 => \%tio_01_00424_def,
   0x0000000090050300 => \%tio_01_00425_def,
   0x0000000090050380 => \%tio_01_00426_def,
   0x0000000090050400 => \%tio_01_00427_def,
   0x0000000090050480 => \%tio_01_00428_def,
   0x0000000090050500 => \%tio_01_00429_def,
   0x0000000090050508 => \%tio_01_00430_def,
   0x0000000090050580 => \%tio_01_00431_def,
   0x0000000090050588 => \%tio_01_00432_def,
   0x0000000090050600 => \%tio_01_00433_def,
   0x0000000090050680 => \%tio_01_00434_def,
   0x0000000090050780 => \%tio_01_00435_def,
   0x0000000090050800 => \%tio_01_00436_def,
   0x0000000090062000 => \%tio_01_00437_def,
   0x0000000090062080 => \%tio_01_00438_def,
   0x0000000090062100 => \%tio_01_00439_def,
   0x0000000090062180 => \%tio_01_00440_def,
   0x0000000090062200 => \%tio_01_00441_def,
   0x0000000090062280 => \%tio_01_00442_def,
   0x0000000090063000 => \%tio_01_00443_def,
   0x0000000090063080 => \%tio_01_00444_def,
   0x0000000090063100 => \%tio_01_00445_def,
   0x0000000090063180 => \%tio_01_00446_def,
   0x0000000090063200 => \%tio_01_00447_def,
   0x0000000090063280 => \%tio_01_00448_def,
   0x0000000090063300 => \%tio_01_00449_def,
   0x0000000090063380 => \%tio_01_00450_def,
   0x0000000090063400 => \%tio_01_00451_def,
   0x0000000090063480 => \%tio_01_00452_def,
   0x0000000090063500 => \%tio_01_00453_def,
   0x0000000090063580 => \%tio_01_00454_def,
   0x0000000090063600 => \%tio_01_00455_def,
   0x0000000090063680 => \%tio_01_00456_def,
   0x0000000090063700 => \%tio_01_00457_def,
   0x0000000090063780 => \%tio_01_00458_def,
   0x0000000090063800 => \%tio_01_00459_def,
   0x0000000090063880 => \%tio_01_00460_def,
   0x0000000090063900 => \%tio_01_00461_def,
   0x0000000090063980 => \%tio_01_00462_def,
   0x0000000090063A00 => \%tio_01_00463_def,
   0x0000000090064000 => \%tio_01_00464_def,
   0x0000000090064080 => \%tio_01_00465_def,
   0x0000000090064100 => \%tio_01_00466_def,
   0x0000000090064180 => \%tio_01_00467_def,
   0x0000000090064200 => \%tio_01_00468_def,
   0x0000000090064280 => \%tio_01_00469_def,
   0x0000000090064300 => \%tio_01_00470_def,
   0x0000000090064380 => \%tio_01_00471_def,
   0x0000000090064400 => \%tio_01_00472_def,
   0x0000000090065000 => \%tio_01_00473_def,
   0x0000000090065080 => \%tio_01_00474_def,
   0x0000000090066000 => \%tio_01_00475_def,
   0x0000000090066080 => \%tio_01_00476_def,
   0x0000000090066100 => \%tio_01_00477_def,
   0x0000000090066180 => \%tio_01_00478_def,
   0x0000000090066200 => \%tio_01_00479_def,
   0x0000000090066280 => \%tio_01_00480_def,
   0x0000000090066300 => \%tio_01_00481_def,
   0x0000000090066380 => \%tio_01_00482_def,
   0x0000000090066400 => \%tio_01_00483_def,
   0x0000000090066480 => \%tio_01_00484_def,
   0x0000000090067000 => \%tio_01_00485_def,
   0x0000000090067080 => \%tio_01_00486_def,
   0x0000000090067100 => \%tio_01_00487_def,
   0x0000000090060000 => \%tio_01_00488_def,
   0x0000000090060080 => \%tio_01_00489_def,
   0x0000000090060100 => \%tio_01_00490_def,
   0x0000000090060180 => \%tio_01_00491_def,
   0x0000000090060200 => \%tio_01_00492_def,
   0x0000000090060280 => \%tio_01_00493_def,
   0x0000000090060300 => \%tio_01_00494_def,
   0x0000000090060380 => \%tio_01_00495_def,
   0x0000000090060400 => \%tio_01_00496_def,
   0x0000000090060480 => \%tio_01_00497_def,
   0x0000000090060680 => \%tio_01_00498_def,
   0x0000000090060700 => \%tio_01_00499_def,
   0x0000000090060780 => \%tio_01_00500_def,
   0x0000000090060800 => \%tio_01_00501_def,
   0x0000000090060880 => \%tio_01_00502_def,
   0x0000000090060900 => \%tio_01_00503_def,
   0x0000000090060980 => \%tio_01_00504_def,
   0x0000000090060A00 => \%tio_01_00505_def,
   0x0000000090060A80 => \%tio_01_00506_def,
   0x0000000090060B00 => \%tio_01_00507_def,
   0x0000000090060B80 => \%tio_01_00508_def,
   0x0000000090060E00 => \%tio_01_00509_def,
   0x0000000090060E80 => \%tio_01_00510_def,
   0x0000000090061100 => \%tio_01_00511_def,
   0x0000000090068000 => \%tio_01_00512_def,
   0x0000000090068080 => \%tio_01_00513_def,
   0x0000000090068100 => \%tio_01_00514_def,
   0x0000000090071000 => \%tio_01_00515_def,
   0x0000000090071100 => \%tio_01_00516_def,
   0x0000000090071380 => \%tio_01_00517_def,
   0x0000000090071880 => \%tio_01_00518_def,
   0x0000000090071900 => \%tio_01_00519_def,
   0x0000000090071980 => \%tio_01_00520_def,
   0x0000000090071A00 => \%tio_01_00521_def,
   0x0000000090072000 => \%tio_01_00522_def,
   0x0000000090072080 => \%tio_01_00523_def,
   0x0000000090072180 => \%tio_01_00524_def,
   0x0000000090072280 => \%tio_01_00525_def,
   0x0000000090072300 => \%tio_01_00526_def,
   0x0000000090072800 => \%tio_01_00527_def,
   0x0000000090072880 => \%tio_01_00528_def,
   0x0000000090072900 => \%tio_01_00529_def,
   0x0000000090073000 => \%tio_01_00530_def,
   0x0000000090073080 => \%tio_01_00531_def,
   0x0000000090073100 => \%tio_01_00532_def,
   0x0000000090074000 => \%tio_01_00533_def,
   0x0000000090074080 => \%tio_01_00534_def,
   0x0000000090074100 => \%tio_01_00535_def,
   0x0000000090074108 => \%tio_01_00536_def,
   0x0000000090075000 => \%tio_01_00537_def,
   0x0000000090077000 => \%tio_01_00538_def,
   0x0000000090080000 => \%tio_01_00539_def,
   0x0000000090090000 => \%tio_01_00540_def,
   0x00000000900A0000 => \%tio_01_00541_def,
   0x00000000900B0000 => \%tio_01_00542_def,
   0x00000000900C0000 => \%tio_01_00543_def,
   0x00000000900D0000 => \%tio_01_00544_def,
   0x00000000900E0000 => \%tio_01_00545_def,
   0x00000000900F0000 => \%tio_01_00546_def,
   0x0000000090100000 => \%tio_01_00547_def,
   0x0000000090100080 => \%tio_01_00548_def,
   0x0000000090100100 => \%tio_01_00549_def,
   0x0000000090100180 => \%tio_01_00550_def,
   0x0000000090101000 => \%tio_01_00551_def,
   0x0000000090110000 => \%tio_01_00552_def,
   0x0000000090120000 => \%tio_01_00553_def,
   0x0000000090130000 => \%tio_01_00554_def,
   0x0000000090140000 => \%tio_01_00555_def,
   0x0000000090150000 => \%tio_01_00556_def,
   0x0000000090160000 => \%tio_01_00557_def,
   0x0000000090170000 => \%tio_01_00558_def,
   0x0000000090180000 => \%tio_01_00559_def,
   0x0000000090190000 => \%tio_01_00560_def,
   0x0000000090190080 => \%tio_01_00561_def,
   0x00000000901C0000 => \%tio_01_00562_def,
   0x00000000901D0000 => \%tio_01_00563_def,
   0x00000000901D0008 => \%tio_01_00564_def,
   0x00000000901D0080 => \%tio_01_00565_def,
   0x00000000901D0088 => \%tio_01_00566_def,
   0x00000000901D0100 => \%tio_01_00567_def,
   0x00000000901D0108 => \%tio_01_00568_def,
   0x00000000901D0180 => \%tio_01_00569_def,
   0x00000000901D0188 => \%tio_01_00570_def,
   0x00000000901D0200 => \%tio_01_00571_def,
   0x00000000901D0208 => \%tio_01_00572_def,
   0x0000000090000300 => \%tio_01_00573_def,
   0x0000000090000480 => \%tio_01_00574_def,
   0x0000000090000500 => \%tio_01_00575_def,
   0x0000000090000580 => \%tio_01_00576_def,
   0x0000000090000600 => \%tio_01_00577_def,
   0x0000000090000680 => \%tio_01_00578_def,
   0x0000000090000700 => \%tio_01_00579_def,
   0x0000000090000780 => \%tio_01_00580_def,
   0x0000000090000800 => \%tio_01_00581_def,
   0x0000000090000880 => \%tio_01_00582_def,
   0x0000000090000900 => \%tio_01_00583_def,
   0x0000000090000980 => \%tio_01_00584_def,
   0x0000000090000A00 => \%tio_01_00585_def,
   0x0000000090001000 => \%tio_01_00586_def,
   0x0000000090001080 => \%tio_01_00587_def,
   0x0000000090001100 => \%tio_01_00588_def,
   0x0000000090001180 => \%tio_01_00589_def,
   0x0000000090001200 => \%tio_01_00590_def,
   0x0000000090001280 => \%tio_01_00591_def,
   0x0000000090001300 => \%tio_01_00592_def,
   0x0000000090001380 => \%tio_01_00593_def,
   0x0000000090001400 => \%tio_01_00594_def,
   0x0000000090001480 => \%tio_01_00595_def,
   0x0000000090001500 => \%tio_01_00596_def,
   0x0000000090001580 => \%tio_01_00597_def,
   0x0000000090001600 => \%tio_01_00598_def,
   0x0000000090001680 => \%tio_01_00599_def,
   0x0000000090001700 => \%tio_01_00600_def,
   0x0000000090001780 => \%tio_01_00601_def,
   0x0000000090001800 => \%tio_01_00602_def,
   0x0000000090001880 => \%tio_01_00603_def,
   0x0000000090001900 => \%tio_01_00604_def,
   0x0000000090001980 => \%tio_01_00605_def,
   0x0000000090001A00 => \%tio_01_00606_def,
   0x0000000090001A80 => \%tio_01_00607_def,
   0x0000000090001B00 => \%tio_01_00608_def,
   0x0000000090001B80 => \%tio_01_00609_def,
   0x0000000090010000 => \%tio_01_00610_def,
   0x0000000090010008 => \%tio_01_00611_def,
   0x0000000090010080 => \%tio_01_00612_def,
   0x0000000090010088 => \%tio_01_00613_def,
   0x0000000090038000 => \%tio_01_00614_def,
   0x0000000090038080 => \%tio_01_00615_def,
   0x0000000090038100 => \%tio_01_00616_def,
   0x0000000090038180 => \%tio_01_00617_def,
   0x00000000D0000000 => \%tio_01_00618_def,
   0x00000000D0000008 => \%tio_01_00619_def,
   0x00000000D0000010 => \%tio_01_00620_def,
   0x00000000D0000018 => \%tio_01_00621_def,
   0x00000000D0000020 => \%tio_01_00622_def,
   0x00000000D0000028 => \%tio_01_00623_def,
   0x00000000D0000030 => \%tio_01_00624_def,
   0x00000000D0000038 => \%tio_01_00625_def,
   0x00000000D0000040 => \%tio_01_00626_def,
   0x00000000D0000048 => \%tio_01_00627_def,
   0x00000000D0002000 => \%tio_01_00628_def,
   0x00000000D0002008 => \%tio_01_00629_def,
   0x00000000D0002010 => \%tio_01_00630_def,
   0x00000000D0002018 => \%tio_01_00631_def,
   0x00000000D0002020 => \%tio_01_00632_def,
   0x00000000D0002028 => \%tio_01_00633_def,
   0x00000000D0002030 => \%tio_01_00634_def,
   0x00000000D0002038 => \%tio_01_00635_def,
   0x00000000D0002040 => \%tio_01_00636_def,
   0x00000000D0002048 => \%tio_01_00637_def,
   0x00000000D0001030 => \%tio_01_00638_def,
   0x00000000D0001040 => \%tio_01_00639_def,
   0x00000000D0001050 => \%tio_01_00640_def,
   0x00000000D0001060 => \%tio_01_00641_def,
   0x00000000D0001070 => \%tio_01_00642_def,
   0x00000000D0003030 => \%tio_01_00643_def,
   0x00000000D0003040 => \%tio_01_00644_def,
   0x00000000D0003050 => \%tio_01_00645_def,
   0x00000000D0003060 => \%tio_01_00646_def,
   0x00000000D0003070 => \%tio_01_00647_def,
   0x00000000D0020000 => \%tio_01_00648_def,
   0x00000000D0020800 => \%tio_01_00649_def,
   0x00000000D0021000 => \%tio_01_00650_def,
   0x00000000D0024000 => \%tio_01_00651_def,
   0x00000000D0024800 => \%tio_01_00652_def,
   0x00000000D0025000 => \%tio_01_00653_def,
   0x00000000D0026000 => \%tio_01_00654_def,
   0x00000000D0026800 => \%tio_01_00655_def,
   0x00000000D0027000 => \%tio_01_00656_def,
   0x00000000D0030200 => \%tio_01_00657_def,
   0x00000000D0030210 => \%tio_01_00658_def,
   0x00000000D0030220 => \%tio_01_00659_def,
   0x00000000D0030230 => \%tio_01_00660_def,
   0x00000000D0030240 => \%tio_01_00661_def,
   0x00000000D0030250 => \%tio_01_00662_def,
   0x00000000D0030260 => \%tio_01_00663_def,
   0x00000000D00302B0 => \%tio_01_00664_def,
   0x00000000D00302C0 => \%tio_01_00665_def,
   0x00000000D00302D0 => \%tio_01_00666_def,
   0x00000000D0030300 => \%tio_01_00667_def,
   0x00000000D0030310 => \%tio_01_00668_def,
   0x00000000D0030320 => \%tio_01_00669_def,
   0x00000000D0030330 => \%tio_01_00670_def,
   0x00000000D0030340 => \%tio_01_00671_def,
   0x00000000D0030350 => \%tio_01_00672_def,
   0x00000000D0030360 => \%tio_01_00673_def,
   0x00000000D0030400 => \%tio_01_00674_def,
   0x00000000D0030450 => \%tio_01_00675_def,
   0x00000000D0030460 => \%tio_01_00676_def,
   0x00000000D0030470 => \%tio_01_00677_def,
   0x00000000D0030480 => \%tio_01_00678_def,
   0x00000000D0030490 => \%tio_01_00679_def,
   0x00000000D00304A0 => \%tio_01_00680_def,
   0x00000000D00304B0 => \%tio_01_00681_def,
   0x00000000D00304C0 => \%tio_01_00682_def,
   0x00000000D00304F0 => \%tio_01_00683_def,
   0x00000000D0030500 => \%tio_01_00684_def,
   0x00000000D0030510 => \%tio_01_00685_def,
   0x00000000D0030520 => \%tio_01_00686_def,
   0x00000000D0030530 => \%tio_01_00687_def,
   0x00000000D0030540 => \%tio_01_00688_def,
   0x00000000D0030550 => \%tio_01_00689_def,
   0x00000000D0030570 => \%tio_01_00690_def,
   0x00000000D0030600 => \%tio_01_00691_def,
   0x00000000D0030650 => \%tio_01_00692_def,
   0x00000000D0030660 => \%tio_01_00693_def,
   0x00000000D0030670 => \%tio_01_00694_def,
   0x00000000D0030680 => \%tio_01_00695_def,
   0x00000000D0030690 => \%tio_01_00696_def,
   0x00000000D00306A0 => \%tio_01_00697_def,
   0x00000000D00306B0 => \%tio_01_00698_def,
   0x00000000D00306C0 => \%tio_01_00699_def,
   0x00000000D00306F0 => \%tio_01_00700_def,
   0x00000000D0030700 => \%tio_01_00701_def,
   0x00000000D0030710 => \%tio_01_00702_def,
   0x00000000D0030720 => \%tio_01_00703_def,
   0x00000000D0030730 => \%tio_01_00704_def,
   0x00000000D0030740 => \%tio_01_00705_def,
   0x00000000D0030750 => \%tio_01_00706_def,
   0x00000000D0030770 => \%tio_01_00707_def,
   0x00000000D0031000 => \%tio_01_00708_def,
   0x00000000D0031020 => \%tio_01_00709_def,
   0x00000000D0031040 => \%tio_01_00710_def,
   0x00000000D0031050 => \%tio_01_00711_def,
   0x00000000D0031060 => \%tio_01_00712_def,
   0x00000000D0031100 => \%tio_01_00713_def,
   0x00000000D0031110 => \%tio_01_00714_def,
   0x00000000D0031120 => \%tio_01_00715_def,
   0x00000000D0031130 => \%tio_01_00716_def,
   0x00000000D0031140 => \%tio_01_00717_def,
   0x00000000D0031150 => \%tio_01_00718_def,
   0x00000000D0031160 => \%tio_01_00719_def,
   0x00000000D0031170 => \%tio_01_00720_def,
   0x00000000D0031280 => \%tio_01_00721_def,
   0x00000000D0031290 => \%tio_01_00722_def,
   0x00000000D00312A0 => \%tio_01_00723_def,
   0x00000000D00312B0 => \%tio_01_00724_def,
   0x00000000D00312C0 => \%tio_01_00725_def,
   0x00000000D00312D0 => \%tio_01_00726_def,
   0x00000000D00312E0 => \%tio_01_00727_def,
   0x00000000D00312F0 => \%tio_01_00728_def,
   0x00000000D00310C0 => \%tio_01_00729_def,
   0x00000000D0031700 => \%tio_01_00730_def,
   0x00000000D0031710 => \%tio_01_00731_def,
   0x00000000D0031720 => \%tio_01_00732_def,
   0x00000000D0031730 => \%tio_01_00733_def,
   0x00000000D00317C0 => \%tio_01_00734_def,
   0x00000000D00317D0 => \%tio_01_00735_def,
   0x00000000D00317E0 => \%tio_01_00736_def,
   0x00000000D00317F0 => \%tio_01_00737_def,
   0x00000000D0031800 => \%tio_01_00738_def,
   0x00000000D0031810 => \%tio_01_00739_def,
   0x00000000D0031820 => \%tio_01_00740_def,
   0x00000000D0031830 => \%tio_01_00741_def,
   0x00000000D00310E0 => \%tio_01_00742_def,
   0x00000000D0031900 => \%tio_01_00743_def,
   0x00000000D0031910 => \%tio_01_00744_def,
   0x00000000D0031920 => \%tio_01_00745_def,
   0x00000000D0031930 => \%tio_01_00746_def,
   0x00000000D00319C0 => \%tio_01_00747_def,
   0x00000000D00319D0 => \%tio_01_00748_def,
   0x00000000D00319E0 => \%tio_01_00749_def,
   0x00000000D00319F0 => \%tio_01_00750_def,
   0x00000000D0031A00 => \%tio_01_00751_def,
   0x00000000D0031A10 => \%tio_01_00752_def,
   0x00000000D0031A20 => \%tio_01_00753_def,
   0x00000000D0031A30 => \%tio_01_00754_def,
   0x00000000D0040500 => \%tio_01_00755_def,
   0x00000000D0040508 => \%tio_01_00756_def,
   0x00000000D0040510 => \%tio_01_00757_def,
   0x00000000D0040518 => \%tio_01_00758_def,
   0x00000000D0040520 => \%tio_01_00759_def,
   0x00000000D0040528 => \%tio_01_00760_def,
   0x00000000D0040530 => \%tio_01_00761_def,
   0x00000000D0040538 => \%tio_01_00762_def,
   0x00000000D0040540 => \%tio_01_00763_def,
   0x00000000D0040550 => \%tio_01_00764_def,
   0x00000000D0040560 => \%tio_01_00765_def,
   0x00000000D0040570 => \%tio_01_00766_def,
   0x00000000D0040580 => \%tio_01_00767_def,
   0x00000000D0040590 => \%tio_01_00768_def,
   0x00000000D0040600 => \%tio_01_00769_def,
   0x00000000D0040608 => \%tio_01_00770_def,
   0x00000000D0040610 => \%tio_01_00771_def,
   0x00000000D0040618 => \%tio_01_00772_def,
   0x00000000D0040620 => \%tio_01_00773_def,
   0x00000000D0040628 => \%tio_01_00774_def,
   0x00000000D0040630 => \%tio_01_00775_def,
   0x00000000D0040638 => \%tio_01_00776_def,
   0x00000000D0040640 => \%tio_01_00777_def,
   0x00000000D0040650 => \%tio_01_00778_def,
   0x00000000D0040660 => \%tio_01_00779_def,
   0x00000000D0040670 => \%tio_01_00780_def,
   0x00000000D0040680 => \%tio_01_00781_def,
   0x00000000D0040690 => \%tio_01_00782_def,
   0x00000000D0040130 => \%tio_01_00783_def,
   0x00000000D0040140 => \%tio_01_00784_def,
   0x00000000D0040150 => \%tio_01_00785_def,
   0x00000000D0040160 => \%tio_01_00786_def,
   0x00000000D0040170 => \%tio_01_00787_def,
   0x00000000D0040000 => \%tio_01_00788_def,
   0x00000000D0040008 => \%tio_01_00789_def,
   0x00000000D0040020 => \%tio_01_00790_def,
   0x00000000D0040028 => \%tio_01_00791_def,
   0x00000000D0040040 => \%tio_01_00792_def,
   0x00000000D0040060 => \%tio_01_00793_def,
   0x00000000D0040200 => \%tio_01_00794_def,
   0x00000000D0040208 => \%tio_01_00795_def,
   0x00000000D0040220 => \%tio_01_00796_def,
   0x00000000D0040228 => \%tio_01_00797_def,
   0x00000000D0040240 => \%tio_01_00798_def,
   0x00000000D0040260 => \%tio_01_00799_def,
   0x00000000D0040210 => \%tio_01_00800_def,
   0x00000000D0040218 => \%tio_01_00801_def,
   0x00000000D0040230 => \%tio_01_00802_def,
   0x00000000D0040238 => \%tio_01_00803_def,
   0x00000000D0040250 => \%tio_01_00804_def,
   0x00000000D0040270 => \%tio_01_00805_def,
   0x0000000020000000 => \%tio_01_00806_def,
   0x0000000020000008 => \%tio_01_00807_def,
   0x0000000020000010 => \%tio_01_00808_def,
   0x0000000020000018 => \%tio_01_00809_def,
   0x0000000020000020 => \%tio_01_00810_def,
   0x0000000020000028 => \%tio_01_00811_def,
   0x0000000020000030 => \%tio_01_00812_def,
   0x0000000020000038 => \%tio_01_00813_def,
   0x0000000020000040 => \%tio_01_00814_def,
   0x0000000020000048 => \%tio_01_00815_def,
   0x0000000020000050 => \%tio_01_00816_def,
   0x0000000020000058 => \%tio_01_00817_def,
   0x0000000020000060 => \%tio_01_00818_def,
   0x0000000020000068 => \%tio_01_00819_def,
   0x0000000020000070 => \%tio_01_00820_def,
   0x0000000020000078 => \%tio_01_00821_def,
   0x0000000020000080 => \%tio_01_00822_def,
   0x0000000020000088 => \%tio_01_00823_def,
   0x0000000020000090 => \%tio_01_00824_def,
   0x0000000020000098 => \%tio_01_00825_def,
   0x00000000200000A0 => \%tio_01_00826_def,
   0x00000000200000A8 => \%tio_01_00827_def,
   0x00000000200000B0 => \%tio_01_00828_def,
   0x00000000200000B8 => \%tio_01_00829_def,
   0x00000000200000D8 => \%tio_01_00830_def,
   0x00000000200000E0 => \%tio_01_00831_def,
   0x00000000200000E8 => \%tio_01_00832_def,
   0x00000000200000F0 => \%tio_01_00833_def,
   0x00000000200000F8 => \%tio_01_00834_def,
   0x0000000020000100 => \%tio_01_00835_def,
   0x0000000020000108 => \%tio_01_00836_def,
   0x0000000020000110 => \%tio_01_00837_def,
   0x0000000020000118 => \%tio_01_00838_def,
   0x0000000020000200 => \%tio_01_00839_def,
   0x0000000020000208 => \%tio_01_00840_def,
   0x0000000020000210 => \%tio_01_00841_def,
   0x0000000020000218 => \%tio_01_00842_def,
   0x0000000020000220 => \%tio_01_00843_def,
   0x0000000020000228 => \%tio_01_00844_def,
   0x0000000020000230 => \%tio_01_00845_def,
   0x0000000020000238 => \%tio_01_00846_def,
   0x0000000020000240 => \%tio_01_00847_def,
   0x0000000020020000 => \%tio_01_00848_def,
   0x0000000020020008 => \%tio_01_00849_def,
   0x0000000020020010 => \%tio_01_00850_def,
   0x0000000020020018 => \%tio_01_00851_def,
   0x0000000020020000 => \%tio_01_00852_def,
   0x0000000020020008 => \%tio_01_00853_def,
   0x0000000020020010 => \%tio_01_00854_def,
   0x0000000020020018 => \%tio_01_00855_def,
   0x0000000020030000 => \%tio_01_00856_def,
   0x0000000020030008 => \%tio_01_00857_def,
   0x0000000020030010 => \%tio_01_00858_def,
   0x0000000020030018 => \%tio_01_00859_def,
   0x0000000020030000 => \%tio_01_00860_def,
   0x0000000020030008 => \%tio_01_00861_def,
   0x0000000020030010 => \%tio_01_00862_def,
   0x0000000020030018 => \%tio_01_00863_def,
   0x0000000020020028 => \%tio_01_00864_def,
   0x0000000020020030 => \%tio_01_00865_def,
   0x0000000020020038 => \%tio_01_00866_def,
   0x0000000020034000 => \%tio_01_00867_def,
   0x0000000020024000 => \%tio_01_00868_def,
   0x0000000020010000 => \%tio_01_00869_def,
   0x0000000020010008 => \%tio_01_00870_def,
   0x0000000020010010 => \%tio_01_00871_def,
   0x0000000020010018 => \%tio_01_00872_def,
   0x0000000020010000 => \%tio_01_00873_def,
   0x0000000020010008 => \%tio_01_00874_def,
   0x0000000020010010 => \%tio_01_00875_def,
   0x0000000020010018 => \%tio_01_00876_def,
   0x0000000000000000 => \%tio_01_00877_def,
   0x0000000000000008 => \%tio_01_00878_def,
   0x0000000000000010 => \%tio_01_00879_def,
   0x0000000000000018 => \%tio_01_00880_def,
   0x0000000000000020 => \%tio_01_00881_def,
   0x0000000000000028 => \%tio_01_00882_def,
   0x0000000000000030 => \%tio_01_00883_def,
   0x0000000000000038 => \%tio_01_00884_def,
   0x0000000000000040 => \%tio_01_00885_def,
   0x0000000000000050 => \%tio_01_00886_def,
   0x0000000000000058 => \%tio_01_00887_def,
   0x0000000000000060 => \%tio_01_00888_def,
   0x0000000000000068 => \%tio_01_00889_def,
   0x0000000000000070 => \%tio_01_00890_def,
   0x0000000000000078 => \%tio_01_00891_def,
   0x0000000000000080 => \%tio_01_00892_def,
   0x0000000000000090 => \%tio_01_00893_def,
   0x00000000000000A0 => \%tio_01_00894_def,
   0x00000000000000B0 => \%tio_01_00895_def,
   0x00000000000000C0 => \%tio_01_00896_def,
   0x00000000000000C8 => \%tio_01_00897_def,
   0x00000000000000D0 => \%tio_01_00898_def,
   0x00000000000000D8 => \%tio_01_00899_def,
   0x0000000000000100 => \%tio_01_00900_def,
   0x0000000000000108 => \%tio_01_00901_def,
   0x0000000000000110 => \%tio_01_00902_def,
   0x0000000000000118 => \%tio_01_00903_def,
   0x0000000000000120 => \%tio_01_00904_def,
   0x0000000000000128 => \%tio_01_00905_def,
   0x0000000000000130 => \%tio_01_00906_def,
   0x0000000000000138 => \%tio_01_00907_def,
   0x0000000000000140 => \%tio_01_00908_def,
   0x0000000000000148 => \%tio_01_00909_def,
   0x0000000000000150 => \%tio_01_00910_def,
   0x0000000000000158 => \%tio_01_00911_def,
   0x0000000000000160 => \%tio_01_00912_def,
   0x0000000000000168 => \%tio_01_00913_def,
   0x0000000000000170 => \%tio_01_00914_def,
   0x0000000000000178 => \%tio_01_00915_def,
   0x0000000000000180 => \%tio_01_00916_def,
   0x0000000000000188 => \%tio_01_00917_def,
   0x0000000000000190 => \%tio_01_00918_def,
   0x0000000000000198 => \%tio_01_00919_def,
   0x00000000000001A0 => \%tio_01_00920_def,
   0x00000000000001A8 => \%tio_01_00921_def,
   0x00000000000001B0 => \%tio_01_00922_def,
   0x00000000000001B8 => \%tio_01_00923_def,
   0x00000000000001C0 => \%tio_01_00924_def,
   0x00000000000001C8 => \%tio_01_00925_def,
   0x00000000000001D0 => \%tio_01_00926_def,
   0x00000000000001D8 => \%tio_01_00927_def,
   0x00000000000001E0 => \%tio_01_00928_def,
   0x00000000000001E8 => \%tio_01_00929_def,
   0x00000000000001F0 => \%tio_01_00930_def,
   0x00000000000001F8 => \%tio_01_00931_def,
   0x0000000000000200 => \%tio_01_00932_def,
   0x0000000000000208 => \%tio_01_00933_def,
   0x0000000000000210 => \%tio_01_00934_def,
   0x0000000000000218 => \%tio_01_00935_def,
   0x0000000000000240 => \%tio_01_00936_def,
   0x0000000000000248 => \%tio_01_00937_def,
   0x0000000000000250 => \%tio_01_00938_def,
   0x0000000000000258 => \%tio_01_00939_def,
   0x0000000000000280 => \%tio_01_00940_def,
   0x0000000000000288 => \%tio_01_00941_def,
   0x0000000000000290 => \%tio_01_00942_def,
   0x0000000000000298 => \%tio_01_00943_def,
   0x0000000000000300 => \%tio_01_00944_def,
   0x0000000000000310 => \%tio_01_00945_def,
   0x0000000000000320 => \%tio_01_00946_def,
   0x0000000000000330 => \%tio_01_00947_def,
   0x0000000000000340 => \%tio_01_00948_def,
   0x0000000000000350 => \%tio_01_00949_def,
   0x0000000000000360 => \%tio_01_00950_def,
   0x0000000000000370 => \%tio_01_00951_def,
   0x0000000000000380 => \%tio_01_00952_def,
   0x0000000000000390 => \%tio_01_00953_def,
   0x00000000000003A0 => \%tio_01_00954_def,
   0x00000000000003B0 => \%tio_01_00955_def,
   0x00000000000003C0 => \%tio_01_00956_def,
   0x00000000000003D0 => \%tio_01_00957_def,
   0x00000000000003E0 => \%tio_01_00958_def,
   0x00000000000003F0 => \%tio_01_00959_def,
   0x0000000000000308 => \%tio_01_00960_def,
   0x0000000000000318 => \%tio_01_00961_def,
   0x0000000000000328 => \%tio_01_00962_def,
   0x0000000000000338 => \%tio_01_00963_def,
   0x0000000000000348 => \%tio_01_00964_def,
   0x0000000000000358 => \%tio_01_00965_def,
   0x0000000000000368 => \%tio_01_00966_def,
   0x0000000000000378 => \%tio_01_00967_def,
   0x0000000000000388 => \%tio_01_00968_def,
   0x0000000000000398 => \%tio_01_00969_def,
   0x00000000000003A8 => \%tio_01_00970_def,
   0x00000000000003B8 => \%tio_01_00971_def,
   0x00000000000003C8 => \%tio_01_00972_def,
   0x00000000000003D8 => \%tio_01_00973_def,
   0x00000000000003E8 => \%tio_01_00974_def,
   0x00000000000003F8 => \%tio_01_00975_def,
   0x0000000000000400 => \%tio_01_00976_def,
   0x0000000000000440 => \%tio_01_00977_def,
   0x0000000000000480 => \%tio_01_00978_def,
   0x00000000000004C0 => \%tio_01_00979_def,
   0x0000000000000500 => \%tio_01_00980_def,
   0x0000000000000540 => \%tio_01_00981_def,
   0x0000000000000580 => \%tio_01_00982_def,
   0x00000000000005C0 => \%tio_01_00983_def,
   0x0000000000000408 => \%tio_01_00984_def,
   0x0000000000000448 => \%tio_01_00985_def,
   0x0000000000000488 => \%tio_01_00986_def,
   0x00000000000004C8 => \%tio_01_00987_def,
   0x0000000000000508 => \%tio_01_00988_def,
   0x0000000000000548 => \%tio_01_00989_def,
   0x0000000000000588 => \%tio_01_00990_def,
   0x00000000000005C8 => \%tio_01_00991_def,
   0x0000000000000410 => \%tio_01_00992_def,
   0x0000000000000450 => \%tio_01_00993_def,
   0x0000000000000490 => \%tio_01_00994_def,
   0x00000000000004D0 => \%tio_01_00995_def,
   0x0000000000000510 => \%tio_01_00996_def,
   0x0000000000000550 => \%tio_01_00997_def,
   0x0000000000000590 => \%tio_01_00998_def,
   0x00000000000005D0 => \%tio_01_00999_def,
   0x0000000000000418 => \%tio_01_01000_def,
   0x0000000000000458 => \%tio_01_01001_def,
   0x0000000000000498 => \%tio_01_01002_def,
   0x00000000000004D8 => \%tio_01_01003_def,
   0x0000000000000518 => \%tio_01_01004_def,
   0x0000000000000558 => \%tio_01_01005_def,
   0x0000000000000598 => \%tio_01_01006_def,
   0x00000000000005D8 => \%tio_01_01007_def,
   0x0000000000000420 => \%tio_01_01008_def,
   0x0000000000000460 => \%tio_01_01009_def,
   0x00000000000004A0 => \%tio_01_01010_def,
   0x00000000000004E0 => \%tio_01_01011_def,
   0x0000000000000520 => \%tio_01_01012_def,
   0x0000000000000560 => \%tio_01_01013_def,
   0x00000000000005A0 => \%tio_01_01014_def,
   0x00000000000005E0 => \%tio_01_01015_def,
   0x0000000000000428 => \%tio_01_01016_def,
   0x0000000000000468 => \%tio_01_01017_def,
   0x00000000000004A8 => \%tio_01_01018_def,
   0x00000000000004E8 => \%tio_01_01019_def,
   0x0000000000000528 => \%tio_01_01020_def,
   0x0000000000000568 => \%tio_01_01021_def,
   0x00000000000005A8 => \%tio_01_01022_def,
   0x00000000000005E8 => \%tio_01_01023_def,
   0x0000000000000430 => \%tio_01_01024_def,
   0x0000000000000470 => \%tio_01_01025_def,
   0x00000000000004B0 => \%tio_01_01026_def,
   0x00000000000004F0 => \%tio_01_01027_def,
   0x0000000000000530 => \%tio_01_01028_def,
   0x0000000000000570 => \%tio_01_01029_def,
   0x00000000000005B0 => \%tio_01_01030_def,
   0x00000000000005F0 => \%tio_01_01031_def,
   0x0000000000000438 => \%tio_01_01032_def,
   0x0000000000000478 => \%tio_01_01033_def,
   0x00000000000004B8 => \%tio_01_01034_def,
   0x00000000000004F8 => \%tio_01_01035_def,
   0x0000000000000538 => \%tio_01_01036_def,
   0x0000000000000578 => \%tio_01_01037_def,
   0x00000000000005B8 => \%tio_01_01038_def,
   0x00000000000005F8 => \%tio_01_01039_def,
   0x0000000000000600 => \%tio_01_01040_def,
   0x0000000000000608 => \%tio_01_01041_def,
   0x0000000000000610 => \%tio_01_01042_def,
   0x0000000000000618 => \%tio_01_01043_def,
   0x0000000000000620 => \%tio_01_01044_def,
   0x0000000000000628 => \%tio_01_01045_def,
   0x0000000000000630 => \%tio_01_01046_def,
   0x0000000000000638 => \%tio_01_01047_def,
   0x0000000000000700 => \%tio_01_01048_def,
   0x0000000000000708 => \%tio_01_01049_def,
   0x0000000000000710 => \%tio_01_01050_def,
   0x0000000000000718 => \%tio_01_01051_def,
   0x0000000000000720 => \%tio_01_01052_def,
   0x0000000000000728 => \%tio_01_01053_def,
   0x0000000000000730 => \%tio_01_01054_def,
   0x0000000010000000 => \%tio_01_01055_def,
   0x0000000010000008 => \%tio_01_01056_def,
   0x0000000010000010 => \%tio_01_01057_def,
   0x0000000010000018 => \%tio_01_01058_def,
   0x0000000010000020 => \%tio_01_01059_def,
   0x0000000010000028 => \%tio_01_01060_def,
   0x0000000010000030 => \%tio_01_01061_def,
   0x0000000010000038 => \%tio_01_01062_def,
   0x0000000010000040 => \%tio_01_01063_def,
   0x0000000010000050 => \%tio_01_01064_def,
   0x0000000010000058 => \%tio_01_01065_def,
   0x0000000010000060 => \%tio_01_01066_def,
   0x0000000010000068 => \%tio_01_01067_def,
   0x0000000010000070 => \%tio_01_01068_def,
   0x0000000010000078 => \%tio_01_01069_def,
   0x0000000010000080 => \%tio_01_01070_def,
   0x0000000010000090 => \%tio_01_01071_def,
   0x00000000100000A0 => \%tio_01_01072_def,
   0x00000000100000B0 => \%tio_01_01073_def,
   0x00000000100000C0 => \%tio_01_01074_def,
   0x00000000100000C8 => \%tio_01_01075_def,
   0x00000000100000D0 => \%tio_01_01076_def,
   0x00000000100000D8 => \%tio_01_01077_def,
   0x0000000010000100 => \%tio_01_01078_def,
   0x0000000010000108 => \%tio_01_01079_def,
   0x0000000010000110 => \%tio_01_01080_def,
   0x0000000010000118 => \%tio_01_01081_def,
   0x0000000010000120 => \%tio_01_01082_def,
   0x0000000010000128 => \%tio_01_01083_def,
   0x0000000010000130 => \%tio_01_01084_def,
   0x0000000010000138 => \%tio_01_01085_def,
   0x0000000010000140 => \%tio_01_01086_def,
   0x0000000010000148 => \%tio_01_01087_def,
   0x0000000010000150 => \%tio_01_01088_def,
   0x0000000010000158 => \%tio_01_01089_def,
   0x0000000010000160 => \%tio_01_01090_def,
   0x0000000010000168 => \%tio_01_01091_def,
   0x0000000010000170 => \%tio_01_01092_def,
   0x0000000010000178 => \%tio_01_01093_def,
   0x0000000010000180 => \%tio_01_01094_def,
   0x0000000010000188 => \%tio_01_01095_def,
   0x0000000010000190 => \%tio_01_01096_def,
   0x0000000010000198 => \%tio_01_01097_def,
   0x00000000100001A0 => \%tio_01_01098_def,
   0x00000000100001A8 => \%tio_01_01099_def,
   0x00000000100001B0 => \%tio_01_01100_def,
   0x00000000100001B8 => \%tio_01_01101_def,
   0x00000000100001C0 => \%tio_01_01102_def,
   0x00000000100001C8 => \%tio_01_01103_def,
   0x00000000100001D0 => \%tio_01_01104_def,
   0x00000000100001D8 => \%tio_01_01105_def,
   0x00000000100001E0 => \%tio_01_01106_def,
   0x00000000100001E8 => \%tio_01_01107_def,
   0x00000000100001F0 => \%tio_01_01108_def,
   0x00000000100001F8 => \%tio_01_01109_def,
   0x0000000010000200 => \%tio_01_01110_def,
   0x0000000010000208 => \%tio_01_01111_def,
   0x0000000010000210 => \%tio_01_01112_def,
   0x0000000010000218 => \%tio_01_01113_def,
   0x0000000010000240 => \%tio_01_01114_def,
   0x0000000010000248 => \%tio_01_01115_def,
   0x0000000010000250 => \%tio_01_01116_def,
   0x0000000010000258 => \%tio_01_01117_def,
   0x0000000010000280 => \%tio_01_01118_def,
   0x0000000010000288 => \%tio_01_01119_def,
   0x0000000010000290 => \%tio_01_01120_def,
   0x0000000010000298 => \%tio_01_01121_def,
   0x0000000010000300 => \%tio_01_01122_def,
   0x0000000010000310 => \%tio_01_01123_def,
   0x0000000010000320 => \%tio_01_01124_def,
   0x0000000010000330 => \%tio_01_01125_def,
   0x0000000010000340 => \%tio_01_01126_def,
   0x0000000010000350 => \%tio_01_01127_def,
   0x0000000010000360 => \%tio_01_01128_def,
   0x0000000010000370 => \%tio_01_01129_def,
   0x0000000010000380 => \%tio_01_01130_def,
   0x0000000010000390 => \%tio_01_01131_def,
   0x00000000100003A0 => \%tio_01_01132_def,
   0x00000000100003B0 => \%tio_01_01133_def,
   0x00000000100003C0 => \%tio_01_01134_def,
   0x00000000100003D0 => \%tio_01_01135_def,
   0x00000000100003E0 => \%tio_01_01136_def,
   0x00000000100003F0 => \%tio_01_01137_def,
   0x0000000010000308 => \%tio_01_01138_def,
   0x0000000010000318 => \%tio_01_01139_def,
   0x0000000010000328 => \%tio_01_01140_def,
   0x0000000010000338 => \%tio_01_01141_def,
   0x0000000010000348 => \%tio_01_01142_def,
   0x0000000010000358 => \%tio_01_01143_def,
   0x0000000010000368 => \%tio_01_01144_def,
   0x0000000010000378 => \%tio_01_01145_def,
   0x0000000010000388 => \%tio_01_01146_def,
   0x0000000010000398 => \%tio_01_01147_def,
   0x00000000100003A8 => \%tio_01_01148_def,
   0x00000000100003B8 => \%tio_01_01149_def,
   0x00000000100003C8 => \%tio_01_01150_def,
   0x00000000100003D8 => \%tio_01_01151_def,
   0x00000000100003E8 => \%tio_01_01152_def,
   0x00000000100003F8 => \%tio_01_01153_def,
   0x0000000010000400 => \%tio_01_01154_def,
   0x0000000010000440 => \%tio_01_01155_def,
   0x0000000010000480 => \%tio_01_01156_def,
   0x00000000100004C0 => \%tio_01_01157_def,
   0x0000000010000500 => \%tio_01_01158_def,
   0x0000000010000540 => \%tio_01_01159_def,
   0x0000000010000580 => \%tio_01_01160_def,
   0x00000000100005C0 => \%tio_01_01161_def,
   0x0000000010000408 => \%tio_01_01162_def,
   0x0000000010000448 => \%tio_01_01163_def,
   0x0000000010000488 => \%tio_01_01164_def,
   0x00000000100004C8 => \%tio_01_01165_def,
   0x0000000010000508 => \%tio_01_01166_def,
   0x0000000010000548 => \%tio_01_01167_def,
   0x0000000010000588 => \%tio_01_01168_def,
   0x00000000100005C8 => \%tio_01_01169_def,
   0x0000000010000410 => \%tio_01_01170_def,
   0x0000000010000450 => \%tio_01_01171_def,
   0x0000000010000490 => \%tio_01_01172_def,
   0x00000000100004D0 => \%tio_01_01173_def,
   0x0000000010000510 => \%tio_01_01174_def,
   0x0000000010000550 => \%tio_01_01175_def,
   0x0000000010000590 => \%tio_01_01176_def,
   0x00000000100005D0 => \%tio_01_01177_def,
   0x0000000010000418 => \%tio_01_01178_def,
   0x0000000010000458 => \%tio_01_01179_def,
   0x0000000010000498 => \%tio_01_01180_def,
   0x00000000100004D8 => \%tio_01_01181_def,
   0x0000000010000518 => \%tio_01_01182_def,
   0x0000000010000558 => \%tio_01_01183_def,
   0x0000000010000598 => \%tio_01_01184_def,
   0x00000000100005D8 => \%tio_01_01185_def,
   0x0000000010000420 => \%tio_01_01186_def,
   0x0000000010000460 => \%tio_01_01187_def,
   0x00000000100004A0 => \%tio_01_01188_def,
   0x00000000100004E0 => \%tio_01_01189_def,
   0x0000000010000520 => \%tio_01_01190_def,
   0x0000000010000560 => \%tio_01_01191_def,
   0x00000000100005A0 => \%tio_01_01192_def,
   0x00000000100005E0 => \%tio_01_01193_def,
   0x0000000010000428 => \%tio_01_01194_def,
   0x0000000010000468 => \%tio_01_01195_def,
   0x00000000100004A8 => \%tio_01_01196_def,
   0x00000000100004E8 => \%tio_01_01197_def,
   0x0000000010000528 => \%tio_01_01198_def,
   0x0000000010000568 => \%tio_01_01199_def,
   0x00000000100005A8 => \%tio_01_01200_def,
   0x00000000100005E8 => \%tio_01_01201_def,
   0x0000000010000430 => \%tio_01_01202_def,
   0x0000000010000470 => \%tio_01_01203_def,
   0x00000000100004B0 => \%tio_01_01204_def,
   0x00000000100004F0 => \%tio_01_01205_def,
   0x0000000010000530 => \%tio_01_01206_def,
   0x0000000010000570 => \%tio_01_01207_def,
   0x00000000100005B0 => \%tio_01_01208_def,
   0x00000000100005F0 => \%tio_01_01209_def,
   0x0000000010000438 => \%tio_01_01210_def,
   0x0000000010000478 => \%tio_01_01211_def,
   0x00000000100004B8 => \%tio_01_01212_def,
   0x00000000100004F8 => \%tio_01_01213_def,
   0x0000000010000538 => \%tio_01_01214_def,
   0x0000000010000578 => \%tio_01_01215_def,
   0x00000000100005B8 => \%tio_01_01216_def,
   0x00000000100005F8 => \%tio_01_01217_def,
   0x0000000010000600 => \%tio_01_01218_def,
   0x0000000010000608 => \%tio_01_01219_def,
   0x0000000010000610 => \%tio_01_01220_def,
   0x0000000010000618 => \%tio_01_01221_def,
   0x0000000010000620 => \%tio_01_01222_def,
   0x0000000010000628 => \%tio_01_01223_def,
   0x0000000010000630 => \%tio_01_01224_def,
   0x0000000010000638 => \%tio_01_01225_def,
   0x0000000010000700 => \%tio_01_01226_def,
   0x0000000010000708 => \%tio_01_01227_def,
   0x0000000010000710 => \%tio_01_01228_def,
   0x0000000010000718 => \%tio_01_01229_def,
   0x0000000010000720 => \%tio_01_01230_def,
   0x0000000010000728 => \%tio_01_01231_def,
   0x0000000010000730 => \%tio_01_01232_def,
   0x0000000030000000 => \%tio_01_01233_def,
   0x0000000030000010 => \%tio_01_01234_def,
   0x0000000030000018 => \%tio_01_01235_def,
   0x0000000030000020 => \%tio_01_01236_def,
   0x0000000030000028 => \%tio_01_01237_def,
   0x0000000030000030 => \%tio_01_01238_def,
   0x0000000030000038 => \%tio_01_01239_def,
   0x0000000030000040 => \%tio_01_01240_def,
   0x0000000030000048 => \%tio_01_01241_def,
   0x0000000030000050 => \%tio_01_01242_def,
   0x0000000030000058 => \%tio_01_01243_def,
   0x0000000030000060 => \%tio_01_01244_def,
   0x0000000030000068 => \%tio_01_01245_def,
   0x0000000030000070 => \%tio_01_01246_def,
   0x0000000030000078 => \%tio_01_01247_def,
   0x0000000030000080 => \%tio_01_01248_def,
   0x0000000030000088 => \%tio_01_01249_def,
   0x0000000030000090 => \%tio_01_01250_def,
   0x0000000030000098 => \%tio_01_01251_def,
   0x00000000300000A0 => \%tio_01_01252_def,
   0x00000000300000A8 => \%tio_01_01253_def,
   0x00000000300000B0 => \%tio_01_01254_def,
   0x00000000300000B8 => \%tio_01_01255_def,
   0x00000000300000C0 => \%tio_01_01256_def,
   0x00000000300000C8 => \%tio_01_01257_def,
   0x00000000300000D0 => \%tio_01_01258_def,
   0x00000000300000D8 => \%tio_01_01259_def,
   0x00000000300000E0 => \%tio_01_01260_def,
   0x00000000300000E8 => \%tio_01_01261_def,
   0x00000000300000F0 => \%tio_01_01262_def,
   0x00000000300000F8 => \%tio_01_01263_def,
   0x0000000030000100 => \%tio_01_01264_def,
   0x0000000030000108 => \%tio_01_01265_def,
   0x0000000030000110 => \%tio_01_01266_def,
   0x0000000030000118 => \%tio_01_01267_def,
   0x0000000030000120 => \%tio_01_01268_def,
   0x0000000030000128 => \%tio_01_01269_def,
   0x0000000030000140 => \%tio_01_01270_def,
   0x0000000030000148 => \%tio_01_01271_def,
   0x0000000030000150 => \%tio_01_01272_def,
   0x0000000030000158 => \%tio_01_01273_def,
   0x0000000030000160 => \%tio_01_01274_def,
   0x0000000030000168 => \%tio_01_01275_def,
   0x0000000030000170 => \%tio_01_01276_def,
   0x0000000030000198 => \%tio_01_01277_def,
   0x0000000030000200 => \%tio_01_01278_def,
   0x0000000030000208 => \%tio_01_01279_def,
   0x0000000030000210 => \%tio_01_01280_def,
   0x0000000030000218 => \%tio_01_01281_def,
   0x0000000030000220 => \%tio_01_01282_def,
   0x0000000030000228 => \%tio_01_01283_def,
   0x0000000030000230 => \%tio_01_01284_def,
   0x0000000030000238 => \%tio_01_01285_def,
   0x0000000030000240 => \%tio_01_01286_def,
   0x0000000030000248 => \%tio_01_01287_def,
   0x0000000030000250 => \%tio_01_01288_def,
   0x0000000030000258 => \%tio_01_01289_def,
   0x0000000030000260 => \%tio_01_01290_def,
   0x0000000030000268 => \%tio_01_01291_def,
   0x0000000030000270 => \%tio_01_01292_def,
   0x0000000030000278 => \%tio_01_01293_def,
   0x0000000030000400 => \%tio_01_01294_def,
   0x0000000030000800 => \%tio_01_01295_def,
   0x0000000030000A00 => \%tio_01_01296_def,
   0x0000000030000C00 => \%tio_01_01297_def,
   0x0000000030002000 => \%tio_01_01298_def,
   0x0000000030002008 => \%tio_01_01299_def,
   0x0000000030002010 => \%tio_01_01300_def,
   0x0000000030002018 => \%tio_01_01301_def,
   0x0000000030002020 => \%tio_01_01302_def,
   0x0000000030002028 => \%tio_01_01303_def,
   0x0000000030002040 => \%tio_01_01304_def,
   0x0000000030002048 => \%tio_01_01305_def,
   0x0000000030002100 => \%tio_01_01306_def,
   0x0000000030002110 => \%tio_01_01307_def,
   0x0000000030002120 => \%tio_01_01308_def,
   0x0000000030002128 => \%tio_01_01309_def,
   0x0000000030002130 => \%tio_01_01310_def,
   0x0000000030002138 => \%tio_01_01311_def,
   0x0000000030002200 => \%tio_01_01312_def,
   0x0000000030002208 => \%tio_01_01313_def,
   0x0000000030002210 => \%tio_01_01314_def,
   0x0000000030002218 => \%tio_01_01315_def,
   0x0000000030002220 => \%tio_01_01316_def,
   0x0000000030002240 => \%tio_01_01317_def,
   0x0000000030002260 => \%tio_01_01318_def,
   0x0000000030002268 => \%tio_01_01319_def,
   0x0000000030002270 => \%tio_01_01320_def,
   0x0000000030002400 => \%tio_01_01321_def,
   0x0000000030002408 => \%tio_01_01322_def,
   0x0000000030002410 => \%tio_01_01323_def,
   0x0000000030002418 => \%tio_01_01324_def,
   0x0000000030002420 => \%tio_01_01325_def,
   0x0000000030002428 => \%tio_01_01326_def,
   0x0000000030002430 => \%tio_01_01327_def,
   0x0000000030002438 => \%tio_01_01328_def,
   0x0000000030002440 => \%tio_01_01329_def,
   0x0000000030002448 => \%tio_01_01330_def,
   0x0000000030002450 => \%tio_01_01331_def,
   0x0000000030002458 => \%tio_01_01332_def,
   0x0000000030002460 => \%tio_01_01333_def,
   0x0000000030002468 => \%tio_01_01334_def,
   0x0000000030002470 => \%tio_01_01335_def,
   0x0000000030002480 => \%tio_01_01336_def,
   0x0000000030002488 => \%tio_01_01337_def,
   0x0000000030002490 => \%tio_01_01338_def,
   0x0000000030002498 => \%tio_01_01339_def,
   0x00000000300024A0 => \%tio_01_01340_def,
   0x00000000300024A8 => \%tio_01_01341_def,
   0x00000000300024C0 => \%tio_01_01342_def,
   0x00000000300024C8 => \%tio_01_01343_def,
   0x00000000300024D0 => \%tio_01_01344_def,
   0x00000000300024E0 => \%tio_01_01345_def,
   0x0000000030002500 => \%tio_01_01346_def,
   0x0000000030002508 => \%tio_01_01347_def,
   0x0000000030002510 => \%tio_01_01348_def,
   0x0000000030002600 => \%tio_01_01349_def,
   0x0000000030002610 => \%tio_01_01350_def,
   0x0000000030002618 => \%tio_01_01351_def,
   0x0000000030002620 => \%tio_01_01352_def,
   0x0000000030002680 => \%tio_01_01353_def,
   0x0000000030002688 => \%tio_01_01354_def,
   0x0000000030002690 => \%tio_01_01355_def,
   0x0000000030002698 => \%tio_01_01356_def,
   0x00000000300026A0 => \%tio_01_01357_def,
   0x00000000300026A8 => \%tio_01_01358_def,
   0x00000000300026B0 => \%tio_01_01359_def,
   0x0000000030002700 => \%tio_01_01360_def,
   0x0000000030002708 => \%tio_01_01361_def,
   0x0000000030002710 => \%tio_01_01362_def,
   0x0000000030002718 => \%tio_01_01363_def,
   0x0000000030002720 => \%tio_01_01364_def,
   0x0000000030002728 => \%tio_01_01365_def,
   0x0000000030002780 => \%tio_01_01366_def,
   0x0000000030002788 => \%tio_01_01367_def,
   0x0000000030002790 => \%tio_01_01368_def,
   0x0000000030002798 => \%tio_01_01369_def,
   0x00000000300027A0 => \%tio_01_01370_def,
   0x00000000300027A8 => \%tio_01_01371_def,
   0x00000000300027B0 => \%tio_01_01372_def,
   0x00000000300027B8 => \%tio_01_01373_def,
   0x00000000300027C0 => \%tio_01_01374_def,
   0x00000000300027C8 => \%tio_01_01375_def,
   0x00000000300027D0 => \%tio_01_01376_def,
   0x0000000030002800 => \%tio_01_01377_def,
   0x0000000030002808 => \%tio_01_01378_def,
   0x0000000030002810 => \%tio_01_01379_def,
   0x0000000030002818 => \%tio_01_01380_def,
   0x0000000030002820 => \%tio_01_01381_def,
   0x0000000030002828 => \%tio_01_01382_def,
   0x0000000030002830 => \%tio_01_01383_def,
   0x0000000030002838 => \%tio_01_01384_def,
   0x0000000030002840 => \%tio_01_01385_def,
   0x0000000030002848 => \%tio_01_01386_def,
   0x0000000030003000 => \%tio_01_01387_def,
   0x0000000030003008 => \%tio_01_01388_def,
   0x0000000030003010 => \%tio_01_01389_def,
   0x0000000030003018 => \%tio_01_01390_def,
   0x0000000030003020 => \%tio_01_01391_def,
   0x0000000030003028 => \%tio_01_01392_def,
   0x0000000030003040 => \%tio_01_01393_def,
   0x0000000030003048 => \%tio_01_01394_def,
   0x0000000030003100 => \%tio_01_01395_def,
   0x0000000030003110 => \%tio_01_01396_def,
   0x0000000030003120 => \%tio_01_01397_def,
   0x0000000030003128 => \%tio_01_01398_def,
   0x0000000030003130 => \%tio_01_01399_def,
   0x0000000030003138 => \%tio_01_01400_def,
   0x0000000030003200 => \%tio_01_01401_def,
   0x0000000030003208 => \%tio_01_01402_def,
   0x0000000030003210 => \%tio_01_01403_def,
   0x0000000030003218 => \%tio_01_01404_def,
   0x0000000030003220 => \%tio_01_01405_def,
   0x0000000030003240 => \%tio_01_01406_def,
   0x0000000030003260 => \%tio_01_01407_def,
   0x0000000030003268 => \%tio_01_01408_def,
   0x0000000030003270 => \%tio_01_01409_def,
   0x0000000030003400 => \%tio_01_01410_def,
   0x0000000030003408 => \%tio_01_01411_def,
   0x0000000030003410 => \%tio_01_01412_def,
   0x0000000030003418 => \%tio_01_01413_def,
   0x0000000030003420 => \%tio_01_01414_def,
   0x0000000030003428 => \%tio_01_01415_def,
   0x0000000030003430 => \%tio_01_01416_def,
   0x0000000030003438 => \%tio_01_01417_def,
   0x0000000030003440 => \%tio_01_01418_def,
   0x0000000030003448 => \%tio_01_01419_def,
   0x0000000030003450 => \%tio_01_01420_def,
   0x0000000030003458 => \%tio_01_01421_def,
   0x0000000030003460 => \%tio_01_01422_def,
   0x0000000030003468 => \%tio_01_01423_def,
   0x0000000030003470 => \%tio_01_01424_def,
   0x0000000030003480 => \%tio_01_01425_def,
   0x0000000030003488 => \%tio_01_01426_def,
   0x0000000030003490 => \%tio_01_01427_def,
   0x0000000030003498 => \%tio_01_01428_def,
   0x00000000300034A0 => \%tio_01_01429_def,
   0x00000000300034A8 => \%tio_01_01430_def,
   0x00000000300034C0 => \%tio_01_01431_def,
   0x00000000300034C8 => \%tio_01_01432_def,
   0x00000000300034D0 => \%tio_01_01433_def,
   0x00000000300034E0 => \%tio_01_01434_def,
   0x0000000030003500 => \%tio_01_01435_def,
   0x0000000030003508 => \%tio_01_01436_def,
   0x0000000030003510 => \%tio_01_01437_def,
   0x0000000030003600 => \%tio_01_01438_def,
   0x0000000030003610 => \%tio_01_01439_def,
   0x0000000030003618 => \%tio_01_01440_def,
   0x0000000030003620 => \%tio_01_01441_def,
   0x0000000030003680 => \%tio_01_01442_def,
   0x0000000030003688 => \%tio_01_01443_def,
   0x0000000030003690 => \%tio_01_01444_def,
   0x0000000030003698 => \%tio_01_01445_def,
   0x00000000300036A0 => \%tio_01_01446_def,
   0x00000000300036A8 => \%tio_01_01447_def,
   0x00000000300036B0 => \%tio_01_01448_def,
   0x0000000030003700 => \%tio_01_01449_def,
   0x0000000030003708 => \%tio_01_01450_def,
   0x0000000030003710 => \%tio_01_01451_def,
   0x0000000030003718 => \%tio_01_01452_def,
   0x0000000030003720 => \%tio_01_01453_def,
   0x0000000030003728 => \%tio_01_01454_def,
   0x0000000030003780 => \%tio_01_01455_def,
   0x0000000030003788 => \%tio_01_01456_def,
   0x0000000030003790 => \%tio_01_01457_def,
   0x0000000030003798 => \%tio_01_01458_def,
   0x00000000300037A0 => \%tio_01_01459_def,
   0x00000000300037A8 => \%tio_01_01460_def,
   0x00000000300037B0 => \%tio_01_01461_def,
   0x00000000300037B8 => \%tio_01_01462_def,
   0x00000000300037C0 => \%tio_01_01463_def,
   0x00000000300037C8 => \%tio_01_01464_def,
   0x00000000300037D0 => \%tio_01_01465_def,
   0x0000000030003800 => \%tio_01_01466_def,
   0x0000000030003808 => \%tio_01_01467_def,
   0x0000000030003810 => \%tio_01_01468_def,
   0x0000000030003818 => \%tio_01_01469_def,
   0x0000000030003820 => \%tio_01_01470_def,
   0x0000000030003828 => \%tio_01_01471_def,
   0x0000000030003830 => \%tio_01_01472_def,
   0x0000000030003838 => \%tio_01_01473_def,
   0x0000000030003840 => \%tio_01_01474_def,
   0x0000000030003848 => \%tio_01_01475_def,
   0x0000000030024000 => \%tio_01_01476_def,
   0x0000000030024800 => \%tio_01_01477_def,
   0x0000000030025000 => \%tio_01_01478_def,
   0x0000000030004050 => \%tio_01_01479_def,
   0x0000000030004060 => \%tio_01_01480_def,
   0x0000000030004068 => \%tio_01_01481_def,
   0x0000000030004070 => \%tio_01_01482_def,
   0x0000000030005010 => \%tio_01_01483_def,
   0x0000000030005018 => \%tio_01_01484_def,
   0x0000000030005020 => \%tio_01_01485_def,
   0x0000000030005028 => \%tio_01_01486_def,
   0x0000000030005030 => \%tio_01_01487_def,
   0x0000000030005050 => \%tio_01_01488_def,
   0x0000000030006000 => \%tio_01_01489_def,
   0x0000000030006008 => \%tio_01_01490_def,
   0x0000000030006010 => \%tio_01_01491_def,
   0x0000000030006018 => \%tio_01_01492_def,
   0x0000000030006050 => \%tio_01_01493_def,
   0x0000000030008000 => \%tio_01_01494_def,
   0x0000000030008008 => \%tio_01_01495_def,
   0x0000000030008010 => \%tio_01_01496_def,
   0x0000000030008018 => \%tio_01_01497_def,
   0x0000000030008050 => \%tio_01_01498_def,
   0x0000000030007000 => \%tio_01_01499_def,
   0x0000000030007008 => \%tio_01_01500_def,
   0x0000000030009000 => \%tio_01_01501_def,
   0x0000000030009008 => \%tio_01_01502_def,
   0x0000000030040010 => \%tio_01_01503_def,
   0x0000000030040018 => \%tio_01_01504_def,
   0x0000000030040100 => \%tio_01_01505_def,
   0x0000000030040020 => \%tio_01_01506_def,
   0x0000000030040028 => \%tio_01_01507_def,
   0x0000000030040120 => \%tio_01_01508_def,
   0x0000000030040030 => \%tio_01_01509_def,
   0x0000000030040038 => \%tio_01_01510_def,
   0x0000000030040040 => \%tio_01_01511_def,
   0x0000000030040048 => \%tio_01_01512_def,
   0x0000000030040050 => \%tio_01_01513_def,
   0x0000000030040058 => \%tio_01_01514_def,
   0x0000000030040060 => \%tio_01_01515_def,
   0x0000000030040068 => \%tio_01_01516_def,
   0x0000000030040070 => \%tio_01_01517_def,
   0x0000000030040078 => \%tio_01_01518_def,
   0x0000000030040080 => \%tio_01_01519_def,
   0x0000000030040088 => \%tio_01_01520_def,
   0x0000000030040090 => \%tio_01_01521_def,
   0x0000000030040098 => \%tio_01_01522_def,
   0x0000000030040400 => \%tio_01_01523_def,
   0x0000000030040300 => \%tio_01_01524_def,
   0x0000000030040200 => \%tio_01_01525_def,
   0x0000000030043000 => \%tio_01_01526_def,
   0x0000000030042000 => \%tio_01_01527_def,
   0x0000000030041000 => \%tio_01_01528_def,
   0x0000000030044200 => \%tio_01_01529_def,
   0x0000000030044100 => \%tio_01_01530_def,
   0x0000000030044000 => \%tio_01_01531_def,
   0x0000000030044300 => \%tio_01_01532_def,
   0x000000003000B010 => \%tio_01_01533_def,
   0x000000003000B018 => \%tio_01_01534_def,
   0x000000003000B020 => \%tio_01_01535_def,
   0x000000003000B030 => \%tio_01_01536_def,
   0x000000003000B038 => \%tio_01_01537_def,
   0x000000003000B050 => \%tio_01_01538_def,
   0x000000003000B058 => \%tio_01_01539_def,
   0x000000003000B060 => \%tio_01_01540_def,
   0x000000003000B068 => \%tio_01_01541_def,
   0x000000003000B070 => \%tio_01_01542_def,
   0x000000003000B078 => \%tio_01_01543_def,
   0x000000003000B080 => \%tio_01_01544_def,
   0x000000003000B088 => \%tio_01_01545_def,
   0x000000003000B090 => \%tio_01_01546_def,
   0x000000003000B098 => \%tio_01_01547_def,
   0x000000003000B0A0 => \%tio_01_01548_def,
   0x000000003000B0A8 => \%tio_01_01549_def,
   0x000000003000B0B0 => \%tio_01_01550_def,
   0x000000003000B0B8 => \%tio_01_01551_def,
   0x000000003000B0C0 => \%tio_01_01552_def,
   0x000000003000B0C8 => \%tio_01_01553_def,
   0x000000003000B0D0 => \%tio_01_01554_def,
   0x000000003000B0D8 => \%tio_01_01555_def,
   0x000000003000B0E0 => \%tio_01_01556_def,
   0x000000003000B0E8 => \%tio_01_01557_def,
   0x000000003000B0F0 => \%tio_01_01558_def,
   0x000000003000B0F8 => \%tio_01_01559_def,
   0x000000003000B100 => \%tio_01_01560_def,
   0x000000003000B108 => \%tio_01_01561_def,
   0x000000003000B110 => \%tio_01_01562_def,
   0x000000003000B118 => \%tio_01_01563_def,
   0x000000003000B120 => \%tio_01_01564_def,
   0x000000003000B128 => \%tio_01_01565_def,
   0x000000003000B130 => \%tio_01_01566_def,
   0x000000003000B138 => \%tio_01_01567_def,
   0x000000003000B140 => \%tio_01_01568_def,
   0x000000003000B148 => \%tio_01_01569_def,
   0x000000003000B150 => \%tio_01_01570_def,
   0x000000003000B158 => \%tio_01_01571_def,
   0x000000003000B160 => \%tio_01_01572_def,
   0x000000003000B168 => \%tio_01_01573_def,
   0x000000003000B170 => \%tio_01_01574_def,
   0x000000003000B178 => \%tio_01_01575_def,
   0x000000003000B180 => \%tio_01_01576_def,
   0x000000003000B188 => \%tio_01_01577_def,
   0x000000003000B190 => \%tio_01_01578_def,
   0x000000003000B198 => \%tio_01_01579_def,
   0x000000003000B1A0 => \%tio_01_01580_def,
   0x000000003000B1A8 => \%tio_01_01581_def,
   0x000000003000C000 => \%tio_01_01582_def,
   0x000000003000D000 => \%tio_01_01583_def,
   0x000000003000E000 => \%tio_01_01584_def,
   0x000000003000F000 => \%tio_01_01585_def,
   0x0000000030010000 => \%tio_01_01586_def,
   0x0000000030011000 => \%tio_01_01587_def,
   0x0000000030012000 => \%tio_01_01588_def,
   0x0000000030013000 => \%tio_01_01589_def,
   0x0000000030014000 => \%tio_01_01590_def,
   0x0000000030015000 => \%tio_01_01591_def,
   0x0000000030016000 => \%tio_01_01592_def,
   0x0000000030017000 => \%tio_01_01593_def,
   0x0000000030018000 => \%tio_01_01594_def,
   0x0000000030019000 => \%tio_01_01595_def,
   0x000000003001A000 => \%tio_01_01596_def,
   0x000000003001B000 => \%tio_01_01597_def,
   0x000000003001B200 => \%tio_01_01598_def,
   0x000000003001B400 => \%tio_01_01599_def,
   0x000000003001B600 => \%tio_01_01600_def,
   0x000000003001B800 => \%tio_01_01601_def,
   0x000000003001BA00 => \%tio_01_01602_def,
   0x0000000030030000 => \%tio_01_01603_def,
   0x0000000030038000 => \%tio_01_01604_def,
   0x0000000034000000 => \%tio_01_01605_def,
   0x0000000034000004 => \%tio_01_01606_def,
   0x0000000034000006 => \%tio_01_01607_def,
   0x0000000034000008 => \%tio_01_01608_def,
   0x000000003400000C => \%tio_01_01609_def,
   0x000000003400000E => \%tio_01_01610_def,
   0x0000000034000800 => \%tio_01_01611_def,
   0x0000000034000804 => \%tio_01_01612_def,
   0x0000000034000806 => \%tio_01_01613_def,
   0x0000000034000808 => \%tio_01_01614_def,
   0x000000003400080C => \%tio_01_01615_def,
   0x000000003400080E => \%tio_01_01616_def,
   0x0000000034000818 => \%tio_01_01617_def,
   0x000000003400081C => \%tio_01_01618_def,
   0x000000003400081E => \%tio_01_01619_def,
   0x0000000034000820 => \%tio_01_01620_def,
   0x0000000034000824 => \%tio_01_01621_def,
   0x0000000034000828 => \%tio_01_01622_def,
   0x000000003400082C => \%tio_01_01623_def,
   0x0000000034000830 => \%tio_01_01624_def,
   0x0000000034000834 => \%tio_01_01625_def,
   0x000000003400083E => \%tio_01_01626_def,
   0x0000000034000840 => \%tio_01_01627_def,
   0x0000000034000844 => \%tio_01_01628_def,
   0x0000000034000848 => \%tio_01_01629_def,
   0x000000003400084A => \%tio_01_01630_def,
   0x000000003400084C => \%tio_01_01631_def,
   0x0000000034000850 => \%tio_01_01632_def,
   0x0000000034000852 => \%tio_01_01633_def,
   0x0000000034000854 => \%tio_01_01634_def,
   0x0000000034000858 => \%tio_01_01635_def,
   0x000000003400085A => \%tio_01_01636_def,
   0x000000003400085C => \%tio_01_01637_def,
   0x0000000034000860 => \%tio_01_01638_def,
   0x0000000034001000 => \%tio_01_01639_def,
   0x0000000034001004 => \%tio_01_01640_def,
   0x0000000034001006 => \%tio_01_01641_def,
   0x0000000034001008 => \%tio_01_01642_def,
   0x000000003400100C => \%tio_01_01643_def,
   0x000000003400100E => \%tio_01_01644_def,
   0x0000000034001018 => \%tio_01_01645_def,
   0x000000003400101C => \%tio_01_01646_def,
   0x000000003400101E => \%tio_01_01647_def,
   0x0000000034001020 => \%tio_01_01648_def,
   0x0000000034001024 => \%tio_01_01649_def,
   0x0000000034001028 => \%tio_01_01650_def,
   0x000000003400102C => \%tio_01_01651_def,
   0x0000000034001030 => \%tio_01_01652_def,
   0x0000000034001034 => \%tio_01_01653_def,
   0x000000003400103E => \%tio_01_01654_def,
   0x0000000034001040 => \%tio_01_01655_def,
   0x0000000034001044 => \%tio_01_01656_def,
   0x0000000034001048 => \%tio_01_01657_def,
   0x000000003400104A => \%tio_01_01658_def,
   0x000000003400104C => \%tio_01_01659_def,
   0x0000000034001050 => \%tio_01_01660_def,
   0x0000000034001052 => \%tio_01_01661_def,
   0x0000000034001054 => \%tio_01_01662_def,
   0x0000000034001058 => \%tio_01_01663_def,
   0x000000003400105A => \%tio_01_01664_def,
   0x000000003400105C => \%tio_01_01665_def,
   0x0000000034001060 => \%tio_01_01666_def,
);

@tio_01_sorted_mmr_name = 
(
   "TIO_AEGIS_DEBUG_DATA",
   "TIO_ASIC_TO_L1_DATA",
   "TIO_ASIC_TO_L1_STATUS",
   "TIO_AUTO_REPLY_ENABLE0",
   "TIO_AUTO_REPLY_ENABLE1",
   "TIO_AUTO_REPLY_HEADER0",
   "TIO_AUTO_REPLY_HEADER1",
   "TIO_CA_AGP_DMA_ADDR_EXTN",
   "TIO_CA_CONTROL1",
   "TIO_CA_CONTROL2",
   "TIO_CA_CRM_CT_ERROR_DETAIL_1",
   "TIO_CA_CRM_CT_ERROR_DETAIL_2",
   "TIO_CA_CRM_PKTERR_TYPE",
   "TIO_CA_CRM_PKTERR_TYPE_ALIAS",
   "TIO_CA_CRM_TNUMTO",
   "TIO_CA_DEBUG_DOMAIN_SEL",
   "TIO_CA_DEBUG_MUX_CORE_SEL",
   "TIO_CA_DEBUG_MUX_PCI_SEL",
   "TIO_CA_DEBUG_VECTOR_SEL",
   "TIO_CA_ERR_INT_DEST_ADDR",
   "TIO_CA_FIRST_ERROR",
   "TIO_CA_FORCE_INTA",
   "TIO_CA_FORCE_INTB",
   "TIO_CA_GART_APERTURE",
   "TIO_CA_GART_ERR",
   "TIO_CA_GART_PTR_TABLE",
   "TIO_CA_GART_TLB_ADDR_0",
   "TIO_CA_GART_TLB_ADDR_1",
   "TIO_CA_GART_TLB_ADDR_2",
   "TIO_CA_GART_TLB_ADDR_3",
   "TIO_CA_GART_TLB_ADDR_4",
   "TIO_CA_GART_TLB_ADDR_5",
   "TIO_CA_GART_TLB_ADDR_6",
   "TIO_CA_GART_TLB_ADDR_7",
   "TIO_CA_GFX_DETACH",
   "TIO_CA_HW_TIME_STAMP",
   "TIO_CA_IDENTIFICATION",
   "TIO_CA_INTA_DEST_ADDR",
   "TIO_CA_INTB_DEST_ADDR",
   "TIO_CA_INT_MASK",
   "TIO_CA_INT_STATUS",
   "TIO_CA_INT_STATUS_ALIAS",
   "TIO_CA_MAINT_RD_BE_BUFF0",
   "TIO_CA_MAINT_RD_BE_BUFF1",
   "TIO_CA_MAINT_RD_GFX0",
   "TIO_CA_MAINT_RD_GFX1",
   "TIO_CA_MAINT_RD_GFX2",
   "TIO_CA_MAINT_RD_GFX3",
   "TIO_CA_MAINT_RD_OP_QUEUE",
   "TIO_CA_MAINT_RD_RD_BUFF0",
   "TIO_CA_MAINT_RD_RD_BUFF1",
   "TIO_CA_MAINT_RD_RD_BUFF2",
   "TIO_CA_MAINT_RD_RD_BUFF3",
   "TIO_CA_MAINT_RD_RMT",
   "TIO_CA_MAINT_RD_WD_BUFF0",
   "TIO_CA_MAINT_RD_WD_BUFF1",
   "TIO_CA_MAINT_RD_WD_BUFF2",
   "TIO_CA_MAINT_RD_WD_BUFF3",
   "TIO_CA_MAINT_WRT_GFX0",
   "TIO_CA_MAINT_WRT_GFX1",
   "TIO_CA_MAINT_WRT_GFX2",
   "TIO_CA_MAINT_WRT_GFX3",
   "TIO_CA_MAINT_WRT_RD_BUFF0",
   "TIO_CA_MAINT_WRT_RD_BUFF1",
   "TIO_CA_MAINT_WRT_RD_BUFF2",
   "TIO_CA_MAINT_WRT_RD_BUFF3",
   "TIO_CA_MAINT_WRT_RMT",
   "TIO_CA_MAINT_WRT_WD_BUFF0",
   "TIO_CA_MAINT_WRT_WD_BUFF1",
   "TIO_CA_MAINT_WRT_WD_BUFF2",
   "TIO_CA_MAINT_WRT_WD_BUFF3",
   "TIO_CA_MULT_ERROR",
   "TIO_CA_MULT_ERROR_ALIAS",
   "TIO_CA_PCIERR_ADDR",
   "TIO_CA_PCIERR_TYPE",
   "TIO_CA_PCI_DMA_ADDR_EXTN",
   "TIO_CA_PCI_RD_BUF_FLUSH",
   "TIO_CA_STATUS1",
   "TIO_CA_STATUS2",
   "TIO_CHIPLET_ID_CONFIG",
   "TIO_COMPARE_COMPARE_MASK",
   "TIO_COMPARE_COMPARE_PATTERN",
   "TIO_COMPARE_SEL",
   "TIO_CP0_ARBITRATION_PRIORITY",
   "TIO_CP0_BR_DEBUG_CTL",
   "TIO_CP0_BUS_ERROR_ADDR_LOWER",
   "TIO_CP0_BUS_ERROR_ADDR_UPPER",
   "TIO_CP0_BUS_SIDE_ERROR_ADDR_LOWER",
   "TIO_CP0_BUS_SIDE_ERROR_ADDR_UPPER",
   "TIO_CP0_BUS_SIDE_ERROR_CMD_WRD",
   "TIO_CP0_CONTROL",
   "TIO_CP0_CT_DEBUG_CTL",
   "TIO_CP0_DEBUG_PORT_CONTROL",
   "TIO_CP0_DEVICE_0",
   "TIO_CP0_DEVICE_0_WRITE_FLUSH",
   "TIO_CP0_DEVICE_1",
   "TIO_CP0_DEVICE_1_WRITE_FLUSH",
   "TIO_CP0_DEVICE_2",
   "TIO_CP0_DEVICE_2_WRITE_FLUSH",
   "TIO_CP0_DEVICE_3",
   "TIO_CP0_DEVICE_3_WRITE_FLUSH",
   "TIO_CP0_DMA_ERROR_ADDRESS",
   "TIO_CP0_DMA_ERROR_ATTRIBUTE",
   "TIO_CP0_ERROR_INTERRUPT_VIEW",
   "TIO_CP0_EVEN_READ_RSP_BUFFER",
   "TIO_CP0_FORCE_ALWAYS_INTERRUPT_0",
   "TIO_CP0_FORCE_ALWAYS_INTERRUPT_1",
   "TIO_CP0_FORCE_ALWAYS_INTERRUPT_2",
   "TIO_CP0_FORCE_ALWAYS_INTERRUPT_3",
   "TIO_CP0_FORCE_ALWAYS_INTERRUPT_4",
   "TIO_CP0_FORCE_ALWAYS_INTERRUPT_5",
   "TIO_CP0_FORCE_ALWAYS_INTERRUPT_6",
   "TIO_CP0_FORCE_ALWAYS_INTERRUPT_7",
   "TIO_CP0_FORCE_INTERRUPT_0",
   "TIO_CP0_FORCE_INTERRUPT_1",
   "TIO_CP0_FORCE_INTERRUPT_2",
   "TIO_CP0_FORCE_INTERRUPT_3",
   "TIO_CP0_FORCE_INTERRUPT_4",
   "TIO_CP0_FORCE_INTERRUPT_5",
   "TIO_CP0_FORCE_INTERRUPT_6",
   "TIO_CP0_FORCE_INTERRUPT_7",
   "TIO_CP0_HOST_ERROR_INTERRUPT",
   "TIO_CP0_IDENTIFICATION",
   "TIO_CP0_INTERNAL_RAM_PARITY_ERROR",
   "TIO_CP0_INTERRUPT_0_HOST_ADDRESS",
   "TIO_CP0_INTERRUPT_1_HOST_ADDRESS",
   "TIO_CP0_INTERRUPT_2_HOST_ADDRESS",
   "TIO_CP0_INTERRUPT_3_HOST_ADDRESS",
   "TIO_CP0_INTERRUPT_4_HOST_ADDRESS",
   "TIO_CP0_INTERRUPT_5_HOST_ADDRESS",
   "TIO_CP0_INTERRUPT_6_HOST_ADDRESS",
   "TIO_CP0_INTERRUPT_7_HOST_ADDRESS",
   "TIO_CP0_INTERRUPT_DEST_LOWER",
   "TIO_CP0_INTERRUPT_DEST_UPPER",
   "TIO_CP0_INTERRUPT_DEVICE",
   "TIO_CP0_INTERRUPT_ENABLE",
   "TIO_CP0_INTERRUPT_MODE",
   "TIO_CP0_INT_STATUS",
   "TIO_CP0_LINK_SIDE_ERROR_ADDR_HOLD",
   "TIO_CP0_LINK_SIDE_ERROR_CMD_WRD",
   "TIO_CP0_MULTIPLE_INTERRUPT",
   "TIO_CP0_MUX3_DEBUG_CTL",
   "TIO_CP0_MUX4_DEBUG_CTL",
   "TIO_CP0_MUX5_DEBUG_CTL",
   "TIO_CP0_MUX6_DEBUG_CTL",
   "TIO_CP0_MUX7_DEBUG_CTL",
   "TIO_CP0_ODD_READ_RSP_BUFFER",
   "TIO_CP0_PAGE_MAP_FAULT_ADD",
   "TIO_CP0_PCIX_TIMEOUT",
   "TIO_CP0_PCI_BUFFER_0_CLEAR",
   "TIO_CP0_PCI_BUFFER_0_FLUSH_COUNT_NOTOUCH",
   "TIO_CP0_PCI_BUFFER_0_FLUSH_COUNT_TOUCH",
   "TIO_CP0_PCI_BUFFER_0_MAX_LATENCY",
   "TIO_CP0_PCI_BUFFER_0_PREFETCH_COUNT",
   "TIO_CP0_PCI_BUFFER_0_REQ_COUNT",
   "TIO_CP0_PCI_BUFFER_0_RETRY_MAX_COUNT",
   "TIO_CP0_PCI_BUFFER_0_RETRY_TOTAL_COUNT",
   "TIO_CP0_PCI_BUFFER_1_CLEAR",
   "TIO_CP0_PCI_BUFFER_1_FLUSH_COUNT_NOTOUCH",
   "TIO_CP0_PCI_BUFFER_1_FLUSH_COUNT_TOUCH",
   "TIO_CP0_PCI_BUFFER_1_MAX_LATENCY",
   "TIO_CP0_PCI_BUFFER_1_PREFETCH_COUNT",
   "TIO_CP0_PCI_BUFFER_1_REQ_COUNT",
   "TIO_CP0_PCI_BUFFER_1_RETRY_MAX_COUNT",
   "TIO_CP0_PCI_BUFFER_1_RETRY_TOTAL_COUNT",
   "TIO_CP0_PCI_BUFFER_2_CLEAR",
   "TIO_CP0_PCI_BUFFER_2_FLUSH_COUNT_NOTOUCH",
   "TIO_CP0_PCI_BUFFER_2_FLUSH_COUNT_TOUCH",
   "TIO_CP0_PCI_BUFFER_2_MAX_LATENCY",
   "TIO_CP0_PCI_BUFFER_2_PREFETCH_COUNT",
   "TIO_CP0_PCI_BUFFER_2_REQ_COUNT",
   "TIO_CP0_PCI_BUFFER_2_RETRY_MAX_COUNT",
   "TIO_CP0_PCI_BUFFER_2_RETRY_TOTAL_COUNT",
   "TIO_CP0_PCI_BUFFER_3_CLEAR",
   "TIO_CP0_PCI_BUFFER_3_FLUSH_COUNT_NOTOUCH",
   "TIO_CP0_PCI_BUFFER_3_FLUSH_COUNT_TOUCH",
   "TIO_CP0_PCI_BUFFER_3_MAX_LATENCY",
   "TIO_CP0_PCI_BUFFER_3_PREFETCH_COUNT",
   "TIO_CP0_PCI_BUFFER_3_REQ_COUNT",
   "TIO_CP0_PCI_BUFFER_3_RETRY_MAX_COUNT",
   "TIO_CP0_PCI_BUFFER_3_RETRY_TOTAL_COUNT",
   "TIO_CP0_PCI_BUFFER_4_CLEAR",
   "TIO_CP0_PCI_BUFFER_4_FLUSH_COUNT_NOTOUCH",
   "TIO_CP0_PCI_BUFFER_4_FLUSH_COUNT_TOUCH",
   "TIO_CP0_PCI_BUFFER_4_MAX_LATENCY",
   "TIO_CP0_PCI_BUFFER_4_PREFETCH_COUNT",
   "TIO_CP0_PCI_BUFFER_4_REQ_COUNT",
   "TIO_CP0_PCI_BUFFER_4_RETRY_MAX_COUNT",
   "TIO_CP0_PCI_BUFFER_4_RETRY_TOTAL_COUNT",
   "TIO_CP0_PCI_BUFFER_5_CLEAR",
   "TIO_CP0_PCI_BUFFER_5_FLUSH_COUNT_NOTOUCH",
   "TIO_CP0_PCI_BUFFER_5_FLUSH_COUNT_TOUCH",
   "TIO_CP0_PCI_BUFFER_5_MAX_LATENCY",
   "TIO_CP0_PCI_BUFFER_5_PREFETCH_COUNT",
   "TIO_CP0_PCI_BUFFER_5_REQ_COUNT",
   "TIO_CP0_PCI_BUFFER_5_RETRY_MAX_COUNT",
   "TIO_CP0_PCI_BUFFER_5_RETRY_TOTAL_COUNT",
   "TIO_CP0_PCI_BUFFER_6_CLEAR",
   "TIO_CP0_PCI_BUFFER_6_FLUSH_COUNT_NOTOUCH",
   "TIO_CP0_PCI_BUFFER_6_FLUSH_COUNT_TOUCH",
   "TIO_CP0_PCI_BUFFER_6_MAX_LATENCY",
   "TIO_CP0_PCI_BUFFER_6_PREFETCH_COUNT",
   "TIO_CP0_PCI_BUFFER_6_REQ_COUNT",
   "TIO_CP0_PCI_BUFFER_6_RETRY_MAX_COUNT",
   "TIO_CP0_PCI_BUFFER_6_RETRY_TOTAL_COUNT",
   "TIO_CP0_PCI_BUFFER_7_CLEAR",
   "TIO_CP0_PCI_BUFFER_7_FLUSH_COUNT_NOTOUCH",
   "TIO_CP0_PCI_BUFFER_7_FLUSH_COUNT_TOUCH",
   "TIO_CP0_PCI_BUFFER_7_MAX_LATENCY",
   "TIO_CP0_PCI_BUFFER_7_PREFETCH_COUNT",
   "TIO_CP0_PCI_BUFFER_7_REQ_COUNT",
   "TIO_CP0_PCI_BUFFER_7_RETRY_MAX_COUNT",
   "TIO_CP0_PCI_BUFFER_7_RETRY_TOTAL_COUNT",
   "TIO_CP0_PCI_BUS_ERROR_ADDRESS",
   "TIO_CP0_PCI_BUS_ERROR_ATTRIBUTE",
   "TIO_CP0_PCI_BUS_ERROR_DATA",
   "TIO_CP0_PCI_DIRECT_MAPPING",
   "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_0",
   "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_1",
   "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_10",
   "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_11",
   "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_12",
   "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_13",
   "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_14",
   "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_15",
   "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_2",
   "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_3",
   "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_4",
   "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_5",
   "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_6",
   "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_7",
   "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_8",
   "TIO_CP0_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_9",
   "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_0",
   "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_1",
   "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_10",
   "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_11",
   "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_12",
   "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_13",
   "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_14",
   "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_15",
   "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_2",
   "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_3",
   "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_4",
   "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_5",
   "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_6",
   "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_7",
   "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_8",
   "TIO_CP0_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_9",
   "TIO_CP0_READ_RSP_BUFFER_CLEAR",
   "TIO_CP0_READ_RSP_BUFFER_STATUS",
   "TIO_CP0_REQUEST_TIMEOUT",
   "TIO_CP0_RESET_INTERRUPT",
   "TIO_CP0_RSP_BUFFER_LOWER",
   "TIO_CP0_RSP_BUFFER_UPPER",
   "TIO_CP0_SPLIT_REQUEST_ADDRESS",
   "TIO_CP0_SPLIT_REQUEST_ATTRIBUTE",
   "TIO_CP0_STATUS",
   "TIO_CP0_TARGET_FLUSH",
   "TIO_CP0_TIMEOUT",
   "TIO_CP0_TYPE1_CONFIGURATION",
   "TIO_CP1_ARBITRATION_PRIORITY",
   "TIO_CP1_BR_DEBUG_CTL",
   "TIO_CP1_BUS_ERROR_ADDR_LOWER",
   "TIO_CP1_BUS_ERROR_ADDR_UPPER",
   "TIO_CP1_BUS_SIDE_ERROR_ADDR_LOWER",
   "TIO_CP1_BUS_SIDE_ERROR_ADDR_UPPER",
   "TIO_CP1_BUS_SIDE_ERROR_CMD_WRD",
   "TIO_CP1_CONTROL",
   "TIO_CP1_CT_DEBUG_CTL",
   "TIO_CP1_DEBUG_PORT_CONTROL",
   "TIO_CP1_DEVICE_0",
   "TIO_CP1_DEVICE_0_WRITE_FLUSH",
   "TIO_CP1_DEVICE_1",
   "TIO_CP1_DEVICE_1_WRITE_FLUSH",
   "TIO_CP1_DEVICE_2",
   "TIO_CP1_DEVICE_2_WRITE_FLUSH",
   "TIO_CP1_DEVICE_3",
   "TIO_CP1_DEVICE_3_WRITE_FLUSH",
   "TIO_CP1_DMA_ERROR_ADDRESS",
   "TIO_CP1_DMA_ERROR_ATTRIBUTE",
   "TIO_CP1_ERROR_INTERRUPT_VIEW",
   "TIO_CP1_EVEN_READ_RSP_BUFFER",
   "TIO_CP1_FORCE_ALWAYS_INTERRUPT_0",
   "TIO_CP1_FORCE_ALWAYS_INTERRUPT_1",
   "TIO_CP1_FORCE_ALWAYS_INTERRUPT_2",
   "TIO_CP1_FORCE_ALWAYS_INTERRUPT_3",
   "TIO_CP1_FORCE_ALWAYS_INTERRUPT_4",
   "TIO_CP1_FORCE_ALWAYS_INTERRUPT_5",
   "TIO_CP1_FORCE_ALWAYS_INTERRUPT_6",
   "TIO_CP1_FORCE_ALWAYS_INTERRUPT_7",
   "TIO_CP1_FORCE_INTERRUPT_0",
   "TIO_CP1_FORCE_INTERRUPT_1",
   "TIO_CP1_FORCE_INTERRUPT_2",
   "TIO_CP1_FORCE_INTERRUPT_3",
   "TIO_CP1_FORCE_INTERRUPT_4",
   "TIO_CP1_FORCE_INTERRUPT_5",
   "TIO_CP1_FORCE_INTERRUPT_6",
   "TIO_CP1_FORCE_INTERRUPT_7",
   "TIO_CP1_HOST_ERROR_INTERRUPT",
   "TIO_CP1_IDENTIFICATION",
   "TIO_CP1_INTERNAL_RAM_PARITY_ERROR",
   "TIO_CP1_INTERRUPT_0_HOST_ADDRESS",
   "TIO_CP1_INTERRUPT_1_HOST_ADDRESS",
   "TIO_CP1_INTERRUPT_2_HOST_ADDRESS",
   "TIO_CP1_INTERRUPT_3_HOST_ADDRESS",
   "TIO_CP1_INTERRUPT_4_HOST_ADDRESS",
   "TIO_CP1_INTERRUPT_5_HOST_ADDRESS",
   "TIO_CP1_INTERRUPT_6_HOST_ADDRESS",
   "TIO_CP1_INTERRUPT_7_HOST_ADDRESS",
   "TIO_CP1_INTERRUPT_DEST_LOWER",
   "TIO_CP1_INTERRUPT_DEST_UPPER",
   "TIO_CP1_INTERRUPT_DEVICE",
   "TIO_CP1_INTERRUPT_ENABLE",
   "TIO_CP1_INTERRUPT_MODE",
   "TIO_CP1_INT_STATUS",
   "TIO_CP1_LINK_SIDE_ERROR_ADDR_HOLD",
   "TIO_CP1_LINK_SIDE_ERROR_CMD_WRD",
   "TIO_CP1_MULTIPLE_INTERRUPT",
   "TIO_CP1_MUX3_DEBUG_CTL",
   "TIO_CP1_MUX4_DEBUG_CTL",
   "TIO_CP1_MUX5_DEBUG_CTL",
   "TIO_CP1_MUX6_DEBUG_CTL",
   "TIO_CP1_MUX7_DEBUG_CTL",
   "TIO_CP1_ODD_READ_RSP_BUFFER",
   "TIO_CP1_PAGE_MAP_FAULT_ADD",
   "TIO_CP1_PCIX_TIMEOUT",
   "TIO_CP1_PCI_BUFFER_0_CLEAR",
   "TIO_CP1_PCI_BUFFER_0_FLUSH_COUNT_NOTOUCH",
   "TIO_CP1_PCI_BUFFER_0_FLUSH_COUNT_TOUCH",
   "TIO_CP1_PCI_BUFFER_0_MAX_LATENCY",
   "TIO_CP1_PCI_BUFFER_0_PREFETCH_COUNT",
   "TIO_CP1_PCI_BUFFER_0_REQ_COUNT",
   "TIO_CP1_PCI_BUFFER_0_RETRY_MAX_COUNT",
   "TIO_CP1_PCI_BUFFER_0_RETRY_TOTAL_COUNT",
   "TIO_CP1_PCI_BUFFER_1_CLEAR",
   "TIO_CP1_PCI_BUFFER_1_FLUSH_COUNT_NOTOUCH",
   "TIO_CP1_PCI_BUFFER_1_FLUSH_COUNT_TOUCH",
   "TIO_CP1_PCI_BUFFER_1_MAX_LATENCY",
   "TIO_CP1_PCI_BUFFER_1_PREFETCH_COUNT",
   "TIO_CP1_PCI_BUFFER_1_REQ_COUNT",
   "TIO_CP1_PCI_BUFFER_1_RETRY_MAX_COUNT",
   "TIO_CP1_PCI_BUFFER_1_RETRY_TOTAL_COUNT",
   "TIO_CP1_PCI_BUFFER_2_CLEAR",
   "TIO_CP1_PCI_BUFFER_2_FLUSH_COUNT_NOTOUCH",
   "TIO_CP1_PCI_BUFFER_2_FLUSH_COUNT_TOUCH",
   "TIO_CP1_PCI_BUFFER_2_MAX_LATENCY",
   "TIO_CP1_PCI_BUFFER_2_PREFETCH_COUNT",
   "TIO_CP1_PCI_BUFFER_2_REQ_COUNT",
   "TIO_CP1_PCI_BUFFER_2_RETRY_MAX_COUNT",
   "TIO_CP1_PCI_BUFFER_2_RETRY_TOTAL_COUNT",
   "TIO_CP1_PCI_BUFFER_3_CLEAR",
   "TIO_CP1_PCI_BUFFER_3_FLUSH_COUNT_NOTOUCH",
   "TIO_CP1_PCI_BUFFER_3_FLUSH_COUNT_TOUCH",
   "TIO_CP1_PCI_BUFFER_3_MAX_LATENCY",
   "TIO_CP1_PCI_BUFFER_3_PREFETCH_COUNT",
   "TIO_CP1_PCI_BUFFER_3_REQ_COUNT",
   "TIO_CP1_PCI_BUFFER_3_RETRY_MAX_COUNT",
   "TIO_CP1_PCI_BUFFER_3_RETRY_TOTAL_COUNT",
   "TIO_CP1_PCI_BUFFER_4_CLEAR",
   "TIO_CP1_PCI_BUFFER_4_FLUSH_COUNT_NOTOUCH",
   "TIO_CP1_PCI_BUFFER_4_FLUSH_COUNT_TOUCH",
   "TIO_CP1_PCI_BUFFER_4_MAX_LATENCY",
   "TIO_CP1_PCI_BUFFER_4_PREFETCH_COUNT",
   "TIO_CP1_PCI_BUFFER_4_REQ_COUNT",
   "TIO_CP1_PCI_BUFFER_4_RETRY_MAX_COUNT",
   "TIO_CP1_PCI_BUFFER_4_RETRY_TOTAL_COUNT",
   "TIO_CP1_PCI_BUFFER_5_CLEAR",
   "TIO_CP1_PCI_BUFFER_5_FLUSH_COUNT_NOTOUCH",
   "TIO_CP1_PCI_BUFFER_5_FLUSH_COUNT_TOUCH",
   "TIO_CP1_PCI_BUFFER_5_MAX_LATENCY",
   "TIO_CP1_PCI_BUFFER_5_PREFETCH_COUNT",
   "TIO_CP1_PCI_BUFFER_5_REQ_COUNT",
   "TIO_CP1_PCI_BUFFER_5_RETRY_MAX_COUNT",
   "TIO_CP1_PCI_BUFFER_5_RETRY_TOTAL_COUNT",
   "TIO_CP1_PCI_BUFFER_6_CLEAR",
   "TIO_CP1_PCI_BUFFER_6_FLUSH_COUNT_NOTOUCH",
   "TIO_CP1_PCI_BUFFER_6_FLUSH_COUNT_TOUCH",
   "TIO_CP1_PCI_BUFFER_6_MAX_LATENCY",
   "TIO_CP1_PCI_BUFFER_6_PREFETCH_COUNT",
   "TIO_CP1_PCI_BUFFER_6_REQ_COUNT",
   "TIO_CP1_PCI_BUFFER_6_RETRY_MAX_COUNT",
   "TIO_CP1_PCI_BUFFER_6_RETRY_TOTAL_COUNT",
   "TIO_CP1_PCI_BUFFER_7_CLEAR",
   "TIO_CP1_PCI_BUFFER_7_FLUSH_COUNT_NOTOUCH",
   "TIO_CP1_PCI_BUFFER_7_FLUSH_COUNT_TOUCH",
   "TIO_CP1_PCI_BUFFER_7_MAX_LATENCY",
   "TIO_CP1_PCI_BUFFER_7_PREFETCH_COUNT",
   "TIO_CP1_PCI_BUFFER_7_REQ_COUNT",
   "TIO_CP1_PCI_BUFFER_7_RETRY_MAX_COUNT",
   "TIO_CP1_PCI_BUFFER_7_RETRY_TOTAL_COUNT",
   "TIO_CP1_PCI_BUS_ERROR_ADDRESS",
   "TIO_CP1_PCI_BUS_ERROR_ATTRIBUTE",
   "TIO_CP1_PCI_BUS_ERROR_DATA",
   "TIO_CP1_PCI_DIRECT_MAPPING",
   "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_0",
   "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_1",
   "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_10",
   "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_11",
   "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_12",
   "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_13",
   "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_14",
   "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_15",
   "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_2",
   "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_3",
   "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_4",
   "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_5",
   "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_6",
   "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_7",
   "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_8",
   "TIO_CP1_PCI_READ_RSP_BUFFER_LOWER_ADDRESS_9",
   "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_0",
   "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_1",
   "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_10",
   "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_11",
   "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_12",
   "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_13",
   "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_14",
   "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_15",
   "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_2",
   "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_3",
   "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_4",
   "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_5",
   "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_6",
   "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_7",
   "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_8",
   "TIO_CP1_PCI_READ_RSP_BUFFER_UPPER_ADDRESS_9",
   "TIO_CP1_READ_RSP_BUFFER_CLEAR",
   "TIO_CP1_READ_RSP_BUFFER_STATUS",
   "TIO_CP1_REQUEST_TIMEOUT",
   "TIO_CP1_RESET_INTERRUPT",
   "TIO_CP1_RSP_BUFFER_LOWER",
   "TIO_CP1_RSP_BUFFER_UPPER",
   "TIO_CP1_SPLIT_REQUEST_ADDRESS",
   "TIO_CP1_SPLIT_REQUEST_ATTRIBUTE",
   "TIO_CP1_STATUS",
   "TIO_CP1_TARGET_FLUSH",
   "TIO_CP1_TIMEOUT",
   "TIO_CP1_TYPE1_CONFIGURATION",
   "TIO_CPU_ACCESS0",
   "TIO_CPU_ACCESS1",
   "TIO_CPU_ACCESS2",
   "TIO_CPU_ACCESS3",
   "TIO_CPU_PERM0",
   "TIO_CPU_PERM1",
   "TIO_CPU_PERM2",
   "TIO_CPU_PERM3",
   "TIO_CPU_PERM_OVR",
   "TIO_DEBUG_PORT",
   "TIO_DEBUG_SELECT",
   "TIO_DIAG_MSG_CNTRL",
   "TIO_DIAG_MSG_DATA0L",
   "TIO_DIAG_MSG_DATA0U",
   "TIO_DIAG_MSG_DATA1L",
   "TIO_DIAG_MSG_DATA1U",
   "TIO_DIAG_MSG_DATA2L",
   "TIO_DIAG_MSG_DATA2U",
   "TIO_DIAG_MSG_DATA3L",
   "TIO_DIAG_MSG_DATA3U",
   "TIO_DIAG_MSG_DATA4L",
   "TIO_DIAG_MSG_DATA4U",
   "TIO_DIAG_MSG_DATA5L",
   "TIO_DIAG_MSG_DATA5U",
   "TIO_DIAG_MSG_DATA6L",
   "TIO_DIAG_MSG_DATA6U",
   "TIO_DIAG_MSG_DATA7L",
   "TIO_DIAG_MSG_DATA7U",
   "TIO_DIAG_MSG_DATA8L",
   "TIO_DIAG_MSG_DATA8U",
   "TIO_DIAG_MSG_HDR0",
   "TIO_DIAG_MSG_HDR1",
   "TIO_ENABLE_RP_AUTO_REPLY",
   "TIO_ENABLE_RQ_AUTO_REPLY",
   "TIO_EVENT_OCCURRED",
   "TIO_EVENT_OCCURRED_ALIAS",
   "TIO_EVENT_OVERFLOW",
   "TIO_EVENT_OVERFLOW_ALIAS",
   "TIO_EXT_IOI_ACCESS0",
   "TIO_EXT_IOI_ACCESS1",
   "TIO_EXT_IOI_ACCESS2",
   "TIO_EXT_IOI_ACCESS3",
   "TIO_EXT_IO_PERM0",
   "TIO_EXT_IO_PERM1",
   "TIO_EXT_IO_PERM2",
   "TIO_EXT_IO_PERM3",
   "TIO_FIRST_ERROR",
   "TIO_GC_FIL_CTRL",
   "TIO_GC_SRC_CTRL",
   "TIO_HARD_RESET",
   "TIO_ICE_CMA_CFG",
   "TIO_ICE_CMA_CL0_DYN_CREDIT_STAT",
   "TIO_ICE_CMA_CL0_LAST_CREDIT_STAT",
   "TIO_ICE_CMA_CL1_DYN_CREDIT_STAT",
   "TIO_ICE_CMA_CL1_LAST_CREDIT_STAT",
   "TIO_ICE_CMA_CL2_DYN_CREDIT_STAT",
   "TIO_ICE_CMA_CL2_LAST_CREDIT_STAT",
   "TIO_ICE_CMA_CL3_DYN_CREDIT_STAT",
   "TIO_ICE_CMA_CL3_LAST_CREDIT_STAT",
   "TIO_ICE_CMA_CORELET_DBG_MUX_SELECT",
   "TIO_ICE_CMA_DBG_MUX_SELECT",
   "TIO_ICE_CMA_ERROR_OVERFLOW",
   "TIO_ICE_CMA_ERROR_OVERFLOW_ALIAS",
   "TIO_ICE_CMA_ERROR_SUMMARY",
   "TIO_ICE_CMA_ERROR_SUMMARY_ALIAS",
   "TIO_ICE_CMA_FIRST_ERROR",
   "TIO_ICE_CMA_PMI_DYN_CREDIT_STAT",
   "TIO_ICE_CMA_PMI_LAST_CREDIT_STAT",
   "TIO_ICE_CMA_PORT_CFG_0",
   "TIO_ICE_CMA_PORT_CFG_1",
   "TIO_ICE_CMA_PORT_CFG_2",
   "TIO_ICE_CMA_PORT_CFG_3",
   "TIO_ICE_CMA_READ_CFG",
   "TIO_ICE_CMA_SYNDROME",
   "TIO_ICE_CMA_TIMEOUT_CFG",
   "TIO_ICE_CMA_WRITE_CFG",
   "TIO_ICE_DEBUG_DATA",
   "TIO_ICE_FRZ_CFG",
   "TIO_ICE_FRZ_CHIPLET_ID_CONFIG",
   "TIO_ICE_FRZ_CPU_PERM0",
   "TIO_ICE_FRZ_CPU_PERM1",
   "TIO_ICE_FRZ_CPU_PERM2",
   "TIO_ICE_FRZ_CPU_PERM3",
   "TIO_ICE_FRZ_CT_ERROR_DETAIL_1",
   "TIO_ICE_FRZ_DBG_MUX_SELECT",
   "TIO_ICE_FRZ_DYN_CREDIT_STAT",
   "TIO_ICE_FRZ_ERROR_SUMMARY",
   "TIO_ICE_FRZ_ERROR_SUMMARY_ALIAS",
   "TIO_ICE_FRZ_EXT_IO_PERM0",
   "TIO_ICE_FRZ_EXT_IO_PERM1",
   "TIO_ICE_FRZ_EXT_IO_PERM2",
   "TIO_ICE_FRZ_EXT_IO_PERM3",
   "TIO_ICE_FRZ_FIRST_ERROR",
   "TIO_ICE_FRZ_GFX_BIG_WINDOW_0",
   "TIO_ICE_FRZ_GFX_BIG_WINDOW_1",
   "TIO_ICE_FRZ_GFX_BIG_WINDOW_2",
   "TIO_ICE_FRZ_GFX_BIG_WINDOW_3",
   "TIO_ICE_FRZ_GFX_BIG_WINDOW_4",
   "TIO_ICE_FRZ_GFX_BIG_WINDOW_5",
   "TIO_ICE_FRZ_GFX_BIG_WINDOW_6",
   "TIO_ICE_FRZ_GFX_BIG_WINDOW_7",
   "TIO_ICE_FRZ_GRC_CREDIT",
   "TIO_ICE_FRZ_GRC_GFX_RSP_0",
   "TIO_ICE_FRZ_GRC_GFX_RSP_1",
   "TIO_ICE_FRZ_GRC_GFX_RSP_2",
   "TIO_ICE_FRZ_GRC_GFX_RSP_3",
   "TIO_ICE_FRZ_GRC_GFX_RSP_4",
   "TIO_ICE_FRZ_GRC_GFX_RSP_5",
   "TIO_ICE_FRZ_GRC_GFX_RSP_6",
   "TIO_ICE_FRZ_GRC_GFX_RSP_7",
   "TIO_ICE_FRZ_GRC_SIR_0",
   "TIO_ICE_FRZ_GRC_SIR_1",
   "TIO_ICE_FRZ_GRC_SIR_2",
   "TIO_ICE_FRZ_GRC_SIR_3",
   "TIO_ICE_FRZ_LAST_CREDIT_STAT",
   "TIO_ICE_FRZ_PIO_BIG_WINDOW_1",
   "TIO_ICE_FRZ_PIO_BIG_WINDOW_2",
   "TIO_ICE_FRZ_PIO_BIG_WINDOW_3",
   "TIO_ICE_FRZ_PIO_BIG_WINDOW_4",
   "TIO_ICE_FRZ_PIO_BIG_WINDOW_5",
   "TIO_ICE_FRZ_PIO_BIG_WINDOW_6",
   "TIO_ICE_FRZ_PIO_BIG_WINDOW_7",
   "TIO_ICE_FRZ_PIO_HUGE_WINDOW",
   "TIO_ICE_FRZ_PRB_0",
   "TIO_ICE_FRZ_PRB_1",
   "TIO_ICE_FRZ_PRB_10",
   "TIO_ICE_FRZ_PRB_11",
   "TIO_ICE_FRZ_PRB_12",
   "TIO_ICE_FRZ_PRB_13",
   "TIO_ICE_FRZ_PRB_14",
   "TIO_ICE_FRZ_PRB_15",
   "TIO_ICE_FRZ_PRB_16",
   "TIO_ICE_FRZ_PRB_17",
   "TIO_ICE_FRZ_PRB_18",
   "TIO_ICE_FRZ_PRB_19",
   "TIO_ICE_FRZ_PRB_2",
   "TIO_ICE_FRZ_PRB_20",
   "TIO_ICE_FRZ_PRB_21",
   "TIO_ICE_FRZ_PRB_22",
   "TIO_ICE_FRZ_PRB_23",
   "TIO_ICE_FRZ_PRB_24",
   "TIO_ICE_FRZ_PRB_25",
   "TIO_ICE_FRZ_PRB_26",
   "TIO_ICE_FRZ_PRB_27",
   "TIO_ICE_FRZ_PRB_28",
   "TIO_ICE_FRZ_PRB_29",
   "TIO_ICE_FRZ_PRB_3",
   "TIO_ICE_FRZ_PRB_30",
   "TIO_ICE_FRZ_PRB_31",
   "TIO_ICE_FRZ_PRB_4",
   "TIO_ICE_FRZ_PRB_5",
   "TIO_ICE_FRZ_PRB_6",
   "TIO_ICE_FRZ_PRB_7",
   "TIO_ICE_FRZ_PRB_8",
   "TIO_ICE_FRZ_PRB_9",
   "TIO_ICE_FRZ_PRB_TIMEOUT_DETAIL",
   "TIO_ICE_FRZ_RIQ_LAST_STAT",
   "TIO_ICE_FRZ_RIQ_STAT",
   "TIO_ICE_FRZ_XN_ERROR_DETAIL_1A",
   "TIO_ICE_FRZ_XN_ERROR_DETAIL_1B",
   "TIO_ICE_FRZ_XN_ERROR_DETAIL_2A",
   "TIO_ICE_FRZ_XN_ERROR_DETAIL_2B",
   "TIO_ICE_GMS_DBG_MUX_SELECT",
   "TIO_ICE_GMS_DBG_TRIG_COMPARE",
   "TIO_ICE_GMS_DBG_TRIG_ENABLE",
   "TIO_ICE_GMS_DBG_TRIG_SELECT",
   "TIO_ICE_GMS_ERROR_MASK",
   "TIO_ICE_GMS_ERROR_OVERFLOW",
   "TIO_ICE_GMS_ERROR_OVERFLOW_ALIAS",
   "TIO_ICE_GMS_ERROR_SUMMARY",
   "TIO_ICE_GMS_ERROR_SUMMARY_ALIAS",
   "TIO_ICE_GMS_FIRST_ERROR",
   "TIO_ICE_GMS_REQ_NACK_LIMIT",
   "TIO_ICE_GMS_REQ_PRIORITY",
   "TIO_ICE_GMS_TIMEOUT_PRESCALE",
   "TIO_ICE_GMS_TIMEOUT_PULSE",
   "TIO_ICE_HW_TIME_STAMP",
   "TIO_ICE_NPA_DBG_MUX_SELECT",
   "TIO_ICE_NPA_ERROR_SUMMARY",
   "TIO_ICE_NPA_ERROR_SUMMARY_ALIAS",
   "TIO_ICE_NPA_FIRST_ERROR",
   "TIO_ICE_NPA_HQ_EJECT_HEAD",
   "TIO_ICE_NPA_HQ_ENTRY0",
   "TIO_ICE_NPA_HQ_VAL_DETAIL0",
   "TIO_ICE_NPA_HQ_VAL_DETAIL1",
   "TIO_ICE_NPA_NIQ_DYN_CREDIT_STAT",
   "TIO_ICE_NPA_NIQ_LAST_CREDIT_STAT",
   "TIO_ICE_NPA_NIQ_REQ_CFG",
   "TIO_ICE_NPA_NIQ_RSP_CFG",
   "TIO_ICE_NPA_NOQ_DYN_CREDIT_STAT",
   "TIO_ICE_NPA_NOQ_LAST_CREDIT_STAT",
   "TIO_ICE_NPA_NOQ_REQ_CFG",
   "TIO_ICE_NPA_NOQ_RSP_CFG",
   "TIO_ICE_NPA_RD_ACC_CFG",
   "TIO_ICE_NPA_RD_REQ_CFG",
   "TIO_ICE_NPA_RD_WR_DYN_CREDIT_STAT",
   "TIO_ICE_NPA_RD_WR_LAST_CREDIT_STAT",
   "TIO_ICE_NPA_RIQ_CFG",
   "TIO_ICE_NPA_RIQ_DYN_STAT",
   "TIO_ICE_NPA_RIQ_LAST_STAT",
   "TIO_ICE_NPA_WR_ACC_CFG",
   "TIO_ICE_NPA_WR_REQ_CFG",
   "TIO_ICE_NPA_XN_DATA0_CMP",
   "TIO_ICE_NPA_XN_DATA0_EN",
   "TIO_ICE_NPA_XN_DATA1_CMP",
   "TIO_ICE_NPA_XN_DATA1_EN",
   "TIO_ICE_NPA_XN_ERROR_DETAIL_1",
   "TIO_ICE_NPA_XN_ERROR_DETAIL_2",
   "TIO_ICE_PMI_RX_CT_DATA0_CMP",
   "TIO_ICE_PMI_RX_CT_DATA0_EN",
   "TIO_ICE_PMI_RX_CT_DATA1_CMP",
   "TIO_ICE_PMI_RX_CT_DATA1_EN",
   "TIO_ICE_PMI_RX_CT_ERROR_DETAIL_1",
   "TIO_ICE_PMI_RX_CT_ERROR_DETAIL_2",
   "TIO_ICE_PMI_RX_DBG_MUX_SELECT",
   "TIO_ICE_PMI_RX_ERROR_SUMMARY",
   "TIO_ICE_PMI_RX_ERROR_SUMMARY_ALIAS",
   "TIO_ICE_PMI_RX_FIRST_ERROR",
   "TIO_ICE_PMI_RX_REQ_BUF_CFG",
   "TIO_ICE_PMI_RX_REQ_DYN_CREDIT_STAT",
   "TIO_ICE_PMI_RX_REQ_LAST_CREDIT_STAT",
   "TIO_ICE_PMI_RX_RSP_BUF_CFG",
   "TIO_ICE_PMI_RX_RSP_DYN_CREDIT_STAT",
   "TIO_ICE_PMI_RX_RSP_LAST_CREDIT_STAT",
   "TIO_ICE_PMI_TX_CFG",
   "TIO_ICE_PMI_TX_CREDIT_CFG_CB0",
   "TIO_ICE_PMI_TX_CREDIT_CFG_CB1",
   "TIO_ICE_PMI_TX_CREDIT_CFG_CB2",
   "TIO_ICE_PMI_TX_CREDIT_CFG_CB3",
   "TIO_ICE_PMI_TX_DYN_CREDIT_STAT_CB0",
   "TIO_ICE_PMI_TX_DYN_CREDIT_STAT_CB1",
   "TIO_ICE_PMI_TX_DYN_CREDIT_STAT_CB2",
   "TIO_ICE_PMI_TX_DYN_CREDIT_STAT_CB3",
   "TIO_ICE_PMI_TX_ERROR_OF_ALIAS",
   "TIO_ICE_PMI_TX_ERROR_OVERFLOW",
   "TIO_ICE_PMI_TX_ERROR_SUMMARY",
   "TIO_ICE_PMI_TX_ERROR_SUMMARY_ALIAS",
   "TIO_ICE_PMI_TX_FIRST_ERROR",
   "TIO_ICE_PMI_TX_FORCE_ECC_ERR",
   "TIO_ICE_PMI_TX_LAST_CRED_STAT",
   "TIO_ICE_PMI_TX_NACK_CFG_CB0",
   "TIO_ICE_PMI_TX_NACK_CFG_CB1",
   "TIO_ICE_PMI_TX_NACK_CFG_CB2",
   "TIO_ICE_PMI_TX_NACK_CFG_CB3",
   "TIO_ICE_PMI_TX_NACK_STAT_CB0",
   "TIO_ICE_PMI_TX_NACK_STAT_CB1",
   "TIO_ICE_PMI_TX_NACK_STAT_CB2",
   "TIO_ICE_PMI_TX_NACK_STAT_CB3",
   "TIO_ICE_RRC_CFG",
   "TIO_ICE_RRC_CRB_0",
   "TIO_ICE_RRC_CRB_1",
   "TIO_ICE_RRC_CRB_10",
   "TIO_ICE_RRC_CRB_11",
   "TIO_ICE_RRC_CRB_12",
   "TIO_ICE_RRC_CRB_13",
   "TIO_ICE_RRC_CRB_14",
   "TIO_ICE_RRC_CRB_15",
   "TIO_ICE_RRC_CRB_16",
   "TIO_ICE_RRC_CRB_17",
   "TIO_ICE_RRC_CRB_18",
   "TIO_ICE_RRC_CRB_19",
   "TIO_ICE_RRC_CRB_2",
   "TIO_ICE_RRC_CRB_20",
   "TIO_ICE_RRC_CRB_21",
   "TIO_ICE_RRC_CRB_22",
   "TIO_ICE_RRC_CRB_23",
   "TIO_ICE_RRC_CRB_24",
   "TIO_ICE_RRC_CRB_25",
   "TIO_ICE_RRC_CRB_26",
   "TIO_ICE_RRC_CRB_27",
   "TIO_ICE_RRC_CRB_28",
   "TIO_ICE_RRC_CRB_29",
   "TIO_ICE_RRC_CRB_3",
   "TIO_ICE_RRC_CRB_30",
   "TIO_ICE_RRC_CRB_31",
   "TIO_ICE_RRC_CRB_32",
   "TIO_ICE_RRC_CRB_33",
   "TIO_ICE_RRC_CRB_34",
   "TIO_ICE_RRC_CRB_35",
   "TIO_ICE_RRC_CRB_36",
   "TIO_ICE_RRC_CRB_37",
   "TIO_ICE_RRC_CRB_38",
   "TIO_ICE_RRC_CRB_39",
   "TIO_ICE_RRC_CRB_4",
   "TIO_ICE_RRC_CRB_40",
   "TIO_ICE_RRC_CRB_41",
   "TIO_ICE_RRC_CRB_42",
   "TIO_ICE_RRC_CRB_43",
   "TIO_ICE_RRC_CRB_44",
   "TIO_ICE_RRC_CRB_45",
   "TIO_ICE_RRC_CRB_46",
   "TIO_ICE_RRC_CRB_47",
   "TIO_ICE_RRC_CRB_48",
   "TIO_ICE_RRC_CRB_49",
   "TIO_ICE_RRC_CRB_5",
   "TIO_ICE_RRC_CRB_50",
   "TIO_ICE_RRC_CRB_51",
   "TIO_ICE_RRC_CRB_52",
   "TIO_ICE_RRC_CRB_53",
   "TIO_ICE_RRC_CRB_54",
   "TIO_ICE_RRC_CRB_55",
   "TIO_ICE_RRC_CRB_56",
   "TIO_ICE_RRC_CRB_57",
   "TIO_ICE_RRC_CRB_58",
   "TIO_ICE_RRC_CRB_59",
   "TIO_ICE_RRC_CRB_6",
   "TIO_ICE_RRC_CRB_60",
   "TIO_ICE_RRC_CRB_61",
   "TIO_ICE_RRC_CRB_62",
   "TIO_ICE_RRC_CRB_63",
   "TIO_ICE_RRC_CRB_7",
   "TIO_ICE_RRC_CRB_8",
   "TIO_ICE_RRC_CRB_9",
   "TIO_ICE_RRC_CRB_ADDR_0",
   "TIO_ICE_RRC_CRB_ADDR_1",
   "TIO_ICE_RRC_CRB_ADDR_10",
   "TIO_ICE_RRC_CRB_ADDR_11",
   "TIO_ICE_RRC_CRB_ADDR_12",
   "TIO_ICE_RRC_CRB_ADDR_13",
   "TIO_ICE_RRC_CRB_ADDR_14",
   "TIO_ICE_RRC_CRB_ADDR_15",
   "TIO_ICE_RRC_CRB_ADDR_16",
   "TIO_ICE_RRC_CRB_ADDR_17",
   "TIO_ICE_RRC_CRB_ADDR_18",
   "TIO_ICE_RRC_CRB_ADDR_19",
   "TIO_ICE_RRC_CRB_ADDR_2",
   "TIO_ICE_RRC_CRB_ADDR_20",
   "TIO_ICE_RRC_CRB_ADDR_21",
   "TIO_ICE_RRC_CRB_ADDR_22",
   "TIO_ICE_RRC_CRB_ADDR_23",
   "TIO_ICE_RRC_CRB_ADDR_24",
   "TIO_ICE_RRC_CRB_ADDR_25",
   "TIO_ICE_RRC_CRB_ADDR_26",
   "TIO_ICE_RRC_CRB_ADDR_27",
   "TIO_ICE_RRC_CRB_ADDR_28",
   "TIO_ICE_RRC_CRB_ADDR_29",
   "TIO_ICE_RRC_CRB_ADDR_3",
   "TIO_ICE_RRC_CRB_ADDR_30",
   "TIO_ICE_RRC_CRB_ADDR_31",
   "TIO_ICE_RRC_CRB_ADDR_32",
   "TIO_ICE_RRC_CRB_ADDR_33",
   "TIO_ICE_RRC_CRB_ADDR_34",
   "TIO_ICE_RRC_CRB_ADDR_35",
   "TIO_ICE_RRC_CRB_ADDR_36",
   "TIO_ICE_RRC_CRB_ADDR_37",
   "TIO_ICE_RRC_CRB_ADDR_38",
   "TIO_ICE_RRC_CRB_ADDR_39",
   "TIO_ICE_RRC_CRB_ADDR_4",
   "TIO_ICE_RRC_CRB_ADDR_40",
   "TIO_ICE_RRC_CRB_ADDR_41",
   "TIO_ICE_RRC_CRB_ADDR_42",
   "TIO_ICE_RRC_CRB_ADDR_43",
   "TIO_ICE_RRC_CRB_ADDR_44",
   "TIO_ICE_RRC_CRB_ADDR_45",
   "TIO_ICE_RRC_CRB_ADDR_46",
   "TIO_ICE_RRC_CRB_ADDR_47",
   "TIO_ICE_RRC_CRB_ADDR_48",
   "TIO_ICE_RRC_CRB_ADDR_49",
   "TIO_ICE_RRC_CRB_ADDR_5",
   "TIO_ICE_RRC_CRB_ADDR_50",
   "TIO_ICE_RRC_CRB_ADDR_51",
   "TIO_ICE_RRC_CRB_ADDR_52",
   "TIO_ICE_RRC_CRB_ADDR_53",
   "TIO_ICE_RRC_CRB_ADDR_54",
   "TIO_ICE_RRC_CRB_ADDR_55",
   "TIO_ICE_RRC_CRB_ADDR_56",
   "TIO_ICE_RRC_CRB_ADDR_57",
   "TIO_ICE_RRC_CRB_ADDR_58",
   "TIO_ICE_RRC_CRB_ADDR_59",
   "TIO_ICE_RRC_CRB_ADDR_6",
   "TIO_ICE_RRC_CRB_ADDR_60",
   "TIO_ICE_RRC_CRB_ADDR_61",
   "TIO_ICE_RRC_CRB_ADDR_62",
   "TIO_ICE_RRC_CRB_ADDR_63",
   "TIO_ICE_RRC_CRB_ADDR_7",
   "TIO_ICE_RRC_CRB_ADDR_8",
   "TIO_ICE_RRC_CRB_ADDR_9",
   "TIO_ICE_RRC_CT_ERROR_DETAIL_1",
   "TIO_ICE_RRC_CT_ERROR_DETAIL_2",
   "TIO_ICE_RRC_DBG_MUX_SELECT",
   "TIO_ICE_RRC_DYN_CREDIT_STAT",
   "TIO_ICE_RRC_ERROR_SUMMARY",
   "TIO_ICE_RRC_ERROR_SUMMARY_ALIAS",
   "TIO_ICE_RRC_FIRST_ERROR",
   "TIO_ICE_RRC_IQ_STAT",
   "TIO_ICE_RRC_LAST_CREDIT_STAT",
   "TIO_ICE_RRC_TIMEOUT_DETAIL",
   "TIO_ICE_RRC_XN_ERROR_DETAIL_1",
   "TIO_ICE_RRC_XN_ERROR_DETAIL_2",
   "TIO_ICE_WRC_CFG",
   "TIO_ICE_WRC_CRB_0",
   "TIO_ICE_WRC_CRB_1",
   "TIO_ICE_WRC_CRB_10",
   "TIO_ICE_WRC_CRB_11",
   "TIO_ICE_WRC_CRB_12",
   "TIO_ICE_WRC_CRB_13",
   "TIO_ICE_WRC_CRB_14",
   "TIO_ICE_WRC_CRB_15",
   "TIO_ICE_WRC_CRB_16",
   "TIO_ICE_WRC_CRB_17",
   "TIO_ICE_WRC_CRB_18",
   "TIO_ICE_WRC_CRB_19",
   "TIO_ICE_WRC_CRB_2",
   "TIO_ICE_WRC_CRB_20",
   "TIO_ICE_WRC_CRB_21",
   "TIO_ICE_WRC_CRB_22",
   "TIO_ICE_WRC_CRB_23",
   "TIO_ICE_WRC_CRB_24",
   "TIO_ICE_WRC_CRB_25",
   "TIO_ICE_WRC_CRB_26",
   "TIO_ICE_WRC_CRB_27",
   "TIO_ICE_WRC_CRB_28",
   "TIO_ICE_WRC_CRB_29",
   "TIO_ICE_WRC_CRB_3",
   "TIO_ICE_WRC_CRB_30",
   "TIO_ICE_WRC_CRB_31",
   "TIO_ICE_WRC_CRB_4",
   "TIO_ICE_WRC_CRB_5",
   "TIO_ICE_WRC_CRB_6",
   "TIO_ICE_WRC_CRB_7",
   "TIO_ICE_WRC_CRB_8",
   "TIO_ICE_WRC_CRB_9",
   "TIO_ICE_WRC_CRB_ADDR_0",
   "TIO_ICE_WRC_CRB_ADDR_1",
   "TIO_ICE_WRC_CRB_ADDR_10",
   "TIO_ICE_WRC_CRB_ADDR_11",
   "TIO_ICE_WRC_CRB_ADDR_12",
   "TIO_ICE_WRC_CRB_ADDR_13",
   "TIO_ICE_WRC_CRB_ADDR_14",
   "TIO_ICE_WRC_CRB_ADDR_15",
   "TIO_ICE_WRC_CRB_ADDR_16",
   "TIO_ICE_WRC_CRB_ADDR_17",
   "TIO_ICE_WRC_CRB_ADDR_18",
   "TIO_ICE_WRC_CRB_ADDR_19",
   "TIO_ICE_WRC_CRB_ADDR_2",
   "TIO_ICE_WRC_CRB_ADDR_20",
   "TIO_ICE_WRC_CRB_ADDR_21",
   "TIO_ICE_WRC_CRB_ADDR_22",
   "TIO_ICE_WRC_CRB_ADDR_23",
   "TIO_ICE_WRC_CRB_ADDR_24",
   "TIO_ICE_WRC_CRB_ADDR_25",
   "TIO_ICE_WRC_CRB_ADDR_26",
   "TIO_ICE_WRC_CRB_ADDR_27",
   "TIO_ICE_WRC_CRB_ADDR_28",
   "TIO_ICE_WRC_CRB_ADDR_29",
   "TIO_ICE_WRC_CRB_ADDR_3",
   "TIO_ICE_WRC_CRB_ADDR_30",
   "TIO_ICE_WRC_CRB_ADDR_31",
   "TIO_ICE_WRC_CRB_ADDR_4",
   "TIO_ICE_WRC_CRB_ADDR_5",
   "TIO_ICE_WRC_CRB_ADDR_6",
   "TIO_ICE_WRC_CRB_ADDR_7",
   "TIO_ICE_WRC_CRB_ADDR_8",
   "TIO_ICE_WRC_CRB_ADDR_9",
   "TIO_ICE_WRC_CT_ERROR_DETAIL_1",
   "TIO_ICE_WRC_CT_ERROR_DETAIL_2",
   "TIO_ICE_WRC_DBG_MUX_SELECT",
   "TIO_ICE_WRC_DYN_CREDIT_STAT",
   "TIO_ICE_WRC_ERROR_SUMMARY",
   "TIO_ICE_WRC_ERROR_SUMMARY_ALIAS",
   "TIO_ICE_WRC_FIRST_ERROR",
   "TIO_ICE_WRC_IQ_STAT",
   "TIO_ICE_WRC_LAST_CREDIT_STAT",
   "TIO_ICE_WRC_TIMEOUT_DETAIL",
   "TIO_ICE_WRC_XN_ERROR_DETAIL_1",
   "TIO_ICE_WRC_XN_ERROR_DETAIL_2",
   "TIO_IILB_GLOBAL_TABLE",
   "TIO_IILB_LOCAL_TABLE",
   "TIO_IILB_OVER_RIDE_TABLE",
   "TIO_INT0",
   "TIO_INT0_CONFIG",
   "TIO_INT0_ENABLE",
   "TIO_INT1",
   "TIO_INT1_CONFIG",
   "TIO_INT1_ENABLE",
   "TIO_INT2",
   "TIO_INT2_CONFIG",
   "TIO_INT2_ENABLE",
   "TIO_INT3",
   "TIO_INT3_CONFIG",
   "TIO_INT3_ENABLE",
   "TIO_INT4",
   "TIO_INT4_CONFIG",
   "TIO_INT4_ENABLE",
   "TIO_INT5",
   "TIO_INT5_CONFIG",
   "TIO_INT5_ENABLE",
   "TIO_INT6",
   "TIO_INT6_CONFIG",
   "TIO_INT6_ENABLE",
   "TIO_INT7",
   "TIO_INT7_CONFIG",
   "TIO_INT7_ENABLE",
   "TIO_INT_NODE_ID_CONFIG",
   "TIO_JTAG_CONFIG",
   "TIO_L1_TO_ASIC_DATA",
   "TIO_L1_TO_ASIC_STATUS",
   "TIO_LB_COMPARE_COMPARE",
   "TIO_LB_CREDIT_STATUS",
   "TIO_LB_DEBUG_COMPARE_SEL",
   "TIO_LB_DEBUG_DATA",
   "TIO_LB_DEBUG_LOCAL_SEL",
   "TIO_LB_DEBUG_MUX0_SEL",
   "TIO_LB_DEBUG_MUX1_SEL",
   "TIO_LB_ERROR_DETAIL_1",
   "TIO_LB_ERROR_DETAIL_2",
   "TIO_LB_ERROR_DETAIL_3",
   "TIO_LB_ERROR_DETAIL_4",
   "TIO_LB_ERROR_MASK",
   "TIO_LB_ERROR_OVERFLOW",
   "TIO_LB_ERROR_OVERFLOW_ALIAS",
   "TIO_LB_ERROR_SUMMARY",
   "TIO_LB_ERROR_SUMMARY_ALIAS",
   "TIO_LB_FIRST_ERROR",
   "TIO_LB_HW_TIME_STAMP",
   "TIO_LB_LAST_CREDIT",
   "TIO_LB_LIQ_CTL",
   "TIO_LB_LOQ_CTL",
   "TIO_LB_MAX_REP_CREDIT_CNT",
   "TIO_LB_MAX_REQ_CREDIT_CNT",
   "TIO_LB_TRIGGER_DATA",
   "TIO_LOCAL_INT0_CONFIG",
   "TIO_LOCAL_INT0_ENABLE",
   "TIO_LOCAL_INT1_CONFIG",
   "TIO_LOCAL_INT1_ENABLE",
   "TIO_LOCAL_INT2_CONFIG",
   "TIO_LOCAL_INT2_ENABLE",
   "TIO_LOCAL_INT3_CONFIG",
   "TIO_LOCAL_INT3_ENABLE",
   "TIO_LOCAL_INT4_CONFIG",
   "TIO_LOCAL_INT4_ENABLE",
   "TIO_LOCAL_INT5_CONFIG",
   "TIO_LOCAL_INT5_ENABLE",
   "TIO_LOGIC_ANALYZER_BUFFER",
   "TIO_NI0_ERROR_DETAIL_1",
   "TIO_NI0_ERROR_DETAIL_2",
   "TIO_NI0_ERROR_DETAIL_3",
   "TIO_NI0_ERROR_MASK_1",
   "TIO_NI0_ERROR_MASK_2",
   "TIO_NI0_ERROR_OVERFLOW_1",
   "TIO_NI0_ERROR_OVERFLOW_1_ALIAS",
   "TIO_NI0_ERROR_OVERFLOW_2",
   "TIO_NI0_ERROR_OVERFLOW_2_ALIAS",
   "TIO_NI0_ERROR_SUMMARY_1",
   "TIO_NI0_ERROR_SUMMARY_1_ALIAS",
   "TIO_NI0_ERROR_SUMMARY_2",
   "TIO_NI0_ERROR_SUMMARY_2_ALIAS",
   "TIO_NI0_FIRST_ERROR_1",
   "TIO_NI0_FIRST_ERROR_2",
   "TIO_NI0_GLOBAL_TABLE",
   "TIO_NI0_LLP_CAPT_SBCB",
   "TIO_NI0_LLP_CAPT_WD1",
   "TIO_NI0_LLP_CAPT_WD2",
   "TIO_NI0_LLP_CHAN_MODE",
   "TIO_NI0_LLP_CONFIG",
   "TIO_NI0_LLP_ERR",
   "TIO_NI0_LLP_RESET",
   "TIO_NI0_LLP_RESET_EN",
   "TIO_NI0_LLP_STAT",
   "TIO_NI0_LLP_TEST_CTL",
   "TIO_NI0_LOCAL_TABLE",
   "TIO_NI0_OVER_RIDE_TABLE",
   "TIO_NI1_ERROR_DETAIL_1",
   "TIO_NI1_ERROR_DETAIL_2",
   "TIO_NI1_ERROR_DETAIL_3",
   "TIO_NI1_ERROR_MASK_1",
   "TIO_NI1_ERROR_MASK_2",
   "TIO_NI1_ERROR_OVERFLOW_1",
   "TIO_NI1_ERROR_OVERFLOW_1_ALIAS",
   "TIO_NI1_ERROR_OVERFLOW_2",
   "TIO_NI1_ERROR_OVERFLOW_2_ALIAS",
   "TIO_NI1_ERROR_SUMMARY_1",
   "TIO_NI1_ERROR_SUMMARY_1_ALIAS",
   "TIO_NI1_ERROR_SUMMARY_2",
   "TIO_NI1_ERROR_SUMMARY_2_ALIAS",
   "TIO_NI1_FIRST_ERROR_1",
   "TIO_NI1_FIRST_ERROR_2",
   "TIO_NI1_GLOBAL_TABLE",
   "TIO_NI1_LLP_CAPT_SBCB",
   "TIO_NI1_LLP_CAPT_WD1",
   "TIO_NI1_LLP_CAPT_WD2",
   "TIO_NI1_LLP_CHAN_MODE",
   "TIO_NI1_LLP_CONFIG",
   "TIO_NI1_LLP_ERR",
   "TIO_NI1_LLP_RESET",
   "TIO_NI1_LLP_RESET_EN",
   "TIO_NI1_LLP_STAT",
   "TIO_NI1_LLP_TEST_CTL",
   "TIO_NI1_LOCAL_TABLE",
   "TIO_NI1_OVER_RIDE_TABLE",
   "TIO_NODE_ID",
   "TIO_OB_LA_CONTROL",
   "TIO_OB_LA_CURRENT_ADDR",
   "TIO_OB_LA_END_ADDRESS",
   "TIO_OB_LA_SEQUENCE",
   "TIO_OB_LA_START_ADDRESS",
   "TIO_OB_LA_START_CONTROL",
   "TIO_OB_LA_STATUS",
   "TIO_OB_LA_STOP_CONTROL",
   "TIO_PERFORMANCE_COUNT0_CONTROL",
   "TIO_PERFORMANCE_COUNT1_CONTROL",
   "TIO_PERFORMANCE_COUNT2_CONTROL",
   "TIO_PERFORMANCE_COUNT3_CONTROL",
   "TIO_PERFORMANCE_COUNT4_CONTROL",
   "TIO_PERFORMANCE_COUNT5_CONTROL",
   "TIO_PERFORMANCE_COUNT6_CONTROL",
   "TIO_PERFORMANCE_COUNT7_CONTROL",
   "TIO_PERFORMANCE_COUNTER0",
   "TIO_PERFORMANCE_COUNTER1",
   "TIO_PERFORMANCE_COUNTER2",
   "TIO_PERFORMANCE_COUNTER3",
   "TIO_PERFORMANCE_COUNTER4",
   "TIO_PERFORMANCE_COUNTER5",
   "TIO_PERFORMANCE_COUNTER6",
   "TIO_PERFORMANCE_COUNTER7",
   "TIO_PERFORMANCE_MONITOR_DESKEW",
   "TIO_PIO_TIME_OUT",
   "TIO_PROFILE_COUNTER",
   "TIO_PROFILE_DN_CONTROL",
   "TIO_PROFILE_PEAK",
   "TIO_PROFILE_PEAK_CONTROL",
   "TIO_PROFILE_RANGE",
   "TIO_PROFILE_UP_CONTROL",
   "TIO_RTC",
   "TIO_SCRATCH0",
   "TIO_SCRATCH0_ALIAS",
   "TIO_SCRATCH1",
   "TIO_SCRATCH1_ALIAS",
   "TIO_SCRATCH2",
   "TIO_SCRATCH2_ALIAS",
   "TIO_SCRATCH3",
   "TIO_SCRATCH3_ALIAS",
   "TIO_SCRATCH4",
   "TIO_SCRATCH4_ALIAS",
   "TIO_SOFT_RESET",
   "TIO_STOP_CLK_CONTROL",
   "TIO_STOP_CLK_DELAY_PHASE",
   "TIO_THROTTLE_ENABLE",
   "TIO_THROTTLE_INTERVAL",
   "TIO_THROTTLE_STATUS",
   "TIO_THROTTLE_TIME",
   "TIO_TSF_ARMED_STATE",
   "TIO_TSF_ARM_MASK",
   "TIO_TSF_COUNTER_PRESETS",
   "TIO_TSF_COUNTER_VALUE",
   "TIO_TSF_DECREMENT_CTL",
   "TIO_TSF_DIAG_MSG_CTL",
   "TIO_TSF_DISARM_MASK",
   "TIO_TSF_ENABLE_CTL",
   "TIO_TSF_SOFTWARE_ARM",
   "TIO_TSF_SOFTWARE_DISARM",
   "TIO_TSF_SOFTWARE_TRIGGERED",
   "TIO_TSF_TRIGGERED_STATE",
   "TIO_TSF_TRIGGER_MASK",
   "TIO_VEC_DATA",
   "TIO_VEC_PARMS",
   "TIO_VEC_RDDATA",
   "TIO_VEC_RETURN",
   "TIO_VEC_ROUTE",
   "TIO_VEC_STATUS",
   "TIO_VEC_STATUS_ALIAS",
   "TIO_XNIILB_AGE_WRAP0",
   "TIO_XNIILB_AGE_WRAP1",
   "TIO_XNIILB_AGE_WRAP2",
   "TIO_XNIILB_ARB_CONFIG_SI",
   "TIO_XNIILB_ARB_CONFIG_SO",
   "TIO_XNIILB_ERROR_DETAIL_1",
   "TIO_XNIILB_ERROR_DETAIL_2",
   "TIO_XNIILB_ERROR_DETAIL_3",
   "TIO_XNIILB_ERROR_MASK",
   "TIO_XNIILB_ERROR_MASK_1",
   "TIO_XNIILB_ERROR_OVERFLOW",
   "TIO_XNIILB_ERROR_OVERFLOW_1",
   "TIO_XNIILB_ERROR_OVERFLOW_ALIAS",
   "TIO_XNIILB_ERROR_OVERFLOW_ALIAS_1",
   "TIO_XNIILB_ERROR_SUMMARY",
   "TIO_XNIILB_ERROR_SUMMARY_1",
   "TIO_XNIILB_ERROR_SUMMARY_ALIAS",
   "TIO_XNIILB_ERROR_SUMMARY_ALIAS_1",
   "TIO_XNIILB_FIRST_ERROR",
   "TIO_XNIILB_FIRST_ERROR_1",
   "TIO_XNIILB_FR_IILB_INTRA_FLOW_CREDIT",
   "TIO_XNIILB_FR_NI0_INTRA_FLOW_CREDIT",
   "TIO_XNIILB_FR_NI1_INTRA_FLOW_CREDIT",
   "TIO_XNIILB_II_FIFO_CREDIT_CNT",
   "TIO_XNIILB_LB_FIFO_CREDIT_CNT",
   "TIO_XNIILB_TO_IILB_INTRA_FLOW_DEBIT",
   "TIO_XNIILB_TO_NI0_INTRA_FLOW_DEBIT",
   "TIO_XNIILB_TO_NI0_INTRA_FLOW_DEBIT13",
   "TIO_XNIILB_TO_NI1_INTRA_FLOW_DEBIT",
   "TIO_XNIILB_TO_NI1_INTRA_FLOW_DEBIT13",
   "TIO_XNII_INTRA_FLOW",
   "TIO_XNLB_INTRA_FLOW",
   "TIO_XNNI0_0_INTRANI_FLOW",
   "TIO_XNNI0_1_INTRANI_FLOW",
   "TIO_XNNI0_2_INTRANI_FLOW",
   "TIO_XNNI0_3_INTRANI_FLOW",
   "TIO_XNNI0_ARB_CONFIG",
   "TIO_XNNI0_DEADLCK_FLOW",
   "TIO_XNNI0_DEADLCK_FLOW_SUPPORT",
   "TIO_XNNI0_IILB_TAILTO",
   "TIO_XNNI0_INJECT_AGE",
   "TIO_XNNI0_LINK_0_FLOW",
   "TIO_XNNI0_LINK_1_FLOW",
   "TIO_XNNI0_LINK_2_FLOW",
   "TIO_XNNI0_LINK_3_FLOW",
   "TIO_XNNI0_LLP_DEBIT_FLOW",
   "TIO_XNNI0_LOCAL_AGE0",
   "TIO_XNNI0_NETWORK_AGE",
   "TIO_XNNI0_NI_TAILTO",
   "TIO_XNNI0_NI_TAILTO_SUPPORT",
   "TIO_XNNI0_QUEUE_CNTR",
   "TIO_XNNI0_TIMER_REG",
   "TIO_XNNI0_TO_IILB_INTRA_FLOW_DEBIT",
   "TIO_XNNI0_VCSWITCH_FLOW",
   "TIO_XNNI1_0_INTRANI_FLOW",
   "TIO_XNNI1_1_INTRANI_FLOW",
   "TIO_XNNI1_2_INTRANI_FLOW",
   "TIO_XNNI1_3_INTRANI_FLOW",
   "TIO_XNNI1_ARB_CONFIG",
   "TIO_XNNI1_DEADLCK_FLOW",
   "TIO_XNNI1_DEADLCK_FLOW_SUPPORT",
   "TIO_XNNI1_IILB_TAILTO",
   "TIO_XNNI1_INJECT_AGE",
   "TIO_XNNI1_LINK_0_FLOW",
   "TIO_XNNI1_LINK_1_FLOW",
   "TIO_XNNI1_LINK_2_FLOW",
   "TIO_XNNI1_LINK_3_FLOW",
   "TIO_XNNI1_LLP_DEBIT_FLOW",
   "TIO_XNNI1_LOCAL_AGE0",
   "TIO_XNNI1_NETWORK_AGE",
   "TIO_XNNI1_NI_TAILTO",
   "TIO_XNNI1_NI_TAILTO_SUPPORT",
   "TIO_XNNI1_QUEUE_CNTR",
   "TIO_XNNI1_TIMER_REG",
   "TIO_XNNI1_TO_IILB_INTRA_FLOW_DEBIT",
   "TIO_XNNI1_VCSWITCH_FLOW",
   "TIO_XN_COR_TIME_STAMP",
   "TIO_XN_DEBUG_DATA",
   "TIO_XN_DEBUG_SEL",
   "TIO_XN_DEBUG_TRIG_SEL",
   "TIO_XN_ERROR_MASK",
   "TIO_XN_ERROR_OVERFLOW",
   "TIO_XN_ERROR_OVERFLOW_ALIAS",
   "TIO_XN_ERROR_SUMMARY",
   "TIO_XN_ERROR_SUMMARY_ALIAS",
   "TIO_XN_FIRST_ERROR",
   "TIO_XN_HW_TIME_STAMP",
   "TIO_XN_IILB_DEBUG_SEL",
   "TIO_XN_IILB_II_CMP_ENABLE0",
   "TIO_XN_IILB_II_CMP_ENABLE1",
   "TIO_XN_IILB_II_CMP_EXP_DATA0",
   "TIO_XN_IILB_II_CMP_EXP_DATA1",
   "TIO_XN_IILB_LB_CMP_ENABLE0",
   "TIO_XN_IILB_LB_CMP_ENABLE1",
   "TIO_XN_IILB_LB_CMP_EXP_DATA0",
   "TIO_XN_IILB_LB_CMP_EXP_DATA1",
   "TIO_XN_IILB_NI0_CMP_ENABLE0",
   "TIO_XN_IILB_NI0_CMP_ENABLE1",
   "TIO_XN_IILB_NI0_CMP_EXP_DATA0",
   "TIO_XN_IILB_NI0_CMP_EXP_DATA1",
   "TIO_XN_IILB_NI1_CMP_ENABLE0",
   "TIO_XN_IILB_NI1_CMP_ENABLE1",
   "TIO_XN_IILB_NI1_CMP_EXP_DATA0",
   "TIO_XN_IILB_NI1_CMP_EXP_DATA1",
   "TIO_XN_NI0_DEBUG_SEL",
   "TIO_XN_NI0_IILB_CMP_ENABLE0",
   "TIO_XN_NI0_IILB_CMP_ENABLE1",
   "TIO_XN_NI0_IILB_CMP_EXP_DATA0",
   "TIO_XN_NI0_IILB_CMP_EXP_DATA1",
   "TIO_XN_NI0_LLP_CMP_ENABLE0",
   "TIO_XN_NI0_LLP_CMP_ENABLE1",
   "TIO_XN_NI0_LLP_CMP_EXP_DATA0",
   "TIO_XN_NI0_LLP_CMP_EXP_DATA1",
   "TIO_XN_NI0_NI_CMP_ENABLE0",
   "TIO_XN_NI0_NI_CMP_ENABLE1",
   "TIO_XN_NI0_NI_CMP_EXP_DATA0",
   "TIO_XN_NI0_NI_CMP_EXP_DATA1",
   "TIO_XN_NI1_DEBUG_SEL",
   "TIO_XN_NI1_IILB_CMP_ENABLE0",
   "TIO_XN_NI1_IILB_CMP_ENABLE1",
   "TIO_XN_NI1_IILB_CMP_EXP_DATA0",
   "TIO_XN_NI1_IILB_CMP_EXP_DATA1",
   "TIO_XN_NI1_LLP_CMP_ENABLE0",
   "TIO_XN_NI1_LLP_CMP_ENABLE1",
   "TIO_XN_NI1_LLP_CMP_EXP_DATA0",
   "TIO_XN_NI1_LLP_CMP_EXP_DATA1",
   "TIO_XN_NI1_NI_CMP_ENABLE0",
   "TIO_XN_NI1_NI_CMP_ENABLE1",
   "TIO_XN_NI1_NI_CMP_EXP_DATA0",
   "TIO_XN_NI1_NI_CMP_EXP_DATA1",
   "TIO_XN_TRIGGER_COMPARE",
   "TIO_XN_TRIGGER_DATA",
   "TIO_XN_UNCOR_TIME_STAMP",
   "XCE_ADM_BAP_CTRL",
   "XCE_ADM_BAP_SRAM_PERR_DETAIL",
   "XCE_ADM_CE_CREDIT_OFLOW_DETAIL",
   "XCE_ADM_CE_ID",
   "XCE_ADM_CE_SRAM_PERR_DETAIL",
   "XCE_ADM_CONTROL",
   "XCE_ADM_CREDIT_LIMIT",
   "XCE_ADM_DYN_CREDIT_STATUS",
   "XCE_ADM_ERROR_MASK",
   "XCE_ADM_ERROR_OVERFLOW",
   "XCE_ADM_ERROR_OVERFLOW_ALIAS",
   "XCE_ADM_ERROR_SUMMARY",
   "XCE_ADM_ERROR_SUMMARY_ALIAS",
   "XCE_ADM_FIRST_ERROR",
   "XCE_ADM_FORCE_CREDIT",
   "XCE_ADM_FORCE_INT",
   "XCE_ADM_INT_DEST_0",
   "XCE_ADM_INT_DEST_1",
   "XCE_ADM_INT_DEST_10",
   "XCE_ADM_INT_DEST_11",
   "XCE_ADM_INT_DEST_12",
   "XCE_ADM_INT_DEST_13",
   "XCE_ADM_INT_DEST_14",
   "XCE_ADM_INT_DEST_2",
   "XCE_ADM_INT_DEST_3",
   "XCE_ADM_INT_DEST_4",
   "XCE_ADM_INT_DEST_5",
   "XCE_ADM_INT_DEST_6",
   "XCE_ADM_INT_DEST_7",
   "XCE_ADM_INT_DEST_8",
   "XCE_ADM_INT_DEST_9",
   "XCE_ADM_INT_MASK",
   "XCE_ADM_INT_PENDING",
   "XCE_ADM_INT_STATUS",
   "XCE_ADM_INT_STATUS_ALIAS",
   "XCE_ADM_LAST_CREDIT_STATUS",
   "XCE_ADM_MAINT_BAP_BUF_DATA127_64",
   "XCE_ADM_MAINT_BAP_BUF_DATA63_0",
   "XCE_ADM_MAINT_BAP_BUF_PARITY",
   "XCE_ADM_MAINT_MSG_BUF_DATA127_64",
   "XCE_ADM_MAINT_MSG_BUF_DATA63_0",
   "XCE_ADM_MAINT_MSG_BUF_PARITY",
   "XCE_ADM_MMR_CHN_TIMEOUT_CTRL",
   "XCE_ADM_MMR_ERR_DETAIL",
   "XCE_ADM_MSG_SRAM_PERR_DETAIL",
   "XCE_ADM_PCIE_DEBUG_LAT_SEL_HI_TOP",
   "XCE_ADM_PCIE_DEBUG_LAT_SEL_LO_TOP",
   "XCE_ADM_PCIE_DEBUG_SEL",
   "XCE_ADM_PCIE_DEBUG_SEL_TOP",
   "XCE_ADM_PCIE_DEBUG_TRIG_LAT_SEL_HI_TOP",
   "XCE_ADM_PCIE_DEBUG_TRIG_LAT_SEL_LO_TOP",
   "XCE_ADM_PCIE_DEBUG_TRIG_SEL_TOP",
   "XCE_ADM_PCIE_TRIG_COMPARE_EN_TOP",
   "XCE_ADM_PCIE_TRIG_COMPARE_TOP",
   "XCE_ADM_SSP_DEBUG_LAT_SEL_HI_TOP",
   "XCE_ADM_SSP_DEBUG_LAT_SEL_LO_TOP",
   "XCE_ADM_SSP_DEBUG_SEL",
   "XCE_ADM_SSP_DEBUG_SEL_TOP",
   "XCE_ADM_SSP_DEBUG_TRIG_LAT_SEL_HI_TOP",
   "XCE_ADM_SSP_DEBUG_TRIG_LAT_SEL_LO_TOP",
   "XCE_ADM_SSP_DEBUG_TRIG_SEL_TOP",
   "XCE_ADM_SSP_DRE_TIMEOUT_CTRL",
   "XCE_ADM_SSP_TRIG_COMPARE_EN_TOP",
   "XCE_ADM_SSP_TRIG_COMPARE_TOP",
   "XCE_ADM_SSP_URE_TIMEOUT_CTRL",
   "XCE_ADM_TNUM_ERROR",
   "XCE_ADM_TX_LINK_IDLE_MAX_TIME",
   "XCE_ADM_URE_UPS_BUF_BARRIER_FLUSH_SEL",
   "XCE_CRM_DEBUG_MUX",
   "XCE_CRM_SSP_ERR_ADDR",
   "XCE_CRM_SSP_ERR_CMD_WRD",
   "XCE_CRM_SSP_ERR_SYN",
   "XCE_CXM_CREDIT_LIMIT",
   "XCE_CXM_DEBUG_MUX",
   "XCE_CXM_DISABLE_BYPASS",
   "XCE_CXM_DYN_CREDIT_STATUS",
   "XCE_CXM_FORCE_CREDIT",
   "XCE_CXM_LAST_CREDIT_STATUS",
   "XCE_DRE_COMP_ERR_ADDR",
   "XCE_DRE_COMP_ERR_CMD_WRD",
   "XCE_DRE_CONFIG1",
   "XCE_DRE_CONFIG2",
   "XCE_DRE_CONFIG_REQ_STATUS",
   "XCE_DRE_CREDIT_LIMIT1",
   "XCE_DRE_CREDIT_LIMIT2",
   "XCE_DRE_DEBUG_MUX1",
   "XCE_DRE_DEBUG_MUX2",
   "XCE_DRE_DYN_CREDIT_STATUS1",
   "XCE_DRE_DYN_CREDIT_STATUS2",
   "XCE_DRE_DYN_FIFO",
   "XCE_DRE_FORCE_CREDIT1",
   "XCE_DRE_FORCE_CREDIT2",
   "XCE_DRE_LAST_CREDIT_STATUS1",
   "XCE_DRE_LAST_CREDIT_STATUS2",
   "XCE_DRE_LAST_FIFO",
   "XCE_DRE_MAINT_DS_DATA_QUEUE_DATA127_64",
   "XCE_DRE_MAINT_DS_DATA_QUEUE_DATA63_0",
   "XCE_DRE_MAINT_DS_DATA_QUEUE_MISC",
   "XCE_DRE_MAINT_DS_HEAD_QUEUE_DATA127_64",
   "XCE_DRE_MAINT_DS_HEAD_QUEUE_DATA63_0",
   "XCE_DRE_MAINT_DS_HEAD_QUEUE_MISC",
   "XCE_DRE_MAINT_URE_US_RSP_QUEUE_DATA127_64",
   "XCE_DRE_MAINT_URE_US_RSP_QUEUE_DATA63_0",
   "XCE_DRE_MAINT_URE_US_RSP_QUEUE_MISC",
   "XCE_DRE_MAINT_US_WRT_RSP_QUEUE",
   "XCE_DRE_REQ_STATUS",
   "XCE_DRE_SSP_ERR_ADDR",
   "XCE_DRE_SSP_ERR_CMD_WRD",
   "XCE_DTL1_DEBUG_SEL",
   "XCE_DTL1_DTDR_CREDIT_FORCE",
   "XCE_DTL1_DTDR_CREDIT_LIMIT",
   "XCE_DTL1_DTL_DYN_CREDIT_STATUS",
   "XCE_DTL1_DTL_LAST_CREDIT_STATUS",
   "XCE_DTL2_DEBUG_SEL",
   "XCE_DTL2_DTDR_CREDIT_FORCE",
   "XCE_DTL2_DTDR_CREDIT_LIMIT",
   "XCE_DTL2_DTL_DYN_CREDIT_STATUS",
   "XCE_DTL2_DTL_LAST_CREDIT_STATUS",
   "XCE_HST_CCR_COMP",
   "XCE_HST_CLS_COMP",
   "XCE_HST_CMD_COMP",
   "XCE_HST_HTR_COMP",
   "XCE_HST_ID_COMP",
   "XCE_HST_STAT_COMP",
   "XCE_LSI1_ACK_LAT_THR",
   "XCE_LSI1_ACK_NAK_LAT_TMR",
   "XCE_LSI1_ACK_SENT_SEQ_NUM",
   "XCE_LSI1_DBG_CFG",
   "XCE_LSI1_DBG_STAT",
   "XCE_LSI1_FC_UPD_CTL",
   "XCE_LSI1_FLW_CTL_UPD_TO_TIMER",
   "XCE_LSI1_FREQ_NAK_LAT_THRSH",
   "XCE_LSI1_GB_CFG1",
   "XCE_LSI1_GB_CFG2",
   "XCE_LSI1_GB_CFG3",
   "XCE_LSI1_GB_CFG4",
   "XCE_LSI1_GB_INT_MASK",
   "XCE_LSI1_GB_INT_STAT",
   "XCE_LSI1_GB_INT_STAT_TEST",
   "XCE_LSI1_GB_PWR_DN1",
   "XCE_LSI1_GB_PWR_DN2",
   "XCE_LSI1_GB_STAT",
   "XCE_LSI1_INT_AND_STAT",
   "XCE_LSI1_INT_MASK",
   "XCE_LSI1_LK_LYR_CFG",
   "XCE_LSI1_LK_LYR_INT_STAT",
   "XCE_LSI1_LK_LYR_STATUS",
   "XCE_LSI1_LK_LY_INT_MASK",
   "XCE_LSI1_LK_LY_INT_STAT_TEST",
   "XCE_LSI1_LK_PERF_CNT1",
   "XCE_LSI1_LK_PERF_CNT1_TEST",
   "XCE_LSI1_LK_PERF_CNT2",
   "XCE_LSI1_LK_PERF_CNT2_TEST",
   "XCE_LSI1_LK_PERF_CNT_CTRL",
   "XCE_LSI1_LK_PERF_CNT_SEL",
   "XCE_LSI1_LK_STAT",
   "XCE_LSI1_LPU_ID",
   "XCE_LSI1_LTSSM_CFG1",
   "XCE_LSI1_LTSSM_CFG2",
   "XCE_LSI1_LTSSM_CFG3",
   "XCE_LSI1_LTSSM_CFG4",
   "XCE_LSI1_LTSSM_CFG5",
   "XCE_LSI1_LTSSM_CTRL",
   "XCE_LSI1_LTSSM_INT_MASK",
   "XCE_LSI1_LTSSM_INT_STAT",
   "XCE_LSI1_LTSSM_INT_STAT_TEST",
   "XCE_LSI1_LTSSM_STAT1",
   "XCE_LSI1_LTSSM_STAT2",
   "XCE_LSI1_LTSSM_STAT_WR_EN",
   "XCE_LSI1_MEM_ADDR_CTL",
   "XCE_LSI1_MEM_D_LD0",
   "XCE_LSI1_MEM_D_LD1",
   "XCE_LSI1_MEM_D_LD2",
   "XCE_LSI1_MEM_D_LD3",
   "XCE_LSI1_MEM_D_LD4",
   "XCE_LSI1_NXT_RCV_SEQ_1_CNTR",
   "XCE_LSI1_PHY_LYR_CFG",
   "XCE_LSI1_PHY_LYR_INT_MASK",
   "XCE_LSI1_PHY_LYR_INT_STAT",
   "XCE_LSI1_PHY_LYR_INT_STAT_TEST",
   "XCE_LSI1_RCV_LK_TS_CTL",
   "XCE_LSI1_RCV_PHY_CFG",
   "XCE_LSI1_RCV_PHY_INT_MASK",
   "XCE_LSI1_RCV_PHY_INT_STAT",
   "XCE_LSI1_RCV_PHY_INT_STAT_TEST",
   "XCE_LSI1_RCV_PHY_STAT1",
   "XCE_LSI1_RCV_PHY_STAT2",
   "XCE_LSI1_RCV_PHY_STAT3",
   "XCE_LSI1_RPLY_NUM_STAT",
   "XCE_LSI1_RPLY_TMR",
   "XCE_LSI1_RPLY_TMR_THR",
   "XCE_LSI1_RST_REG",
   "XCE_LSI1_RTY_BUF_MAX_ADDR",
   "XCE_LSI1_RTY_D_CNT",
   "XCE_LSI1_RTY_FIFO_CRED",
   "XCE_LSI1_RTY_FIFO_PTR",
   "XCE_LSI1_RTY_FIFO_RD_WR_PTR",
   "XCE_LSI1_SEQ_BUF_BT_D",
   "XCE_LSI1_SEQ_BUF_CNT",
   "XCE_LSI1_SEQ_CNT",
   "XCE_LSI1_SEQ_CNT_FIFO_MAX_ADDR",
   "XCE_LSI1_SEQ_CNT_FIFO_PTR",
   "XCE_LSI1_SEQ_CNT_RD_WR_PTR",
   "XCE_LSI1_TX_LK_TS_CTL",
   "XCE_LSI1_TX_PHY_CFG",
   "XCE_LSI1_TX_PHY_INT_MASK",
   "XCE_LSI1_TX_PHY_INT_STAT",
   "XCE_LSI1_TX_PHY_INT_STAT_TEST",
   "XCE_LSI1_TX_PHY_STAT",
   "XCE_LSI1_TX_PHY_STAT2",
   "XCE_LSI1_UNSP_DLLP_RCVD",
   "XCE_LSI1_VC0_FLW_CTL_UPD_TIMER0",
   "XCE_LSI1_VC0_FLW_CTL_UPD_TIMER1",
   "XCE_LSI2_ACK_LAT_THR",
   "XCE_LSI2_ACK_NAK_LAT_TMR",
   "XCE_LSI2_ACK_SENT_SEQ_NUM",
   "XCE_LSI2_DBG_CFG",
   "XCE_LSI2_DBG_STAT",
   "XCE_LSI2_FC_UPD_CTL",
   "XCE_LSI2_FLW_CTL_UPD_TO_TIMER",
   "XCE_LSI2_FREQ_NAK_LAT_THRSH",
   "XCE_LSI2_GB_CFG1",
   "XCE_LSI2_GB_CFG2",
   "XCE_LSI2_GB_CFG3",
   "XCE_LSI2_GB_CFG4",
   "XCE_LSI2_GB_INT_MASK",
   "XCE_LSI2_GB_INT_STAT",
   "XCE_LSI2_GB_INT_STAT_TEST",
   "XCE_LSI2_GB_PWR_DN1",
   "XCE_LSI2_GB_PWR_DN2",
   "XCE_LSI2_GB_STAT",
   "XCE_LSI2_INT_AND_STAT",
   "XCE_LSI2_INT_MASK",
   "XCE_LSI2_LK_LYR_CFG",
   "XCE_LSI2_LK_LYR_INT_STAT",
   "XCE_LSI2_LK_LYR_STATUS",
   "XCE_LSI2_LK_LY_INT_MASK",
   "XCE_LSI2_LK_LY_INT_STAT_TEST",
   "XCE_LSI2_LK_PERF_CNT1",
   "XCE_LSI2_LK_PERF_CNT1_TEST",
   "XCE_LSI2_LK_PERF_CNT2",
   "XCE_LSI2_LK_PERF_CNT2_TEST",
   "XCE_LSI2_LK_PERF_CNT_CTRL",
   "XCE_LSI2_LK_PERF_CNT_SEL",
   "XCE_LSI2_LK_STAT",
   "XCE_LSI2_LPU_ID",
   "XCE_LSI2_LTSSM_CFG1",
   "XCE_LSI2_LTSSM_CFG2",
   "XCE_LSI2_LTSSM_CFG3",
   "XCE_LSI2_LTSSM_CFG4",
   "XCE_LSI2_LTSSM_CFG5",
   "XCE_LSI2_LTSSM_CTRL",
   "XCE_LSI2_LTSSM_INT_MASK",
   "XCE_LSI2_LTSSM_INT_STAT",
   "XCE_LSI2_LTSSM_INT_STAT_TEST",
   "XCE_LSI2_LTSSM_STAT1",
   "XCE_LSI2_LTSSM_STAT2",
   "XCE_LSI2_LTSSM_STAT_WR_EN",
   "XCE_LSI2_MEM_ADDR_CTL",
   "XCE_LSI2_MEM_D_LD0",
   "XCE_LSI2_MEM_D_LD1",
   "XCE_LSI2_MEM_D_LD2",
   "XCE_LSI2_MEM_D_LD3",
   "XCE_LSI2_MEM_D_LD4",
   "XCE_LSI2_NXT_RCV_SEQ_1_CNTR",
   "XCE_LSI2_PHY_LYR_CFG",
   "XCE_LSI2_PHY_LYR_INT_MASK",
   "XCE_LSI2_PHY_LYR_INT_STAT",
   "XCE_LSI2_PHY_LYR_INT_STAT_TEST",
   "XCE_LSI2_RCV_LK_TS_CTL",
   "XCE_LSI2_RCV_PHY_CFG",
   "XCE_LSI2_RCV_PHY_INT_MASK",
   "XCE_LSI2_RCV_PHY_INT_STAT",
   "XCE_LSI2_RCV_PHY_INT_STAT_TEST",
   "XCE_LSI2_RCV_PHY_STAT1",
   "XCE_LSI2_RCV_PHY_STAT2",
   "XCE_LSI2_RCV_PHY_STAT3",
   "XCE_LSI2_RPLY_NUM_STAT",
   "XCE_LSI2_RPLY_TMR",
   "XCE_LSI2_RPLY_TMR_THR",
   "XCE_LSI2_RST_REG",
   "XCE_LSI2_RTY_BUF_MAX_ADDR",
   "XCE_LSI2_RTY_D_CNT",
   "XCE_LSI2_RTY_FIFO_CRED",
   "XCE_LSI2_RTY_FIFO_PTR",
   "XCE_LSI2_RTY_FIFO_RD_WR_PTR",
   "XCE_LSI2_SEQ_BUF_BT_D",
   "XCE_LSI2_SEQ_BUF_CNT",
   "XCE_LSI2_SEQ_CNT",
   "XCE_LSI2_SEQ_CNT_FIFO_MAX_ADDR",
   "XCE_LSI2_SEQ_CNT_FIFO_PTR",
   "XCE_LSI2_SEQ_CNT_RD_WR_PTR",
   "XCE_LSI2_TX_LK_TS_CTL",
   "XCE_LSI2_TX_PHY_CFG",
   "XCE_LSI2_TX_PHY_INT_MASK",
   "XCE_LSI2_TX_PHY_INT_STAT",
   "XCE_LSI2_TX_PHY_INT_STAT_TEST",
   "XCE_LSI2_TX_PHY_STAT",
   "XCE_LSI2_TX_PHY_STAT2",
   "XCE_LSI2_UNSP_DLLP_RCVD",
   "XCE_LSI2_VC0_FLW_CTL_UPD_TIMER0",
   "XCE_LSI2_VC0_FLW_CTL_UPD_TIMER1",
   "XCE_PCIE_CONTROL1",
   "XCE_PCIE_CONTROL2",
   "XCE_PPB1_BCTRL_COMP",
   "XCE_PPB1_BUS_ID_COMP",
   "XCE_PPB1_CCR_COMP",
   "XCE_PPB1_CLS_COMP",
   "XCE_PPB1_CMD_COMP",
   "XCE_PPB1_CPTR_COMP",
   "XCE_PPB1_DCAP_COMP",
   "XCE_PPB1_DCON_COMP",
   "XCE_PPB1_DSTAT_COMP",
   "XCE_PPB1_HTR_COMP",
   "XCE_PPB1_ID_COMP",
   "XCE_PPB1_IOLB_COMP",
   "XCE_PPB1_IOULB_COMP",
   "XCE_PPB1_LCAP_COMP",
   "XCE_PPB1_LCON_COMP",
   "XCE_PPB1_LSTAT_COMP",
   "XCE_PPB1_MEMLIMIT_COMP",
   "XCE_PPB1_PCAP_COMP",
   "XCE_PPB1_PMEMLIMIT_COMP",
   "XCE_PPB1_PMEMUBASE_COMP",
   "XCE_PPB1_PMEMULIMIT_COMP",
   "XCE_PPB1_RCON_COMP",
   "XCE_PPB1_RSTAT_COMP",
   "XCE_PPB1_SCAP_COMP",
   "XCE_PPB1_SCON_COMP",
   "XCE_PPB1_SECSTAT_COMP",
   "XCE_PPB1_SSTAT_COMP",
   "XCE_PPB1_STAT_COMP",
   "XCE_PPB2_BCTRL_COMP",
   "XCE_PPB2_BUS_ID_COMP",
   "XCE_PPB2_CCR_COMP",
   "XCE_PPB2_CLS_COMP",
   "XCE_PPB2_CMD_COMP",
   "XCE_PPB2_CPTR_COMP",
   "XCE_PPB2_DCAP_COMP",
   "XCE_PPB2_DCON_COMP",
   "XCE_PPB2_DSTAT_COMP",
   "XCE_PPB2_HTR_COMP",
   "XCE_PPB2_ID_COMP",
   "XCE_PPB2_IOLB_COMP",
   "XCE_PPB2_IOULB_COMP",
   "XCE_PPB2_LCAP_COMP",
   "XCE_PPB2_LCON_COMP",
   "XCE_PPB2_LSTAT_COMP",
   "XCE_PPB2_MEMLIMIT_COMP",
   "XCE_PPB2_PCAP_COMP",
   "XCE_PPB2_PMEMLIMIT_COMP",
   "XCE_PPB2_PMEMUBASE_COMP",
   "XCE_PPB2_PMEMULIMIT_COMP",
   "XCE_PPB2_RCON_COMP",
   "XCE_PPB2_RSTAT_COMP",
   "XCE_PPB2_SCAP_COMP",
   "XCE_PPB2_SCON_COMP",
   "XCE_PPB2_SECSTAT_COMP",
   "XCE_PPB2_SSTAT_COMP",
   "XCE_PPB2_STAT_COMP",
   "XCE_URE_ATE3240",
   "XCE_URE_ATE40",
   "XCE_URE_BUF_FLUSH10",
   "XCE_URE_BUF_FLUSH11",
   "XCE_URE_BUF_FLUSH12",
   "XCE_URE_BUF_FLUSH13",
   "XCE_URE_BUF_FLUSH20",
   "XCE_URE_BUF_FLUSH21",
   "XCE_URE_BUF_FLUSH22",
   "XCE_URE_BUF_FLUSH23",
   "XCE_URE_CONTROL",
   "XCE_URE_CREDIT_LIMIT",
   "XCE_URE_DIR_MAP1",
   "XCE_URE_DIR_MAP2",
   "XCE_URE_DYN_CREDIT_STATUS",
   "XCE_URE_LAST_CREDIT_STATUS",
   "XCE_URE_MAINT_DNS_DAT_DATA127_64",
   "XCE_URE_MAINT_DNS_DAT_DATA63_0",
   "XCE_URE_MAINT_DNS_DAT_PARITY",
   "XCE_URE_MAINT_DNS_HDR_DATA31_0",
   "XCE_URE_MAINT_DNS_HDR_DATA95_32",
   "XCE_URE_MAINT_DNS_HDR_PARITY",
   "XCE_URE_MAINT_RCI_DATA41_0",
   "XCE_URE_MAINT_RCI_DATA69_42",
   "XCE_URE_MAINT_RSPQ",
   "XCE_URE_MAINT_UPS_DAT1_DATA127_64",
   "XCE_URE_MAINT_UPS_DAT1_DATA63_0",
   "XCE_URE_MAINT_UPS_DAT1_PARITY",
   "XCE_URE_MAINT_UPS_DAT2_DATA127_64",
   "XCE_URE_MAINT_UPS_DAT2_DATA63_0",
   "XCE_URE_MAINT_UPS_DAT2_PARITY",
   "XCE_URE_MAINT_UPS_HDR1_DATA127_64",
   "XCE_URE_MAINT_UPS_HDR1_DATA63_0",
   "XCE_URE_MAINT_UPS_HDR1_PARITY",
   "XCE_URE_MAINT_UPS_HDR2_DATA127_64",
   "XCE_URE_MAINT_UPS_HDR2_DATA63_0",
   "XCE_URE_MAINT_UPS_HDR2_PARITY",
   "XCE_URE_PAGE_MAP",
   "XCE_URE_PCIE1_CREDITS_SENT",
   "XCE_URE_PCIE1_CREDITS_USED",
   "XCE_URE_PCIE1_CREDIT_LIMIT",
   "XCE_URE_PCIE2_CREDITS_SENT",
   "XCE_URE_PCIE2_CREDITS_USED",
   "XCE_URE_PCIE2_CREDIT_LIMIT",
   "XCE_URE_PCIE_DEBUG_SEL",
   "XCE_URE_PCIE_FORCE_CREDIT",
   "XCE_URE_PIPE_MASK1",
   "XCE_URE_PIPE_MASK2",
   "XCE_URE_PIPE_SEL1",
   "XCE_URE_PIPE_SEL2",
   "XCE_URE_RD_TNUM_ERROR",
   "XCE_URE_RD_TNUM_ESENT",
   "XCE_URE_RD_TNUM_FIRST_CL",
   "XCE_URE_RD_TNUM_LINK_BUF",
   "XCE_URE_RD_TNUM_RSP_RCVD",
   "XCE_URE_RD_TNUM_VAL",
   "XCE_URE_SRAM_ERR_ADDR0",
   "XCE_URE_SRAM_ERR_ADDR1",
   "XCE_URE_SRAM_ERR_ADDR2",
   "XCE_URE_SRAM_RD_ADDR0",
   "XCE_URE_SRAM_RD_ADDR1",
   "XCE_URE_SRAM_RD_ADDR2",
   "XCE_URE_SRAM_WR_ADDR0",
   "XCE_URE_SRAM_WR_ADDR1",
   "XCE_URE_SRAM_WR_ADDR2",
   "XCE_URE_SSP_DEBUG_SEL",
   "XCE_URE_SSP_ERR_ADDR",
   "XCE_URE_SSP_ERR_CMD_WRD",
   "XCE_URE_STATUS",
   "XCE_URE_WR_TNUM_VAL",
   "XCE_UTL1_DEBUG_SEL",
   "XCE_UTL1_UTL_CTRL",
   "XCE_UTL2_DEBUG_SEL",
   "XCE_UTL2_UTL_CTRL",
);

@tio_01_sorted_mmr_addr = 
(
   0x0000000000000000,
   0x0000000000000008,
   0x0000000000000010,
   0x0000000000000018,
   0x0000000000000020,
   0x0000000000000028,
   0x0000000000000030,
   0x0000000000000038,
   0x0000000000000040,
   0x0000000000000050,
   0x0000000000000058,
   0x0000000000000060,
   0x0000000000000068,
   0x0000000000000070,
   0x0000000000000078,
   0x0000000000000080,
   0x0000000000000090,
   0x00000000000000A0,
   0x00000000000000B0,
   0x00000000000000C0,
   0x00000000000000C8,
   0x00000000000000D0,
   0x00000000000000D8,
   0x0000000000000100,
   0x0000000000000108,
   0x0000000000000110,
   0x0000000000000118,
   0x0000000000000120,
   0x0000000000000128,
   0x0000000000000130,
   0x0000000000000138,
   0x0000000000000140,
   0x0000000000000148,
   0x0000000000000150,
   0x0000000000000158,
   0x0000000000000160,
   0x0000000000000168,
   0x0000000000000170,
   0x0000000000000178,
   0x0000000000000180,
   0x0000000000000188,
   0x0000000000000190,
   0x0000000000000198,
   0x00000000000001A0,
   0x00000000000001A8,
   0x00000000000001B0,
   0x00000000000001B8,
   0x00000000000001C0,
   0x00000000000001C8,
   0x00000000000001D0,
   0x00000000000001D8,
   0x00000000000001E0,
   0x00000000000001E8,
   0x00000000000001F0,
   0x00000000000001F8,
   0x0000000000000200,
   0x0000000000000208,
   0x0000000000000210,
   0x0000000000000218,
   0x0000000000000240,
   0x0000000000000248,
   0x0000000000000250,
   0x0000000000000258,
   0x0000000000000280,
   0x0000000000000288,
   0x0000000000000290,
   0x0000000000000298,
   0x0000000000000300,
   0x0000000000000308,
   0x0000000000000310,
   0x0000000000000318,
   0x0000000000000320,
   0x0000000000000328,
   0x0000000000000330,
   0x0000000000000338,
   0x0000000000000340,
   0x0000000000000348,
   0x0000000000000350,
   0x0000000000000358,
   0x0000000000000360,
   0x0000000000000368,
   0x0000000000000370,
   0x0000000000000378,
   0x0000000000000380,
   0x0000000000000388,
   0x0000000000000390,
   0x0000000000000398,
   0x00000000000003A0,
   0x00000000000003A8,
   0x00000000000003B0,
   0x00000000000003B8,
   0x00000000000003C0,
   0x00000000000003C8,
   0x00000000000003D0,
   0x00000000000003D8,
   0x00000000000003E0,
   0x00000000000003E8,
   0x00000000000003F0,
   0x00000000000003F8,
   0x0000000000000400,
   0x0000000000000408,
   0x0000000000000410,
   0x0000000000000418,
   0x0000000000000420,
   0x0000000000000428,
   0x0000000000000430,
   0x0000000000000438,
   0x0000000000000440,
   0x0000000000000448,
   0x0000000000000450,
   0x0000000000000458,
   0x0000000000000460,
   0x0000000000000468,
   0x0000000000000470,
   0x0000000000000478,
   0x0000000000000480,
   0x0000000000000488,
   0x0000000000000490,
   0x0000000000000498,
   0x00000000000004A0,
   0x00000000000004A8,
   0x00000000000004B0,
   0x00000000000004B8,
   0x00000000000004C0,
   0x00000000000004C8,
   0x00000000000004D0,
   0x00000000000004D8,
   0x00000000000004E0,
   0x00000000000004E8,
   0x00000000000004F0,
   0x00000000000004F8,
   0x0000000000000500,
   0x0000000000000508,
   0x0000000000000510,
   0x0000000000000518,
   0x0000000000000520,
   0x0000000000000528,
   0x0000000000000530,
   0x0000000000000538,
   0x0000000000000540,
   0x0000000000000548,
   0x0000000000000550,
   0x0000000000000558,
   0x0000000000000560,
   0x0000000000000568,
   0x0000000000000570,
   0x0000000000000578,
   0x0000000000000580,
   0x0000000000000588,
   0x0000000000000590,
   0x0000000000000598,
   0x00000000000005A0,
   0x00000000000005A8,
   0x00000000000005B0,
   0x00000000000005B8,
   0x00000000000005C0,
   0x00000000000005C8,
   0x00000000000005D0,
   0x00000000000005D8,
   0x00000000000005E0,
   0x00000000000005E8,
   0x00000000000005F0,
   0x00000000000005F8,
   0x0000000000000600,
   0x0000000000000608,
   0x0000000000000610,
   0x0000000000000618,
   0x0000000000000620,
   0x0000000000000628,
   0x0000000000000630,
   0x0000000000000638,
   0x0000000000000700,
   0x0000000000000708,
   0x0000000000000710,
   0x0000000000000718,
   0x0000000000000720,
   0x0000000000000728,
   0x0000000000000730,
   0x0000000010000000,
   0x0000000010000008,
   0x0000000010000010,
   0x0000000010000018,
   0x0000000010000020,
   0x0000000010000028,
   0x0000000010000030,
   0x0000000010000038,
   0x0000000010000040,
   0x0000000010000050,
   0x0000000010000058,
   0x0000000010000060,
   0x0000000010000068,
   0x0000000010000070,
   0x0000000010000078,
   0x0000000010000080,
   0x0000000010000090,
   0x00000000100000A0,
   0x00000000100000B0,
   0x00000000100000C0,
   0x00000000100000C8,
   0x00000000100000D0,
   0x00000000100000D8,
   0x0000000010000100,
   0x0000000010000108,
   0x0000000010000110,
   0x0000000010000118,
   0x0000000010000120,
   0x0000000010000128,
   0x0000000010000130,
   0x0000000010000138,
   0x0000000010000140,
   0x0000000010000148,
   0x0000000010000150,
   0x0000000010000158,
   0x0000000010000160,
   0x0000000010000168,
   0x0000000010000170,
   0x0000000010000178,
   0x0000000010000180,
   0x0000000010000188,
   0x0000000010000190,
   0x0000000010000198,
   0x00000000100001A0,
   0x00000000100001A8,
   0x00000000100001B0,
   0x00000000100001B8,
   0x00000000100001C0,
   0x00000000100001C8,
   0x00000000100001D0,
   0x00000000100001D8,
   0x00000000100001E0,
   0x00000000100001E8,
   0x00000000100001F0,
   0x00000000100001F8,
   0x0000000010000200,
   0x0000000010000208,
   0x0000000010000210,
   0x0000000010000218,
   0x0000000010000240,
   0x0000000010000248,
   0x0000000010000250,
   0x0000000010000258,
   0x0000000010000280,
   0x0000000010000288,
   0x0000000010000290,
   0x0000000010000298,
   0x0000000010000300,
   0x0000000010000308,
   0x0000000010000310,
   0x0000000010000318,
   0x0000000010000320,
   0x0000000010000328,
   0x0000000010000330,
   0x0000000010000338,
   0x0000000010000340,
   0x0000000010000348,
   0x0000000010000350,
   0x0000000010000358,
   0x0000000010000360,
   0x0000000010000368,
   0x0000000010000370,
   0x0000000010000378,
   0x0000000010000380,
   0x0000000010000388,
   0x0000000010000390,
   0x0000000010000398,
   0x00000000100003A0,
   0x00000000100003A8,
   0x00000000100003B0,
   0x00000000100003B8,
   0x00000000100003C0,
   0x00000000100003C8,
   0x00000000100003D0,
   0x00000000100003D8,
   0x00000000100003E0,
   0x00000000100003E8,
   0x00000000100003F0,
   0x00000000100003F8,
   0x0000000010000400,
   0x0000000010000408,
   0x0000000010000410,
   0x0000000010000418,
   0x0000000010000420,
   0x0000000010000428,
   0x0000000010000430,
   0x0000000010000438,
   0x0000000010000440,
   0x0000000010000448,
   0x0000000010000450,
   0x0000000010000458,
   0x0000000010000460,
   0x0000000010000468,
   0x0000000010000470,
   0x0000000010000478,
   0x0000000010000480,
   0x0000000010000488,
   0x0000000010000490,
   0x0000000010000498,
   0x00000000100004A0,
   0x00000000100004A8,
   0x00000000100004B0,
   0x00000000100004B8,
   0x00000000100004C0,
   0x00000000100004C8,
   0x00000000100004D0,
   0x00000000100004D8,
   0x00000000100004E0,
   0x00000000100004E8,
   0x00000000100004F0,
   0x00000000100004F8,
   0x0000000010000500,
   0x0000000010000508,
   0x0000000010000510,
   0x0000000010000518,
   0x0000000010000520,
   0x0000000010000528,
   0x0000000010000530,
   0x0000000010000538,
   0x0000000010000540,
   0x0000000010000548,
   0x0000000010000550,
   0x0000000010000558,
   0x0000000010000560,
   0x0000000010000568,
   0x0000000010000570,
   0x0000000010000578,
   0x0000000010000580,
   0x0000000010000588,
   0x0000000010000590,
   0x0000000010000598,
   0x00000000100005A0,
   0x00000000100005A8,
   0x00000000100005B0,
   0x00000000100005B8,
   0x00000000100005C0,
   0x00000000100005C8,
   0x00000000100005D0,
   0x00000000100005D8,
   0x00000000100005E0,
   0x00000000100005E8,
   0x00000000100005F0,
   0x00000000100005F8,
   0x0000000010000600,
   0x0000000010000608,
   0x0000000010000610,
   0x0000000010000618,
   0x0000000010000620,
   0x0000000010000628,
   0x0000000010000630,
   0x0000000010000638,
   0x0000000010000700,
   0x0000000010000708,
   0x0000000010000710,
   0x0000000010000718,
   0x0000000010000720,
   0x0000000010000728,
   0x0000000010000730,
   0x0000000020000000,
   0x0000000020000008,
   0x0000000020000010,
   0x0000000020000018,
   0x0000000020000020,
   0x0000000020000028,
   0x0000000020000030,
   0x0000000020000038,
   0x0000000020000040,
   0x0000000020000048,
   0x0000000020000050,
   0x0000000020000058,
   0x0000000020000060,
   0x0000000020000068,
   0x0000000020000070,
   0x0000000020000078,
   0x0000000020000080,
   0x0000000020000088,
   0x0000000020000090,
   0x0000000020000098,
   0x00000000200000A0,
   0x00000000200000A8,
   0x00000000200000B0,
   0x00000000200000B8,
   0x00000000200000D8,
   0x00000000200000E0,
   0x00000000200000E8,
   0x00000000200000F0,
   0x00000000200000F8,
   0x0000000020000100,
   0x0000000020000108,
   0x0000000020000110,
   0x0000000020000118,
   0x0000000020000200,
   0x0000000020000208,
   0x0000000020000210,
   0x0000000020000218,
   0x0000000020000220,
   0x0000000020000228,
   0x0000000020000230,
   0x0000000020000238,
   0x0000000020000240,
   0x0000000020010000,
   0x0000000020010000,
   0x0000000020010008,
   0x0000000020010008,
   0x0000000020010010,
   0x0000000020010010,
   0x0000000020010018,
   0x0000000020010018,
   0x0000000020020000,
   0x0000000020020000,
   0x0000000020020008,
   0x0000000020020008,
   0x0000000020020010,
   0x0000000020020010,
   0x0000000020020018,
   0x0000000020020018,
   0x0000000020020028,
   0x0000000020020030,
   0x0000000020020038,
   0x0000000020024000,
   0x0000000020030000,
   0x0000000020030000,
   0x0000000020030008,
   0x0000000020030008,
   0x0000000020030010,
   0x0000000020030010,
   0x0000000020030018,
   0x0000000020030018,
   0x0000000020034000,
   0x0000000030000000,
   0x0000000030000010,
   0x0000000030000018,
   0x0000000030000020,
   0x0000000030000028,
   0x0000000030000030,
   0x0000000030000038,
   0x0000000030000040,
   0x0000000030000048,
   0x0000000030000050,
   0x0000000030000058,
   0x0000000030000060,
   0x0000000030000068,
   0x0000000030000070,
   0x0000000030000078,
   0x0000000030000080,
   0x0000000030000088,
   0x0000000030000090,
   0x0000000030000098,
   0x00000000300000A0,
   0x00000000300000A8,
   0x00000000300000B0,
   0x00000000300000B8,
   0x00000000300000C0,
   0x00000000300000C8,
   0x00000000300000D0,
   0x00000000300000D8,
   0x00000000300000E0,
   0x00000000300000E8,
   0x00000000300000F0,
   0x00000000300000F8,
   0x0000000030000100,
   0x0000000030000108,
   0x0000000030000110,
   0x0000000030000118,
   0x0000000030000120,
   0x0000000030000128,
   0x0000000030000140,
   0x0000000030000148,
   0x0000000030000150,
   0x0000000030000158,
   0x0000000030000160,
   0x0000000030000168,
   0x0000000030000170,
   0x0000000030000198,
   0x0000000030000200,
   0x0000000030000208,
   0x0000000030000210,
   0x0000000030000218,
   0x0000000030000220,
   0x0000000030000228,
   0x0000000030000230,
   0x0000000030000238,
   0x0000000030000240,
   0x0000000030000248,
   0x0000000030000250,
   0x0000000030000258,
   0x0000000030000260,
   0x0000000030000268,
   0x0000000030000270,
   0x0000000030000278,
   0x0000000030000400,
   0x0000000030000800,
   0x0000000030000A00,
   0x0000000030000C00,
   0x0000000030002000,
   0x0000000030002008,
   0x0000000030002010,
   0x0000000030002018,
   0x0000000030002020,
   0x0000000030002028,
   0x0000000030002040,
   0x0000000030002048,
   0x0000000030002100,
   0x0000000030002110,
   0x0000000030002120,
   0x0000000030002128,
   0x0000000030002130,
   0x0000000030002138,
   0x0000000030002200,
   0x0000000030002208,
   0x0000000030002210,
   0x0000000030002218,
   0x0000000030002220,
   0x0000000030002240,
   0x0000000030002260,
   0x0000000030002268,
   0x0000000030002270,
   0x0000000030002400,
   0x0000000030002408,
   0x0000000030002410,
   0x0000000030002418,
   0x0000000030002420,
   0x0000000030002428,
   0x0000000030002430,
   0x0000000030002438,
   0x0000000030002440,
   0x0000000030002448,
   0x0000000030002450,
   0x0000000030002458,
   0x0000000030002460,
   0x0000000030002468,
   0x0000000030002470,
   0x0000000030002480,
   0x0000000030002488,
   0x0000000030002490,
   0x0000000030002498,
   0x00000000300024A0,
   0x00000000300024A8,
   0x00000000300024C0,
   0x00000000300024C8,
   0x00000000300024D0,
   0x00000000300024E0,
   0x0000000030002500,
   0x0000000030002508,
   0x0000000030002510,
   0x0000000030002600,
   0x0000000030002610,
   0x0000000030002618,
   0x0000000030002620,
   0x0000000030002680,
   0x0000000030002688,
   0x0000000030002690,
   0x0000000030002698,
   0x00000000300026A0,
   0x00000000300026A8,
   0x00000000300026B0,
   0x0000000030002700,
   0x0000000030002708,
   0x0000000030002710,
   0x0000000030002718,
   0x0000000030002720,
   0x0000000030002728,
   0x0000000030002780,
   0x0000000030002788,
   0x0000000030002790,
   0x0000000030002798,
   0x00000000300027A0,
   0x00000000300027A8,
   0x00000000300027B0,
   0x00000000300027B8,
   0x00000000300027C0,
   0x00000000300027C8,
   0x00000000300027D0,
   0x0000000030002800,
   0x0000000030002808,
   0x0000000030002810,
   0x0000000030002818,
   0x0000000030002820,
   0x0000000030002828,
   0x0000000030002830,
   0x0000000030002838,
   0x0000000030002840,
   0x0000000030002848,
   0x0000000030003000,
   0x0000000030003008,
   0x0000000030003010,
   0x0000000030003018,
   0x0000000030003020,
   0x0000000030003028,
   0x0000000030003040,
   0x0000000030003048,
   0x0000000030003100,
   0x0000000030003110,
   0x0000000030003120,
   0x0000000030003128,
   0x0000000030003130,
   0x0000000030003138,
   0x0000000030003200,
   0x0000000030003208,
   0x0000000030003210,
   0x0000000030003218,
   0x0000000030003220,
   0x0000000030003240,
   0x0000000030003260,
   0x0000000030003268,
   0x0000000030003270,
   0x0000000030003400,
   0x0000000030003408,
   0x0000000030003410,
   0x0000000030003418,
   0x0000000030003420,
   0x0000000030003428,
   0x0000000030003430,
   0x0000000030003438,
   0x0000000030003440,
   0x0000000030003448,
   0x0000000030003450,
   0x0000000030003458,
   0x0000000030003460,
   0x0000000030003468,
   0x0000000030003470,
   0x0000000030003480,
   0x0000000030003488,
   0x0000000030003490,
   0x0000000030003498,
   0x00000000300034A0,
   0x00000000300034A8,
   0x00000000300034C0,
   0x00000000300034C8,
   0x00000000300034D0,
   0x00000000300034E0,
   0x0000000030003500,
   0x0000000030003508,
   0x0000000030003510,
   0x0000000030003600,
   0x0000000030003610,
   0x0000000030003618,
   0x0000000030003620,
   0x0000000030003680,
   0x0000000030003688,
   0x0000000030003690,
   0x0000000030003698,
   0x00000000300036A0,
   0x00000000300036A8,
   0x00000000300036B0,
   0x0000000030003700,
   0x0000000030003708,
   0x0000000030003710,
   0x0000000030003718,
   0x0000000030003720,
   0x0000000030003728,
   0x0000000030003780,
   0x0000000030003788,
   0x0000000030003790,
   0x0000000030003798,
   0x00000000300037A0,
   0x00000000300037A8,
   0x00000000300037B0,
   0x00000000300037B8,
   0x00000000300037C0,
   0x00000000300037C8,
   0x00000000300037D0,
   0x0000000030003800,
   0x0000000030003808,
   0x0000000030003810,
   0x0000000030003818,
   0x0000000030003820,
   0x0000000030003828,
   0x0000000030003830,
   0x0000000030003838,
   0x0000000030003840,
   0x0000000030003848,
   0x0000000030004050,
   0x0000000030004060,
   0x0000000030004068,
   0x0000000030004070,
   0x0000000030005010,
   0x0000000030005018,
   0x0000000030005020,
   0x0000000030005028,
   0x0000000030005030,
   0x0000000030005050,
   0x0000000030006000,
   0x0000000030006008,
   0x0000000030006010,
   0x0000000030006018,
   0x0000000030006050,
   0x0000000030007000,
   0x0000000030007008,
   0x0000000030008000,
   0x0000000030008008,
   0x0000000030008010,
   0x0000000030008018,
   0x0000000030008050,
   0x0000000030009000,
   0x0000000030009008,
   0x000000003000B010,
   0x000000003000B018,
   0x000000003000B020,
   0x000000003000B030,
   0x000000003000B038,
   0x000000003000B050,
   0x000000003000B058,
   0x000000003000B060,
   0x000000003000B068,
   0x000000003000B070,
   0x000000003000B078,
   0x000000003000B080,
   0x000000003000B088,
   0x000000003000B090,
   0x000000003000B098,
   0x000000003000B0A0,
   0x000000003000B0A8,
   0x000000003000B0B0,
   0x000000003000B0B8,
   0x000000003000B0C0,
   0x000000003000B0C8,
   0x000000003000B0D0,
   0x000000003000B0D8,
   0x000000003000B0E0,
   0x000000003000B0E8,
   0x000000003000B0F0,
   0x000000003000B0F8,
   0x000000003000B100,
   0x000000003000B108,
   0x000000003000B110,
   0x000000003000B118,
   0x000000003000B120,
   0x000000003000B128,
   0x000000003000B130,
   0x000000003000B138,
   0x000000003000B140,
   0x000000003000B148,
   0x000000003000B150,
   0x000000003000B158,
   0x000000003000B160,
   0x000000003000B168,
   0x000000003000B170,
   0x000000003000B178,
   0x000000003000B180,
   0x000000003000B188,
   0x000000003000B190,
   0x000000003000B198,
   0x000000003000B1A0,
   0x000000003000B1A8,
   0x000000003000C000,
   0x000000003000D000,
   0x000000003000E000,
   0x000000003000F000,
   0x0000000030010000,
   0x0000000030011000,
   0x0000000030012000,
   0x0000000030013000,
   0x0000000030014000,
   0x0000000030015000,
   0x0000000030016000,
   0x0000000030017000,
   0x0000000030018000,
   0x0000000030019000,
   0x000000003001A000,
   0x000000003001B000,
   0x000000003001B200,
   0x000000003001B400,
   0x000000003001B600,
   0x000000003001B800,
   0x000000003001BA00,
   0x0000000030024000,
   0x0000000030024800,
   0x0000000030025000,
   0x0000000030030000,
   0x0000000030038000,
   0x0000000030040010,
   0x0000000030040018,
   0x0000000030040020,
   0x0000000030040028,
   0x0000000030040030,
   0x0000000030040038,
   0x0000000030040040,
   0x0000000030040048,
   0x0000000030040050,
   0x0000000030040058,
   0x0000000030040060,
   0x0000000030040068,
   0x0000000030040070,
   0x0000000030040078,
   0x0000000030040080,
   0x0000000030040088,
   0x0000000030040090,
   0x0000000030040098,
   0x0000000030040100,
   0x0000000030040120,
   0x0000000030040200,
   0x0000000030040300,
   0x0000000030040400,
   0x0000000030041000,
   0x0000000030042000,
   0x0000000030043000,
   0x0000000030044000,
   0x0000000030044100,
   0x0000000030044200,
   0x0000000030044300,
   0x0000000034000000,
   0x0000000034000004,
   0x0000000034000006,
   0x0000000034000008,
   0x000000003400000C,
   0x000000003400000E,
   0x0000000034000800,
   0x0000000034000804,
   0x0000000034000806,
   0x0000000034000808,
   0x000000003400080C,
   0x000000003400080E,
   0x0000000034000818,
   0x000000003400081C,
   0x000000003400081E,
   0x0000000034000820,
   0x0000000034000824,
   0x0000000034000828,
   0x000000003400082C,
   0x0000000034000830,
   0x0000000034000834,
   0x000000003400083E,
   0x0000000034000840,
   0x0000000034000844,
   0x0000000034000848,
   0x000000003400084A,
   0x000000003400084C,
   0x0000000034000850,
   0x0000000034000852,
   0x0000000034000854,
   0x0000000034000858,
   0x000000003400085A,
   0x000000003400085C,
   0x0000000034000860,
   0x0000000034001000,
   0x0000000034001004,
   0x0000000034001006,
   0x0000000034001008,
   0x000000003400100C,
   0x000000003400100E,
   0x0000000034001018,
   0x000000003400101C,
   0x000000003400101E,
   0x0000000034001020,
   0x0000000034001024,
   0x0000000034001028,
   0x000000003400102C,
   0x0000000034001030,
   0x0000000034001034,
   0x000000003400103E,
   0x0000000034001040,
   0x0000000034001044,
   0x0000000034001048,
   0x000000003400104A,
   0x000000003400104C,
   0x0000000034001050,
   0x0000000034001052,
   0x0000000034001054,
   0x0000000034001058,
   0x000000003400105A,
   0x000000003400105C,
   0x0000000034001060,
   0x0000000090000300,
   0x0000000090000480,
   0x0000000090000500,
   0x0000000090000580,
   0x0000000090000600,
   0x0000000090000680,
   0x0000000090000700,
   0x0000000090000780,
   0x0000000090000800,
   0x0000000090000880,
   0x0000000090000900,
   0x0000000090000980,
   0x0000000090000A00,
   0x0000000090001000,
   0x0000000090001080,
   0x0000000090001100,
   0x0000000090001180,
   0x0000000090001200,
   0x0000000090001280,
   0x0000000090001300,
   0x0000000090001380,
   0x0000000090001400,
   0x0000000090001480,
   0x0000000090001500,
   0x0000000090001580,
   0x0000000090001600,
   0x0000000090001680,
   0x0000000090001700,
   0x0000000090001780,
   0x0000000090001800,
   0x0000000090001880,
   0x0000000090001900,
   0x0000000090001980,
   0x0000000090001A00,
   0x0000000090001A80,
   0x0000000090001B00,
   0x0000000090001B80,
   0x0000000090010000,
   0x0000000090010008,
   0x0000000090010080,
   0x0000000090010088,
   0x0000000090038000,
   0x0000000090038080,
   0x0000000090038100,
   0x0000000090038180,
   0x0000000090040000,
   0x0000000090040080,
   0x0000000090040100,
   0x0000000090040180,
   0x0000000090040200,
   0x0000000090050000,
   0x0000000090050080,
   0x0000000090050100,
   0x0000000090050180,
   0x0000000090050200,
   0x0000000090050280,
   0x0000000090050300,
   0x0000000090050380,
   0x0000000090050400,
   0x0000000090050480,
   0x0000000090050500,
   0x0000000090050508,
   0x0000000090050580,
   0x0000000090050588,
   0x0000000090050600,
   0x0000000090050680,
   0x0000000090050780,
   0x0000000090050800,
   0x0000000090060000,
   0x0000000090060080,
   0x0000000090060100,
   0x0000000090060180,
   0x0000000090060200,
   0x0000000090060280,
   0x0000000090060300,
   0x0000000090060380,
   0x0000000090060400,
   0x0000000090060480,
   0x0000000090060680,
   0x0000000090060700,
   0x0000000090060780,
   0x0000000090060800,
   0x0000000090060880,
   0x0000000090060900,
   0x0000000090060980,
   0x0000000090060A00,
   0x0000000090060A80,
   0x0000000090060B00,
   0x0000000090060B80,
   0x0000000090060E00,
   0x0000000090060E80,
   0x0000000090061100,
   0x0000000090062000,
   0x0000000090062080,
   0x0000000090062100,
   0x0000000090062180,
   0x0000000090062200,
   0x0000000090062280,
   0x0000000090063000,
   0x0000000090063080,
   0x0000000090063100,
   0x0000000090063180,
   0x0000000090063200,
   0x0000000090063280,
   0x0000000090063300,
   0x0000000090063380,
   0x0000000090063400,
   0x0000000090063480,
   0x0000000090063500,
   0x0000000090063580,
   0x0000000090063600,
   0x0000000090063680,
   0x0000000090063700,
   0x0000000090063780,
   0x0000000090063800,
   0x0000000090063880,
   0x0000000090063900,
   0x0000000090063980,
   0x0000000090063A00,
   0x0000000090064000,
   0x0000000090064080,
   0x0000000090064100,
   0x0000000090064180,
   0x0000000090064200,
   0x0000000090064280,
   0x0000000090064300,
   0x0000000090064380,
   0x0000000090064400,
   0x0000000090065000,
   0x0000000090065080,
   0x0000000090066000,
   0x0000000090066080,
   0x0000000090066100,
   0x0000000090066180,
   0x0000000090066200,
   0x0000000090066280,
   0x0000000090066300,
   0x0000000090066380,
   0x0000000090066400,
   0x0000000090066480,
   0x0000000090067000,
   0x0000000090067080,
   0x0000000090067100,
   0x0000000090068000,
   0x0000000090068080,
   0x0000000090068100,
   0x0000000090071000,
   0x0000000090071100,
   0x0000000090071380,
   0x0000000090071880,
   0x0000000090071900,
   0x0000000090071980,
   0x0000000090071A00,
   0x0000000090072000,
   0x0000000090072080,
   0x0000000090072180,
   0x0000000090072280,
   0x0000000090072300,
   0x0000000090072800,
   0x0000000090072880,
   0x0000000090072900,
   0x0000000090073000,
   0x0000000090073080,
   0x0000000090073100,
   0x0000000090074000,
   0x0000000090074080,
   0x0000000090074100,
   0x0000000090074108,
   0x0000000090075000,
   0x0000000090077000,
   0x0000000090080000,
   0x0000000090090000,
   0x00000000900A0000,
   0x00000000900B0000,
   0x00000000900C0000,
   0x00000000900D0000,
   0x00000000900E0000,
   0x00000000900F0000,
   0x0000000090100000,
   0x0000000090100080,
   0x0000000090100100,
   0x0000000090100180,
   0x0000000090101000,
   0x0000000090110000,
   0x0000000090120000,
   0x0000000090130000,
   0x0000000090140000,
   0x0000000090150000,
   0x0000000090160000,
   0x0000000090170000,
   0x0000000090180000,
   0x0000000090190000,
   0x0000000090190080,
   0x00000000901C0000,
   0x00000000901D0000,
   0x00000000901D0008,
   0x00000000901D0080,
   0x00000000901D0088,
   0x00000000901D0100,
   0x00000000901D0108,
   0x00000000901D0180,
   0x00000000901D0188,
   0x00000000901D0200,
   0x00000000901D0208,
   0x00000000B0000000,
   0x00000000B0000008,
   0x00000000B0000010,
   0x00000000B0000018,
   0x00000000B0000020,
   0x00000000B0000028,
   0x00000000B00000E0,
   0x00000000B00000E8,
   0x00000000B00000F0,
   0x00000000B00000F8,
   0x00000000B0000100,
   0x00000000B0000108,
   0x00000000B0000110,
   0x00000000B0000118,
   0x00000000B0002000,
   0x00000000B0002008,
   0x00000000B0002020,
   0x00000000B0002040,
   0x00000000B0002048,
   0x00000000B00020C0,
   0x00000000B00020C8,
   0x00000000B00020D0,
   0x00000000B00020D8,
   0x00000000B00020F8,
   0x00000000B0002100,
   0x00000000B0002108,
   0x00000000B0002110,
   0x00000000B0002118,
   0x00000000B0002120,
   0x00000000B0002128,
   0x00000000B0002130,
   0x00000000B0002140,
   0x00000000B0002148,
   0x00000000B0002150,
   0x00000000B0002158,
   0x00000000B0002160,
   0x00000000B0002168,
   0x00000000B0002180,
   0x00000000B0002188,
   0x00000000B0002190,
   0x00000000B0002198,
   0x00000000B0002200,
   0x00000000B0002208,
   0x00000000B0002210,
   0x00000000B0002218,
   0x00000000B0004000,
   0x00000000B0004008,
   0x00000000B0004020,
   0x00000000B0004040,
   0x00000000B0004048,
   0x00000000B0004060,
   0x00000000B0004068,
   0x00000000B00040F8,
   0x00000000B0004100,
   0x00000000B0004108,
   0x00000000B0004110,
   0x00000000B0004118,
   0x00000000B0004120,
   0x00000000B0004800,
   0x00000000B0004808,
   0x00000000B0004810,
   0x00000000B0004818,
   0x00000000B0004820,
   0x00000000B0004828,
   0x00000000B0004830,
   0x00000000B0004838,
   0x00000000B0004840,
   0x00000000B0004848,
   0x00000000B0004850,
   0x00000000B0004858,
   0x00000000B0004860,
   0x00000000B0004868,
   0x00000000B0004870,
   0x00000000B0004878,
   0x00000000B0004880,
   0x00000000B0004888,
   0x00000000B0004890,
   0x00000000B0004898,
   0x00000000B00048A0,
   0x00000000B00048A8,
   0x00000000B00048B0,
   0x00000000B00048B8,
   0x00000000B00048C0,
   0x00000000B00048C8,
   0x00000000B00048D0,
   0x00000000B00048D8,
   0x00000000B00048E0,
   0x00000000B00048E8,
   0x00000000B00048F0,
   0x00000000B00048F8,
   0x00000000B0004900,
   0x00000000B0004908,
   0x00000000B0004910,
   0x00000000B0004918,
   0x00000000B0004920,
   0x00000000B0004928,
   0x00000000B0004930,
   0x00000000B0004938,
   0x00000000B0004940,
   0x00000000B0004948,
   0x00000000B0004950,
   0x00000000B0004958,
   0x00000000B0004960,
   0x00000000B0004968,
   0x00000000B0004970,
   0x00000000B0004978,
   0x00000000B0004980,
   0x00000000B0004988,
   0x00000000B0004990,
   0x00000000B0004998,
   0x00000000B00049A0,
   0x00000000B00049A8,
   0x00000000B00049B0,
   0x00000000B00049B8,
   0x00000000B00049C0,
   0x00000000B00049C8,
   0x00000000B00049D0,
   0x00000000B00049D8,
   0x00000000B00049E0,
   0x00000000B00049E8,
   0x00000000B00049F0,
   0x00000000B00049F8,
   0x00000000B0006000,
   0x00000000B0006008,
   0x00000000B0006020,
   0x00000000B0006040,
   0x00000000B0006048,
   0x00000000B0006060,
   0x00000000B0006068,
   0x00000000B00060F8,
   0x00000000B0006100,
   0x00000000B0006108,
   0x00000000B0006118,
   0x00000000B0006120,
   0x00000000B0006128,
   0x00000000B0006800,
   0x00000000B0006808,
   0x00000000B0006810,
   0x00000000B0006818,
   0x00000000B0006820,
   0x00000000B0006828,
   0x00000000B0006830,
   0x00000000B0006838,
   0x00000000B0006840,
   0x00000000B0006848,
   0x00000000B0006850,
   0x00000000B0006858,
   0x00000000B0006860,
   0x00000000B0006868,
   0x00000000B0006870,
   0x00000000B0006878,
   0x00000000B0006880,
   0x00000000B0006888,
   0x00000000B0006890,
   0x00000000B0006898,
   0x00000000B00068A0,
   0x00000000B00068A8,
   0x00000000B00068B0,
   0x00000000B00068B8,
   0x00000000B00068C0,
   0x00000000B00068C8,
   0x00000000B00068D0,
   0x00000000B00068D8,
   0x00000000B00068E0,
   0x00000000B00068E8,
   0x00000000B00068F0,
   0x00000000B00068F8,
   0x00000000B0006900,
   0x00000000B0006908,
   0x00000000B0006910,
   0x00000000B0006918,
   0x00000000B0006920,
   0x00000000B0006928,
   0x00000000B0006930,
   0x00000000B0006938,
   0x00000000B0006940,
   0x00000000B0006948,
   0x00000000B0006950,
   0x00000000B0006958,
   0x00000000B0006960,
   0x00000000B0006968,
   0x00000000B0006970,
   0x00000000B0006978,
   0x00000000B0006980,
   0x00000000B0006988,
   0x00000000B0006990,
   0x00000000B0006998,
   0x00000000B00069A0,
   0x00000000B00069A8,
   0x00000000B00069B0,
   0x00000000B00069B8,
   0x00000000B00069C0,
   0x00000000B00069C8,
   0x00000000B00069D0,
   0x00000000B00069D8,
   0x00000000B00069E0,
   0x00000000B00069E8,
   0x00000000B00069F0,
   0x00000000B00069F8,
   0x00000000B0006A00,
   0x00000000B0006A08,
   0x00000000B0006A10,
   0x00000000B0006A18,
   0x00000000B0006A20,
   0x00000000B0006A28,
   0x00000000B0006A30,
   0x00000000B0006A38,
   0x00000000B0006A40,
   0x00000000B0006A48,
   0x00000000B0006A50,
   0x00000000B0006A58,
   0x00000000B0006A60,
   0x00000000B0006A68,
   0x00000000B0006A70,
   0x00000000B0006A78,
   0x00000000B0006A80,
   0x00000000B0006A88,
   0x00000000B0006A90,
   0x00000000B0006A98,
   0x00000000B0006AA0,
   0x00000000B0006AA8,
   0x00000000B0006AB0,
   0x00000000B0006AB8,
   0x00000000B0006AC0,
   0x00000000B0006AC8,
   0x00000000B0006AD0,
   0x00000000B0006AD8,
   0x00000000B0006AE0,
   0x00000000B0006AE8,
   0x00000000B0006AF0,
   0x00000000B0006AF8,
   0x00000000B0006B00,
   0x00000000B0006B08,
   0x00000000B0006B10,
   0x00000000B0006B18,
   0x00000000B0006B20,
   0x00000000B0006B28,
   0x00000000B0006B30,
   0x00000000B0006B38,
   0x00000000B0006B40,
   0x00000000B0006B48,
   0x00000000B0006B50,
   0x00000000B0006B58,
   0x00000000B0006B60,
   0x00000000B0006B68,
   0x00000000B0006B70,
   0x00000000B0006B78,
   0x00000000B0006B80,
   0x00000000B0006B88,
   0x00000000B0006B90,
   0x00000000B0006B98,
   0x00000000B0006BA0,
   0x00000000B0006BA8,
   0x00000000B0006BB0,
   0x00000000B0006BB8,
   0x00000000B0006BC0,
   0x00000000B0006BC8,
   0x00000000B0006BD0,
   0x00000000B0006BD8,
   0x00000000B0006BE0,
   0x00000000B0006BE8,
   0x00000000B0006BF0,
   0x00000000B0006BF8,
   0x00000000B0008000,
   0x00000000B0008008,
   0x00000000B0008020,
   0x00000000B0008040,
   0x00000000B0008048,
   0x00000000B0008050,
   0x00000000B0008058,
   0x00000000B0008060,
   0x00000000B00080F8,
   0x00000000B0008100,
   0x00000000B0008108,
   0x00000000B0008110,
   0x00000000B0008118,
   0x00000000B0008120,
   0x00000000B0008128,
   0x00000000B0008200,
   0x00000000B0008210,
   0x00000000B0008220,
   0x00000000B0008230,
   0x00000000B0008240,
   0x00000000B0008250,
   0x00000000B0008260,
   0x00000000B0008270,
   0x00000000B0008280,
   0x00000000B0008290,
   0x00000000B00082A0,
   0x00000000B00082B0,
   0x00000000B00082C0,
   0x00000000B00082D0,
   0x00000000B00082E0,
   0x00000000B00082F0,
   0x00000000B0008300,
   0x00000000B0008310,
   0x00000000B0008320,
   0x00000000B0008330,
   0x00000000B0008340,
   0x00000000B0008350,
   0x00000000B0008360,
   0x00000000B0008370,
   0x00000000B0008380,
   0x00000000B0008390,
   0x00000000B00083A0,
   0x00000000B00083B0,
   0x00000000B00083C0,
   0x00000000B00083D0,
   0x00000000B00083E0,
   0x00000000B00083F0,
   0x00000000B0008800,
   0x00000000B0008808,
   0x00000000B0008810,
   0x00000000B0008818,
   0x00000000B0008820,
   0x00000000B0008828,
   0x00000000B0008830,
   0x00000000B0008838,
   0x00000000B0008840,
   0x00000000B0008848,
   0x00000000B0008850,
   0x00000000B0008858,
   0x00000000B0008860,
   0x00000000B0008868,
   0x00000000B0008870,
   0x00000000B0008878,
   0x00000000B0008880,
   0x00000000B0008888,
   0x00000000B0008890,
   0x00000000B0008898,
   0x00000000B00088A0,
   0x00000000B00088A8,
   0x00000000B00088B0,
   0x00000000B00088B8,
   0x00000000B00088C0,
   0x00000000B0009000,
   0x00000000B0009008,
   0x00000000B0009010,
   0x00000000B0009018,
   0x00000000B0009020,
   0x00000000B0009028,
   0x00000000B0009030,
   0x00000000B0009038,
   0x00000000B0009040,
   0x00000000B0009048,
   0x00000000B0009050,
   0x00000000B0009058,
   0x00000000B0009060,
   0x00000000B000A000,
   0x00000000B000A008,
   0x00000000B000A020,
   0x00000000B000A060,
   0x00000000B000A068,
   0x00000000B000A0C0,
   0x00000000B000A0C8,
   0x00000000B000A0D0,
   0x00000000B000A0D8,
   0x00000000B000A0F8,
   0x00000000B000A100,
   0x00000000B000A108,
   0x00000000B000A110,
   0x00000000B000A118,
   0x00000000B000A120,
   0x00000000B000A128,
   0x00000000B000B000,
   0x00000000B000B008,
   0x00000000B000B010,
   0x00000000B000B018,
   0x00000000B000B020,
   0x00000000B000B100,
   0x00000000B000B108,
   0x00000000B000B110,
   0x00000000B000B800,
   0x00000000B000B808,
   0x00000000B000B810,
   0x00000000B000B818,
   0x00000000B000BA00,
   0x00000000B000BA08,
   0x00000000B000BA10,
   0x00000000B000BA18,
   0x00000000B000BC00,
   0x00000000B000BC08,
   0x00000000B000BC10,
   0x00000000B000BC18,
   0x00000000B000BE00,
   0x00000000B000BE08,
   0x00000000B000BE10,
   0x00000000B000BE18,
   0x00000000B000E000,
   0x00000000B000E008,
   0x00000000B000E010,
   0x00000000B000E018,
   0x00000000B000E020,
   0x00000000B000E0F8,
   0x00000000B000E100,
   0x00000000B000E108,
   0x00000000B000E110,
   0x00000000B000E118,
   0x00000000B000E120,
   0x00000000B000E128,
   0x00000000B000E130,
   0x00000000B000E138,
   0x00000000B000E140,
   0x00000000B000E148,
   0x00000000B000E150,
   0x00000000B000E158,
   0x00000000B000E160,
   0x00000000B000E168,
   0x00000000B000E170,
   0x00000000B000E178,
   0x00000000B000E180,
   0x00000000B000E188,
   0x00000000B000E190,
   0x00000000B000E198,
   0x00000000D0000000,
   0x00000000D0000008,
   0x00000000D0000010,
   0x00000000D0000018,
   0x00000000D0000020,
   0x00000000D0000028,
   0x00000000D0000030,
   0x00000000D0000038,
   0x00000000D0000040,
   0x00000000D0000048,
   0x00000000D0001030,
   0x00000000D0001040,
   0x00000000D0001050,
   0x00000000D0001060,
   0x00000000D0001070,
   0x00000000D0002000,
   0x00000000D0002008,
   0x00000000D0002010,
   0x00000000D0002018,
   0x00000000D0002020,
   0x00000000D0002028,
   0x00000000D0002030,
   0x00000000D0002038,
   0x00000000D0002040,
   0x00000000D0002048,
   0x00000000D0003030,
   0x00000000D0003040,
   0x00000000D0003050,
   0x00000000D0003060,
   0x00000000D0003070,
   0x00000000D0020000,
   0x00000000D0020800,
   0x00000000D0021000,
   0x00000000D0024000,
   0x00000000D0024800,
   0x00000000D0025000,
   0x00000000D0026000,
   0x00000000D0026800,
   0x00000000D0027000,
   0x00000000D0030200,
   0x00000000D0030210,
   0x00000000D0030220,
   0x00000000D0030230,
   0x00000000D0030240,
   0x00000000D0030250,
   0x00000000D0030260,
   0x00000000D00302B0,
   0x00000000D00302C0,
   0x00000000D00302D0,
   0x00000000D0030300,
   0x00000000D0030310,
   0x00000000D0030320,
   0x00000000D0030330,
   0x00000000D0030340,
   0x00000000D0030350,
   0x00000000D0030360,
   0x00000000D0030400,
   0x00000000D0030450,
   0x00000000D0030460,
   0x00000000D0030470,
   0x00000000D0030480,
   0x00000000D0030490,
   0x00000000D00304A0,
   0x00000000D00304B0,
   0x00000000D00304C0,
   0x00000000D00304F0,
   0x00000000D0030500,
   0x00000000D0030510,
   0x00000000D0030520,
   0x00000000D0030530,
   0x00000000D0030540,
   0x00000000D0030550,
   0x00000000D0030570,
   0x00000000D0030600,
   0x00000000D0030650,
   0x00000000D0030660,
   0x00000000D0030670,
   0x00000000D0030680,
   0x00000000D0030690,
   0x00000000D00306A0,
   0x00000000D00306B0,
   0x00000000D00306C0,
   0x00000000D00306F0,
   0x00000000D0030700,
   0x00000000D0030710,
   0x00000000D0030720,
   0x00000000D0030730,
   0x00000000D0030740,
   0x00000000D0030750,
   0x00000000D0030770,
   0x00000000D0031000,
   0x00000000D0031020,
   0x00000000D0031040,
   0x00000000D0031050,
   0x00000000D0031060,
   0x00000000D00310C0,
   0x00000000D00310E0,
   0x00000000D0031100,
   0x00000000D0031110,
   0x00000000D0031120,
   0x00000000D0031130,
   0x00000000D0031140,
   0x00000000D0031150,
   0x00000000D0031160,
   0x00000000D0031170,
   0x00000000D0031280,
   0x00000000D0031290,
   0x00000000D00312A0,
   0x00000000D00312B0,
   0x00000000D00312C0,
   0x00000000D00312D0,
   0x00000000D00312E0,
   0x00000000D00312F0,
   0x00000000D0031700,
   0x00000000D0031710,
   0x00000000D0031720,
   0x00000000D0031730,
   0x00000000D00317C0,
   0x00000000D00317D0,
   0x00000000D00317E0,
   0x00000000D00317F0,
   0x00000000D0031800,
   0x00000000D0031810,
   0x00000000D0031820,
   0x00000000D0031830,
   0x00000000D0031900,
   0x00000000D0031910,
   0x00000000D0031920,
   0x00000000D0031930,
   0x00000000D00319C0,
   0x00000000D00319D0,
   0x00000000D00319E0,
   0x00000000D00319F0,
   0x00000000D0031A00,
   0x00000000D0031A10,
   0x00000000D0031A20,
   0x00000000D0031A30,
   0x00000000D0040000,
   0x00000000D0040008,
   0x00000000D0040020,
   0x00000000D0040028,
   0x00000000D0040040,
   0x00000000D0040060,
   0x00000000D0040130,
   0x00000000D0040140,
   0x00000000D0040150,
   0x00000000D0040160,
   0x00000000D0040170,
   0x00000000D0040200,
   0x00000000D0040208,
   0x00000000D0040210,
   0x00000000D0040218,
   0x00000000D0040220,
   0x00000000D0040228,
   0x00000000D0040230,
   0x00000000D0040238,
   0x00000000D0040240,
   0x00000000D0040250,
   0x00000000D0040260,
   0x00000000D0040270,
   0x00000000D0040500,
   0x00000000D0040508,
   0x00000000D0040510,
   0x00000000D0040518,
   0x00000000D0040520,
   0x00000000D0040528,
   0x00000000D0040530,
   0x00000000D0040538,
   0x00000000D0040540,
   0x00000000D0040550,
   0x00000000D0040560,
   0x00000000D0040570,
   0x00000000D0040580,
   0x00000000D0040590,
   0x00000000D0040600,
   0x00000000D0040608,
   0x00000000D0040610,
   0x00000000D0040618,
   0x00000000D0040620,
   0x00000000D0040628,
   0x00000000D0040630,
   0x00000000D0040638,
   0x00000000D0040640,
   0x00000000D0040650,
   0x00000000D0040660,
   0x00000000D0040670,
   0x00000000D0040680,
   0x00000000D0040690,
);


##########################################################################
#                                                                        #
#   REGISTER SEARCH SUBROUTINES (BY NAME OR ADDRESS)                     #
#                                                                        #
##########################################################################

sub tio_01_mmr_search_name
{  my $rptr = 0;
   return($rptr) if ( $#_ != 0 );
   $rptr = $tio_01_mmr_by_name{$_[0]} if ( exists $tio_01_mmr_by_name{$_[0]} );
   return($rptr);
}

sub tio_01_mmr_search_addr
{  my $rptr = 0;
   return($rptr) if ( $#_ != 0 );
   $rptr = $tio_01_mmr_by_addr{$_[0]} if ( exists $tio_01_mmr_by_addr{$_[0]} );
   return($rptr);
}


##########################################################################
# Number of MMRs    : 1667
##########################################################################


##########################################################################
# Set packet generator flag for some MMRs
##########################################################################

my ($i, $def_ptr);
#printf "\n-> Define TYPE field for each register: num=%u\n",
    $#tio_01_sorted_mmr_addr;
for ($i = 0; $i <= $#tio_01_sorted_mmr_addr; $i++)
{  $def_ptr = $tio_01_mmr_by_addr{ $tio_01_sorted_mmr_addr[$i] };
   $$def_ptr{TYPE} = ($$def_ptr{ADDRESS} < 0x80000000) ? $REG_TYPE_PKTGEN :
      $REG_TYPE_NORMAL;
}


1;
